SystemOrganization addCategory: #'Kernel-Chronology'!
SystemOrganization addCategory: #'Kernel-Classes'!
SystemOrganization addCategory: #'Kernel-Methods'!
SystemOrganization addCategory: #'Kernel-Models'!
SystemOrganization addCategory: #'Kernel-Numbers'!
SystemOrganization addCategory: #'Kernel-Objects'!
SystemOrganization addCategory: #'Kernel-Processes'!
SystemOrganization addCategory: #'Kernel-Processes-Variables'!

nil subclass: #ProtoObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

ProtoObject subclass: #FutureMaker
	instanceVariableNames: 'myTarget deltaMSecs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!FutureMaker methodsFor: 'comparing' stamp: ''!
= t1 
	^ self == t1! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
basicAt: t1 
	<primitive: 60>
	t1 isInteger
		ifTrue: [self errorSubscriptBounds: t1].
	t1 isNumber
		ifTrue: [^ self basicAt: t1 asInteger].
	self errorNonIntegerIndex! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
basicAt: t1 put: t2 
	<primitive: 61>
	t1 isInteger
		ifTrue: [(t1 >= 1
					and: [t1 <= self size])
				ifTrue: [self errorImproperStore]
				ifFalse: [self errorSubscriptBounds: t1]].
	t1 isNumber
		ifTrue: [^ self basicAt: t1 asInteger put: t2].
	self errorNonIntegerIndex! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
basicSize
	<primitive: 62>
	^ 0! !

!FutureMaker methodsFor: 'debug' stamp: ''!
defaultLabelForInspector
	^ self class name! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
doesNotUnderstand: t1 
	^ myTarget
		futureSend: t1 selector
		at: deltaMSecs
		args: t1 arguments! !

!FutureMaker methodsFor: 'comparing' stamp: ''!
hash
	^ self scaledIdentityHash! !

!FutureMaker methodsFor: 'debug' stamp: ''!
inspectorClass
	^ Inspector! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
instVarAt: t1 
	<primitive: 73>
	^ self basicAt: t1 - self class instSize! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
instVarAt: t1 put: t2 
	<primitive: 74>
	^ self basicAt: t1 - self class instSize put: t2! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
isKindOf: t1 
	self class == t1
		ifTrue: [^ true].
	^ self class inheritsFrom: t1! !

!FutureMaker methodsFor: 'accessing' stamp: ''!
isMemberOf: t1 
	^ self class == t1! !

!FutureMaker methodsFor: 'testing' stamp: ''!
isText
	^ false! !

!FutureMaker methodsFor: 'printing' stamp: ''!
printOn: t1 
	| t2 |
	t2 := self class name.
	t1
		nextPutAll: (t2 first isVowel
				ifTrue: ['an ']
				ifFalse: ['a ']);
		 nextPutAll: t2! !

!FutureMaker methodsFor: 'printing' stamp: ''!
printString
	^ self printStringLimitedTo: 50000! !

!FutureMaker methodsFor: 'printing' stamp: ''!
printStringLimitedTo: t1 
	| t2 |
	t2 := String
				streamContents: [:t3 | self printOn: t3]
				limitedTo: t1.
	t2 size < t1
		ifTrue: [^ t2].
	^ t2 , '...etc...'! !

!FutureMaker methodsFor: 'private' stamp: ''!
setDeltaMSecs: t1 target: t2 
	deltaMSecs := t1.
	myTarget := t2! !

!FutureMaker methodsFor: 'private' stamp: ''!
setTarget: t1 
	myTarget := t1! !

ProtoObject subclass: #MessageCatcher
	instanceVariableNames: 'accumulator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!MessageCatcher methodsFor: 'as yet unclassified' stamp: ''!
doesNotUnderstand: t1 
	accumulator
		ifNotNil: [accumulator add: t1].
	^ t1! !

!MessageCatcher methodsFor: 'as yet unclassified' stamp: ''!
privAccumulator
	^ accumulator! !

!MessageCatcher methodsFor: 'as yet unclassified' stamp: ''!
privAccumulator: t1 
	accumulator := t1! !

ProtoObject subclass: #Object
	instanceVariableNames: ''
	classVariableNames: 'DependentsFields'
	poolDictionaries: ''
	category: 'Kernel-Objects'!

Object variableSubclass: #AdditionalMethodState
	instanceVariableNames: 'method selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!AdditionalMethodState class methodsFor: 'instance creation' stamp: 'eem 9/16/2011 11:25'!
forMethod: aMethod selector: aSelector
	^(self new: 0)
		selector: aSelector;
		setMethod: aMethod;
		yourself! !

!AdditionalMethodState class methodsFor: 'instance creation' stamp: 'eem 9/16/2011 11:26'!
selector: aSelector with: aPropertyOrPragma
	^(self new: 1)
		selector: aSelector;
		basicAt: 1 put: aPropertyOrPragma;
		yourself! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
analogousCodeTo: t1 
	| t2 |
	(t2 := self basicSize) ~= t1 basicSize
		ifTrue: [^ false].
	1
		to: t2
		do: [:t3 | ((self basicAt: t3)
					analogousCodeTo: (t1 basicAt: t3))
				ifFalse: [^ false]].
	^ true! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
at: t1 
	^ self
		at: t1
		ifAbsent: [self error: 'not found']! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
at: t1 ifAbsent: t2 
	| t4 |
	1
		to: self basicSize
		do: [:t3 | (t4 := self basicAt: t3) key == t1
				ifTrue: [^ t4 isVariableBinding
						ifTrue: [t4 value]
						ifFalse: [t4]]].
	^ t2 value! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
at: t1 ifAbsentPut: t2 
	| t4 |
	1
		to: self basicSize
		do: [:t3 | (t4 := self basicAt: t3) key == t1
				ifTrue: [^ t4 isVariableBinding
						ifTrue: [t4 value]
						ifFalse: [t4]]].
	^ method propertyValueAt: t1 put: t2 value! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
at: t1 put: t2 
	| t3 t5 |
	t3 := false.
	1
		to: self basicSize
		do: [:t4 | (t5 := self basicAt: t4) key == t1
				ifTrue: [t3 := true.
					t5 isVariableBinding
						ifTrue: [t5 value: t2]
						ifFalse: [self basicAt: t4 put: t2]]].
	t3
		ifFalse: [method propertyValueAt: t1 put: t2].
	^ t2! !

!AdditionalMethodState methodsFor: 'copying' stamp: 'eem 9/16/2011 11:26'!
copyWith: aPropertyOrPragma "<Association|Pragma>"
	"Answer a copy of the receiver which includes aPropertyOrPragma"
	| bs copy |
	(Association == aPropertyOrPragma class
	 or: [Pragma == aPropertyOrPragma class]) ifFalse:
		[self error: self class name, ' instances should hold only Associations or Pragmas.'].
	"no need to initialize here; we're copying all inst vars"
	copy := self class basicNew: (bs := self basicSize) + 1.
	1 to: bs do:
		[:i|
		copy basicAt: i put: (self basicAt: i) shallowCopy].
	copy basicAt: bs + 1 put: aPropertyOrPragma.
	1 to: self class instSize do:
		[:i| copy instVarAt: i put: (self instVarAt: i)].
	^copy! !

!AdditionalMethodState methodsFor: 'copying' stamp: 'eem 9/16/2011 11:27'!
copyWithout: aPropertyOrPragma "<Association|Pragma>"
	"Answer a copy of the receiver which no longer includes aPropertyOrPragma"
	| bs copy offset |
	"no need to initialize here; we're copying all inst vars"
	copy := self class basicNew: (bs := self basicSize) - ((self includes: aPropertyOrPragma)
															ifTrue: [1]
															ifFalse: [0]).
	offset := 0.
	1 to: bs do:
		[:i|
		(self basicAt: i) = aPropertyOrPragma
			ifTrue: [offset := 1]
			ifFalse: [copy basicAt: i - offset put: (self basicAt: i) shallowCopy]].
	1 to: self class instSize do:
		[:i| copy instVarAt: i put: (self instVarAt: i)].
	^copy! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
hasAtLeastTheSamePropertiesAs: t1 
	t1
		keysAndValuesDo: [:t2 :t3 | (t3 isKindOf: Pragma)
				ifFalse: [(self includes: t2 -> t3)
						ifFalse: [^ false]]].
	^ true! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
hasLiteralSuchThat: t1 
	| t3 |
	1
		to: self basicSize
		do: [:t2 | 
			t3 := self basicAt: t2.
			(t3 isVariableBinding
					ifTrue: [(t1 value: t3 key)
							or: [(t1 value: t3 value)
									or: [t3 value isArray
											and: [t3 value hasLiteralSuchThat: t1]]]]
					ifFalse: [t3 hasLiteralSuchThat: t1])
				ifTrue: [^ true]].
	^ false! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
hasLiteralThorough: t1 
	| t3 |
	1
		to: self basicSize
		do: [:t2 | 
			t3 := self basicAt: t2.
			(t3 isVariableBinding
					ifTrue: [t3 key == t1
							or: [t3 value == t1
									or: [t3 value isArray
											and: [t3 value hasLiteral: t1]]]]
					ifFalse: [t3 hasLiteral: t1])
				ifTrue: [^ true]].
	^ false! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
includes: t1 
	1
		to: self basicSize
		do: [:t2 | (self basicAt: t2)
					= t1
				ifTrue: [^ true]].
	^ false! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
includesKey: t1 
	1
		to: self basicSize
		do: [:t2 | (self basicAt: t2) key == t1
				ifTrue: [^ true]].
	^ false! !

!AdditionalMethodState methodsFor: 'properties' stamp: ''!
includesProperty: t1 
	| t3 |
	1
		to: self basicSize
		do: [:t2 | 
			t3 := self basicAt: t2.
			(t3 isVariableBinding
					and: [t3 key == t1])
				ifTrue: [^ true]].
	^ false! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
isEmpty
	^ self basicSize = 0! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
isMethodProperties
	^ true! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
keysAndValuesDo: t1 
	| t3 |
	1
		to: self basicSize
		do: [:t2 | (t3 := self basicAt: t2) isVariableBinding
				ifTrue: [t1 value: t3 key value: t3 value]
				ifFalse: [t1 value: t3 keyword value: t3]]! !

!AdditionalMethodState methodsFor: 'decompiling' stamp: ''!
method: t1 
	method := t1! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
methodHome
	^ method methodClass! !

!AdditionalMethodState methodsFor: 'testing' stamp: ''!
notEmpty
	^ self basicSize > 0! !

!AdditionalMethodState methodsFor: 'copying' stamp: 'eem 9/14/2011 17:50'!
postCopy
	"After copying we must duplicate any associations and pragmas so they don't end up being shared."
	1 to: self basicSize do:
		[:i| self basicAt: i put: (self basicAt: i) shallowCopy]! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
pragmas
	| t1 t3 |
	t1 := WriteStream
				on: (Array new: self basicSize).
	1
		to: self basicSize
		do: [:t2 | (t3 := self basicAt: t2) isVariableBinding
				ifFalse: [t1 nextPut: t3]].
	^ t1 contents! !

!AdditionalMethodState methodsFor: 'printing' stamp: 'eem 9/14/2011 17:18'!
printOn: aStream
	super printOn: aStream.
	aStream space; nextPut: $(; print: self identityHash; nextPut: $)! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
properties
	| t1 t3 |
	t1 := WriteStream
				on: (Array new: self basicSize * 2).
	1
		to: self basicSize
		do: [:t2 | (t3 := self basicAt: t2) isVariableBinding
				ifTrue: [t1 nextPut: t3 key;
						 nextPut: t3 value]].
	^ IdentityDictionary newFromPairs: t1 contents! !

!AdditionalMethodState methodsFor: 'properties' stamp: ''!
propertyKeysAndValuesDo: t1 
	| t3 |
	1
		to: self basicSize
		do: [:t2 | (t3 := self basicAt: t2) isVariableBinding
				ifTrue: [t1 value: t3 key value: t3 value]]! !

!AdditionalMethodState methodsFor: 'properties' stamp: ''!
propertyValueAt: t1 
	^ self
		propertyValueAt: t1
		ifAbsent: [self error: 'Property not found']! !

!AdditionalMethodState methodsFor: 'properties' stamp: ''!
propertyValueAt: t1 ifAbsent: t2 
	| t4 |
	1
		to: self basicSize
		do: [:t3 | 
			t4 := self basicAt: t3.
			(t4 isVariableBinding
					and: [t4 key == t1])
				ifTrue: [^ t4 value]].
	^ t2 value! !

!AdditionalMethodState methodsFor: 'properties' stamp: ''!
removeKey: t1 
	^ self
		removeKey: t1
		ifAbsent: [self error: 'Property not found']! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
removeKey: t1 ifAbsent: t2 
	| t4 |
	1
		to: self basicSize
		do: [:t3 | 
			t4 := self basicAt: t3.
			(t4 isVariableBinding
					ifTrue: [t4 key]
					ifFalse: [t4 keyword])
					== t1
				ifTrue: [^ method removeProperty: t1]].
	^ t2 value! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
selector: t1 
	selector := t1! !

!AdditionalMethodState methodsFor: 'accessing' stamp: ''!
setMethod: t1 
	| t3 |
	method := t1.
	1
		to: self basicSize
		do: [:t2 | (t3 := self basicAt: t2) isVariableBinding
				ifFalse: [t3 setMethod: t1]]! !

Object subclass: #Behavior
	instanceVariableNames: 'superclass methodDict format'
	classVariableNames: 'ObsoleteSubclasses'
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!Behavior class methodsFor: 'testing' stamp: ''!
canZapMethodDictionary
	^ false! !

!Behavior class methodsFor: 'class initialization' stamp: ''!
cleanUp
	self flushObsoleteSubclasses! !

!Behavior class methodsFor: 'class initialization' stamp: ''!
flushObsoleteSubclasses
	ObsoleteSubclasses finalizeValues! !

!Behavior class methodsFor: 'class initialization' stamp: ''!
initialize
	| t1 |
	ObsoleteSubclasses
		ifNil: [self initializeObsoleteSubclasses]
		ifNotNil: [t1 := WeakKeyToCollectionDictionary newFrom: ObsoleteSubclasses.
			t1 rehash.
			ObsoleteSubclasses := t1]! !

!Behavior class methodsFor: 'class initialization' stamp: ''!
initializeObsoleteSubclasses
	ObsoleteSubclasses := WeakKeyToCollectionDictionary new! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
>> t1 
	^ self compiledMethodAt: t1! !

!Behavior methodsFor: 'obsolete subclasses' stamp: ''!
addObsoleteSubclass: t1 
	| t2 |
	t2 := ObsoleteSubclasses
				at: self
				ifAbsent: [WeakArray new].
	(t2 includes: t1)
		ifTrue: [^ self].
	t2 := t2 copyWithout: nil.
	t2 := t2 copyWith: t1.
	ObsoleteSubclasses at: self put: t2! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
addSelector: t1 withMethod: t2 
	^ self
		addSelector: t1
		withMethod: t2
		notifying: nil! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
addSelector: t1 withMethod: t2 notifying: t3 
	^ self basicAddSelector: t1 withMethod: t2! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
addSelectorSilently: t1 withMethod: t2 
	self basicAddSelector: t1 withMethod: t2! !

!Behavior methodsFor: 'instance creation' stamp: 'hsj 2/16/2011 13:44'!
adoptInstance: anInstance
	"Change the class of anInstance to me.
	Primitive (found in Cog and new VMs)  follows the same rules as primitiveChangeClassTo:, but returns the class rather than the modified instance"

	<primitive: 160 error: ec>
	anInstance primitiveChangeClassTo: self basicNew.
	^self! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
allClassVarNames
	^ superclass allClassVarNames! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
allInstVarNames
	| t1 |
	superclass
		ifNil: [t1 := self instVarNames copy]
		ifNotNil: [t1 := superclass allInstVarNames , self instVarNames].
	^ t1! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
allInstances
	| t1 |
	t1 := OrderedCollection new.
	self
		allInstancesDo: [:t2 | t2 == t1
				ifFalse: [t1 add: t2]].
	^ t1 asArray! !

!Behavior methodsFor: 'enumerating' stamp: ''!
allInstancesDo: t1 
	| t2 t3 |
	t2 := self someInstance.
	[t2 == nil]
		whileFalse: [t3 := t2 nextInstance.
			t1 value: t2.
			t2 := t3]! !

!Behavior methodsFor: 'enumerating' stamp: ''!
allInstancesEverywhereDo: t1 
	self == UndefinedObject
		ifTrue: [^ t1 value: nil].
	self allInstancesDo: t1.
	ImageSegment
		allSubInstancesDo: [:t2 | t2 allInstancesOf: self do: t1]! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
allSelectors
	^ (Array
		streamContents: [:t1 | self
				withAllSuperclassesDo: [:t2 | t2
						selectorsDo: [:t3 | t1 nextPut: t3]]]) asIdentitySet! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
allSelectorsBelow: t1 
	| t2 |
	t2 := IdentitySet new.
	self
		withAllSuperclassesDo: [:t3 | 
			t3 = t1
				ifTrue: [^ t2].
			t3
				selectorsDo: [:t4 | t2 add: t4]].
	^ t2! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
allSharedPools
	^ superclass allSharedPools! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
allSubInstances
	| t1 |
	t1 := OrderedCollection new.
	self
		allSubInstancesDo: [:t2 | t2 == t1
				ifFalse: [t1 add: t2]].
	^ t1! !

!Behavior methodsFor: 'enumerating' stamp: ''!
allSubInstancesDo: t1 
	self allInstancesDo: t1.
	self
		allSubclassesDo: [:t2 | t2 allInstancesDo: t1]! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
allSubclasses
	| t1 t2 |
	t1 := OrderedCollection withAll: self subclasses.
	t2 := 1.
	[t2 > t1 size]
		whileFalse: [t1 addAll: (t1 at: t2) subclasses.
			t2 := t2 + 1].
	^ t1! !

!Behavior methodsFor: 'enumerating' stamp: ''!
allSubclassesDo: t1 
	self
		subclassesDo: [:t2 | 
			t1 value: t2.
			t2 allSubclassesDo: t1]! !

!Behavior methodsFor: 'enumerating' stamp: ''!
allSubclassesDoGently: t1 
	self
		subclassesDoGently: [:t2 | t2 isInMemory
				ifTrue: [t1 value: t2.
					t2 allSubclassesDoGently: t1]]! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: 'ul 4/30/2011 01:52'!
allSubclassesWithLevelDo: classAndLevelBlock startingLevel: level 
	"Walk the tree of subclasses, giving the class and its level"

	classAndLevelBlock value: self value: level.
	self == Class ifTrue:  [^ self].  "Don't visit all the metaclasses"
	"Visit subclasses in alphabetical order"
	self subclasses
		sort: [ :a :b | a name <= b name ];
		do: [ :subclass | 
			subclass
				allSubclassesWithLevelDo: classAndLevelBlock
				startingLevel: level + 1 ]! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
allSuperclasses
	| t1 |
	^ superclass
		ifNil: [OrderedCollection new]
		ifNotNil: [t1 := superclass allSuperclasses.
			t1 addFirst: superclass.
			t1]! !

!Behavior methodsFor: 'enumerating' stamp: ''!
allSuperclassesDo: t1 
	superclass
		ifNotNil: [t1 value: superclass.
			superclass allSuperclassesDo: t1]! !

!Behavior methodsFor: 'traits' stamp: ''!
allTraits
	^ #()! !

!Behavior methodsFor: 'user interface' stamp: ''!
allUnreferencedInstanceVariables
	^ self allInstVarNames
		reject: [:t1 | 
			| t2 |
			t2 := self classThatDefinesInstanceVariable: t1.
			t2 withAllSubclasses
				anySatisfy: [:t3 | (t3 whichSelectorsAccess: t1 asSymbol) notEmpty]]! !

!Behavior methodsFor: 'compiling' stamp: ''!
allowUnderscoreAssignments
	^ nil! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
allowsSubInstVars
	^ true! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
basicAddSelector: t1 withMethod: t2 
	| t3 |
	t3 := self lookupSelector: t1.
	self methodDict at: t1 put: t2.
	t2 methodClass: self.
	t2 selector: t1.
	t3
		ifNotNil: [t3 flushCache].
	t1 flushCache! !

!Behavior methodsFor: 'instance creation' stamp: ''!
basicNew
	<primitive: 70>
	self isVariable
		ifTrue: [^ self basicNew: 0].
	OutOfMemory signal.
	^ self basicNew! !

!Behavior methodsFor: 'instance creation' stamp: ''!
basicNew: t1 
	<primitive: 71>
	self isVariable
		ifFalse: [self error: self printString , ' cannot have variable sized instances'].
	(t1 isInteger
			and: [t1 >= 0])
		ifTrue: [OutOfMemory signal.
			^ self basicNew: t1].
	self primitiveFailed! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
basicRemoveSelector: t1 
	| t2 |
	t2 := self methodDict
				at: t1
				ifAbsent: [^ nil].
	self methodDict removeKey: t1.
	t2 flushCache.
	t1 flushCache.
	^ t2! !

!Behavior methodsFor: 'private' stamp: 'ul 9/3/2012 11:45'!
becomeCompact
	"Here are the restrictions on compact classes in order for export segments to work:  A compact class index may not be reused.  If a class was compact in a release of Squeak, no other class may use that index.  The class might not be compact later, and there should be nil in its place in the array."
	| cct index |

	self isWeak ifTrue:[^ self halt: 'You must not make a weak class compact'].
	cct := Smalltalk compactClassesArray.
	(self isCompact or: [cct includes: self])
		ifTrue: [^ self halt: self name , 'is already compact'].
	index := cct indexOf: nil
		ifAbsent: [^ self halt: 'compact class table is full'].
	"Install this class in the compact class table"
	cct at: index put: self.
	"Update instspec so future instances will be compact"
	format := format + (index bitShift: 11).
	"Make up new instances and become old ones into them"
	self updateInstancesFrom: self.
	"Purge any old instances"
	Smalltalk garbageCollect.! !

!Behavior methodsFor: 'private' stamp: 'ul 9/3/2012 11:45'!
becomeCompactSimplyAt: index
	"Make me compact, but don't update the instances.  For importing segments."
"Here are the restrictions on compact classes in order for export segments to work:  A compact class index may not be reused.  If a class was compact in a release of Squeak, no other class may use that index.  The class might not be compact later, and there should be nil in its place in the array."
	| cct |

	self isWeak ifTrue:[^ self halt: 'You must not make a weak class compact'].
	cct := Smalltalk compactClassesArray.
	(self isCompact or: [cct includes: self])
		ifTrue: [^ self halt: self name , 'is already compact'].
	(cct at: index) ifNotNil: [^ self halt: 'compact table slot already in use'].
	"Install this class in the compact class table"
	cct at: index put: self.
	"Update instspec so future instances will be compact"
	format := format + (index bitShift: 11).
	"Caller must convert the instances"
! !

!Behavior methodsFor: 'private' stamp: ''!
becomeUncompact
	| t1 t2 |
	t1 := Smalltalk compactClassesArray.
	(t2 := self indexIfCompact) = 0
		ifTrue: [^ self].
	(t1 includes: self)
		ifFalse: [^ self halt].
	format := format
				- (t2 bitShift: 11).
	self updateInstancesFrom: self.
	Smalltalk garbageCollect.
	t1 at: t2 put: nil! !

!Behavior methodsFor: 'compiling' stamp: ''!
binding
	^ nil -> self! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
bindingOf: t1 
	^ superclass bindingOf: t1! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
canUnderstand: t1 
	(self includesSelector: t1)
		ifTrue: [^ true].
	superclass
		ifNil: [^ false].
	^ superclass canUnderstand: t1! !

!Behavior methodsFor: 'testing' stamp: ''!
canZapMethodDictionary
	^ true! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
changeRecordsAt: t1 
	^ ChangeSet
		scanVersionsOf: (self
				compiledMethodAt: t1
				ifAbsent: [^ nil])
		class: self
		meta: self isMeta
		category: (self whichCategoryIncludesSelector: t1)
		selector: t1! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
classBindingOf: t1 
	^ self bindingOf: t1! !

!Behavior methodsFor: 'accessing' stamp: ''!
classDepth
	superclass
		ifNil: [^ 1].
	^ superclass classDepth + 1! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
classVarNames
	^ #()! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
cleanUp
	^ self! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
cleanUp: t1 
	^ self cleanUp! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
commentsAt: t1 
	^ self commentsIn: (self sourceCodeAt: t1) asString! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'ul 4/30/2011 03:42'!
commentsIn: sourceString
	"Return the comments as a collection of strings in sourceString. This method along with #nextQuotePosIn:startingFrom: is wrong, because it assumes that all double quote characters are comment delimiters, but even this method has a double quote which is not part of any method comment. Also this method has nothing to do with the Behavior itself. Probably CompiledMethod is the best place for this."
	
	| commentStart nextQuotePos someComments aPos |
	(sourceString includes: $") ifFalse: [^#()].
	someComments:= OrderedCollection new.
	aPos:=1.
	nextQuotePos:= 0.
	[commentStart := sourceString findString: '"' startingAt: aPos.
	nextQuotePos:= self nextQuotePosIn: sourceString startingFrom: commentStart.
	(commentStart ~= 0 and: [nextQuotePos >commentStart])] whileTrue: [
		commentStart ~= nextQuotePos ifTrue: [
			someComments add: ((sourceString copyFrom: commentStart + 1 to: nextQuotePos - 1) copyReplaceAll: '""' with: '"').].
	aPos := nextQuotePos+1].
	^someComments! !

!Behavior methodsFor: 'compiling' stamp: ''!
compile: t1 
	^ self compile: t1 notifying: nil! !

!Behavior methodsFor: 'compiling' stamp: 'nice 2/23/2011 21:36'!
compile: code classified: category notifying: requestor trailer: bytes ifFail: failBlock
	"Compile code without logging the source in the changes file"

	| methodNode |
	methodNode  := self newCompiler
				compile: code
				in: self
				classified: category 
				notifying: requestor
				ifFail: failBlock.
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: bytes.! !

!Behavior methodsFor: 'compiling' stamp: ''!
compile: t1 notifying: t2 
	| t3 |
	t3 := self
				compile: t1
				classified: nil
				notifying: t2
				trailer: self defaultMethodTrailer
				ifFail: [^ nil].
	t3 method
		putSource: t1
		fromParseNode: t3 node
		inFile: 2
		withPreamble: [:t4 | t4 cr; nextPut: $!!; nextChunkPut: 'Behavior method'; cr].
	self
		addSelector: t3 selector
		withMethod: t3 method
		notifying: t2.
	^ t3 selector! !

!Behavior methodsFor: 'compiling' stamp: ''!
compileAll
	^ self compileAllFrom: self! !

!Behavior methodsFor: 'compiling' stamp: ''!
compileAllFrom: t1 
	| t2 |
	t1
		selectorsDo: [:t3 | self recompile: t3 from: t1].
	t2 := self binding.
	self
		methodsDo: [:t3 | t3 methodClassAssociation == t2
				ifFalse: [t3 methodClassAssociation: t2]]! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
compiledMethodAt: t1 
	^ self methodDict at: t1! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'ul 8/2/2011 19:52'!
compiledMethodAt: selector ifAbsent: aBlock
	"Answer the compiled method associated with the argument, selector (a Symbol), a message selector in the receiver's method dictionary. If the selector is not in the dictionary, return the value of aBlock"

	^ self methodDict at: selector ifAbsent: aBlock! !

!Behavior methodsFor: 'compiling' stamp: ''!
compilerClass
	^ Compiler! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'ul 4/28/2010 12:29'!
compress
	"Compact the method dictionary of the receiver."

	self methodDict compact! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'nice 2/23/2011 21:37'!
compressedSourceCodeAt: selector
	"(Paragraph compressedSourceCodeAt: #displayLines:affectedRectangle:) size 721 1921
	Paragraph selectors inject: 0 into: [:tot :sel | tot + (Paragraph compressedSourceCodeAt: sel) size] 13606 31450"
	| rawText parse |
	rawText := (self sourceCodeAt: selector) asString.
	parse := self newCompiler parse: rawText in: self notifying: nil.
	^ rawText compressWithTable:
		((selector keywords ,
		parse tempNames ,
		self instVarNames ,
		#(self super ifTrue: ifFalse:) ,
		((0 to: 7) collect:
			[:i | String streamContents:
				[:s | s cr. i timesRepeat: [s tab]]]) ,
		(self compiledMethodAt: selector) literalStrings)
			asSortedCollection: [:a :b | a size > b size])! !

!Behavior methodsFor: 'copying' stamp: ''!
copyOfMethodDictionary
	^ self methodDict copy! !

!Behavior methodsFor: 'user interface' stamp: ''!
crossReference
	^ self selectors asArray sort
		collect: [:t1 | Array
				with: (String with: Character cr)
						, t1
				with: (self whichSelectorsReferTo: t1)]! !

!Behavior methodsFor: 'compiling' stamp: ''!
decompile: t1 
	^ self decompilerClass new decompile: t1 in: self! !

!Behavior methodsFor: 'compiling' stamp: ''!
decompilerClass
	^ self compilerClass decompilerClass! !

!Behavior methodsFor: 'copying' stamp: 'nice 12/29/2010 12:11'!
deepCopy
	"Behavior are shared rather than copied."

	^ self! !

!Behavior methodsFor: 'compiling' stamp: ''!
defaultMethodTrailer
	^ CompiledMethodTrailer empty! !

!Behavior methodsFor: 'printing' stamp: ''!
defaultNameStemForInstances
	^ self name! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
emptyMethodDictionary
	^ MethodDictionary new! !

!Behavior methodsFor: 'accessing' stamp: ''!
environment
	^ Smalltalk globals! !

!Behavior methodsFor: 'compiling' stamp: ''!
evaluatorClass
	^ Compiler! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
firstCommentAt: t1 
	| t2 |
	t2 := self commentsAt: t1.
	^ t2 isEmpty
		ifTrue: ['']
		ifFalse: [t2 first]! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'nice 2/23/2011 21:44'!
firstPrecodeCommentFor:  selector
	"If there is a comment in the source code at the given selector that preceeds the body of the method, return it here, else return nil"

	| parser source tree |
	"Behavior firstPrecodeCommentFor: #firstPrecodeCommentFor:"
	(#(Comment Definition Hierarchy) includes: selector)
		ifTrue:
			["Not really a selector"
			^ nil].
	source := self sourceCodeAt: selector asSymbol ifAbsent: [^ nil].
	parser := self newParser.
	tree := 
		parser
			parse: (ReadStream on: source)
			class: self
			noPattern: false
			context: nil
			notifying: nil
			ifFail: [^ nil].
	^ (tree comment ifNil: [^ nil]) first! !

!Behavior methodsFor: 'private' stamp: ''!
flushCache
	<primitive: 89>
	self primitiveFailed! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
forgetDoIts
	self basicRemoveSelector: #DoIt;
		 basicRemoveSelector: #DoItIn:! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
formalHeaderPartsFor: t1 
	^ Scanner new
		scanMessageParts: (self methodHeaderFor: t1)! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'nice 2/23/2011 21:44'!
formalParametersAt: aSelector
	"Return the names of the arguments used in this method."

	| source |
	source := self sourceCodeAt: aSelector ifAbsent: [^ #()].	"for now"
	^self newParser parseParameterNames: source! !

!Behavior methodsFor: 'accessing' stamp: ''!
format
	^ format! !

!Behavior methodsFor: 'printing' stamp: ''!
formatterClass
	^ self compilerClass! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
fullyImplementsVocabulary: t1 
	(t1 encompassesAPriori: self)
		ifTrue: [^ true].
	t1 allSelectorsInVocabulary
		do: [:t2 | (self canUnderstand: t2)
				ifFalse: [^ false]].
	^ true! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
hasMethods
	^ self methodDict size > 0! !

!Behavior methodsFor: 'traits' stamp: ''!
hasTraitComposition
	^ false! !

!Behavior methodsFor: 'comparing' stamp: ''!
hash
	^ self name hash! !

!Behavior methodsFor: 'testing class hierarchy' stamp: ''!
includesBehavior: t1 
	^ self == t1
		or: [self inheritsFrom: t1]! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
includesLocalSelector: t1 
	^ self includesSelector: t1! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
includesSelector: t1 
	^ self methodDict includesKey: t1! !

!Behavior methodsFor: 'private' stamp: ''!
indexIfCompact
	^ (format bitShift: -11)
		bitAnd: 31! !

!Behavior methodsFor: 'testing class hierarchy' stamp: ''!
inheritsFrom: t1 
	| t2 |
	t2 := superclass.
	[t2 == nil]
		whileFalse: [t2 == t1
				ifTrue: [^ true].
			t2 := t2 superclass].
	^ false! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
initialize
	self methodDictionary: self emptyMethodDictionary.
	self superclass: Object.
	self setFormat: Object format! !

!Behavior methodsFor: 'instance creation' stamp: ''!
initializedInstance
	^ self new! !

!Behavior methodsFor: 'accessing instances and variables' stamp: 'ul 11/15/2010 10:09'!
inspectAllInstances 
	"Inpsect all instances of the receiver.  1/26/96 sw"

	| all allSize prefix |
	all := self allInstances.
	(allSize := all size) = 0 ifTrue: [^ self inform: 'There are no 
instances of ', self name].
	prefix := allSize = 1
		ifTrue: 	['The lone instance']
		ifFalse:	['The ', allSize printString, ' instances'].
	
	all asArray inspectWithLabel: (prefix, ' of ', self name)! !

!Behavior methodsFor: 'accessing instances and variables' stamp: 'ul 11/15/2010 10:10'!
inspectSubInstances 
	"Inspect all instances of the receiver and all its subclasses.  CAUTION - don't do this for something as generic as Object!!  1/26/96 sw"

	| all allSize prefix |
	all := self allSubInstances.
	(allSize := all size) = 0 ifTrue: [^ self inform: 'There are no 
instances of ', self name, '
or any of its subclasses'].
	prefix := allSize = 1
		ifTrue: 	['The lone instance']
		ifFalse:	['The ', allSize printString, ' instances'].
	
	all asArray inspectWithLabel: (prefix, ' of ', self name, ' & its subclasses')! !

!Behavior methodsFor: 'testing' stamp: ''!
instSize
	self flag: #instSizeChange.
	^ ((format bitShift: -10)
		bitAnd: 192)
		+ ((format bitShift: -1)
				bitAnd: 63) - 1! !

!Behavior methodsFor: 'testing' stamp: ''!
instSpec
	^ (format bitShift: -7)
		bitAnd: 15! !

!Behavior methodsFor: 'accessing instances and variables' stamp: 'ul 4/27/2011 00:43'!
instVarIndexFor: instVarName ifAbsent: aBlock
	"Answer the index of the named instance variable."
	
	^self allInstVarNames indexOf: instVarName ifAbsent: aBlock! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
instVarNames
	| t1 t2 |
	t1 := self instSize.
	t2 := superclass
				ifNil: [0]
				ifNotNil: [superclass instSize].
	t1 = t2
		ifTrue: [^ #()].
	^ (t2 + 1 to: t1)
		collect: [:t3 | 'inst' , t3 printString]! !

!Behavior methodsFor: 'compiling' stamp: ''!
instVarNamesAndOffsetsDo: t1 
	^ self! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
instanceCount
	| t1 |
	t1 := 0.
	self
		allInstancesDo: [:t3 | t1 := t1 + 1].
	^ t1! !

!Behavior methodsFor: 'testing' stamp: ''!
isBehavior
	^ true! !

!Behavior methodsFor: 'testing' stamp: ''!
isBits
	^ self instSpec >= 6! !

!Behavior methodsFor: 'testing' stamp: ''!
isBytes
	^ self instSpec >= 8! !

!Behavior methodsFor: 'testing' stamp: 'ul 9/2/2012 19:46'!
isCompact

	^self indexIfCompact ~= 0! !

!Behavior methodsFor: 'testing' stamp: ''!
isFixed
	^ self isVariable not! !

!Behavior methodsFor: 'testing' stamp: ''!
isMeta
	^ false! !

!Behavior methodsFor: 'testing' stamp: ''!
isObsolete
	^ self instanceCount = 0! !

!Behavior methodsFor: 'testing' stamp: ''!
isPointers
	^ self isBits not! !

!Behavior methodsFor: 'testing' stamp: ''!
isVariable
	^ self instSpec >= 2! !

!Behavior methodsFor: 'testing' stamp: ''!
isWeak
	^ self instSpec = 4! !

!Behavior methodsFor: 'testing' stamp: 'nice 10/26/2010 21:14'!
isWords
	"Answer true if the receiver is made of 32-bit instance variables."

	^self isBytes not! !

!Behavior methodsFor: 'testing class hierarchy' stamp: ''!
kindOfSubclass
	self isWeak
		ifTrue: [^ ' weakSubclass: '].
	^ self isVariable
		ifTrue: [self isBits
				ifTrue: [self isBytes
						ifTrue: [' variableByteSubclass: ']
						ifFalse: [' variableWordSubclass: ']]
				ifFalse: [' variableSubclass: ']]
		ifFalse: [' subclass: ']! !

!Behavior methodsFor: 'printing' stamp: ''!
literalScannedAs: t1 notifying: t2 
	| t3 t4 |
	t1 isVariableBinding
		ifFalse: [^ t1].
	t3 := t1 key.
	t4 := t1 value.
	t3 isNil
		ifTrue: [(self bindingOf: t4)
				ifNotNil: [:t5 | (t5 value isKindOf: Behavior)
						ifTrue: [^ nil -> t5 value class]].
			t2 notify: 'No such metaclass'.
			^ false].
	t3 isSymbol
		ifTrue: [(self bindingOf: t3)
				ifNotNil: [:t6 | ^ t6].
			Undeclared at: t3 put: nil.
			^ Undeclared bindingOf: t3].
	t2 notify: '## must be followed by a non-local variable name'.
	^ false! !

!Behavior methodsFor: 'adding/removing methods' stamp: 'rms 1/13/2013 00:10'!
localSelectors

	self selectors ifEmpty: [^nil].
	^self selectors asSet! !

!Behavior methodsFor: 'printing' stamp: ''!
longPrintOn: t1 
	t1 nextPutAll: '<<too complex to show>>';
		 cr! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
lookupSelector: t1 
	| t2 |
	t2 := self.
	[t2 == nil]
		whileFalse: [(t2 includesSelector: t1)
				ifTrue: [^ t2 compiledMethodAt: t1].
			t2 := t2 superclass].
	^ nil! !

!Behavior methodsFor: 'accessing' stamp: ''!
methodDict
	methodDict
		ifNil: [self recoverFromMDFaultWithTrace].
	^ methodDict! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
methodDict: t1 
	methodDict := t1! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
methodDictionary
	^ self methodDict! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
methodDictionary: t1 
	self methodDict: t1! !

!Behavior methodsFor: 'accessing method dictionary' stamp: 'nice 2/23/2011 21:44'!
methodHeaderFor: selector 
	"Answer the string corresponding to the method header for the given selector"

	| sourceString parser |
	sourceString := self ultimateSourceCodeAt: selector ifAbsent: [self standardMethodHeaderFor: selector].
	(parser := self newParser) parseSelector: sourceString.
	^ sourceString asString copyFrom: 1 to: (parser endOfLastToken min: sourceString size)

	"Behavior methodHeaderFor: #methodHeaderFor: "
! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
methodsDo: t1 
	^ self methodDict valuesDo: t1! !

!Behavior methodsFor: 'accessing' stamp: ''!
name
	^ 'a subclass of ' , superclass name! !

!Behavior methodsFor: 'instance creation' stamp: ''!
new
	^ self basicNew initialize! !

!Behavior methodsFor: 'instance creation' stamp: ''!
new: t1 
	^ (self basicNew: t1) initialize! !

!Behavior methodsFor: 'compiling' stamp: 'nice 2/23/2011 21:36'!
newCompiler
	"Answer a Compiler suitable for compiling this Behavior"
	^self compilerClass new parser: self newParser! !

!Behavior methodsFor: 'compiling' stamp: 'nice 2/23/2011 21:36'!
newParser
	"Answer a Parser suitable for parsing source code in this Behavior"
	^self parserClass new! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
nextQuotePosIn: t1 startingFrom: t2 
	| t3 t4 |
	t3 := t2 + 1.
	[(t4 := t1 findString: '"' startingAt: t3)
			== (t1 findString: '""' startingAt: t3)
		and: [t4 ~= 0]]
		whileTrue: [t3 := t4 + 2].
	^ t4! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
nonObsoleteClass
	| t1 |
	t1 := self name.
	[t1 beginsWith: 'AnObsolete']
		whileTrue: [t1 := t1 copyFrom: 'AnObsolete' size + 1 to: t1 size].
	^ self environment at: t1 asSymbol! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
obsolete
	self canZapMethodDictionary
		ifTrue: [self methodDict: self emptyMethodDictionary]! !

!Behavior methodsFor: 'obsolete subclasses' stamp: ''!
obsoleteSubclasses
	| t1 |
	t1 := ObsoleteSubclasses
				at: self
				ifAbsent: [^ #()].
	^ t1 copyWithout: nil! !

!Behavior methodsFor: 'compiling' stamp: ''!
parserClass
	^ self compilerClass parserClass! !

!Behavior methodsFor: 'copying' stamp: 'nice 12/29/2010 10:35'!
postCopy
	super postCopy.
	self methodDict: self methodDict copy! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
precodeCommentOrInheritedCommentFor: t1 
	| t2 t3 |
	^ (t3 := self firstPrecodeCommentFor: t1) isEmptyOrNil
		ifTrue: [(self == Behavior
					or: [superclass
							ifNil: [true]
							ifNotNil: [(t2 := superclass whichClassIncludesSelector: t1) == nil]])
				ifFalse: [t2 precodeCommentOrInheritedCommentFor: t1]]
		ifFalse: [t3]! !

!Behavior methodsFor: 'printing' stamp: ''!
prettyPrinterClass
	^ self compilerClass! !

!Behavior methodsFor: 'printing' stamp: ''!
printHierarchy
	| t1 t2 |
	t2 := 0.
	t1 := WriteStream
				on: (String new: 16).
	self allSuperclasses
		reverseDo: [:t4 | 
			t1 crtab: t2.
			t2 := t2 + 1.
			t1 nextPutAll: t4 name.
			t1 space.
			t1 print: t4 instVarNames].
	t1 cr.
	self printSubclassesOn: t1 level: t2.
	^ t1 contents! !

!Behavior methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: 'a descendent of '.
	superclass printOn: t1! !

!Behavior methodsFor: 'printing' stamp: ''!
printOnStream: t1 
	t1 print: 'a descendent of ';
		 write: superclass! !

!Behavior methodsFor: 'printing' stamp: ''!
printWithClosureAnalysisOn: t1 
	t1 nextPutAll: 'a descendent of '.
	superclass printWithClosureAnalysisOn: t1! !

!Behavior methodsFor: 'compiling' stamp: ''!
recompile: t1 
	^ self recompile: t1 from: self! !

!Behavior methodsFor: 'compiling' stamp: 'nice 2/23/2011 21:38'!
recompile: selector from: oldClass
	"Compile the method associated with selector in the receiver's method dictionary."
	"ar 7/10/1999: Use oldClass compiledMethodAt: not self compiledMethodAt:"
	| method trailer methodNode |
	method := oldClass compiledMethodAt: selector.
	trailer := method trailer.
	methodNode := self newCompiler
				compile: (oldClass sourceCodeAt: selector)
				in: self
				notifying: nil
				ifFail: [^ self].   "Assume OK after proceed from SyntaxError"
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	self basicAddSelector: selector withMethod: (methodNode generate: trailer).
! !

!Behavior methodsFor: 'compiling' stamp: ''!
recompileChanges
	self
		selectorsAndMethodsDo: [:t1 :t2 | t2 fileIndex > 1
				ifTrue: [self recompile: t1 from: self]]! !

!Behavior methodsFor: 'compiling' stamp: 'nice 2/23/2011 21:38'!
recompileNonResidentMethod: method atSelector: selector from: oldClass
	"Recompile the method supplied in the context of this class."

	| trailer methodNode |
	trailer := method trailer.
	methodNode := self newCompiler
			compile: (method getSourceFor: selector in: oldClass)
			in: self
			notifying: nil
			ifFail: ["We're in deep doo-doo if this fails (syntax error).
				Presumably the user will correct something and proceed,
				thus installing the result in this methodDict.  We must
				retrieve that new method, and restore the original (or remove)
				and then return the method we retrieved."
				^ self error: 'see comment'].
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	^ methodNode generate: trailer
! !

!Behavior methodsFor: 'obsolete subclasses' stamp: ''!
removeAllObsoleteSubclasses
	ObsoleteSubclasses
		removeKey: self
		ifAbsent: []! !

!Behavior methodsFor: 'obsolete subclasses' stamp: ''!
removeObsoleteSubclass: t1 
	| t2 |
	t2 := ObsoleteSubclasses
				at: self
				ifAbsent: [^ self].
	(t2 includes: t1)
		ifFalse: [^ self].
	t2 := t2 copyWithout: t1.
	t2 := t2 copyWithout: nil.
	ObsoleteSubclasses at: self put: t2! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
removeSelector: t1 
	^ self basicRemoveSelector: t1! !

!Behavior methodsFor: 'adding/removing methods' stamp: ''!
removeSelectorSilently: t1 
	^ SystemChangeNotifier uniqueInstance
		doSilently: [self removeSelector: t1]! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
rootStubInImageSegment: t1 
	^ ImageSegmentRootStub new
		xxSuperclass: superclass
		format: format
		segment: t1! !

!Behavior methodsFor: 'enumerating' stamp: ''!
selectSubclasses: t1 
	| t2 |
	t2 := Set new.
	self allSubclasses
		do: [:t3 | (t1 value: t3)
				ifTrue: [t2 add: t3]].
	^ t2! !

!Behavior methodsFor: 'enumerating' stamp: ''!
selectSuperclasses: t1 
	| t2 |
	t2 := Set new.
	self allSuperclasses
		do: [:t3 | (t1 value: t3)
				ifTrue: [t2 add: t3]].
	^ t2! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
selectors
	^ self methodDict keys! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
selectorsAndMethodsDo: t1 
	^ self methodDict keysAndValuesDo: t1! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
selectorsDo: t1 
	^ self methodDict keysDo: t1! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
selectorsWithArgs: t1 
	^ self selectors
		select: [:t2 | t2 numArgs = t1]! !

!Behavior methodsFor: 'private' stamp: ''!
setFormat: t1 
	format := t1! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
sharedPools
	^ OrderedCollection new! !

!Behavior methodsFor: 'testing' stamp: ''!
shouldNotBeRedefined
	^ (Smalltalk compactClassesArray includes: self)
		or: [(Smalltalk specialObjectsArray includes: self)
				or: [self isKindOf: self]]! !

!Behavior methodsFor: 'system startup' stamp: ''!
shutDown
	^ self! !

!Behavior methodsFor: 'system startup' stamp: ''!
shutDown: t1 
	^ self shutDown! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
someInstance
	<primitive: 77>
	^ nil! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
sourceCodeAt: t1 
	^ (self methodDict at: t1)
		getSourceFor: t1
		in: self! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
sourceCodeAt: t1 ifAbsent: t2 
	^ (self methodDict
		at: t1
		ifAbsent: [^ t2 value])
		getSourceFor: t1
		in: self! !

!Behavior methodsFor: 'compiling' stamp: ''!
sourceCodeTemplate
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!Behavior methodsFor: 'testing' stamp: 'nice 2/23/2011 21:38'!
sourceMatchesBytecodeAt: selector
	"Answers true if the source code at the selector compiles to the bytecode at the selector, and false otherwise. Implemented to detect an error where Monticello did not recompile sources when the class shape changed"
	"This code was copied from #recompile:from:, with few changes. Several methods would benefit from a method which turned a selector and class into a CompiledMethod, without  installing it into the methodDictionary"

	| method trailer methodNode |
	method := self compiledMethodAt: selector.
	trailer := method trailer.
	methodNode := self newCompiler
				compile: (self sourceCodeAt: selector)
				in: self
				notifying: nil
				ifFail: [^ false].   "Assume OK after proceed from SyntaxError"
	selector == methodNode selector ifFalse: [self error: 'selector changed!!'].
	^ (methodNode generate: trailer) = method! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
sourceMethodAt: t1 
	^ (self sourceCodeAt: t1) asText makeSelectorBoldIn: self! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
sourceMethodAt: t1 ifAbsent: t2 
	^ (self
		sourceCodeAt: t1
		ifAbsent: [^ t2 value]) asText makeSelectorBoldIn: self! !

!Behavior methodsFor: 'private' stamp: 'eem 5/23/2011 17:11'!
spaceUsed
	"Answer a rough estimate of number of bytes used by this class and its metaclass. Does not include space used by class variables."

	| space |
	space := 0.
	self methodsDo: [:method |
		space := space + 16.  "dict and org'n space"
		space := space + (method size + 6 "hdr + avg pad").
		method literalsDo: [:lit |
			(lit isMemberOf: Array) ifTrue: [space := space + ((lit size + 1) * 4)].
			(lit isMemberOf: Float) ifTrue: [space := space + 12].
			(lit isMemberOf: ByteString) ifTrue: [space := space + (lit size + 6)].
			(lit isMemberOf: LargeNegativeInteger) ifTrue: [space := space + ((lit size + 1) * 4)].
			(lit isMemberOf: LargePositiveInteger) ifTrue: [space := space + ((lit size + 1) * 4)]]].
		^ space! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
standardMethodHeaderFor: t1 
	| t2 |
	t2 := (1 to: t1 numArgs)
				collect: [:t3 | 'arg' , t3 printString].
	t2 size = 0
		ifTrue: [^ t1 asString].
	t2 size = 1
		ifTrue: [^ t1 , ' arg1'].
	^ String
		streamContents: [:t3 | (t1 findTokens: ':')
				with: t2
				do: [:t4 :t5 | t3 nextPutAll: t4;
						 nextPutAll: ': ';
						 nextPutAll: t5;
						 nextPutAll: ' ']]! !

!Behavior methodsFor: 'system startup' stamp: ''!
startUp
	^ self! !

!Behavior methodsFor: 'system startup' stamp: ''!
startUp: t1 
	^ self startUp! !

!Behavior methodsFor: 'system startup' stamp: ''!
startUpFrom: t1 
	^ nil! !

!Behavior methodsFor: 'printing' stamp: ''!
storeLiteral: t1 on: t2 
	| t3 t4 |
	t1 isVariableBinding
		ifFalse: [t1 storeOn: t2.
			^ self].
	t3 := t1 key.
	(t3 isNil
			and: [(t4 := t1 value) isMemberOf: Metaclass])
		ifTrue: [t2 nextPutAll: '###';
				 nextPutAll: t4 soleInstance name.
			^ self].
	(t3 isSymbol
			and: [(self bindingOf: t3) notNil])
		ifTrue: [t2 nextPutAll: '##';
				 nextPutAll: t3.
			^ self].
	t1 storeOn: t2! !

!Behavior methodsFor: 'accessing' stamp: ''!
subclassDefinerClass
	^ Compiler! !

!Behavior methodsFor: 'accessing instances and variables' stamp: ''!
subclassInstVarNames
	| t1 |
	t1 := Set new.
	self allSubclasses
		do: [:t2 | t1 addAll: t2 instVarNames].
	^ t1! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
subclasses
	^ self class allInstances
		select: [:t1 | t1 superclass = self]! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
superclass
	^ superclass! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
superclass: t1 
	(t1
			ifNil: [true]
			ifNotNil: [t1 isBehavior])
		ifTrue: [superclass := t1.
			Object flushCache]
		ifFalse: [self error: 'superclass must be a class-describing object']! !

!Behavior methodsFor: 'initialize-release' stamp: ''!
superclass: t1 methodDictionary: t2 format: t3 
	superclass := t1.
	format := t3.
	methodDict := t2! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
supermostPrecodeCommentFor: t1 
	| t2 t3 |
	(self == Behavior
			or: [superclass
					ifNil: [true]
					ifNotNil: [(t2 := superclass whichClassIncludesSelector: t1) == nil]])
		ifFalse: [t3 := t2 supermostPrecodeCommentFor: t1].
	^ t3
		ifNil: [self firstPrecodeCommentFor: t1]! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ul 3/12/2011 21:31'!
thoroughWhichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a 
	literal. Dives into the compact literal notation, making it slow but 
	thorough "

	^self whichSelectorsReferTo: literal special: specialFlag byte: specialByte thorough: true! !

!Behavior methodsFor: 'traits' stamp: ''!
traitComposition
	^ #()! !

!Behavior methodsFor: 'traits' stamp: ''!
traitCompositionString
	^ '{}'! !

!Behavior methodsFor: 'accessing' stamp: ''!
typeOfClass
	self instSpec = CompiledMethod instSpec
		ifTrue: [^ #compiledMethod].
	self isBytes
		ifTrue: [^ #bytes].
	(self isWords
			and: [self isPointers not])
		ifTrue: [^ #words].
	self isWeak
		ifTrue: [^ #weak].
	self isVariable
		ifTrue: [^ #variable].
	^ #normal! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
ultimateSourceCodeAt: t1 ifAbsent: t2 
	^ self
		sourceCodeAt: t1
		ifAbsent: [superclass
				ifNil: [t2 value]
				ifNotNil: [superclass ultimateSourceCodeAt: t1 ifAbsent: t2]]! !

!Behavior methodsFor: 'user interface' stamp: ''!
unreferencedInstanceVariables
	^ self instVarNames
		reject: [:t1 | self withAllSubclasses
				anySatisfy: [:t2 | (t2 whichSelectorsAccess: t1)
						anySatisfy: [:t3 | t3 isDoIt not]]]! !

!Behavior methodsFor: 'compiling' stamp: ''!
variablesAndOffsetsDo: t1 
	self instVarNamesAndOffsetsDo: t1! !

!Behavior methodsFor: 'copying' stamp: 'nice 12/29/2010 12:00'!
veryDeepCopyWith: deepCopier
	"Return self.  Must be created, not copied.  Do not record me."! !

!Behavior methodsFor: 'queries' stamp: ''!
whichClassDefinesClassVar: t1 
	Symbol
		hasInterned: t1
		ifTrue: [:t2 | ^ self
				whichSuperclassSatisfies: [:t3 | t3 classVarNames
						anySatisfy: [:t4 | t4 = t2]]].
	^ nil! !

!Behavior methodsFor: 'queries' stamp: ''!
whichClassDefinesInstVar: t1 
	^ self
		whichSuperclassSatisfies: [:t2 | t2 instVarNames includes: t1]! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
whichClassIncludesSelector: t1 
	(self includesSelector: t1)
		ifTrue: [^ self].
	superclass
		ifNil: [^ nil].
	^ superclass whichClassIncludesSelector: t1! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ul 5/7/2011 02:11'!
whichMethodsStoreInto: instVarName 
	"Answer a collection of CompiledMethod whose methods access the argument, instVarName, as a named instance variable."
	
	| instVarIndex |
	instVarIndex := self instVarIndexFor: instVarName ifAbsent: [ ^Array new ].
	^self methodDict values select: [:eachMethod | eachMethod writesField: instVarIndex ]
	
	"Point whichMethodsStoreInto: 'x'."! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ul 3/14/2011 23:34'!
whichSelectorsAccess: instVarName 
	"Answer a collection of selectors whose methods access the argument, instVarName, as a named instance variable."
	"Point whichSelectorsAccess: 'x'."
	
	| instVarIndex |
	instVarIndex := self instVarIndexFor: instVarName ifAbsent: [ ^Array new ].
	^Array streamContents: [ :stream |
		self selectorsAndMethodsDo: [ :selector :method |
			((method readsField: instVarIndex) or: [
				method writesField: instVarIndex ]) ifTrue: [
					stream nextPut: selector ] ] ]
! !

!Behavior methodsFor: 'queries' stamp: 'ul 5/7/2011 02:43'!
whichSelectorsAssign: instVarName 
	"Answer a Set of selectors whose methods store into the argument, 
	instVarName, as a named instance variable."
	
	self deprecated: 'Use #whichSelectorsStoreInto:.'.
	^self whichSelectorsStoreInto: instVarName! !

!Behavior methodsFor: 'queries' stamp: ''!
whichSelectorsRead: t1 
	^ self whichSelectorsAccess: t1! !

!Behavior methodsFor: 'testing method dictionary' stamp: ''!
whichSelectorsReferTo: t1 
	| t2 t3 |
	t2 := Smalltalk
				hasSpecialSelector: t1
				ifTrueSetByte: [:t5 | t3 := t5].
	^ self
		whichSelectorsReferTo: t1
		special: t2
		byte: t3! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ul 3/12/2011 21:31'!
whichSelectorsReferTo: literal special: specialFlag byte: specialByte
	"Answer a set of selectors whose methods access the argument as a literal."

	^self whichSelectorsReferTo: literal special: specialFlag byte: specialByte thorough: false! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'eem 5/23/2011 17:07'!
whichSelectorsReferTo: literal special: specialFlag byte: specialByte thorough: thorough
	"Answer a set of selectors whose methods access the argument as a literal. If thorough is true, then dives into the compact literal notation, making it slow but thorough "

	| who |
	who := IdentitySet new.
	self selectorsAndMethodsDo: [ :selector :method |
		(((thorough
			ifFalse: [ method hasLiteral: literal ]
			ifTrue: [ method hasLiteralThorough: literal ]) or: [
				specialFlag and: [ method scanFor: specialByte ] ]) and: [
			literal isVariableBinding not or: [
				"N.B. (method indexOfLiteral: literal) < method numLiterals copes with l;ooking for
				Float bindingOf: #NaN, since (Float bindingOf: #NaN) ~= (Float bindingOf: #NaN)."
				(method indexOfLiteral: literal) ~= 0] ]) ifTrue: [
			who add: selector ] ].
	^who! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ul 5/7/2011 02:11'!
whichSelectorsStoreInto: instVarName 
	"Answer a collection of selectors whose methods access the argument, instVarName, as a named instance variable."
	
	| instVarIndex |
	instVarIndex := self instVarIndexFor: instVarName ifAbsent: [ ^Array new ].
	^ self methodDict keys select: 
		[:sel | (self methodDict at: sel) writesField: instVarIndex]

	"Point whichSelectorsStoreInto: 'x'."! !

!Behavior methodsFor: 'queries' stamp: ''!
whichSuperclassSatisfies: t1 
	(t1 value: self)
		ifTrue: [^ self].
	^ superclass isNil
		ifFalse: [superclass whichSuperclassSatisfies: t1]! !

!Behavior methodsFor: 'user interface' stamp: ''!
withAllSubAndSuperclassesDo: t1 
	self withAllSubclassesDo: t1.
	self allSuperclassesDo: t1! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
withAllSubclasses
	^ self allSubclasses addFirst: self;
		 yourself! !

!Behavior methodsFor: 'enumerating' stamp: ''!
withAllSubclassesDo: t1 
	t1 value: self.
	self allSubclassesDo: t1! !

!Behavior methodsFor: 'enumerating' stamp: 'topa 10/25/2010 10:24'!
withAllSuperAndSubclassesDo: aBlock
	self allSuperclassesDo: aBlock.
	aBlock value: self.
	self allSubclassesDo: aBlock! !

!Behavior methodsFor: 'enumerating' stamp: ''!
withAllSuperAndSubclassesDoGently: t1 
	self allSuperclassesDo: t1.
	t1 value: self.
	self allSubclassesDoGently: t1! !

!Behavior methodsFor: 'accessing class hierarchy' stamp: ''!
withAllSuperclasses
	| t1 |
	t1 := self allSuperclasses.
	t1 addFirst: self.
	^ t1! !

!Behavior methodsFor: 'enumerating' stamp: ''!
withAllSuperclassesDo: t1 
	t1 value: self.
	superclass
		ifNotNil: [superclass withAllSuperclassesDo: t1]! !

!Behavior methodsFor: 'accessing method dictionary' stamp: ''!
zapAllMethods
	methodDict := self emptyMethodDictionary.
	self class isMeta
		ifTrue: [self class zapAllMethods]! !

Behavior subclass: #ClassDescription
	instanceVariableNames: 'instanceVariables organization'
	classVariableNames: 'TraitImpl'
	poolDictionaries: ''
	category: 'Kernel-Classes'!

ClassDescription subclass: #Class
	instanceVariableNames: 'subclasses name classPool sharedPools environment category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!Class class methodsFor: 'fileIn/Out' stamp: ''!
fileOutPool: t1 
	| t2 |
	t2 := WriteStream
				on: (String new: 1000).
	self new
		fileOutPool: (self environment at: t1 asSymbol)
		onFileStream: t2.
	FileStream
		writeSourceCodeFrom: t2
		baseName: t1
		isSt: true
		useHtml: false! !

!Class class methodsFor: 'inquiries' stamp: ''!
rootsOfTheWorld
	^ (Smalltalk globals
		select: [:t1 | t1 isBehavior
				and: [t1 superclass isNil]]) asOrderedCollection! !

!Class class methodsFor: 'instance creation' stamp: ''!
template: t1 
	^ self templateForSubclassOf: Object name category: t1! !

!Class class methodsFor: 'instance creation' stamp: ''!
templateForSubclassOf: t1 category: t2 
	^ t1 asString , ' subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''' , t2 asString , ''''! !

!Class methodsFor: 'class variables' stamp: 'spd 12/4/2010 13:20'!
addClassVarName: aString 
	"Add the argument, aString, as a class variable of the receiver.
	Signal an error if the first character of aString is not capitalized,
	or if it is already a variable named in the class."
	| symbol oldState |
	oldState := self copy.
	aString first canBeGlobalVarInitial
		ifFalse: [^self error: aString, ' class variable name should be capitalized; proceed to include anyway.'].
	symbol := aString asSymbol.
	self withAllSubclasses do: 
		[:subclass | 
		(self canFindWithoutEnvironment: symbol) ifTrue: [
			(DuplicateVariableError new)
				superclass: superclass; "fake!!!!!!"
				variable: aString;
				signal: aString, ' is already defined']].
	classPool == nil ifTrue: [classPool := Dictionary new].
	(classPool includesKey: symbol) ifFalse: 
		["Pick up any refs in Undeclared"
		classPool declare: symbol from: Undeclared.
		SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: oldState to: self]! !

!Class methodsFor: 'instance variables' stamp: ''!
addInstVarName: t1 
	^ ClassBuilder new
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: self instanceVariablesString , ' ' , t1
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!Class methodsFor: 'pool variables' stamp: ''!
addSharedPool: t1 
	(self sharedPools includes: t1)
		ifTrue: [^ self error: 'This is already in my shared pool list'].
	sharedPools
		ifNil: [sharedPools := OrderedCollection with: t1]
		ifNotNil: [sharedPools add: t1]! !

!Class methodsFor: 'accessing class hierarchy' stamp: ''!
addSubclass: t1 
	t1 superclass ~~ self
		ifTrue: [^ self error: t1 name , ' is not my subclass'].
	subclasses
		ifNil: [subclasses := Array with: t1.
			^ self].
	subclasses
		do: [:t2 | 
			t2 == t1
				ifTrue: [^ self].
			nil].
	subclasses := subclasses copyWith: t1! !

!Class methodsFor: 'class variables' stamp: 'cmm 5/1/2011 22:05'!
allClassVarNames
	"Answer a Set of the names of the receiver's class variables, including those defined in the superclasses of the receiver."
	| aSet |
	^ self superclass == nil
		ifTrue: 
			[self classVarNames asSet]  "This is the keys so it is a new Set."
		ifFalse: 
			[aSet := self superclass allClassVarNames.
			aSet addAll: self classVarNames.
			aSet]! !

!Class methodsFor: 'pool variables' stamp: ''!
allSharedPools
	| t1 |
	^ self superclass
		ifNil: [self sharedPools copy]
		ifNotNil: [t1 := self superclass allSharedPools.
			t1 addAll: self sharedPools.
			t1]! !

!Class methodsFor: 'accessing' stamp: 'rms 1/11/2013 22:28'!
basicCategory
	^category! !

!Class methodsFor: 'as yet unclassified' stamp: 'rms 1/11/2013 22:34'!
basicCategory: aSymbol
	category := aSymbol! !

!Class methodsFor: 'compiling' stamp: ''!
binding
	| t1 |
	t1 := self environment
				associationAt: name
				ifAbsent: [nil -> self].
	^ t1 value == self
		ifTrue: [t1]
		ifFalse: [nil -> self]! !

!Class methodsFor: 'compiling' stamp: ''!
bindingOf: t1 
	| t2 t3 |
	t2 := t1 asSymbol.
	t3 := self classPool bindingOf: t2.
	t3
		ifNotNil: [^ t3].
	self sharedPools
		do: [:t5 | 
			t3 := t5 bindingOf: t2.
			t3
				ifNotNil: [^ t3]].
	t3 := self environment bindingOf: t2.
	t3
		ifNotNil: [^ t3].
	superclass
		ifNil: [^ nil].
	^ superclass bindingOf: t2! !

!Class methodsFor: 'compiling' stamp: 'spd 12/3/2010 13:32'!
canFindWithoutEnvironment: varName
	"This method is used for analysis of system structure -- see senders."
	"Look up varName, in the context of the receiver. Return true if it can be found without using the declared environment."

	"First look in classVar dictionary."
	(self classPool bindingOf: varName) ifNotNil:[^true].

	"Next look in shared pools."
	self sharedPools do:[:pool | 
		(pool bindingOf: varName) ifNotNil:[^true].
	].

	"Finally look higher up the superclass chain and fail at the end."
	superclass == nil
		ifTrue: [^ false]
		ifFalse: [^ superclass canFindWithoutEnvironment: varName].

! !

!Class methodsFor: 'organization' stamp: ''!
category
	category
		ifNotNil: [:t1 | ((SystemOrganization listAtCategoryNamed: t1)
					includes: self name)
				ifTrue: [^ t1]].
	category := SystemOrganization categoryOfElement: self name.
	^ category! !

!Class methodsFor: 'organization' stamp: 'laza 12/14/2011 16:13'!
category: aString 
	"Categorize the receiver under the system category, aString, removing it from 
	any previous categorization."

	| oldCategory |
	oldCategory := category.
	aString isString
		ifTrue: [
			category := aString asSymbol.
			SystemOrganization classify: self name under: category ]
		ifFalse: [self errorCategoryName]! !

!Class methodsFor: 'accessing' stamp: ''!
classPool
	classPool
		ifNil: [^ Dictionary new].
	^ classPool! !

!Class methodsFor: 'accessing' stamp: ''!
classPool: t1 
	classPool := t1! !

!Class methodsFor: 'accessing' stamp: ''!
classPoolFrom: t1 
	classPool := t1 classPool! !

!Class methodsFor: 'class variables' stamp: ''!
classVarNames
	^ self classPool keys asArray sort! !

!Class methodsFor: 'compiling' stamp: ''!
compileAllFrom: t1 
	super compileAllFrom: t1.
	self class compileAllFrom: t1 class! !

!Class methodsFor: 'copying' stamp: 'eem 5/15/2012 09:43'!
copy 
	"Answer a copy of the receiver without a list of subclasses.
	 This copy is used by the ClassBuilder when mutating classes on redefinition.
	 (SystemNavigation new browseAllCallsOn: #copy localTo: ClassBuilder)"
	| newClass |
	newClass := self class copy new
		superclass: superclass
		methodDict: self methodDict copy
		format: format
		name: name
		organization: self organization copy
		instVarNames: instanceVariables copy
		classPool: classPool copy
		sharedPools: sharedPools copy.
	Class instSize+1 to: self class instSize do:
		[:offset | newClass instVarAt: offset put: (self instVarAt: offset)].
	^ newClass! !

!Class methodsFor: 'initialize-release' stamp: ''!
deactivate
	^ self! !

!Class methodsFor: 'initialize-release' stamp: 'spd 12/4/2010 13:21'!
declare: varString 
	"Declare class variables common to all instances. Answer whether 
	recompilation is advisable."

	| newVars conflicts |
	
	newVars := 
		(Scanner new scanFieldNames: varString)
			collect: [:x | x asSymbol].
	newVars do:
		[:var | var first canBeGlobalVarInitial
			ifFalse: [self error: var, ' class variable name should be capitalized; proceed to include anyway.']].
	conflicts := false.
	classPool == nil 
		ifFalse: [(classPool keys reject: [:x | newVars includes: x]) do: 
					[:var | self removeClassVarName: var]].
	(newVars reject: [:var | self classPool includesKey: var])
		do: [:var | "adding"
			"check if new vars defined elsewhere"
			(self canFindWithoutEnvironment: var) ifTrue: [
					(DuplicateVariableError new)
						superclass: superclass; "fake!!!!!!"
						variable: var;
						signal: var, ' is already defined'.
					conflicts := true]].
	newVars size > 0
		ifTrue: 
			[classPool := self classPool.
			"in case it was nil"
			newVars do: [:var | classPool declare: var from: Undeclared]].
	^conflicts! !

!Class methodsFor: 'class variables' stamp: ''!
ensureClassPool
	classPool
		ifNil: [classPool := Dictionary new]! !

!Class methodsFor: 'organization' stamp: ''!
environment
	environment
		ifNil: [^ super environment].
	^ environment! !

!Class methodsFor: 'organization' stamp: ''!
environment: t1 
	environment := t1! !

!Class methodsFor: 'class name' stamp: ''!
externalName
	^ name! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOut
	^ self fileOutAsHtml: false! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOutAsHtml: t1 
	| t2 |
	t2 := WriteStream
				on: (String new: 100).
	t2 header; timeStamp.
	self sharedPools size > 0
		ifTrue: [self shouldFileOutPools
				ifTrue: [self fileOutSharedPoolsOn: t2]].
	self
		fileOutOn: t2
		moveSource: false
		toFile: 0.
	t2 trailer.
	FileStream
		writeSourceCodeFrom: t2
		baseName: self name
		isSt: true
		useHtml: t1! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOutInitializerOn: t1 
	^ self class fileOutInitializerOn: t1! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 
	^ self
		fileOutOn: t1
		moveSource: t2
		toFile: t3
		initializing: true! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 initializing: t4 
	Transcript cr; show: self name.
	super
		fileOutOn: t1
		moveSource: t2
		toFile: t3.
	self class nonTrivial
		ifTrue: [t1 cr; nextPutAll: '"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!!'; cr; cr.
			self class
				fileOutOn: t1
				moveSource: t2
				toFile: t3
				initializing: t4]! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOutPool: t1 onFileStream: t2 
	| t3 |
	(t1 isKindOf: SharedPool class)
		ifTrue: [^ self notify: 'we do not fileout SharedPool type shared pools for now'].
	t3 := self environment keyAtIdentityValue: t1.
	Transcript cr; show: t3.
	t2 nextPutAll: 'Transcript show: ''' , t3 , '''; cr!!';
		 cr.
	t2 nextPutAll: 'Smalltalk at: #' , t3 , ' put: Dictionary new!!';
		 cr.
	t1 keys asArray sort
		do: [:t4 | 
			| t5 |
			t5 := t1 at: t4.
			t2 nextPutAll: t3 , ' at: #''' , t4 asString , '''' , ' put:  '.
			(t5 isKindOf: Number)
				ifTrue: [t5 printOn: t2]
				ifFalse: [t2 nextPutAll: '('.
					t5 printOn: t2.
					t2 nextPutAll: ')'].
			t2 nextPutAll: '!!';
				 cr].
	t2 cr! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
fileOutSharedPoolsOn: t1 
	| t2 |
	t2 := self sharedPools
				select: [:t3 | self
						shouldFileOutPool: (self environment keyAtIdentityValue: t3)].
	t2
		do: [:t3 | self fileOutPool: t3 onFileStream: t1]! !

!Class methodsFor: 'testing' stamp: ''!
hasMethods
	^ super hasMethods
		or: [self class hasMethods]! !

!Class methodsFor: 'testing' stamp: ''!
isObsolete
	^ (self environment
		at: name
		ifAbsent: [])
		~~ self! !

!Class methodsFor: 'testing' stamp: ''!
isSystemDefined
	^ self == self officialClass! !

!Class methodsFor: 'accessing' stamp: ''!
name
	name
		ifNil: [^ super name].
	^ name! !

!Class methodsFor: 'class name' stamp: ''!
nameForViewer
	^ self name
		ifNil: ['Unnamed class']! !

!Class methodsFor: 'subclass creation' stamp: ''!
newSubclass
	| t1 t2 |
	t1 := 1.
	[t2 := (self name , t1 printString) asSymbol.
	self environment includesKey: t2]
		whileTrue: [t1 := t1 + 1].
	^ self
		subclass: t2
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: Object categoryForUniclasses! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
objectForDataStream: t1 
	t1 insideASegment
		ifTrue: [self isSystemDefined
				ifFalse: [^ self].
			(t1 rootObject includes: self)
				ifTrue: [^ self].
			t1 references
				removeKey: self
				ifAbsent: [].
			^ nil].
	^ DiskProxy
		global: self theNonMetaClass name
		selector: #withClassVersion:
		args: {self classVersion}! !

!Class methodsFor: 'initialize-release' stamp: ''!
obsolete
	self == Object
		ifTrue: [^ self error: 'Object is NOT obsolete'].
	self setName: 'AnObsolete' , self name.
	Object class instSize + 1
		to: self class instSize
		do: [:t1 | self instVarAt: t1 put: nil].
	self classPool: nil.
	self sharedPools: nil.
	self class obsolete.
	super obsolete! !

!Class methodsFor: 'testing' stamp: ''!
officialClass
	^ self! !

!Class methodsFor: 'compiling' stamp: ''!
possibleVariablesFor: t1 continuedFrom: t2 
	| t3 |
	t3 := t1 correctAgainstDictionary: self classPool continuedFrom: t2.
	self sharedPools
		do: [:t5 | t3 := t1 correctAgainstDictionary: t5 continuedFrom: t3].
	superclass
		ifNil: [^ t1 correctAgainstDictionary: self environment continuedFrom: t3].
	^ superclass possibleVariablesFor: t1 continuedFrom: t3! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
reformatAll
	super reformatAll.
	self class reformatAll! !

!Class methodsFor: 'class variables' stamp: ''!
removeClassVarName: t1 
	| t2 |
	t2 := t1 asSymbol.
	(classPool includesKey: t2)
		ifFalse: [^ self error: t1 , ' is not a class variable'].
	self withAllSubclasses
		do: [:t3 | (Array with: t3 with: t3 class)
				do: [:t4 | (t4
							whichSelectorsReferTo: (classPool associationAt: t2)) isEmpty
						ifFalse: [InMidstOfFileinNotification signal
								ifTrue: [Transcript cr; show: self name , ' (' , t1 , ' is Undeclared) '.
									^ Undeclared declare: t2 from: classPool].
							(self confirm: (t1 , ' is still used in code of class ' , t4 name , '.\Is it okay to move it to Undeclared?') withCRs)
								ifTrue: [^ Undeclared declare: t2 from: classPool].
							^ self]]].
	classPool removeKey: t2.
	classPool isEmpty
		ifTrue: [classPool := nil]! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
removeFromChanges
	ChangeSet current removeClassAndMetaClassChanges: self! !

!Class methodsFor: 'initialize-release' stamp: ''!
removeFromSystem
	self removeFromSystem: true! !

!Class methodsFor: 'initialize-release' stamp: ''!
removeFromSystem: t1 
	self deactivate; unload.
	self superclass
		ifNotNil: [self superclass addObsoleteSubclass: self].
	self environment forgetClass: self logged: t1.
	self obsolete! !

!Class methodsFor: 'initialize-release' stamp: ''!
removeFromSystemUnlogged
	^ self removeFromSystem: false! !

!Class methodsFor: 'instance variables' stamp: ''!
removeInstVarName: t1 
	| t2 |
	(self instVarNames includes: t1)
		ifFalse: [self error: t1 , ' is not one of my instance variables'].
	t2 := ''.
	(self instVarNames copyWithout: t1)
		do: [:t4 | t2 := t2 , ' ' , t4].
	^ ClassBuilder new
		name: self name
		inEnvironment: self environment
		subclassOf: self superclass
		type: self typeOfClass
		instanceVariableNames: t2
		classVariableNames: self classVariablesString
		poolDictionaries: self sharedPoolsString
		category: self category! !

!Class methodsFor: 'pool variables' stamp: ''!
removeSharedPool: t1 
	| t2 t3 t4 |
	(self sharedPools includes: t1)
		ifFalse: [^ self error: 'the dictionary is not in my pool'].
	(self
			selectSuperclasses: [:t5 | t5 sharedPools includes: t1]) isEmpty
		ifFalse: [sharedPools remove: t1.
			sharedPools isEmpty
				ifTrue: [sharedPools := nil].
			^ self].
	t3 := self subclasses asOrderedCollection.
	t2 := Set new.
	[t3 isEmpty]
		whileFalse: [t4 := t3 removeFirst.
			(t4 sharedPools includes: t1)
				ifFalse: [t2 add: t4.
					t3 addAll: t4 subclasses]].
	t2 add: self.
	t2
		do: [:t5 | t1
				associationsDo: [:t6 | (t5 whichSelectorsReferTo: t6) isEmpty
						ifFalse: [^ self error: t6 key , ' is still used in code of class ' , t5 name]]].
	sharedPools remove: t1.
	sharedPools isEmpty
		ifTrue: [sharedPools := nil]! !

!Class methodsFor: 'accessing class hierarchy' stamp: ''!
removeSubclass: t1 
	subclasses
		ifNotNil: [subclasses := subclasses copyWithout: t1.
			subclasses isEmpty
				ifTrue: [subclasses := nil]]! !

!Class methodsFor: 'class name' stamp: ''!
rename: t1 
	| t2 t3 |
	(t3 := t1 asSymbol) = (t2 := self name)
		ifTrue: [^ self].
	(self environment includesKey: t3)
		ifTrue: [^ self error: t3 , ' already exists'].
	(Undeclared includesKey: t3)
		ifTrue: [self inform: 'There are references to, ' , t1 printString , '
from Undeclared. Check them after this change.'].
	name := t3.
	self environment renameClass: self from: t2! !

!Class methodsFor: 'private' stamp: ''!
setName: t1 
	name := t1! !

!Class methodsFor: 'pool variables' stamp: ''!
sharedPools
	sharedPools
		ifNil: [^ OrderedCollection new].
	^ sharedPools! !

!Class methodsFor: 'pool variables' stamp: ''!
sharedPools: t1 
	sharedPools := t1! !

!Class methodsFor: 'initialize-release' stamp: ''!
sharing: t1 
	| t2 |
	t2 := self sharedPools.
	sharedPools := OrderedCollection new.
	(Scanner new scanFieldNames: t1)
		do: [:t3 | sharedPools
				add: (self environment
						at: t3 asSymbol
						ifAbsent: [(self confirm: 'The pool dictionary ' , t3 , ' does not exist.' , '\Do you want it automatically created?' withCRs)
								ifTrue: [self environment at: t3 asSymbol put: Dictionary new]
								ifFalse: [^ self error: t3 , ' does not exist']])].
	sharedPools isEmpty
		ifTrue: [sharedPools := nil].
	t2
		do: [:t3 | 
			| t4 |
			t4 := self sharedPools
						anySatisfy: [:t5 | t5 == t3].
			t4
				ifFalse: [^ true]].
	^ false! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
shouldFileOutPool: t1 
	^ self confirm: 'FileOut the sharedPool ' , t1 , '?'! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
shouldFileOutPools
	^ self confirm: 'FileOut selected sharedPools?'! !

!Class methodsFor: 'private' stamp: ''!
spaceUsed
	^ super spaceUsed + self class spaceUsed! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
storeDataOn: t1 
	(t1 insideASegment
			and: [self isSystemDefined not])
		ifTrue: [^ super storeDataOn: t1].
	self error: 'use a DiskProxy to store a Class'! !

!Class methodsFor: 'subclass creation' stamp: ''!
subclass: t1 instanceVariableNames: t2 classVariableNames: t3 poolDictionaries: t4 category: t5 
	^ ClassBuilder new
		superclass: self
		subclass: t1
		instanceVariableNames: t2
		classVariableNames: t3
		poolDictionaries: t4
		category: t5! !

!Class methodsFor: 'subclass creation' stamp: ''!
subclass: t1 uses: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	| t7 t8 |
	t8 := self copy.
	t7 := self
				subclass: t1
				instanceVariableNames: t3
				classVariableNames: t4
				poolDictionaries: t5
				category: t6.
	t7 setTraitComposition: t2 asTraitComposition.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t8 to: t7.
	^ t7! !

!Class methodsFor: 'accessing class hierarchy' stamp: ''!
subclasses
	^ subclasses
		ifNil: [#()]
		ifNotNil: [subclasses copy]! !

!Class methodsFor: 'accessing class hierarchy' stamp: ''!
subclassesDo: t1 
	subclasses
		ifNotNil: [subclasses do: t1]! !

!Class methodsFor: 'accessing class hierarchy' stamp: ''!
subclassesDoGently: t1 
	subclasses
		ifNotNil: [subclasses do: t1]! !

!Class methodsFor: 'initialize-release' stamp: ''!
superclass: t1 methodDict: t2 format: t3 name: t4 organization: t5 instVarNames: t6 classPool: t7 sharedPools: t8 
	superclass := t1.
	methodDict := t2.
	format := t3.
	name := t4.
	instanceVariables := t6.
	classPool := t7.
	sharedPools := t8.
	self organization: t5! !

!Class methodsFor: 'initialize-release' stamp: ''!
superclass: t1 methodDictionary: t2 format: t3 
	super
		superclass: t1
		methodDictionary: t2
		format: t3.
	subclasses := nil! !

!Class methodsFor: 'initialize-release' stamp: ''!
unload
	^ self! !

!Class methodsFor: 'subclass creation' stamp: ''!
variableByteSubclass: t1 instanceVariableNames: t2 classVariableNames: t3 poolDictionaries: t4 category: t5 
	^ ClassBuilder new
		superclass: self
		variableByteSubclass: t1
		instanceVariableNames: t2
		classVariableNames: t3
		poolDictionaries: t4
		category: t5! !

!Class methodsFor: 'subclass creation' stamp: ''!
variableByteSubclass: t1 uses: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	| t7 t8 |
	t8 := self copy.
	t7 := self
				variableByteSubclass: t1
				instanceVariableNames: t3
				classVariableNames: t4
				poolDictionaries: t5
				category: t6.
	t7 setTraitComposition: t2 asTraitComposition.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t8 to: t7.
	^ t7! !

!Class methodsFor: 'subclass creation' stamp: ''!
variableSubclass: t1 instanceVariableNames: t2 classVariableNames: t3 poolDictionaries: t4 category: t5 
	^ ClassBuilder new
		superclass: self
		variableSubclass: t1
		instanceVariableNames: t2
		classVariableNames: t3
		poolDictionaries: t4
		category: t5! !

!Class methodsFor: 'subclass creation' stamp: ''!
variableSubclass: t1 uses: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	| t7 t8 |
	t8 := self copy.
	t7 := self
				variableSubclass: t1
				instanceVariableNames: t3
				classVariableNames: t4
				poolDictionaries: t5
				category: t6.
	t7 setTraitComposition: t2 asTraitComposition.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t8 to: t7.
	^ t7! !

!Class methodsFor: 'subclass creation' stamp: ''!
variableWordSubclass: t1 instanceVariableNames: t2 classVariableNames: t3 poolDictionaries: t4 category: t5 
	^ ClassBuilder new
		superclass: self
		variableWordSubclass: t1
		instanceVariableNames: t2
		classVariableNames: t3
		poolDictionaries: t4
		category: t5! !

!Class methodsFor: 'subclass creation' stamp: ''!
variableWordSubclass: t1 uses: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	| t7 t8 |
	t8 := self copy.
	t7 := self
				variableWordSubclass: t1
				instanceVariableNames: t3
				classVariableNames: t4
				poolDictionaries: t5
				category: t6.
	t7 setTraitComposition: t2 asTraitComposition.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t8 to: t7.
	^ t7! !

!Class methodsFor: 'subclass creation' stamp: ''!
weakSubclass: t1 instanceVariableNames: t2 classVariableNames: t3 poolDictionaries: t4 category: t5 
	^ ClassBuilder new
		superclass: self
		weakSubclass: t1
		instanceVariableNames: t2
		classVariableNames: t3
		poolDictionaries: t4
		category: t5! !

!Class methodsFor: 'subclass creation' stamp: ''!
weakSubclass: t1 uses: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	| t7 t8 |
	t8 := self copy.
	t7 := self
				weakSubclass: t1
				instanceVariableNames: t3
				classVariableNames: t4
				poolDictionaries: t5
				category: t6.
	t7 setTraitComposition: t2 asTraitComposition.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t8 to: t7.
	^ t7! !

!Class methodsFor: 'testing' stamp: 'nice 5/6/2011 22:54'!
whichMethodsStoreInto: varName 
	"Answer a collection of CompiledMethod whose methods access the argument, varName, as a named class variable. Or let super try with a named instance variable."
	| ref |
	ref := self classPool
		associationAt: varName
		ifAbsent: [ ^ super whichMethodsStoreInto: varName ].
	^self methodDict values select: [:eachMethod | eachMethod writesRef: ref ]! !

!Class methodsFor: 'testing' stamp: 'nice 5/7/2011 14:04'!
whichSelectorsStoreInto: varName 
	"Answer a collection of selectors whose methods access the argument, varName, as a named class variable. Or let super try with a named instance variable."
	| ref |
	ref := self classPool
		associationAt: varName
		ifAbsent: [ ^ super whichSelectorsStoreInto: varName ].
	^self methodDict keys select: [:aSelector | (self methodDict at: aSelector) writesRef: ref ]! !

!Class methodsFor: 'fileIn/Out' stamp: ''!
withClassVersion: t1 
	t1 = self classVersion
		ifTrue: [^ self].
	^ self error: 'Invalid class version'! !

!ClassDescription class methodsFor: 'traits' stamp: ''!
allTraitsDo: t1 
	TraitImpl
		ifNotNil: [TraitImpl allTraitsDo: t1]! !

!ClassDescription class methodsFor: 'traits' stamp: ''!
newTraitComposition
	^ TraitImpl
		ifNil: [#()]
		ifNotNil: [TraitImpl newTraitComposition]! !

!ClassDescription class methodsFor: 'traits' stamp: ''!
newTraitNamed: t1 uses: t2 category: t3 
	^ TraitImpl
		ifNil: [self error: 'Traits are not installed']
		ifNotNil: [TraitImpl
				newTraitNamed: t1
				uses: t2
				category: t3]! !

!ClassDescription class methodsFor: 'traits' stamp: ''!
newTraitTemplateIn: t1 
	^ TraitImpl
		ifNil: ['']
		ifNotNil: [TraitImpl newTemplateIn: t1]! !

!ClassDescription class methodsFor: 'traits' stamp: ''!
traitImpl
	^ TraitImpl! !

!ClassDescription class methodsFor: 'traits' stamp: ''!
traitImpl: t1 
	TraitImpl := t1! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
acceptsLoggingOfCompilation
	^ true! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
addAndClassifySelector: t1 withMethod: t2 inProtocol: t3 notifying: t4 
	| t5 |
	t5 := self
				compiledMethodAt: t1
				ifAbsent: [].
	self addSelectorSilently: t1 withMethod: t2.
	SystemChangeNotifier uniqueInstance
		doSilently: [self organization classify: t1 under: t3].
	t5 isNil
		ifTrue: [SystemChangeNotifier uniqueInstance
				methodAdded: t2
				selector: t1
				inProtocol: t3
				class: self
				requestor: t4]
		ifFalse: [SystemChangeNotifier uniqueInstance
				methodChangedFrom: t5
				to: t2
				selector: t1
				inClass: self
				requestor: t4]! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
addInstVarName: t1 
	self subclassResponsibility! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
addSelector: t1 withMethod: t2 notifying: t3 
	| t4 |
	t4 := self
				compiledMethodAt: t1
				ifAbsent: [].
	self addSelectorSilently: t1 withMethod: t2.
	t4 isNil
		ifTrue: [SystemChangeNotifier uniqueInstance
				methodAdded: t2
				selector: t1
				inClass: self
				requestor: t3]
		ifFalse: [SystemChangeNotifier uniqueInstance
				methodChangedFrom: t4
				to: t2
				selector: t1
				inClass: self
				requestor: t3]! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
addSelectorSilently: t1 withMethod: t2 
	super addSelectorSilently: t1 withMethod: t2.
	self instanceSide noteAddedSelector: t1 meta: self isMeta! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
allInstVarNamesEverywhere
	| t1 |
	t1 := OrderedCollection new.
	self allSuperclasses , self withAllSubclasses asOrderedCollection
		do: [:t2 | t1 addAll: t2 instVarNames].
	^ t1 asSet! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: 'nice 8/19/2010 16:32'!
allMethodCategoriesIntegratedThrough: mostGenericClass
	"Answer a list of all the method categories of the receiver and all its superclasses, up through mostGenericClass"

	| aColl |
	aColl := OrderedCollection new.
	self withAllSuperclasses do:
		[:aClass |
			(aClass includesBehavior: mostGenericClass)
				ifTrue:	[aColl addAll: aClass organization categories]].
	aColl remove: 'no messages' asSymbol ifAbsent: [].

	^aColl asSet asArray sort: [:a :b | a asLowercase < b asLowercase]

"ColorTileMorph allMethodCategoriesIntegratedThrough: TileMorph"! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
allMethodsInCategory: t1 
	| t2 |
	t2 := OrderedCollection new.
	self withAllSuperclasses
		do: [:t3 | t2
				addAll: (t1 = ClassOrganizer allCategory
						ifTrue: [t3 organization allMethodSelectors]
						ifFalse: [t3 organization listAtCategoryNamed: t1])].
	^ t2 asSet asSortedArray! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
checkForInstVarsOK: t1 
	| t2 |
	t2 := Scanner new scanFieldNames: t1.
	self allSubclasses
		do: [:t3 | t3 instVarNames
				do: [:t4 | 
					(t2 includes: t4)
						ifTrue: [self error: t4 , ' is already used in ' , t3 name.
							^ false].
					nil]].
	^ true! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
chooseClassVarName
	| t1 t2 t3 t4 |
	t1 := OrderedCollection new.
	t3 := OrderedCollection new.
	t2 := WriteStream
				on: (String new: 200).
	self withAllSuperclasses
		reverseDo: [:t5 | 
			| t6 |
			t6 := t5 classVarNames.
			t6
				do: [:t7 | 
					t2 nextPutAll: t7;
						 cr.
					t3 add: t7].
			t6 isEmpty
				ifFalse: [t1 add: t3 size]].
	t2 contents isEmpty
		ifTrue: [^ Beeper beep].
	t2 skip: -1.
	t4 := UIManager default chooseFrom: t2 contents substrings lines: t1.
	t4 = 0
		ifTrue: [^ nil].
	^ t3 at: t4! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
chooseInstVarAlphabeticallyThenDo: t1 
	| t2 t3 |
	t2 := self allInstVarNames asSortedArray.
	t2 isEmpty
		ifTrue: [^ self inform: 'There are no
instance variables'].
	t3 := UIManager default
				chooseFrom: t2
				lines: #()
				title: 'Instance variables in
' , self name.
	t3 = 0
		ifTrue: [^ self].
	t1
		value: (t2 at: t3)! !

!ClassDescription methodsFor: 'instance variables' stamp: 'bf 11/17/2011 14:15'!
chooseVarThenDo: aBlock 
	"Put up a menu of all the instance variables in the receiver, and when
the user chooses one, evaluate aBlock with the chosen variable as its
parameter."
	| lines labelStream allVars index |
	(self allInstVarNames size + self theNonMetaClass allClassVarNames size) = 0 ifTrue: [ ^ self inform: 'There are no variables.' ].
	allVars := OrderedCollection new.
	lines := OrderedCollection new.
	labelStream := WriteStream on: (String new: 200).
	self withAllSuperclasses reverseDo:
		[ : class | | vars |
		vars := class instVarNames , class theNonMetaClass classVarNames.
		vars do:
			[ : var | labelStream
				 nextPutAll: var ;
				 cr.
			allVars add: var ].
		vars isEmpty ifFalse: [ lines add: allVars size ] ].
	labelStream skip: -1.
	"cut last CR"
	(lines size > 0 and: [ lines last = allVars size ]) ifTrue: [ lines removeLast ].
	"dispense with inelegant line beneath last item"
	index := UIManager default
		chooseFrom: (labelStream contents subStrings: {Character cr})
		lines: lines
		title: 'Variables in ' , self name.
	index = 0 ifTrue: [ ^ self ].
	aBlock value: (allVars at: index)! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
classComment: t1 
	^ self classComment: t1 stamp: '<historical>'! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
classComment: t1 stamp: t2 
	| t3 t4 t6 |
	(t1 isKindOf: RemoteString)
		ifTrue: [SystemChangeNotifier uniqueInstance classCommented: self.
			^ self organization classComment: t1 stamp: t2].
	t6 := self organization commentRemoteStr.
	t1 size = 0 & (t6 == nil)
		ifTrue: [^ self organization classComment: nil].
	t3 := t6
				ifNil: [0]
				ifNotNil: [t6 sourcePointer].
	SourceFiles
		ifNotNil: [(SourceFiles at: 2)
				ifNotNil: [:t5 | 
					t5 setToEnd; cr; nextPut: $!!.
					t4 := String
								streamContents: [:t7 | 
									t7 nextPutAll: self name;
										 nextPutAll: ' commentStamp: '.
									t2 storeOn: t7.
									t7 nextPutAll: ' prior: ';
										 nextPutAll: t3 printString].
					t5 nextChunkPut: t4]].
	self organization
		classComment: (RemoteString newString: t1 onFileNumber: 2)
		stamp: t2.
	SystemChangeNotifier uniqueInstance classCommented: self! !

!ClassDescription methodsFor: 'accessing comment' stamp: ''!
classCommentBlank
	| t1 t2 |
	t1 := self theNonMetaClass organization classComment.
	t1 isEmpty
		ifFalse: [^ t1].
	t2 := WriteStream
				on: (String new: 100).
	t2 nextPutAll: 'A';
		
		nextPutAll: (self name first isVowel
				ifTrue: ['n ']
				ifFalse: [' ']);
		 nextPutAll: self name;
		 nextPutAll: ' is xxxxxxxxx.';
		 cr;
		 cr;
		 nextPutAll: 'Instance Variables'.
	self instVarNames asSortedCollection
		do: [:t3 | t2 cr; tab; nextPutAll: t3; nextPut: $:; tab; tab; nextPutAll: '<Object>'].
	t2 cr.
	self instVarNames asSortedCollection
		do: [:t3 | t2 cr; nextPutAll: t3; cr; tab; nextPutAll: '- xxxxx'; cr].
	^ t2 contents! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: ''!
classSide
	^ self theMetaClass! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
classThatDefinesClassVariable: t1 
	(self classPool includesKey: t1 asSymbol)
		ifTrue: [^ self].
	^ self superclass
		ifNotNil: [self superclass classThatDefinesClassVariable: t1]! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
classThatDefinesInstanceVariable: t1 
	(self instVarNames notNil
			and: [self instVarNames includes: t1 asString])
		ifTrue: [^ self].
	^ self superclass
		ifNotNil: [self superclass classThatDefinesInstanceVariable: t1]! !

!ClassDescription methodsFor: 'printing' stamp: 'nice 10/22/2009 09:39'!
classVariablesString
	"Answer a string of my class variable names separated by spaces."

	^String streamContents: [ :stream | 
		self classVarNames 
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!ClassDescription methodsFor: 'accessing' stamp: ''!
classVersion
	^ 0! !

!ClassDescription methodsFor: 'accessing class hierarchy' stamp: ''!
classesThatImplementAllOf: t1 
	| t2 t3 |
	t2 := OrderedCollection new.
	t1
		do: [:t4 | (self methodDict includesKey: t4)
				ifTrue: [t2 add: t4]].
	t2 isEmpty
		ifTrue: [^ self subclasses
				inject: Array new
				into: [:t4 :t5 | t4
						, (t5 classesThatImplementAllOf: t1)]].
	t3 := t1 copyWithoutAll: t2.
	t3 isEmpty
		ifTrue: [^ Array with: self].
	^ self subclasses
		inject: Array new
		into: [:t4 :t5 | t4
				, (t5 classesThatImplementAllOf: t3)]! !

!ClassDescription methodsFor: 'accessing comment' stamp: ''!
comment
	| t1 |
	t1 := self instanceSide organization classComment.
	t1 isEmpty
		ifFalse: [^ t1].
	^ self classCommentBlank! !

!ClassDescription methodsFor: 'accessing comment' stamp: ''!
comment: t1 
	self instanceSide classComment: t1! !

!ClassDescription methodsFor: 'accessing comment' stamp: ''!
comment: t1 stamp: t2 
	self instanceSide classComment: t1 stamp: t2! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
commentFollows
	^ ClassCommentReader new setClass: self category: #Comment! !

!ClassDescription methodsFor: 'accessing class hierarchy' stamp: ''!
commentInventory
	^ SystemOrganization commentInventory: (self category copyUpTo: $-)
			, '*'! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
commentStamp: t1 
	self organization commentStamp: t1.
	^ self commentStamp: t1 prior: 0! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
commentStamp: t1 prior: t2 
	^ ClassCommentReader new
		setClass: self
		category: #Comment
		changeStamp: t1! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compile: t1 classified: t2 
	^ self
		compile: t1
		classified: t2
		notifying: nil! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compile: t1 classified: t2 notifying: t3 
	| t4 |
	t4 := self acceptsLoggingOfCompilation
				ifTrue: [Utilities changeStamp].
	^ self
		compile: t1
		classified: t2
		withStamp: t4
		notifying: t3! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compile: t1 classified: t2 withStamp: t3 notifying: t4 
	^ self
		compile: t1
		classified: t2
		withStamp: t3
		notifying: t4
		logSource: self acceptsLoggingOfCompilation! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compile: t1 classified: t2 withStamp: t3 notifying: t4 logSource: t5 
	| t6 |
	t6 := self
				compile: t1 asString
				classified: t2
				notifying: t4
				trailer: self defaultMethodTrailer
				ifFail: [^ nil].
	t5
		ifTrue: [self
				logMethodSource: t1
				forMethodWithNode: t6
				inCategory: t2
				withStamp: t3
				notifying: t4].
	self
		addAndClassifySelector: t6 selector
		withMethod: t6 method
		inProtocol: t2
		notifying: t4.
	self instanceSide noteCompilationOf: t6 selector meta: self isClassSide.
	^ t6 selector! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compile: t1 notifying: t2 
	^ self
		compile: t1
		classified: ClassOrganizer default
		notifying: t2! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compileSilently: t1 classified: t2 
	^ self
		compileSilently: t1
		classified: t2
		notifying: nil! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
compileSilently: t1 classified: t2 notifying: t3 
	^ SystemChangeNotifier uniqueInstance
		doSilently: [self
				compile: t1
				classified: t2
				withStamp: nil
				notifying: t3
				logSource: false]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copy: t1 from: t2 
	self
		copy: t1
		from: t2
		classified: nil! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copy: t1 from: t2 classified: t3 
	| t4 t5 |
	t4 := t2 sourceMethodAt: t1.
	t4
		ifNotNil: [t3
				ifNil: [t5 := t2 organization categoryOfElement: t1]
				ifNotNil: [t5 := t3].
			(self methodDict includesKey: t1)
				ifTrue: [t4 asString = (self sourceMethodAt: t1) asString
						ifFalse: [self error: self name , ' ' , t1 , ' will be redefined if you proceed.']].
			self compile: t4 classified: t5]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyAll: t1 from: t2 
	self
		copyAll: t1
		from: t2
		classified: nil! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyAll: t1 from: t2 classified: t3 
	t1
		do: [:t4 | self
				copy: t4
				from: t2
				classified: t3]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyAllCategoriesFrom: t1 
	t1 organization categories
		do: [:t2 | self copyCategory: t2 from: t1]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyAllCategoriesUnobtrusivelyFrom: t1 
	t1 organization categories
		do: [:t2 | self copyCategoryUnobtrusively: t2 from: t1]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyAllUnobtrusively: t1 from: t2 classified: t3 
	t1
		do: [:t4 | self
				copyUnobtrusively: t4
				from: t2
				classified: t3]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyCategory: t1 from: t2 
	self
		copyCategory: t1
		from: t2
		classified: t1! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyCategory: t1 from: t2 classified: t3 
	self
		copyAll: (t2 organization listAtCategoryNamed: t1)
		from: t2
		classified: t3! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyCategoryUnobtrusively: t1 from: t2 
	self
		copyUnobtrusivelyCategory: t1
		from: t2
		classified: t1! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyMethodDictionaryFrom: t1 
	self methodDict: t1 copyOfMethodDictionary.
	self organization: t1 organization deepCopy! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyUnobtrusively: t1 from: t2 classified: t3 
	| t4 t5 |
	t4 := t2 sourceMethodAt: t1.
	t4
		ifNotNil: [t3
				ifNil: [t5 := t2 organization categoryOfElement: t1]
				ifNotNil: [t5 := t3].
			self methodDict includesKey: t1.
			self compileSilently: t4 classified: t5]! !

!ClassDescription methodsFor: 'copying' stamp: ''!
copyUnobtrusivelyCategory: t1 from: t2 classified: t3 
	self
		copyAllUnobtrusively: (t2 organization listAtCategoryNamed: t1)
		from: t2
		classified: t3! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
definition
	| t1 t2 |
	t1 := WriteStream
				on: (String new: 300).
	superclass
		ifNil: [t1 nextPutAll: 'ProtoObject']
		ifNotNil: [t2 := ''.
			self environment
				scopeFor: superclass name
				from: nil
				envtAndPathIfFound: [:t4 :t5 | t2 := t5].
			t1 nextPutAll: t2 , superclass name].
	t1 nextPutAll: self kindOfSubclass;
		 store: self name.
	(self hasTraitComposition
			and: [self traitComposition notEmpty])
		ifTrue: [t1 cr; tab; nextPutAll: 'uses: '; nextPutAll: self traitCompositionString].
	t1 cr; tab; nextPutAll: 'instanceVariableNames: '; store: self instanceVariablesString.
	t1 cr; tab; nextPutAll: 'classVariableNames: '; store: self classVariablesString.
	t1 cr; tab; nextPutAll: 'poolDictionaries: '; store: self sharedPoolsString.
	t1 cr; tab; nextPutAll: 'category: '; store: (SystemOrganization categoryOfElement: self name) asString.
	superclass
		ifNil: [t1 nextPutAll: '.';
				 cr.
			t1 nextPutAll: self name.
			t1 space; nextPutAll: 'superclass: nil'].
	^ t1 contents! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
doneCompiling
	^ self! !

!ClassDescription methodsFor: 'private' stamp: ''!
errorCategoryName
	self error: 'Category name must be a String'! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutCategory: t1 
	^ self fileOutCategory: t1 asHtml: false! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutCategory: t1 asHtml: t2 
	| t3 |
	t3 := WriteStream
				on: (String new: 1000).
	t3 header; timeStamp.
	self
		fileOutCategory: t1
		on: t3
		moveSource: false
		toFile: 0.
	t3 trailer.
	FileStream
		writeSourceCodeFrom: t3
		baseName: self name , '-' , t1
		isSt: true
		useHtml: t2! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutCategory: t1 on: t2 moveSource: t3 toFile: t4 
	| t5 |
	t2 cr.
	t5 := t1 asString = ClassOrganizer allCategory
				ifTrue: [self organization allMethodSelectors]
				ifFalse: [self organization listAtCategoryNamed: t1].
	t5 := t5
				select: [:t6 | self includesLocalSelector: t6].
	t5
		do: [:t6 | self
				printMethodChunk: t6
				withPreamble: true
				on: t2
				moveSource: t3
				toFile: t4]! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutChangedMessages: t1 on: t2 
	self
		fileOutChangedMessages: t1
		on: t2
		moveSource: false
		toFile: 0! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: 'bf 7/24/2012 11:01'!
fileOutChangedMessages: aSet on: aFileStream moveSource: moveSource toFile: fileIndex 
	"File a description of the messages of this class that have been 
	changed (i.e., are entered into the argument, aSet) onto aFileStream.  If 
	moveSource, is true, then set the method source pointer to the new file position.
	Note when this method is called with moveSource=true, it is condensing the
	.changes file, and should only write a preamble for every method."
	| org |
	(org := self organization) categories do: 
		[:cat | 
		| sels |
		sels := (org listAtCategoryNamed: cat) select: [:sel | aSet includes: sel].
		(moveSource and: [(cat beginsWith: '*') and: [cat endsWith: '-override']])
			ifTrue: ["when condensing sources/changes, preserve overridden methods"
				sels do:
					[:sel |  self printMethodChunkHistorically: sel on: aFileStream
						moveSource: moveSource toFile: fileIndex]]
			ifFalse: [
				sels do:
					[:sel |  self printMethodChunk: sel withPreamble: true on: aFileStream
						moveSource: moveSource toFile: fileIndex]]]! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutChangedMessagesHistorically: t1 on: t2 moveSource: t3 toFile: t4 
	| t5 |
	(t5 := self organization) categories
		do: [:t6 | 
			| t7 |
			t7 := (t5 listAtCategoryNamed: t6)
						select: [:t8 | t1 includes: t8].
			t7
				do: [:t8 | self
						printMethodChunkHistorically: t8
						on: t2
						moveSource: t3
						toFile: t4]]! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutInitializerOn: t1 
	^ self! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutMethod: t1 
	self fileOutMethod: t1 asHtml: false! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutMethod: t1 asHtml: t2 
	| t3 |
	t1 == #Comment
		ifTrue: [^ self inform: 'Sorry, cannot file out class comment in isolation.'].
	(self includesSelector: t1)
		ifFalse: [^ self error: 'Selector ' , t1 asString , ' not found'].
	t3 := WriteStream
				on: (String new: 1000).
	t3 header; timeStamp.
	self
		printMethodChunk: t1
		withPreamble: true
		on: t3
		moveSource: false
		toFile: 0.
	FileStream
		writeSourceCodeFrom: t3
		baseName: self name , '-'
				, (t1 copyReplaceAll: ':' with: '')
		isSt: true
		useHtml: t2! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 
	self
		fileOutOn: t1
		moveSource: false
		toFile: 0! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 
	t1 command: 'H3'.
	t1 nextChunkPut: self definition.
	t1 command: '/H3'.
	self organization
		putCommentOnFile: t1
		numbered: t3
		moveSource: t2
		forClass: self.
	self organization categories
		do: [:t4 | self
				fileOutCategory: t4
				on: t1
				moveSource: t2
				toFile: t3]! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 initializing: t4 
	^ self
		fileOutOn: t1
		moveSource: t2
		toFile: t3! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
fileOutOrganizationOn: t1 
	t1 cr; nextPut: $!!.
	t1 nextChunkPut: self name , ' reorganize';
		 cr.
	t1 nextChunkPut: self organization printString;
		 cr! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
forceNewFrom: t1 
	| t2 t3 |
	t2 := self new.
	t3 := self instSize.
	t1
		doWithIndex: [:t4 :t5 | t5 > t3
				ifFalse: [t2 instVarAt: t5 put: t4]].
	^ t2! !

!ClassDescription methodsFor: 'initialize-release' stamp: ''!
forgetDoIts
	SystemChangeNotifier uniqueInstance
		doSilently: [self organization removeElement: #DoIt;
				 removeElement: #DoItIn:].
	super forgetDoIts! !

!ClassDescription methodsFor: 'accessing comment' stamp: ''!
hasComment
	| t1 |
	t1 := self instanceSide organization.
	^ t1 classComment isEmptyOrNil not! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
induceMDFault
	organization := Array with: methodDict with: organization.
	methodDict := nil.
	self flushCache! !

!ClassDescription methodsFor: 'instance variables' stamp: 'ul 11/15/2010 10:10'!
instVarIndexFor: instVarName ifAbsent: aBlock
	"Answer the index of the named instance variable."

	| index |
	index := instanceVariables == nil 
				ifTrue: [0]
				ifFalse: [instanceVariables indexOf: instVarName ifAbsent: [0]].
	index = 0 ifTrue: 
		[^superclass == nil 
			ifTrue: [aBlock value]
			ifFalse: [superclass instVarIndexFor: instVarName ifAbsent: aBlock]].
	^superclass == nil 	
		ifTrue: [index]
		ifFalse: [index + superclass instSize]! !

!ClassDescription methodsFor: 'private' stamp: ''!
instVarMappingFrom: t1 
	| t2 |
	t2 := t1 allInstVarNames.
	^ self allInstVarNames
		collect: [:t3 | t2 lastIndexOf: t3]! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
instVarNameForIndex: t1 
	| t2 |
	t1 > self instSize
		ifTrue: [^ nil].
	t2 := superclass isNil
				ifTrue: [0]
				ifFalse: [superclass instSize].
	t1 > t2
		ifTrue: [^ instanceVariables at: t1 - t2].
	superclass isNil
		ifTrue: [^ nil].
	^ superclass instVarNameForIndex: t1! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
instVarNames
	instanceVariables
		ifNil: [^ #()].
	^ instanceVariables! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
instVarNamesAndOffsetsDo: t1 
	| t2 |
	(t2 := superclass notNil
					ifTrue: [superclass instSize]
					ifFalse: [0]) > 0
		ifTrue: [superclass instVarNamesAndOffsetsDo: t1].
	1
		to: self instSize - t2
		do: [:t3 | t1
				value: (instanceVariables at: t3)
				value: t3 + t2]! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: ''!
instanceSide
	^ self theNonMetaClass! !

!ClassDescription methodsFor: 'printing' stamp: ''!
instanceVariablesString
	^ String
		streamContents: [:t1 | self instVarNames
				do: [:t2 | t1 nextPutAll: t2]
				separatedBy: [t1 space]]! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: 'nice 12/29/2010 12:29'!
isClassSide
	^self isMeta! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: ''!
isInstanceSide
	^ self isClassSide not! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
isUniClass
	^ self name endsWithDigit! !

!ClassDescription methodsFor: 'private' stamp: ''!
linesOfCode
	| t1 |
	t1 := self methodDict
				inject: 0
				into: [:t2 :t3 | t2 + t3 linesOfCode].
	self isMeta
		ifTrue: [^ t1].
	^ t1 + self class linesOfCode! !

!ClassDescription methodsFor: 'private' stamp: ''!
logMethodSource: t1 forMethodWithNode: t2 inCategory: t3 withStamp: t4 notifying: t5 
	| t6 t7 |
	t6 := self
				compiledMethodAt: t2 selector
				ifAbsent: [].
	t7 := (t5 notNil
					and: [Preferences confirmFirstUseOfStyle])
				ifTrue: [t1 askIfAddStyle: t6 req: t5]
				ifFalse: [t1].
	t2 method
		putSource: t7
		fromParseNode: t2 node
		class: self
		category: t3
		withStamp: t4
		inFile: 2
		priorMethod: t6! !

!ClassDescription methodsFor: 'organization' stamp: ''!
methodReferencesInCategory: t1 
	^ (self organization listAtCategoryNamed: t1)
		collect: [:t2 | MethodReference new
				setClassSymbol: self theNonMetaClass name
				classIsMeta: self isMeta
				methodSymbol: t2
				stringVersion: '']! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
methods
	^ ClassCategoryReader new setClass: self category: ClassOrganizer default! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
methodsFor: t1 
	^ ClassCategoryReader new setClass: self category: t1 asSymbol! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
methodsFor: t1 priorSource: t2 inFile: t3 
	^ self methodsFor: t1! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
methodsFor: t1 stamp: t2 
	^ self
		methodsFor: t1
		stamp: (Utilities fixStamp: t2)
		prior: 0! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
methodsFor: t1 stamp: t2 prior: t3 
	^ ClassCategoryReader new
		setClass: self
		category: t1 asSymbol
		changeStamp: t2! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: 'MarcusDenker 3/5/2010 14:33'!
methodsInCategory: aName 
	"Answer a list of the methods of the receiver that are in category named aName"
	
	| aColl |
	aColl := Set withAll: (aName = ClassOrganizer allCategory
			ifTrue: [self organization allMethodSelectors]
			ifFalse: [self organization listAtCategoryNamed: aName]).
	^ aColl asArray sort! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
moveChangesTo: t1 
	| t2 |
	t2 := self methodDict keys
				select: [:t3 | (self compiledMethodAt: t3) fileIndex > 1].
	self
		fileOutChangedMessages: t2
		on: t1
		moveSource: true
		toFile: 2! !

!ClassDescription methodsFor: 'filein/out' stamp: 'MarcusDenker 2/21/2010 12:51'!
moveChangesWithVersionsTo: newFile 
	"Used in the process of condensing changes, this message requests that 
	the source code of all methods of the receiver that have been changed 
	should be moved to newFile."

	| changes |
	changes := self selectors select: [:sel | (self methodDict at: sel) fileIndex > 1].
	self fileOutChangedMessagesHistorically: changes
		on: newFile
		moveSource: true
		toFile: 2! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: 'ul 11/15/2010 10:11'!
moveClassCommentTo: aFileStream fileIndex: newFileIndex
	"Called when condensing changes.  If the receiver has a class comment, and if that class comment does not reside in the .sources file, then write it to the given filestream, with the resulting RemoteString being reachable from the source file fileIndex.  Note that any existing backpointer into the .sources file is lost by this process -- a situation that maybe should be fixed someday."

	| header aStamp aCommentRemoteStr |
	self isMeta ifTrue: [^ self].  "bulletproofing only"
	((aCommentRemoteStr := self organization commentRemoteStr) isNil or:
		[aCommentRemoteStr sourceFileNumber = 1]) ifTrue: [^ self].

	aFileStream cr; nextPut: $!!.
	header := String streamContents: [:strm | strm nextPutAll: self name;
		nextPutAll: ' commentStamp: '.
		(aStamp := self organization commentStamp ifNil: ['<historical>']) storeOn: strm.
		strm nextPutAll: ' prior: 0'].
	aFileStream nextChunkPut: header.
	aFileStream cr.
	self organization classComment: (RemoteString newString: self organization classComment onFileNumber: newFileIndex toFile: aFileStream) stamp: aStamp! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
moveInstVarNamed: t1 to: t2 after: t3 
	self == t2
		ifFalse: [self notify: 'Warning:' asText allBold , ' moving ' , t1 printString , ' from ' , self name , ' to ' , t2 name , ' will not be recorded in the change set correctly.
Proceed to do it anyways.'].
	^ ClassBuilder new
		moveInstVarNamed: t1
		from: self
		to: t2
		after: t3! !

!ClassDescription methodsFor: 'private' stamp: ''!
newInstanceFrom: t1 variable: t2 size: t3 map: t4 
	| t5 |
	t2
		ifTrue: [t5 := self basicNew: t1 basicSize]
		ifFalse: [t5 := self basicNew].
	1
		to: t3
		do: [:t6 | (t4 at: t6)
					> 0
				ifTrue: [t5
						instVarAt: t6
						put: (t1
								instVarAt: (t4 at: t6))]].
	t2
		ifTrue: [1
				to: t1 basicSize
				do: [:t7 | t5
						basicAt: t7
						put: (t1 basicAt: t7)]].
	^ t5! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
noteAddedSelector: t1 meta: t2 
	^ self! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
noteCompilationOf: t1 meta: t2 
	^ self! !

!ClassDescription methodsFor: 'organization' stamp: ''!
notifyOfRecategorizedSelector: t1 from: t2 to: t3 
	SystemChangeNotifier uniqueInstance
		selector: t1
		recategorizedFrom: t2
		to: t3
		inClass: self! !

!ClassDescription methodsFor: 'initialize-release' stamp: ''!
obsolete
	self hasTraitComposition
		ifTrue: [self traitComposition
				do: [:t1 | t1 removeTraitUser: self]].
	superclass removeSubclass: self.
	self organization: nil.
	super obsolete! !

!ClassDescription methodsFor: 'organization' stamp: ''!
organization
	organization
		ifNil: [self
				organization: (ClassOrganizer defaultList: self methodDict keys sort)].
	(organization isMemberOf: Array)
		ifTrue: [self recoverFromMDFaultWithTrace].
	organization
		ifNotNil: [organization setSubject: self].
	^ organization! !

!ClassDescription methodsFor: 'organization' stamp: ''!
organization: t1 
	t1
		ifNotNil: [t1 setSubject: self].
	organization := t1! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
printCategoryChunk: t1 on: t2 
	^ self
		printCategoryChunk: t1
		withStamp: ''
		on: t2! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
printCategoryChunk: t1 on: t2 priorMethod: t3 
	^ self
		printCategoryChunk: t1
		on: t2
		withStamp: Utilities changeStamp
		priorMethod: t3! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
printCategoryChunk: t1 on: t2 withStamp: t3 priorMethod: t4 
	t2 cr; command: 'H3'; nextPut: $!!.
	t2
		nextChunkPut: (String
				streamContents: [:t5 | 
					t5 nextPutAll: self name;
						 nextPutAll: ' methodsFor: ';
						 print: t1 asString.
					(t3 ~~ nil
							and: [t3 size > 0
									or: [t4 ~~ nil]])
						ifTrue: [t5 nextPutAll: ' stamp: ';
								 print: t3].
					t4 ~~ nil
						ifTrue: [t5 nextPutAll: ' prior: ';
								 print: t4 sourcePointer]]).
	t2 command: '/H3'! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
printCategoryChunk: t1 withStamp: t2 on: t3 
	^ self
		printCategoryChunk: t1
		on: t3
		withStamp: t2
		priorMethod: nil! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
printMethodChunk: t1 withPreamble: t2 on: t3 moveSource: t4 toFile: t5 
	| t6 t7 t8 t9 t10 t11 |
	t2
		ifTrue: [t6 := self name , ' methodsFor: ' , (self organization categoryOfElement: t1) asString printString]
		ifFalse: [t6 := ''].
	t7 := self methodDict
				at: t1
				ifAbsent: [t3 nextPutAll: t1;
						 cr.
					t3 tab; nextPutAll: '** ERROR!!  THIS SCRIPT IS MISSING ** ' translated; cr; cr.
					t3 nextPutAll: '  '.
					^ t3].
	((t7 fileIndex = 0
				or: [(SourceFiles at: t7 fileIndex)
						== nil])
			or: [(t8 := t7 filePosition) = 0])
		ifTrue: [t6 size > 0
				ifTrue: [t3 cr; nextPut: $!!; nextChunkPut: t6; cr].
			t3 nextChunkPut: t7 decompileString]
		ifFalse: [t10 := SourceFiles at: t7 fileIndex.
			t6 size > 0
				ifTrue: [t3
						copyPreamble: t6
						from: t10
						at: t8]
				ifFalse: [t10 position: t8].
			t9 := t3 position.
			t3 copyMethodChunkFrom: t10.
			t10 skipSeparators.
			t10 peek == $]
				ifTrue: [t3 cr; copyMethodChunkFrom: t10].
			t4
				ifTrue: [t11 := t3 position.
					t7 checkOKToAdd: t11 - t9 at: t9.
					t7 setSourcePosition: t9 inFile: t5]].
	t6 size > 0
		ifTrue: [t3 nextChunkPut: ' '].
	^ t3 cr! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
printMethodChunkHistorically: t1 on: t2 moveSource: t3 toFile: t4 
	| t5 t6 t7 t8 t9 t10 t11 |
	t9 := self organization categoryOfElement: t1.
	t5 := self name , ' methodsFor: ' , t9 asString printString.
	t6 := self methodDict at: t1.
	((t6 fileIndex = 0
				or: [(SourceFiles at: t6 fileIndex)
						== nil])
			or: [t6 filePosition = 0])
		ifTrue: [t2 cr; nextPut: $!!; nextChunkPut: t5; cr.
			t2 nextChunkPut: t6 decompileString.
			t2 nextChunkPut: ' ';
				 cr]
		ifFalse: [t10 := ChangeSet
						scanVersionsOf: t6
						class: self
						meta: self isMeta
						category: t9
						selector: t1.
			t11 := nil.
			t7 := SourceFiles at: t6 fileIndex.
			t10
				reverseDo: [:t13 | t13 fileIndex = t4
						ifTrue: [t2
								copyPreamble: t5
								from: t7
								at: t13 position.
							t13 prior
								ifNotNil: [:t14 | 
									t2 position: t2 position - 2.
									t2 nextPutAll: ' prior: ' , (t14 first = t6 fileIndex
												ifTrue: [SourceFiles sourcePointerFromFileIndex: t6 fileIndex andPosition: t11]
												ifFalse: [t14 third]) printString.
									t2 nextPut: $!!;
										 cr].
							t11 := t2 position.
							t2 copyMethodChunkFrom: t7 at: t13 position.
							t7 skipSeparators.
							t7 peek == $]
								ifTrue: [t2 cr; copyMethodChunkFrom: t7].
							t2 nextChunkPut: ' ';
								 cr]].
			t3
				ifTrue: [t8 := t2 position.
					t6 checkOKToAdd: t8 - t11 at: t11.
					t6 setSourcePosition: t11 inFile: t4]].
	^ t2! !

!ClassDescription methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: self name! !

!ClassDescription methodsFor: 'printing' stamp: ''!
printOnStream: t1 
	t1 print: self name! !

!ClassDescription methodsFor: 'accessing class hierarchy' stamp: ''!
printSubclassesOn: t1 level: t2 
	| t3 |
	t1 crtab: t2.
	t1 nextPutAll: self name.
	t1 space; print: self instVarNames.
	self == Class
		ifTrue: [t1 crtab: t2 + 1;
				 nextPutAll: '[ ... all the Metaclasses ... ]'.
			^ self].
	t3 := self subclasses
				asSortedCollection: [:t4 :t5 | t4 name <= t5 name].
	t3
		do: [:t4 | t4 printSubclassesOn: t1 level: t2 + 1]! !

!ClassDescription methodsFor: 'printing' stamp: ''!
printWithClosureAnalysisOn: t1 
	t1 nextPutAll: self name! !

!ClassDescription methodsFor: 'fileIn/Out' stamp: ''!
putClassCommentToCondensedChangesFile: t1 
	^ self moveClassCommentTo: t1 fileIndex: 2! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
recoverFromMDFault
	(organization isMemberOf: Array)
		ifFalse: [^ self error: 'oops'].
	methodDict := organization first.
	organization := organization second! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
recoverFromMDFaultWithTrace
	self recoverFromMDFault.
	self environment
		at: #MDFaultDict
		ifPresent: [:t1 | t1
				at: self name
				put: (String
						streamContents: [:t2 | (thisContext stackOfSize: 20)
								do: [:t3 | t2 print: t3;
										 cr]])]! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
reformatAll
	self
		selectorsDo: [:t1 | self reformatMethodAt: t1]! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
reformatMethodAt: t1 
	| t2 t3 |
	t2 := self prettyPrinterClass
				format: (self sourceCodeAt: t1)
				in: self
				notifying: nil
				decorated: false.
	t3 := self compiledMethodAt: t1.
	t3
		putSource: t2
		fromParseNode: nil
		class: self
		category: (self organization categoryOfElement: t1)
		inFile: 2
		priorMethod: t3! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
removeCategory: t1 
	| t2 |
	t2 := t1 asSymbol.
	(self organization listAtCategoryNamed: t2)
		do: [:t3 | self removeSelector: t3].
	self organization removeCategory: t2! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
removeInstVarName: t1 
	self subclassResponsibility! !

!ClassDescription methodsFor: 'accessing method dictionary' stamp: ''!
removeSelector: t1 
	| t2 t3 |
	t2 := self
				compiledMethodAt: t1
				ifAbsent: [^ nil].
	t3 := self whichCategoryIncludesSelector: t1.
	SystemChangeNotifier uniqueInstance
		doSilently: [self organization removeElement: t1].
	super removeSelector: t1.
	SystemChangeNotifier uniqueInstance
		methodRemoved: t2
		selector: t1
		inProtocol: t3
		class: self! !

!ClassDescription methodsFor: 'accessing class hierarchy' stamp: ''!
removeUninstantiatedSubclassesSilently
	| t1 t2 |
	t2 := Smalltalk garbageCollect.
	t1 := self subclasses
				select: [:t3 | t3 instanceCount = 0
						and: [t3 subclasses size = 0]].
	t1
		do: [:t3 | t3 removeFromSystem].
	^ Smalltalk garbageCollect - t2! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
renameInstVar: t1 to: t2 
	(self confirm: 'WARNING: Renaming of instance variables
is subject to substitution ambiguities.
Do you still wish to attempt it?')
		ifFalse: [self halt].
	^ self renameSilentlyInstVar: t1 to: t2! !

!ClassDescription methodsFor: 'instance variables' stamp: ''!
renameSilentlyInstVar: t1 to: t2 
	| t3 t4 t5 |
	t4 := t1 asString.
	t5 := t2 asString.
	(t3 := self instVarNames indexOf: t4) = 0
		ifTrue: [self error: t4 , ' is not defined in ' , self name].
	self allSuperclasses , self withAllSubclasses asOrderedCollection
		do: [:t6 | (t6 instVarNames includes: t5)
				ifTrue: [self error: t5 , ' is already used in ' , t6 name]].
	self instVarNames
		replaceFrom: t3
		to: t3
		with: (Array with: t5).
	self replaceSilently: t4 to: t5! !

!ClassDescription methodsFor: 'organization' stamp: ''!
reorganize
	^ self organization! !

!ClassDescription methodsFor: 'instance variables' stamp: 'nice 2/23/2011 21:47'!
replaceSilently: old to: new
	"text-replace any part of a method.  Used for class and pool variables.  Don't touch the header.  Not guaranteed to work if name appears in odd circumstances"
	| oldName newName |
	oldName := old asString.
	newName := new asString.
	self withAllSubclasses do:
		[:cls |
		| sels |
		sels := cls selectors copyWithoutAll: #(DoIt DoItIn:).
		sels do:
			[:sel |
			| oldCode newCode parser header body |
			oldCode := cls sourceCodeAt: sel.
			"Don't make changes in the method header"
			(parser := cls newParser) parseSelector: oldCode.
			header := oldCode copyFrom: 1 to: (parser endOfLastToken min: oldCode size).
			body := header size > oldCode size
					ifTrue: ['']
					ifFalse: [oldCode copyFrom: header size+1 to: oldCode size].
			newCode := header , (body copyReplaceTokens: oldName with: newName).
			newCode ~= oldCode ifTrue:
				[cls compile: newCode
					classified: (cls organization categoryOfElement: sel)
					notifying: nil]].
		cls isMeta ifFalse:
			[| oldCode newCode |
			oldCode := cls comment.
			newCode := oldCode copyReplaceTokens: oldName with: newName.
			newCode ~= oldCode ifTrue:
				[cls comment: newCode]]]! !

!ClassDescription methodsFor: 'private' stamp: ''!
setInstVarNames: t1 
	| t2 |
	t2 := self instSize.
	superclass notNil
		ifTrue: [t2 := t2 - superclass instSize].
	t1 size = t2
		ifFalse: [^ self error: t2 printString , ' instvar names are required'].
	t1 isEmpty
		ifTrue: [instanceVariables := nil]
		ifFalse: [instanceVariables := t1 asArray]! !

!ClassDescription methodsFor: 'printing' stamp: ''!
sharedPoolsString
	^ String
		streamContents: [:t1 | self sharedPools
				do: [:t2 | t1
						nextPutAll: (self environment
								keyAtIdentityValue: t2
								ifAbsent: ['private'])]
				separatedBy: [t1 space]]! !

!ClassDescription methodsFor: 'printing' stamp: ''!
storeOn: t1 
	t1 nextPutAll: self name! !

!ClassDescription methodsFor: 'accessing class hierarchy' stamp: ''!
subclasses
	^ Array new! !

!ClassDescription methodsFor: 'accessing class hierarchy' stamp: ''!
subclassesDo: t1 
	^ self subclasses do: t1! !

!ClassDescription methodsFor: 'initialize-release' stamp: ''!
superclass: t1 methodDictionary: t2 format: t3 
	super
		superclass: t1
		methodDictionary: t2
		format: t3.
	instanceVariables := nil.
	self organization: nil! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: ''!
theMetaClass
	^ self class! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: ''!
theNonMetaClass
	^ self! !

!ClassDescription methodsFor: 'initialize-release' stamp: ''!
updateInstances: t1 from: t2 isMeta: t3 
	| t4 t5 t6 t7 |
	t1 isEmpty
		ifTrue: [^ #()].
	t3
		ifTrue: [t1 size = 1
				ifFalse: [^ self error: 'Metaclasses can only have one instance'].
			self soleInstance class == self
				ifTrue: [^ self error: 'Metaclasses can only have one instance']].
	t4 := self instVarMappingFrom: t2.
	t5 := self isVariable.
	t6 := self instSize.
	t7 := Array new: t1 size.
	1
		to: t1 size
		do: [:t8 | t7
				at: t8
				put: (self
						newInstanceFrom: (t1 at: t8)
						variable: t5
						size: t6
						map: t4)].
	t1 elementsExchangeIdentityWith: t7.
	^ t7! !

!ClassDescription methodsFor: 'initialize-release' stamp: ''!
updateInstancesFrom: t1 
	| t2 |
	t2 := t1 allInstances asArray.
	t2 := self
				updateInstances: t2
				from: t1
				isMeta: self isMeta.
	ImageSegment
		allSubInstancesDo: [:t3 | t3
				segUpdateInstancesOf: t1
				toBe: self
				isMeta: self isMeta].
	^ t2! !

!ClassDescription methodsFor: 'accessing' stamp: ''!
version
	^ self classVersion! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ true! !

!ClassDescription methodsFor: 'compiling' stamp: ''!
wantsRecompilationProgressReported
	^ true! !

!ClassDescription methodsFor: 'organization' stamp: ''!
whichCategoryIncludesSelector: t1 
	(self includesSelector: t1)
		ifTrue: [^ self organization categoryOfElement: t1].
	^ nil! !

!ClassDescription methodsFor: 'organization' stamp: ''!
zapOrganization
	self hasTraitComposition
		ifFalse: [self organization: nil.
			self isClassSide
				ifFalse: [self classSide zapOrganization]]! !

ClassDescription subclass: #Metaclass
	instanceVariableNames: 'thisClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!Metaclass class methodsFor: 'anti-corruption' stamp: ''!
isScarySelector: t1 
	(Metaclass includesSelector: t1)
		ifTrue: [^ true].
	(ClassDescription includesSelector: t1)
		ifTrue: [^ true].
	(Behavior includesSelector: t1)
		ifTrue: [^ true].
	^ false! !

!Metaclass methodsFor: 'compiling' stamp: ''!
acceptsLoggingOfCompilation
	^ thisClass acceptsLoggingOfCompilation! !

!Metaclass methodsFor: 'instance variables' stamp: ''!
addInstVarName: t1 
	| t2 |
	t2 := String
				streamContents: [:t3 | 
					self instVarNames
						do: [:t4 | t3 nextPutAll: t4;
								 space].
					t3 nextPutAll: t1].
	self instanceVariableNames: t2! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
addObsoleteSubclass: t1 
	^ self! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
addSubclass: t1 
	^ self! !

!Metaclass methodsFor: 'initialize-release' stamp: ''!
adoptInstance: t1 from: t2 
	thisClass class == self
		ifTrue: [^ self error: 'Metaclasses have only one instance'].
	t2 isMeta
		ifFalse: [^ self error: 'Argument must be Metaclass'].
	t1 class == t2
		ifFalse: [^ self error: 'Not the class of argument'].
	^ thisClass := self
				newInstanceFrom: t1
				variable: self isVariable
				size: self instSize
				map: (self instVarMappingFrom: t2)! !

!Metaclass methodsFor: 'enumerating' stamp: ''!
allInstancesDo: t1 
	thisClass class == self
		ifTrue: [^ t1 value: thisClass].
	^ super allInstancesDo: t1! !

!Metaclass methodsFor: 'enumerating' stamp: ''!
allInstancesEverywhereDo: t1 
	thisClass class == self
		ifTrue: [^ t1 value: thisClass].
	^ super allInstancesEverywhereDo: t1! !

!Metaclass methodsFor: 'compiling' stamp: ''!
bindingOf: t1 
	^ thisClass classBindingOf: t1! !

!Metaclass methodsFor: 'testing' stamp: ''!
canZapMethodDictionary
	thisClass
		ifNil: [^ true].
	^ thisClass canZapMethodDictionary! !

!Metaclass methodsFor: 'organization' stamp: 'fbs 2/15/2011 08:27'!
category
	^ thisClass category! !

!Metaclass methodsFor: 'pool variables' stamp: ''!
classPool
	^ thisClass classPool! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
definition
	^ String
		streamContents: [:t1 | 
			t1 print: self.
			self traitComposition isEmpty
				ifFalse: [t1 crtab; nextPutAll: 'uses: '; nextPutAll: self traitComposition asString].
			t1 crtab; nextPutAll: 'instanceVariableNames: '; store: self instanceVariablesString]! !

!Metaclass methodsFor: 'accessing' stamp: ''!
environment
	^ thisClass environment! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
fileOutInitializerOn: t1 
	(self methodDict includesKey: #initialize)
		ifTrue: [t1 cr.
			t1 nextChunkPut: thisClass name , ' initialize']! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 
	^ self
		fileOutOn: t1
		moveSource: t2
		toFile: t3
		initializing: true! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
fileOutOn: t1 moveSource: t2 toFile: t3 initializing: t4 
	super
		fileOutOn: t1
		moveSource: t2
		toFile: t3.
	(t4
			and: [t2 not
					and: [self methodDict includesKey: #initialize]])
		ifTrue: [t1 cr.
			t1 cr.
			t1 nextChunkPut: thisClass name , ' initialize'.
			t1 cr]! !

!Metaclass methodsFor: 'initialize-release' stamp: ''!
instanceVariableNames: t1 
	^ ClassBuilder new class: self instanceVariableNames: t1! !

!Metaclass methodsFor: 'testing' stamp: ''!
isMeta
	^ true! !

!Metaclass methodsFor: 'testing' stamp: ''!
isObsolete
	^ thisClass
		ifNil: [true]
		ifNotNil: [thisClass class ~~ self
				or: [thisClass isObsolete]]! !

!Metaclass methodsFor: 'accessing' stamp: ''!
isSystemDefined
	^ true! !

!Metaclass methodsFor: 'accessing' stamp: ''!
name
	thisClass
		ifNil: [^ 'a Metaclass'].
	^ thisClass name , ' class'! !

!Metaclass methodsFor: 'instance creation' stamp: ''!
new
	thisClass class ~~ self
		ifTrue: [^ thisClass := self basicNew].
	self error: 'A Metaclass should only have one instance!!'! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
nonTrivial
	^ self instVarNames size > 0
		or: [self methodDict size > 0
				or: [self hasTraitComposition]]! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
objectForDataStream: t1 
	| t2 |
	(t1 insideASegment
			and: [self isSystemDefined not])
		ifTrue: [^ self].
	t2 := DiskProxy
				global: self theNonMetaClass name
				selector: #class
				args: Array new.
	t1 replace: self with: t2.
	^ t2! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
obsoleteSubclasses
	thisClass
		ifNil: [^ #()].
	^ thisClass obsoleteSubclasses
		select: [:t1 | t1 isMeta not]
		thenCollect: [:t1 | t1 class]! !

!Metaclass methodsFor: 'compiling' stamp: ''!
possibleVariablesFor: t1 continuedFrom: t2 
	^ thisClass possibleVariablesFor: t1 continuedFrom: t2! !

!Metaclass methodsFor: 'copying' stamp: 'nice 12/29/2010 10:21'!
postCopy
	"Don't share the reference to the sole instance."

	super postCopy.
	thisClass := nil.! !

!Metaclass methodsFor: 'instance variables' stamp: ''!
removeInstVarName: t1 
	| t2 t3 |
	(self instVarNames includes: t1)
		ifFalse: [self error: t1 , ' is not one of my instance variables'].
	t2 := self instVarNames copyWithout: t1.
	t3 := ''.
	t2
		do: [:t5 | t3 := t5 , ' ' , t3].
	self instanceVariableNames: t3! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
removeObsoleteSubclass: t1 
	^ self! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
removeSubclass: t1 
	^ self! !

!Metaclass methodsFor: 'private' stamp: ''!
replaceObsoleteInstanceWith: t1 
	thisClass class == self
		ifTrue: [^ self error: 'I am fine, thanks'].
	t1 class == self
		ifFalse: [^ self error: 'Not an instance of me'].
	thisClass := t1! !

!Metaclass methodsFor: 'accessing' stamp: ''!
soleInstance
	^ thisClass! !

!Metaclass methodsFor: 'fileIn/Out' stamp: ''!
storeDataOn: t1 
	(t1 insideASegment
			and: [self isSystemDefined not])
		ifTrue: [^ super storeDataOn: t1].
	self error: 'use a DiskProxy to store a Class'! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
subclasses
	thisClass
		ifNil: [^ #()].
	^ thisClass subclasses
		select: [:t1 | t1 isMeta not]
		thenCollect: [:t1 | t1 class]! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
subclassesDo: t1 
	thisClass
		subclassesDo: [:t2 | t2 isMeta
				ifFalse: [t1 value: t2 class]]! !

!Metaclass methodsFor: 'class hierarchy' stamp: ''!
subclassesDoGently: t1 
	thisClass
		subclassesDo: [:t2 | t2 isInMemory
				ifTrue: [t2 isMeta
						ifFalse: [t1 value: t2 class]]]! !

!Metaclass methodsFor: 'accessing parallel hierarchy' stamp: ''!
theMetaClass
	^ self! !

!Metaclass methodsFor: 'accessing parallel hierarchy' stamp: ''!
theNonMetaClass
	^ thisClass! !

!Metaclass methodsFor: 'initialize-release' stamp: ''!
uses: t1 instanceVariableNames: t2 
	| t3 t4 t5 |
	t5 := self copy.
	t4 := self instanceVariableNames: t2.
	t3 := t1 asTraitComposition.
	t4 setTraitComposition: t3.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t5 to: t4! !

!Metaclass methodsFor: 'compiling' stamp: ''!
wantsChangeSetLogging
	^ thisClass wantsChangeSetLogging! !

!Metaclass methodsFor: 'compiling' stamp: ''!
wantsRecompilationProgressReported
	^ thisClass wantsRecompilationProgressReported! !

!Metaclass methodsFor: 'testing' stamp: 'nice 5/7/2011 14:27'!
whichMethodsStoreInto: varName 
	"Answer a collection of CompiledMethod which store into the argument, varName, as a named class variable. Or let super try with a named instance variable."
	| ref |
	ref := self classPool
		associationAt: varName
		ifAbsent: [ ^ super whichMethodsStoreInto: varName ].
	^self methodDict values select: [:eachMethod | eachMethod writesRef: ref ]! !

!Metaclass methodsFor: 'testing' stamp: 'nice 5/7/2011 14:10'!
whichSelectorsStoreInto: varName 
	"Answer a collection of selectors whose methods access the argument, varName, as a named class variable. Or let super try with a named instance variable."
	| ref |
	ref := self classPool
		associationAt: varName
		ifAbsent: [ ^ super whichSelectorsStoreInto: varName ].
	^self methodDict keys select: [:aSelector | (self methodDict at: aSelector) writesRef: ref ]! !

Object variableSubclass: #BlockClosure
	instanceVariableNames: 'outerContext startpc numArgs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!BlockClosure class methodsFor: 'instance creation' stamp: ''!
outerContext: t1 startpc: t2 numArgs: t3 copiedValues: t4 
	^ (self new: t4 basicSize)
		outerContext: t1
		startpc: t2
		numArgs: t3
		copiedValues: t4! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
argumentCount
	^ self numArgs! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
asContext
	^ self asContextWithSender: nil! !

!BlockClosure methodsFor: 'private' stamp: 'HenrikSperreJohansen 8/2/2010 04:15'!
asContextWithSender: aContext
	"Inner private support method for evaluation.  Do not use unless you know what you're doing."

	^(MethodContext newForMethod: outerContext method)
		setSender: aContext
		receiver: outerContext receiver
		method: outerContext method
		closure: self
		startpc: startpc;
		privRefresh! !

!BlockClosure methodsFor: 'events-support' stamp: ''!
asMinimalRepresentation
	^ self! !

!BlockClosure methodsFor: 'exceptions' stamp: ''!
assert
	self assert: self! !

!BlockClosure methodsFor: 'evaluating' stamp: 'nice 9/10/2010 20:54'!
bench
	"See how many times I can value in 5 seconds.  I'll answer a meaningful description."

	| startTime endTime count roundTo3Digits |
	roundTo3Digits := [:num |
		| rounded lowDigit |
		rounded := (num * 1000) rounded. "round to 1/1000"
		lowDigit := (rounded numberOfDigitsInBase: 10) - 3. "keep only first 3 digits"
		rounded := rounded roundTo:(10 raisedTo: lowDigit).
		(lowDigit >= 3 or: [rounded \\ 1000 = 0]) "display fractional part only when needed"
			ifTrue: [(rounded // 1000) asStringWithCommas]
			ifFalse: [(rounded / 1000.0) printString]].
	count := 0.
	endTime := Time millisecondClockValue + 5000.
	startTime := Time millisecondClockValue.
	[ Time millisecondClockValue > endTime ] whileFalse: [ self value.  count := count + 1 ].
	endTime := Time millisecondClockValue.
	^count = 1
		ifTrue: [ (roundTo3Digits value: (endTime - startTime) / 1000) , ' seconds.' ]
		ifFalse:
			[ (roundTo3Digits value: (count * 1000) / (endTime - startTime)) , ' per second.' ]! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
copiedValueAt: t1 
	<primitive: 60>
	^ self basicAt: t1! !

!BlockClosure methodsFor: 'private' stamp: ''!
copyForSaving
	^ self shallowCopy postCopy! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
cull: t1 
	numArgs >= 1
		ifTrue: [^ self value: t1].
	^ self value! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
cull: t1 cull: t2 
	numArgs >= 2
		ifTrue: [^ self value: t1 value: t2].
	numArgs = 1
		ifTrue: [^ self value: t1].
	^ self value! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
cull: t1 cull: t2 cull: t3 
	numArgs >= 2
		ifTrue: [numArgs >= 3
				ifTrue: [^ self
						value: t1
						value: t2
						value: t3].
			^ self value: t1 value: t2].
	numArgs = 1
		ifTrue: [^ self value: t1].
	^ self value! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
cull: t1 cull: t2 cull: t3 cull: t4 
	numArgs >= 3
		ifTrue: [numArgs >= 4
				ifTrue: [^ self
						value: t1
						value: t2
						value: t3
						value: t4].
			^ self
				value: t1
				value: t2
				value: t3].
	numArgs = 2
		ifTrue: [^ self value: t1 value: t2].
	numArgs = 1
		ifTrue: [^ self value: t1].
	^ self value! !

!BlockClosure methodsFor: 'printing' stamp: ''!
decompile
	^ Decompiler new decompileBlock: self! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
doWhileFalse: t1 
	| t2 |
	[t2 := self value.
	t1 value] whileFalse.
	^ t2! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
doWhileTrue: t1 
	| t2 |
	[t2 := self value.
	t1 value] whileTrue.
	^ t2! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
durationToRun
	^ Duration milliSeconds: self timeToRun! !

!BlockClosure methodsFor: 'exceptions' stamp: ''!
ensure: t1 
	| t2 t3 |
	<primitive: 198>
	t3 := self valueNoContextSwitch.
	t2
		ifNil: [t2 := true.
			t1 value].
	^ t3! !

!BlockClosure methodsFor: 'private' stamp: ''!
fixTemps
	^ self! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
fork
	^ self newProcess resume! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
forkAndWait
	| t1 |
	t1 := Semaphore new.
	[self
		ensure: [t1 signal]] fork.
	t1 wait! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
forkAt: t1 
	^ self newProcess priority: t1;
		 resume! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
forkAt: t1 named: t2 
	| t3 |
	t3 := self newProcess.
	t3 priority: t1.
	t3 name: t2.
	^ t3 resume! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
forkNamed: t1 
	^ self newProcess name: t1;
		 resume! !

!BlockClosure methodsFor: 'printing' stamp: ''!
fullPrintOn: t1 
	t1 print: self;
		 cr.
	(self decompile
		ifNil: ['--source missing--'])
		printOn: t1
		indent: 0! !

!BlockClosure methodsFor: 'testing' stamp: 'eem 4/26/2012 10:21'!
hasMethodReturn
	"Answer whether the receiver has a method-return ('^') in its code."
	| scanner endpc |
	scanner := InstructionStream new method: outerContext method pc: startpc.
	endpc := self endPC.
	scanner scanFor: [:byte | (byte between: 120 and: 124) or: [scanner pc > endpc]].
	^scanner pc <= endpc! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
home
	^ outerContext home! !

!BlockClosure methodsFor: 'exceptions' stamp: ''!
ifCurtailed: t1 
	| t2 t3 |
	<primitive: 198>
	t3 := self valueNoContextSwitch.
	t2 := true.
	^ t3! !

!BlockClosure methodsFor: 'evaluating' stamp: 'ul 8/2/2010 19:40'!
ifError: errorHandlerBlock
	"Evaluate the block represented by the receiver, and normally return it's value.  If an error occurs, the errorHandlerBlock is evaluated, and it's value is instead returned.  The errorHandlerBlock must accept zero, one, or two parameters (the error message and the receiver)."
	"Examples:
		[1 whatsUpDoc] ifError: [:err :rcvr | 'huh?'].
		[1 / 0] ifError: [:err :rcvr |
			'ZeroDivide' = err
				ifTrue: [Float infinity]
				ifFalse: [self error: err]]
"

	^ self on: Error do: [:ex |
		errorHandlerBlock cull: ex description cull: ex receiver ]! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
isBlock
	^ true! !

!BlockClosure methodsFor: 'testing' stamp: ''!
isClosure
	^ true! !

!BlockClosure methodsFor: 'testing' stamp: ''!
isDead
	^ false! !

!BlockClosure methodsFor: 'events-support' stamp: 'nice 9/21/2010 10:22'!
isReceiverOrAnyArgumentGarbage
	"For use in the when:evaluate: protocol, i.e.,
		foo when: #bar evaluate:[self handleBar].."
	^false! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
method
	^ outerContext method! !

!BlockClosure methodsFor: 'scheduling' stamp: ''!
newProcess
	<primitive: 19>
	^ Process forContext: [self value.
		Processor terminateActive] asContext priority: Processor activePriority! !

!BlockClosure methodsFor: 'scheduling' stamp: 'ul 12/8/2010 02:47'!
newProcessWith: anArray 
	"Answer a Process running the code in the receiver. The receiver's block 
	arguments are bound to the contents of the argument, anArray. The 
	process is not scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self valueWithArguments: anArray.
			Processor terminateActive] asContext
		priority: Processor activePriority! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
numArgs
	^ numArgs! !

!BlockClosure methodsFor: 'error handing' stamp: ''!
numArgsError: t1 
	| t2 |
	t2 := [:t3 | t3 printString , ' argument'
				, (t3 = 1
						ifTrue: ['']
						ifFalse: ['s'])].
	self error: 'This block accepts '
			, (t2 value: numArgs) , ', but was called with '
			, (t2 value: t1) , '.'! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
numCopiedValues
	<primitive: 62>
	^ self basicSize! !

!BlockClosure methodsFor: 'accessing' stamp: 'eem 4/26/2012 11:01'!
numTemps
	"Answer the number of temporaries for the receiver; this includes
	 the number of arguments and the number of copied values."
	| blockCreationBytecodeSize |
	^self numCopiedValues
	 + self numArgs
	 + (BlockLocalTempCounter
			tempCountForBlockAt: startpc - (blockCreationBytecodeSize := 4)
			in: self method)! !

!BlockClosure methodsFor: 'exceptions' stamp: ''!
on: t1 do: t2 
	| t3 |
	<primitive: 199>
	t3 := true.
	^ self value! !

!BlockClosure methodsFor: 'exceptions' stamp: 'ul 8/2/2011 19:52'!
on: exc1 do: block1 on: exc2 do: block2

	^[
		self
			on: exc1
			do: block1 ]
		on: exc2
		do: block2! !

!BlockClosure methodsFor: 'exceptions' stamp: 'ul 8/2/2011 19:52'!
on: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		self
			on: exc1
			do: block1 ]
		on: exc2
		do: block2
		on: exc3
		do: block3! !

!BlockClosure methodsFor: 'exceptions' stamp: 'ul 8/12/2010 00:07'!
onDNU: selector do: handleBlock
	"Catch MessageNotUnderstood exceptions but only those of the given selector (DNU stands for doesNotUnderstand:)"

	^ self on: MessageNotUnderstood do: [:exception |
		exception message selector = selector
			ifTrue: [handleBlock cull: exception]
			ifFalse: [exception pass]
	  ]! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 3/28/2012 18:27'!
once
	"Evaluate the receiver exactly once, so that repeated evaluations
	 answer exactly the same object as the first evaluation.  This
	 allows one to intern values with the idiom
		myResourceMethod
			^[expression] once"

	| cache |
	cache := self method
				propertyValueAt: #onceCache
				ifAbsent: [self method propertyValueAt: #onceCache put: Dictionary new].
	^cache at: startpc ifAbsentPut: [self value]! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
outerContext
	^ outerContext! !

!BlockClosure methodsFor: 'initialize-release' stamp: ''!
outerContext: t1 startpc: t2 numArgs: t3 copiedValues: t4 
	outerContext := t1.
	startpc := t2.
	numArgs := t3.
	1
		to: self numCopiedValues
		do: [:t5 | self
				at: t5
				put: (t4 at: t5)]! !

!BlockClosure methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: '[closure] in '.
	outerContext printOn: t1! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
receiver
	^ outerContext receiver! !

!BlockClosure methodsFor: 'private' stamp: ''!
reentrant
	^ self! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
repeat
	[self value.
	true] whileTrue! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
repeatWithGCIf: t1 
	| t2 |
	t2 := self value.
	(t1 value: t2)
		ifTrue: [Smalltalk garbageCollect.
			t2 := self value].
	^ t2! !

!BlockClosure methodsFor: 'debugger access' stamp: ''!
sender
	^ outerContext sender! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
simulateValueWithArguments: t1 caller: t2 
	| t3 t4 |
	(t1 class ~~ Array
			or: [numArgs ~= t1 size])
		ifTrue: [^ ContextPart primitiveFailToken].
	t3 := (MethodContext newForMethod: outerContext method)
				setSender: t2
				receiver: outerContext receiver
				method: outerContext method
				closure: self
				startpc: startpc.
	t4 := self basicSize.
	t3 stackp: t4 + numArgs.
	1
		to: numArgs
		do: [:t5 | t3
				at: t5
				put: (t1 at: t5)].
	1
		to: t4
		do: [:t6 | t3
				at: t6 + numArgs
				put: (self at: t6)].
	^ t3! !

!BlockClosure methodsFor: 'accessing' stamp: 'mha 9/22/2010 11:40'!
size
	"Extract this closure's bytecode size (number of bytes) by accessing the closure
	creation bytecode in the enclosing method."
	
	^ ((self method at: self startpc - 2) bitShift: 8) + (self method at: self startpc - 1)! !

!BlockClosure methodsFor: 'accessing' stamp: ''!
startpc
	^ startpc! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
timeToRun
	^ Time millisecondsToRun: self! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
timeToRunWithoutGC
	^ (SmalltalkImage current vmParameterAt: 8)
		+ (SmalltalkImage current vmParameterAt: 10) + self timeToRun
		- (SmalltalkImage current vmParameterAt: 8)
		- (SmalltalkImage current vmParameterAt: 10)! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 7/7/2010 11:50'!
value
	"Activate the receiver, creating a closure activation (MethodContext)
	 whose closure is the receiver and whose caller is the sender of this
	 message. Supply the copied values to the activation as its copied
	 temps. Primitive. Essential."
	<primitive: 201>
	| newContext |
	numArgs ~= 0 ifTrue:
		[self numArgsError: 0].
	false
		ifTrue: "Old code to simulate the closure value primitive on VMs that lack it."
			[newContext := self asContextWithSender: thisContext sender.
			thisContext privSender: newContext]
		ifFalse: [self primitiveFailed]! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 7/7/2010 10:21'!
value: firstArg
	"Activate the receiver, creating a closure activation (MethodContext)
	 whose closure is the receiver and whose caller is the sender of this
	 message. Supply the argument and copied values to the activation
	 as its argument and copied temps. Primitive. Essential."
	<primitive: 202>
	| newContext |
	numArgs ~= 1 ifTrue:
		[self numArgsError: 1].
	false
		ifTrue: "Old code to simulate the closure value primitive on VMs that lack it."
			[newContext := self asContextWithSender: thisContext sender.
			newContext at: 1 put: firstArg.
			thisContext privSender: newContext]
		ifFalse: [self primitiveFailed]! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 7/7/2010 10:22'!
value: firstArg value: secondArg
	"Activate the receiver, creating a closure activation (MethodContext)
	 whose closure is the receiver and whose caller is the sender of this
	 message. Supply the arguments and copied values to the activation
	 as its arguments and copied temps. Primitive. Essential."
	<primitive: 203>
	| newContext |
	numArgs ~= 2 ifTrue:
		[self numArgsError: 2].
	false
		ifTrue: "Old code to simulate the closure value primitive on VMs that lack it."
			[newContext := self asContextWithSender: thisContext sender.
			newContext at: 1 put: firstArg.
			newContext at: 2 put: secondArg.
			thisContext privSender: newContext]
		ifFalse: [self primitiveFailed]! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 7/7/2010 10:22'!
value: firstArg value: secondArg value: thirdArg
	"Activate the receiver, creating a closure activation (MethodContext)
	 whose closure is the receiver and whose caller is the sender of this
	 message. Supply the arguments and copied values to the activation
	 as its arguments and copied temps. Primitive. Essential."
	<primitive: 204>
	| newContext |
	numArgs ~= 3 ifTrue:
		[self numArgsError: 3].
	false
		ifTrue: "Old code to simulate the closure value primitive on VMs that lack it."
			[newContext := self asContextWithSender: thisContext sender.
			newContext at: 1 put: firstArg.
			newContext at: 2 put: secondArg.
			newContext at: 3 put: thirdArg.
			thisContext privSender: newContext]
		ifFalse: [self primitiveFailed]! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 7/2/2010 10:31'!
value: firstArg value: secondArg value: thirdArg value: fourthArg
	"Activate the receiver, creating a closure activation (MethodContext)
	 whose closure is the receiver and whose caller is the sender of this
	 message. Supply the arguments and copied values to the activation
	 as its arguments and copied temps. Primitive. Essential."
	<primitive: 205>
	| newContext |
	numArgs ~= 4 ifTrue:
		[self numArgsError: 4].
	false
		ifTrue: "Old code to simulate the closure value primitive on VMs that lack it."
			[newContext := self asContextWithSender: thisContext sender.
			newContext at: 1 put: firstArg.
			newContext at: 2 put: secondArg.
			newContext at: 3 put: thirdArg.
			newContext at: 4 put: fourthArg.
			thisContext privSender: newContext]
		ifFalse: [self primitiveFailed]! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueAt: t1 
	| t2 t3 t4 |
	t2 := Processor activeProcess.
	t4 := t2 priority.
	t2 priority: t1.
	t3 := self
				ensure: [t2 priority: t4].
	t1 > t4
		ifTrue: [Processor yield].
	^ t3! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueNoContextSwitch
	<primitive: 221>
	numArgs ~= 0
		ifTrue: [self numArgsError: 0].
	self primitiveFailed! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueNoContextSwitch: t1 
	<primitive: 222>
	numArgs ~= 1
		ifTrue: [self numArgsError: 1].
	self primitiveFailed! !

!BlockClosure methodsFor: 'events-support' stamp: 'nice 9/21/2010 10:18'!
valueOtherwise: aBlock
	"Send the message and answer the return value"

	^self value! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueSupplyingAnswer: t1 
	^ (t1 isCollection
			and: [t1 isString not])
		ifTrue: [self valueSupplyingAnswers: {t1}]
		ifFalse: [self valueSupplyingAnswers: {{'*'. t1}}]! !

!BlockClosure methodsFor: 'evaluating' stamp: 'ul 8/2/2011 19:56'!
valueSupplyingAnswers: aListOfPairs
	"evaluate the block using a list of questions / answers that might be called upon to
	automatically respond to Object>>confirm: or FillInTheBlank requests"

	^self
		on: ProvideAnswerNotification
		do: [ :notification |
			| caption |
			caption := notification messageText withSeparatorsCompacted. "to remove new lines"
			aListOfPairs
				detect:  [ :each |
					caption = each first
						or: [ (caption includesSubstring: each first caseSensitive: false)
						or: [ each first match: caption ] ] ]
				ifFound: [ :answer | notification resume: answer second ]
				ifNone: [
					(ProvideAnswerNotification signal: notification messageText)
						ifNil: [ notification resume ]
						ifNotNil: [ :outerAnswer | notification resume: outerAnswer ] ] ]! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueSuppressingAllMessages
	^ self valueSuppressingMessages: #('*' )! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueSuppressingMessages: t1 
	^ self valueSuppressingMessages: t1 supplyingAnswers: #()! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueSuppressingMessages: t1 supplyingAnswers: t2 
	^ self valueSupplyingAnswers: t2
			, (t1
					collect: [:t3 | {t3. true}])! !

!BlockClosure methodsFor: 'exceptions' stamp: ''!
valueUninterruptably
	^ self
		ifCurtailed: [^ self]! !

!BlockClosure methodsFor: 'private' stamp: ''!
valueUnpreemptively
	| t1 t2 t3 |
	t1 := Processor activeProcess.
	t2 := t1 priority.
	t1 priority: Processor highestPriority.
	t3 := self
				ensure: [t1 priority: t2].
	Processor yield.
	^ t3! !

!BlockClosure methodsFor: 'evaluating' stamp: 'eem 7/2/2010 10:29'!
valueWithArguments: anArray
	"Activate the receiver, creating a closure activation (MethodContext)
	 whose closure is the receiver and whose caller is the sender of this
	 message. Supply the arguments in an anArray and copied values to
	 the activation as its arguments and copied temps. Primitive. Essential."
	<primitive: 206>
	| newContext |
	numArgs ~= anArray size ifTrue:
		[self numArgsError: anArray size].
	false
		ifTrue: "Old code to simulate the closure value primitive on VMs that lack it."
			[newContext := self asContextWithSender: thisContext sender.
			1 to: numArgs do:
				[:i| newContext at: i put: (anArray at: i)].
			thisContext privSender: newContext]
		ifFalse: [self primitiveFailed]! !

!BlockClosure methodsFor: 'events-support' stamp: 'nice 9/21/2010 10:18'!
valueWithArguments: anArray otherwise: aBlock

	^ self valueWithArguments: anArray! !

!BlockClosure methodsFor: 'events-support' stamp: 'nice 9/21/2010 10:25'!
valueWithEnoughArguments: anArray
	"call me with enough arguments from anArray"
	| args |
	(anArray size == self numArgs)
		ifTrue: [ ^self valueWithArguments: anArray ].

	args := Array new: self numArgs.
	args replaceFrom: 1
		to: (anArray size min: args size)
		with: anArray
		startingAt: 1.

	^ self valueWithArguments: args! !

!BlockClosure methodsFor: 'evaluating' stamp: 'ul 12/8/2010 02:47'!
valueWithExit 
	  self value: [ ^nil ]! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueWithPossibleArgs: t1 
	^ numArgs = 0
		ifTrue: [self value]
		ifFalse: [self
				valueWithArguments: (numArgs = t1 size
						ifTrue: [t1]
						ifFalse: [numArgs > t1 size
								ifTrue: [t1
										, (Array new: numArgs - t1 size)]
								ifFalse: [t1 copyFrom: 1 to: numArgs]])]! !

!BlockClosure methodsFor: 'evaluating' stamp: ''!
valueWithPossibleArgument: t1 
	| t2 |
	numArgs = 0
		ifTrue: [^ self value].
	numArgs = 1
		ifTrue: [^ self value: t1].
	t2 := Array new: numArgs.
	t2 at: 1 put: t1.
	^ self valueWithArguments: t2! !

!BlockClosure methodsFor: 'evaluating' stamp: 'ar 12/4/2012 20:36'!
valueWithin: aDuration onTimeout: timeoutBlock
	"Evaluate the receiver.
	If the evaluation does not complete in less than aDuration evaluate the timeoutBlock instead"

	| theProcess delay watchdog tag |

	aDuration <= Duration zero ifTrue: [^ timeoutBlock value ].

	"the block will be executed in the current process"
	theProcess := Processor activeProcess.
	delay := aDuration asDelay.
	tag := self.

	"make a watchdog process"
	watchdog := [
		delay wait. 	"wait for timeout or completion"
		theProcess ifNotNil:[ theProcess signalException: (TimedOut new tag: tag)] 
	] newProcess.

	"Watchdog needs to run at high priority to do its job (but not at timing priority)"
	watchdog priority: Processor timingPriority-1.

	"catch the timeout signal"
	^ [	watchdog resume.				"start up the watchdog"
		self ensure:[						"evaluate the receiver"
			theProcess := nil.				"it has completed, so ..."
			delay delaySemaphore signal.	"arrange for the watchdog to exit"
		]] on: TimedOut do: [ :e | 
			e tag == tag 
				ifTrue:[ timeoutBlock value ]
				ifFalse:[ e pass]].! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
whileFalse
	[self value] whileFalse.
	^ nil! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
whileFalse: t1 
	[self value]
		whileFalse: [t1 value].
	^ nil! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
whileNil: t1 
	[self value isNil]
		whileTrue: [t1 value].
	^ nil! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
whileNotNil: t1 
	[self value notNil]
		whileTrue: [t1 value].
	^ nil! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
whileTrue
	[self value] whileTrue.
	^ nil! !

!BlockClosure methodsFor: 'controlling' stamp: ''!
whileTrue: t1 
	[self value]
		whileTrue: [t1 value].
	^ nil! !

Object subclass: #Boolean
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!Boolean class methodsFor: 'instance creation' stamp: ''!
initializedInstance
	^ nil! !

!Boolean class methodsFor: 'instance creation' stamp: ''!
new
	self error: 'You may not create any more Booleans - this is two-valued logic'! !

!Boolean methodsFor: 'logical operations' stamp: ''!
& t1 
	self subclassResponsibility! !

!Boolean methodsFor: 'logical operations' stamp: 'nice 2/1/2011 21:50'!
==> aBlock
	"this is material implication, a ==> b, also known as:
			b if a 
			a implies b
			if a then b
			b is a consequence of a
			a therefore b (but note: 'it is raining therefore it is cloudy' is implication; 'it is autumn therefore the leaves are falling' is equivalence).
		
	Here is the truth table for material implication (view in a monospaced font):
	
	   p   |   q   |   p ==> q
	-------|-------|-------------
	   T   |   T   |      T
	   T   |   F   |      F
	   F   |   T   |      T
	   F   |   F   |      T
	"

	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
and: t1 
	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
and: t1 and: t2 
	self
		ifFalse: [^ false].
	t1 value
		ifFalse: [^ false].
	t2 value
		ifFalse: [^ false].
	^ true! !

!Boolean methodsFor: 'controlling' stamp: ''!
and: t1 and: t2 and: t3 
	self
		ifFalse: [^ false].
	t1 value
		ifFalse: [^ false].
	t2 value
		ifFalse: [^ false].
	t3 value
		ifFalse: [^ false].
	^ true! !

!Boolean methodsFor: 'controlling' stamp: ''!
and: t1 and: t2 and: t3 and: t4 
	self
		ifFalse: [^ false].
	t1 value
		ifFalse: [^ false].
	t2 value
		ifFalse: [^ false].
	t3 value
		ifFalse: [^ false].
	t4 value
		ifFalse: [^ false].
	^ true! !

!Boolean methodsFor: 'copying' stamp: ''!
clone
	^ self! !

!Boolean methodsFor: 'copying' stamp: ''!
deepCopy
	^ self! !

!Boolean methodsFor: 'logical operations' stamp: ''!
eqv: t1 
	^ self == t1! !

!Boolean methodsFor: 'controlling' stamp: ''!
ifFalse: t1 
	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
ifFalse: t1 ifTrue: t2 
	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
ifTrue: t1 
	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
ifTrue: t1 ifFalse: t2 
	self subclassResponsibility! !

!Boolean methodsFor: 'printing' stamp: ''!
isLiteral
	^ true! !

!Boolean methodsFor: 'logical operations' stamp: ''!
not
	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
or: t1 
	self subclassResponsibility! !

!Boolean methodsFor: 'controlling' stamp: ''!
or: t1 or: t2 
	self
		ifTrue: [^ true].
	t1 value
		ifTrue: [^ true].
	t2 value
		ifTrue: [^ true].
	^ false! !

!Boolean methodsFor: 'controlling' stamp: ''!
or: t1 or: t2 or: t3 
	self
		ifTrue: [^ true].
	t1 value
		ifTrue: [^ true].
	t2 value
		ifTrue: [^ true].
	t3 value
		ifTrue: [^ true].
	^ false! !

!Boolean methodsFor: 'controlling' stamp: ''!
or: t1 or: t2 or: t3 or: t4 
	self
		ifTrue: [^ true].
	t1 value
		ifTrue: [^ true].
	t2 value
		ifTrue: [^ true].
	t3 value
		ifTrue: [^ true].
	t4 value
		ifTrue: [^ true].
	^ false! !

!Boolean methodsFor: 'controlling' stamp: ''!
or: t1 or: t2 or: t3 or: t4 or: t5 
	self
		ifTrue: [^ true].
	t1 value
		ifTrue: [^ true].
	t2 value
		ifTrue: [^ true].
	t3 value
		ifTrue: [^ true].
	t4 value
		ifTrue: [^ true].
	t5 value
		ifTrue: [^ true].
	^ false! !

!Boolean methodsFor: 'copying' stamp: ''!
shallowCopy
	^ self! !

!Boolean methodsFor: 'printing' stamp: ''!
storeOn: t1 
	self printOn: t1! !

!Boolean methodsFor: 'copying' stamp: ''!
veryDeepCopyWith: t1 
	^ self! !

!Boolean methodsFor: 'logical operations' stamp: ''!
| t1 
	self subclassResponsibility! !

Boolean subclass: #False
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!False class methodsFor: 'as yet unclassified' stamp: ''!
initializedInstance
	^ false! !

!False methodsFor: 'logical operations' stamp: ''!
& t1 
	^ self! !

!False methodsFor: 'logical operations' stamp: 'nice 2/1/2011 21:50'!
==> aBlock
	^true! !

!False methodsFor: 'controlling' stamp: ''!
and: t1 
	^ self! !

!False methodsFor: 'printing' stamp: ''!
asBit
	^ 0! !

!False methodsFor: 'controlling' stamp: ''!
ifFalse: t1 
	^ t1 value! !

!False methodsFor: 'controlling' stamp: ''!
ifFalse: t1 ifTrue: t2 
	^ t1 value! !

!False methodsFor: 'controlling' stamp: ''!
ifTrue: t1 
	^ nil! !

!False methodsFor: 'controlling' stamp: ''!
ifTrue: t1 ifFalse: t2 
	^ t2 value! !

!False methodsFor: 'logical operations' stamp: ''!
not
	^ true! !

!False methodsFor: 'controlling' stamp: ''!
or: t1 
	^ t1 value! !

!False methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: 'false'! !

!False methodsFor: 'logical operations' stamp: ''!
xor: t1 
	^ t1! !

!False methodsFor: 'logical operations' stamp: ''!
| t1 
	^ t1! !

Object subclass: #Categorizer
	instanceVariableNames: 'categoryArray categoryStops elementArray'
	classVariableNames: 'Default NullCategory'
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!Categorizer commentStamp: 'nice 5/6/2010 21:10' prior: 0!
A Categorizer goal is to classify the elements of a collection into categories.
It is typically used to classify methods of class into categories (also named protocols in this case).

Instance Variables
	categoryArray:		<SequenceableCollection of: Object>
	categoryStops:		<SequenceableCollection of: Integer>
	elementArray:		<SequenceableCollection of: Object>

categoryArray
	- holds the list of categories.
	A category could be any Object but is generally a String or Symbol.
	Categories should be unique (categoryArray asSet size = categoryArray size)

categoryStops
	- holds the index of last element belonging to each category.
	There should be a category stop for each category (categoryStops size = categoryArray size).
	The categoryStops should be sorted (categoryStops sorted = categoryStops).
	A category stop equal to its predecessor (= 0 for the first category stop) denotes an empty category.

elementArray
	- holds the elements to be classified. The elements are sorted by category.

Class variables
	Default is the default category used to classify yet unclassified methods of a class
	NullCategory is the category to be displayed in a Browser for a class having no method.
!

Categorizer subclass: #BasicClassOrganizer
	instanceVariableNames: 'subject classComment commentStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!BasicClassOrganizer class methodsFor: 'constants' stamp: ''!
ambiguous
	^ #ambiguous! !

!BasicClassOrganizer class methodsFor: 'instance creation' stamp: ''!
class: t1 
	^ self new setSubject: t1! !

!BasicClassOrganizer class methodsFor: 'instance creation' stamp: ''!
class: t1 defaultList: t2 
	| t3 |
	t3 := self defaultList: t2.
	t3 setSubject: t1.
	^ t3! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
classComment
	classComment
		ifNil: [^ ''].
	^ classComment text
		ifNil: ['']! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
classComment: t1 
	(t1 isKindOf: RemoteString)
		ifTrue: [classComment := t1]
		ifFalse: [(t1
					ifNil: [true]
					ifNotNil: [t1 size = 0])
				ifTrue: [classComment := nil]
				ifFalse: [self error: 'use aClass classComment:'.
					classComment := RemoteString newString: t1 onFileNumber: 2]]! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
classComment: t1 stamp: t2 
	self commentStamp: t2.
	(t1 isKindOf: RemoteString)
		ifTrue: [classComment := t1]
		ifFalse: [(t1
					ifNil: [true]
					ifNotNil: [t1 size = 0])
				ifTrue: [classComment := nil]
				ifFalse: [self error: 'use aClass classComment:'.
					classComment := RemoteString newString: t1 onFileNumber: 2]]! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
commentRemoteStr
	^ classComment! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
commentStamp
	^ commentStamp! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
commentStamp: t1 
	commentStamp := t1! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
dateCommentLastSubmitted
	| t1 t2 |
	(t1 := self commentStamp) isEmptyOrNil
		ifTrue: [^ nil].
	t2 := t1 findBetweenSubStrs: ' 
'.
	^ t2 size > 1
		ifTrue: [[t2 second asDate]
				ifError: []]! !

!BasicClassOrganizer methodsFor: 'fileIn/Out' stamp: ''!
fileOutCommentOn: t1 moveSource: t2 toFile: t3 
	| t4 |
	classComment
		ifNotNil: [t1 cr.
			t4 := RemoteString
						newString: classComment text
						onFileNumber: t3
						toFile: t1.
			t2
				ifTrue: [classComment := t4]]! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
hasNoComment
	^ classComment == nil! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
hasSubject
	^ self subject notNil! !

!BasicClassOrganizer methodsFor: 'fileIn/Out' stamp: ''!
moveChangedCommentToFile: t1 numbered: t2 
	(classComment ~~ nil
			and: [classComment sourceFileNumber > 1])
		ifTrue: [self
				fileOutCommentOn: t1
				moveSource: true
				toFile: t2]! !

!BasicClassOrganizer methodsFor: 'fileIn/Out' stamp: ''!
objectForDataStream: t1 
	| t2 |
	self hasSubject
		ifTrue: [(t1 insideASegment
					and: [self subject isSystemDefined not])
				ifTrue: [^ self].
			(self subject isKindOf: Class)
				ifTrue: [t2 := DiskProxy
								global: self subject name
								selector: #organization
								args: #().
					t1 replace: self with: t2.
					^ t2]]! !

!BasicClassOrganizer methodsFor: 'fileIn/Out' stamp: ''!
putCommentOnFile: t1 numbered: t2 moveSource: t3 forClass: t4 
	| t5 |
	classComment
		ifNotNil: [t1 cr; nextPut: $!!.
			t5 := String
						streamContents: [:t6 | 
							t6 nextPutAll: t4 name;
								 nextPutAll: ' commentStamp: '.
							commentStamp
								ifNil: [commentStamp := '<historical>'].
							commentStamp storeOn: t6.
							t6 nextPutAll: ' prior: ';
								 nextPutAll: '0'].
			t1 nextChunkPut: t5.
			t4 organization
				fileOutCommentOn: t1
				moveSource: t3
				toFile: t2.
			t1 cr]! !

!BasicClassOrganizer methodsFor: 'private' stamp: ''!
setSubject: t1 
	subject := t1! !

!BasicClassOrganizer methodsFor: 'accessing' stamp: ''!
subject
	^ subject! !

BasicClassOrganizer subclass: #ClassOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!ClassOrganizer class methodsFor: 'class initialization' stamp: ''!
cleanUp: t1 
	t1
		ifTrue: [Smalltalk removeEmptyMessageCategories]! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'laza 12/8/2011 14:54'!
addCategory: catString before: nextCategory
	SystemChangeNotifier uniqueInstance
		doSilently: [super addCategory: catString before: nextCategory];
		protocolAdded: catString inClass: self subject! !

!ClassOrganizer methodsFor: 'accessing' stamp: ''!
changeFromCategorySpecs: t1 
	| t2 t3 |
	t2 := self elementCategoryDict.
	t3 := self categories copy.
	SystemChangeNotifier uniqueInstance
		doSilently: [super changeFromCategorySpecs: t1].
	self notifyOfChangedSelectorsOldDict: t2 newDict: self elementCategoryDict.
	self notifyOfChangedCategoriesFrom: t3 to: self categories! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'bf 4/12/2012 16:14'!
classify: element under: heading logged: aBoolean
	self classify: element under: heading suppressIfDefault: true logged: aBoolean
! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'bf 4/12/2012 16:13'!
classify: element under: heading suppressIfDefault: aBoolean
	self classify: element under: heading suppressIfDefault: aBoolean logged: false
! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'bf 4/12/2012 16:13'!
classify: element under: heading suppressIfDefault: aBoolean logged: logged 
	| oldCat newCat |
	oldCat := self categoryOfElement: element.
	SystemChangeNotifier uniqueInstance doSilently: [
		super classify: element under: heading suppressIfDefault: aBoolean].
	newCat := self categoryOfElement: element.
	self notifyOfChangedSelector: element from: oldCat to: newCat.
	logged ifTrue: [self logChangedSelector: element category: newCat].
! !

!ClassOrganizer methodsFor: 'private' stamp: 'bf 4/12/2012 15:31'!
logChangedSelector: element category: newCategory
	"make an entry in the changes to record the changed category"
	| method |	
	"if we do not have a changes file, the code below would try to make a new method"
	(subject == nil or: [SourceFiles == nil or: [(SourceFiles at: 2) == nil]]) ifTrue: [^self].
	method := subject compiledMethodAt: element ifAbsent: [^self].
	subject logMethodSource: (method getSourceFor: element in: subject)
		forMethodWithNode: (CompiledMethodWithNode method: method node: method) 
		inCategory: newCategory withStamp: method timeStamp notifying: nil.
! !

!ClassOrganizer methodsFor: 'private' stamp: 'bf 4/12/2012 15:02'!
logSelectorsInChangedCategory: newCategory
	"make an entry in the changes file for each method in the changed category"
	(self listAtCategoryNamed: newCategory) do: [:element |
		self logChangedSelector: element category: newCategory].
! !

!ClassOrganizer methodsFor: 'private' stamp: ''!
notifyOfChangedCategoriesFrom: t1 to: t2 
	(self hasSubject
			and: [t1 ~= t2])
		ifTrue: [SystemChangeNotifier uniqueInstance classReorganized: self subject]! !

!ClassOrganizer methodsFor: 'private' stamp: ''!
notifyOfChangedSelector: t1 from: t2 to: t3 
	(self hasSubject
			and: [t2 ~= t3])
		ifTrue: [self subject
				notifyOfRecategorizedSelector: t1
				from: t2
				to: t3]! !

!ClassOrganizer methodsFor: 'private' stamp: ''!
notifyOfChangedSelectorsOldDict: t1 newDict: t2 
	(t1 isNil
			and: [t2 isNil])
		ifTrue: [^ self].
	t1 isNil
		ifTrue: [t2
				keysAndValuesDo: [:t3 :t4 | self
						notifyOfChangedSelector: t3
						from: nil
						to: t4].
			^ self].
	t2 isNil
		ifTrue: [t1
				keysAndValuesDo: [:t3 :t4 | self
						notifyOfChangedSelector: t3
						from: t4
						to: nil].
			^ self].
	t1
		keysAndValuesDo: [:t3 :t4 | 
			| t5 |
			t5 := t2 at: t3.
			self
				notifyOfChangedSelector: t3
				from: t4
				to: t5]! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'laza 12/8/2011 14:53'!
removeCategory: cat 
	SystemChangeNotifier uniqueInstance
		doSilently: [super removeCategory: cat];
		protocolRemoved: cat inClass: self subject! !

!ClassOrganizer methodsFor: 'accessing' stamp: ''!
removeElement: t1 
	| t2 |
	t2 := self categoryOfElement: t1.
	SystemChangeNotifier uniqueInstance
		doSilently: [super removeElement: t1].
	self
		notifyOfChangedSelector: t1
		from: t2
		to: (self categoryOfElement: t1)! !

!ClassOrganizer methodsFor: 'accessing' stamp: ''!
removeEmptyCategories
	| t1 |
	t1 := self categories copy.
	SystemChangeNotifier uniqueInstance
		doSilently: [super removeEmptyCategories].
	self notifyOfChangedCategoriesFrom: t1 to: self categories! !

!ClassOrganizer methodsFor: 'accessing' stamp: 'bf 4/12/2012 15:03'!
renameCategory: oldCatString toBe: newCatString
	SystemChangeNotifier uniqueInstance
		doSilently: [super renameCategory: oldCatString toBe: newCatString];
		protocolRenamedFrom: oldCatString asSymbol to: newCatString asSymbol inClass: self subject.
	self logSelectorsInChangedCategory: newCatString.
! !

!ClassOrganizer methodsFor: 'accessing' stamp: ''!
setDefaultList: t1 
	| t2 t3 |
	t2 := self elementCategoryDict.
	t3 := self categories copy.
	SystemChangeNotifier uniqueInstance
		doSilently: [super setDefaultList: t1].
	self notifyOfChangedSelectorsOldDict: t2 newDict: self elementCategoryDict.
	self notifyOfChangedCategoriesFrom: t3 to: self categories! !

!ClassOrganizer methodsFor: 'accessing' stamp: ''!
sortCategories
	| t1 |
	t1 := self categories copy.
	SystemChangeNotifier uniqueInstance
		doSilently: [super sortCategories].
	self notifyOfChangedCategoriesFrom: t1 to: self categories! !

!Categorizer class methodsFor: 'class initialization' stamp: ''!
allCategory
	^ #'-- all --'! !

!Categorizer class methodsFor: 'class initialization' stamp: ''!
default
	^ Default! !

!Categorizer class methodsFor: 'instance creation' stamp: ''!
defaultList: t1 
	^ self new setDefaultList: t1! !

!Categorizer class methodsFor: 'documentation' stamp: ''!
documentation
	^ self! !

!Categorizer class methodsFor: 'class initialization' stamp: ''!
initialize
	Default := 'as yet unclassified' asSymbol.
	NullCategory := 'no messages' asSymbol! !

!Categorizer class methodsFor: 'class initialization' stamp: ''!
nullCategory
	^ NullCategory! !

!Categorizer class methodsFor: 'housekeeping' stamp: ''!
sortAllCategories
	self allSubInstances
		do: [:t1 | t1 sortCategories]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
addCategory: t1 
	^ self addCategory: t1 before: nil! !

!Categorizer methodsFor: 'accessing' stamp: ''!
addCategory: t1 before: t2 
	| t3 t4 |
	t4 := t1 asSymbol.
	(categoryArray indexOf: t4)
			> 0
		ifTrue: [^ self].
	t3 := categoryArray
				indexOf: t2
				ifAbsent: [categoryArray size + 1].
	categoryArray := categoryArray
				copyReplaceFrom: t3
				to: t3 - 1
				with: (Array with: t4).
	categoryStops := categoryStops
				copyReplaceFrom: t3
				to: t3 - 1
				with: (Array
						with: (t3 = 1
								ifTrue: [0]
								ifFalse: [categoryStops at: t3 - 1])).
	(t4 ~= Default
			and: [(self listAtCategoryNamed: Default) isEmpty])
		ifTrue: [self removeCategory: Default]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
allMethodSelectors
	^ elementArray copy sort! !

!Categorizer methodsFor: 'private' stamp: ''!
assertInvariant
	self assert: elementArray size = categoryStops last! !

!Categorizer methodsFor: 'private' stamp: ''!
basicRemoveElement: t1 
	| t2 t3 t4 t5 |
	t2 := 1.
	t3 := 0.
	t4 := 0.
	t5 := WriteStream
				on: (Array new: elementArray size).
	[(t3 := t3 + 1) <= elementArray size]
		whileTrue: [[t3
				> (categoryStops at: t2)]
				whileTrue: [categoryStops at: t2 put: t4.
					t2 := t2 + 1].
			(elementArray at: t3)
					= t1
				ifFalse: [t4 := t4 + 1.
					t5
						nextPut: (elementArray at: t3)]].
	[t2 <= categoryStops size]
		whileTrue: [categoryStops at: t2 put: t4.
			t2 := t2 + 1].
	elementArray := t5 contents.
	self assertInvariant! !

!Categorizer methodsFor: 'accessing' stamp: ''!
categories
	categoryArray isNil
		ifTrue: [^ nil].
	(categoryArray size = 1
			and: [categoryArray first = Default & (elementArray size = 0)])
		ifTrue: [^ Array with: NullCategory].
	^ categoryArray! !

!Categorizer methodsFor: 'accessing' stamp: ''!
categories: t1 
	| t2 t3 t4 t5 t6 t7 |
	t1 size < 2
		ifTrue: [^ self].
	t2 := Array new: t1 size.
	t3 := Array new: t1 size.
	t4 := Array new: 0.
	t7 := 0.
	1
		to: t1 size
		do: [:t8 | 
			t5 := (t1 at: t8) asSymbol.
			t6 := self listAtCategoryNamed: t5.
			t4 := t4 , t6.
			t2 at: t8 put: t5.
			t3 at: t8 put: (t7 := t7 + t6 size)].
	elementArray
		do: [:t10 | (t4 includes: t10)
				ifFalse: [^ self error: 'New categories must match old ones']].
	categoryArray := t2.
	categoryStops := t3.
	elementArray := t4! !

!Categorizer methodsFor: 'accessing' stamp: ''!
categoryOfElement: t1 
	| t2 |
	t2 := self numberOfCategoryOfElement: t1.
	t2 = 0
		ifTrue: [^ nil].
	^ categoryArray at: t2! !

!Categorizer methodsFor: 'accessing' stamp: ''!
changeFromCategorySpecs: t1 
	| t2 t3 t4 t5 t7 t8 t10 t12 t13 |
	t12 := elementArray asSet.
	t2 := Array new: t1 size.
	t3 := Array new: t1 size.
	t10 := 0.
	t13 := WriteStream
				on: (Array new: 16).
	1
		to: t1 size
		do: [:t6 | 
			t7 := t1 at: t6.
			t2 at: t6 put: t7 first asSymbol.
			t8 := t7 allButFirst
						collect: [:t14 | t14 isSymbol
								ifTrue: [t14]
								ifFalse: [t14 printString asSymbol]].
			t8 asSortedCollection
				do: [:t14 | (t12
							remove: t14
							ifAbsent: []) notNil
						ifTrue: [t13 nextPut: t14.
							t10 := t10 + 1]].
			t3 at: t6 put: t10].
	t12 := t12
				collect: [:t14 | Array
						with: (self categoryOfElement: t14)
						with: t14].
	t13 := t13 contents.
	categoryArray := t2.
	(t5 := categoryArray asSet) size = categoryArray size
		ifFalse: [t4 := categoryArray asOrderedCollection.
			t4 removeAll: categoryArray asSet asOrderedCollection.
			t4
				do: [:t14 | 
					| t15 t16 t17 |
					t15 := categoryArray indexOf: t14.
					t17 := 2.
					[t16 := (t14 , ' #' , t17 printString) asSymbol.
					t5 includes: t16]
						whileTrue: [t17 := t17 + 1].
					t5 add: t16.
					categoryArray at: t15 put: t16]].
	categoryStops := t3.
	elementArray := t13.
	t12
		do: [:t14 | self classify: t14 last under: t14 first]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
changeFromString: t1 
	| t2 |
	t2 := Scanner new scanTokens: t1.
	(t2 isEmpty
			and: [elementArray isEmpty])
		ifTrue: [^ self setDefaultList: Array new].
	^ self changeFromCategorySpecs: t2! !

!Categorizer methodsFor: 'accessing' stamp: ''!
classify: t1 under: t2 
	self
		classify: t1
		under: t2
		suppressIfDefault: true! !

!Categorizer methodsFor: 'accessing' stamp: ''!
classify: t1 under: t2 suppressIfDefault: t3 
	| t4 t5 t6 t7 |
	(t2 = NullCategory
			or: [t2 == nil])
		ifTrue: [t7 := Default]
		ifFalse: [t7 := t2 asSymbol].
	(t4 := self categoryOfElement: t1) = t7
		ifTrue: [^ self].
	t4 ~~ nil
		ifTrue: [(t3
					and: [t7 = Default])
				ifTrue: [^ self].
			self basicRemoveElement: t1].
	(categoryArray indexOf: t7)
			= 0
		ifTrue: [self addCategory: t7].
	t5 := categoryArray indexOf: t7.
	t6 := t5 > 1
				ifTrue: [categoryStops at: t5 - 1]
				ifFalse: [0].
	[(t6 := t6 + 1)
			<= (categoryStops at: t5)
		and: [t1
				>= (elementArray at: t6)]] whileTrue.
	elementArray := elementArray
				copyReplaceFrom: t6
				to: t6 - 1
				with: (Array with: t1).
	t5
		to: categoryArray size
		do: [:t8 | categoryStops at: t8 put: (categoryStops at: t8)
					+ 1].
	((categoryArray includes: Default)
			and: [(self listAtCategoryNamed: Default) size = 0])
		ifTrue: [self removeCategory: Default].
	self assertInvariant! !

!Categorizer methodsFor: 'accessing' stamp: ''!
classifyAll: t1 under: t2 
	t1
		do: [:t3 | self classify: t3 under: t2]! !

!Categorizer methodsFor: 'private' stamp: ''!
elementArray
	^ elementArray! !

!Categorizer methodsFor: 'accessing' stamp: ''!
elementCategoryDict
	| t1 t2 |
	elementArray isNil
		ifTrue: [^ nil].
	t1 := Dictionary new: elementArray size.
	1
		to: categoryStops size
		do: [:t5 | 
			t2 := self firstIndexOfCategoryNumber: t5.
			t2
				to: (self lastIndexOfCategoryNumber: t5)
				do: [:t4 | t1
						at: (elementArray at: t4)
						put: (categoryArray at: t5)]].
	^ t1! !

!Categorizer methodsFor: 'private' stamp: ''!
firstIndexOfCategoryNumber: t1 
	t1 < 1
		ifTrue: [^ nil].
	^ t1 > 1
		ifTrue: [(categoryStops at: t1 - 1)
				+ 1]
		ifFalse: [1]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
isEmptyCategoryNamed: t1 
	| t2 |
	t2 := categoryArray
				indexOf: t1
				ifAbsent: [^ false].
	^ self isEmptyCategoryNumber: t2! !

!Categorizer methodsFor: 'accessing' stamp: ''!
isEmptyCategoryNumber: t1 
	| t2 t3 |
	(t1 < 1
			or: [t1 > categoryStops size])
		ifTrue: [^ true].
	t2 := self firstIndexOfCategoryNumber: t1.
	t3 := self lastIndexOfCategoryNumber: t1.
	^ t2 > t3! !

!Categorizer methodsFor: 'private' stamp: ''!
lastIndexOfCategoryNumber: t1 
	t1 > categoryStops size
		ifTrue: [^ nil].
	^ categoryStops at: t1! !

!Categorizer methodsFor: 'accessing' stamp: ''!
listAtCategoryNamed: t1 
	| t2 |
	t2 := categoryArray
				indexOf: t1
				ifAbsent: [^ Array new].
	^ self listAtCategoryNumber: t2! !

!Categorizer methodsFor: 'accessing' stamp: ''!
listAtCategoryNumber: t1 
	| t2 t3 |
	(t1 < 1
			or: [t1 > categoryStops size])
		ifTrue: [^ nil].
	t2 := self firstIndexOfCategoryNumber: t1.
	t3 := self lastIndexOfCategoryNumber: t1.
	^ elementArray copyFrom: t2 to: t3! !

!Categorizer methodsFor: 'accessing' stamp: ''!
numberOfCategoryOfElement: t1 
	| t2 t3 |
	t2 := 1.
	t3 := 0.
	[(t3 := t3 + 1) <= elementArray size]
		whileTrue: [[t3
				> (categoryStops at: t2)]
				whileTrue: [t2 := t2 + 1].
			t1
					= (elementArray at: t3)
				ifTrue: [^ t2]].
	^ 0! !

!Categorizer methodsFor: 'printing' stamp: ''!
printOn: t1 
	| t2 |
	t2 := 1.
	1
		to: categoryArray size
		do: [:t3 | 
			t1 nextPut: $(.
			(categoryArray at: t3) asString printOn: t1.
			[t2
				<= (categoryStops at: t3)]
				whileTrue: [t1 space;
						nextPutAll: (elementArray at: t2).
					t2 := t2 + 1].
			t1 nextPut: $);
				 cr]! !

!Categorizer methodsFor: 'printing' stamp: ''!
printOnStream: t1 
	| t2 |
	t2 := 1.
	1
		to: categoryArray size
		do: [:t3 | 
			t1 print: '(';
				
				write: (categoryArray at: t3).
			[t2
				<= (categoryStops at: t3)]
				whileTrue: [t1 print: ' ';
						
						write: (elementArray at: t2).
					t2 := t2 + 1].
			t1 print: ')'.
			t1 cr]! !

!Categorizer methodsFor: 'printing' stamp: ''!
printString
	^ String
		streamContents: [:t1 | self printOn: t1]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
removeCategory: t1 
	| t2 t3 |
	t2 := categoryArray
				indexOf: t1
				ifAbsent: [^ self].
	t3 := t2 = 1
				ifTrue: [0]
				ifFalse: [categoryStops at: t2 - 1].
	(categoryStops at: t2)
			- t3 > 0
		ifTrue: [^ self error: 'cannot remove non-empty category'].
	categoryArray := categoryArray
				copyReplaceFrom: t2
				to: t2
				with: Array new.
	categoryStops := categoryStops
				copyReplaceFrom: t2
				to: t2
				with: Array new.
	categoryArray size = 0
		ifTrue: [categoryArray := Array with: Default.
			categoryStops := Array with: 0]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
removeElement: t1 
	^ self basicRemoveElement: t1! !

!Categorizer methodsFor: 'accessing' stamp: ''!
removeEmptyCategories
	| t1 t2 t3 t4 |
	t3 := WriteStream
				on: (Array new: 16).
	t4 := WriteStream
				on: (Array new: 16).
	t2 := t1 := 0.
	[(t1 := t1 + 1) <= categoryArray size]
		whileTrue: [(categoryStops at: t1)
					> t2
				ifTrue: [t3
						nextPut: (categoryArray at: t1).
					t4 nextPut: (t2 := categoryStops at: t1)]].
	categoryArray := t3 contents.
	categoryStops := t4 contents.
	categoryArray size = 0
		ifTrue: [categoryArray := Array with: Default.
			categoryStops := Array with: 0]! !

!Categorizer methodsFor: 'accessing' stamp: ''!
renameCategory: t1 toBe: t2 
	| t3 t4 t5 |
	t4 := t1 asSymbol.
	t5 := t2 asSymbol.
	(categoryArray indexOf: t5)
			> 0
		ifTrue: [^ self].
	(t3 := categoryArray indexOf: t4) = 0
		ifTrue: [^ self].
	categoryArray := categoryArray copy.
	categoryArray at: t3 put: t5! !

!Categorizer methodsFor: 'fileIn/Out' stamp: ''!
scanFrom: t1 
	self changeFromString: t1 nextChunk.
	t1 skipStyleChunk! !

!Categorizer methodsFor: 'private' stamp: ''!
setDefaultList: t1 
	categoryArray := Array with: Default.
	categoryStops := Array with: t1 size.
	elementArray := t1 asArray! !

!Categorizer methodsFor: 'accessing' stamp: 'nice 8/19/2010 21:26'!
sortCategories
	| privateCategories publicCategories newCategories |

	privateCategories := self categories select:
		[:one | (one findString: 'private' startingAt: 1 caseSensitive: false) = 1].
	publicCategories := self categories copyWithoutAll: privateCategories.
	newCategories := publicCategories asArray sort , privateCategories asArray sort.
	self categories: newCategories! !

Object subclass: #ClassBuilder
	instanceVariableNames: 'environ classMap instVarMap progress maxClassIndex currentClassIndex'
	classVariableNames: 'QuietMode'
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!ClassBuilder class methodsFor: 'accessing' stamp: ''!
beSilent: t1 
	QuietMode := t1! !

!ClassBuilder class methodsFor: 'accessing' stamp: ''!
beSilentDuring: t1 
	| t2 t3 |
	t2 := self isSilent.
	self beSilent: true.
	t3 := t1 value.
	self beSilent: t2.
	^ t3! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
checkClassHierarchyConsistency
	Utilities
		informUserDuring: [:t1 | self checkClassHierarchyConsistency: t1]! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
checkClassHierarchyConsistency: t1 
	| t2 |
	Transcript cr; show: 'Start checking the class hierarchy...'.
	Smalltalk garbageCollect.
	t2 := Metaclass allInstances.
	t2
		keysAndValuesDo: [:t3 :t4 | 
			t1 value: 'Validating class hierarchy ' , (t3 * 100 // t2 size) printString , '%'.
			t4 allInstances
				do: [:t5 | self checkClassHierarchyConsistencyFor: t5].
			self checkClassHierarchyConsistencyFor: t4].
	Transcript show: 'OK'! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
checkClassHierarchyConsistencyFor: t1 
	| t2 |
	t2 := t1 superclass.
	(t2 subclasses includes: t1)
			= t1 isObsolete
		ifTrue: [self error: 'Something wrong!!'].
	t2
		ifNil: [^ self].
	(t2 obsoleteSubclasses includes: t1)
			= t1 isObsolete
		ifFalse: [self error: 'Something wrong!!'].
	t1 subclasses
		do: [:t3 | 
			t3 isObsolete
				ifTrue: [self error: 'Something wrong!!'].
			t3 superclass == t1
				ifFalse: [self error: 'Something wrong!!']].
	t1 obsoleteSubclasses
		do: [:t3 | 
			t3 isObsolete
				ifFalse: [self error: 'Something wrong!!'].
			t3 superclass == t1
				ifFalse: [self error: 'Something wrong!!']]! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
cleanupAndCheckClassHierarchy
	Utilities
		informUserDuring: [:t1 | self cleanupAndCheckClassHierarchy: t1]! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
cleanupAndCheckClassHierarchy: t1 
	Transcript cr; show: '*** Before cleaning up ***'.
	self countReallyObsoleteClassesAndMetaclasses.
	self cleanupClassHierarchy: t1.
	self checkClassHierarchyConsistency: t1.
	Transcript cr; cr; show: '*** After cleaning up ***'.
	self countReallyObsoleteClassesAndMetaclasses! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
cleanupClassHierarchy
	Utilities
		informUserDuring: [:t1 | self cleanupClassHierarchy: t1]! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
cleanupClassHierarchy: t1 
	| t2 |
	Transcript cr; show: 'Start fixing the class hierarchy and cleaning up...'.
	Smalltalk garbageCollect.
	t2 := Metaclass allInstances.
	t2
		keysAndValuesDo: [:t3 :t4 | 
			t1 value: 'Fixing  class hierarchy ' , (t3 * 100 // t2 size) printString , '%'.
			t4 allInstances
				do: [:t5 | self cleanupClassHierarchyFor: t5].
			self cleanupClassHierarchyFor: t4].
	Transcript show: 'DONE'! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
cleanupClassHierarchyFor: t1 
	| t2 t3 |
	t3 := t1 superclass.
	(self isReallyObsolete: t1)
		ifTrue: [t2 := t1 name asString.
			Smalltalk globals keys
				do: [:t4 | (t4 asString = t2
							and: [(Smalltalk at: t4)
									== t1])
						ifTrue: [Smalltalk globals removeKey: t4]].
			(t1 name asString beginsWith: 'AnObsolete')
				ifFalse: [t1 obsolete].
			t1 isObsolete
				ifFalse: [self error: 'Something wrong!!'].
			t3
				ifNil: [self error: 'Obsolete subclasses of nil cannot be stored'].
			(t3 obsoleteSubclasses includes: t1)
				ifFalse: [t3 addObsoleteSubclass: t1]]
		ifFalse: [t3
				ifNil: [t3 := Class].
			t3 removeObsoleteSubclass: t1].
	t1 obsoleteSubclasses
		do: [:t4 | t4 superclass == t1
				ifFalse: [t1 removeObsoleteSubclass: t4]]! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
countReallyObsoleteClassesAndMetaclasses
	| t1 t2 |
	Smalltalk garbageCollect.
	t1 := self reallyObsoleteMetaclasses size.
	Transcript cr; show: 'Really obsolete metaclasses: ' , t1 printString.
	t2 := self reallyObsoleteClasses size.
	Transcript cr; show: 'Really obsolete classes: ' , t2 printString; cr.
	t1 ~= t2
		ifTrue: [self error: 'Serious metalevel inconsistency!!!!']! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
isReallyObsolete: t1 
	^ t1 isObsolete
		or: [(t1 superclass subclasses includes: t1) not]! !

!ClassBuilder class methodsFor: 'accessing' stamp: ''!
isSilent
	^ QuietMode == true! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
reallyObsoleteClasses
	| t1 |
	t1 := OrderedCollection new.
	Metaclass allInstances
		do: [:t2 | t2 allInstances
				do: [:t3 | (self isReallyObsolete: t3)
						ifTrue: [t1 add: t3]]].
	^ t1! !

!ClassBuilder class methodsFor: 'cleanup obsolete classes' stamp: ''!
reallyObsoleteMetaclasses
	^ Metaclass allInstances
		select: [:t1 | self isReallyObsolete: t1]! !

!ClassBuilder methodsFor: 'public' stamp: ''!
class: t1 instanceVariableNames: t2 
	t1 isMeta
		ifFalse: [^ self error: t1 name , 'is not a Metaclass'].
	^ self
		class: t1
		instanceVariableNames: t2
		unsafe: false! !

!ClassBuilder methodsFor: 'class definition' stamp: ''!
class: t1 instanceVariableNames: t2 unsafe: t3 
	| t4 t5 t6 t7 |
	environ := t1 environment.
	t4 := Scanner new scanFieldNames: t2.
	t3
		ifFalse: [(self
					validateInstvars: t4
					from: t1
					forSuper: t1 superclass)
				ifFalse: [^ nil].
			(self
					validateSubclassFormat: t1 typeOfClass
					from: t1
					forSuper: t1 superclass
					extra: t4 size)
				ifFalse: [^ nil]].
	t6 := self
				needsSubclassOf: t1 superclass
				type: t1 typeOfClass
				instanceVariables: t4
				from: t1.
	t6
		ifNil: [^ nil].
	t6
		ifFalse: [^ t1].
	t7 := t1 copy.
	t5 := self
				newSubclassOf: t1 superclass
				type: t1 typeOfClass
				instanceVariables: t4
				from: t1.
	t5 := self
				recompile: false
				from: t1
				to: t5
				mutate: false.
	self doneCompiling: t5.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t7 to: t5.
	^ t5! !

!ClassBuilder methodsFor: 'class format' stamp: 'eem 4/18/2012 10:37'!
computeFormat: type instSize: newInstSize forSuper: newSuper ccIndex: ccIndex
	"Compute the new format for making oldClass a subclass of newSuper.
	Return the format or nil if there is any problem."
	| instSize isVar isWords isPointers isWeak |
	type == #compiledMethod ifTrue:
		[^(CompiledMethod format
			bitClear: (16r1F bitShift: 11))
				bitOr: (ccIndex bitShift: 11)].
	instSize := newInstSize + (newSuper ifNil:[0] ifNotNil:[newSuper instSize]).
	instSize > 254 ifTrue:
		[self error: 'Class has too many instance variables (', instSize printString,')'.
		^nil].
	type == #normal ifTrue:[isVar := isWeak := false. isWords := isPointers := true].
	type == #bytes ifTrue:[isVar := true. isWords := isPointers := isWeak := false].
	type == #words ifTrue:[isVar := isWords := true. isPointers := isWeak := false].
	type == #variable ifTrue:[isVar := isPointers := isWords := true. isWeak := false].
	type == #weak ifTrue:[isVar := isWeak := isWords := isPointers := true].
	(isPointers not and:[instSize > 0]) ifTrue:
		[self error:'A non-pointer class cannot have instance variables'.
		^nil].
	^(self format: instSize 
		variable: isVar 
		words: isWords 
		pointers: isPointers 
		weak: isWeak) + (ccIndex bitShift: 11).! !

!ClassBuilder methodsFor: 'initialize' stamp: ''!
doneCompiling: t1 
	t1 doneCompiling.
	Behavior flushObsoleteSubclasses! !

!ClassBuilder methodsFor: 'class format' stamp: ''!
format: t1 variable: t2 words: t3 pointers: t4 weak: t5 
	| t6 t7 t8 t9 |
	self flag: #instSizeChange.
	t8 := t1 + 1 // 64.
	t6 := 0.
	t7 := t5
				ifTrue: [4]
				ifFalse: [t4
						ifTrue: [t2
								ifTrue: [t1 > 0
										ifTrue: [3]
										ifFalse: [2]]
								ifFalse: [t1 > 0
										ifTrue: [1]
										ifFalse: [0]]]
						ifFalse: [t3
								ifTrue: [6]
								ifFalse: [8]]].
	t9 := t8.
	t9 := (t9 bitShift: 5)
				+ t6.
	t9 := (t9 bitShift: 4)
				+ t7.
	t9 := (t9 bitShift: 6)
				+ (t1 + 1 \\ 64).
	t9 := t9 bitShift: 1.
	^ t9! !

!ClassBuilder methodsFor: 'private' stamp: ''!
informUserDuring: t1 
	self class isSilent
		ifTrue: [^ t1 value].
	Utilities
		informUserDuring: [:t2 | 
			progress := t2.
			t1 value].
	progress := nil! !

!ClassBuilder methodsFor: 'initialize' stamp: ''!
initialize
	environ := Smalltalk.
	instVarMap := IdentityDictionary new! !

!ClassBuilder methodsFor: 'public' stamp: ''!
moveInstVarNamed: t1 from: t2 to: t3 after: t4 
	(t2 instVarNames includes: t1)
		ifFalse: [^ self error: t1 , ' is not an instance variable of ' , t2 name].
	(t4 isNil
			or: [t3 instVarNames includes: t4])
		ifFalse: [^ self error: t4 , 'is not an instance variable of' , t3 name].
	(t2 inheritsFrom: t3)
		ifTrue: [(self
					validateClass: t2
					forMoving: t1
					upTo: t3)
				ifFalse: [^ false]].
	(t3 inheritsFrom: t2)
		ifTrue: [(self
					validateClass: t2
					forMoving: t1
					downTo: t3)
				ifFalse: [^ false]].
	^ self
		silentlyMoveInstVarNamed: t1
		from: t2
		to: t3
		after: t4! !

!ClassBuilder methodsFor: 'class mutation' stamp: ''!
mutate: t1 to: t2 
	self showProgressFor: t1.
	t1 subclasses
		do: [:t3 | 
			| t4 |
			t4 := self reshapeClass: t3 toSuper: t2.
			self mutate: t3 to: t4].
	t1 obsoleteSubclasses
		do: [:t3 | | t4 | t3
				ifNotNil: [t4 := self reshapeClass: t3 toSuper: t2.
					self mutate: t3 to: t4]].
	self update: t1 to: t2.
	^ t2! !

!ClassBuilder methodsFor: 'class definition' stamp: ''!
name: t1 inEnvironment: t2 subclassOf: t3 type: t4 instanceVariableNames: t5 classVariableNames: t6 poolDictionaries: t7 category: t8 
	^ self
		name: t1
		inEnvironment: t2
		subclassOf: t3
		type: t4
		instanceVariableNames: t5
		classVariableNames: t6
		poolDictionaries: t7
		category: t8
		unsafe: false! !

!ClassBuilder methodsFor: 'class definition' stamp: 'laza 12/14/2011 10:23'!
name: className inEnvironment: env subclassOf: newSuper type: type instanceVariableNames: instVarString classVariableNames: classVarString poolDictionaries: poolString category: category unsafe: unsafe
	"Define a new class in the given environment.
	If unsafe is true do not run any validation checks.
	This facility is provided to implement important system changes."
	| oldClass instVars classVars copyOfOldClass newClass |
 
	environ := env.
	instVars := Scanner new scanFieldNames: instVarString.
	classVars := (Scanner new scanFieldNames: classVarString) collect: [:x | x asSymbol].

	"Validate the proposed name"
	unsafe ifFalse:[(self validateClassName: className) ifFalse:[^nil]].
	oldClass := env at: className ifAbsent:[nil].
	oldClass isBehavior 
		ifFalse: [oldClass := nil]  "Already checked in #validateClassName:"
		ifTrue: [
			copyOfOldClass := oldClass copy.
			copyOfOldClass superclass addSubclass: copyOfOldClass].
	
	
	[ | newCategory needNew force organization oldCategory |
	unsafe ifFalse:[
		"Run validation checks so we know that we have a good chance for recompilation"
		(self validateSuperclass: newSuper forSubclass: oldClass) ifFalse:[^nil].
		(self validateInstvars: instVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
		(self validateClassvars: classVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
		(self validateSubclassFormat: type from: oldClass forSuper: newSuper extra: instVars size) ifFalse:[^nil]].

	"See if we need a new subclass"
	needNew := self needsSubclassOf: newSuper type: type instanceVariables: instVars from: oldClass.
	needNew == nil ifTrue:[^nil]. "some error"

	(needNew and:[unsafe not]) ifTrue:[
		"Make sure we don't redefine any dangerous classes"
		(self tooDangerousClasses includes: oldClass name) ifTrue:[
			self error: oldClass name, ' cannot be changed'.
		].
		"Check if the receiver should not be redefined"
		(oldClass ~~ nil and:[oldClass shouldNotBeRedefined]) ifTrue:[
			self notify: oldClass name asText allBold, 
						' should not be redefined. \Proceed to store over it.' withCRs]].

	needNew ifTrue:[
		"Create the new class"
		newClass := self 
			newSubclassOf: newSuper 
			type: type 
			instanceVariables: instVars
			from: oldClass.
		newClass == nil ifTrue:[^nil]. "Some error"
		newClass setName: className.
	] ifFalse:[
		"Reuse the old class"
		newClass := oldClass.
	].

	"Install the class variables and pool dictionaries... "
	force := (newClass declare: classVarString) | (newClass sharing: poolString).

	"... classify ..."
	newCategory := category asSymbol.
	organization := environ ifNotNil:[environ organization].
	oldClass isNil ifFalse: [oldCategory := (organization categoryOfElement: oldClass name) asSymbol].
	organization classify: newClass name under: newCategory suppressIfDefault: true.
	newClass environment: environ.

	"... recompile ..."
	newClass := self recompile: force from: oldClass to: newClass mutate: false.

	"... export if not yet done ..."
	(environ at: newClass name ifAbsent:[nil]) == newClass ifFalse:[
		[environ at: newClass name put: newClass]
			on: AttemptToWriteReadOnlyGlobal do:[:ex| ex resume: true].
		environ flushClassNameCache.
	].


	newClass doneCompiling.
	"... notify interested clients ..."
	oldClass isNil ifTrue: [
		SystemChangeNotifier uniqueInstance classAdded: newClass inCategory: newCategory.
		^ newClass].
	newCategory ~= oldCategory 
		ifTrue: [SystemChangeNotifier uniqueInstance class: newClass recategorizedFrom: oldCategory to: category]
		ifFalse: [SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: copyOfOldClass to: newClass.].
] ensure: 
		[copyOfOldClass ifNotNil: [copyOfOldClass superclass removeSubclass: copyOfOldClass].
		Behavior flushObsoleteSubclasses.
		].
	^newClass! !

!ClassBuilder methodsFor: 'class definition' stamp: ''!
needsSubclassOf: t1 type: t2 instanceVariables: t3 from: t4 
	| t5 |
	t5 := self
				computeFormat: t2
				instSize: t3 size
				forSuper: t1
				ccIndex: (t4
						ifNil: [0]
						ifNotNil: [t4 indexIfCompact]).
	t5
		ifNil: [^ nil].
	t4
		ifNil: [^ true].
	t1 == t4 superclass
		ifFalse: [^ true].
	t5 = t4 format
		ifFalse: [^ true].
	t3 = t4 instVarNames
		ifFalse: [^ true].
	^ false! !

!ClassBuilder methodsFor: 'class definition' stamp: ''!
newSubclassOf: t1 type: t2 instanceVariables: t3 from: t4 
	| t5 t6 |
	t5 := self
				computeFormat: t2
				instSize: t3 size
				forSuper: t1
				ccIndex: (t4
						ifNil: [0]
						ifNotNil: [t4 indexIfCompact]).
	t5
		ifNil: [^ nil].
	(t4
			ifNil: [true]
			ifNotNil: [t4 isMeta not])
		ifTrue: [t6 := self privateNewSubclassOf: t1 from: t4]
		ifFalse: [t6 := t4 clone].
	t6
		superclass: t1
		methodDictionary: MethodDictionary new
		format: t5;
		 setInstVarNames: t3.
	t4
		ifNotNil: [t6 organization: t4 organization.
			t4 hasMethods
				ifTrue: [t6 compileAllFrom: t4].
			t4 hasTraitComposition
				ifTrue: [t6 setTraitComposition: t4 traitComposition copyTraitExpression].
			t4 class hasTraitComposition
				ifTrue: [t6 class setTraitComposition: t4 class traitComposition copyTraitExpression].
			self recordClass: t4 replacedBy: t6].
	(t4
			ifNil: [true]
			ifNotNil: [t4 isObsolete not])
		ifTrue: [t1 addSubclass: t6]
		ifFalse: [t1 addObsoleteSubclass: t6].
	^ t6! !

!ClassBuilder methodsFor: 'private' stamp: ''!
privateNewSubclassOf: t1 
	| t2 t3 |
	t2 := t1
				ifNil: [Class]
				ifNotNil: [t1 class].
	t3 := Metaclass new.
	t3
		superclass: t2
		methodDictionary: MethodDictionary new
		format: t2 format.
	^ t3 new! !

!ClassBuilder methodsFor: 'private' stamp: ''!
privateNewSubclassOf: t1 from: t2 
	| t3 t4 t5 |
	t2
		ifNil: [^ self privateNewSubclassOf: t1].
	t3 := t1
				ifNil: [Class]
				ifNotNil: [t1 class].
	t4 := t2 class.
	t5 := t4 clone.
	t5
		superclass: t3
		methodDictionary: MethodDictionary new
		format: (self
				computeFormat: t4 typeOfClass
				instSize: t4 instVarNames size
				forSuper: t3
				ccIndex: 0);
		 setInstVarNames: t4 instVarNames;
		 organization: t4 organization.
	t4 hasMethods
		ifTrue: [t5 compileAllFrom: t4].
	self recordClass: t4 replacedBy: t5.
	^ t5 adoptInstance: t2 from: t4! !

!ClassBuilder methodsFor: 'class definition' stamp: ''!
recompile: t1 from: t2 to: t3 mutate: t4 
	t2
		ifNil: [^ t3].
	(t3 == t2
			and: [t1 not
					and: [t4 not]])
		ifTrue: [^ t3].
	currentClassIndex := 0.
	maxClassIndex := t2 withAllSubclasses size.
	(t2 == t3
			and: [t4 not])
		ifTrue: [self
				informUserDuring: [t3 isSystemDefined
						ifFalse: [progress := nil].
					t3
						withAllSubclassesDo: [:t5 | 
							self showProgressFor: t5.
							t5 compileAll]].
			^ t3].
	self
		informUserDuring: [t3 isSystemDefined
				ifFalse: [progress := nil].
			self mutate: t2 to: t3].
	^ t2! !

!ClassBuilder methodsFor: 'private' stamp: ''!
recordClass: t1 replacedBy: t2 
	(instVarMap includesKey: t1 name)
		ifTrue: [SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t1 to: t2]! !

!ClassBuilder methodsFor: 'private' stamp: ''!
reservedNames
	^ #('self' 'super' 'thisContext' 'true' 'false' 'nil' #self #super #thisContext #true #false #nil )! !

!ClassBuilder methodsFor: 'class mutation' stamp: ''!
reshapeClass: t1 toSuper: t2 
	| t3 |
	t1 becomeUncompact.
	t3 := instVarMap
				at: t1 name
				ifAbsent: [t1 instVarNames].
	^ self
		newSubclassOf: t2
		type: t1 typeOfClass
		instanceVariables: t3
		from: t1! !

!ClassBuilder methodsFor: 'private' stamp: ''!
showProgressFor: t1 
	progress
		ifNil: [^ self].
	t1 isObsolete
		ifTrue: [^ self].
	currentClassIndex := currentClassIndex + 1.
	(t1 hasMethods
			and: [t1 wantsRecompilationProgressReported])
		ifTrue: [progress value: 'Recompiling ' , t1 name , ' (' , currentClassIndex printString , '/' , maxClassIndex printString , ')']! !

!ClassBuilder methodsFor: 'class definition' stamp: ''!
silentlyMoveInstVarNamed: t1 from: t2 to: t3 after: t4 
	| t5 t6 t7 t8 t9 t10 |
	t9 := t2 copy.
	t10 := t3 copy.
	t5 := t2 instVarNames copyWithout: t1.
	t2 == t3
		ifTrue: [t6 := t5]
		ifFalse: [t6 := t3 instVarNames].
	t7 := t6 indexOf: t4.
	t6 := (t6 copyFrom: 1 to: t7)
				, (Array with: t1)
				, (t6 copyFrom: t7 + 1 to: t6 size).
	instVarMap at: t2 name put: t5.
	instVarMap at: t3 name put: t6.
	(t2 inheritsFrom: t3)
		ifTrue: [t8 := self reshapeClass: t3 toSuper: t3 superclass.
			self
				recompile: false
				from: t3
				to: t8
				mutate: true]
		ifFalse: [(t3 inheritsFrom: t2)
				ifTrue: [t8 := self reshapeClass: t2 toSuper: t2 superclass.
					self
						recompile: false
						from: t2
						to: t8
						mutate: true]
				ifFalse: [t2 == t3
						ifFalse: [t8 := self reshapeClass: t3 toSuper: t3 superclass.
							self
								recompile: false
								from: t3
								to: t8
								mutate: true].
					t8 := self reshapeClass: t2 toSuper: t2 superclass.
					self
						recompile: false
						from: t2
						to: t8
						mutate: true]].
	self doneCompiling: t2.
	self doneCompiling: t3.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t9 to: t2.
	SystemChangeNotifier uniqueInstance classDefinitionChangedFrom: t10 to: t3! !

!ClassBuilder methodsFor: 'public' stamp: ''!
superclass: t1 subclass: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	^ self
		name: t2
		inEnvironment: t1 environment
		subclassOf: t1
		type: t1 typeOfClass
		instanceVariableNames: t3
		classVariableNames: t4
		poolDictionaries: t5
		category: t6! !

!ClassBuilder methodsFor: 'public' stamp: ''!
superclass: t1 variableByteSubclass: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	| t7 t8 |
	t1 instSize > 0
		ifTrue: [^ self error: 'cannot make a byte subclass of a class with named fields'].
	(t1 isVariable
			and: [t1 isWords])
		ifTrue: [^ self error: 'cannot make a byte subclass of a class with word fields'].
	(t1 isVariable
			and: [t1 isPointers])
		ifTrue: [^ self error: 'cannot make a byte subclass of a class with pointer fields'].
	t7 := t1 environment
				at: t2
				ifAbsent: [].
	t8 := (t7 notNil
					and: [t7 typeOfClass == #compiledMethod])
				ifTrue: [#compiledMethod]
				ifFalse: [#bytes].
	^ self
		name: t2
		inEnvironment: t1 environment
		subclassOf: t1
		type: t8
		instanceVariableNames: t3
		classVariableNames: t4
		poolDictionaries: t5
		category: t6! !

!ClassBuilder methodsFor: 'public' stamp: ''!
superclass: t1 variableSubclass: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	t1 isBits
		ifTrue: [^ self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^ self
		name: t2
		inEnvironment: t1 environment
		subclassOf: t1
		type: #variable
		instanceVariableNames: t3
		classVariableNames: t4
		poolDictionaries: t5
		category: t6! !

!ClassBuilder methodsFor: 'public' stamp: ''!
superclass: t1 variableWordSubclass: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	t1 instSize > 0
		ifTrue: [^ self error: 'cannot make a word subclass of a class with named fields'].
	(t1 isVariable
			and: [t1 isBytes])
		ifTrue: [^ self error: 'cannot make a word subclass of a class with byte fields'].
	(t1 isVariable
			and: [t1 isPointers])
		ifTrue: [^ self error: 'cannot make a word subclass of a class with pointer fields'].
	^ self
		name: t2
		inEnvironment: t1 environment
		subclassOf: t1
		type: #words
		instanceVariableNames: t3
		classVariableNames: t4
		poolDictionaries: t5
		category: t6! !

!ClassBuilder methodsFor: 'public' stamp: ''!
superclass: t1 weakSubclass: t2 instanceVariableNames: t3 classVariableNames: t4 poolDictionaries: t5 category: t6 
	t1 isBits
		ifTrue: [^ self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^ self
		name: t2
		inEnvironment: t1 environment
		subclassOf: t1
		type: #weak
		instanceVariableNames: t3
		classVariableNames: t4
		poolDictionaries: t5
		category: t6! !

!ClassBuilder methodsFor: 'private' stamp: 'ar 6/14/2010 22:06'!
tooDangerousClasses
	"Return a list of class names which will not be modified in the public interface"
	^#(
		"Object will break immediately"
		ProtoObject Object
		"Contexts and their superclasses"
		InstructionStream ContextPart BlockContext MethodContext BlockClosure
		"Superclasses of basic collections"
		Collection SequenceableCollection ArrayedCollection
		"Collections known to the VM"
		Array Bitmap String Symbol ByteArray CompiledMethod
		"Basic Numbers"
		Magnitude Number SmallInteger Float
		"Misc other"
		LookupKey Association Link Point Rectangle Behavior PositionableStream UndefinedObject
	)
! !

!ClassBuilder methodsFor: 'class mutation' stamp: ''!
update: t1 to: t2 
	| t3 |
	t3 := t1 isMeta.
	[t1 superclass removeSubclass: t1.
	t1 superclass removeObsoleteSubclass: t1.
	t2 updateInstancesFrom: t1.
	t3
		ifTrue: [t1 becomeForward: t2]
		ifFalse: [(Array with: t1 with: t1 class)
				elementsForwardIdentityTo: (Array with: t2 with: t2 class)].
	Smalltalk garbageCollect] valueUnpreemptively! !

!ClassBuilder methodsFor: 'validation' stamp: 'ul 6/17/2011 12:21'!
validateClass: srcClass forMoving: iv downTo: dstClass
	"Make sure that we don't have any accesses to the instVar left"
	srcClass withAllSubclassesDo:[:cls|
		(cls == dstClass or:[cls inheritsFrom: dstClass]) ifFalse:[
			(cls whichSelectorsAccess: iv) isEmpty ifFalse:[
				self notify: (iv printString asText allBold), ' is still used in ', cls name asText allBold,'.
Proceed to move it to Undeclared'.
			].
		].
	].
	^true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateClass: t1 forMoving: t2 upTo: t3 
	t3
		withAllSubclassesDo: [:t4 | (t4 == t1
					or: [t4 inheritsFrom: t1])
				ifFalse: [t4 isPointers
						ifFalse: [self error: t3 name , ' cannot have instance variables'.
							^ false].
					t4 instSize >= 254
						ifTrue: [self error: t4 name , ' has more than 254 instance variables'.
							^ false].
					(t4 instVarNames includes: t2)
						ifTrue: [self notify: t2 printString asText allBold , ' is defined in ' , t4 name asText allBold , '
Proceed to move it up to ' , t3 name asText allBold , ' as well'.
							instVarMap
								at: t4 name
								put: (t4 instVarNames copyWithout: t2)]]].
	^ true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateClassName: t1 
	t1 first canBeGlobalVarInitial
		ifFalse: [self error: 'Class names must be capitalized'.
			^ false].
	environ
		at: t1
		ifPresent: [:t2 | (t2 isKindOf: Behavior)
				ifFalse: [self notify: t1 asText allBold , ' already exists!!\Proceed will store over it.' withCRs]].
	^ true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateClassvars: t1 from: t2 forSuper: t3 
	| t4 t5 t7 |
	t1 isEmpty
		ifTrue: [^ true].
	t5 := t1 asSet.
	t5 size = t1 size
		ifFalse: [t1
				do: [:t8 | t5
						remove: t8
						ifAbsent: [t7 := t8]].
			self error: t7 , ' is multiply defined'.
			^ false].
	(t5 includesAnyOf: self reservedNames)
		ifTrue: [self reservedNames
				do: [:t8 | (t5 includes: t8)
						ifTrue: [t7 := t8]].
			self error: t7 , ' is a reserved name'.
			^ false].
	t3
		ifNotNil: [t5 := t3 allClassVarNames asSet.
			t1
				do: [:t8 | (t5 includes: t8)
						ifTrue: [t3
								withAllSuperclassesDo: [:t9 | (t9 classVarNames includes: t8)
										ifTrue: [t7 := t9]].
							DuplicateVariableError new superclass: t7;
								 variable: t8;
								 signal: t8 , ' is already defined in ' , t7 name]]].
	t2
		ifNotNil: [t5 := Set new: 20.
			t2
				allSubclassesDo: [:t8 | t5 addAll: t8 classVarNames].
			t4 := t1.
			t3
				ifNotNil: [t4 := t4 , t3 allClassVarNames asArray].
			t4
				do: [:t8 | (t5 includes: t8)
						ifTrue: [DuplicateVariableError new superclass: t2;
								 variable: t8;
								 signal: t8 , ' is already defined in a subclass of ' , t2 name]]].
	^ true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateInstvars: t1 from: t2 forSuper: t3 
	| t4 t5 t7 |
	t1 isEmpty
		ifTrue: [^ true].
	t3 allowsSubInstVars
		ifFalse: [self error: t3 printString , ' does not allow subclass inst vars. See allowsSubInstVars.'.
			^ false].
	t5 := t1 asSet.
	t5 size = t1 size
		ifFalse: [t1
				do: [:t8 | t5
						remove: t8
						ifAbsent: [t7 := t8]].
			self error: t7 , ' is multiply defined'.
			^ false].
	(t5 includesAnyOf: self reservedNames)
		ifTrue: [self reservedNames
				do: [:t8 | (t5 includes: t8)
						ifTrue: [t7 := t8]].
			self error: t7 , ' is a reserved name'.
			^ false].
	t3
		ifNotNil: [t5 := t3 allInstVarNames asSet.
			t1
				do: [:t8 | (t5 includes: t8)
						ifTrue: [t3
								withAllSuperclassesDo: [:t9 | (t9 instVarNames includes: t8)
										ifTrue: [t7 := t9]].
							DuplicateVariableError new superclass: t7;
								 variable: t8;
								 signal: t8 , ' is already defined in ' , t7 name]]].
	t2
		ifNotNil: [t5 := Set new: 20.
			t2
				allSubclassesDo: [:t8 | t5 addAll: t8 instVarNames].
			t4 := t1.
			t3
				ifNotNil: [t4 := t4 , t3 allInstVarNames].
			t4
				do: [:t8 | (t5 includes: t8)
						ifTrue: [DuplicateVariableError new superclass: t2;
								 variable: t8;
								 signal: t8 , ' is already defined in a subclass of ' , t7 name]]].
	^ true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateSubclass: t1 canKeepLayoutFrom: t2 forSubclassFormat: t3 
	t1 = t2
		ifTrue: [^ true].
	(t2 isVariable
			and: [t1 isWeak])
		ifFalse: [t1 typeOfClass == t3
				ifFalse: [self error: t1 name , ' cannot be recompiled'.
					^ false]].
	^ true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateSubclassFormat: t1 from: t2 forSuper: t3 extra: t4 
	| t5 |
	t2
		ifNil: [^ true].
	t5 := t4.
	t2 notNil
		ifTrue: [t5 := t5 - t2 instVarNames size].
	t3 notNil
		ifTrue: [t5 := t5 + t3 instSize].
	(t2 notNil
			and: [t2 superclass notNil])
		ifTrue: [t5 := t5 - t2 superclass instSize].
	t2
		ifNil: [t5 > 254
				ifTrue: [self error: 'More than 254 instance variables'.
					^ false].
			^ true].
	t2
		withAllSubclassesDo: [:t6 | 
			t6 instSize + t5 > 254
				ifTrue: [self error: t6 name , ' has more than 254 instance variables'.
					^ false].
			t1 ~~ #normal
				ifTrue: [self
						validateSubclass: t6
						canKeepLayoutFrom: t2
						forSubclassFormat: t1]].
	^ true! !

!ClassBuilder methodsFor: 'validation' stamp: ''!
validateSuperclass: t1 forSubclass: t2 
	t2
		ifNil: [(t1
					ifNil: [true]
					ifNotNil: [t1 isBehavior
							and: [t1 isMeta not]])
				ifFalse: [self error: t1 name , ' is not a valid superclass'.
					^ false].
			^ true].
	t1 == t2 superclass
		ifTrue: [^ true].
	t2 isMeta
		ifTrue: [^ self error: t2 name , ' must inherit from ' , t2 superclass name].
	(t1 ~~ nil
			and: [t1 == t2
					or: [t1 inheritsFrom: t2]])
		ifTrue: [self error: t1 name , ' inherits from ' , t2 name.
			^ false].
	^ true! !

Object subclass: #ClassCategoryReader
	instanceVariableNames: 'class category changeStamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!ClassCategoryReader methodsFor: 'fileIn/Out' stamp: ''!
scanFrom: t1 
	| t2 |
	[t2 := t1 nextChunkText.
	t2 size > 0]
		whileTrue: [class
				compile: t2
				classified: category
				withStamp: changeStamp
				notifying: nil]! !

!ClassCategoryReader methodsFor: 'fileIn/Out' stamp: 'nice 2/23/2011 21:46'!
scanFromNoCompile: aStream 
	"Just move the source code for the methods from aStream."
	| methodText selector |

	[methodText := aStream nextChunkText.
	 methodText size > 0]
		whileTrue:
		[(SourceFiles at: 2) ifNotNil: [
			selector := class newParser parseSelector: methodText.
			(class compiledMethodAt: selector) putSource: methodText 
				fromParseNode: nil class: class category: category
				withStamp: changeStamp inFile: 2 priorMethod: nil]]! !

!ClassCategoryReader methodsFor: 'fileIn/Out' stamp: ''!
scanFromNoCompile: t1 forSegment: t2 
	^ self scanFromNoCompile: t1! !

!ClassCategoryReader methodsFor: 'private' stamp: ''!
setClass: t1 category: t2 
	^ self
		setClass: t1
		category: t2
		changeStamp: String new! !

!ClassCategoryReader methodsFor: 'private' stamp: ''!
setClass: t1 category: t2 changeStamp: t3 
	class := t1.
	category := t2.
	changeStamp := t3! !

!ClassCategoryReader methodsFor: 'private' stamp: ''!
theClass
	^ class! !

ClassCategoryReader subclass: #ClassCommentReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!ClassCommentReader methodsFor: 'as yet unclassified' stamp: ''!
scanFrom: t1 
	class theNonMetaClass classComment: t1 nextChunkText stamp: changeStamp! !

!ClassCommentReader methodsFor: 'as yet unclassified' stamp: ''!
scanFromNoCompile: t1 
	self scanFrom: t1! !

Object subclass: #CompiledMethodTrailer
	instanceVariableNames: 'data encodedData kind size method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!CompiledMethodTrailer class methodsFor: 'as yet unclassified' stamp: ''!
empty
	^ self new! !

!CompiledMethodTrailer class methodsFor: 'as yet unclassified' stamp: ''!
generateTrailerKindDecoders
	self class
		compile: (String
				streamContents: [:t1 | t1 nextPutAll: 'trailerKindDecoders';
						 cr;
						 cr;
						 tab;
						 nextPut: $^;
						
						print: (self trailerKinds
								collect: [:t2 | ('decode' , t2) asSymbol])])
		classified: 'generated'! !

!CompiledMethodTrailer class methodsFor: 'generated' stamp: ''!
trailerKindDecoders
	^ #(#decodeNoTrailer #decodeClearedTrailer #decodeTempsNamesQCompress #decodeTempsNamesZip #decodeSourceBySelector #decodeSourceByStringIdentifier #decodeEmbeddedSourceQCompress #decodeEmbeddedSourceZip #decodeVarLengthSourcePointer #decodeExtendedKind #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeUndefined #decodeSourcePointer )! !

!CompiledMethodTrailer class methodsFor: 'as yet unclassified' stamp: ''!
trailerKinds
	^ #(#NoTrailer #ClearedTrailer #TempsNamesQCompress #TempsNamesZip #SourceBySelector #SourceByStringIdentifier #EmbeddedSourceQCompress #EmbeddedSourceZip #VarLengthSourcePointer #ExtendedKind #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #Undefined #SourcePointer )! !

!CompiledMethodTrailer methodsFor: 'initialize-release' stamp: ''!
clear
	kind := #NoTrailer.
	size := 1.
	data := encodedData := method := nil! !

!CompiledMethodTrailer methodsFor: 'creating a method' stamp: 'eem 5/20/2012 11:42'!
compiledMethodClass
	"Allow subclasses to create instyances of classes other than CompiledMethod."

	^CompiledMethod! !

!CompiledMethodTrailer methodsFor: 'creating a method' stamp: 'eem 9/13/2011 15:14'!
createMethod: numberOfBytesForAllButTrailer class: aCompiledMethodClass header: headerWord 
	| meth |
	encodedData ifNil: [self encode].
	
	meth := aCompiledMethodClass newMethod: numberOfBytesForAllButTrailer + size header: headerWord.
	"copy the encoded trailer data"
	1 to: size do:
		[:i | meth at: meth size - size + i put: (encodedData at: i)].

	^meth! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeClearedTrailer
	self decodeLengthField! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeEmbeddedSourceQCompress
	self qDecompress! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeEmbeddedSourceZip
	self decodeZip! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
decodeExtendedKind
	self shouldBeImplemented! !

!CompiledMethodTrailer methodsFor: 'private' stamp: ''!
decodeLengthField
	| t1 t2 t3 |
	t2 := method size.
	t1 := ((method at: t2)
				bitAnd: 3)
				+ 1.
	t3 := 0.
	1
		to: t1
		do: [:t4 | t3 := t3 << 8
						+ (method at: t2 - t4)].
	size := 1 + t1 + t3.
	^ t3! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeNoTrailer
	size := 1! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeSourceBySelector
	size := 1! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeSourceByStringIdentifier
	| t1 |
	t1 := self decodeLengthField.
	data := (ReadStream
				on: method
				from: method size - size + 1
				to: method size - size + t1) contents asString convertFromEncoding: 'utf8'! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeSourcePointer
	| t1 |
	size := 4.
	t1 := method size.
	data := (method at: t1)
				- 251 << 8
				+ (method at: t1 - 1) << 8
				+ (method at: t1 - 2) << 8
				+ (method at: t1 - 3)! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeTempsNamesQCompress
	self qDecompress! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeTempsNamesZip
	self decodeZip! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeUndefined
	self error: 'undefined method encoding'! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
decodeVarLengthSourcePointer
	| t1 t2 t3 |
	t1 := method size - 1.
	t2 := data := 0.
	[t3 := method at: t1.
	data := (t3 bitAnd: 127)
				<< t2 + data.
	t1 := t1 - 1.
	t2 := t2 + 7.
	t3 > 127] whileTrue.
	size := method size - t1! !

!CompiledMethodTrailer methodsFor: 'private' stamp: ''!
decodeZip
	| t1 t2 |
	t1 := self decodeLengthField.
	t2 := ByteArray new: t1.
	1
		to: t1
		do: [:t3 | t2
				at: t3
				put: (method at: method size - size + t3)].
	data := (ZipReadStream on: t2) contents asString convertFromEncoding: 'utf8'! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encode
	encodedData := nil.
	self perform: ('encode' , kind) asSymbol.
	self
		assert: (encodedData notNil
				and: [encodedData size > 0]).
	size := encodedData size! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeClearedTrailer
	self clear.
	kind := #NoTrailer.
	^ self encode! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeEmbeddedSourceQCompress
	self encodeUsingQCompress! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeEmbeddedSourceZip
	self encodeUsingZip! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeExtendedKind
	self error: 'Not yet implemented'! !

!CompiledMethodTrailer methodsFor: 'private' stamp: ''!
encodeLengthField: t1 
	| t2 t3 |
	self assert: t1 > 0.
	t3 := t1.
	t2 := ByteArray
				streamContents: [:t5 | 
					[t3 > 0]
						whileTrue: [t5
								nextPut: (t3 bitAnd: 255).
							t3 := t3 >> 8].
					nil].
	self assert: t2 size <= 4.
	^ t2! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeNoTrailer
	encodedData := ByteArray with: self kindAsByte! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeSourceBySelector
	encodedData := ByteArray with: self kindAsByte! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeSourceByStringIdentifier
	self assert: data isString.
	encodedData := ByteArray
				streamContents: [:t1 | 
					| t2 t3 |
					t2 := (data convertToEncoding: 'utf8') asByteArray.
					t1 nextPutAll: t2.
					t3 := self encodeLengthField: t2 size.
					t1 nextPutAll: t3.
					t1 nextPut: self kindAsByte + (t3 size - 1)]! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeSourcePointer
	encodedData := ByteArray new: 4.
	encodedData at: 4 put: data >> 24 + 251.
	1
		to: 3
		do: [:t1 | encodedData
				at: 4 - t1
				put: ((data bitShift: t1 - 3 * 8)
						bitAnd: 255)]! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeTempsNamesQCompress
	self encodeUsingQCompress! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
encodeTempsNamesZip
	self encodeUsingZip! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeUndefined
	self error: 'use of an undefined kind of trailer encoding'! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: ''!
encodeUsingQCompress
	| t1 t2 t3 |
	self assert: data isString.
	t1 := self qCompress: data.
	t2 := t1 position.
	t3 := self encodeLengthField: t2.
	t1 nextPutAll: t3.
	t1 nextPut: self kindAsByte + t3 size - 1.
	encodedData := t1 contents! !

!CompiledMethodTrailer methodsFor: 'private' stamp: ''!
encodeUsingZip
	| t1 t2 t3 t4 |
	self assert: data isString.
	t1 := data convertToEncoding: 'utf8'.
	t2 := (ZipWriteStream
				on: (ByteArray new: t1 size)) nextPutAll: t1 asByteArray;
				 close;
				 encodedStream.
	t3 := t2 position.
	t4 := self encodeLengthField: t3.
	t2 nextPutAll: t4.
	t2 nextPut: self kindAsByte + t4 size - 1.
	encodedData := t2 contents! !

!CompiledMethodTrailer methodsFor: 'encoding' stamp: 'IgorStasenko 5/10/2011 13:21'!
encodeVarLengthSourcePointer

	"source pointer must be >=0"
	[data >= 0] assert.
	
	encodedData := 
		data = 0 ifTrue: [ #[0] ] 
		ifFalse: [ ByteArray streamContents: [:str |
		| value |
		value := data.
		[value > 0] whileTrue: [
			value > 127 ifTrue: [ str nextPut: 128 + (value bitAnd: 16r7F) ]
				ifFalse: [ str nextPut: value. ].
			value := value >> 7.
			].
		]].
	encodedData := encodedData reversed copyWith: (self kindAsByte)! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
endPC
	method
		ifNil: [self error: 'Cannot determine the endPC without compiled method'].
	^ method size - size! !

!CompiledMethodTrailer methodsFor: 'testing' stamp: ''!
hasSourcePointer
	^ kind == #SourcePointer
		or: [kind == #VarLengthSourcePointer]! !

!CompiledMethodTrailer methodsFor: 'testing' stamp: ''!
hasTempNames
	^ kind == #TempsNamesQCompress
		or: [kind == #TempsNamesZip]! !

!CompiledMethodTrailer methodsFor: 'initialize-release' stamp: ''!
initialize
	self clear! !

!CompiledMethodTrailer methodsFor: 'testing' stamp: ''!
isEmpty
	^ kind == #NoTrailer
		or: [kind == #ClearedTrailer]! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
kind
	^ kind! !

!CompiledMethodTrailer methodsFor: 'private' stamp: 'ul 11/15/2010 10:11'!
kindAsByte
	| index |
	index := self class trailerKinds indexOf: kind.
	self assert: (index ~= 0).

	^ (index - 1) << 2! !

!CompiledMethodTrailer methodsFor: 'initialize-release' stamp: ''!
method: t1 
	| t2 t3 |
	data := size := nil.
	method := t1.
	t2 := method at: method size.
	t3 := t2 >> 2 + 1.
	kind := self class trailerKinds at: t3.
	self
		perform: (self class trailerKindDecoders at: t3).
	self assert: size notNil! !

!CompiledMethodTrailer methodsFor: 'private' stamp: ''!
qCompress: t1 
	| t2 t3 t4 |
	t1 isEmpty
		ifTrue: [^ self qCompress: ' '].
	t2 := t1 convertToEncoding: 'utf8'.
	t3 := WriteStream
				on: (ByteArray new: t2 size).
	t4 := nil.
	t2
		do: [:t6 | 
			| t7 |
			t7 := 'ear tonsilcmbdfghjkpquvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ012345[]()' indexOf: t6 ifAbsent: 0.
			(t7 = 0
				ifTrue: [{0. t6 asInteger // 16. t6 asInteger \\ 16}]
				ifFalse: [t7 <= 11
						ifTrue: [{t7}]
						ifFalse: [{t7 // 16 + 12. t7 \\ 16}]])
				do: [:t8 | t4
						ifNil: [t4 := t8]
						ifNotNil: [t3 nextPut: t4 * 16 + t8.
							t4 := nil]]].
	t4
		ifNotNil: [t3 nextPut: t4 * 16 + 4].
	^ t3! !

!CompiledMethodTrailer methodsFor: 'decoding' stamp: ''!
qDecompress
	| t1 t2 t3 |
	t1 := self decodeLengthField.
	t3 := ReadStream
				on: method
				from: method size - size + 1
				to: method size - size + t1.
	t2 := String
				streamContents: [:t4 | 
					| t5 t6 t7 t8 |
					t7 := 'ear tonsilcmbdfghjkpquvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ012345[]()'.
					t8 := true.
					t5 := [t8
								ifTrue: [t8 := false.
									t3 peek
										ifNil: [0]
										ifNotNil: [:t10 | t10 // 16]]
								ifFalse: [t8 := true.
									t3 next
										ifNil: [0]
										ifNotNil: [:t11 | t11 \\ 16]]].
					[t3 atEnd]
						whileFalse: [(t6 := t5 value) = 0
								ifTrue: [t3 atEnd
										ifFalse: [t4
												nextPut: (Character value: t5 value * 16 + t5 value)]]
								ifFalse: [t6 <= 11
										ifTrue: [t4
												nextPut: (t7 at: t6)]
										ifFalse: [t4
												nextPut: (t7 at: t6 - 12 * 16 + t5 value)]]].
					nil].
	data := t2 convertFromEncoding: 'utf8'! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
setSourceBySelector
	self clear.
	kind := #SourceBySelector! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
size
	^ size! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
sourceCode
	(kind == #EmbeddedSourceQCompress
			or: [kind == #EmbeddedSourceZip])
		ifTrue: [^ data].
	kind == #SourceBySelector
		ifTrue: [^ method methodClass getSourceCodeBySelector: method selector].
	kind == #SourceByStringIdentifier
		ifTrue: [^ method methodClass getSourceCodeByIdentifier: data].
	^ nil! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
sourceCode: t1 
	| t2 |
	self clear.
	kind := #EmbeddedSourceQCompress.
	data := t1 asString.
	self encode.
	t2 := encodedData.
	kind := #EmbeddedSourceZip.
	self encode.
	encodedData size > t2 size
		ifTrue: [encodedData := t2.
			kind := #EmbeddedSourceQCompress.
			size := encodedData size]! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
sourceIdentifier
	^ kind == #SourceByStringIdentifier
		ifTrue: [data]! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
sourceIdentifier: t1 
	self clear.
	data := t1.
	kind := #SourceByStringIdentifier.
	self encode! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
sourcePointer
	^ (kind == #SourcePointer
			or: [kind == #VarLengthSourcePointer])
		ifTrue: [data]
		ifFalse: [0]! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
sourcePointer: t1 
	self clear.
	data := t1.
	kind := (t1 between: 16777216 and: 83886079)
				ifTrue: [#SourcePointer]
				ifFalse: [#VarLengthSourcePointer]! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
tempNames
	^ (kind == #TempsNamesQCompress
			or: [kind == #TempsNamesZip])
		ifTrue: [data]! !

!CompiledMethodTrailer methodsFor: 'accessing' stamp: ''!
tempNames: t1 
	| t2 |
	self clear.
	kind := #TempsNamesQCompress.
	data := t1.
	self encode.
	t2 := encodedData.
	kind := #TempsNamesZip.
	self encode.
	encodedData size > t2 size
		ifTrue: [encodedData := t2.
			kind := #TempsNamesQCompress.
			size := encodedData size]! !

!CompiledMethodTrailer methodsFor: 'testing' stamp: ''!
testEncoding
	encodedData
		ifNil: [self encode].
	^ CompiledMethodTrailer new method: encodedData! !

Object subclass: #Complex
	instanceVariableNames: 'real imaginary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!Complex class methodsFor: 'instance creation' stamp: 'nice 4/22/2011 00:46'!
abs: aNumber1 arg: aNumber2
	^self
		real: aNumber1 * aNumber2 cos
		imaginary: aNumber1 * aNumber2 sin! !

!Complex class methodsFor: 'instance creation' stamp: ''!
new
	^ self real: 0 imaginary: 0! !

!Complex class methodsFor: 'instance creation' stamp: 'nice 9/18/2008 22:50'!
one
	^ self real: 1 imaginary: 0! !

!Complex class methodsFor: 'instance creation' stamp: 'nice 8/29/2011 00:11'!
real: aNumber1 imaginary: aNumber2
	^self basicNew	real: aNumber1 imaginary: aNumber2! !

!Complex class methodsFor: 'instance creation' stamp: 'nice 9/18/2008 22:50'!
zero
	^ self real: 0 imaginary: 0! !

!Complex methodsFor: 'arithmetic' stamp: ''!
* t1 
	| t2 t3 t4 t5 t6 t7 |
	t1 isComplex
		ifTrue: [t2 := self real.
			t3 := self imaginary.
			t4 := t1 real.
			t5 := t1 imaginary.
			t6 := t2 * t4 - (t3 * t5).
			t7 := t2 * t5 + (t3 * t4).
			^ Complex real: t6 imaginary: t7].
	^ t1 adaptToComplex: self andSend: #*! !

!Complex methodsFor: 'arithmetic' stamp: ''!
+ t1 
	| t2 t3 t4 t5 t6 t7 |
	t1 isComplex
		ifTrue: [t2 := self real.
			t3 := self imaginary.
			t4 := t1 real.
			t5 := t1 imaginary.
			t6 := t2 + t4.
			t7 := t3 + t5.
			^ Complex real: t6 imaginary: t7].
	^ t1 adaptToComplex: self andSend: #+! !

!Complex methodsFor: 'arithmetic' stamp: ''!
- t1 
	| t2 t3 t4 t5 t6 t7 |
	t1 isComplex
		ifTrue: [t2 := self real.
			t3 := self imaginary.
			t4 := t1 real.
			t5 := t1 imaginary.
			t6 := t2 - t4.
			t7 := t3 - t5.
			^ Complex real: t6 imaginary: t7].
	^ t1 adaptToComplex: self andSend: #-! !

!Complex methodsFor: 'arithmetic' stamp: ''!
/ t1 
	| t2 t3 t4 t5 t6 t7 |
	t1 isComplex
		ifTrue: [t2 := self real.
			t3 := self imaginary.
			t4 := t1 real.
			t5 := t1 imaginary.
			t6 := t2 * t4 + (t3 * t5) / (t4 * t4 + (t5 * t5)).
			t7 := t3 * t4 - (t2 * t5) / (t4 * t4 + (t5 * t5)).
			^ Complex real: t6 imaginary: t7].
	^ t1 adaptToComplex: self andSend: #/! !

!Complex methodsFor: 'comparing' stamp: ''!
= t1 
	t1 isNumber
		ifFalse: [^ false].
	t1 isComplex
		ifTrue: [^ real = t1 real & (imaginary = t1 imaginary)].
	^ t1 adaptToComplex: self andSend: #=! !

!Complex methodsFor: 'arithmetic' stamp: ''!
abs
	^ (real * real + (imaginary * imaginary)) sqrt! !

!Complex methodsFor: 'arithmetic' stamp: 'nice 4/21/2011 21:47'!
absSecure
	"Answer the distance of the receiver from zero (0 + 0 i).
	Try avoiding overflow and/or underflow"

	| scale |
	scale := real abs max: imaginary abs.
	^scale isZero 
		ifTrue: [scale]
		ifFalse: [(self class real: real / scale imaginary: imaginary / scale) squaredNorm sqrt * scale]! !

!Complex methodsFor: 'converting' stamp: ''!
adaptToCollection: t1 andSend: t2 
	^ t1
		collect: [:t3 | t3 perform: t2 with: self]! !

!Complex methodsFor: 'converting' stamp: ''!
adaptToFloat: t1 andSend: t2 
	^ t1 asComplex perform: t2 with: self! !

!Complex methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andSend: t2 
	^ t1 asComplex perform: t2 with: self! !

!Complex methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andSend: t2 
	^ t1 asComplex perform: t2 with: self! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/24/2011 22:44'!
arCosh
	"Answer receiver's area hyperbolic cosine.
	That is the inverse function of cosh.
	Some possible implementations:
	^imaginary > 0 
		ifTrue: [(self + (self * self - 1) sqrt) ln]
		ifFalse: [(self + (self * self - 1) sqrt) ln negated]
	^self arcCos i
	This implementation provides an answer with a positive real part.
	It also avoids creating intermediate Complex."
	
	| x y tmp sh2x shx delta ch2x chx |
	imaginary = 0 ifTrue: [real abs > 1
			ifTrue: 
				[y := real < 0
					ifTrue: [Float pi]
					ifFalse: [0].
				x := real abs arCosh.
				^self class real: x imaginary: y]
			ifFalse: [^self class real: 0 imaginary: real arcCos]].
	tmp := self squaredNorm - 1 / 2.
	delta := tmp squared + imaginary squared.
	sh2x := tmp + delta sqrt.
	shx := sh2x sqrt.
	ch2x := 1 + sh2x.
	chx := ch2x sqrt.
	x := shx arSinh.
	y := imaginary copySignTo: (real / chx) arcCos.
	^self class real: x imaginary: y! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 01:31'!
arSinh
	"Answer receiver's area hyperbolic sine.
	That is the inverse function of sinh."

	"Some possible implementation:

	^imaginary * real < 0 
		ifTrue: [(self + (self * self + 1) sqrt) ln]
		ifFalse: [(self - (self * self + 1) sqrt) ln]"

	^self i arcSin i negated! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 01:31'!
arTanh
	"Answer receiver's area hyperbolic tangent.
	That is the inverse function of tanh."

	"Some other possible implementation:

	^((1 + self) / (1 - self)) ln / 2"

	^self i arcTan i negated! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/24/2011 21:31'!
arcCos
	"Answer the arc cosine of the receiver.
	This is the inverse function of cos."

	| x y tmp sh2y shy delta ch2y chy |
	imaginary = 0 ifTrue: [real abs > 1
			ifTrue: 
				[x := real < 0
					ifTrue: [Float pi]
					ifFalse: [0].
				y := real copySignTo: real abs arCosh.
				^self class real: x imaginary: y]
			ifFalse: [^self class real: real arcCos imaginary: 0]].
	tmp := self squaredNorm - 1 / 2.
	delta := tmp squared + imaginary squared.
	sh2y := tmp + delta sqrt.
	shy := sh2y sqrt.
	ch2y := 1 + sh2y.
	chy := ch2y sqrt.
	y := imaginary copySignTo: shy arSinh.
	x := (real / chy) arcCos.
	^self class real: x imaginary: y negated! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/24/2011 22:46'!
arcSin
	"Answer the arc sine of the receiver.
	This is the inverse function of sin."

	| x y tmp delta sh2y shy ch2y chy |
	imaginary = 0 
		ifTrue: 
			[real abs > 1 
				ifTrue: 
					[x := Float pi / 2 * real sign.
					y := (real copySignTo: real abs arCosh) negated.
					^self class real: x imaginary: y]
				ifFalse: [^self class real: real arcSin imaginary: 0]].
	tmp := (self squaredNorm - 1) / 2.
	delta := tmp squared + imaginary squared.
	sh2y := tmp + delta sqrt.
	shy := sh2y sqrt.
	ch2y := 1 + sh2y.
	chy := ch2y sqrt.
	y := imaginary copySignTo: shy arSinh.
	x := (real / chy) arcSin.
	^self class real: x imaginary: y! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/21/2011 21:45'!
arcTan
	"Answer the arc tangent of the receiver.
	This is the inverse function of tan."

	| r2 |
	r2 := self squaredNorm.
	^self class
		real: (real * 2 arcTan: 1 - r2) / 2
		imaginary: ((r2 + (imaginary * 2) + 1) / (r2 - (imaginary * 2) + 1)) ln / 4! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 01:34'!
arcTan: denominator 
	"Answer the  four quadrants arc tangent of receiver over denominator."

	^denominator isZero 
		ifTrue: 
			[self isZero 
				ifTrue: 
					["shouldn't it be an error ? ^DomainError signal: '0 arcTan: 0'"
					^self class real: 0 imaginary: 0]
				ifFalse: 
					[self class
						real: Float pi / (real copySignTo: 2)
						imaginary: 0]]
		ifFalse: 
			[| res |
			res := (self / denominator) arcTan.
			denominator real < 0 ifTrue: [res := res + Float pi].
			res real > Float pi 
				ifTrue: [res := res - (Float pi * 2)].
			res]! !

!Complex methodsFor: 'arithmetic' stamp: 'nice 4/20/2011 22:18'!
arg
	"Answer the argument of the receiver."

	self isZero ifTrue: [self error: 'zero has no argument.'].
	^imaginary arcTan: real! !

!Complex methodsFor: 'converting' stamp: 'nice 10/16/2011 16:34'!
asComplex
	^self! !

!Complex methodsFor: 'arithmetic' stamp: 'nice 2/5/2006 03:24'!
conjugated
	"Return the complex conjugate of this complex number."

	^self class real: real imaginary: imaginary negated! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 00:54'!
cos
	"Answer receiver's cosine."

	^self i cosh! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 21:30'!
cosh
	"Answer receiver's hyperbolic cosine.
	Hyperbolic cosine is defined by same power serie expansion as for real numbers, that is in term of exponential:
	^ (self exp + self negated exp) / 2.
	This implementation avoids creating intermediate objects."
	
	^self class
		real: real cosh * imaginary cos
		imaginary: real sinh * imaginary sin! !

!Complex methodsFor: 'arithmetic' stamp: ''!
divideFastAndSecureBy: t1 
	| t2 t3 t4 t5 |
	t1 isComplex
		ifTrue: [t1 real abs > t1 imaginary abs
				ifTrue: [t2 := t1 imaginary / t1 real.
					t3 := t2 * t1 imaginary + t1 real.
					t4 := t2 * imaginary + real / t3.
					t5 := t2 negated * real + imaginary / t3]
				ifFalse: [t2 := t1 real / t1 imaginary.
					t3 := t2 * t1 real + t1 imaginary.
					t4 := t2 * real + imaginary / t3.
					t5 := t2 * imaginary - real / t3].
			^ Complex real: t4 imaginary: t5].
	^ t1 adaptToComplex: self andSend: #/! !

!Complex methodsFor: 'arithmetic' stamp: ''!
divideSecureBy: t1 
	| t2 t3 t4 t5 t6 t7 t8 |
	t1 isComplex
		ifTrue: [t2 := t1 real abs + t1 imaginary abs.
			t3 := self real / t2.
			t4 := self imaginary / t2.
			t5 := t1 real / t2.
			t6 := t1 imaginary / t2.
			t2 := t5 squared + t6 squared.
			t7 := t3 * t5 + (t4 * t6) / t2.
			t8 := t4 * t5 - (t3 * t6) / t2.
			^ Complex real: t7 imaginary: t8].
	^ t1 adaptToComplex: self andSend: #/! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/22/2011 00:38'!
exp
	"Answer the exponential of the receiver."

	^ real exp * (imaginary cos + imaginary sin i)! !

!Complex methodsFor: 'comparing' stamp: ''!
hash
	^ real hash bitXor: imaginary hash! !

!Complex methodsFor: 'arithmetic' stamp: 'nice 2/5/2006 03:25'!
i
	"Answer the result of multiplying the receiver with pure imaginary.
		^self * 1 i
	This is an obvious extension of method i implemented in Number."

	^self class real: imaginary negated imaginary: real! !

!Complex methodsFor: 'accessing' stamp: ''!
imaginary
	^ imaginary! !

!Complex methodsFor: 'testing' stamp: ''!
isComplex
	^ true! !

!Complex methodsFor: 'testing' stamp: ''!
isNumber
	^ true! !

!Complex methodsFor: 'testing' stamp: 'nice 4/20/2011 22:06'!
isZero
	^ real isZero and: [imaginary isZero]! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/22/2011 00:39'!
ln
	"Answer the natural log of the receiver."

	^ self abs ln + self arg i! !

!Complex methodsFor: 'mathematical functions' stamp: ''!
log: t1 
	^ self ln / t1 ln! !

!Complex methodsFor: 'arithmetic' stamp: 'nice 4/20/2011 22:06'!
negated
	"Answer a Number that is the negation of the receiver."

	^self class real: real negated imaginary: imaginary negated! !

!Complex methodsFor: 'printing' stamp: ''!
printOn: t1 
	real printOn: t1.
	t1 nextPut: Character space.
	0 <= imaginary
		ifTrue: [t1 nextPut: $+]
		ifFalse: [t1 nextPut: $-].
	t1 nextPut: Character space.
	imaginary abs printOn: t1.
	t1 nextPut: Character space.
	t1 nextPut: $i! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 9/18/2008 22:51'!
raisedTo: aNumber 
	"Answer the receiver raised to aNumber."

	aNumber isInteger ifTrue:
		["Do the special case of integer power"
		^ self raisedToInteger: aNumber].
	
	0 = aNumber ifTrue: [^ self class one].	"Special case of exponent=0"
	1 = aNumber ifTrue: [^ self].	"Special case of exponent=1"
	0 = self ifTrue: [				"Special case of self = 0"
		aNumber < 0
			ifTrue: [^ (ZeroDivide dividend: self) signal]
			ifFalse: [^ self]].
	^ (aNumber * self ln) exp		"Otherwise use logarithms"! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 6/17/2011 04:14'!
raisedToInteger: operand 
	"Answer the receiver raised to the power operand, an Integer."

	"implementation note: this code is copied from Number.
	This suggest that both Number and Complex should have an
	ArithmeticValue common superclass like in Visualworks.
	Or maybe should it be a Traits (a property of fields ?)"

	| count result |
	operand isInteger ifFalse: [^ ArithmeticError signal: 'parameter is not an Integer'].
	operand = 0 ifTrue: [^ self class one].
	operand = 1 ifTrue: [^ self].
	operand < 0 ifTrue: [^ (self raisedToInteger: operand negated) reciprocal].
	count := 1 bitShift: (operand-1) highBit.
	result := self class one.
	[count > 0]
		whileTrue: 
			[result := result squared.
			(operand bitAnd: count)
				= 0 ifFalse: [result := result * self].
			count := count bitShift: -1].
	^ result! !

!Complex methodsFor: 'accessing' stamp: ''!
real
	^ real! !

!Complex methodsFor: 'private' stamp: 'nice 8/29/2011 00:11'!
real: aNumber1 imaginary: aNumber2
	"Private - initialize the real and imaginary parts of a Complex"
	real := aNumber1.
	imaginary := aNumber2.! !

!Complex methodsFor: 'arithmetic' stamp: ''!
reciprocal
	self = 0
		ifTrue: [^ (ZeroDivide dividend: self) signal].
	^ 1 / self! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 00:54'!
sin
	"Answer receiver's sine."

	^self i sinh i negated! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 21:30'!
sinh
	"Answer receiver's hyperbolic sine.
	Hyperbolic sine is defined by same power serie expansion as for real numbers, that is in term of exponential:
	^ (self exp - self negated exp) / 2.
	This implementation avoids creating intermediate objects."
	
	^self class
		real: real sinh * imaginary cos
		imaginary: real cosh * imaginary sin! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/20/2011 21:58'!
sqrt
	"Return the square root of the receiver with a positive imaginary part."

	| u v |
	(imaginary = 0 and: [real >= 0])
		ifTrue:	[^self class real: real sqrt imaginary: 0].
	v := (self abs - real / 2) sqrt.
	u := imaginary / 2 / v.
	^self class real: u imaginary: v! !

!Complex methodsFor: 'mathematical functions' stamp: ''!
squared
	^ self * self! !

!Complex methodsFor: 'arithmetic' stamp: 'nice 2/5/2006 03:27'!
squaredNorm
	"Answer the square of receiver norm."

	^real * real + (imaginary * imaginary)! !

!Complex methodsFor: 'mathematical functions' stamp: ''!
tan
	^ self sin / self cos! !

!Complex methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 00:55'!
tanh
	"Answer receiver's hyperbolic tangent."

	"Some possible implementation are:

	^self sinh / self cosh

	| tr ti |
	tr := real tanh.
	ti := imaginary tan i.
	^(tr + ti) / (tr * ti + 1)"

	^self i tan i negated! !

Object subclass: #Delay
	instanceVariableNames: 'delayDuration resumptionTime delaySemaphore beingWaitedOn'
	classVariableNames: 'AccessProtect ActiveDelay ActiveDelayStartTime DelaySuspended FinishedDelay RunTimerEventLoop ScheduledDelay SuspendedDelays TimerEventLoop TimingSemaphore'
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Delay class methodsFor: 'testing' stamp: ''!
anyActive
	^ ActiveDelay notNil! !

!Delay class methodsFor: 'instance creation' stamp: 'brp 9/25/2003 13:43'!
forDuration: aDuration

	^ self forMilliseconds: aDuration asMilliSeconds
! !

!Delay class methodsFor: 'instance creation' stamp: ''!
forMilliseconds: t1 
	t1 < 0
		ifTrue: [self error: 'delay times cannot be negative'].
	^ self new setDelay: t1 asInteger forSemaphore: Semaphore new! !

!Delay class methodsFor: 'instance creation' stamp: ''!
forSeconds: t1 
	t1 < 0
		ifTrue: [self error: 'delay times cannot be negative'].
	^ self new setDelay: (t1 * 1000) asInteger forSemaphore: Semaphore new! !

!Delay class methodsFor: 'timer process' stamp: ''!
handleTimerEvent
	| t1 t2 |
	TimingSemaphore wait.
	ScheduledDelay
		ifNotNil: [self scheduleDelay: ScheduledDelay.
			ScheduledDelay := nil].
	FinishedDelay
		ifNotNil: [self unscheduleDelay: FinishedDelay.
			FinishedDelay := nil].
	t1 := Time millisecondClockValue.
	t1 < ActiveDelayStartTime
		ifTrue: [self saveResumptionTimes.
			self restoreResumptionTimes].
	ActiveDelayStartTime := t1.
	[ActiveDelay notNil
		and: [t1 >= ActiveDelay resumptionTime]]
		whileTrue: [ActiveDelay signalWaitingProcess.
			SuspendedDelays isEmpty
				ifTrue: [ActiveDelay := nil]
				ifFalse: [ActiveDelay := SuspendedDelays removeFirst]].
	t2 := t1 + 1000.
	ActiveDelay
		ifNotNil: [t2 := t2 min: ActiveDelay resumptionTime].
	t2 := t2 min: SmallInteger maxVal.
	TimingSemaphore initSignals.
	Delay primSignal: TimingSemaphore atMilliseconds: t2.
	Time millisecondClockValue < t1
		ifTrue: [TimingSemaphore signal]! !

!Delay class methodsFor: 'class initialization' stamp: ''!
initialize
	self startTimerEventLoop! !

!Delay class methodsFor: 'testing' stamp: ''!
nextWakeUpTime
	^ AccessProtect
		critical: [ActiveDelay isNil
				ifTrue: [0]
				ifFalse: [ActiveDelay resumptionTime]]! !

!Delay class methodsFor: 'primitives' stamp: ''!
primSignal: t1 atMilliseconds: t2 
	<primitive: 136>
	^ self primitiveFailed! !

!Delay class methodsFor: 'snapshotting' stamp: ''!
restoreResumptionTimes
	| t1 |
	t1 := Time millisecondClockValue.
	SuspendedDelays
		do: [:t2 | t2 adjustResumptionTimeOldBase: 0 newBase: t1].
	ActiveDelay
		ifNotNil: [ActiveDelay adjustResumptionTimeOldBase: 0 newBase: t1]! !

!Delay class methodsFor: 'timer process' stamp: ''!
runTimerEventLoop
	[RunTimerEventLoop]
		whileTrue: [self handleTimerEvent]! !

!Delay class methodsFor: 'snapshotting' stamp: ''!
saveResumptionTimes
	| t1 |
	t1 := Time millisecondClockValue.
	ActiveDelay
		ifNotNil: [t1 < ActiveDelayStartTime
				ifTrue: [t1 := ActiveDelayStartTime].
			ActiveDelay adjustResumptionTimeOldBase: t1 newBase: 0].
	SuspendedDelays
		do: [:t2 | t2 adjustResumptionTimeOldBase: t1 newBase: 0]! !

!Delay class methodsFor: 'timer process' stamp: 'GaryChambers 4/11/2011 10:05'!
scheduleDelay: aDelay
	"Private. Schedule this Delay."
	
	aDelay resumptionTime: Time millisecondClockValue + aDelay delayDuration. 
		"Gary Chambers:  do the above here, via the high priority timer process to avoid rollover bug due to process pre-emption
		since the caller cannot use the AccessProtect semaphore."
	aDelay beingWaitedOn: true.
	ActiveDelay 
		ifNil: [ActiveDelay := aDelay]
		ifNotNil: [aDelay resumptionTime < ActiveDelay resumptionTime
			ifTrue: [SuspendedDelays add: ActiveDelay.
					ActiveDelay := aDelay]
			ifFalse: [SuspendedDelays add: aDelay]]
! !

!Delay class methodsFor: 'snapshotting' stamp: ''!
shutDown
	AccessProtect wait.
	self primSignal: nil atMilliseconds: 0.
	self saveResumptionTimes.
	DelaySuspended := true! !

!Delay class methodsFor: 'timer process' stamp: ''!
startTimerEventLoop
	self stopTimerEventLoop.
	AccessProtect := Semaphore forMutualExclusion.
	ActiveDelayStartTime := Time millisecondClockValue.
	SuspendedDelays := Heap
				withAll: (SuspendedDelays
						ifNil: [#()])
				sortBlock: [:t1 :t2 | t1 resumptionTime <= t2 resumptionTime].
	TimingSemaphore := Semaphore new.
	RunTimerEventLoop := true.
	TimerEventLoop := [self runTimerEventLoop] newProcess.
	TimerEventLoop priority: Processor timingPriority.
	TimerEventLoop resume.
	TimingSemaphore signal! !

!Delay class methodsFor: 'snapshotting' stamp: ''!
startUp
	DelaySuspended
		ifFalse: [^ self error: 'Trying to activate Delay twice'].
	DelaySuspended := false.
	self restoreResumptionTimes.
	AccessProtect signal! !

!Delay class methodsFor: 'timer process' stamp: ''!
stopTimerEventLoop
	RunTimerEventLoop := false.
	TimingSemaphore signal.
	TimerEventLoop := nil! !

!Delay class methodsFor: 'example' stamp: ''!
testDelayOf: t1 for: t2 rect: t3 
	| t4 t5 |
	t4 := Delay forMilliseconds: 50.
	t5 := Delay forMilliseconds: t1 - 50.
	Display fillBlack: t3.
	[1
		to: t2
		do: [:t6 | 
			Display fillWhite: t3.
			t4 wait.
			Display reverse: t3.
			t5 wait].
	nil]
		forkAt: Processor userInterruptPriority! !

!Delay class methodsFor: 'instance creation' stamp: ''!
timeoutSemaphore: t1 afterMSecs: t2 
	t2 < 0
		ifTrue: [self error: 'delay times cannot be negative'].
	^ (self new setDelay: t2 forSemaphore: t1) schedule! !

!Delay class methodsFor: 'timer process' stamp: ''!
unscheduleDelay: t1 
	t1 beingWaitedOn
		ifFalse: [^ self].
	ActiveDelay == t1
		ifTrue: [SuspendedDelays isEmpty
				ifTrue: [ActiveDelay := nil]
				ifFalse: [ActiveDelay := SuspendedDelays removeFirst]]
		ifFalse: [SuspendedDelays
				remove: t1
				ifAbsent: []].
	t1 beingWaitedOn: false! !

!Delay methodsFor: 'private' stamp: ''!
adjustResumptionTimeOldBase: t1 newBase: t2 
	resumptionTime := t2 + (resumptionTime - t1)! !

!Delay methodsFor: 'public' stamp: ''!
beingWaitedOn
	^ beingWaitedOn! !

!Delay methodsFor: 'public' stamp: ''!
beingWaitedOn: t1 
	beingWaitedOn := t1! !

!Delay methodsFor: 'public' stamp: ''!
delayDuration
	^ delayDuration! !

!Delay methodsFor: 'public' stamp: ''!
delaySemaphore
	^ delaySemaphore! !

!Delay methodsFor: 'delaying' stamp: ''!
isExpired
	^ delaySemaphore isSignaled! !

!Delay methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPutAll: '(';
		 print: delayDuration;
		 nextPutAll: ' msecs'.
	beingWaitedOn
		ifTrue: [t1 nextPutAll: '; ';
				 print: resumptionTime - Time millisecondClockValue;
				 nextPutAll: ' msecs remaining'].
	t1 nextPutAll: ')'! !

!Delay methodsFor: 'private' stamp: ''!
resumptionTime
	^ resumptionTime! !

!Delay methodsFor: 'private' stamp: 'GaryChambers 4/11/2011 10:04'!
resumptionTime: anInteger
	"Private!! Set the value of the system's millisecondClock at which the receiver's suspended Process will resumed.
	Must only be called from the class-side #scheduleDelay:."
	
	resumptionTime := anInteger! !

!Delay methodsFor: 'private' stamp: 'GaryChambers 4/11/2011 10:07'!
schedule
	"Schedule this delay."
	
	beingWaitedOn ifTrue: [^self error: 'This Delay has already been scheduled.'].
	AccessProtect critical: [
		ScheduledDelay := self.
		TimingSemaphore signal]! !

!Delay methodsFor: 'private' stamp: ''!
scheduleEvent
	resumptionTime := Time millisecondClockValue + delayDuration.
	AccessProtect
		critical: [ScheduledDelay := self.
			TimingSemaphore signal]! !

!Delay methodsFor: 'private' stamp: ''!
setDelay: t1 forSemaphore: t2 
	delayDuration := t1.
	delaySemaphore := t2.
	beingWaitedOn := false! !

!Delay methodsFor: 'private' stamp: ''!
signalWaitingProcess
	beingWaitedOn := false.
	delaySemaphore signal! !

!Delay methodsFor: 'private' stamp: ''!
unschedule
	AccessProtect
		critical: [FinishedDelay := self.
			TimingSemaphore signal]! !

!Delay methodsFor: 'private' stamp: ''!
unscheduleEvent
	AccessProtect
		critical: [FinishedDelay := self.
			TimingSemaphore signal]! !

!Delay methodsFor: 'delaying' stamp: ''!
wait
	self schedule.
	[delaySemaphore wait]
		ifCurtailed: [self unschedule]! !

Delay subclass: #DelayWaitTimeout
	instanceVariableNames: 'process expired'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!DelayWaitTimeout methodsFor: 'testing' stamp: ''!
isExpired
	^ expired! !

!DelayWaitTimeout methodsFor: 'private' stamp: ''!
setDelay: t1 forSemaphore: t2 
	super setDelay: t1 forSemaphore: t2.
	process := Processor activeProcess.
	expired := false! !

!DelayWaitTimeout methodsFor: 'signaling' stamp: ''!
signalWaitingProcess
	beingWaitedOn := false.
	process suspendingList == delaySemaphore
		ifTrue: [expired := true.
			process suspend; resume]! !

!DelayWaitTimeout methodsFor: 'waiting' stamp: ''!
wait
	[self schedule.
	beingWaitedOn
		ifTrue: [delaySemaphore wait]
		ifFalse: [expired := true]]
		ensure: [self unschedule].
	^ self isExpired! !

Delay subclass: #MonitorDelay
	instanceVariableNames: 'monitor queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!MonitorDelay class methodsFor: 'instance creation' stamp: ''!
signalLock: t1 afterMSecs: t2 inMonitor: t3 queue: t4 
	t2 < 0
		ifTrue: [self error: 'delay times cannot be negative'].
	^ (self new
		setDelay: t2
		forSemaphore: t1
		monitor: t3
		queue: t4) schedule! !

!MonitorDelay methodsFor: 'private' stamp: ''!
setDelay: t1 forSemaphore: t2 monitor: t3 queue: t4 
	monitor := t3.
	queue := t4.
	self setDelay: t1 forSemaphore: t2! !

!MonitorDelay methodsFor: 'private' stamp: ''!
signalWaitingProcess
	beingWaitedOn := false.
	monitor signalLock: delaySemaphore inQueue: queue! !

Object subclass: #InputSensor
	instanceVariableNames: ''
	classVariableNames: 'ButtonDecodeTable InterruptSemaphore InterruptWatcherProcess KeyDecodeTable'
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!InputSensor class methodsFor: 'public' stamp: ''!
default
	^ Sensor! !

!InputSensor class methodsFor: 'class initialization' stamp: ''!
defaultCrossPlatformKeys
	^ {$c. $x. $v. $a. $s. $f. $g. $z}! !

!InputSensor class methodsFor: 'preference change notification' stamp: ''!
duplicateAllControlAndAltKeysChanged
	(Preferences
			valueOfFlag: #swapControlAndAltKeys
			ifAbsent: [false])
		ifTrue: [self inform: 'Resetting swapControlAndAltKeys preference'.
			(Preferences preferenceAt: #swapControlAndAltKeys)
				rawValue: false].
	(Preferences
			valueOfFlag: #duplicateControlAndAltKeys
			ifAbsent: [false])
		ifTrue: [self inform: 'Resetting duplicateControlAndAltKeys preference'.
			(Preferences preferenceAt: #duplicateControlAndAltKeys)
				rawValue: false].
	self installKeyDecodeTable! !

!InputSensor class methodsFor: 'public' stamp: ''!
duplicateControlAndAltKeys: t1 
	Preferences setPreference: #duplicateControlAndAltKeys toValue: t1.
	self installKeyDecodeTable! !

!InputSensor class methodsFor: 'preference change notification' stamp: ''!
duplicateControlAndAltKeysChanged
	(Preferences
			valueOfFlag: #swapControlAndAltKeys
			ifAbsent: [false])
		ifTrue: [self inform: 'Resetting swapControlAndAltKeys preference'.
			(Preferences preferenceAt: #swapControlAndAltKeys)
				rawValue: false].
	(Preferences
			valueOfFlag: #duplicateAllControlAndAltKeys
			ifAbsent: [false])
		ifTrue: [self inform: 'Resetting duplicateAllControlAndAltKeys preference'.
			(Preferences preferenceAt: #duplicateAllControlAndAltKeys)
				rawValue: false].
	self installKeyDecodeTable! !

!InputSensor class methodsFor: 'public' stamp: ''!
installDuplicateKeyEntryFor: t1 
	| t2 |
	t2 := t1 asInteger.
	KeyDecodeTable at: {t2 bitAnd: 159. 2} put: {t2. 8}.
	KeyDecodeTable at: {t2. 8} put: {t2. 8}! !

!InputSensor class methodsFor: 'class initialization' stamp: ''!
installKeyDecodeTable
	KeyDecodeTable := Dictionary new.
	Preferences duplicateControlAndAltKeys
		ifTrue: [self defaultCrossPlatformKeys
				do: [:t1 | self installDuplicateKeyEntryFor: t1]].
	Preferences swapControlAndAltKeys
		ifTrue: [self defaultCrossPlatformKeys
				do: [:t1 | self installSwappedKeyEntryFor: t1]].
	Preferences duplicateAllControlAndAltKeys
		ifTrue: [(Character allCharacters
				select: [:t1 | t1 isAlphaNumeric])
				do: [:t1 | self installDuplicateKeyEntryFor: t1]]! !

!InputSensor class methodsFor: 'class initialization' stamp: ''!
installMouseDecodeTable
	ButtonDecodeTable := Preferences swapMouseButtons
				ifTrue: [ByteArray
						withAll: ((0 to: 255)
								collect: [:t1 | ((t1 bitAnd: 1)
										<< 1 bitOr: (t1 bitAnd: 2)
											>> 1)
										bitOr: (t1 bitAnd: 252)])]
				ifFalse: [ByteArray
						withAll: (0 to: 255)]! !

!InputSensor class methodsFor: 'public' stamp: ''!
installSwappedKeyEntryFor: t1 
	| t2 |
	t2 := t1 asInteger.
	KeyDecodeTable at: {t2 bitAnd: 159. 2} put: {t2. 8}.
	KeyDecodeTable at: {t2. 8} put: {t2 bitAnd: 159. 2}! !

!InputSensor class methodsFor: 'public' stamp: ''!
keyDecodeTable
	^ KeyDecodeTable
		ifNil: [self installKeyDecodeTable]! !

!InputSensor class methodsFor: 'system startup' stamp: ''!
shutDown
	self default shutDown! !

!InputSensor class methodsFor: 'system startup' stamp: ''!
startUp
	self installMouseDecodeTable.
	self installKeyDecodeTable.
	self default startUp! !

!InputSensor class methodsFor: 'public' stamp: ''!
swapControlAndAltKeys: t1 
	Preferences setPreference: #swapControlAndAltKeys toValue: t1.
	self installKeyDecodeTable! !

!InputSensor class methodsFor: 'preference change notification' stamp: ''!
swapControlAndAltKeysChanged
	(Preferences
			valueOfFlag: #duplicateControlAndAltKeys
			ifAbsent: [false])
		ifTrue: [self inform: 'Resetting duplicateControlAndAltKeys preference'.
			(Preferences preferenceAt: #duplicateControlAndAltKeys)
				rawValue: false].
	(Preferences
			valueOfFlag: #duplicateAllControlAndAltKeys
			ifAbsent: [false])
		ifTrue: [self inform: 'Resetting duplicateAllControlAndAltKeys preference'.
			(Preferences preferenceAt: #duplicateAllControlAndAltKeys)
				rawValue: false].
	self installKeyDecodeTable! !

!InputSensor class methodsFor: 'public' stamp: ''!
swapMouseButtons: t1 
	Preferences setPreference: #swapMouseButtons toValue: t1.
	self installMouseDecodeTable! !

!InputSensor methodsFor: 'mouse' stamp: ''!
anyButtonPressed
	^ self primMouseButtons anyMask: 7! !

!InputSensor methodsFor: 'modifier keys' stamp: ''!
anyModifierKeyPressed
	^ self primMouseButtons anyMask: 112! !

!InputSensor methodsFor: 'mouse' stamp: ''!
blueButtonPressed
	^ (self primMouseButtons bitAnd: 7)
		= 1! !

!InputSensor methodsFor: 'buttons' stamp: ''!
buttons
	^ ButtonDecodeTable at: self primMouseButtons + 1! !

!InputSensor methodsFor: 'private' stamp: ''!
characterForKeycode: t1 
	t1 = nil
		ifTrue: [^ nil].
	t1 class = Character
		ifTrue: [^ t1].
	^ Character
		value: (t1 bitAnd: 255)! !

!InputSensor methodsFor: 'modifier keys' stamp: ''!
commandKeyPressed
	^ self primMouseButtons anyMask: 64! !

!InputSensor methodsFor: 'modifier keys' stamp: ''!
controlKeyPressed
	^ self primMouseButtons anyMask: 16! !

!InputSensor methodsFor: 'cursor' stamp: ''!
currentCursor
	^ Cursor currentCursor! !

!InputSensor methodsFor: 'cursor' stamp: ''!
currentCursor: t1 
	Cursor currentCursor: t1! !

!InputSensor methodsFor: 'cursor' stamp: ''!
cursorPoint
	^ self mousePoint! !

!InputSensor methodsFor: 'cursor' stamp: ''!
cursorPoint: t1 
	^ self primCursorLocPut: t1! !

!InputSensor methodsFor: 'accessing' stamp: ''!
eventQueue
	^ nil! !

!InputSensor methodsFor: 'accessing' stamp: ''!
eventQueue: t1 
	^ self! !

!InputSensor methodsFor: 'user interrupts' stamp: ''!
eventTicklerProcess
	^ nil! !

!InputSensor methodsFor: 'accessing' stamp: ''!
flushAllButDandDEvents
	^ self! !

!InputSensor methodsFor: 'initialize' stamp: ''!
flushEvents
	^ self! !

!InputSensor methodsFor: 'keyboard' stamp: ''!
flushKeyboard
	[self keyboardPressed]
		whileTrue: [self keyboard]! !

!InputSensor methodsFor: 'tablet' stamp: ''!
hasTablet
	^ (self primTabletGetParameters: 1) notNil! !

!InputSensor methodsFor: 'user interrupts' stamp: ''!
inputProcess
	^ nil! !

!InputSensor methodsFor: 'user interrupts' stamp: ''!
installInterruptWatcher
	InterruptWatcherProcess
		ifNotNil: [InterruptWatcherProcess terminate].
	InterruptSemaphore := Semaphore new.
	InterruptWatcherProcess := [self userInterruptWatcher]
				forkAt: Processor lowIOPriority.
	self primInterruptSemaphore: InterruptSemaphore! !

!InputSensor methodsFor: 'user interrupts' stamp: ''!
interruptWatcherProcess
	^ InterruptWatcherProcess! !

!InputSensor methodsFor: 'joystick' stamp: ''!
joystickButtons: t1 
	^ ((self primReadJoystick: t1)
		bitShift: -22)
		bitAnd: 1823! !

!InputSensor methodsFor: 'joystick' stamp: ''!
joystickOn: t1 
	^ (((self primReadJoystick: t1)
		bitShift: -27)
		bitAnd: 1)
		~= 0! !

!InputSensor methodsFor: 'joystick' stamp: ''!
joystickXY: t1 
	| t2 t3 t4 |
	t2 := self primReadJoystick: t1.
	t3 := (t2 bitAnd: 2047)
				- 1024.
	t4 := ((t2 bitShift: -11)
				bitAnd: 2047)
				- 1024.
	^ t3 @ t4! !

!InputSensor methodsFor: 'keyboard' stamp: ''!
kbdTest
	| t1 |
	t1 := nil.
	[t1 = $x]
		whileFalse: [[self keyboardPressed] whileFalse.
			t1 := self characterForKeycode: self keyboard.
			(String
				streamContents: [:t3 | t3 nextPut: t1;
						 space;
						 print: t1 asciiValue;
						 space;
						 print: self primMouseButtons;
						 nextPutAll: '     '])
				displayAt: 10 @ 10]! !

!InputSensor methodsFor: 'keyboard' stamp: ''!
keyboard
	| t1 t2 t3 t4 t5 |
	t1 := self characterForKeycode: self primKbdNext.
	t2 := self characterForKeycode: self primKbdPeek.
	t2 isNil
		ifTrue: [^ t1].
	t5 := TextConverter defaultSystemConverter.
	t5 isNil
		ifTrue: [^ t1].
	t3 := ReadStream
				on: (String with: t1 with: t2).
	t4 := t5 nextFromStream: t3.
	t4 isOctetCharacter
		ifTrue: [^ t4].
	self primKbdNext.
	^ t4! !

!InputSensor methodsFor: 'keyboard' stamp: ''!
keyboardPeek
	^ self characterForKeycode: self primKbdPeek! !

!InputSensor methodsFor: 'keyboard' stamp: ''!
keyboardPressed
	^ self primKbdPeek notNil! !

!InputSensor methodsFor: 'modifier keys' stamp: ''!
leftShiftDown
	^ self primMouseButtons anyMask: 8! !

!InputSensor methodsFor: 'mouse' stamp: ''!
mouseButtons
	^ self primMouseButtons bitAnd: 7! !

!InputSensor methodsFor: 'mouse' stamp: ''!
mousePoint
	^ self primMousePt! !

!InputSensor methodsFor: 'mouse' stamp: ''!
noButtonPressed
	^ self anyButtonPressed not! !

!InputSensor methodsFor: 'mouse' stamp: ''!
peekButtons
	^ self primMouseButtons! !

!InputSensor methodsFor: 'mouse' stamp: ''!
peekMousePt
	^ self primMousePt! !

!InputSensor methodsFor: 'cursor' stamp: ''!
peekPosition
	^ self cursorPoint! !

!InputSensor methodsFor: 'private' stamp: ''!
primCursorLocPut: t1 
	<primitive: 91>
	^ self primCursorLocPutAgain: t1 rounded! !

!InputSensor methodsFor: 'private' stamp: ''!
primCursorLocPutAgain: t1 
	<primitive: 91>
	^ self! !

!InputSensor methodsFor: 'private' stamp: ''!
primInterruptSemaphore: t1 
	<primitive: 134>
	^ self primitiveFailed! !

!InputSensor methodsFor: 'private' stamp: ''!
primKbdNext
	<primitive: 108>
	^ nil! !

!InputSensor methodsFor: 'private' stamp: ''!
primKbdPeek
	<primitive: 109>
	^ nil! !

!InputSensor methodsFor: 'private' stamp: ''!
primMouseButtons
	<primitive: 107>
	^ 0! !

!InputSensor methodsFor: 'private' stamp: ''!
primMousePt
	<primitive: 90>
	^ 0 @ 0! !

!InputSensor methodsFor: 'private' stamp: ''!
primReadJoystick: t1 
	<primitive: 'primitiveReadJoystick' module: 'JoystickTabletPlugin'>
	^ 0! !

!InputSensor methodsFor: 'private' stamp: ''!
primSetInterruptKey: t1 
	<primitive: 133>
	^ self primitiveFailed! !

!InputSensor methodsFor: 'private' stamp: ''!
primTabletGetParameters: t1 
	<primitive: 'primitiveGetTabletParameters' module: 'JoystickTabletPlugin'>
	^ nil! !

!InputSensor methodsFor: 'private' stamp: ''!
primTabletRead: t1 
	<primitive: 'primitiveReadTablet' module: 'JoystickTabletPlugin'>
	self primitiveFailed! !

!InputSensor methodsFor: 'modifier keys' stamp: ''!
rawMacOptionKeyPressed
	^ self primMouseButtons anyMask: 32! !

!InputSensor methodsFor: 'mouse' stamp: ''!
redButtonPressed
	^ (self primMouseButtons bitAnd: 7)
		= 4! !

!InputSensor methodsFor: 'user interrupts' stamp: ''!
setInterruptKey: t1 
	self primSetInterruptKey: t1! !

!InputSensor methodsFor: 'modifier keys' stamp: ''!
shiftPressed
	^ self primMouseButtons anyMask: 8! !

!InputSensor methodsFor: 'initialize' stamp: ''!
shutDown
	InterruptWatcherProcess
		ifNotNil: [InterruptWatcherProcess terminate.
			InterruptWatcherProcess := nil]! !

!InputSensor methodsFor: 'initialize' stamp: ''!
startUp
	self installInterruptWatcher! !

!InputSensor methodsFor: 'tablet' stamp: ''!
tabletExtent
	| t1 |
	t1 := self primTabletGetParameters: 1.
	t1
		ifNil: [^ self error: 'no tablet available'].
	^ (t1 at: 1)
		@ (t1 at: 2)! !

!InputSensor methodsFor: 'tablet' stamp: ''!
tabletPoint
	| t1 |
	t1 := self primTabletRead: 1.
	^ (t1 at: 3)
		@ (t1 at: 4)! !

!InputSensor methodsFor: 'tablet' stamp: ''!
tabletPressure
	| t1 t2 |
	t1 := self primTabletGetParameters: 1.
	t1
		ifNil: [^ self].
	t2 := self primTabletRead: 1.
	^ (t2 at: 10) asFloat / ((t1 at: 10)
			- 1)! !

!InputSensor methodsFor: 'tablet' stamp: ''!
tabletTimestamp
	| t1 |
	t1 := self primTabletRead: 1.
	^ t1 at: 2! !

!InputSensor methodsFor: 'joystick' stamp: ''!
testJoystick: t1 
	| t2 t3 t4 t5 |
	t2 := Form extent: 110 @ 50.
	[Sensor anyButtonPressed]
		whileFalse: [t3 := Sensor joystickXY: t1.
			t4 := Sensor joystickButtons: t1.
			t5 := 'xy: ' , t3 printString , '
buttons: ' , t4 printStringHex.
			t2 fillWhite.
			t5 displayOn: t2 at: 10 @ 10.
			t2 displayOn: Display at: 10 @ 10]! !

!InputSensor methodsFor: 'user interrupts' stamp: 'nice 3/31/2011 01:37'!
userInterruptWatcher
	"Wait for user interrupts and open a notifier on the active process when one occurs."

	[ InterruptSemaphore wait.
	Display deferUpdates: false.
	SoundService default shutDown.
	Smalltalk handleUserInterrupt ] repeat! !

!InputSensor methodsFor: 'mouse' stamp: ''!
waitButton
	| t1 |
	t1 := Delay forMilliseconds: 50.
	[self anyButtonPressed]
		whileFalse: [t1 wait].
	^ self cursorPoint! !

!InputSensor methodsFor: 'mouse' stamp: ''!
waitButtonOrKeyboard
	| t1 |
	t1 := Delay forMilliseconds: 50.
	[self anyButtonPressed]
		whileFalse: [t1 wait.
			self keyboardPressed
				ifTrue: [^ nil]].
	^ self cursorPoint! !

!InputSensor methodsFor: 'mouse' stamp: ''!
waitClickButton
	self waitButton.
	^ self waitNoButton! !

!InputSensor methodsFor: 'mouse' stamp: ''!
waitNoButton
	| t1 |
	t1 := Delay forMilliseconds: 50.
	[self anyButtonPressed]
		whileTrue: [t1 wait].
	^ self cursorPoint! !

!InputSensor methodsFor: 'mouse' stamp: ''!
yellowButtonPressed
	^ (self primMouseButtons bitAnd: 7)
		= 2! !

Object subclass: #InstructionClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

InstructionClient subclass: #BlockStartLocator
	instanceVariableNames: 'nextJumpIsAroundBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!BlockStartLocator methodsFor: 'initialize-release' stamp: ''!
initialize
	nextJumpIsAroundBlock := false! !

!BlockStartLocator methodsFor: 'instruction decoding' stamp: ''!
jump: t1 
	nextJumpIsAroundBlock
		ifTrue: [nextJumpIsAroundBlock := false.
			^ t1]! !

!BlockStartLocator methodsFor: 'instruction decoding' stamp: ''!
pushClosureCopyNumCopiedValues: t1 numArgs: t2 blockSize: t3 
	^ t3! !

!BlockStartLocator methodsFor: 'instruction decoding' stamp: ''!
send: t1 super: t2 numArgs: t3 
	nextJumpIsAroundBlock := #closureCopy:copiedValues: == t1! !

InstructionClient subclass: #ClosureExtractor
	instanceVariableNames: 'action scanner currentContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!ClosureExtractor commentStamp: 'mha 9/21/2010 11:16' prior: 0!
A ClosureExtractor is a utility class that is used to extract all BlockClosures from a CompiledMethod. It inherits from InstructionClient and understands only one single message, namely that corresponding to the push closure bytecode instruction. Being sent this message, a ClosureExtractor will create a BlockClosure instance and evaluate the block it holds as an instance variable with that closure as parameter.!

!ClosureExtractor class methodsFor: 'instance creation' stamp: 'mha 9/21/2010 11:34'!
withAction: aBlock andScanner: anInstructionStream
	"The passed block must accept one value, which will be a BlockClosure."
	^ self new action: aBlock; scanner: anInstructionStream! !

!ClosureExtractor methodsFor: 'accessing' stamp: 'mha 9/21/2010 11:18'!
action
	^ action! !

!ClosureExtractor methodsFor: 'accessing' stamp: 'mha 9/21/2010 11:18'!
action: aBlock
	action := aBlock! !

!ClosureExtractor methodsFor: 'instruction decoding' stamp: 'eem 10/24/2012 14:08'!
blockReturnTop
	currentContext := currentContext sender! !

!ClosureExtractor methodsFor: 'instruction decoding' stamp: 'eem 10/24/2012 14:11'!
pushClosureCopyNumCopiedValues: numCopied numArgs: numArgs blockSize: blockSize
	"Create a BlockClosure corresponding to the closure bytecode
	 and execute the action block with it. The created BlockClosure is only a pseudo value,
	 it is not populated with meaningful context and argument information."
	| block |
	block := BlockClosure
				outerContext: currentContext
				startpc: scanner pc
				numArgs: numArgs
				copiedValues: (Array new: numCopied)..
	currentContext := block asContextWithSender: currentContext.
	action value: block! !

!ClosureExtractor methodsFor: 'accessing' stamp: 'mha 9/21/2010 11:35'!
scanner
	^ scanner! !

!ClosureExtractor methodsFor: 'accessing' stamp: 'eem 10/24/2012 14:09'!
scanner: anInstructionStream
	scanner := anInstructionStream.
	currentContext := MethodContext
							sender: nil
							receiver: self
							method: scanner method
							arguments: (Array new: scanner method numArgs)! !

InstructionClient subclass: #InstVarRefLocator
	instanceVariableNames: 'bingo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!InstVarRefLocator methodsFor: 'initialize-release' stamp: ''!
interpretNextInstructionUsing: t1 
	bingo := false.
	t1 interpretNextInstructionFor: self.
	^ bingo! !

!InstVarRefLocator methodsFor: 'instruction decoding' stamp: ''!
popIntoReceiverVariable: t1 
	bingo := true! !

!InstVarRefLocator methodsFor: 'instruction decoding' stamp: ''!
pushReceiverVariable: t1 
	bingo := true! !

!InstVarRefLocator methodsFor: 'instruction decoding' stamp: ''!
storeIntoReceiverVariable: t1 
	bingo := true! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
blockReturnTop
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
doDup
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
doPop
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
jump: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
jump: t1 if: t2 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
methodReturnConstant: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
methodReturnReceiver
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
methodReturnTop
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
popIntoLiteralVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
popIntoReceiverVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
popIntoRemoteTemp: t1 inVectorAt: t2 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
popIntoTemporaryVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushActiveContext
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushClosureCopyNumCopiedValues: t1 numArgs: t2 blockSize: t3 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushConsArrayWithElements: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushConstant: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushLiteralVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushNewArrayOfSize: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushReceiver
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushReceiverVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushRemoteTemp: t1 inVectorAt: t2 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
pushTemporaryVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
send: t1 super: t2 numArgs: t3 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
storeIntoLiteralVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
storeIntoReceiverVariable: t1 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
storeIntoRemoteTemp: t1 inVectorAt: t2 
	^ self! !

!InstructionClient methodsFor: 'instruction decoding' stamp: ''!
storeIntoTemporaryVariable: t1 
	^ self! !

InstructionClient subclass: #InstructionPrinter
	instanceVariableNames: 'method scanner stream oldPC innerIndents indent printPC indentSpanOfFollowingJump'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!InstructionPrinter class methodsFor: 'printing' stamp: ''!
on: t1 
	^ self new method: t1! !

!InstructionPrinter class methodsFor: 'printing' stamp: ''!
printClass: t1 
	| t2 |
	t2 := FileStream newFileNamed: t1 name , '.bytes'.
	t1
		selectorsAndMethodsDo: [:t3 :t4 | 
			t2 cr; nextPutAll: t3; cr.
			(self on: t4)
				printInstructionsOn: t2].
	t2 close! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
blockReturnTop
	self print: 'blockReturn'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
doDup
	self print: 'dup'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
doPop
	self print: 'pop'! !

!InstructionPrinter methodsFor: 'accessing' stamp: ''!
indent
	^ indent
		ifNil: [0]! !

!InstructionPrinter methodsFor: 'initialize-release' stamp: ''!
indent: t1 
	indent := t1! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
jump: t1 
	self print: 'jumpTo: ' , (scanner pc + t1) printString.
	indentSpanOfFollowingJump
		ifTrue: [indentSpanOfFollowingJump := false.
			innerIndents
				atAll: (scanner pc to: scanner pc + t1 - 1)
				put: (innerIndents at: scanner pc - 1)
						+ 1]! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
jump: t1 if: t2 
	self print: (t2
			ifTrue: ['jumpTrue: ']
			ifFalse: ['jumpFalse: '])
			, (scanner pc + t1) printString! !

!InstructionPrinter methodsFor: 'accessing' stamp: ''!
method
	^ method! !

!InstructionPrinter methodsFor: 'accessing' stamp: ''!
method: t1 
	method := t1.
	printPC := true.
	indentSpanOfFollowingJump := false! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
methodReturnConstant: t1 
	self print: 'return: ' , t1 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
methodReturnReceiver
	self print: 'returnSelf'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
methodReturnTop
	self print: 'returnTop'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
popIntoLiteralVariable: t1 
	self print: 'popIntoLit: ' , t1 key! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
popIntoReceiverVariable: t1 
	self print: 'popIntoRcvr: ' , t1 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
popIntoRemoteTemp: t1 inVectorAt: t2 
	self print: 'popIntoTemp: ' , t1 printString , ' inVectorAt: ' , t2 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
popIntoTemporaryVariable: t1 
	self print: 'popIntoTemp: ' , t1 printString! !

!InstructionPrinter methodsFor: 'printing' stamp: ''!
print: t1 
	| t2 |
	stream tab: self indent.
	printPC
		ifTrue: [stream print: oldPC;
				 space].
	stream
		tab: (innerIndents at: oldPC).
	stream nextPut: $<.
	oldPC
		to: scanner pc - 1
		do: [:t3 | 
			t2 := (method at: t3)
						radix: 16.
			stream
				nextPut: (t2 size < 2
						ifTrue: [$0]
						ifFalse: [t2 at: 1]).
			stream nextPut: t2 last;
				 space].
	stream skip: -1.
	stream nextPut: $>.
	stream space.
	stream nextPutAll: t1.
	stream cr.
	oldPC := scanner pc! !

!InstructionPrinter methodsFor: 'initialize-release' stamp: ''!
printInstructionsOn: t1 
	| t2 |
	stream := t1.
	scanner := InstructionStream on: method.
	t2 := method endPC.
	oldPC := scanner pc.
	innerIndents := Array new: t2 withAll: 0.
	[scanner pc <= t2]
		whileTrue: [scanner interpretNextInstructionFor: self]! !

!InstructionPrinter methodsFor: 'initialize-release' stamp: ''!
printInstructionsOn: t1 do: t2 
	| t3 |
	stream := t1.
	scanner := InstructionStream on: method.
	t3 := method endPC.
	oldPC := scanner pc.
	innerIndents := Array new: t3 withAll: 0.
	[scanner pc <= t3]
		whileTrue: [scanner interpretNextInstructionFor: self.
			t2
				value: self
				value: scanner
				value: stream]! !

!InstructionPrinter methodsFor: 'accessing' stamp: ''!
printPC
	^ printPC! !

!InstructionPrinter methodsFor: 'accessing' stamp: ''!
printPC: t1 
	printPC := t1! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushActiveContext
	self print: 'pushThisContext: '! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushClosureCopyNumCopiedValues: t1 numArgs: t2 blockSize: t3 
	self print: 'closureNumCopied: ' , t1 printString , ' numArgs: ' , t2 printString , ' bytes ' , scanner pc printString , ' to ' , (scanner pc + t3 - 1) printString.
	innerIndents
		atAll: (scanner pc to: scanner pc + t3 - 1)
		put: (innerIndents at: scanner pc - 1)
				+ 1! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushConsArrayWithElements: t1 
	self print: 'pop ' , t1 printString , ' into (Array new: ' , t1 printString , ')'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushConstant: t1 
	self
		print: (String
				streamContents: [:t2 | 
					t2 nextPutAll: 'pushConstant: '.
					(t1 isKindOf: LookupKey)
						ifTrue: [t1 key
								ifNil: [t2 nextPutAll: '###';
										 nextPutAll: t1 value soleInstance name]
								ifNotNil: [t2 nextPutAll: '##';
										 nextPutAll: t1 key]]
						ifFalse: [t1 printOn: t2]]).
	(t1 isKindOf: CompiledMethod)
		ifTrue: [t1 longPrintOn: stream indent: self indent + 2.
			^ self]! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushLiteralVariable: t1 
	self print: 'pushLit: ' , t1 key! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushNewArrayOfSize: t1 
	self print: 'push: (Array new: ' , t1 printString , ')'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushReceiver
	self print: 'self'! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushReceiverVariable: t1 
	self print: 'pushRcvr: ' , t1 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushRemoteTemp: t1 inVectorAt: t2 
	self print: 'pushTemp: ' , t1 printString , ' inVectorAt: ' , t2 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
pushTemporaryVariable: t1 
	self print: 'pushTemp: ' , t1 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
send: t1 super: t2 numArgs: t3 
	self print: (t2
			ifTrue: ['superSend: ']
			ifFalse: ['send: '])
			, t1.
	indentSpanOfFollowingJump := #(#blockCopy: #closureCopy:copiedValues: ) includes: t1! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
storeIntoLiteralVariable: t1 
	self print: 'storeIntoLit: ' , t1 key! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
storeIntoReceiverVariable: t1 
	self print: 'storeIntoRcvr: ' , t1 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
storeIntoRemoteTemp: t1 inVectorAt: t2 
	self print: 'storeIntoTemp: ' , t1 printString , ' inVectorAt: ' , t2 printString! !

!InstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
storeIntoTemporaryVariable: t1 
	self print: 'storeIntoTemp: ' , t1 printString! !

Object subclass: #InstructionStream
	instanceVariableNames: 'sender pc'
	classVariableNames: 'SpecialConstants'
	poolDictionaries: ''
	category: 'Kernel-Methods'!

InstructionStream subclass: #ContextPart
	instanceVariableNames: 'stackp'
	classVariableNames: 'PrimitiveFailToken QuickStep'
	poolDictionaries: ''
	category: 'Kernel-Methods'!

ContextPart variableSubclass: #BlockContext
	instanceVariableNames: 'nargs startpc home'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!BlockContext methodsFor: 'private' stamp: ''!
aboutToReturn: t1 through: t2 
	self home return: t1! !

!BlockContext methodsFor: 'accessing' stamp: ''!
activeHome
	^ self caller
		findContextSuchThat: [:t1 | t1 = home]! !

!BlockContext methodsFor: 'accessing' stamp: ''!
argumentCount
	^ self numArgs! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
asContext
	^ self! !

!BlockContext methodsFor: 'exceptions' stamp: ''!
assert
	self assert: self! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
bench
	| t1 t2 t3 |
	t3 := 0.
	t2 := Time millisecondClockValue + 5000.
	t1 := Time millisecondClockValue.
	[Time millisecondClockValue > t2]
		whileFalse: [self value.
			t3 := t3 + 1].
	t2 := Time millisecondClockValue.
	^ t3 = 1
		ifTrue: [(t2 - t1 // 1000) printString , ' seconds.']
		ifFalse: [(t3 * 1000 / (t2 - t1)) asFloat printString , ' per second.']! !

!BlockContext methodsFor: 'instruction decoding' stamp: ''!
blockReturnTop
	| t1 t2 |
	t1 := home.
	t2 := self return: self pop from: self.
	home := t1.
	sender := nil.
	^ t2! !

!BlockContext methodsFor: 'accessing' stamp: ''!
caller
	^ sender! !

!BlockContext methodsFor: 'private' stamp: ''!
cannotReturn: t1 
	| t2 t3 |
	t2 := BlockCannotReturn new.
	t2 result: t1.
	t3 := t2 signal.
	^ t3! !

!BlockContext methodsFor: 'accessing' stamp: ''!
closureHome
	^ self home! !

!BlockContext methodsFor: 'accessing' stamp: ''!
contextForLocalVariables
	^ home! !

!BlockContext methodsFor: 'accessing' stamp: ''!
copyForSaving
	home := home copy.
	home swapSender: nil! !

!BlockContext methodsFor: 'evaluating' stamp: 'nice 10/11/2010 23:31'!
cull: firstArg
	"Activate the receiver, with one or zero arguments."
	
	self numArgs >= 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!BlockContext methodsFor: 'evaluating' stamp: 'nice 10/11/2010 23:32'!
cull: firstArg cull: secondArg
	"Activate the receiver, with two or less arguments."
	
	self numArgs >= 2 ifTrue: [ ^self value: firstArg value: secondArg ].	
	self numArgs = 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!BlockContext methodsFor: 'evaluating' stamp: 'nice 10/11/2010 23:32'!
cull: firstArg cull: secondArg cull: thirdArg
	"Activate the receiver, with three or less arguments."
	
	self numArgs >= 2 ifTrue: [ 
		self numArgs >= 3 ifTrue: [ ^self value: firstArg value: secondArg value: thirdArg ].
		^self value: firstArg value: secondArg ].
	self numArgs = 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!BlockContext methodsFor: 'evaluating' stamp: 'nice 10/11/2010 23:32'!
cull: firstArg cull: secondArg cull: thirdArg cull: fourthArg
	"Activate the receiver, with four or less arguments."
	
	self numArgs >= 3 ifTrue: [
		self numArgs >= 4 ifTrue: [
			^self value: firstArg value: secondArg value: thirdArg value: fourthArg ].
		^self value: firstArg value: secondArg value: thirdArg ].
	self numArgs = 2 ifTrue: [ ^self value: firstArg value: secondArg ].	
	self numArgs = 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!BlockContext methodsFor: 'printing' stamp: ''!
decompile
	^ home method decompilerClass new decompileBlock: self! !

!BlockContext methodsFor: 'printing' stamp: ''!
decompileString
	^ self decompile decompileString! !

!BlockContext methodsFor: 'controlling' stamp: ''!
doWhileFalse: t1 
	| t2 |
	[t2 := self value.
	t1 value] whileFalse.
	^ t2! !

!BlockContext methodsFor: 'controlling' stamp: ''!
doWhileTrue: t1 
	| t2 |
	[t2 := self value.
	t1 value] whileTrue.
	^ t2! !

!BlockContext methodsFor: 'evaluating' stamp: 'brp 9/25/2003 13:49'!
durationToRun
	"Answer the duration taken to execute this block."

	^ Duration milliSeconds: self timeToRun

! !

!BlockContext methodsFor: 'private' stamp: ''!
endPC
	^ (self method at: startpc - 2)
		\\ 16 - 4 * 256
		+ (self method at: startpc - 1) + startpc - 1! !

!BlockContext methodsFor: 'exceptions' stamp: ''!
ensure: t1 
	| t2 t3 |
	<primitive: 198>
	t3 := self value.
	t2
		ifNil: [t2 := true.
			t1 value].
	^ t3! !

!BlockContext methodsFor: 'accessing' stamp: ''!
fixTemps
	home := home copy.
	home swapSender: nil! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
fork
	^ self newProcess resume! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
forkAndWait
	| t1 |
	t1 := Semaphore new.
	[self
		ensure: [t1 signal]] fork.
	t1 wait! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
forkAt: t1 
	| t2 |
	t2 := self newProcess.
	t2 priority: t1.
	^ t2 resume! !

!BlockContext methodsFor: 'scheduling' stamp: 'svp 6/23/2003 10:59'!
forkAt: priority named: name
	"Create and schedule a Process running the code in the receiver at the
	given priority and having the given name. Answer the newly created 
	process."

	| forkedProcess |
	forkedProcess := self newProcess.
	forkedProcess priority: priority.
	forkedProcess name: name.
	^ forkedProcess resume! !

!BlockContext methodsFor: 'scheduling' stamp: 'svp 6/23/2003 10:59'!
forkNamed: aString
	"Create and schedule a Process running the code in the receiver and
	having the given name."

	^ self newProcess name: aString; resume! !

!BlockContext methodsFor: 'printing' stamp: ''!
fullPrintOn: t1 
	t1 print: self;
		 cr.
	(self decompile
		ifNil: ['--source missing--'])
		printOn: t1
		indent: 0! !

!BlockContext methodsFor: 'accessing' stamp: ''!
hasInstVarRef
	| t1 t2 t3 t4 |
	home
		ifNil: [^ false].
	t1 := self method.
	t3 := self endPC.
	t2 := InstructionStream new method: t1 pc: startpc.
	t4 := InstVarRefLocator new.
	[t2 pc <= t3]
		whileTrue: [(t4 interpretNextInstructionUsing: t2)
				ifTrue: [^ true]].
	^ false! !

!BlockContext methodsFor: 'accessing' stamp: ''!
hasMethodReturn
	| t1 t2 t3 |
	t1 := self method.
	t3 := (t1 at: startpc - 2)
				\\ 16 - 4 * 256
				+ (t1 at: startpc - 1) + startpc - 1.
	t2 := InstructionStream new method: t1 pc: startpc.
	t2
		scanFor: [:t4 | (t4 between: 120 and: 124)
				or: [t2 pc > t3]].
	^ t2 pc <= t3! !

!BlockContext methodsFor: 'private' stamp: ''!
hideFromDebugger
	^ home ~~ nil
		and: [home hideFromDebugger]! !

!BlockContext methodsFor: 'accessing' stamp: ''!
home
	^ home! !

!BlockContext methodsFor: 'initialize-release' stamp: ''!
home: t1 startpc: t2 nargs: t3 
	home := t1.
	pc := startpc := t2.
	nargs := t3.
	stackp := 0! !

!BlockContext methodsFor: 'exceptions' stamp: ''!
ifCurtailed: t1 
	| t2 t3 |
	<primitive: 198>
	t3 := self value.
	t2 := true.
	^ t3! !

!BlockContext methodsFor: 'evaluating' stamp: 'HenrikSperreJohansen 6/28/2010 12:12'!
ifError: errorHandlerBlock
	"Evaluate the block represented by the receiver, and normally return it's value.  If an error occurs, the errorHandlerBlock is evaluated, and it's value is instead returned.  The errorHandlerBlock must accept zero, one, or two parameters (the error message and the receiver)."
	"Examples:
		[1 whatsUpDoc] ifError: [:err :rcvr | 'huh?'].
		[1 / 0] ifError: [:err :rcvr |
			'ZeroDivide' = err
				ifTrue: [Float infinity]
				ifFalse: [self error: err]]
"

	^ self on: Error do: [:ex |
		errorHandlerBlock cull: ex description cull: ex receiver]! !

!BlockContext methodsFor: 'private' stamp: ''!
instVarAt: t1 put: t2 
	t1 = 3
		ifTrue: [self stackp: t2.
			^ t2].
	^ super instVarAt: t1 put: t2! !

!BlockContext methodsFor: 'accessing' stamp: ''!
isBlock
	^ true! !

!BlockContext methodsFor: 'accessing' stamp: ''!
isExecutingBlock
	^ true! !

!BlockContext methodsFor: 'accessing' stamp: ''!
method
	^ home method! !

!BlockContext methodsFor: 'accessing' stamp: ''!
methodReturnContext
	^ home! !

!BlockContext methodsFor: 'private' stamp: ''!
myEnv
	^ nil! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
newProcess
	<primitive: 19>
	^ Process forContext: [self value.
		Processor terminateActive] asContext priority: Processor activePriority! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
newProcessWith: t1 
	<primitive: 19>
	^ Process forContext: [self valueWithArguments: t1.
		Processor terminateActive] asContext priority: Processor activePriority! !

!BlockContext methodsFor: 'accessing' stamp: ''!
numArgs
	^ nargs! !

!BlockContext methodsFor: 'exceptions' stamp: ''!
on: t1 do: t2 
	| t3 |
	<primitive: 199>
	t3 := true.
	^ self value! !

!BlockContext methodsFor: 'exceptions' stamp: 'ul 8/2/2011 20:14'!
on: exc1 do: block1 on: exc2 do: block2

	^[
		self
			on: exc1
			do: block1 ]
		on: exc2
		do: block2! !

!BlockContext methodsFor: 'exceptions' stamp: 'ul 8/2/2011 20:14'!
on: exc1 do: block1 on: exc2 do: block2 on: exc3 do: block3

	^[
		self
			on: exc1
			do: block1 ]
		on: exc2
		do: block2
		on: exc3
		do: block3! !

!BlockContext methodsFor: 'exceptions' stamp: ''!
onDNU: t1 do: t2 
	^ self
		on: MessageNotUnderstood
		do: [:t3 | t3 message selector = t1
				ifTrue: [t2 valueWithPossibleArgs: {t3}]
				ifFalse: [t3 pass]]! !

!BlockContext methodsFor: 'printing' stamp: ''!
printOn: t1 
	| t2 t3 t4 |
	home
		ifNil: [^ t1 nextPutAll: 'a BlockContext with home=nil'].
	t1 nextPutAll: '[] in '.
	super printOn: t1.
	t2 := [self decompile
				ifNil: ['--source missing--']]
				on: Error
				do: [:t5 | ' (error in decompilation)'].
	t3 := ((t2 isString
				ifTrue: [t2]
				ifFalse: [t2 printString])
				replaceAll: Character cr
				with: Character space)
				replaceAll: Character tab
				with: Character space.
	t4 := t3 truncateWithElipsisTo: 80.
	t4 size < t3 size
		ifTrue: [t4 := t4 , ']}'].
	t1 space; nextPutAll: t4! !

!BlockContext methodsFor: 'printing' stamp: ''!
printOnStream: t1 
	home
		ifNil: [^ t1 print: 'a BlockContext with home=nil'].
	t1 print: '[] in '.
	super printOnStream: t1! !

!BlockContext methodsFor: 'private' stamp: ''!
privHome: t1 
	home := t1! !

!BlockContext methodsFor: 'initialize-release' stamp: ''!
privRefresh
	pc := startpc.
	self stackp: 0.
	nargs
		timesRepeat: [self nextInstruction selector = #popIntoTemporaryVariable:
				ifFalse: [self halt: 'unexpected bytecode instruction']]! !

!BlockContext methodsFor: 'system simulation' stamp: ''!
pushArgs: t1 from: t2 
	t1 size ~= nargs
		ifTrue: [^ self error: 'incorrect number of args'].
	self stackp: 0.
	t1
		do: [:t3 | self push: t3].
	sender := t2.
	pc := startpc! !

!BlockContext methodsFor: 'accessing' stamp: ''!
receiver
	^ home receiver! !

!BlockContext methodsFor: 'accessing' stamp: ''!
reentrant
	^ self copy! !

!BlockContext methodsFor: 'controlling' stamp: ''!
repeat
	[self value.
	true] whileTrue! !

!BlockContext methodsFor: 'controlling' stamp: ''!
repeatWithGCIf: t1 
	| t2 |
	t2 := self value.
	(t1 value: t2)
		ifTrue: [Smalltalk garbageCollect.
			t2 := self value].
	^ t2! !

!BlockContext methodsFor: 'private' stamp: ''!
startpc
	^ startpc! !

!BlockContext methodsFor: 'system simulation' stamp: ''!
stepToSendOrReturn
	pc = startpc
		ifTrue: [self numArgs
				timesRepeat: [self step]].
	^ super stepToSendOrReturn! !

!BlockContext methodsFor: 'accessing' stamp: ''!
tempAt: t1 
	^ home at: t1! !

!BlockContext methodsFor: 'accessing' stamp: ''!
tempAt: t1 put: t2 
	^ home at: t1 put: t2! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
timeToRun
	^ Time millisecondsToRun: self! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
value
	<primitive: 81>
	^ self valueWithArguments: #()! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
value: t1 
	<primitive: 81>
	^ self
		valueWithArguments: (Array with: t1)! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
value: t1 value: t2 
	<primitive: 81>
	^ self
		valueWithArguments: (Array with: t1 with: t2)! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
value: t1 value: t2 value: t3 
	<primitive: 81>
	^ self
		valueWithArguments: (Array
				with: t1
				with: t2
				with: t3)! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
value: t1 value: t2 value: t3 value: t4 
	<primitive: 81>
	^ self
		valueWithArguments: (Array
				with: t1
				with: t2
				with: t3
				with: t4)! !

!BlockContext methodsFor: 'scheduling' stamp: ''!
valueAt: t1 
	| t2 t3 t4 |
	t2 := Processor activeProcess.
	t4 := t2 priority.
	t2 priority: t1.
	t3 := self
				ensure: [t2 priority: t4].
	t1 > t4
		ifTrue: [Processor yield].
	^ t3! !

!BlockContext methodsFor: 'private' stamp: ''!
valueError
	self error: 'Incompatible number of args, or already active'! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueSupplyingAnswer: t1 
	^ (t1 isCollection
			and: [t1 isString not])
		ifTrue: [self valueSupplyingAnswers: {t1}]
		ifFalse: [self valueSupplyingAnswers: {{'*'. t1}}]! !

!BlockContext methodsFor: 'evaluating' stamp: 'ul 8/2/2011 20:14'!
valueSupplyingAnswers: aListOfPairs
	"evaluate the block using a list of questions / answers that might be called upon to
	automatically respond to Object>>confirm: or FillInTheBlank requests"

	^self
		on: ProvideAnswerNotification
		do: 
			[:notify | | answer caption |
			
			caption := notify messageText withSeparatorsCompacted. "to remove new lines"
			answer := aListOfPairs
				detect: 
					[:each | caption = each first
						or: [(caption includesSubstring: each first caseSensitive: false)
						or: [each first match: caption]]]
					ifNone: [nil].
			answer
				ifNotNil: [notify resume: answer second]
				ifNil: 
					[ | outerAnswer |
					outerAnswer := ProvideAnswerNotification signal: notify messageText.
					outerAnswer 
						ifNil: [notify resume] 
						ifNotNil: [notify resume: outerAnswer]]]! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueSuppressingAllMessages
	^ self valueSuppressingMessages: #('*' )! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueSuppressingMessages: t1 
	^ self valueSuppressingMessages: t1 supplyingAnswers: #()! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueSuppressingMessages: t1 supplyingAnswers: t2 
	^ self valueSupplyingAnswers: t2
			, (t1
					collect: [:t3 | {t3. true}])! !

!BlockContext methodsFor: 'exceptions' stamp: ''!
valueUninterruptably
	^ self
		ifCurtailed: [^ self]! !

!BlockContext methodsFor: 'private' stamp: ''!
valueUnpreemptively
	| t1 t2 t3 |
	t1 := Processor activeProcess.
	t2 := t1 priority.
	t1 priority: Processor highestPriority.
	t3 := self
				ensure: [t1 priority: t2].
	Processor yield.
	^ t3! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueWithArguments: t1 
	<primitive: 82>
	t1 isArray
		ifFalse: [^ self error: 'valueWithArguments: expects an array'].
	self numArgs = t1 size
		ifTrue: [self error: 'Attempt to evaluate a block that is already being evaluated.']
		ifFalse: [self error: 'This block accepts ' , self numArgs printString , ' argument'
					, (self numArgs = 1
							ifTrue: ['']
							ifFalse: ['s']) , ', but was called with ' , t1 size printString , '.']! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueWithEnoughArguments: t1 
	| t2 |
	t1 size == self numArgs
		ifTrue: [^ self valueWithArguments: t1].
	t2 := Array new: self numArgs.
	t2
		replaceFrom: 1
		to: (t1 size min: t2 size)
		with: t1
		startingAt: 1.
	^ self valueWithArguments: t2! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueWithExit
	self
		value: [^ nil]! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueWithPossibleArgs: t1 
	self numArgs = 0
		ifTrue: [^ self value].
	self numArgs = t1 size
		ifTrue: [^ self valueWithArguments: t1].
	self numArgs > t1 size
		ifTrue: [^ self valueWithArguments: t1
					, (Array new: self numArgs - t1 size)].
	^ self
		valueWithArguments: (t1 copyFrom: 1 to: self numArgs)! !

!BlockContext methodsFor: 'evaluating' stamp: ''!
valueWithPossibleArgument: t1 
	self numArgs = 0
		ifTrue: [^ self value].
	self numArgs = 1
		ifTrue: [^ self value: t1].
	self numArgs > 1
		ifTrue: [^ self valueWithArguments: {t1}
					, (Array new: self numArgs - 1)]! !

!BlockContext methodsFor: 'evaluating' stamp: 'ar 12/4/2012 20:37'!
valueWithin: aDuration onTimeout: timeoutBlock
	"Evaluate the receiver.
	If the evaluation does not complete in less than aDuration evaluate the timeoutBlock instead"

	| theProcess delay watchdog tag |

	aDuration <= Duration zero ifTrue: [^ timeoutBlock value ].

	"the block will be executed in the current process"
	theProcess := Processor activeProcess.
	delay := aDuration asDelay.
	tag := self.

	"make a watchdog process"
	watchdog := [
		delay wait. 	"wait for timeout or completion"
		theProcess ifNotNil:[ theProcess signalException: (TimedOut new tag: tag)] 
	] newProcess.

	"Watchdog needs to run at high priority to do its job (but not at timing priority)"
	watchdog priority: Processor timingPriority-1.

	"catch the timeout signal"
	^ [	watchdog resume.				"start up the watchdog"
		self ensure:[						"evaluate the receiver"
			theProcess := nil.				"it has completed, so ..."
			delay delaySemaphore signal.	"arrange for the watchdog to exit"
		]] on: TimedOut do: [ :e | 
			e tag == tag 
				ifTrue:[ timeoutBlock value ]
				ifFalse:[ e pass]].! !

!BlockContext methodsFor: 'controlling' stamp: ''!
whileFalse
	[self value] whileFalse.
	^ nil! !

!BlockContext methodsFor: 'controlling' stamp: ''!
whileFalse: t1 
	[self value]
		whileFalse: [t1 value].
	^ nil! !

!BlockContext methodsFor: 'controlling' stamp: ''!
whileTrue
	[self value] whileTrue.
	^ nil! !

!BlockContext methodsFor: 'controlling' stamp: ''!
whileTrue: t1 
	[self value]
		whileTrue: [t1 value].
	^ nil! !

!ContextPart class methodsFor: 'instance creation' stamp: 'cmm 8/1/2011 13:41'!
basicNew: size 
	^ (size = CompiledMethod smallFrameSize or: [ size = CompiledMethod fullFrameSize ])
		ifTrue: [ super basicNew: size ]
		ifFalse: [ self error: 'Contexts must be ' , CompiledMethod smallFrameSize , ' or ' , CompiledMethod fullFrameSize , ' bytes.' ]! !

!ContextPart class methodsFor: 'private' stamp: ''!
carefullyPrint: t1 on: t2 
	t2
		nextPutAll: ([t1 printString]
				on: Error
				do: ['unprintable ' , t1 class name])! !

!ContextPart class methodsFor: 'special context creation' stamp: ''!
contextEnsure: t1 
	| t2 t3 |
	t2 := thisContext.
	[t3 := thisContext sender cut: t2.
	t2 jump]
		ensure: t1.
	^ t3! !

!ContextPart class methodsFor: 'special context creation' stamp: ''!
contextOn: t1 do: t2 
	| t3 t4 |
	t3 := thisContext.
	[t4 := thisContext sender cut: t3.
	t3 jump]
		on: t1
		do: t2.
	^ t4! !

!ContextPart class methodsFor: 'simulation' stamp: ''!
initialize
	PrimitiveFailToken := Object new! !

!ContextPart class methodsFor: 'instance creation' stamp: ''!
initializedInstance
	^ nil! !

!ContextPart class methodsFor: 'private' stamp: ''!
isContextClass
	^ true! !

!ContextPart class methodsFor: 'instance creation' stamp: ''!
new
	self error: 'Contexts must only be created with newForMethod:'! !

!ContextPart class methodsFor: 'instance creation' stamp: ''!
new: t1 
	self error: 'Contexts must only be created with newForMethod:'! !

!ContextPart class methodsFor: 'instance creation' stamp: ''!
newForMethod: t1 
	^ super basicNew: t1 frameSize! !

!ContextPart class methodsFor: 'simulation' stamp: ''!
primitiveFailToken
	^ PrimitiveFailToken! !

!ContextPart class methodsFor: 'simulation' stamp: ''!
runSimulated: t1 
	^ thisContext sender
		runSimulated: t1
		contextAtEachStep: [:t2 | t2]! !

!ContextPart class methodsFor: 'examples' stamp: ''!
tallyInstructions: t1 
	| t2 |
	t2 := Bag new.
	thisContext sender
		runSimulated: t1
		contextAtEachStep: [:t3 | t2 add: t3 nextByte].
	^ t2 sortedElements! !

!ContextPart class methodsFor: 'examples' stamp: ''!
tallyMethods: t1 
	| t2 t3 |
	t2 := Bag new.
	t3 := t1.
	thisContext sender
		runSimulated: t1
		contextAtEachStep: [:t5 | t5 == t3
				ifFalse: [t3 sender
						ifNotNil: [t2 add: t5 printString].
					t3 := t5]].
	^ t2 sortedCounts! !

!ContextPart class methodsFor: 'special context creation' stamp: ''!
theReturnMethod
	| t1 |
	t1 := self lookupSelector: #return:.
	t1 primitive = 0
		ifFalse: [^ self error: 'expected #return: to not be a primitive'].
	^ t1! !

!ContextPart class methodsFor: 'examples' stamp: ''!
trace: t1 
	Transcript clear.
	^ self trace: t1 on: Transcript! !

!ContextPart class methodsFor: 'examples' stamp: ''!
trace: t1 on: t2 
	| t3 |
	t3 := t1.
	^ thisContext sender
		runSimulated: t1
		contextAtEachStep: [:t5 | 
			Sensor anyButtonPressed
				ifTrue: [^ nil].
			t5 == t3
				ifFalse: [t3 sender
						ifNil: [t2 space; nextPut: $^.
							self carefullyPrint: t5 top on: t2].
					t2 cr.
					(t5 depthBelow: t1)
						timesRepeat: [t2 space].
					self carefullyPrint: t5 receiver on: t2.
					t2 space; nextPutAll: t5 selector; flush.
					t3 := t5]]! !

!ContextPart class methodsFor: 'examples' stamp: ''!
trace: t1 onFileNamed: t2 
	^ FileStream
		fileNamed: t2
		do: [:t3 | self trace: t1 on: t3]! !

!ContextPart methodsFor: 'controlling' stamp: ''!
activateMethod: t1 withArgs: t2 receiver: t3 class: t4 
	^ MethodContext
		sender: self
		receiver: t3
		method: t1
		arguments: t2! !

!ContextPart methodsFor: 'private' stamp: ''!
activateReturn: t1 value: t2 
	^ self
		activateMethod: ContextPart theReturnMethod
		withArgs: {t2}
		receiver: t1
		class: t1 class! !

!ContextPart methodsFor: 'accessing' stamp: ''!
at: t1 
	<primitive: 210>
	t1 isInteger
		ifTrue: [self errorSubscriptBounds: t1].
	t1 isNumber
		ifTrue: [^ self at: t1 asInteger].
	self errorNonIntegerIndex! !

!ContextPart methodsFor: 'accessing' stamp: ''!
at: t1 put: t2 
	<primitive: 211>
	t1 isInteger
		ifTrue: [self errorSubscriptBounds: t1].
	t1 isNumber
		ifTrue: [^ self at: t1 asInteger put: t2].
	self errorNonIntegerIndex! !

!ContextPart methodsFor: 'accessing' stamp: ''!
basicAt: t1 
	<primitive: 210>
	t1 isInteger
		ifTrue: [self errorSubscriptBounds: t1].
	t1 isNumber
		ifTrue: [^ self at: t1 asInteger].
	self errorNonIntegerIndex! !

!ContextPart methodsFor: 'accessing' stamp: ''!
basicAt: t1 put: t2 
	<primitive: 211>
	t1 isInteger
		ifTrue: [self errorSubscriptBounds: t1].
	t1 isNumber
		ifTrue: [^ self at: t1 asInteger put: t2].
	self errorNonIntegerIndex! !

!ContextPart methodsFor: 'accessing' stamp: ''!
basicSize
	<primitive: 212>
	^ self primitiveFail! !

!ContextPart methodsFor: 'controlling' stamp: ''!
blockCopy: t1 
	<primitive: 80>
	^ (BlockContext newForMethod: self method)
		home: self home
		startpc: pc + 2
		nargs: t1! !

!ContextPart methodsFor: 'query' stamp: ''!
bottomContext
	^ self
		findContextSuchThat: [:t1 | t1 sender isNil]! !

!ContextPart methodsFor: 'private-debugger' stamp: ''!
cachesStack
	^ false! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
canHandleSignal: t1 
	^ (((self tempAt: 1)
				handles: t1)
			and: [self tempAt: 3])
		or: [self nextHandlerContext canHandleSignal: t1]! !

!ContextPart methodsFor: 'private' stamp: ''!
cannotReturn: t1 to: t2 
	^ BlockCannotReturn new result: t1;
		 deadHome: t2;
		 signal! !

!ContextPart methodsFor: 'accessing' stamp: ''!
client
	^ sender receiver! !

!ContextPart methodsFor: 'controlling' stamp: ''!
closureCopy: t1 copiedValues: t2 
	<primitive: 200>
	^ BlockClosure
		outerContext: self
		startpc: pc + 2
		numArgs: t1
		copiedValues: t2! !

!ContextPart methodsFor: 'system simulation' stamp: ''!
completeCallee: t1 
	| t2 t3 t4 |
	t2 := t1.
	[t2 == t3
		or: [t2 hasSender: self]]
		whileTrue: [t3 := t2.
			t4 := t2 quickStep.
			t4
				ifNil: [self halt].
			t2 := t4].
	^ self stepToSendOrReturn! !

!ContextPart methodsFor: 'accessing' stamp: ''!
contextForLocalVariables
	self subclassResponsibility! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
contextStack
	^ self stackOfSize: 100000! !

!ContextPart methodsFor: 'query' stamp: ''!
copyStack
	^ self copyTo: nil! !

!ContextPart methodsFor: 'query' stamp: 'ul 4/27/2011 22:57'!
copyTo: aContext
	"Copy self and my sender chain down to, but not including, aContext.  End of copied chain will have nil sender."

	| copy |
	self == aContext ifTrue: [ ^nil ].
	copy := self copy.
	sender ifNotNil: [ copy privSender: (sender copyTo: aContext) ].
	^copy! !

!ContextPart methodsFor: 'query' stamp: 'ul 4/28/2011 00:01'!
copyTo: aContext bottomContextDo: aBlock
	"Copy self and my sender chain down to, but not including, aContext.  End of copied chain will have nil sender. Evaluate aBlock with the copy of bottom context when it still points to the original sender."

	| copy |
	self == aContext ifTrue: [ ^nil ].
	copy := self copy.
	sender
		ifNil: [ aBlock value: copy ]
		ifNotNil: [
			sender == aContext ifTrue: [ aBlock value: copy ].
			copy privSender: (sender copyTo: aContext bottomContextDo: aBlock) ].
	^copy! !

!ContextPart methodsFor: 'private' stamp: ''!
cut: t1 
	| t2 t3 |
	t2 := self.
	[t2 == t1]
		whileFalse: [t3 := t2.
			t2 := t2 sender.
			t2
				ifNil: [t1
						ifNotNil: [self error: 'aContext not a sender']]].
	t3 privSender: nil! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
depthBelow: t1 
	| t2 t3 |
	t2 := self.
	t3 := 0.
	[t2 == t1
		or: [t2 == nil]]
		whileFalse: [t2 := t2 sender.
			t3 := t3 + 1].
	^ t3! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
doDup
	self push: self top! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
doPop
	self pop! !

!ContextPart methodsFor: 'private' stamp: 'eem 1/30/2012 16:05'!
doPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The
	 simulated receiver and arguments are given as arguments to this message.
	 If successful, push result and return resuming context, else ^ PrimitiveFailToken.
	 Any primitive which provokes execution needs to be intercepted and simulated
	 to avoid execution running away."

	| value |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primtiive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[ToolSet 
			debugContext: self
			label:'Code simulation error'
			contents: nil].

	"ContextPart>>blockCopy:; simulated to get startpc right"
	(primitiveIndex = 80 and: [receiver isKindOf: ContextPart]) 
		ifTrue: [^self push: ((BlockContext newForMethod: receiver method)
						home: receiver home
						startpc: pc + 2
						nargs: (arguments at: 1))].
	(primitiveIndex = 81 and: [receiver isMemberOf: BlockContext]) "BlockContext>>value[:value:...]"
		ifTrue: [^receiver pushArgs: arguments from: self].
	(primitiveIndex = 82 and: [receiver isMemberOf: BlockContext]) "BlockContext>>valueWithArguments:"
		ifTrue: [^receiver pushArgs: arguments first from: self].
	primitiveIndex = 83 "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		ifTrue: [^self send: arguments first to: receiver
					with: arguments allButFirst
					super: false].
	primitiveIndex = 84 "afr 9/11/1998 19:50" "Object>>perform:withArguments:"
		ifTrue: [^self send: arguments first to: receiver
					with: (arguments at: 2)
					super: false].
	primitiveIndex = 188 ifTrue: [
		arguments size = 2 ifTrue: [ "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
			^MethodContext
				sender: self
				receiver: receiver
				method: (arguments at: 2)
				arguments: (arguments at: 1) ].
		arguments size = 3 ifTrue: [ "CompiledMethod class >> #receiver:withArguments:executeMethod:"
			^MethodContext
				sender: self
				receiver: (arguments at: 1)
				method: (arguments at: 3)
				arguments: (arguments at: 2) ] ].
	primitiveIndex = 189 ifTrue: [ "Object >> (#with:)*executeMethod"
		^MethodContext
			sender: self
			receiver: receiver
			method: arguments last
			arguments: arguments allButLast ].

	"Closure primitives"
	(primitiveIndex = 200 and: [receiver == self]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: receiver
						startpc: pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].
	((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
	or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
		[^receiver simulateValueWithArguments: arguments caller: self].
	primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
		[^receiver simulateValueWithArguments: arguments first caller: self].

	primitiveIndex = 120 ifTrue:[ "FFI method"
		value := meth literals first tryInvokeWithArguments: arguments.
	] ifFalse:[
		arguments size > 6 ifTrue: [^PrimitiveFailToken].
		value := primitiveIndex = 117 "named primitives"
				ifTrue:[self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
				ifFalse:[receiver tryPrimitive: primitiveIndex withArgs: arguments].
	].
	^value == PrimitiveFailToken
		ifTrue: [PrimitiveFailToken]
		ifFalse: [self push: value]! !

!ContextPart methodsFor: 'debugger access' stamp: 'mtf 6/26/2009 17:56'!
errorReportOn: strm
	"Write a detailed error report on the stack (above me) on a stream.  For both the error file, and emailing a bug report.  Suppress any errors while getting printStrings.  Limit the length."

	| cnt aContext startPos |
 	strm print: Date today; space; print: Time now; cr.
	strm cr.
	strm nextPutAll: 'VM: ';
		nextPutAll:  SmalltalkImage current platformName asString;
		nextPutAll: ' - ';
		nextPutAll: SmalltalkImage current asString;
		cr.
	strm nextPutAll: 'Image: ';
		nextPutAll:  SystemVersion current version asString;
		nextPutAll: ' [';
		nextPutAll: SmalltalkImage current lastUpdateString asString;
		nextPutAll: ']';
		cr.
	strm cr.
	SecurityManager default printStateOn: strm.
	
	"Note: The following is an open-coded version of ContextPart>>stackOfSize: since this method may be called during a low space condition and we might run out of space for allocating the full stack."
	cnt := 0.  startPos := strm position.
	aContext := self.
	[aContext notNil and: [(cnt := cnt + 1) < 20]] whileTrue:
		[aContext printDetails: strm.	"variable values"
		strm cr.
		aContext := aContext sender].

	strm cr; nextPutAll: '--- The full stack ---'; cr.
	aContext := self.
	cnt := 0.
	[aContext == nil] whileFalse:
		[cnt := cnt + 1.
		cnt = 20 ifTrue: [strm nextPutAll: ' - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -'; cr].
		strm print: aContext; cr.  "just class>>selector"	

		strm position > (startPos+40000) ifTrue: [strm nextPutAll: '...etc...'.
			^ self]. 	"exit early"
		cnt > 60 ifTrue: [strm nextPutAll: '-- and more not shown --'.  ^ self].
		aContext := aContext sender].
! !

!ContextPart methodsFor: 'query' stamp: ''!
findContextSuchThat: t1 
	| t2 |
	t2 := self.
	[t2 isNil]
		whileFalse: [(t1 value: t2)
				ifTrue: [^ t2].
			t2 := t2 sender].
	^ nil! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
findNextHandlerContextStarting
	| t1 |
	<primitive: 197>
	t1 := self.
	[t1 isHandlerContext
		ifTrue: [^ t1].
	(t1 := t1 sender) == nil] whileFalse.
	^ nil! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
findNextUnwindContextUpTo: t1 
	| t2 |
	<primitive: 195>
	t2 := self.
	[(t2 := t2 sender)
		ifNil: [true]
		ifNotNil: [t2 == t1]]
		whileFalse: [t2 isUnwindContext
				ifTrue: [^ t2]].
	^ nil! !

!ContextPart methodsFor: 'query' stamp: ''!
findSecondToOldestSimilarSender
	| t1 t2 t3 |
	t1 := self.
	t2 := self.
	[t3 := t2 findSimilarSender.
	t3 isNil]
		whileFalse: [t1 := t2.
			t2 := t3].
	^ t1! !

!ContextPart methodsFor: 'query' stamp: ''!
findSimilarSender
	| t1 |
	t1 := self method.
	^ self sender
		findContextSuchThat: [:t2 | t2 method == t1]! !

!ContextPart methodsFor: 'private-exceptions' stamp: 'nice 10/11/2010 23:25'!
handleSignal: exception
	"Sent to handler (on:do:) contexts only.  If my exception class (first arg) handles exception then execute my handle block (second arg), otherwise forward this message to the next handler context.  If none left, execute exception's defaultAction (see nil>>handleSignal:)."

	| val |
	(((self tempAt: 1) handles: exception) and: [self tempAt: 3]) ifFalse: [
		^ self nextHandlerContext handleSignal: exception].

	exception privHandlerContext: self contextTag.
	self tempAt: 3 put: false.  "disable self while executing handle block"
	val := [(self tempAt: 2) cull: exception ]
		ensure: [self tempAt: 3 put: true].
	self return: val.  "return from self if not otherwise directed in handle block"
! !

!ContextPart methodsFor: 'query' stamp: ''!
hasContext: t1 
	^ (self
		findContextSuchThat: [:t2 | t2 == t1]) notNil! !

!ContextPart methodsFor: 'controlling' stamp: ''!
hasSender: t1 
	| t2 |
	self == t1
		ifTrue: [^ false].
	t2 := sender.
	[t2 == nil]
		whileFalse: [t2 == t1
				ifTrue: [^ true].
			t2 := t2 sender].
	^ false! !

!ContextPart methodsFor: 'accessing' stamp: ''!
home
	self subclassResponsibility! !

!ContextPart methodsFor: 'private' stamp: ''!
insertSender: t1 
	| t2 |
	t2 := t1 bottomContext.
	t2 privSender: self sender.
	self privSender: t1.
	^ t2! !

!ContextPart methodsFor: 'query' stamp: ''!
isBottomContext
	^ sender isNil! !

!ContextPart methodsFor: 'query' stamp: ''!
isClosureContext
	^ false! !

!ContextPart methodsFor: 'query' stamp: ''!
isContext
	^ true! !

!ContextPart methodsFor: 'query' stamp: ''!
isDead
	^ pc isNil! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
isHandlerContext
	^ false! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
isUnwindContext
	^ false! !

!ContextPart methodsFor: 'controlling' stamp: ''!
jump
	| t1 |
	thisContext sender push: nil.
	stackp = 0
		ifTrue: [self stepToSendOrReturn].
	stackp = 0
		ifTrue: [self push: nil].
	t1 := self pop.
	thisContext privSender: self.
	^ t1! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
jump: t1 
	pc := pc + t1! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
jump: t1 if: t2 
	| t3 |
	t3 := self pop.
	(t3 == true
			or: [t3 == false])
		ifFalse: [^ self
				send: #mustBeBooleanIn:
				to: t3
				with: {self}
				super: false].
	(t3 eqv: t2)
		ifTrue: [self jump: t1]! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
longStack
	^ String
		streamContents: [:t1 | (self stackOfSize: 100)
				do: [:t2 | t1 print: t2;
						 cr]]! !

!ContextPart methodsFor: 'accessing' stamp: ''!
method
	self subclassResponsibility! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
methodClass
	^ self method methodClass
		ifNil: [self receiver class]! !

!ContextPart methodsFor: 'accessing' stamp: ''!
methodNode
	^ self method methodNode! !

!ContextPart methodsFor: 'accessing' stamp: ''!
methodNodeFormattedAndDecorated: t1 
	^ self method methodNodeFormattedAndDecorated: t1! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
methodReturnConstant: t1 
	^ self return: t1 from: self methodReturnContext! !

!ContextPart methodsFor: 'accessing' stamp: ''!
methodReturnContext
	self subclassResponsibility! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
methodReturnReceiver
	^ self return: self receiver from: self methodReturnContext! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
methodReturnTop
	^ self return: self pop from: self methodReturnContext! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
namedTempAt: t1 
	^ self debuggerMap namedTempAt: t1 in: self! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
namedTempAt: t1 put: t2 
	^ self debuggerMap
		namedTempAt: t1
		put: t2
		in: self! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
nextHandlerContext
	^ self sender findNextHandlerContextStarting! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'eem 5/13/2009 14:21'!
object: anObject basicAt: index 
	"Answer the value of an indexable element in the argument anObject without sending
	 it a message. Fail if the argument index is not an Integer or is out of bounds, or if
	 anObject is not indexable. This mimics the action of the VM when it indexes an object.
	 Used to simulate the execution machinery by, for example, the debugger.
	 Primitive.  See Object documentation whatIsAPrimitive."

	<primitive: 60>
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber
		ifTrue: [^self object: anObject basicAt: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'eem 5/13/2009 14:21'!
object: anObject basicAt: index put: value 
	"Store the last argument 
	 value in the indexable element of the argument anObject indicated by index without sending
	 anObject a message. Fail if the argument index is not an Integer or is out of bounds, or if
	 anObject is not indexable, or if value is an inappropriate value for anObject's indexable slots.
	 This mimics the action of the VM when it indexes an object.
	 Used to simulate the execution machinery by, for example, the debugger.
	 Primitive.  See Object documentation whatIsAPrimitive."

	<primitive: 61>
	index isInteger
		ifTrue: [(index >= 1 and: [index <= (self objectSize: anObject)])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]].
	index isNumber
		ifTrue: [^self object: anObject basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'eem 5/13/2009 14:23'!
object: anObject eqeq: anOtherObject 
	"Answer whether the first and second arguments are the same object (have the
	 same object pointer) without sending a message to the first argument.  This
	 mimics the action of the VM when it compares two object pointers.  Used to
	 simulate the execution machinery by, for example, the debugger.
	 Primitive.  See Object documentation whatIsAPrimitive."

	<primitive: 110>
	self primitiveFailed! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'eem 4/8/2009 19:27'!
object: anObject instVarAt: anIndex
	"Primitive. Answer a fixed variable in an object. The numbering of the 
	 variables corresponds to the named instance variables. Fail if the index 
	 is not an Integer or is not the index of a fixed variable. Essential for the
	 debugger. See  Object documentation whatIsAPrimitive."

	<primitive: 73>
	"Access beyond fixed variables."
	^self object: anObject basicAt: anIndex - (self objectClass: anObject) instSize! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'eem 4/8/2009 19:30'!
object: anObject instVarAt: anIndex put: aValue 
	"Primitive. Store a value into a fixed variable in the argument anObject.
	 The numbering of the variables corresponds to the named instance
	 variables.  Fail if the index is not an Integer or is not the index of a
	 fixed variable.  Answer the value stored as the result. Using this
	 message violates the  principle that each object has sovereign control
	 over the storing of values into its instance variables. Essential for the
	 debugger. See Object documentation whatIsAPrimitive."

	<primitive: 74>
	"Access beyond fixed fields"
	^self object: anObject basicAt: anIndex - (self objectClass: anObject) instSize put: aValue! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'dtl 12/11/2011 19:39'!
object: anObject perform: selector withArguments: argArray inClass: lookupClass
	"Send the selector, aSymbol, to anObject with arguments in argArray.
	 Fail if the number of arguments expected by the selector 
	 does not match the size of argArray, or if lookupClass
	 cannot be found among the anObject's superclasses.
	 Primitive. Essential for the debugger."

	<primitive: 100 error: error>
	(selector isSymbol) ifFalse:
		[^self error: 'selector argument must be a Symbol'].
	(argArray isMemberOf: Array) ifFalse:
		[^self error: 'argArray must be an Array'].
	(selector numArgs = argArray size)
		ifFalse: [^self error: 'incorrect number of arguments'].
	((self objectClass: anObject) == lookupClass
	 or: [(self objectClass: anObject) inheritsFrom: lookupClass]) ifFalse:
		[^self error: 'lookupClass is not in anObject''s inheritance chain'].
	self primitiveFailed! !

!ContextPart methodsFor: 'mirror primitives' stamp: ''!
objectClass: t1 
	<primitive: 111>
	self primitiveFailed! !

!ContextPart methodsFor: 'mirror primitives' stamp: 'eem 5/13/2009 14:21'!
objectSize: anObject
	"Answer the number of indexable variables in the argument anObject without sending
	 it a message. This mimics the action of the VM when it fetches an object's variable size.
	 Used to simulate the execution machinery by, for example, the debugger.
	 Primitive.  See Object documentation whatIsAPrimitive."

	<primitive: 62>
	"The number of indexable fields of fixed-length objects is 0"
	^0! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
pc
	^ pc! !

!ContextPart methodsFor: 'controlling' stamp: ''!
pop
	| t1 |
	t1 := self at: stackp.
	self stackp: stackp - 1.
	^ t1! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
popIntoLiteralVariable: t1 
	t1 value: self pop! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
popIntoReceiverVariable: t1 
	self receiver instVarAt: t1 + 1 put: self pop! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
popIntoRemoteTemp: t1 inVectorAt: t2 
	(self at: t2 + 1)
		at: t1 + 1
		put: self pop! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
popIntoTemporaryVariable: t1 
	self contextForLocalVariables at: t1 + 1 put: self pop! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
print: t1 on: t2 
	| t3 |
	(t1 class canUnderstand: #printOn:)
		ifTrue: [^ t1 printOn: t2].
	t3 := t1 class name.
	t2
		nextPutAll: (t3 first isVowel
				ifTrue: ['an ']
				ifFalse: ['a ']);
		 nextPutAll: t3! !

!ContextPart methodsFor: 'printing' stamp: 'jrd 5/6/2010 00:41'!
printDetails: strm
	"Put my class>>selector and arguments and temporaries on the stream.  Protect against errors during printing."

	| str |
	self printOn: strm.  

	strm cr; tab; nextPutAll: 'Arguments and temporary variables: '; cr.
	str := [self tempsAndValuesLimitedTo: 160 indent: 2] ifError: [:err :rcvr | 
						'<<error during printing>>'].
	strm nextPutAll: str.
	strm peekLast == Character cr ifFalse: [strm cr].! !

!ContextPart methodsFor: 'printing' stamp: ''!
printOn: t1 
	| t2 t3 t4 |
	self method
		ifNil: [^ super printOn: t1].
	t3 := self receiver class.
	t4 := self methodClass.
	t2 := self selector
				ifNil: [self method defaultSelector].
	t1 nextPutAll: t3 name.
	t4 == t3
		ifFalse: [t1 nextPut: $(.
			t1 nextPutAll: t4 name.
			t1 nextPut: $)].
	t1 nextPutAll: '>>'.
	t1 nextPutAll: t2.
	t2 = #doesNotUnderstand:
		ifTrue: [t1 space.
			(self tempAt: 1) selector printOn: t1]! !

!ContextPart methodsFor: 'private' stamp: ''!
privSender: t1 
	sender := t1! !

!ContextPart methodsFor: 'controlling' stamp: ''!
push: t1 
	self stackp: stackp + 1.
	self at: stackp put: t1! !

!ContextPart methodsFor: 'private' stamp: ''!
push: t1 fromIndexable: t2 
	1
		to: t1
		do: [:t3 | self
				push: (t2 at: t3)]! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushActiveContext
	self push: self! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushClosureCopyNumCopiedValues: t1 numArgs: t2 blockSize: t3 
	| t4 |
	t1 > 0
		ifTrue: [t4 := Array new: t1.
			t1
				to: 1
				by: -1
				do: [:t5 | t4 at: t5 put: self pop].
			nil]
		ifFalse: [t4 := nil].
	self
		push: (BlockClosure
				outerContext: self
				startpc: pc
				numArgs: t2
				copiedValues: t4).
	self jump: t3! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushConstant: t1 
	self push: t1! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushLiteralVariable: t1 
	self push: t1 value! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushNewArrayOfSize: t1 
	self
		push: (Array new: t1)! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushReceiver
	self push: self receiver! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushReceiverVariable: t1 
	self
		push: (self receiver instVarAt: t1 + 1)! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushRemoteTemp: t1 inVectorAt: t2 
	self
		push: ((self at: t2 + 1)
				at: t1 + 1)! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
pushTemporaryVariable: t1 
	self
		push: (self contextForLocalVariables at: t1 + 1)! !

!ContextPart methodsFor: 'controlling' stamp: ''!
quickSend: t1 to: t2 with: t3 super: t4 
	| t5 t6 t8 |
	t6 := self.
	t5 := t4
				ifTrue: [(self method literalAt: self method numLiterals) value superclass]
				ifFalse: [t2 class].
	[| t9 |
	t9 := thisContext sender swapSender: self.
	t8 := t2
				perform: t1
				withArguments: t3
				inSuperclass: t5.
	thisContext sender swapSender: t9]
		ifCurtailed: [t6 := thisContext sender receiver.
			t6 jump: -1.
			t6 nextByte = 124
				ifTrue: [t6
						push: (thisContext sender tempAt: 1)].
			thisContext swapSender: thisContext home sender.
			t6].
	t6 push: t8.
	^ t6! !

!ContextPart methodsFor: 'system simulation' stamp: ''!
quickStep
	self willReallySend
		ifTrue: [QuickStep := self].
	^ self step! !

!ContextPart methodsFor: 'private-exceptions' stamp: 'mtf 6/3/2010 09:36'!
rearmHandlerDuring: aBlock
	"Sent to handler (on:do:) contexts only. Makes me re-entrant for the duration of aBlock. Only works in a closure-enabled image"

	^ [self tempAt: 3 put: true. aBlock value]
		ensure: [self tempAt: 3 put: false]! !

!ContextPart methodsFor: 'accessing' stamp: ''!
receiver
	self subclassResponsibility! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
release
	self releaseTo: nil! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
releaseTo: t1 
	| t2 t3 |
	t2 := self.
	[t2
		ifNil: [true]
		ifNotNil: [t2 == t1]]
		whileFalse: [t3 := t2 sender.
			t2 singleRelease.
			t2 := t3]! !

!ContextPart methodsFor: 'controlling' stamp: ''!
restart
	| t1 t2 |
	self isDead
		ifTrue: [self cannotReturn: nil to: self].
	self privRefresh.
	t1 := thisContext.
	[t1 := t1 findNextUnwindContextUpTo: self.
	t1 isNil]
		whileFalse: [(t1 tempAt: 2)
				ifNil: [t1 tempAt: 2 put: true.
					t2 := t1 tempAt: 1.
					thisContext terminateTo: t1.
					t2 value]].
	thisContext terminateTo: self.
	self jump! !

!ContextPart methodsFor: 'controlling' stamp: ''!
resume
	self resume: nil! !

!ContextPart methodsFor: 'controlling' stamp: ''!
resume: t1 
	| t2 t3 |
	self isDead
		ifTrue: [self cannotReturn: t1 to: self].
	t2 := thisContext.
	[t2 := t2 findNextUnwindContextUpTo: self.
	t2 isNil]
		whileFalse: [(t2 tempAt: 2)
				ifNil: [t2 tempAt: 2 put: true.
					t3 := t2 tempAt: 1.
					thisContext terminateTo: t2.
					t3 value]].
	thisContext terminateTo: self.
	^ t1! !

!ContextPart methodsFor: 'controlling' stamp: 'eem 4/25/2012 10:48'!
resume: value through: firstUnwindCtxt
	"Unwind thisContext to self and resume with value as result of last send.
	 Execute any unwind blocks while unwinding.
	 ASSUMES self is a sender of thisContext."

	| ctxt unwindBlock |
	self isDead ifTrue: [self cannotReturn: value to: self].
	ctxt := firstUnwindCtxt.
	[ctxt isNil] whileFalse:
		[(ctxt tempAt: 2) ifNil:
			[ctxt tempAt: 2 put: true.
			 unwindBlock := ctxt tempAt: 1.
			 thisContext terminateTo: ctxt.
			 unwindBlock value].
		 ctxt := ctxt findNextUnwindContextUpTo: self].
	thisContext terminateTo: self.
	^value
! !

!ContextPart methodsFor: 'controlling' stamp: ''!
return
	self return: self receiver! !

!ContextPart methodsFor: 'controlling' stamp: ''!
return: t1 
	sender
		ifNil: [self cannotReturn: t1 to: sender].
	sender resume: t1! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
return: t1 from: t2 
	| t3 t4 |
	t2 isDead
		ifTrue: [^ self
				send: #cannotReturn:
				to: self
				with: {t1}
				super: false].
	t3 := t2 sender.
	t4 := self findNextUnwindContextUpTo: t3.
	t4
		ifNotNil: [^ self
				send: #aboutToReturn:through:
				to: self
				with: {t1. t4}
				super: false].
	self releaseTo: t3.
	t3
		ifNotNil: [t3 push: t1].
	^ t3! !

!ContextPart methodsFor: 'controlling' stamp: 'eem 4/25/2012 10:47'!
return: value through: firstUnwindContext
	"Unwind thisContext to self and return value to self's sender.
	 Execute any unwind blocks while unwinding.
	 ASSUMES self is a sender of thisContext."

	sender ifNil: [self cannotReturn: value to: sender].
	sender resume: value through: firstUnwindContext! !

!ContextPart methodsFor: 'controlling' stamp: ''!
return: t1 to: t2 
	self releaseTo: t2.
	t2
		ifNil: [^ nil].
	^ t2 push: t1! !

!ContextPart methodsFor: 'system simulation' stamp: ''!
runSimulated: t1 contextAtEachStep: t2 
	| t3 |
	t1 hasMethodReturn
		ifTrue: [self error: 'simulation of blocks with ^ can run loose'].
	t3 := t1 asContext.
	t3 pushArgs: Array new from: self.
	[t3 == self]
		whileFalse: [t2 value: t3.
			t3 := t3 step].
	^ self pop! !

!ContextPart methodsFor: 'controlling' stamp: 'ajh 5/20/2004 17:20'!
runUntilErrorOrReturnFrom: aSender 
	"ASSUMES aSender is a sender of self.  Execute self's stack until aSender returns or an unhandled exception is raised.  Return a pair containing the new top context and a possibly nil exception.  The exception is not nil if it was raised before aSender returned and it was not handled.  The exception is returned rather than openning the debugger, giving the caller the choice of how to handle it."
	"Self is run by jumping directly to it (the active process abandons thisContext and executes self).  However, before jumping to self we insert an ensure block under aSender that jumps back to thisContext when evaluated.  We also insert an exception handler under aSender that jumps back to thisContext when an unhandled exception is raised.  In either case, the inserted ensure and exception handler are removed once control jumps back to thisContext."

	| error ctxt here topContext |
	here := thisContext.

	"Insert ensure and exception handler contexts under aSender"
	error := nil.
	ctxt := aSender insertSender: (ContextPart
		contextOn: UnhandledError do: [:ex |
			error ifNil: [
				error := ex exception.
				topContext := thisContext.
				ex resumeUnchecked: here jump]
			ifNotNil: [ex pass]
		]).
	ctxt := ctxt insertSender: (ContextPart
		contextEnsure: [error ifNil: [
				topContext := thisContext.
				here jump]
		]).
	self jump.  "Control jumps to self"

	"Control resumes here once above ensure block or exception handler is executed"
	^ error ifNil: [
		"No error was raised, remove ensure context by stepping until popped"
		[ctxt isDead] whileFalse: [topContext := topContext stepToCallee].
		{topContext. nil}

	] ifNotNil: [
		"Error was raised, remove inserted above contexts then return signaler context"
		aSender terminateTo: ctxt sender.  "remove above ensure and handler contexts"
		{topContext. error}
	].
! !

!ContextPart methodsFor: 'query' stamp: ''!
secondFromBottom
	self sender
		ifNil: [^ nil].
	^ self
		findContextSuchThat: [:t1 | t1 sender sender isNil]! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
selector
	^ self method selector
		ifNil: [self method defaultSelector]! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
send: t1 super: t2 numArgs: t3 
	| t4 t5 t6 |
	t5 := Array new: t3.
	t3
		to: 1
		by: -1
		do: [:t7 | t5 at: t7 put: self pop].
	t4 := self pop.
	t1 == #doPrimitive:method:receiver:args:
		ifTrue: [t6 := t4
						doPrimitive: (t5 at: 1)
						method: (t5 at: 2)
						receiver: (t5 at: 3)
						args: (t5 at: 4).
			self push: t6.
			^ self].
	QuickStep == self
		ifTrue: [QuickStep := nil.
			^ self
				quickSend: t1
				to: t4
				with: t5
				super: t2].
	^ self
		send: t1
		to: t4
		with: t5
		super: t2! !

!ContextPart methodsFor: 'controlling' stamp: ''!
send: t1 to: t2 with: t3 super: t4 
	| t5 t6 t7 |
	t5 := t4
				ifTrue: [(self method literalAt: self method numLiterals) value superclass]
				ifFalse: [t2 class].
	t6 := t5 lookupSelector: t1.
	t6
		ifNil: [^ self
				send: #doesNotUnderstand:
				to: t2
				with: (Array
						with: (Message selector: t1 arguments: t3))
				super: t4].
	t7 := self
				tryPrimitiveFor: t6
				receiver: t2
				args: t3.
	t7 == PrimitiveFailToken
		ifFalse: [^ t7].
	(t1 == #doesNotUnderstand:
			and: [t5 == ProtoObject])
		ifTrue: [^ self error: 'Simulated message ' , (t3 at: 1) selector , ' not understood'].
	^ self
		activateMethod: t6
		withArgs: t3
		receiver: t2
		class: t5! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
sender
	^ sender! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
shortStack
	^ String
		streamContents: [:t1 | (self stackOfSize: 10)
				do: [:t2 | t1 print: t2;
						 cr]]! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
singleRelease
	stackp
		ifNotNil: [1
				to: stackp
				do: [:t1 | self at: t1 put: nil]].
	sender := nil.
	pc := nil! !

!ContextPart methodsFor: 'accessing' stamp: ''!
size
	<primitive: 212>
	^ self primitiveFail! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
sourceCode
	^ self method getSource! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
stack
	^ self stackOfSize: 9999! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
stackOfSize: t1 
	| t2 t3 |
	t2 := OrderedCollection new.
	t2 addLast: (t3 := self).
	[(t3 := t3 sender) ~~ nil
		and: [t2 size < t1]]
		whileTrue: [t2 addLast: t3].
	^ t2! !

!ContextPart methodsFor: 'private' stamp: ''!
stackPtr
	^ stackp! !

!ContextPart methodsFor: 'private' stamp: ''!
stackp: t1 
	<primitive: 76>
	self error: 'stackp store failure'! !

!ContextPart methodsFor: 'system simulation' stamp: ''!
step
	^ self interpretNextInstructionFor: self! !

!ContextPart methodsFor: 'system simulation' stamp: ''!
stepToCallee
	| t1 |
	t1 := self.
	[(t1 := t1 step) == self] whileTrue.
	^ t1! !

!ContextPart methodsFor: 'system simulation' stamp: ''!
stepToSendOrReturn
	| t1 |
	[self willReallySend | self willReturn | self willStore]
		whileFalse: [t1 := self step.
			t1 == self
				ifFalse: [self halt.
					^ t1]]! !

!ContextPart methodsFor: 'objects from disk' stamp: ''!
storeDataOn: t1 
	t1 insideASegment
		ifTrue: [^ super storeDataOn: t1].
	self error: 'This Context was not included in the ImageSegment'.
	^ nil! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
storeIntoLiteralVariable: t1 
	t1 value: self top! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
storeIntoReceiverVariable: t1 
	self receiver instVarAt: t1 + 1 put: self top! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
storeIntoRemoteTemp: t1 inVectorAt: t2 
	(self at: t2 + 1)
		at: t1 + 1
		put: self top! !

!ContextPart methodsFor: 'instruction decoding' stamp: ''!
storeIntoTemporaryVariable: t1 
	self contextForLocalVariables at: t1 + 1 put: self top! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
swapSender: t1 
	| t2 |
	t2 := sender.
	sender := t1.
	^ t2! !

!ContextPart methodsFor: 'accessing' stamp: ''!
tempAt: t1 
	self subclassResponsibility! !

!ContextPart methodsFor: 'accessing' stamp: ''!
tempAt: t1 put: t2 
	self subclassResponsibility! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
tempNames
	^ self debuggerMap tempNamesForContext: self! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
tempsAndValues
	^ self debuggerMap tempsAndValuesForContext: self! !

!ContextPart methodsFor: 'debugger access' stamp: ''!
tempsAndValuesLimitedTo: t1 indent: t2 
	| t3 |
	t3 := WriteStream
				on: (String new: 100).
	self tempNames
		doWithIndex: [:t4 :t5 | 
			t2
				timesRepeat: [t3 tab].
			t3 nextPutAll: t4;
				 nextPut: $:;
				 space;
				 tab.
			t3
				nextPutAll: ((self tempAt: t5)
						printStringLimitedTo: (t1 - 3 - t4 size max: 1)).
			t3 cr].
	^ t3 contents! !

!ContextPart methodsFor: 'controlling' stamp: ''!
terminate
	sender := nil.
	pc := nil! !

!ContextPart methodsFor: 'controlling' stamp: ''!
terminateTo: t1 
	| t2 t3 |
	<primitive: 196>
	(self hasSender: t1)
		ifTrue: [t2 := sender.
			[t2 == t1]
				whileFalse: [t3 := t2 sender.
					t2 terminate.
					t2 := t3]].
	sender := t1! !

!ContextPart methodsFor: 'controlling' stamp: ''!
top
	^ self at: stackp! !

!ContextPart methodsFor: 'private' stamp: 'eem 5/23/2010 14:13'!
tryNamedPrimitiveIn: aCompiledMethod for: aReceiver withArgs: arguments
	"Hack. Attempt to execute the named primitive from the given compiled method"
	| selector theMethod spec |
	arguments size > 8 ifTrue:[^PrimitiveFailToken].
	selector := #(
		tryNamedPrimitive 
		tryNamedPrimitive: 
		tryNamedPrimitive:with: 
		tryNamedPrimitive:with:with: 
		tryNamedPrimitive:with:with:with:
		tryNamedPrimitive:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:
		tryNamedPrimitive:with:with:with:with:with:with:with:) at: arguments size+1.
	theMethod := aReceiver class lookupSelector: selector.
	theMethod == nil ifTrue:[^PrimitiveFailToken].
	spec := theMethod literalAt: 1.
	spec replaceFrom: 1 to: spec size with: (aCompiledMethod literalAt: 1) startingAt: 1.
	theMethod flushCache.
	selector flushCache.
	^aReceiver perform: selector withArguments: arguments! !

!ContextPart methodsFor: 'private' stamp: ''!
tryPrimitiveFor: t1 receiver: t2 args: t3 
	| t4 |
	(t4 := t1 primitive) = 0
		ifTrue: [^ PrimitiveFailToken].
	^ self
		doPrimitive: t4
		method: t1
		receiver: t2
		args: t3! !

!ContextPart methodsFor: 'private-exceptions' stamp: ''!
unwindTo: t1 
	| t2 t3 |
	t2 := self.
	[(t2 := t2 findNextUnwindContextUpTo: t1) isNil]
		whileFalse: [(t2 tempAt: 2)
				ifNil: [t2 tempAt: 2 put: true.
					t3 := t2 tempAt: 1.
					t3 value]]! !

ContextPart variableSubclass: #MethodContext
	instanceVariableNames: 'method closureOrNil receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!MethodContext class methodsFor: 'private' stamp: ''!
allInstancesDo: t1 
	| t2 t3 |
	t2 := self someInstance.
	[t2 == thisContext]
		whileFalse: [t3 := t2 nextInstance.
			t1 value: t2.
			t2 := t3]! !

!MethodContext class methodsFor: 'closure support' stamp: ''!
myEnvFieldIndex
	^ self allInstVarNames indexOf: 'receiverMap'! !

!MethodContext class methodsFor: 'instance creation' stamp: ''!
sender: t1 receiver: t2 method: t3 arguments: t4 
	^ (self newForMethod: t3)
		setSender: t1
		receiver: t2
		method: t3
		arguments: t4! !

!MethodContext methodsFor: 'private' stamp: 'eem 4/25/2012 10:48'!
aboutToReturn: result through: firstUnwindContext 
	"Called from VM when an unwindBlock is found between self and its home.
	 Return to home's sender, executing unwind blocks on the way."

	self methodReturnContext return: result through: firstUnwindContext! !

!MethodContext methodsFor: 'accessing' stamp: ''!
activeHome
	| t1 |
	self isExecutingBlock
		ifFalse: [^ self].
	self sender
		ifNil: [^ nil].
	t1 := self methodReturnContext.
	^ self sender
		findContextSuchThat: [:t2 | t2 = t1]! !

!MethodContext methodsFor: 'accessing' stamp: ''!
activeOuterContext
	| t1 |
	self isExecutingBlock
		ifFalse: [^ self].
	self sender
		ifNil: [^ nil].
	t1 := self outerContext.
	^ self sender
		findContextSuchThat: [:t2 | t2 = t1]! !

!MethodContext methodsFor: 'closure support' stamp: ''!
asContext
	^ self! !

!MethodContext methodsFor: 'testing' stamp: 'mha 9/22/2010 11:42'!
atEnd
	^ self isExecutingBlock
		ifTrue: [ self closure startpc + self closure size - 1 = self pc ]
		ifFalse: [ self pc >= self method endPC ]! !

!MethodContext methodsFor: 'instruction decoding (closures)' stamp: ''!
blockReturnTop
	self assert: closureOrNil isClosure.
	^ self return: self pop from: self! !

!MethodContext methodsFor: 'private-debugger' stamp: ''!
cachesStack
	^ false! !

!MethodContext methodsFor: 'private-exceptions' stamp: ''!
cannotReturn: t1 
	closureOrNil notNil
		ifTrue: [^ self cannotReturn: t1 to: self home sender].
	ToolSet
		debugContext: thisContext
		label: 'computation has been terminated'
		contents: nil! !

!MethodContext methodsFor: 'closure support' stamp: ''!
capturedTempNames
	^ self methodNode scope capturedVars
		collect: [:t1 | t1 name]! !

!MethodContext methodsFor: 'accessing' stamp: ''!
closure
	^ closureOrNil! !

!MethodContext methodsFor: 'accessing' stamp: ''!
contextForLocalVariables
	^ self! !

!MethodContext methodsFor: 'closure support' stamp: ''!
contextTag
	^ self! !

!MethodContext methodsFor: 'closure support' stamp: ''!
doItScope
	^ self methodNode scope asDoItScope! !

!MethodContext methodsFor: 'private' stamp: 'eem 4/26/2012 10:17'!
endPC
	^closureOrNil
		ifNil:	[self method endPC]
		ifNotNil: [closureOrNil endPC]! !

!MethodContext methodsFor: 'closure support' stamp: ''!
freeNames
	^ self methodNode freeNames! !

!MethodContext methodsFor: 'closure support' stamp: ''!
freeNamesAndValues
	| t1 t2 |
	t2 := [:t3 | self class evaluatorClass new
				evaluate2: (ReadStream on: t3)
				in: self
				to: nil
				notifying: nil
				ifFail: [self error: 'bug']
				logged: false].
	t1 := '' writeStream.
	self freeNames
		doWithIndex: [:t3 :t4 | 
			t1 nextPutAll: t3;
				 nextPut: $:;
				 space;
				 tab.
			(t2 value: t3)
				printOn: t1.
			t1 cr].
	^ t1 contents! !

!MethodContext methodsFor: 'accessing' stamp: ''!
hasInstVarRef
	^ self method hasInstVarRef! !

!MethodContext methodsFor: 'accessing' stamp: ''!
hasMethodReturn
	^ closureOrNil hasMethodReturn! !

!MethodContext methodsFor: 'private-debugger' stamp: ''!
hideFromDebugger
	| t1 t2 |
	^ self cachesStack
		or: [(t1 := self sender) ~~ nil
				and: [(t2 := t1 home) ~~ nil
						and: [t2 cachesStack]]]! !

!MethodContext methodsFor: 'accessing' stamp: ''!
home
	closureOrNil
		ifNil: [^ self].
	^ closureOrNil outerContext home! !

!MethodContext methodsFor: 'private' stamp: ''!
instVarAt: t1 put: t2 
	t1 = 3
		ifTrue: [self stackp: t2.
			^ t2].
	^ super instVarAt: t1 put: t2! !

!MethodContext methodsFor: 'closure support' stamp: ''!
isClosureContext
	^ self isExecutingBlock! !

!MethodContext methodsFor: 'accessing' stamp: ''!
isExecutingBlock
	^ closureOrNil isClosure! !

!MethodContext methodsFor: 'private-exceptions' stamp: ''!
isHandlerContext
	^ method primitive = 199! !

!MethodContext methodsFor: 'testing' stamp: ''!
isMethodContext
	^ true! !

!MethodContext methodsFor: 'private-exceptions' stamp: ''!
isUnwindContext
	^ method primitive = 198! !

!MethodContext methodsFor: 'accessing' stamp: ''!
method
	^ method! !

!MethodContext methodsFor: 'accessing' stamp: ''!
methodReturnContext
	closureOrNil
		ifNil: [^ self].
	^ closureOrNil outerContext methodReturnContext! !

!MethodContext methodsFor: 'accessing' stamp: 'eem 4/26/2012 10:51'!
numArgs
	"Answer the number of arguments for this activation."
	^closureOrNil
		ifNil: [method numArgs]
		ifNotNil: [closureOrNil numArgs]! !

!MethodContext methodsFor: 'accessing' stamp: 'eem 4/26/2012 10:58'!
numTemps
	"Answer the number of temporaries for this activation; this includes
	 the number of arguments, and for blocks, the number of copied values."
	^closureOrNil
		ifNil: [method numTemps]
		ifNotNil: [closureOrNil numTemps]! !

!MethodContext methodsFor: 'accessing' stamp: ''!
outerContext
	^ closureOrNil
		ifNotNil: [closureOrNil outerContext]! !

!MethodContext methodsFor: 'printing' stamp: ''!
printDetails: t1 
	| t2 t3 t4 |
	self printOn: t1.
	t1 cr.
	t1 tab; nextPutAll: 'Receiver: '.
	t2 := '<<error during printing>>'.
	t1
		nextPutAll: ([receiver printStringLimitedTo: 90]
				ifError: [:t5 :t6 | t2]).
	t1 cr; tab; nextPutAll: 'Arguments and temporary variables: '; cr.
	t3 := [(self tempsAndValuesLimitedTo: 80 indent: 2)
				padded: #right
				to: 1
				with: $x]
				ifError: [:t5 :t6 | t2].
	t1 nextPutAll: t3 allButLast.
	t1 cr; tab; nextPutAll: 'Receiver''s instance variables: '; cr.
	t4 := t1 position.
	[receiver
		longPrintOn: t1
		limitedTo: 80
		indent: 2]
		ifError: [:t5 :t6 | t1 nextPutAll: t2].
	t4 = t1 position
		ifTrue: [t1
				nextPutAll: ([receiver printStringLimitedTo: 90]
						ifError: [:t5 :t6 | t2])].
	t1 peekLast == Character cr
		ifFalse: [t1 cr]! !

!MethodContext methodsFor: 'printing' stamp: ''!
printOn: t1 
	self outerContext
		ifNil: [super printOn: t1]
		ifNotNil: [:t2 | 
			t1 nextPutAll: '[] in '.
			t2 printOn: t1]! !

!MethodContext methodsFor: 'printing' stamp: ''!
printString
	^ (self method notNil
			and: [self method hasBreakpoint])
		ifTrue: [(super printString , ' [break]') asText allBold]
		ifFalse: [super printString]! !

!MethodContext methodsFor: 'initialize-release' stamp: 'eem 9/10/2009 15:49'!
privRefresh
	"Reinitialize the receiver so that it is in the state it was at its creation."

	closureOrNil
		ifNotNil:
			[pc := closureOrNil startpc.
			self stackp: closureOrNil numArgs + closureOrNil numCopiedValues.
			1 to: closureOrNil numCopiedValues do:
				[:i | self tempAt: closureOrNil numArgs + i put: (closureOrNil at: i)]]
		ifNil:
			[pc := method initialPC.
			self stackp: method numTemps.
			method numArgs+1 to: method numTemps do:
				[:i | self tempAt: i put: nil]]! !

!MethodContext methodsFor: 'initialize-release' stamp: ''!
privRefreshWith: t1 
	t1 isCompiledMethod
		ifFalse: [self error: 'method can only be set to aCompiledMethod'].
	method := t1.
	self assert: closureOrNil == nil.
	self privRefresh! !

!MethodContext methodsFor: 'system simulation' stamp: 'eem 7/2/2010 10:26'!
pushArgs: args "<Array>" from: sendr "<ContextPart>" 
	"Helps simulate action of the value primitive for closures.
	 This is used by ContextPart>>runSimulated:contextAtEachStep:"

	closureOrNil
		ifNil: [self error: 'context needs a closure!!']
		ifNotNil:
			["See BlockClosure>>asContextWithSender:"
			 stackp ~= (closureOrNil numArgs + closureOrNil numCopiedValues) ifTrue:
				[self error: 'stack pointer is incorrect!!'].].

	1 to: closureOrNil numArgs do:
		[:i| self at: i put: (args at: i)].
	sender := sendr! !

!MethodContext methodsFor: 'instruction decoding (closures)' stamp: ''!
pushConsArrayWithElements: t1 
	| t2 |
	t2 := Array new: t1.
	t1
		to: 1
		by: -1
		do: [:t3 | t2 at: t3 put: self pop].
	self push: t2! !

!MethodContext methodsFor: 'accessing' stamp: ''!
receiver
	^ receiver! !

!MethodContext methodsFor: 'private-exceptions' stamp: ''!
receiver: t1 
	receiver := t1! !

!MethodContext methodsFor: 'accessing' stamp: ''!
removeSelf
	| t1 |
	t1 := receiver.
	receiver := nil.
	^ t1! !

!MethodContext methodsFor: 'private-exceptions' stamp: ''!
restartWithNewReceiver: t1 
	self swapReceiver: t1;
		 restart! !

!MethodContext methodsFor: 'private' stamp: ''!
setSender: t1 receiver: t2 method: t3 arguments: t4 
	sender := t1.
	receiver := t2.
	method := t3.
	closureOrNil := nil.
	pc := method initialPC.
	self stackp: method numTemps.
	1
		to: t4 size
		do: [:t5 | self
				at: t5
				put: (t4 at: t5)]! !

!MethodContext methodsFor: 'private' stamp: ''!
setSender: t1 receiver: t2 method: t3 closure: t4 startpc: t5 
	sender := t1.
	receiver := t2.
	method := t3.
	closureOrNil := t4.
	pc := t5.
	stackp := 0! !

!MethodContext methodsFor: 'private' stamp: ''!
startpc
	^ closureOrNil
		ifNil: [self method initialPC]
		ifNotNil: [closureOrNil startpc]! !

!MethodContext methodsFor: 'private-exceptions' stamp: ''!
swapReceiver: t1 
	receiver := t1! !

!MethodContext methodsFor: 'accessing' stamp: ''!
tempAt: t1 
	<primitive: 210>
	^ self at: t1! !

!MethodContext methodsFor: 'accessing' stamp: ''!
tempAt: t1 put: t2 
	<primitive: 211>
	^ self at: t1 put: t2! !

!InstructionStream class methodsFor: 'class initialization' stamp: ''!
initialize
	SpecialConstants := (Array
				with: true
				with: false
				with: nil)
				, (Array
						with: -1
						with: 0
						with: 1
						with: 2)! !

!InstructionStream class methodsFor: 'compiling' stamp: ''!
instVarNamesAndOffsetsDo: t1 
	| t2 |
	(self withAllSubclasses
			noneSatisfy: [:t5 | t5 isContextClass])
		ifTrue: [^ super instVarNamesAndOffsetsDo: t1].
	(t2 := superclass notNil
					ifTrue: [superclass instSize]
					ifFalse: [0]) > 0
		ifTrue: [superclass instVarNamesAndOffsetsDo: t1].
	1
		to: self instSize - t2
		do: [:t3 | t1
				value: (instanceVariables at: t3)
				value: (t3 + t2) negated]! !

!InstructionStream class methodsFor: 'compiling' stamp: ''!
isContextClass
	^ false! !

!InstructionStream class methodsFor: 'instance creation' stamp: ''!
on: t1 
	^ self new method: t1 pc: t1 initialPC! !

!InstructionStream methodsFor: 'debugger access' stamp: ''!
abstractPC
	^ self method abstractPCForConcretePC: pc! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
addSelectorTo: t1 
	| t2 |
	(t2 := self selectorToSendOrSelf) == self
		ifFalse: [t1 add: t2]! !

!InstructionStream methodsFor: 'decoding' stamp: ''!
atEnd
	^ pc > self method endPC! !

!InstructionStream methodsFor: 'debugger access' stamp: ''!
debuggerMap
	^ self method debuggerMap! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
firstByte
	^ self method at: pc! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
followingByte
	^ self method at: pc + 1! !

!InstructionStream methodsFor: 'scanning' stamp: 'eem 8/13/2010 11:45'!
followingBytecode
	"Answer the bytecode of the following bytecode (different to nextByte)."

	^self method at: self followingPc! !

!InstructionStream methodsFor: 'scanning' stamp: 'eem 8/13/2010 11:45'!
followingPc
	"Answer the pc of the following bytecode."

	^self nextPc: (self method at: pc)! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
fourthByte
	^ self method at: pc + 3! !

!InstructionStream methodsFor: 'decoding' stamp: ''!
interpret
	[self atEnd]
		whileFalse: [self interpretNextInstructionFor: self]! !

!InstructionStream methodsFor: 'private' stamp: ''!
interpretExtension: t1 in: t2 for: t3 
	| t4 t5 t6 t7 t8 |
	t1 <= 6
		ifTrue: [t6 := t2 at: pc.
			pc := pc + 1.
			t1 <= 2
				ifTrue: [t4 := t6 // 64.
					t5 := t6 \\ 64.
					t1 = 0
						ifTrue: [t4 = 0
								ifTrue: [^ t3 pushReceiverVariable: t5].
							t4 = 1
								ifTrue: [^ t3 pushTemporaryVariable: t5].
							t4 = 2
								ifTrue: [^ t3
										pushConstant: (t2 literalAt: t5 + 1)].
							t4 = 3
								ifTrue: [^ t3
										pushLiteralVariable: (t2 literalAt: t5 + 1)]].
					t1 = 1
						ifTrue: [t4 = 0
								ifTrue: [^ t3 storeIntoReceiverVariable: t5].
							t4 = 1
								ifTrue: [^ t3 storeIntoTemporaryVariable: t5].
							t4 = 2
								ifTrue: [self error: 'illegalStore'].
							t4 = 3
								ifTrue: [^ t3
										storeIntoLiteralVariable: (t2 literalAt: t5 + 1)]].
					t1 = 2
						ifTrue: [t4 = 0
								ifTrue: [^ t3 popIntoReceiverVariable: t5].
							t4 = 1
								ifTrue: [^ t3 popIntoTemporaryVariable: t5].
							t4 = 2
								ifTrue: [self error: 'illegalStore'].
							t4 = 3
								ifTrue: [^ t3
										popIntoLiteralVariable: (t2 literalAt: t5 + 1)]]].
			t1 = 3
				ifTrue: [^ t3
						send: (t2 literalAt: t6 \\ 32 + 1)
						super: false
						numArgs: t6 // 32].
			t1 = 4
				ifTrue: [t7 := t2 at: pc.
					pc := pc + 1.
					t4 := t6 // 32.
					t4 = 0
						ifTrue: [^ t3
								send: (t2 literalAt: t7 + 1)
								super: false
								numArgs: t6 \\ 32].
					t4 = 1
						ifTrue: [^ t3
								send: (t2 literalAt: t7 + 1)
								super: true
								numArgs: t6 \\ 32].
					t4 = 2
						ifTrue: [^ t3 pushReceiverVariable: t7].
					t4 = 3
						ifTrue: [^ t3
								pushConstant: (t2 literalAt: t7 + 1)].
					t4 = 4
						ifTrue: [^ t3
								pushLiteralVariable: (t2 literalAt: t7 + 1)].
					t4 = 5
						ifTrue: [^ t3 storeIntoReceiverVariable: t7].
					t4 = 6
						ifTrue: [^ t3 popIntoReceiverVariable: t7].
					t4 = 7
						ifTrue: [^ t3
								storeIntoLiteralVariable: (t2 literalAt: t7 + 1)]].
			t1 = 5
				ifTrue: [^ t3
						send: (t2 literalAt: t6 \\ 32 + 1)
						super: true
						numArgs: t6 // 32].
			t1 = 6
				ifTrue: [^ t3
						send: (t2 literalAt: t6 \\ 64 + 1)
						super: false
						numArgs: t6 // 64]].
	t1 = 7
		ifTrue: [^ t3 doPop].
	t1 = 8
		ifTrue: [^ t3 doDup].
	t1 = 9
		ifTrue: [^ t3 pushActiveContext].
	t6 := t2 at: pc.
	pc := pc + 1.
	t1 = 10
		ifTrue: [^ t6 < 128
				ifTrue: [t3 pushNewArrayOfSize: t6]
				ifFalse: [t3 pushConsArrayWithElements: t6 - 128]].
	t1 = 11
		ifTrue: [^ self error: 'unusedBytecode'].
	t7 := t2 at: pc.
	pc := pc + 1.
	t1 = 12
		ifTrue: [^ t3 pushRemoteTemp: t6 inVectorAt: t7].
	t1 = 13
		ifTrue: [^ t3 storeIntoRemoteTemp: t6 inVectorAt: t7].
	t1 = 14
		ifTrue: [^ t3 popIntoRemoteTemp: t6 inVectorAt: t7].
	t8 := t2 at: pc.
	pc := pc + 1.
	^ t3
		pushClosureCopyNumCopiedValues: (t6 bitShift: -4)
		numArgs: (t6 bitAnd: 15)
		blockSize: t7 * 256 + t8! !

!InstructionStream methodsFor: 'decoding' stamp: ''!
interpretJump
	| t1 |
	t1 := self method at: pc.
	(t1 between: 144 and: 151)
		ifTrue: [pc := pc + 1.
			^ t1 - 143].
	(t1 between: 160 and: 167)
		ifTrue: [pc := pc + 2.
			^ t1 - 164 * 256
				+ (self method at: pc - 1)].
	^ nil! !

!InstructionStream methodsFor: 'decoding' stamp: ''!
interpretJumpIfCond
	| t1 |
	t1 := self method at: pc.
	(t1 between: 152 and: 159)
		ifTrue: [pc := pc + 1.
			^ t1 - 151].
	(t1 between: 168 and: 175)
		ifTrue: [pc := pc + 2.
			^ (t1 bitAnd: 3)
				* 256
				+ (self method at: pc - 1)].
	^ nil! !

!InstructionStream methodsFor: 'decoding' stamp: ''!
interpretNextInstructionFor: t1 
	| t2 t3 t4 t5 |
	t5 := self method.
	t2 := t5 at: pc.
	t3 := t2 // 16.
	t4 := t2 \\ 16.
	pc := pc + 1.
	t3 < 8
		ifTrue: [t3 < 4
				ifTrue: [t3 < 2
						ifTrue: [t3 < 1
								ifTrue: [^ t1 pushReceiverVariable: t4].
							^ t1 pushTemporaryVariable: t4].
					t3 < 3
						ifTrue: [^ t1
								pushConstant: (t5 literalAt: t4 + 1)].
					^ t1
						pushConstant: (t5 literalAt: t4 + 17)].
			t3 < 6
				ifTrue: [t3 < 5
						ifTrue: [^ t1
								pushLiteralVariable: (t5 literalAt: t4 + 1)].
					^ t1
						pushLiteralVariable: (t5 literalAt: t4 + 17)].
			t3 < 7
				ifTrue: [t4 < 8
						ifTrue: [^ t1 popIntoReceiverVariable: t4].
					^ t1 popIntoTemporaryVariable: t4 - 8].
			t4 = 0
				ifTrue: [^ t1 pushReceiver].
			t4 < 8
				ifTrue: [^ t1
						pushConstant: (SpecialConstants at: t4)].
			t4 = 8
				ifTrue: [^ t1 methodReturnReceiver].
			t4 < 12
				ifTrue: [^ t1
						methodReturnConstant: (SpecialConstants at: t4 - 8)].
			t4 = 12
				ifTrue: [^ t1 methodReturnTop].
			t4 = 13
				ifTrue: [^ t1 blockReturnTop].
			t4 > 13
				ifTrue: [^ self error: 'unusedBytecode']]
		ifFalse: [t3 < 12
				ifTrue: [t3 < 10
						ifTrue: [t3 < 9
								ifTrue: [^ self
										interpretExtension: t4
										in: t5
										for: t1].
							t4 < 8
								ifTrue: [^ t1 jump: t4 + 1].
							^ t1 jump: t4 - 8 + 1 if: false].
					t3 < 11
						ifTrue: [t2 := t5 at: pc.
							pc := pc + 1.
							t4 < 8
								ifTrue: [^ t1 jump: t4 - 4 * 256 + t2].
							^ t1 jump: (t4 bitAnd: 3)
									* 256 + t2 if: t4 < 12].
					^ t1
						send: (Smalltalk specialSelectorAt: t4 + 1)
						super: false
						numArgs: (Smalltalk specialNargsAt: t4 + 1)].
			t3 = 12
				ifTrue: [^ t1
						send: (Smalltalk specialSelectorAt: t4 + 17)
						super: false
						numArgs: (Smalltalk specialNargsAt: t4 + 17)].
			^ t1
				send: (t5 literalAt: t4 + 1)
				super: false
				numArgs: t3 - 13]! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
method
	^ sender! !

!InstructionStream methodsFor: 'private' stamp: ''!
method: t1 pc: t2 
	sender := t1.
	pc := t2! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
nextByte
	^ self method at: pc! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
nextInstruction
	^ self interpretNextInstructionFor: MessageCatcher new! !

!InstructionStream methodsFor: 'private' stamp: 'eem 8/13/2010 11:38'!
nextPc: currentByte
	"Answer the pc of the next bytecode following the current one, given the current bytecode.."

	| type |
	type := currentByte // 16.
	^type = 8 "extensions"
				ifTrue: [pc + (#(2 2 2 2 3 2 2 1 1 1 2 1 3 3 3 4) at: currentByte \\ 16 + 1)]
				ifFalse: [type = 10 "long jumps"
							ifTrue: [pc + 2]
							ifFalse: [pc + 1]]! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
pc
	^ pc! !

!InstructionStream methodsFor: 'private' stamp: ''!
pc: t1 
	pc := t1! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
peekInstruction
	| t1 t2 |
	t1 := self pc.
	t2 := self nextInstruction.
	self pc: t1.
	^ t2! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
previousPc
	^ self method pcPreviousTo: pc! !

!InstructionStream methodsFor: 'scanning' stamp: 'mha 9/23/2010 10:30'!
scanFor: scanBlock
	"Check all bytecode instructions with scanBlock, answer true if scanBlock answers true.
	This can be used to, e.g., check whether a method contains 'push closure' bytecodes like this:
	aMethod scanFor: [ :b | b = 143 ]"

	| method end byte |
	method := self method.
	end := method endPC.
	[pc <= end] whileTrue: 
		[(scanBlock value: (byte := method at: pc)) ifTrue:
			[^true].
		 pc := self nextPc: byte].
	^false! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
secondByte
	^ self method at: pc + 1! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
selectorToSendOrSelf
	| t1 t2 |
	t1 := self method at: pc.
	t1 < 131
		ifTrue: [^ self].
	t1 >= 176
		ifTrue: [t1 >= 208
				ifTrue: [^ self method literalAt: (t1 bitAnd: 15)
							+ 1].
			^ Smalltalk specialSelectorAt: t1 - 176 + 1].
	t1 <= 134
		ifTrue: [t2 := self method at: pc + 1.
			t1 = 131
				ifTrue: [^ self method literalAt: t2 \\ 32 + 1].
			t1 = 132
				ifTrue: [t2 < 64
						ifTrue: [^ self method literalAt: (self method at: pc + 2)
									+ 1]].
			t1 = 133
				ifTrue: [^ self method literalAt: t2 \\ 32 + 1].
			t1 = 134
				ifTrue: [^ self method literalAt: t2 \\ 64 + 1]]! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
skipBackBeforeJump
	| t1 t2 |
	t1 := InstructionStream on: self method.
	(t1
			scanFor: [:t4 | ((t2 := t4 between: 152 and: 159)
						or: [t4 between: 168 and: 175])
					and: [t1 pc
							= (t2
									ifTrue: [pc - 1]
									ifFalse: [pc - 2])]])
		ifFalse: [self error: 'Where''s the jump??'].
	self
		jump: (t2
				ifTrue: [-1]
				ifFalse: [-2])! !

!InstructionStream methodsFor: 'scanning' stamp: ''!
thirdByte
	^ self method at: pc + 2! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willBlockReturn
	^ (self method at: pc)
		= Encoder blockReturnCode! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willJump
	| t1 |
	t1 := self method at: pc.
	^ (t1 between: 144 and: 151)
		or: [t1 between: 160 and: 167]! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willJumpIfFalse
	| t1 |
	t1 := self method at: pc.
	^ (t1 between: 152 and: 159)
		or: [t1 between: 172 and: 175]! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willJumpIfTrue
	| t1 |
	t1 := self method at: pc.
	^ t1 between: 168 and: 171! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willJustPop
	^ (self method at: pc)
		= Encoder popCode! !

!InstructionStream methodsFor: 'testing' stamp: 'ul 11/15/2010 10:11'!
willReallySend
	"Answer whether the next bytecode is a real message-send,
	not blockCopy:."

	| byte |
	byte := self method at: pc.
	^byte >= 131
	  and: [byte ~= 200
	  and: [byte >= 176   "special send or short send"
		or: [byte <= 134 "long sends"	
			and: [| litIndex |
				"long form support demands we check the selector"
				litIndex := byte = 132
							ifTrue: [(self method at: pc + 1) // 32 > 1 ifTrue: [^false].
									self method at: pc + 2]
							ifFalse: [byte = 134
										ifTrue: [(self method at: pc + 1) bitAnd: 2r111111]
										ifFalse: [(self method at: pc + 1) bitAnd: 2r11111]].
				(self method literalAt: litIndex + 1) ~~ #blockCopy:]]]]! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willReturn
	^ (self method at: pc)
		between: 120
		and: 125! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willSend
	| t1 |
	t1 := self method at: pc.
	^ t1 >= 131
		and: [t1 >= 176
				or: [t1 <= 134]]! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willStore
	| t1 |
	t1 := self method at: pc.
	^ (t1 between: 96 and: 142)
		and: [t1 <= 111
				or: [t1 >= 129
						and: [t1 <= 130
								or: [(t1 = 132
											and: [(self method at: pc + 1)
													>= 160])
										or: [t1 = 141
												or: [t1 = 142]]]]]]! !

!InstructionStream methodsFor: 'testing' stamp: ''!
willStorePop
	| t1 |
	t1 := self method at: pc.
	^ t1 = 130
		or: [t1 = 142
				or: [t1 between: 96 and: 111]]! !

Object subclass: #Magnitude
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!Magnitude methodsFor: 'comparing' stamp: ''!
< t1 
	^ self subclassResponsibility! !

!Magnitude methodsFor: 'comparing' stamp: ''!
<= t1 
	^ (self > t1) not! !

!Magnitude methodsFor: 'comparing' stamp: ''!
= t1 
	^ self subclassResponsibility! !

!Magnitude methodsFor: 'comparing' stamp: ''!
> t1 
	^ t1 < self! !

!Magnitude methodsFor: 'comparing' stamp: ''!
>= t1 
	^ t1 <= self! !

!Magnitude methodsFor: 'comparing' stamp: ''!
between: t1 and: t2 
	^ self >= t1
		and: [self <= t2]! !

!Magnitude methodsFor: 'testing' stamp: 'mtf 3/7/2011 21:35'!
clampHigh: highMagnitude
"Answer my value, but keep it less than highMagnitude"

	^ self min: highMagnitude! !

!Magnitude methodsFor: 'testing' stamp: 'mtf 3/7/2011 21:34'!
clampLow: lowMagnitude
"Answer my value, but keep it greater than lowMagnitude"

	^ self max: lowMagnitude! !

!Magnitude methodsFor: 'testing' stamp: 'mtf 3/7/2011 21:35'!
clampLow: lowMagnitude high: highMagnitude
"Answer my value, but keep it between lowMagnitude and highMagnitude"

	^ self min: highMagnitude max: lowMagnitude! !

!Magnitude methodsFor: 'comparing' stamp: ''!
hash
	^ self subclassResponsibility! !

!Magnitude methodsFor: 'testing' stamp: ''!
max: t1 
	self > t1
		ifTrue: [^ self].
	^ t1! !

!Magnitude methodsFor: 'testing' stamp: ''!
min: t1 
	self < t1
		ifTrue: [^ self].
	^ t1! !

!Magnitude methodsFor: 'testing' stamp: ''!
min: t1 max: t2 
	^ (self min: t1)
		max: t2! !

!Magnitude methodsFor: 'streaming' stamp: ''!
putOn: t1 
	(t1 isBinary
		ifTrue: [self asByteArray]
		ifFalse: [self asString])
		putOn: t1! !

Magnitude subclass: #Number
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

Number variableWordSubclass: #Float
	instanceVariableNames: ''
	classVariableNames: 'E Epsilon Halfpi Infinity Ln10 Ln2 MaxVal MaxValLn MinValLogBase2 NaN NegativeInfinity NegativeZero Pi RadiansPerDegree Sqrt2 ThreePi Twopi'
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!Float commentStamp: '<historical>' prior: 0!
My instances represent IEEE-754 floating-point double-precision numbers.  They have about 16 digits of accuracy and their range is between plus and minus 10^307. Some valid examples are:
	
	8.0 13.3 0.3 2.5e6 1.27e-30 1.27e-31 -12.987654e12

Mainly: no embedded blanks, little e for tens power, and a digit on both sides of the decimal point.  It is actually possible to specify a radix for Squeak Float constants.  This is great for teaching about numbers, but may be confusing to the average reader:

	3r20.2 --> 6.66666666666667
	8r20.2 --> 16.25

If you don't have access to the definition of IEEE-754, you can figure out what is going on by printing various simple values in Float hex.  It may help you to know that the basic format is...
	sign		1 bit
	exponent	11 bits with bias of 1023 (16r3FF) to produce an exponent
						in the range -1023 .. +1024
				- 16r000:
					significand = 0: Float zero
					significand ~= 0: Denormalized number (exp = -1024, no hidden '1' bit)
				- 16r7FF:
					significand = 0: Infinity
					significand ~= 0: Not A Number (NaN) representation
	mantissa	53 bits, but only 52 are stored (20 in the first word, 32 in the second).  This is because a normalized mantissa, by definition, has a 1 to the right of its floating point, and IEEE-754 omits this redundant bit to gain an extra bit of precision instead.  People talk about the mantissa without its leading one as the FRACTION, and with its leading 1 as the SIGNFICAND.

The single-precision format is...
	sign		1 bit
	exponent	8 bits, with bias of 127, to represent -126 to +127
                    - 0x0 and 0xFF reserved for Float zero (mantissa is ignored)
                    - 16r7F reserved for Float underflow/overflow (mantissa is ignored)
	mantissa	24 bits, but only 23 are stored
This format is used in FloatArray (qv), and much can be learned from the conversion routines, Float asIEEE32BitWord, and Float class fromIEEE32Bit:.

Thanks to Rich Harmon for asking many questions and to Tim Olson, Bruce Cohen, Rick Zaccone and others for the answers that I have collected here.!

!Float class methodsFor: 'constants' stamp: ''!
denormalized
	^ true! !

!Float class methodsFor: 'constants' stamp: ''!
e
	^ E! !

!Float class methodsFor: 'constants' stamp: ''!
emax
	^ 1023! !

!Float class methodsFor: 'constants' stamp: ''!
emin
	^ -1022! !

!Float class methodsFor: 'constants' stamp: ''!
epsilon
	^ 1.0 timesTwoPower: 1 - self precision! !

!Float class methodsFor: 'constants' stamp: ''!
fmax
	^ MaxVal! !

!Float class methodsFor: 'constants' stamp: ''!
fmin
	^ self denormalized
		ifTrue: [self fminDenormalized]
		ifFalse: [self fminNormalized]! !

!Float class methodsFor: 'constants' stamp: ''!
fminDenormalized
	^ 1.0 timesTwoPower: MinValLogBase2! !

!Float class methodsFor: 'constants' stamp: ''!
fminNormalized
	^ 1.0 timesTwoPower: -1022! !

!Float class methodsFor: 'instance creation' stamp: ''!
fromIEEE32Bit: t1 
	| t2 t3 t4 t5 t6 |
	t1 negative
		ifTrue: [^ self error: 'Cannot deal with negative numbers'].
	t1 = 0
		ifTrue: [^ 0.0].
	t2 := t1 bitAnd: 2147483648.
	t1 = t2
		ifTrue: [^ self negativeZero].
	t4 := ((t1 bitShift: -23)
				bitAnd: 255)
				- 127.
	t3 := t1 bitAnd: 8388607.
	t4 = 128
		ifTrue: [t3 = 0
				ifFalse: [^ Float nan].
			t2 = 0
				ifTrue: [^ Float infinity].
			^ Float infinity negated].
	t4 = -127
		ifTrue: [t6 := t3 highBit.
			t3 := (t3 bitShift: 1)
						bitAnd: (1 bitShift: t6)
								- 1.
			t4 := t4 + t6 - 23].
	t5 := self new: 2.
	t5
		basicAt: 1
		put: ((t2
				bitOr: (1023 + t4 bitShift: 20))
				bitOr: (t3 bitShift: -3)).
	t5
		basicAt: 2
		put: ((t3 bitAnd: 7)
				bitShift: 29).
	^ t5! !

!Float class methodsFor: 'constants' stamp: ''!
halfPi
	^ Halfpi! !

!Float class methodsFor: 'constants' stamp: ''!
infinity
	^ Infinity! !

!Float class methodsFor: 'class initialization' stamp: 'nice 3/15/2008 22:42'!
initialize
	"Float initialize"
	"Constants from Computer Approximations, pp. 182-183:
		Pi = 3.14159265358979323846264338327950288
		Pi/2 = 1.57079632679489661923132169163975144
		Pi*2 = 6.28318530717958647692528676655900576
		Pi/180 = 0.01745329251994329576923690768488612
		2.0 ln = 0.69314718055994530941723212145817657
		2.0 sqrt = 1.41421356237309504880168872420969808"

	Pi := 3.14159265358979323846264338327950288.
	Halfpi := Pi / 2.0.
	Twopi := Pi * 2.0.
	ThreePi := Pi * 3.0.
	RadiansPerDegree := Pi / 180.0.

	Ln2 := 0.69314718055994530941723212145817657.
	Ln10 := 10.0 ln.
	Sqrt2 := 1.41421356237309504880168872420969808.
	E := 2.718281828459045235360287471353.

	Epsilon := 0.000000000001.  "Defines precision of mathematical functions"

	MaxVal := 1.7976931348623157e308.
	MaxValLn := 709.782712893384.
	MinValLogBase2 := -1074.

	Infinity := MaxVal * MaxVal.
	NegativeInfinity := 0.0 - Infinity.
	NaN := Infinity - Infinity.
	NegativeZero := 1.0 / Infinity negated.
! !

!Float class methodsFor: 'constants' stamp: 'mtf 3/7/2011 10:42'!
ln10
	^ Ln10! !

!Float class methodsFor: 'constants' stamp: 'mtf 3/7/2011 10:41'!
ln2
	^ Ln2! !

!Float class methodsFor: 'constants' stamp: 'jmv 10/13/2011 19:57'!
maxExactInteger
	"Answer the biggest integer such that it is exactly represented in a float, and all smaller integers also are"
	^1 bitShift: self precision! !

!Float class methodsFor: 'constants' stamp: ''!
nan
	^ NaN! !

!Float class methodsFor: 'constants' stamp: ''!
negativeZero
	^ NegativeZero! !

!Float class methodsFor: 'constants' stamp: ''!
one
	^ 1.0! !

!Float class methodsFor: 'constants' stamp: ''!
pi
	^ Pi! !

!Float class methodsFor: 'constants' stamp: ''!
precision
	^ 53! !

!Float class methodsFor: 'constants' stamp: ''!
radix
	^ 2! !

!Float class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 
	^ (super readFrom: t1) asFloat! !

!Float class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 ifFail: t2 
	^ (super
		readFrom: t1
		ifFail: [^ t2 value]) asFloat! !

!Float class methodsFor: 'constants' stamp: ''!
threePi
	^ ThreePi! !

!Float class methodsFor: 'constants' stamp: ''!
twoPi
	^ Twopi! !

!Float methodsFor: 'arithmetic' stamp: ''!
* t1 
	<primitive: 49>
	^ t1 adaptToFloat: self andSend: #*! !

!Float methodsFor: 'arithmetic' stamp: ''!
+ t1 
	<primitive: 41>
	^ t1 adaptToFloat: self andSend: #+! !

!Float methodsFor: 'arithmetic' stamp: ''!
- t1 
	<primitive: 42>
	^ t1 adaptToFloat: self andSend: #-! !

!Float methodsFor: 'arithmetic' stamp: 'hh 10/3/2000 11:46'!
/ aNumber 
	"Primitive. Answer the result of dividing receiver by aNumber.
	Fail if the argument is not a Float. Essential. See Object documentation
	whatIsAPrimitive."

	<primitive: 50>
	aNumber isZero ifTrue: [^(ZeroDivide dividend: self) signal].
	^ aNumber adaptToFloat: self andSend: #/! !

!Float methodsFor: 'comparing' stamp: ''!
< t1 
	<primitive: 43>
	^ t1 adaptToFloat: self andCompare: #<! !

!Float methodsFor: 'comparing' stamp: ''!
<= t1 
	<primitive: 45>
	^ t1 adaptToFloat: self andCompare: #<=! !

!Float methodsFor: 'comparing' stamp: ''!
= t1 
	<primitive: 47>
	t1 isNumber
		ifFalse: [^ false].
	^ t1 adaptToFloat: self andCompare: #=! !

!Float methodsFor: 'comparing' stamp: ''!
> t1 
	<primitive: 44>
	^ t1 adaptToFloat: self andCompare: #>! !

!Float methodsFor: 'comparing' stamp: ''!
>= t1 
	<primitive: 46>
	^ t1 adaptToFloat: self andCompare: #>=! !

!Float methodsFor: 'arithmetic' stamp: 'nice 8/21/2010 22:31'!
abs
	"This is faster than using Number abs and works for negativeZero."
	self <= 0.0
		ifTrue: [^ 0.0 - self]
		ifFalse: [^ self]! !

!Float methodsFor: 'printing' stamp: ''!
absByteEncode: t1 base: t2 
	| t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 |
	self isInfinite
		ifTrue: [t1 print: 'Infinity'.
			^ self].
	t3 := 50.
	t4 := t2 asFloat.
	t5 := self exponent.
	t6 := (t5 * t4 reciprocalLogBase2 - 1.0e-10) ceiling.
	t5 >= 0
		ifTrue: [t7 := self.
			t8 := 1.0.
			t9 := 1.0 timesTwoPower: t5 - t3.
			t10 := self significand ~= 1.0
						ifTrue: [t9]
						ifFalse: [t9 / 2.0]]
		ifFalse: [t7 := self timesTwoPower: t3.
			t8 := 1.0 timesTwoPower: t3.
			t10 := 1.0
						timesTwoPower: (t5 max: -1024).
			t9 := t5 = MinValLogBase2 | (self significand ~= 1.0)
						ifTrue: [t10]
						ifFalse: [t10 * 2.0]].
	t6 >= 0
		ifTrue: [t8 := t8
						* (t4 raisedToInteger: t6).
			t5 = 1023
				ifTrue: [t7 := t7 / t4.
					t8 := t8 / t4.
					t9 := t9 / t4.
					t10 := t10 / t4]]
		ifFalse: [t5 < -1023
				ifTrue: [t12 := (53 * t4 reciprocalLogBase2 - 1.0e-10) ceiling.
					t11 := t4 raisedToInteger: t12.
					t7 := t7 * t11.
					t9 := t9 * t11.
					t10 := t10 * t11.
					t11 := t4 raisedToInteger: (t6 + t12) negated]
				ifFalse: [t11 := t4 raisedToInteger: t6 negated].
			t8 := t8 / t11].
	t7 + t9 >= t8
		ifTrue: [t6 := t6 + 1]
		ifFalse: [t8 := t8 / t4].
	(t15 := t6 between: -3 and: 6)
		ifTrue: [t16 := t6.
			t6 <= 0
				ifTrue: [t1
						print: ('0.000000' truncateTo: 2 - t6)]]
		ifFalse: [t16 := 1].
	[t12 := (t7 / t8) truncated.
	t7 := t7 - (t12 * t8).
	(t13 := t7 <= t10) | (t14 := t7 + t9 >= t8)]
		whileFalse: [t1
				print: (Character digitValue: t12).
			t7 := t7 * t4.
			t9 := t9 * t4.
			t10 := t10 * t4.
			t16 := t16 - 1.
			t16 = 0
				ifTrue: [t1 print: $.]].
	t14
		ifTrue: [t13 not | (t13 & (t7 * 2.0 >= t8))
				ifTrue: [t12 := t12 + 1]].
	t1
		print: (Character digitValue: t12).
	t16 > 0
		ifTrue: [t16 - 1
				to: 1
				by: -1
				do: [:t17 | t1 print: $0].
			t1 print: '.0'].
	t15
		ifFalse: [t1 print: $e.
			t1 print: (t6 - 1) printString]! !

!Float methodsFor: 'printing' stamp: 'nice 11/5/2011 00:01'!
absPrintExactlyOn: aStream base: base
	"Print my value on a stream in the given base.  Assumes that my value is strictly
	positive; negative numbers, zero, and NaNs have already been handled elsewhere.
	Based upon the algorithm outlined in:
	Robert G. Burger and R. Kent Dybvig
	Printing Floating Point Numbers Quickly and Accurately
	ACM SIGPLAN 1996 Conference on Programming Language Design and Implementation
	June 1996.
	This version guarantees that the printed representation exactly represents my value
	by using exact integer arithmetic."

	| significand exp baseExpEstimate r s mPlus mMinus scale roundingIncludesLimits d tc1 tc2 fixedFormat decPointCount slowbit shead |
	self isInfinite ifTrue: [aStream nextPutAll: 'Infinity'. ^ self].
	significand := self significandAsInteger.
	roundingIncludesLimits := significand even.
	exp := (self exponent - 52) max: MinValLogBase2.
	baseExpEstimate := (self exponent * base asFloat reciprocalLogBase2 - 1.0e-10) ceiling.
	exp >= 0
		ifTrue:
			[significand ~= 16r10000000000000
				ifTrue:
					[r := significand bitShift: 1 + exp.
					s := 2.
					mPlus := mMinus := 1 bitShift: exp]
				ifFalse:
					[r := significand bitShift: 2 + exp.
					s := 4.
					mPlus := 2 * (mMinus := 1 bitShift: exp)]]
		ifFalse:
			[(exp = MinValLogBase2 or: [significand ~= 16r10000000000000])
				ifTrue:
					[r := significand bitShift: 1.
					s := 1 bitShift: 1 - exp.
					mPlus := mMinus := 1]
				ifFalse:
					[r := significand bitShift: 2.
					s := 1 bitShift: 2 - exp.
					mPlus := 2.
					mMinus := 1]].
	baseExpEstimate >= 0
		ifTrue: [s := s * (base raisedToInteger: baseExpEstimate)]
		ifFalse:
			[scale := base raisedToInteger: baseExpEstimate negated.
			r := r * scale.
			mPlus := mPlus * scale.
			mMinus := mMinus * scale].
	((r + mPlus >= s) and: [roundingIncludesLimits or: [r + mPlus > s]])
		ifTrue: [baseExpEstimate := baseExpEstimate + 1]
		ifFalse:
			[r := r * base.
			mPlus := mPlus * base.
			mMinus := mMinus * base].
	(fixedFormat := baseExpEstimate between: -3 and: 6)
		ifTrue:
			[decPointCount := baseExpEstimate.
			baseExpEstimate <= 0
				ifTrue: [aStream nextPutAll: ('0.000000' truncateTo: 2 - baseExpEstimate)]]
		ifFalse:
			[decPointCount := 1].
	slowbit := 1 - s lowBit .
	shead := s bitShift: slowbit.
	[d := (r bitShift: slowbit) // shead.
	r := r - (d * s).
	(tc1 := (r <= mMinus) and: [roundingIncludesLimits or: [r < mMinus]]) |
	(tc2 := (r + mPlus >= s) and: [roundingIncludesLimits or: [r + mPlus > s]])] whileFalse:
		[aStream nextPut: (Character digitValue: d).
		r := r * base.
		mPlus := mPlus * base.
		mMinus := mMinus * base.
		(decPointCount := decPointCount - 1) = 0 ifTrue: [aStream nextPut: $.]].
	tc2 ifTrue:
		[(tc1 not or: [r * 2 >= s]) ifTrue: [d := d + 1]].
	aStream nextPut: (Character digitValue: d).
	decPointCount > 0
		ifTrue:
			[decPointCount - 1 to: 1 by: -1 do: [:i | aStream nextPut: $0].
			aStream nextPutAll: '.0'].
	fixedFormat
		ifFalse:
			[aStream nextPut: $e.
			aStream nextPutAll: (baseExpEstimate - 1) printString]! !

!Float methodsFor: 'printing' stamp: 'nice 5/20/2012 00:29'!
absPrintExactlyOn: aStream base: base decimalPlaces: placesDesired showTrailingFractionalZeros: showtrailingZeros
	"Print my value on a stream in the given base with fixed number of digits after floating point.
	When placesDesired are beyond Float precision, zeroes are appended.
	When showtrailingZeros is false, the trailing zeroes after decimal point will be omitted.
	If all fractional digits are zeros, the decimal point is omitted too.
	Assumes that my value is strictly positive; negative numbers, zero, and NaNs have already been handled elsewhere.
	Based upon the algorithm outlined in:
	Robert G. Burger and R. Kent Dybvig
	Printing Floating Point Numbers Quickly and Accurately
	ACM SIGPLAN 1996 Conference on Programming Language Design and Implementation
	June 1996.."

	| significand exp baseExpEstimate r s mPlus mMinus scale roundingLowIncludesLimits roundingHighIncludesLimits d tc1 tc2 decPointCount slowbit shead delta |
	self isInfinite ifTrue: [aStream nextPutAll: 'Infinity'. ^ self].
	significand := self significandAsInteger.
	exp := (self exponent - 52) max: MinValLogBase2.
	exp >= 0
		ifTrue:
			[significand ~= 16r10000000000000
				ifTrue:
					[r := significand bitShift: 1 + exp.
					s := 2.
					mPlus := mMinus := 1 bitShift: exp]
				ifFalse:
					[r := significand bitShift: 2 + exp.
					s := 4.
					mPlus := 2 * (mMinus := 1 bitShift: exp)]]
		ifFalse:
			[(exp = MinValLogBase2 or: [significand ~= 16r10000000000000])
				ifTrue:
					[r := significand bitShift: 1.
					s := 1 bitShift: 1 - exp.
					mPlus := mMinus := 1]
				ifFalse:
					[r := significand bitShift: 2.
					s := 1 bitShift: 2 - exp.
					mPlus := 2.
					mMinus := 1]].
	delta := s / 2 / (base raisedTo: placesDesired).
	roundingLowIncludesLimits :=  (mMinus < delta and: [mMinus := delta. true]) or: [significand even].
	roundingHighIncludesLimits := (mPlus < delta and: [mPlus := delta. true]) or: [significand even].
	baseExpEstimate := (self exponent * base asFloat reciprocalLogBase2 - 1.0e-10) ceiling.
	baseExpEstimate >= 0
		ifTrue: [s := s * (base raisedToInteger: baseExpEstimate)]
		ifFalse:
			[scale := base raisedToInteger: baseExpEstimate negated.
			r := r * scale.
			mPlus := mPlus * scale.
			mMinus := mMinus * scale].
	((r + mPlus >= s) and: [roundingHighIncludesLimits or: [r + mPlus > s]])
		ifTrue: [baseExpEstimate := baseExpEstimate + 1]
		ifFalse:
			[r := r * base.
			mPlus := mPlus * base.
			mMinus := mMinus * base].
	decPointCount := baseExpEstimate.
	baseExpEstimate <= 0
		ifTrue:
			[placesDesired + baseExpEstimate <= 0
				ifTrue:
					[aStream nextPut: $0.
					(showtrailingZeros and: [placesDesired > 0]) ifTrue: [aStream nextPut: $.; nextPutAll: (String new: placesDesired withAll: $0)].
					^self].
			aStream nextPutAll: '0.'; nextPutAll: (String new: 0 - baseExpEstimate withAll: $0)].
	slowbit := 1 - s lowBit .
	shead := s bitShift: slowbit.
	[d := (r bitShift: slowbit) // shead.
	r := r - (d * s).
	(tc1 := (r <= mMinus) and: [roundingLowIncludesLimits or: [r < mMinus]]) |
	(tc2 := (r + mPlus >= s) and: [roundingHighIncludesLimits or: [r + mPlus > s]])] whileFalse:
		[aStream nextPut: (Character digitValue: d).
		r := r * base.
		mPlus := mPlus * base.
		mMinus := mMinus * base.
		(decPointCount := decPointCount - 1) = 0 ifTrue: [aStream nextPut: $.]].
	tc2 ifTrue:
		[(tc1 not or: [r * 2 >= s]) ifTrue: [d := d + 1]].
	aStream nextPut: (Character digitValue: d).
	decPointCount > 0
		ifTrue:
			[decPointCount - 1 to: 1 by: -1 do: [:i | aStream nextPut: $0].
			(showtrailingZeros and: [placesDesired > 0]) ifTrue: [aStream nextPut: $.; nextPutAll: (String new: placesDesired withAll: $0)]]
		ifFalse:
			[(showtrailingZeros and: [placesDesired + decPointCount > 1]) ifTrue: [aStream nextPutAll: (String new: placesDesired + decPointCount - 1 withAll: $0)]].! !

!Float methodsFor: 'printing' stamp: 'nice 4/20/2010 22:32'!
absPrintOn: aStream base: base
	"Print my value on a stream in the given base.  Assumes that my value is strictly
	positive; negative numbers, zero, and NaNs have already been handled elsewhere.
	Based upon the algorithm outlined in:
	Robert G. Burger and R. Kent Dybvig
	Printing Floating Point Numbers Quickly and Accurately
	ACM SIGPLAN 1996 Conference on Programming Language Design and Implementation
	June 1996.
	This version performs all calculations with Floats instead of LargeIntegers, and loses
	about 3 lsbs of accuracy compared to an exact conversion."

	| significantBits fBase exp baseExpEstimate r s mPlus mMinus scale d tc1 tc2 fixedFormat decPointCount |
	self isInfinite ifTrue: [aStream nextPutAll: 'Infinity'. ^ self].
	significantBits := 50.  "approximately 3 lsb's of accuracy loss during conversion"
	fBase := base asFloat.
	exp := self exponent.
	baseExpEstimate := (exp * fBase reciprocalLogBase2 - 1.0e-10) ceiling.
	exp >= 0
		ifTrue:
			[r := self.
			s := 1.0.
			mPlus := 1.0 timesTwoPower: exp - significantBits.
			mMinus := self significand ~= 1.0 ifTrue: [mPlus] ifFalse: [mPlus / 2.0]]
		ifFalse:
			[r := self timesTwoPower: significantBits.
			s := 1.0 timesTwoPower:  significantBits.
			mMinus := 1.0 timesTwoPower: (exp max: -1024).
			mPlus :=
				(exp = MinValLogBase2) | (self significand ~= 1.0)
					ifTrue: [mMinus]
					ifFalse: [mMinus * 2.0]].
	baseExpEstimate >= 0
		ifTrue:
			[exp = 1023
				ifTrue:   "scale down to prevent overflow to Infinity during conversion"
					[r := r / fBase.
					s := s * (fBase raisedToInteger: baseExpEstimate - 1).
					mPlus := mPlus / fBase.
					mMinus := mMinus / fBase]
				ifFalse:
					[s := s * (fBase raisedToInteger: baseExpEstimate)]]
		ifFalse:
			[exp < -1023
				ifTrue:   "scale up to prevent denorm reciprocals overflowing to Infinity"
					[d := (53 * fBase reciprocalLogBase2 - 1.0e-10) ceiling.
					scale := fBase raisedToInteger: d.
					r := r * scale.
					mPlus := mPlus * scale.
					mMinus := mMinus * scale.
					scale := fBase raisedToInteger: (baseExpEstimate + d) negated]
				ifFalse:
				[scale := fBase raisedToInteger: baseExpEstimate negated].
			s := s / scale].
	(r + mPlus >= s)
		ifTrue: [baseExpEstimate := baseExpEstimate + 1]
		ifFalse:
			[s := s / fBase].
	(fixedFormat := baseExpEstimate between: -3 and: 6)
		ifTrue:
			[decPointCount := baseExpEstimate.
			baseExpEstimate <= 0
				ifTrue: [aStream nextPutAll: ('0.000000' truncateTo: 2 - baseExpEstimate)]]
		ifFalse:
			[decPointCount := 1].
	[d := (r / s) truncated.
	r := r - (d * s).
	(tc1 := r <= mMinus) | (tc2 := r + mPlus >= s)] whileFalse:
		[aStream nextPut: (Character digitValue: d).
		r := r * fBase.
		mPlus := mPlus * fBase.
		mMinus := mMinus * fBase.
		decPointCount := decPointCount - 1.
		decPointCount = 0 ifTrue: [aStream nextPut: $.]].
	tc2 ifTrue:
		[tc1 not | (tc1 & (r*2.0 >= s)) ifTrue: [d := d + 1]].
	aStream nextPut: (Character digitValue: d).
	decPointCount > 0
		ifTrue:
		[decPointCount - 1 to: 1 by: -1 do: [:i | aStream nextPut: $0].
		aStream nextPutAll: '.0'].
	fixedFormat ifFalse:
		[aStream nextPut: $e.
		aStream nextPutAll: (baseExpEstimate - 1) printString]! !

!Float methodsFor: 'printing' stamp: 'nice 8/9/2009 21:01'!
absPrintOn: aStream base: base digitCount: digitCount 
	"Print me in the given base, using digitCount significant figures."

	| fuzz x exp q fBase scale logScale xi |
	self isInfinite ifTrue: [^ aStream nextPutAll: 'Inf'].
	fBase := base asFloat.
	"x is myself normalized to [1.0, fBase), exp is my exponent"
	exp := 
		self < 1.0
			ifTrue: [self reciprocalFloorLog: fBase]
			ifFalse: [self floorLog: fBase].
	scale := 1.0.
	logScale := 0.
	[(x := fBase raisedTo: (exp + logScale)) = 0]
		whileTrue:
			[scale := scale * fBase.
			logScale := logScale + 1].
	x := self * scale / x.
	fuzz := fBase raisedTo: 1 - digitCount.
	"round the last digit to be printed"
	x := 0.5 * fuzz + x.
	x >= fBase
		ifTrue: 
			["check if rounding has unnormalized x"
			x := x / fBase.
			exp := exp + 1].
	(exp < 6 and: [exp > -4])
		ifTrue: 
			["decimal notation"
			q := 0.
			exp < 0 ifTrue: [1 to: 1 - exp do: [:i | aStream nextPut: ('0.0000'
at: i)]]]
		ifFalse: 
			["scientific notation"
			q := exp.
			exp := 0].
	[x >= fuzz]
		whileTrue: 
			["use fuzz to track significance"
			xi := x asInteger.
			aStream nextPut: (Character digitValue: xi).
			x := x - xi asFloat * fBase.
			fuzz := fuzz * fBase.
			exp := exp - 1.
			exp = -1 ifTrue: [aStream nextPut: $.]].
	[exp >= -1]
		whileTrue: 
			[aStream nextPut: $0.
			exp := exp - 1.
			exp = -1 ifTrue: [aStream nextPut: $.]].
	q ~= 0
		ifTrue: 
			[aStream nextPut: $e.
			q printOn: aStream]! !

!Float methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andCompare: t2 
	self isFinite
		ifFalse: [t2 == #=
				ifTrue: [^ false].
			t2 == #~=
				ifTrue: [^ true].
			self isNaN
				ifTrue: [^ false].
			(t2 = #<
					or: [t2 = #<=])
				ifTrue: [^ self positive].
			(t2 = #>
					or: [t2 = #>=])
				ifTrue: [^ self positive not].
			^ self error: 'unknow comparison selector'].
	t2 == #=
		ifTrue: [t1 denominator isPowerOfTwo
				ifFalse: [^ false]].
	t2 == #~=
		ifTrue: [t1 denominator isPowerOfTwo
				ifFalse: [^ true]].
	^ t1 perform: t2 with: self asTrueFraction! !

!Float methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andSend: t2 
	^ t1 asFloat perform: t2 with: self! !

!Float methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andCompare: t2 
	self isFinite
		ifFalse: [t2 == #=
				ifTrue: [^ false].
			t2 == #~=
				ifTrue: [^ true].
			self isNaN
				ifTrue: [^ false].
			(t2 = #<
					or: [t2 = #<=])
				ifTrue: [^ self positive].
			(t2 = #>
					or: [t2 = #>=])
				ifTrue: [^ self positive not].
			^ self error: 'unknow comparison selector'].
	t2 == #=
		ifTrue: [self fractionPart = 0.0
				ifFalse: [^ false]].
	t2 == #~=
		ifTrue: [self fractionPart = 0.0
				ifFalse: [^ true]].
	^ t1 perform: t2 with: self asTrueFraction! !

!Float methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andSend: t2 
	^ t1 asFloat perform: t2 with: self! !

!Float methodsFor: 'converting' stamp: ''!
adaptToScaledDecimal: t1 andCompare: t2 
	self isFinite
		ifFalse: [t2 == #=
				ifTrue: [^ false].
			t2 == #~=
				ifTrue: [^ true].
			self isNaN
				ifTrue: [^ false].
			(t2 = #<
					or: [t2 = #<=])
				ifTrue: [^ self positive].
			(t2 = #>
					or: [t2 = #>=])
				ifTrue: [^ self positive not].
			^ self error: 'unknow comparison selector'].
	^ t1 perform: t2 with: self asTrueFraction! !

!Float methodsFor: 'converting' stamp: ''!
adaptToScaledDecimal: t1 andSend: t2 
	^ t1 asFloat perform: t2 with: self! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:10'!
arCosh
	"Answer receiver's area hyperbolic cosine.
	That is the inverse function of cosh."

	self < 1 
		ifTrue: 
			[^DomainError signal: 'Receiver must be greater or equal to 1'].
	^self + 1 = self 
		ifTrue: [self abs ln + 2 ln]
		ifFalse: [((self squared - 1) sqrt + self) ln]! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:10'!
arSinh
	"Answer receiver's area hyperbolic sine.
	That is the inverse function of sinh."

	self = 0.0 ifTrue: [^self].	"Handle negativeZero"  
	^self + 1 = self 
		ifTrue: [(self abs ln + 2 ln) * self sign]
		ifFalse: [((self squared + 1) sqrt + self) ln]! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 5/4/2011 21:29'!
arTanh
	"Answer receiver's area hyperbolic tangent.
	That is the inverse function of tanh."

	self = 0.0 ifTrue: [^self].	"Handle negativeZero"
	self abs = 1 ifTrue: [^self copySignTo: Float infinity].
	self abs > 1 
		ifTrue: 
			[^DomainError signal: 'Receiver must be between -1.0 and 1.0'].
	^((1 + self) / (1 - self)) ln / 2! !

!Float methodsFor: 'mathematical functions' stamp: ''!
arcCos
	"Answer the angle in radians."

	^ Halfpi - self arcSin! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/22/2011 02:17'!
arcSin
	"Answer the angle in radians."

	((self < -1.0) or: [self > 1.0]) ifTrue: [DomainError signal: 'arcSin only takes values between -1 and 1'].
	((self = -1.0) or: [self = 1.0])
		ifTrue: [^ Halfpi * self]
		ifFalse: [^ (self / (1.0 - (self * self)) sqrt) arcTan]! !

!Float methodsFor: 'mathematical functions' stamp: ''!
arcTan
	"Answer the angle in radians.
	 Optional. See Object documentation whatIsAPrimitive."

	| theta eps step sinTheta cosTheta |
	<primitive: 57>

	"Newton-Raphson"
	self < 0.0 ifTrue: [ ^ 0.0 - (0.0 - self) arcTan ].

	"first guess"
	theta := (self * Halfpi) / (self + 1.0).

	"iterate"
	eps := Halfpi * Epsilon.
	step := theta.
	[(step * step) > eps] whileTrue: [
		sinTheta := theta sin.
		cosTheta := theta cos.
		step := (sinTheta * cosTheta) - (self * cosTheta * cosTheta).
		theta := theta - step].
	^ theta! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 10/30/2009 22:21'!
arcTan: denominator
	"Answer the angle in radians.
	 Optional. See Object documentation whatIsAPrimitive.
	Implementation note: use sign in order to catch cases of negativeZero"

	^self = 0.0
		ifTrue: [denominator sign >= 0
			ifTrue: [ 0 ]
			ifFalse: [ self sign >= 0
				ifTrue: [ Pi ]
				ifFalse: [ Pi negated ]]]
		ifFalse: [denominator = 0.0
			ifTrue: [self > 0.0
				ifTrue: [ Halfpi ]
				ifFalse: [ Halfpi negated ]]
			ifFalse: [denominator > 0
				ifTrue: [ (self / denominator) arcTan ]
				ifFalse: [self > 0
					ifTrue: [ ((self / denominator) arcTan) + Pi ]
					ifFalse: [ ((self / denominator) arcTan) - Pi ]]]]! !

!Float methodsFor: 'converting' stamp: ''!
asApproximateFraction
	^ self asApproximateFractionAtOrder: 0! !

!Float methodsFor: 'converting' stamp: ''!
asApproximateFractionAtOrder: t1 
	| t2 t3 t4 t5 t6 t7 t8 t9 t10 |
	t2 := self asInteger.
	t3 := 1.
	t4 := 1.
	t5 := 0.
	t6 := t2.
	t7 := self fractionPart.
	t10 := t1 = 0
				ifTrue: [-1]
				ifFalse: [t1].
	[t7 = 0
		or: [t10 = 0]]
		whileFalse: [t10 := t10 - 1.
			t8 := 1.0 / t7.
			t6 := t8 asInteger.
			t7 := t8 fractionPart.
			t9 := t4.
			t4 := t2.
			t2 := t2 * t6 + t9.
			t9 := t5.
			t5 := t3.
			t3 := t6 * t3 + t9.
			1.0e10 < t3
				ifTrue: [t4 = 0.0
						ifTrue: [^ Fraction numerator: t2 denominator: t3].
					^ Fraction numerator: t4 denominator: t5]].
	t3 = 1
		ifTrue: [^ t2].
	^ Fraction numerator: t2 denominator: t3! !

!Float methodsFor: 'converting' stamp: ''!
asFloat
	^ self! !

!Float methodsFor: 'converting' stamp: ''!
asFraction
	^ self asTrueFraction! !

!Float methodsFor: 'converting' stamp: ''!
asIEEE32BitWord
	| t1 t2 t3 t4 t5 t6 t7 t8 t9 |
	self = 0.0
		ifTrue: [^ self basicAt: 1].
	t1 := self basicAt: 1.
	t2 := self basicAt: 2.
	t3 := t1 bitAnd: 2147483648.
	t5 := ((t1 bitShift: -20)
				bitAnd: 2047)
				- 1023 + 127.
	t4 := (t2 bitShift: -29)
				+ ((t1 bitAnd: 1048575)
						bitShift: 3).
	t7 := t2 bitAnd: 536870911.
	t5 < -24
		ifTrue: [^ t3].
	t5 <= 0
		ifTrue: [t8 := 1 bitShift: t5 negated.
			t4 := t4 bitOr: 8388608.
			t9 := (t4 bitAnd: t8) isZero not
						and: [t7 isZero not
								or: [(t4 bitAnd: t8 - 1) isZero not
										or: [(t4 bitAnd: t8 * 2) isZero not]]].
			t4 := t4 bitShift: t5 - 1]
		ifFalse: [t9 := (t7 bitAnd: 268435456) isZero not
						and: [(t4 bitAnd: 1) isZero not
								or: [(t7 bitAnd: 268435455) isZero not]]].
	t9
		ifTrue: [t4 := t4 + 1.
			t4 > 8388607
				ifTrue: [t4 := 0.
					t5 := t5 + 1]].
	t5 > 254
		ifTrue: [t5 := 255.
			self isNaN
				ifTrue: [t4 isZero
						ifTrue: [t4 := 1]]
				ifFalse: [t4 := 0]].
	t6 := (t3
				bitOr: ((t5 max: 0)
						bitShift: 23))
				bitOr: t4.
	^ t6! !

!Float methodsFor: 'converting' stamp: ''!
asTrueFraction
	| t1 t2 t3 t4 t5 t6 t7 t8 t9 |
	self isInfinite
		ifTrue: [self error: 'Cannot represent infinity as a fraction'].
	self isNaN
		ifTrue: [self error: 'Cannot represent Not-a-Number as a fraction'].
	t1 := (self basicAt: 1)
				bitShift: -20.
	t2 := (t1 bitAnd: 2048)
				= 0.
	t3 := t1 bitAnd: 2047.
	t6 := (((self basicAt: 1)
				bitAnd: 1048575)
				bitShift: 32)
				+ (self basicAt: 2).
	(t3 = 0
			and: [t6 = 0])
		ifTrue: [^ 0].
	t5 := t3 = 0
				ifTrue: [t6 bitShift: 1]
				ifFalse: [t6 bitOr: 4503599627370496].
	t7 := t2
				ifTrue: [t5]
				ifFalse: [t5 negated].
	t4 := 1023 + 52 - t3.
	t4 negative
		ifTrue: [t8 := t7 bitShift: t4 negated]
		ifFalse: [t9 := t5 lowBit - 1.
			t4 := t4 - t9.
			t4 <= 0
				ifTrue: [t9 := t9 + t4.
					t8 := t7 bitShift: t9 negated]
				ifFalse: [t8 := Fraction
								numerator: (t7 bitShift: t9 negated)
								denominator: (1 bitShift: t4)]].
	^ t8! !

!Float methodsFor: 'accessing' stamp: 'ar 6/20/2010 14:28'!
at: index 
	"Avoid primitive in Object>>at:"

	^self basicAt: index! !

!Float methodsFor: 'accessing' stamp: 'ar 6/20/2010 14:28'!
at: index put: value 
	"Avoid primitive in Object>>at:put:"

	^self basicAt: index put: value! !

!Float methodsFor: 'accessing' stamp: 'eem 4/20/2009 09:34'!
basicAt: index
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. Do not override in a subclass. See 
	Object documentation whatIsAPrimitive.

	This version of basicAt: is specifically for floats, answering the most significant
	word for index 1 and the least significant word for index 2.  This alows the VM
	to store floats in whatever order it chooses while it appears to the image that
	they are always in big-endian/PowerPC order."

	<primitive: 38 error: ec>
	ec == nil ifTrue: "primitive not implemented; floats are in big-endian/PowerPC order."
		[^super basicAt: index].
	index isInteger ifTrue: [self errorSubscriptBounds: index].
	index isNumber
		ifTrue: [^self basicAt: index asInteger]
		ifFalse: [self errorNonIntegerIndex]! !

!Float methodsFor: 'accessing' stamp: 'eem 4/20/2009 09:35'!
basicAt: index put: value
	"Primitive. Assumes receiver is indexable. Store the second argument 
	value in the indexable element of the receiver indicated by index. Fail 
	if the index is not an Integer or is out of bounds. Or fail if the value is 
	not of the right type for this kind of collection. Answer the value that 
	was stored. Essential. Do not override in a subclass. See Object 
	documentation whatIsAPrimitive.

	This version of basicAt: is specifically for floats, answering the most significant
	word for index 1 and the least significant word for index 2.  This alows the VM
	to store floats in whatever order it chooses while it appears to the image that
	they are always in big-endian/PowerPC order."

	<primitive: 39 error: ec>
	ec == nil ifTrue: "primitive not implemented; floats are in big-endian/PowerPC order."
		[^super basicAt: index put: value].
	index isInteger
		ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]].
	index isNumber
		ifTrue: [^self basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]! !

!Float methodsFor: 'printing' stamp: ''!
byteEncode: t1 base: t2 
	self isNaN
		ifTrue: [t1 print: 'NaN'.
			^ self].
	self > 0.0
		ifTrue: [self absByteEncode: t1 base: t2]
		ifFalse: [self sign = -1
				ifTrue: [t1 print: '-'].
			self = 0.0
				ifTrue: [t1 print: '0.0'.
					^ self].
			t1 writeNumber: self negated base: t2]! !

!Float methodsFor: 'comparing' stamp: ''!
closeTo: t1 
	t1 isNumber
		ifFalse: [^ [self = t1]
				ifError: [false]].
	self = 0.0
		ifTrue: [^ t1 abs < 0.0001].
	t1 = 0
		ifTrue: [^ self abs < 0.0001].
	^ self = t1 asFloat
		or: [(self - t1) abs
				/ (self abs max: t1 abs) < 0.0001]! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:26'!
copySignTo: aNumber
	"Return a number with same magnitude as aNumber and same sign as self.
	Implementation note: take care of Float negativeZero, which is considered as having a negative sign."

	(self > 0.0 or: [(self at: 1) = 0]) ifTrue: [^ aNumber abs].
	^aNumber withNegativeSign! !

!Float methodsFor: 'mathematical functions' stamp: ''!
cos
	"Answer the cosine of the receiver taken as an angle in radians."

	^ (self + Halfpi) sin! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:35'!
cosh
	"Answer receivers hyperbolic cosine."
	
	| ex |
	ex := self abs exp.
	^(ex + ex reciprocal) / 2! !

!Float methodsFor: 'copying' stamp: ''!
deepCopy
	^ self copy! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 11/1/2010 11:56'!
degreeCos
	"Take care of exceptional values"
	
	self isFinite ifTrue: [^super degreeCos].
	^self degreesToRadians cos! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 11/1/2010 11:56'!
degreeSin
	"Take care of exceptional values"
	
	self isFinite ifTrue: [^super degreeSin].
	^self degreesToRadians sin! !

!Float methodsFor: 'converting' stamp: ''!
degreesToRadians
	^ self * RadiansPerDegree! !

!Float methodsFor: 'mathematical functions' stamp: ''!
exp
	"Answer E raised to the receiver power.
	 Optional. See Object documentation whatIsAPrimitive." 

	| base fract correction delta div |
	<primitive: 59>

	"Taylor series"
	"check the special cases"
	self < 0.0 ifTrue: [^ (self negated exp) reciprocal].
	self = 0.0 ifTrue: [^ 1].
	self abs > MaxValLn ifTrue: [self error: 'exp overflow'].

	"get first approximation by raising e to integer power"
	base := E raisedToInteger: (self truncated).

	"now compute the correction with a short Taylor series"
	"fract will be 0..1, so correction will be 1..E"
	"in the worst case, convergance time is logarithmic with 1/Epsilon"
	fract := self fractionPart.
	fract = 0.0 ifTrue: [ ^ base ].  "no correction required"

	correction := 1.0 + fract.
	delta := fract * fract / 2.0.
	div := 2.0.
	[delta > Epsilon] whileTrue: [
		correction := correction + delta.
		div := div + 1.0.
		delta := delta * fract / div].
	correction := correction + delta.
	^ base * correction! !

!Float methodsFor: 'truncation and round off' stamp: 'nice 6/3/2012 15:23'!
exponent
	"Primitive. Consider the receiver to be represented as a power of two
	multiplied by a mantissa (between one and two). Answer with the
	SmallInteger to whose power two is raised. Optional. See Object
	documentation whatIsAPrimitive."

	<primitive: 53>
	^self exponentFromBitPattern! !

!Float methodsFor: 'truncation and round off' stamp: 'nice 6/3/2012 15:21'!
exponentFromBitPattern
	"Extract the exponent from the bit pattern.
	This is used only when primitive fails"
	
	| exponent word1 |
	self isFinite ifFalse: [^self error: 'cannot take the exponent of non finite Float'].
	self = 0.0 ifTrue: [^-1].
	word1 := self basicAt: 1.
	exponent := (word1 bitShift: -20) bitAnd: 16r7FF.
	^exponent = 0
		ifTrue:
			[| high |
			high := (word1 bitAnd: 16rFFFFF) highBit.
			high := high = 0
				ifTrue: [(self basicAt: 2) highBit]
				ifFalse: [high + 32].
			self class emin - self class precision + high]
		ifFalse:
			[exponent + self class emin - 1]! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 6/3/2012 17:26'!
floorLog: radix
	"Answer the floor of the log base radix of the receiver.
	The result may be off by one due to rounding errors, except in base 2."

	(radix = 2 and: [self > 0.0 and: [self isFinite]]) ifTrue: [^self exponent].
	^ (self log: radix) floor
! !

!Float methodsFor: 'truncation and round off' stamp: ''!
fractionPart
	"Primitive. Answer a Float whose value is the difference between the 
	receiver and the receiver's asInteger value. Optional. See Object 
	documentation whatIsAPrimitive."

	<primitive: 52>
	^self - self truncated asFloat! !

!Float methodsFor: 'comparing' stamp: ''!
hash
	(self isFinite
			and: [self fractionPart = 0.0])
		ifTrue: [^ self truncated hash].
	^ ((self basicAt: 1)
		bitShift: -4)
		+ ((self basicAt: 2)
				bitShift: -4)! !

!Float methodsFor: 'printing' stamp: ''!
hex
	^ String
		streamContents: [:t1 | 
			| t2 t3 |
			1
				to: 2
				do: [:t5 | 
					t2 := self at: t5.
					1
						to: 8
						do: [:t4 | 
							t3 := (t2 bitShift: -8 + t4 * 4)
										bitAnd: 15.
							t1
								nextPut: ('0123456789ABCDEF' at: t3 + 1)]].
			nil]! !

!Float methodsFor: 'truncation and round off' stamp: ''!
integerPart
	^ self - self fractionPart! !

!Float methodsFor: 'testing' stamp: ''!
isFinite
	^ self - self = 0.0! !

!Float methodsFor: 'testing' stamp: ''!
isFloat
	^ true! !

!Float methodsFor: 'testing' stamp: ''!
isInfinite
	^ self = Infinity
		or: [self = NegativeInfinity]! !

!Float methodsFor: 'testing' stamp: ''!
isLiteral
	^ self isFinite! !

!Float methodsFor: 'testing' stamp: ''!
isNaN
	^ self ~= self! !

!Float methodsFor: 'testing' stamp: ''!
isPowerOfTwo
	^ false! !

!Float methodsFor: 'testing' stamp: ''!
isZero
	^ self = 0.0! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/22/2011 02:16'!
ln
	"Answer the natural logarithm of the receiver.
	 Optional. See Object documentation whatIsAPrimitive."

	| expt n mant x div pow delta sum eps |
	<primitive: 58>

	"Taylor series"
	self <= 0.0 ifTrue: [DomainError signal: 'ln is only defined for x > 0.0'].

	"get a rough estimate from binary exponent"
	expt := self exponent.
	n := Ln2 * expt.
	mant := self timesTwoPower: 0 - expt.

	"compute fine correction from mantinssa in Taylor series"
	"mant is in the range [0..2]"
	"we unroll the loop to avoid use of abs"
	x := mant - 1.0.
	div := 1.0.
	pow := delta := sum := x.
	x := x negated.  "x <= 0"
	eps := Epsilon * (n abs + 1.0).
	[delta > eps] whileTrue: [
		"pass one: delta is positive"
		div := div + 1.0.
		pow := pow * x.
		delta := pow / div.
		sum := sum + delta.
		"pass two: delta is negative"
		div := div + 1.0.
		pow := pow * x.
		delta := pow / div.
		sum := sum + delta].

	^ n + sum

	"2.718284 ln 1.0"! !

!Float methodsFor: 'mathematical functions' stamp: ''!
log
	"Answer the base 10 logarithm of the receiver."

	^ self ln / Ln10! !

!Float methodsFor: 'arithmetic' stamp: ''!
negated
	^ 0.0 - self! !

!Float methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 09:03'!
nthRoot: aPositiveInteger
	"Answer the nth root of the receiver."
	aPositiveInteger = 2 ifTrue: [
		^self sqrt ].

	(aPositiveInteger isInteger not or: [ aPositiveInteger negative ])
		ifTrue: [^ ArithmeticError signal: 'nth root only defined for positive Integer n.'].
	
	^self negative
		ifTrue: [
			aPositiveInteger odd
				ifTrue: [ (self negated raisedTo: 1.0 / aPositiveInteger) negated ]
				ifFalse: [ ArithmeticError signal: 'Negative numbers don''t have even roots.' ]]
		ifFalse: [ self raisedTo: 1.0 / aPositiveInteger ]! !

!Float methodsFor: 'truncation and round off' stamp: ''!
predecessor
	| t1 |
	self isFinite
		ifFalse: [(self isNaN
					or: [self negative])
				ifTrue: [^ self].
			^ Float fmax].
	self = 0.0
		ifTrue: [^ Float fmin negated].
	t1 := self ulp.
	^ self - (0.5 * t1) = self
		ifTrue: [self - t1]
		ifFalse: [self - (0.5 * t1)]! !

!Float methodsFor: 'printing' stamp: 'nice 11/5/2011 00:32'!
printOn: aStream base: base
	"Print the receiver with the minimal number of digits that describes it unambiguously.
	This way, every two different Float will have a different printed representation.
	More over, every Float can be reconstructed from its printed representation with #readFrom:." 

	self isNaN ifTrue: [aStream nextPutAll: 'NaN'. ^ self]. "check for NaN before sign"
	self > 0.0
		ifTrue: [self absPrintExactlyOn: aStream base: base]
		ifFalse:
			[self sign = -1
				ifTrue: [aStream nextPutAll: '-'].
			self = 0.0
				ifTrue: [aStream nextPutAll: '0.0']
				ifFalse: [self negated absPrintExactlyOn: aStream base: base]]! !

!Float methodsFor: 'printing' stamp: 'nice 5/20/2012 00:11'!
printOn: aStream maxDecimalPlaces: placesDesired
	"Refine super implementation in order to avoid any rounding error caused by rounded or roundTo:"
	
	self isFinite ifFalse: [^self printOn: aStream].
	self > 0.0
		ifTrue: [self absPrintExactlyOn: aStream base: 10 decimalPlaces: placesDesired showTrailingFractionalZeros: false]
		ifFalse:
			[self sign = -1
				ifTrue: [aStream nextPutAll: '-'].
			self = 0.0
				ifTrue: [aStream nextPutAll: '0.0']
				ifFalse: [self absPrintExactlyOn: aStream base: 10 decimalPlaces: placesDesired showTrailingFractionalZeros: false]]! !

!Float methodsFor: 'printing' stamp: 'nice 11/5/2012 21:42'!
printOn: aStream showingDecimalPlaces: placesDesired
	"Refine super implementation in order to avoid any rounding error caused by rounded or roundTo:"
	
	self isFinite ifFalse: [^self printOn: aStream].
	self > 0.0
		ifTrue: [self absPrintExactlyOn: aStream base: 10 decimalPlaces: placesDesired showTrailingFractionalZeros: true]
		ifFalse:
			[self sign = -1
				ifTrue: [aStream nextPutAll: '-'].
			self = 0.0
				ifTrue:
					[aStream nextPut: $0.
					placesDesired > 0 ifTrue: [aStream nextPut: $.; next: placesDesired put: $0]]
				ifFalse: [self absPrintExactlyOn: aStream base: 10 decimalPlaces: placesDesired showTrailingFractionalZeros: true]]! !

!Float methodsFor: 'printing' stamp: 'dtl 2/27/2011 21:39'!
printPaddedWith: aCharacter to: aNumber 
	"Answer the string containing the ASCII representation of the receiver 
	padded on the left with aCharacter to be at least on aNumber 
	integerPart characters and padded the right with aCharacter to be at 
	least anInteger fractionPart characters."
	| aStream digits fPadding fLen iPadding iLen curLen periodIndex |
	#Numeric.
	"2000/03/04  Harmon R. Added Date and Time support"
	aStream := WriteStream on: (String new: 10).
	self printOn: aStream.
	digits := aStream contents.
	periodIndex := digits indexOf: $..
	curLen := periodIndex - 1.
	iLen := aNumber integerPart.
	curLen < iLen
		ifTrue: [iPadding := (String new: (iLen - curLen) asInteger) atAllPut: aCharacter;
					 yourself]
		ifFalse: [iPadding := ''].
	curLen := digits size - periodIndex.
	"n.b. Treat aNumber as a string format specifier rather than as a number, because
	floating point truncation can produce incorrect results for the fraction part."
	fLen := (aNumber asString copyAfterLast: $. )
		ifNotEmpty: [:s | s asInteger]
		ifEmpty: [ 0 ].
	curLen < fLen
		ifTrue: [fPadding := (String new: fLen - curLen) atAllPut: aCharacter;
					 yourself]
		ifFalse: [fPadding := ''].
	^ iPadding , digits , fPadding! !

!Float methodsFor: 'converting' stamp: ''!
radiansToDegrees
	^ self / RadiansPerDegree! !

!Float methodsFor: 'arithmetic' stamp: ''!
reciprocal
	^ 1.0 / self! !

!Float methodsFor: 'mathematical functions' stamp: ''!
reciprocalFloorLog: t1 
	| t2 t3 t4 |
	t2 := 0.
	t3 := 1.0.
	[(t4 := t1 / (self * t3)) isInfinite]
		whileTrue: [t3 := t3 * t1.
			t2 := t2 + 1].
	^ ((t4 floorLog: t1)
		+ t2) negated! !

!Float methodsFor: 'mathematical functions' stamp: ''!
reciprocalLogBase2
	^ self = 10.0
		ifTrue: [Ln2 / Ln10]
		ifFalse: [Ln2 / self ln]! !

!Float methodsFor: 'truncation and round off' stamp: ''!
reduce
	(self closeTo: self rounded)
		ifTrue: [^ self rounded]! !

!Float methodsFor: 'truncation and round off' stamp: ''!
rounded
	self fractionPart abs < 0.5
		ifTrue: [^ self truncated].
	^ self truncated + self sign rounded! !

!Float methodsFor: 'mathematical functions' stamp: ''!
safeArcCos
	(self between: -1.0 and: 1.0)
		ifTrue: [^ self arcCos].
	^ self sign arcCos! !

!Float methodsFor: 'mathematical functions' stamp: 'jm 4/28/1998 01:10'!
sign
	"Answer 1 if the receiver is greater than 0, -1 if less than 0, else 0.
	Handle IEEE-754 negative-zero by reporting a sign of -1"

	self > 0 ifTrue: [^ 1].
	(self < 0 or: [((self at: 1) bitShift: -31) = 1]) ifTrue: [^ -1].
	^ 0! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 9/21/2010 23:30'!
sign: aNumber
	"Return a Number with the same sign as aNumber and same magnitude as self.
	Implementation is different from super to handle the special case of Float negativeZero."

	(self = 0.0 and: [aNumber sign negative]) ifTrue: [^Float negativeZero].
	^aNumber copySignTo: self! !

!Float methodsFor: 'truncation and round off' stamp: ''!
significand
	^ self timesTwoPower: self exponent negated! !

!Float methodsFor: 'truncation and round off' stamp: 'nice 6/7/2012 00:17'!
significandAsInteger
	"Answer the mantissa of a Float shifted so as to have the ulp equal to 1.
	For exceptional values, infinity and nan, just answer the bit pattern."

	self isFinite ifTrue:
		[^(self timesTwoPower: self class precision - 1 - (self exponent max: self class emin)) truncated abs].
	^(((self basicAt: 1) bitAnd: 16r000FFFFF) bitShift: 32) bitOr: (self basicAt: 2)! !

!Float methodsFor: 'mathematical functions' stamp: ''!
sin
	"Answer the sine of the receiver taken as an angle in radians.
	 Optional. See Object documentation whatIsAPrimitive."

	| sum delta self2 i |
	<primitive: 56>

	"Taylor series"
	"normalize to the range [0..Pi/2]"
	self < 0.0 ifTrue: [^ (0.0 - ((0.0 - self) sin))].
	self > Twopi ifTrue: [^ (self \\ Twopi) sin].
	self > Pi ifTrue: [^ (0.0 - (self - Pi) sin)].
	self > Halfpi ifTrue: [^ (Pi - self) sin].

	"unroll loop to avoid use of abs"
	sum := delta := self.
	self2 := 0.0 - (self * self).
	i := 2.0.
	[delta > Epsilon] whileTrue: [
		"once"
		delta := (delta * self2) / (i * (i + 1.0)).
		i := i + 2.0.
		sum := sum + delta.
		"twice"
		delta := (delta * self2) / (i * (i + 1.0)).
		i := i + 2.0.
		sum := sum + delta].
	^ sum! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 01:55'!
sinh
	"Answer receivers hyperbolic sine"
	
	| ex |
	ex := self abs exp.
	^self copySignTo: (ex - ex reciprocal) / 2! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/22/2011 02:29'!
sqrt
	"Answer the square root of the receiver. 
	 Optional. See Object documentation whatIsAPrimitive."
	| exp guess eps delta |
	<primitive: 55>
	#Numeric.
	"Changed 200/01/19 For ANSI <number> support."
	"Newton-Raphson"
	self <= 0.0
		ifTrue: [self = 0.0
				ifTrue: [^ 0.0]
				ifFalse: ["v Chg"
					^ DomainError signal: 'sqrt undefined for number less than zero.']].
	"first guess is half the exponent"
	exp := self exponent // 2.
	guess := self timesTwoPower: 0 - exp.
	"get eps value"
	eps := guess * Epsilon.
	eps := eps * eps.
	delta := self - (guess * guess) / (guess * 2.0).
	[delta * delta > eps]
		whileTrue: 
			[guess := guess + delta.
			delta := self - (guess * guess) / (guess * 2.0)].
	^ guess! !

!Float methodsFor: 'printing' stamp: ''!
storeOn: t1 
	self storeOn: t1 base: 10! !

!Float methodsFor: 'printing' stamp: ''!
storeOn: t1 base: t2 
	self isFinite
		ifTrue: [self sign = -1
				ifTrue: [t1 nextPutAll: '-'].
			t2 = 10
				ifFalse: [t1 print: t2;
						 nextPut: $r].
			self = 0.0
				ifTrue: [t1 nextPutAll: '0.0']
				ifFalse: [self abs absPrintExactlyOn: t1 base: t2]]
		ifFalse: [self isNaN
				ifTrue: [t1 nextPutAll: 'Float nan']
				ifFalse: [self > 0.0
						ifTrue: [t1 nextPutAll: 'Float infinity']
						ifFalse: [t1 nextPutAll: 'Float infinity negated']]]! !

!Float methodsFor: 'truncation and round off' stamp: ''!
successor
	| t1 |
	self isFinite
		ifFalse: [(self isNaN
					or: [self positive])
				ifTrue: [^ self].
			^ Float fmax negated].
	self = 0.0
		ifTrue: [^ Float fmin].
	t1 := self ulp.
	^ self + (0.5 * t1) = self
		ifTrue: [self + t1]
		ifFalse: [self + (0.5 * t1)]! !

!Float methodsFor: 'mathematical functions' stamp: ''!
tan
	"Answer the tangent of the receiver taken as an angle in radians."

	^ self sin / self cos! !

!Float methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:08'!
tanh
	"Answer hyperbolic tangent of receiver.
	Trivial implementation is:
		^self sinh/self cosh
	This implementation takes care not to overflow."

	| ex emx |
	self = 0.0 ifTrue: [^self].	"Handle negativeZero"
	self > 20.0 ifTrue: [^1.0].
	self < -20.0 ifTrue: [^-1.0].
	ex := self exp.
	emx := ex reciprocal.
	^(ex - emx) / (ex + emx)! !

!Float methodsFor: 'mathematical functions' stamp: ''!
timesTwoPower: anInteger 
	"Primitive. Answer with the receiver multiplied by 2.0 raised
	to the power of the argument.
	Optional. See Object documentation whatIsAPrimitive."

	<primitive: 54>

	anInteger < -29 ifTrue: [^ self * (2.0 raisedToInteger: anInteger)].
	anInteger < 0 ifTrue: [^ self / (1 bitShift: (0 - anInteger)) asFloat].
	anInteger < 30 ifTrue: [^ self * (1 bitShift: anInteger) asFloat].
	^ self * (2.0 raisedToInteger: anInteger)! !

!Float methodsFor: 'truncation and round off' stamp: ''!
truncated
	| t1 t2 t3 t4 |
	<primitive: 51>
	self isFinite
		ifFalse: [self error: 'Cannot truncate this number'].
	self abs < 2.0e16
		ifTrue: [t1 := 1
						+ (SmallInteger maxVal bitShift: -1).
			t2 := t1 asFloat.
			t3 := self quo: t2.
			t4 := self - (t3 asFloat * t2).
			^ t3 * t1 + t4 truncated].
	^ self asTrueFraction! !

!Float methodsFor: 'truncation and round off' stamp: 'nice 5/4/2011 21:45'!
ulp
	"Answer the unit of least precision of self (the power of two corresponding to last bit of mantissa)"
	
	| exponent |
	self isFinite ifFalse: [^self abs].
	self = 0.0 ifTrue: [^Float fmin].
	exponent := self exponent.
	^exponent < self class emin
		ifTrue: [Float fminDenormalized]
 		ifFalse: [Float epsilon timesTwoPower: exponent]! !

!Float methodsFor: 'copying' stamp: ''!
veryDeepCopyWith: t1 
	^ self clone! !

!Float methodsFor: 'converting' stamp: 'nice 4/23/2011 02:24'!
withNegativeSign
	"Same as super, but handle the subtle case of Float negativeZero"
	
	self = 0.0 ifTrue: [^self class negativeZero].  
	^super withNegativeSign! !

!Float methodsFor: 'comparing' stamp: ''!
~= t1 
	<primitive: 48>
	^ super ~= t1! !

Number subclass: #Fraction
	instanceVariableNames: 'numerator denominator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!Fraction class methodsFor: 'instance creation' stamp: ''!
numerator: t1 denominator: t2 
	^ self new setNumerator: t1 denominator: t2! !

!Fraction class methodsFor: 'instance creation' stamp: 'nice 5/20/2012 16:30'!
readFrom: stringOrStream 
	"Answer a fraction as described on aStream. 
	The fraction may be specified as numerator/denominator, or just a numerator, or as integerPart.fractionPart.
	In numerator/denominator form, both parts may have a radix specification and an exponent, but only numerator can have a sign.
	In fractional digits form, an alternate radix and an exponent can also be provided, the integer or fraction part being optional."
	
	^(ExtendedNumberParser on: stringOrStream) nextFraction! !

!Fraction class methodsFor: 'instance creation' stamp: 'nice 5/20/2012 16:10'!
readFrom: stringOrStream base: aRadix
	"Answer a Fraction as described on aStream. 
	The Fraction may be specified as numerator/denominator, or just with numerator.
	Both numerator and denominator can have an exponent, but only numerator can have a sign."
	
	^(ExtendedNumberParser on: stringOrStream) nextFractionBase: aRadix! !

!Fraction methodsFor: 'arithmetic' stamp: ''!
* t1 
	| t2 t3 |
	t1 isFraction
		ifTrue: [t2 := numerator gcd: t1 denominator.
			t3 := denominator gcd: t1 numerator.
			(t3 = denominator
					and: [t2 = t1 denominator])
				ifTrue: [^ numerator // t2 * (t1 numerator // t3)].
			^ Fraction numerator: numerator // t2 * (t1 numerator // t3) denominator: denominator // t3 * (t1 denominator // t2)].
	^ t1 adaptToFraction: self andSend: #*! !

!Fraction methodsFor: 'arithmetic' stamp: ''!
+ t1 
	| t2 t3 t4 t5 |
	t1 isFraction
		ifTrue: [t3 := denominator gcd: t1 denominator.
			t2 := numerator * (t4 := t1 denominator // t3) + (t1 numerator * (t5 := denominator // t3)).
			t4 := t4 * t5.
			t2 := t2 // (t5 := t2 gcd: t3).
			(t3 := t4 * (t3 // t5)) = 1
				ifTrue: [^ t2].
			^ Fraction numerator: t2 denominator: t3].
	^ t1 adaptToFraction: self andSend: #+! !

!Fraction methodsFor: 'arithmetic' stamp: ''!
- t1 
	t1 isFraction
		ifTrue: [^ self + t1 negated].
	^ t1 adaptToFraction: self andSend: #-! !

!Fraction methodsFor: 'arithmetic' stamp: ''!
/ t1 
	t1 isFraction
		ifTrue: [^ self * t1 reciprocal].
	^ t1 adaptToFraction: self andSend: #/! !

!Fraction methodsFor: 'comparing' stamp: ''!
< t1 
	t1 isFraction
		ifTrue: [^ numerator * t1 denominator < (t1 numerator * denominator)].
	^ t1 adaptToFraction: self andCompare: #<! !

!Fraction methodsFor: 'comparing' stamp: ''!
<= t1 
	t1 isFraction
		ifTrue: [^ numerator * t1 denominator <= (t1 numerator * denominator)].
	^ t1 adaptToFraction: self andCompare: #<=! !

!Fraction methodsFor: 'comparing' stamp: ''!
= t1 
	t1 isNumber
		ifFalse: [^ false].
	t1 isFraction
		ifTrue: [numerator = 0
				ifTrue: [^ t1 numerator = 0].
			^ numerator * t1 denominator = (t1 numerator * denominator)].
	^ t1 adaptToFraction: self andCompare: #=! !

!Fraction methodsFor: 'comparing' stamp: ''!
> t1 
	t1 isFraction
		ifTrue: [^ numerator * t1 denominator > (t1 numerator * denominator)].
	^ t1 adaptToFraction: self andCompare: #>! !

!Fraction methodsFor: 'comparing' stamp: ''!
>= t1 
	t1 isFraction
		ifTrue: [^ numerator * t1 denominator >= (t1 numerator * denominator)].
	^ t1 adaptToFraction: self andCompare: #>=! !

!Fraction methodsFor: 'converting' stamp: 'nice 9/7/2011 21:56'!
adaptToInteger: rcvr andSend: selector
	"If I am involved in arithmetic with an Integer, convert it to a Fraction."
	^ (Fraction numerator: rcvr denominator: 1) perform: selector with: self! !

!Fraction methodsFor: 'converting' stamp: ''!
adaptToScaledDecimal: t1 andSend: t2 
	^ t1
		perform: t2
		with: (self asScaledDecimal: t1 scale)! !

!Fraction methodsFor: 'converting' stamp: 'nice 9/25/2011 12:47'!
asFloat
	"Answer a Float that closely approximates the value of the receiver.
	This implementation will answer the closest floating point number to the receiver.
	In case of a tie, it will use the IEEE 754 round to nearest even mode.
	In case of overflow, it will answer +/- Float infinity."

	| a b mantissa exponent hasTruncatedBits lostBit n ha hb hm |
	a := numerator abs.
	b := denominator.	"denominator is always positive"
	ha := a highBit.
	hb := b highBit.
	
	"Number of bits to keep in mantissa plus one to handle rounding."
	n := 1 + Float precision.

	"If both numerator and denominator are represented exactly in floating point number,
	then fastest thing to do is to use hardwired float division."
	(ha < n and: [hb < n]) ifTrue: [^numerator asFloat / denominator asFloat].

	"Shift the fraction by a power of two exponent so as to obtain a mantissa with n bits.
	First guess is rough, the mantissa might have n+1 bits."
	exponent := ha - hb - n.
	exponent >= 0
		ifTrue: [b := b bitShift: exponent]
		ifFalse: [a := a bitShift: exponent negated].
	mantissa := a quo: b.
	hasTruncatedBits := a > (mantissa * b).
	hm := mantissa highBit.
	
	"Check for gradual underflow, in which case the mantissa will loose bits.
	Keep at least one bit to let underflow preserve the sign of zero."
	lostBit := Float emin - (exponent + hm - 1).
	lostBit > 0 ifTrue: [n := n - lostBit max: 1].

	"Remove excess bits in the mantissa."
	hm > n
		ifTrue:
			[exponent := exponent + hm - n.
			hasTruncatedBits := hasTruncatedBits or: [mantissa anyBitOfMagnitudeFrom: 1 to: hm - n].
			mantissa := mantissa bitShift: n - hm].

	"Check if mantissa must be rounded upward.
	The case of tie (mantissa odd & hasTruncatedBits not)
	will be handled by Integer>>asFloat."
	(hasTruncatedBits and: [mantissa odd])
		ifTrue: [mantissa := mantissa + 1].

	^ (self positive
			ifTrue: [mantissa asFloat]
			ifFalse: [mantissa asFloat negated])
		timesTwoPower: exponent! !

!Fraction methodsFor: 'converting' stamp: ''!
asFraction
	^ self! !

!Fraction methodsFor: 'converting' stamp: 'wiz 5/29/2011 18:33'!
asNonFraction	
	"Answer a number equivalent to the receiver that is not a fraction."


	^self asFloat! !

!Fraction methodsFor: 'converting' stamp: ''!
asScaledDecimal
	| t1 t2 t3 t4 |
	t1 := denominator lowBit - 1.
	t3 := denominator bitShift: t1 negated.
	t2 := 0.
	[t3 = 1]
		whileFalse: [t4 := t3 // 5.
			t3 - (5 * t4) = 0
				ifFalse: [^ super asScaledDecimal].
			t3 := t4.
			t2 := t2 + 1].
	^ self
		asScaledDecimal: (t1 max: t2)! !

!Fraction methodsFor: 'private' stamp: ''!
denominator
	^ denominator! !

!Fraction methodsFor: 'comparing' stamp: 'nice 6/11/2009 02:52'!
hash
	"Hash is reimplemented because = is implemented.
	Care is taken that a Fraction equal to a Float also have an equal hash"

	| tmp |
	denominator isPowerOfTwo ifTrue: [
		"If denominator is a power of two, I can be exactly equal to a Float"
		tmp := self asFloat.
		tmp isFinite ifTrue: [^tmp hash]].
	
	"Else, I cannot be exactly equal to a Float, use own hash algorithm.
	(Assume the fraction is already reduced)"
	^numerator hash bitXor: denominator hash! !

!Fraction methodsFor: 'converting' stamp: ''!
isFraction
	^ true! !

!Fraction methodsFor: 'mathematical functions' stamp: 'nice 11/1/2011 18:09'!
ln
	"This function is defined because super ln might overflow."
	| res |
	self <= 0 ifTrue: [DomainError signal: 'ln is only defined for x > 0'].
	"Test self < 1 before converting to float in order to avoid precision loss due to gradual underflow."
	numerator < denominator ifTrue: [^self reciprocal ln negated].
	res := super ln.
	res isFinite ifTrue: [^res].
	^numerator ln - denominator ln! !

!Fraction methodsFor: 'mathematical functions' stamp: 'nice 11/1/2011 18:08'!
log
	"This function is defined because super log might overflow."
	| res |
	self <= 0 ifTrue: [DomainError signal: 'log is only defined for x > 0'].
	"Test self < 1 before converting to float in order to avoid precision loss due to gradual underflow."
	numerator < denominator ifTrue: [^self reciprocal log negated].
	res := super log.
	res isFinite ifTrue: [^res].
	^numerator log - denominator log! !

!Fraction methodsFor: 'arithmetic' stamp: ''!
negated
	^ Fraction numerator: numerator negated denominator: denominator! !

!Fraction methodsFor: 'testing' stamp: 'ul 11/29/2010 20:05'!
negative

	^numerator negative! !

!Fraction methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 21:38'!
nthRoot: aPositiveInteger
	"Answer the nth root of the receiver."

	| d n |
	n := numerator nthRoot: aPositiveInteger.
	d := denominator nthRoot: aPositiveInteger.
	"The #sqrt method in integer will only answer a Float if there's no exact square root.
	So, we need a float anyway."
	(n isInfinite or: [ d isInfinite ]) ifTrue: [
		^self asFloat nthRoot: aPositiveInteger ].
	^n / d! !

!Fraction methodsFor: 'private' stamp: ''!
numerator
	^ numerator! !

!Fraction methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPut: $(.
	numerator printOn: t1.
	t1 nextPut: $/.
	denominator printOn: t1.
	t1 nextPut: $)! !

!Fraction methodsFor: 'printing' stamp: ''!
printOn: t1 base: t2 
	t1 nextPut: $(.
	numerator printOn: t1 base: t2.
	t1 nextPut: $/.
	denominator printOn: t1 base: t2.
	t1 nextPut: $)! !

!Fraction methodsFor: 'printing' stamp: 'nice 3/29/2011 22:56'!
printOn: aStream showingDecimalPlaces: placesDesired
	"Same as super, but provides a faster implementation by inlining some Fraction protocol thus avoiding intermediate Fraction creation."
	
	| roundedFractionPart integerPart scaling |
	placesDesired <= 0
		ifTrue: [self rounded printOn: aStream]
		ifFalse:
			[scaling := 10 raisedToInteger: placesDesired.
			integerPart := numerator abs quo: denominator.
			roundedFractionPart := (numerator abs - (integerPart * denominator)) * scaling * 2 + denominator quo: denominator * 2.
			roundedFractionPart = scaling
				ifTrue:
					[integerPart := integerPart + 1.
					roundedFractionPart := 0].
			"Don't print minus sign if result is rouded to zero"
			(numerator negative and: [integerPart > 0 or: [roundedFractionPart > 0]]) ifTrue: [aStream nextPut: $-].
			integerPart printOn: aStream.
			aStream nextPut: $..
			roundedFractionPart printOn: aStream base: 10 length: placesDesired padded: true].! !

!Fraction methodsFor: 'printing' stamp: 'nice 3/29/2011 21:45'!
printTruncatedOn: aStream showingDecimalPlaces: placesDesired
	"Print a representation of the receiver on aStream in decimal notation with prescribed number of places after decimal separator.
	Print as if the receiver was truncated to requested precision."
	
	| truncatedFractionPart integerPart scaling |
	placesDesired <= 0
		ifTrue: [self truncated printOn: aStream]
		ifFalse:
			[scaling := 10 raisedToInteger: placesDesired.
			integerPart := numerator abs quo: denominator.
			truncatedFractionPart := (numerator abs - (integerPart * denominator)) * scaling quo: denominator.
			numerator negative ifTrue: [aStream nextPut: $-].
			integerPart printOn: aStream.
			aStream nextPut: $..
			truncatedFractionPart printOn: aStream base: 10 length: placesDesired padded: true].! !

!Fraction methodsFor: 'mathematical functions' stamp: ''!
raisedToInteger: t1 
	t1 = 0
		ifTrue: [^ 1].
	t1 < 0
		ifTrue: [^ self reciprocal raisedToInteger: t1 negated].
	^ Fraction
		numerator: (numerator raisedToInteger: t1)
		denominator: (denominator raisedToInteger: t1)! !

!Fraction methodsFor: 'private' stamp: ''!
reciprocal
	numerator abs = 1
		ifTrue: [^ denominator * numerator].
	^ self class numerator: denominator denominator: numerator! !

!Fraction methodsFor: 'private' stamp: ''!
reduced
	| t1 t2 t3 |
	numerator = 0
		ifTrue: [^ 0].
	t1 := numerator gcd: denominator.
	t2 := numerator // t1.
	t3 := denominator // t1.
	t3 = 1
		ifTrue: [^ t2].
	^ Fraction numerator: t2 denominator: t3! !

!Fraction methodsFor: 'private' stamp: ''!
setNumerator: t1 denominator: t2 
	t2 = 0
		ifTrue: [^ (ZeroDivide dividend: t1) signal].
	numerator := t1 asInteger.
	denominator := t2 asInteger abs.
	t2 < 0
		ifTrue: [numerator := numerator negated]! !

!Fraction methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 20:16'!
sqrt
	| d n |
	n := numerator sqrt.
	d := denominator sqrt.
	"The #sqrt method in integer will only answer a Float if there's no exact square root.
	So, we need a float anyway."
	(n isInfinite or: [ d isInfinite ]) ifTrue: [
		^self asFloat sqrt ].
	^n / d! !

!Fraction methodsFor: 'mathematical functions' stamp: ''!
squared
	^ Fraction numerator: numerator squared denominator: denominator squared! !

!Fraction methodsFor: 'printing' stamp: ''!
storeOn: t1 base: t2 
	t1 nextPut: $(.
	numerator storeOn: t1 base: t2.
	t1 nextPut: $/.
	denominator storeOn: t1 base: t2.
	t1 nextPut: $)! !

!Fraction methodsFor: 'truncation and round off' stamp: ''!
truncated
	^ numerator quo: denominator! !

Number subclass: #Integer
	instanceVariableNames: ''
	classVariableNames: 'LowBitPerByteTable'
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!Integer commentStamp: '<historical>' prior: 0!
I am a common abstract superclass for all Integer implementations. My implementation subclasses are SmallInteger, LargePositiveInteger, and LargeNegativeInteger.
	
Integer division consists of:
	/	exact division, answers a fraction if result is not a whole integer
	//	answers an Integer, rounded towards negative infinity
	\\	is modulo rounded towards negative infinity
	quo: truncated division, rounded towards zero!

!Integer class methodsFor: 'instance creation' stamp: ''!
basicNew
	self == Integer
		ifTrue: [^ self error: 'Integer is an abstract class.  Make a concrete subclass.'].
	^ super basicNew! !

!Integer class methodsFor: 'instance creation' stamp: ''!
byte1: t1 byte2: t2 byte3: t3 byte4: t4 
	| t5 |
	t4 < 64
		ifTrue: [^ (t4 bitShift: 24)
				+ (t3 bitShift: 16)
				+ (t2 bitShift: 8) + t1].
	t5 := LargePositiveInteger new: 4.
	t5 digitAt: 4 put: t4.
	t5 digitAt: 3 put: t3.
	t5 digitAt: 2 put: t2.
	t5 digitAt: 1 put: t1.
	^ t5! !

!Integer class methodsFor: 'class initialization' stamp: 'ul 7/18/2011 17:23'!
initialize	"Integer initialize"
	"Ensure we have the right compact class index"

	"LPI has been a compact class forever - just ensure basic correctness"
	(LargePositiveInteger indexIfCompact = 5) ifFalse:[
		(Smalltalk compactClassesArray at: 5)
			ifNil:[LargePositiveInteger becomeCompactSimplyAt: 5]
			ifNotNil:[self error: 'Unexpected compact class setup']].

	"Cog requires LNI to be compact at 4 (replacing PseudoContext)"
	(LargeNegativeInteger indexIfCompact = 4) ifFalse:[
		"PseudoContext will likely get removed at some point so write this test
		without introducing a hard dependency"
		(Smalltalk compactClassesArray at: 4) name == #PseudoContext
			ifTrue:[Smalltalk compactClassesArray at: 4 put: nil].
		(Smalltalk compactClassesArray at: 4)
			ifNil:[LargeNegativeInteger becomeCompactSimplyAt: 4]
			ifNotNil:[self error: 'Unexpected compact class setup']].
		
	self initializeLowBitPerByteTable
! !

!Integer class methodsFor: 'class initialization' stamp: 'ul 7/18/2011 17:24'!
initializeLowBitPerByteTable
	"Initialize LowBitPerByteTable which is a ByteArray that contains the index of the lowest set bit of the integers between 1 and 255. It's defined as a class variable because it's used from the instance side and subclasses."
	"The low bits table can be obtained with:
	((1 to: 8) inject: #[1] into: [:lowBits :rank | (lowBits copy at: 1 put: lowBits first + 1; yourself) , lowBits]) allButFirst
	or with it's symmetric pair:
	((1 to: 8) inject: #[1] into: [:lowBits :rank | lowBits, (lowBits copy atLast: 1 put: lowBits last + 1; yourself)]) allButLast."
	
	LowBitPerByteTable := #[1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 6 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 7 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 6 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 8 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 6 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 7 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 6 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1 5 1 2 1 3 1 2 1 4 1 2 1 3 1 2 1]! !

!Integer class methodsFor: 'instance creation' stamp: ''!
initializedInstance
	^ 2468! !

!Integer class methodsFor: 'prime numbers' stamp: ''!
largePrimesUpTo: t1 
	^ Array
		streamContents: [:t2 | self
				largePrimesUpTo: t1
				do: [:t3 | t2 nextPut: t3]]! !

!Integer class methodsFor: 'prime numbers' stamp: 'nice 6/15/2011 00:21'!
largePrimesUpTo: max do: aBlock
	"Evaluate aBlock with all primes up to maxValue.
	The Algorithm is adapted from http://www.rsok.com/~jrm/printprimes.html
	It encodes prime numbers much more compactly than #primesUpTo: 
	38.5 integer per byte (2310 numbers per 60 byte) allow for some fun large primes.
	(all primes up to SmallInteger maxVal can be computed within ~27MB of memory;
	the regular #primesUpTo: would require 4 *GIGA*bytes).
	Note: The algorithm could be re-written to produce the first primes (which require
	the longest time to sieve) faster but only at the cost of clarity."

	| limit flags maskBitIndex bitIndex maskBit byteIndex index primesUpTo2310 indexLimit |
	limit := max asInteger - 1.
	indexLimit := max asInteger sqrtFloor + 1.
	"Create the array of flags."
	flags := ByteArray new: (limit + 2309) // 2310 * 60 + 60.
	flags atAllPut: 16rFF. "set all to true"

	"Compute the primes up to 2310"
	primesUpTo2310 := self primesUpTo: 2310.

	"Create a mapping from 2310 integers to 480 bits (60 byte)"
	maskBitIndex := Array new: 2310.
	bitIndex := -1. "for pre-increment"
	maskBitIndex at: 1 put: (bitIndex := bitIndex + 1).
	maskBitIndex at: 2 put: (bitIndex := bitIndex + 1).

	1 to: 5 do:[:i| aBlock value: (primesUpTo2310 at: i)].

	index := 6.
	2 to: 2309 do:[:n|
		[(primesUpTo2310 at: index) < n] 
			whileTrue:[index := index + 1].
		n = (primesUpTo2310 at: index) ifTrue:[
			maskBitIndex at: n+1 put: (bitIndex := bitIndex + 1).
		] ifFalse:[
			"if modulo any of the prime factors of 2310, then could not be prime"
			(n \\ 2 = 0 or:[n \\ 3 = 0 or:[n \\ 5 = 0 or:[n \\ 7 = 0 or:[n \\ 11 = 0]]]]) 
				ifTrue:[maskBitIndex at: n+1 put: 0]
				ifFalse:[maskBitIndex at: n+1 put: (bitIndex := bitIndex + 1)].
		].
	].

	"Now the real work begins...
	Start with 13 since multiples of 2,3,5,7,11 are handled by the storage method;
	increment by 2 for odd numbers only."
	13 to: limit by: 2 do:[:n|
		(maskBit := maskBitIndex at: (n \\ 2310 + 1)) = 0 ifFalse:["not a multiple of 2,3,5,7,11"
			byteIndex := n // 2310 * 60 + (maskBit-1 bitShift: -3) + 1.
			bitIndex := 1 bitShift: (maskBit bitAnd: 7).
			((flags at: byteIndex) bitAnd: bitIndex) = 0 ifFalse:["not marked -- n is prime"
				aBlock value: n.
				"Start with n*n since any integer < n has already been sieved 
				(e.g., any multiple of n with a number k < n has been cleared 
				when k was sieved); add 2 * i to avoid even numbers and
				mark all multiples of this prime. Note: n < indexLimit below
				limits running into LargeInts -- nothing more."
				n < indexLimit ifTrue:[
					index := n * n.
					[index <= limit] whileTrue:[
						(maskBit := maskBitIndex at: (index \\ 2310 + 1)) = 0 ifFalse:[
							byteIndex := (index // 2310 * 60) + (maskBit-1 bitShift: -3) + 1.
							maskBit := 255 - (1 bitShift: (maskBit bitAnd: 7)).
							flags at: byteIndex put: ((flags at: byteIndex) bitAnd: maskBit).
						].
						index := index + (2 * n)].
				].
			].
		].
	].
! !

!Integer class methodsFor: 'instance creation' stamp: ''!
new
	self == Integer
		ifTrue: [^ self error: 'Integer is an abstract class.  Make a concrete subclass.'].
	^ super new! !

!Integer class methodsFor: 'instance creation' stamp: ''!
new: t1 neg: t2 
	t2
		ifTrue: [^ LargeNegativeInteger new: t1].
	^ LargePositiveInteger new: t1! !

!Integer class methodsFor: 'prime numbers' stamp: ''!
primesUpTo: t1 
	^ Array
		streamContents: [:t2 | self
				primesUpTo: t1
				do: [:t3 | t2 nextPut: t3]]! !

!Integer class methodsFor: 'prime numbers' stamp: 'nice 6/17/2011 02:21'!
primesUpTo: max do: aBlock
	"Compute aBlock with all prime integers up to the given integer."
	"Integer primesUpTo: 100"

	| index limit limitSqrtFloor sieve increment |
	limit := max asInteger.
	limit <= 1 ifTrue: [ ^self ].
	"Fall back into #largePrimesUpTo:do: if we'd require more than 100k of memory; 
	the alternative will only requre 1/154th of the amount we need here and is almost as fast."
	limit > 25000 ifTrue:[ ^self largePrimesUpTo: limit do: aBlock ].
	limit := limit - 1. "upTo:"
	sieve := Array new: limit withAll: true.
	sieve at: 1 put: false.
	index := 2.
	limitSqrtFloor := limit sqrtFloor.
	increment := 1.
	[ index <= limitSqrtFloor ] whileTrue: [
		(sieve at: index) ifTrue: [
			| notPrimeIndex notPrimeIncrement |
			aBlock value: index.
			notPrimeIndex := index * index.
			notPrimeIncrement := increment * index.
			[ notPrimeIndex <= limit ] whileTrue: [
				sieve at: notPrimeIndex put: false.
				notPrimeIndex := notPrimeIndex + notPrimeIncrement ] ].
		index := index + increment.
		increment := 2].
	[ index <= limit ] whileTrue: [
		(sieve at: index) ifTrue: [
			aBlock value: index ].
		index := index + increment.
		increment := 2]! !

!Integer class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 
	^ self readFrom: t1 base: 10! !

!Integer class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 base: t2 
	^ (ExtendedNumberParser on: t1)
		nextIntegerBase: t2! !

!Integer class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 ifFail: t2 
	^ (ExtendedNumberParser on: t1)
		nextIntegerBase: 10
		ifFail: t2! !

!Integer class methodsFor: 'compatibility' stamp: ''!
readFrom: t1 radix: t2 
	^ self readFrom: t1 base: t2! !

!Integer class methodsFor: 'prime numbers' stamp: ''!
verbosePrimesUpTo: t1 
	^ Array
		streamContents: [:t2 | self
				verbosePrimesUpTo: t1
				do: [:t3 | t2 nextPut: t3]]! !

!Integer class methodsFor: 'prime numbers' stamp: ''!
verbosePrimesUpTo: t1 do: t2 
	| t3 |
	t3 := Time millisecondClockValue.
	Utilities
		informUserDuring: [:t5 | 
			t5 value: 'Computing primes...'.
			self
				primesUpTo: t1
				do: [:t6 | 
					| t7 |
					t2 value: t6.
					t7 := Time millisecondClockValue.
					t7 - t3 > 1000
						ifTrue: [t3 := t7.
							t5 value: 'Last prime found: ' , t6 printString]]]! !

!Integer methodsFor: 'arithmetic' stamp: ''!
* t1 
	t1 isInteger
		ifTrue: [^ self digitMultiply: t1 neg: self negative ~~ t1 negative].
	^ t1 adaptToInteger: self andSend: #*! !

!Integer methodsFor: 'arithmetic' stamp: ''!
+ t1 
	t1 isInteger
		ifTrue: [self negative == t1 negative
				ifTrue: [^ (self digitAdd: t1) normalize].
			^ self digitSubtract: t1].
	^ t1 adaptToInteger: self andSend: #+! !

!Integer methodsFor: 'arithmetic' stamp: ''!
- t1 
	t1 isInteger
		ifTrue: [self negative == t1 negative
				ifTrue: [^ self digitSubtract: t1].
			^ (self digitAdd: t1) normalize].
	^ t1 adaptToInteger: self andSend: #-! !

!Integer methodsFor: 'arithmetic' stamp: ''!
/ t1 
	| t2 |
	t1 isInteger
		ifTrue: [t2 := self digitDiv: t1 abs neg: self negative ~~ t1 negative.
			(t2 at: 2)
					= 0
				ifTrue: [^ (t2 at: 1) normalize].
			^ (Fraction numerator: self denominator: t1) reduced].
	^ t1 adaptToInteger: self andSend: #/! !

!Integer methodsFor: 'arithmetic' stamp: ''!
// t1 
	| t2 |
	t1 = 0
		ifTrue: [^ (ZeroDivide dividend: self) signal].
	self = 0
		ifTrue: [^ 0].
	t2 := self quo: t1.
	(t2 negative
			ifTrue: [t2 * t1 ~= self]
			ifFalse: [t2 = 0
					and: [self negative ~= t1 negative]])
		ifTrue: [^ t2 - 1].
	^ t2! !

!Integer methodsFor: 'comparing' stamp: ''!
< t1 
	t1 isInteger
		ifTrue: [self negative == t1 negative
				ifTrue: [self negative
						ifTrue: [^ (self digitCompare: t1)
								> 0].
					^ (self digitCompare: t1)
						< 0].
			^ self negative].
	^ t1 adaptToInteger: self andCompare: #<! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
<< t1 
	t1 < 0
		ifTrue: [self error: 'negative arg'].
	^ self bitShift: t1! !

!Integer methodsFor: 'comparing' stamp: ''!
<= t1 
	t1 isInteger
		ifTrue: [self negative == t1 negative
				ifTrue: [self negative
						ifTrue: [^ (self digitCompare: t1)
								>= 0].
					^ (self digitCompare: t1)
						<= 0].
			^ self negative].
	^ t1 adaptToInteger: self andCompare: #<=! !

!Integer methodsFor: 'comparing' stamp: 'ul 7/4/2011 03:16'!
= aNumber

	aNumber isInteger ifTrue: [
		aNumber class == self class ifFalse: [ ^false ].
		^(self digitCompare: aNumber) = 0 ].
	aNumber isNumber ifFalse: [ ^false ].
	^aNumber adaptToInteger: self andCompare: #=! !

!Integer methodsFor: 'comparing' stamp: ''!
> t1 
	t1 isInteger
		ifTrue: [self negative == t1 negative
				ifTrue: [self negative
						ifTrue: [^ (self digitCompare: t1)
								< 0].
					^ (self digitCompare: t1)
						> 0].
			^ t1 negative].
	^ t1 adaptToInteger: self andCompare: #>! !

!Integer methodsFor: 'comparing' stamp: ''!
>= t1 
	t1 isInteger
		ifTrue: [self negative == t1 negative
				ifTrue: [self negative
						ifTrue: [^ (self digitCompare: t1)
								<= 0].
					^ (self digitCompare: t1)
						>= 0].
			^ t1 negative].
	^ t1 adaptToInteger: self andCompare: #>=! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
>> t1 
	t1 < 0
		ifTrue: [self error: 'negative arg'].
	^ self bitShift: 0 - t1! !

!Integer methodsFor: 'arithmetic' stamp: ''!
\\\ t1 
	^ self \\ t1! !

!Integer methodsFor: 'converting' stamp: ''!
adaptToScaledDecimal: t1 andSend: t2 
	^ t1
		perform: t2
		with: (self asScaledDecimal: 0)! !

!Integer methodsFor: 'arithmetic' stamp: ''!
alignedTo: t1 
	^ self + t1 - 1 // t1 * t1! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
allMask: t1 
	^ t1
		= (self bitAnd: t1)! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
anyBitOfMagnitudeFrom: t1 to: t2 
	| t3 t4 t5 t6 t7 t8 t9 t10 |
	<primitive: 'primAnyBitFromTo' module: 'LargeIntegers'>
	t1 < 1 | (t2 < 1)
		ifTrue: [^ self error: 'out of range'].
	t3 := self abs.
	t8 := t2 min: t3 highBit.
	t1 > t8
		ifTrue: [^ false].
	t4 := t1 - 1 // 8 + 1.
	t5 := t8 - 1 // 8 + 1.
	t6 := (t1 - 1 \\ 8) negated.
	t7 := 7 - (t8 - 1 \\ 8).
	t4 = t5
		ifTrue: [t10 := (255 bitShift: t6 negated)
						bitAnd: (255 bitShift: t7 negated).
			t9 := t3 digitAt: t4.
			^ (t9 bitAnd: t10)
				~= 0].
	((t3 digitAt: t4)
			bitShift: t6)
			~= 0
		ifTrue: [^ true].
	t4 + 1
		to: t5 - 1
		do: [:t11 | (t3 digitAt: t11)
					~= 0
				ifTrue: [^ true]].
	(((t3 digitAt: t5)
			bitShift: t7)
			bitAnd: 255)
			~= 0
		ifTrue: [^ true].
	^ false! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
anyMask: t1 
	^ 0
		~= (self bitAnd: t1)! !

!Integer methodsFor: 'converting' stamp: ''!
asCharacter
	^ Character value: self! !

!Integer methodsFor: 'converting' stamp: ''!
asColorOfDepth: t1 
	^ Color colorFromPixelValue: self depth: t1! !

!Integer methodsFor: 'converting' stamp: 'nice 9/22/2011 01:39'!
asFloat
	"Answer a Float that best approximates the value of the receiver."
	
	self subclassResponsibility! !

!Integer methodsFor: 'converting' stamp: 'nice 9/7/2011 22:21'!
asFraction
	"Answer a Fraction that represents the value of the receiver.
	Since an Integer already behaves as a special kind of Fraction, no conversion is required, see #isFraction."

	^self! !

!Integer methodsFor: 'converting' stamp: ''!
asHexDigit
	^ '0123456789ABCDEF' at: self + 1! !

!Integer methodsFor: 'converting' stamp: ''!
asInteger
	^ self! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
asLargerPowerOfTwo
	self isPowerOfTwo
		ifTrue: [^ self].
	^ 1 bitShift: self highBit! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
asPowerOfTwo
	^ self asSmallerPowerOfTwo! !

!Integer methodsFor: 'tiles' stamp: ''!
asPrecedenceName
	^ #('unary' 'binary' 'keyword' ) at: self! !

!Integer methodsFor: 'converting' stamp: ''!
asScaledDecimal
	^ ScaledDecimal newFromNumber: self scale: 0! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
asSmallerPowerOfTwo
	self isPowerOfTwo
		ifTrue: [^ self].
	^ 1 bitShift: self highBit - 1! !

!Integer methodsFor: 'printing' stamp: 'cmm 6/15/2012 16:04'!
asStringWithCommas
	"123456789 asStringWithCommas"
	"-123456789 asStringWithCommas"
	^ self asStringWithCommasSigned: false! !

!Integer methodsFor: 'printing' stamp: 'cmm 6/8/2012 15:45'!
asStringWithCommasSigned
	"123456789 asStringWithCommasSigned"
	"-123456789 asStringWithCommasSigned"
	| digits |
self deprecated: 'Use #asStringWithCommasSigned:'.
	digits := self abs printString.
	^ String streamContents:
		[:strm | 
		self sign = -1 ifTrue: [strm nextPut: $-] ifFalse:[strm nextPut: $+].
		1 to: digits size do: 
			[:i | strm nextPut: (digits at: i).
			(i < digits size and: [(i - digits size) \\ 3 = 0])
				ifTrue: [strm nextPut: $,]]]! !

!Integer methodsFor: 'printing' stamp: 'cmm 6/8/2012 15:43'!
asStringWithCommasSigned: aBoolean
	"123456789 asStringWithCommasSigned: true"
	"-123456789 asStringWithCommasSigned: false"
	| digits |
	digits := self abs printString.
	^ String streamContents:
		[:strm | 
		self sign = -1 ifTrue: [strm nextPut: $-] ifFalse: [aBoolean ifTrue: [strm nextPut: $+]].
		1 to: digits size do: 
			[:i | strm nextPut: (digits at: i).
			(i < digits size and: [(i - digits size) \\ 3 = 0])
				ifTrue: [strm nextPut: $,]]]! !

!Integer methodsFor: 'printing' stamp: ''!
asTwoCharacterString
	^ (self >= 0
			and: [self < 10])
		ifTrue: ['0' , self printString]
		ifFalse: [self printString copyFrom: 1 to: 2]! !

!Integer methodsFor: 'printing' stamp: ''!
asWords
	| t1 t2 t3 t4 t5 t6 |
	self = 0
		ifTrue: [^ 'zero'].
	t1 := #('' ' thousand' ' million' ' billion' ' trillion' ' quadrillion' ' quintillion' ' sextillion' ' septillion' ' octillion' ' nonillion' ' decillion' ' undecillion' ' duodecillion' ' tredecillion' ' quattuordecillion' ' quindecillion' ' sexdecillion' ' septendecillion' ' octodecillion' ' novemdecillion' ' vigintillion' ).
	t4 := self.
	t2 := ''.
	self < 0
		ifTrue: [t2 := 'negative '.
			t4 := t4 negated].
	t5 := String new.
	t6 := 1.
	[t4 > 0]
		whileTrue: [t3 := (t4 \\ 1000) threeDigitName.
			t4 := t4 // 1000.
			t3 isEmpty
				ifFalse: [t5 isEmpty
						ifFalse: [t5 := ', ' , t5].
					t5 := t3
								, (t1 at: t6) , t5].
			t6 := t6 + 1].
	^ t2 , t5! !

!Integer methodsFor: 'converting' stamp: 'brp 5/13/2003 10:12'!
asYear

	^ Year year: self 
! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
atRandom
	self = 0
		ifTrue: [^ 0].
	self < 0
		ifTrue: [^ self negated atRandom negated].
	^ Collection mutexForPicking
		critical: [self atRandom: Collection randomForPicking]! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
atRandom: t1 
	^ t1 nextInt: self! !

!Integer methodsFor: 'benchmarks' stamp: ''!
benchFib
	^ self < 2
		ifTrue: [1]
		ifFalse: [(self - 1) benchFib + (self - 2) benchFib + 1]! !

!Integer methodsFor: 'benchmarks' stamp: ''!
benchmark
	| t1 t2 t3 t4 t5 |
	t1 := 8190.
	1
		to: self
		do: [:t7 | 
			t5 := 0.
			t2 := (Array new: t1)
						atAllPut: true.
			1
				to: t1
				do: [:t6 | (t2 at: t6)
						ifTrue: [t3 := t6 + 1.
							t4 := t6 + t3.
							[t4 <= t1]
								whileTrue: [t2 at: t4 put: false.
									t4 := t4 + t3].
							t5 := t5 + 1]]].
	^ t5! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitAnd: t1 
	| t2 |
	<primitive: 'primDigitBitAnd' module: 'LargeIntegers'>
	t2 := t1 normalize.
	^ self
		digitLogic: t2
		op: #bitAnd:
		length: (self digitLength max: t2 digitLength)! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitAt: t1 
	^ (self bitShift: 1 - t1)
		bitAnd: 1! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitAt: t1 put: t2 
	| t3 |
	t3 := self bitAt: t1.
	t3 = t2
		ifTrue: [^ self].
	0 = t2
		ifTrue: [^ self bitAnd: (1 bitShift: t1 - 1) bitInvert].
	1 = t2
		ifTrue: [^ self
				bitOr: (1 bitShift: t1 - 1)].
	self error: 'bit value should be 0 or 1'! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitClear: t1 
	^ (self bitOr: t1)
		- t1! !

!Integer methodsFor: 'bit manipulation' stamp: 'nice 6/14/2011 21:48'!
bitCount
	"Count the number of bits set to 1 in self"

	| bitCount |
	self < 0 ifTrue: [self error: 'Cannot count bits of negative integers'].
	bitCount := 0.
	1 to: self digitLength do: [:i |
		bitCount := bitCount + (self digitAt: i) bitCountOfByte].
	^bitCount! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitInvert
	^ -1 - self! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitInvert32
	^ self bitXor: 4294967295! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitOr: t1 
	| t2 |
	<primitive: 'primDigitBitOr' module: 'LargeIntegers'>
	t2 := t1 normalize.
	^ self
		digitLogic: t2
		op: #bitOr:
		length: (self digitLength max: t2 digitLength)! !

!Integer methodsFor: 'bit manipulation' stamp: 'cmm 4/11/2011 20:43'!
bitReverse: highBit 
	"Reverse the bits of the receiver so that the lsb is the highBit'th bit of the answer.  Translated from C code at:  http://graphics.stanford.edu/~seander/bithacks.html#BitReverseObvious."
	| v r s |
	highBit < self highBit ifTrue: [ self error: 'Not enough bits.' ].
	v := self.
	r := v bitAnd: 1.
	s := highBit - 1.
	[ v := v bitShift: -1.
	v = 0 ] whileFalse:
		[ r := r bitShift: 1.
		r := r bitOr: (v bitAnd: 1).
		s := s - 1 ].
	^ r bitShift: s! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitShift: t1 
	| t2 |
	t2 := self bitShiftMagnitude: t1.
	^ ((self negative
				and: [t1 negative])
			and: [self anyBitOfMagnitudeFrom: 1 to: t1 negated])
		ifTrue: [t2 - 1]
		ifFalse: [t2]! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitShiftMagnitude: t1 
	| t2 |
	<primitive: 'primDigitBitShiftMagnitude' module: 'LargeIntegers'>
	t1 >= 0
		ifTrue: [^ self digitLshift: t1].
	t2 := 0 - t1.
	^ (self
		digitRshift: (t2 bitAnd: 7)
		bytes: (t2 bitShift: -3)
		lookfirst: self digitLength) normalize! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
bitXor: t1 
	| t2 |
	<primitive: 'primDigitBitXor' module: 'LargeIntegers'>
	t2 := t1 normalize.
	^ self
		digitLogic: t2
		op: #bitXor:
		length: (self digitLength max: t2 digitLength)! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
byteEncode: t1 base: t2 
	^ self printOn: t1 base: t2! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
ceiling
	^ self! !

!Integer methodsFor: 'private' stamp: ''!
copyto: t1 
	| t2 |
	t2 := self digitLength min: t1 digitLength.
	^ t1
		replaceFrom: 1
		to: t2
		with: self
		startingAt: 1! !

!Integer methodsFor: 'arithmetic' stamp: ''!
crossSumBase: t1 
	| t2 |
	self
		assert: [t1 isInteger
				and: [t1 >= 2]].
	self < 0
		ifTrue: [^ self negated crossSumBase: t1].
	self < t1
		ifTrue: [^ self].
	t2 := self \\ t1
				+ (self // t1 crossSumBase: t1).
	self
		assert: [t2 \\ (t1 - 1) = 0 = (self \\ (t1 - 1) = 0)].
	^ t2! !

!Integer methodsFor: 'accessing' stamp: 'nice 9/7/2011 21:47'!
denominator
	"Let an Integer be polymorphic to a Fraction. See #isFraction."
	^1! !

!Integer methodsFor: 'printing' stamp: ''!
destinationBuffer: t1 
	t1 <= 1
		ifTrue: [self]
		ifFalse: [LargePositiveInteger new: t1]! !

!Integer methodsFor: 'private' stamp: ''!
digitAdd: t1 
	| t2 t3 t4 t5 |
	<primitive: 'primDigitAdd' module: 'LargeIntegers'>
	t4 := 0.
	(t2 := self digitLength) < (t3 := t1 digitLength)
		ifTrue: [t2 := t3].
	t5 := Integer new: t2 neg: self negative.
	1
		to: t2
		do: [:t6 | 
			t4 := (t4 bitShift: -8)
						+ (self digitAt: t6)
						+ (t1 digitAt: t6).
			t5
				digitAt: t6
				put: (t4 bitAnd: 255)].
	t4 > 255
		ifTrue: [t5 := t5 growby: 1.
			t5
				at: t5 digitLength
				put: (t4 bitShift: -8)].
	^ t5! !

!Integer methodsFor: 'printing' stamp: ''!
digitBuffer: t1 
	^ Array new: t1 * 8! !

!Integer methodsFor: 'private' stamp: ''!
digitCompare: t1 
	| t2 t3 t4 t5 |
	<primitive: 'primDigitCompare' module: 'LargeIntegers'>
	t2 := self digitLength.
	(t3 := t1 digitLength) ~= t2
		ifTrue: [t3 > t2
				ifTrue: [^ -1].
			^ 1].
	[t2 > 0]
		whileTrue: [(t4 := t1 digitAt: t2) ~= (t5 := self digitAt: t2)
				ifTrue: [t4 < t5
						ifTrue: [^ 1].
					^ -1].
			t2 := t2 - 1].
	^ 0! !

!Integer methodsFor: 'private' stamp: 'nice 9/24/2011 22:50'!
digitDiv: arg neg: ng 
	"Answer with an array of (quotient, remainder)."
	| quo rem ql d div dh dnh dl qhi qlo j l hi lo r3 a t |
	<primitive: 'primDigitDivNegative' module:'LargeIntegers'>
	arg = 0 ifTrue: [^ (ZeroDivide dividend: self) signal].
	"TFEI added this line"
	l := self digitLength - arg digitLength + 1.
	l <= 0 ifTrue: [^ Array with: 0 with: self].
	"shortcut against #highBit"
	d := 8 - arg lastDigit highBitOfByte.
	div := arg digitLshift: d.
	div := div growto: div digitLength + 1.
	"shifts so high order word is >=128"
	rem := self digitLshift: d.
	rem digitLength = self digitLength ifTrue: [rem := rem growto: self digitLength + 1].
	"makes a copy and shifts"
	quo := Integer new: l neg: ng.
	dl := div digitLength - 1.
	"Last actual byte of data"
	ql := l.
	dh := div digitAt: dl.
	dnh := dl = 1
				ifTrue: [0]
				ifFalse: [div digitAt: dl - 1].
	1 to: ql do: 
		[:k | 
		"maintain quo*arg+rem=self"
		"Estimate rem/div by dividing the leading to bytes of rem by dh."
		"The estimate is q = qhi*16+qlo, where qhi and qlo are nibbles."
		j := rem digitLength + 1 - k.
		"r1 := rem digitAt: j."
		(rem digitAt: j)
			= dh
			ifTrue: [qhi := qlo := 15
				"i.e. q=255"]
			ifFalse: 
				["Compute q = (r1,r2)//dh, t = (r1,r2)\\dh.  
				Note that r1,r2 are bytes, not nibbles.  
				Be careful not to generate intermediate results exceeding 13  
				bits."
				"r2 := (rem digitAt: j - 1)."
				t := ((rem digitAt: j)
							bitShift: 4)
							+ ((rem digitAt: j - 1)
									bitShift: -4).
				qhi := t // dh.
				t := (t \\ dh bitShift: 4)
							+ ((rem digitAt: j - 1)
									bitAnd: 15).
				qlo := t // dh.
				t := t \\ dh.
				"Next compute (hi,lo) := q*dnh"
				hi := qhi * dnh.
				lo := qlo * dnh + ((hi bitAnd: 15)
								bitShift: 4).
				hi := (hi bitShift: -4)
							+ (lo bitShift: -8).
				lo := lo bitAnd: 255.
				"Correct overestimate of q.  
				Max of 2 iterations through loop -- see Knuth vol. 2"
				r3 := j < 3
							ifTrue: [0]
							ifFalse: [rem digitAt: j - 2].
				[(t < hi
					or: [t = hi and: [r3 < lo]])
					and: 
						["i.e. (t,r3) < (hi,lo)"
						qlo := qlo - 1.
						lo := lo - dnh.
						lo < 0
							ifTrue: 
								[hi := hi - 1.
								lo := lo + 256].
						hi >= dh]]
					whileTrue: [hi := hi - dh].
				qlo < 0
					ifTrue: 
						[qhi := qhi - 1.
						qlo := qlo + 16]].
		"Subtract q*div from rem"
		l := j - dl.
		a := 0.
		1 to: div digitLength do: 
			[:i | 
			hi := (div digitAt: i)
						* qhi.
			lo := a + (rem digitAt: l) - ((hi bitAnd: 15)
							bitShift: 4) - ((div digitAt: i)
							* qlo).
			rem digitAt: l put: lo - (lo // 256 * 256).
			"sign-tolerant form of (lo bitAnd: 255)"
			a := lo // 256 - (hi bitShift: -4).
			l := l + 1].
		a < 0
			ifTrue: 
				["Add div back into rem, decrease q by 1"
				qlo := qlo - 1.
				l := j - dl.
				a := 0.
				1 to: div digitLength do: 
					[:i | 
					a := (a bitShift: -8)
								+ (rem digitAt: l) + (div digitAt: i).
					rem digitAt: l put: (a bitAnd: 255).
					l := l + 1]].
		quo digitAt: quo digitLength + 1 - k put: (qhi bitShift: 4)
				+ qlo].
	rem := rem
				digitRshift: d
				bytes: 0
				lookfirst: dl.
	^ Array with: quo with: rem! !

!Integer methodsFor: 'private' stamp: ''!
digitLogic: t1 op: t2 length: t3 
	| t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 |
	t6 := self negative.
	t7 := t1 negative.
	t8 := ((t6
				ifTrue: [-1]
				ifFalse: [0])
				perform: t2
				with: (t7
						ifTrue: [-1]
						ifFalse: [0]))
				< 0.
	t5 := Integer new: t3 neg: t8.
	t11 := t9 := t10 := true.
	t4 := 0.
	[(t4 := t4 + 1) <= t3
		or: [t8
				and: [t11
						and: [t5 := t5 growby: 1.
							true]]]]
		whileTrue: [t12 := self digitAt: t4.
			t6
				ifTrue: [t12 := t9
								ifTrue: [t12 = 0
										ifTrue: [0]
										ifFalse: [t9 := false.
											256 - t12]]
								ifFalse: [255 - t12]].
			t13 := t1 digitAt: t4.
			t7
				ifTrue: [t13 := t10
								ifTrue: [t13 = 0
										ifTrue: [0]
										ifFalse: [t10 := false.
											256 - t13]]
								ifFalse: [255 - t13]].
			t14 := t12 perform: t2 with: t13.
			t5
				digitAt: t4
				put: (t8
						ifTrue: [t11
								ifTrue: [t14 = 0
										ifTrue: [0]
										ifFalse: [t11 := false.
											256 - t14]]
								ifFalse: [255 - t14]]
						ifFalse: [t14])].
	^ t5 normalize! !

!Integer methodsFor: 'private' stamp: ''!
digitLshift: t1 
	| t2 t3 t4 t5 t6 t7 t8 t9 t10 |
	(t10 := self highBitOfMagnitude) = 0
		ifTrue: [^ 0].
	t5 := t10 + t1 + 7 // 8.
	t6 := Integer new: t5 neg: self negative.
	t8 := t1 // 8.
	t9 := t1 \\ 8.
	t9 = 0
		ifTrue: [^ t6
				replaceFrom: t8 + 1
				to: t5
				with: self
				startingAt: 1].
	t2 := 0.
	t3 := t9 - 8.
	t4 := 255 bitShift: 0 - t9.
	1
		to: t8
		do: [:t11 | t6 digitAt: t11 put: 0].
	1
		to: t5 - t8
		do: [:t12 | 
			t7 := self digitAt: t12.
			t6
				digitAt: t12 + t8
				put: (((t7 bitAnd: t4)
						bitShift: t9)
						bitOr: t2).
			t2 := t7 bitShift: t3].
	^ t6! !

!Integer methodsFor: 'private' stamp: ''!
digitMultiply: t1 neg: t2 
	| t3 t4 t5 t6 t7 t8 |
	<primitive: 'primDigitMultiplyNegative' module: 'LargeIntegers'>
	(t1 digitLength = 1
			and: [(t1 digitAt: 1)
					= 0])
		ifTrue: [^ 0].
	(self digitLength = 1
			and: [(self digitAt: 1)
					= 0])
		ifTrue: [^ 0].
	t4 := self digitLength + t1 digitLength.
	t3 := Integer new: t4 neg: t2.
	1
		to: self digitLength
		do: [:t11 | (t6 := self digitAt: t11) ~= 0
				ifTrue: [t7 := t11.
					t5 := 0.
					1
						to: t1 digitLength
						do: [:t9 | 
							t8 := (t1 digitAt: t9)
										* t6 + t5
										+ (t3 digitAt: t7).
							t5 := t8 bitShift: -8.
							t3
								digitAt: t7
								put: (t8 bitAnd: 255).
							t7 := t7 + 1].
					t3 digitAt: t7 put: t5]].
	^ t3 normalize! !

!Integer methodsFor: 'private' stamp: ''!
digitRshift: t1 bytes: t2 lookfirst: t3 
	| t4 t5 t6 t7 t8 t9 t10 t11 |
	t4 := 0 - t1.
	t5 := 0.
	t7 := t4 + 8.
	t11 := t3.
	t8 := 255 bitShift: 0 - t7.
	t9 := self digitAt: t11.
	[((t9 bitShift: t4)
			bitOr: t5)
			= 0
		and: [t11 ~= 1]]
		whileTrue: [t5 := t9 bitShift: t7.
			t11 := t11 - 1.
			t9 := self digitAt: t11].
	t11 <= t2
		ifTrue: [^ Integer new: 0 neg: self negative].
	t6 := Integer new: t11 - t2 neg: self negative.
	t10 := t11.
	t5 := (self digitAt: t2 + 1)
				bitShift: t4.
	t2 + 1
		to: t10
		do: [:t12 | 
			t9 := self digitAt: t12 + 1.
			t6
				digitAt: t12 - t2
				put: (((t9 bitAnd: t8)
						bitShift: t7)
						bitOr: t5).
			t5 := t9 bitShift: t4].
	^ t6! !

!Integer methodsFor: 'private' stamp: ''!
digitSubtract: t1 
	| t2 t3 t4 t5 t6 t7 t8 |
	<primitive: 'primDigitSubtract' module: 'LargeIntegers'>
	t6 := self digitLength.
	t7 := t1 digitLength.
	(t6 = t7
			ifTrue: [[(self digitAt: t6)
						= (t1 digitAt: t6)
					and: [t6 > 1]]
					whileTrue: [t6 := t6 - 1].
				t7 := t6.
				(self digitAt: t6)
					< (t1 digitAt: t6)]
			ifFalse: [t6 < t7])
		ifTrue: [t3 := t1.
			t2 := self.
			t8 := self negative == false.
			t6 := t7]
		ifFalse: [t3 := self.
			t2 := t1.
			t8 := self negative].
	t5 := Integer new: t6 neg: t8.
	t4 := 0.
	1
		to: t6
		do: [:t9 | 
			t4 := t4
						+ (t3 digitAt: t9)
						- (t2 digitAt: t9).
			t5 digitAt: t9 put: t4 - (t4 // 256 * 256).
			t4 := t4 // 256].
	^ t5 normalize! !

!Integer methodsFor: 'testing' stamp: ''!
even
	^ ((self digitAt: 1)
		bitAnd: 1)
		= 0! !

!Integer methodsFor: 'mathematical functions' stamp: ''!
factorial
	self = 0
		ifTrue: [^ 1].
	self > 0
		ifTrue: [^ self * (self - 1) factorial].
	self error: 'Not valid for negative integers'! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
floor
	^ self! !

!Integer methodsFor: 'mathematical functions' stamp: ''!
gcd: t1 
	| t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 |
	t2 := SmallInteger maxVal highBit.
	t3 := self abs max: (t4 := t1 abs).
	t4 := self abs min: t4.
	[t4 class == SmallInteger]
		whileFalse: [(t6 := t3 bitShift: (t5 := t2 - t3 highBit)) class == SmallInteger
				ifFalse: [t5 := t5 - 1.
					t6 := t6 bitShift: -1].
			t7 := t4 bitShift: t5.
			t8 := 1.
			t9 := 0.
			t10 := 0.
			t11 := 1.
			[(t12 := t7 + t11) ~= 0
				and: [(t13 := t7 + t10) ~= 0
						and: [(t14 := t6 + t8 // t13) = (t6 + t9 // t12)]]]
				whileTrue: [t10 := t8 - (t14 * (t8 := t10)).
					t11 := t9 - (t14 * (t9 := t11)).
					t7 := t6 - (t14 * (t6 := t7))].
			t9 = 0
				ifTrue: [t4 := t3 rem: (t3 := t4)]
				ifFalse: [t15 := t3 * t8 + (t4 * t9).
					t4 := t3 * t10 + (t4 * t11).
					t3 := t15]].
	^ t4 gcd: t3! !

!Integer methodsFor: 'private' stamp: ''!
growby: t1 
	^ self growto: self digitLength + t1! !

!Integer methodsFor: 'private' stamp: ''!
growto: t1 
	^ self
		copyto: (self species new: t1)! !

!Integer methodsFor: 'comparing' stamp: ''!
hash
	^ (self lastDigit bitShift: 8)
		+ (self digitAt: 1)! !

!Integer methodsFor: 'printing' stamp: 'eem 5/21/2010 11:06'!
hex
	"Print the receiver as hex, prefixed with 16r.  DO NOT CHANGE THIS!!  The Cog VMMaker depends on this.
	 Consider using any of
		printStringHex
		printStringBase: 16
		printStringBase: 16 length: 8 padded: true
		storeStringHex
		storeStringBase: 16
		storeStringBase: 16 length: 11 padded: true"
	^self storeStringBase: 16! !

!Integer methodsFor: 'printing' stamp: 'eem 5/21/2010 11:09'!
hex8
	"Print the receiver in base 16 with prefixed base, using at least 8 digits.
	 DO NOT CHANGE THIS!!  The Cog VMMaker depends on this.
	 Consider using storeStringBase: 16 length: 11 padded: true instead."
	  "16r3333 hex8"
	| hex |
	hex := self hex.  "16rNNN"
	^hex size < 11
		ifTrue: [hex copyReplaceFrom: 4 to: 3
						 with: ('00000000' copyFrom: 1 to: 11-hex size)]
		ifFalse: [hex]! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
highBit
	^ self subclassResponsibility! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
highBitOfMagnitude
	^ self subclassResponsibility! !

!Integer methodsFor: 'testing' stamp: 'nice 9/7/2011 22:20'!
isFraction
	"Each Integer is considered as a special kind of Fraction with self as numerator and a unit denominator.
	Rationale: A Fraction with a unit denominator will be automatically reduced to an Integer.
	Hence Integer has to be polymorphic to Fraction."
	^true! !

!Integer methodsFor: 'testing' stamp: ''!
isInteger
	^ true! !

!Integer methodsFor: 'printing' stamp: ''!
isLiteral
	^ true! !

!Integer methodsFor: 'testing' stamp: 'ul 1/18/2012 14:37'!
isPowerOfTwo
	"Return true if the receiver is an integral power of two."
	
	^self strictlyPositive and: [ (self bitAnd: self - 1) = 0 ]! !

!Integer methodsFor: 'testing' stamp: ''!
isPrime
	self <= 1
		ifTrue: [^ false].
	self even
		ifTrue: [^ self = 2].
	3
		to: self sqrtFloor
		by: 2
		do: [:t1 | self \\ t1 = 0
				ifTrue: [^ false]].
	^ true! !

!Integer methodsFor: 'testing' stamp: 'nice 11/14/2011 21:59'!
isProbablyPrime
	"See isProbablyPrimeWithK:andQ: for the algoritm description."
	
	| k q |
	self <= 1 ifTrue: [ ^false ].
	self even ifTrue: [ ^self = 2 ].
	"Factor self into (2 raisedTo: k) * q + 1, where q odd"
	q := self bitShift: -1.
	k := q lowBit.
	q := q bitShift: 1 - k.
	"Repeat the probabilistic until false (the probability of false negative is null) or until probability is very low."
	25 timesRepeat: [ (self isProbablyPrimeWithK: k andQ: q) ifFalse: [ ^false ] ].
	"The probability of false positive after 25 iterations is less than (1/4 raisedTo: 25) < 1.0e-15"
	^true! !

!Integer methodsFor: 'private' stamp: 'nice 11/15/2011 23:13'!
isProbablyPrimeWithK: k andQ: q 
	"Algorithm P, probabilistic primality test, from
	Knuth, Donald E. 'The Art of Computer Programming', Vol 2,
	Third Edition, section 4.5.4, page 395, P1-P5 refer to Knuth description..
	Note that this is a Miller Rabin test which may answer false positives (known as pseudoprimes) for at most 1/4 of the possible bases x."

	| x j y minusOne |
	"P1"
	x := (self - 2) atRandom + 1.
	"P2"
	j := 0.
	y := x raisedTo: q modulo: self.
	minusOne := self - 1.
	
	["P3"
	y = 1 ifTrue: [^j = 0].
	y = minusOne ifTrue: [^true].
	"P4"
	(j := j + 1) < k]
		whileTrue:
			[y := y squared \\ self].
	"P5"
	^false! !

!Integer methodsFor: 'system primitives' stamp: ''!
lastDigit
	^ self digitAt: self digitLength! !

!Integer methodsFor: 'mathematical functions' stamp: ''!
lcm: t1 
	^ self
		// (self gcd: t1) * t1! !

!Integer methodsFor: 'bit manipulation' stamp: 'ul 7/18/2011 17:28'!
lowBit
	"Answer the index of the low order bit of this number."
	
	| index digit |
	index := 0.
	[ (digit := self digitAt: (index := index + 1)) = 0 ] whileTrue.
	^(LowBitPerByteTable at: digit) + (index - 1 * 8)! !

!Integer methodsFor: 'private' stamp: 'nice 5/19/2011 02:08'!
montgomeryRaisedTo: n times: y modulo: m mInvModB: mInv
	"Private - do a Montgomery exponentiation of self modulo m.
	The operation is equivalent to (self/y raisedTo: n)*y \\ m,
	with y is (256 raisedTo: m digitLength),
	with (m bitAnd: 255) * mInv \\ 256 = 255."
	
	| pow j k w index oddPowersOfSelf square |
	
	"Precompute powers of self for odd bit patterns xxxx1 up to length w + 1.
	The width w is chosen with respect to the total bit length of n,
	such that each bit pattern will on average be encoutered P times in the whole bit sequence of n.
	This costs (2 raisedTo: w) multiplications, but more will be saved later (see below)."
	k := n highBit.
	w := (k highBit - 1 >> 1 min: 16) max: 1.
	oddPowersOfSelf := Array new: 1 << w.
	oddPowersOfSelf at: 1 put: (pow := self).
	square := self montgomeryTimes: self modulo: m mInvModB: mInv.
	2 to: oddPowersOfSelf size do: [:i | pow := oddPowersOfSelf at: i put: (pow montgomeryTimes: square modulo: m mInvModB: mInv)].
	
	"Now exponentiate by searching precomputed bit patterns with a sliding window"
	pow := y.
	[k > 0]
		whileTrue:
			[pow := pow montgomeryTimes: pow modulo: m mInvModB: mInv.
			"Skip bits set to zero (the sliding window)"
			(n bitAt: k) = 0
				ifFalse:
					["Find longest odd bit pattern up to window length (w + 1)"
					j := k - w max: 1.
					[j < k and: [(n bitAt: j) = 0]] whileTrue: [j := j + 1].
					"We found a bit pattern of length k-j+1;
					perform the square powers for each bit
					(same cost as bitwise algorithm);
					compute the index of this bit pattern in the precomputed powers."
					index := 0.
					[k > j] whileTrue:
						[pow := pow montgomeryTimes: pow modulo: m mInvModB: mInv.
						index := index << 1 + (n bitAt: k).
						k := k - 1].
					"Perform a single multiplication for the whole bit pattern.
					This saves up to (k-j) multiplications versus a naive algorithm operating bit by bit"
					pow := pow montgomeryTimes: (oddPowersOfSelf at: index + 1) modulo: m mInvModB: mInv].
			k := k - 1].
	^pow! !

!Integer methodsFor: 'private' stamp: 'nice 5/18/2011 22:29'!
montgomeryTimes: a modulo: m mInvModB: mInv
	"Answer the result of a Montgomery multiplication
	self * a * (256 raisedTo: m digitLength) inv \\ m
	NOTE: it is assumed that:
	self digitLength <= m digitLength
	a digitLength <= m digitLength
	mInv * m \\ 256 = (-1 \\ 256) = 255 (this implies m odd)
	
	Answer nil in case of absent plugin or other failure."
	
	<primitive: 'primMontgomeryTimesModulo' module:'LargeIntegers'>
	^nil! !

!Integer methodsFor: 'bit manipulation' stamp: ''!
noMask: t1 
	^ 0
		= (self bitAnd: t1)! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
normalize
	^ self! !

!Integer methodsFor: 'mathematical functions' stamp: 'jmv 10/19/2011 22:39'!
nthRoot: aPositiveInteger
	"Answer the nth root of the receiver.
	See #nthRootAlt: for an alternative implementation."

	| selfAsFloat floatResult guess delta higher lower raised |
	selfAsFloat := self asFloat.

	"If we can't do Float arithmetic because we are too big, then look for an exact answer in exact arithmetic"
	selfAsFloat isInfinite ifTrue: [
		guess := self nthRootTruncated: aPositiveInteger.
		(guess raisedToInteger: aPositiveInteger) = self
			ifTrue: [ ^ guess ].
		"Nothing else can be done. No exact answer means answer must be a Float.
		Answer the best we have."
		^guess asFloat ].

	floatResult := selfAsFloat nthRoot: aPositiveInteger.
	guess := floatResult rounded.

	"If got an exact answer, answer it."
	raised := guess raisedToInteger: aPositiveInteger.
	raised = self
		ifTrue: [ ^ guess ].

	"In this case, maybe it failed because we are such a big integer that the Float
	method gets inexact, even if we are a whole square number.
	Note 1(jmv): This algorithm is faster than #nthRootTruncated: for big n (aPositiveInteger)
	but fails if self asFloat isInfinite.
	Note 2(jmv): The algorithms I found for computing the nthRoot would havily use
	very large fractions. I wrote this one, that doesn't create fractions."
	selfAsFloat abs >= (Float maxExactInteger asFloat raisedToInteger: aPositiveInteger)
		ifTrue: [
			raised > self
				ifTrue: [
					higher := guess.
					delta :=  floatResult predecessor - floatResult.
					[
						floatResult := floatResult + delta.
						lower := floatResult rounded.
						(lower raisedToInteger: aPositiveInteger) > self ] whileTrue: [
							delta := delta * 2.
							higher := lower ] ]
				ifFalse: [
					lower := guess.
					delta :=  floatResult successor - floatResult.
					[
						floatResult := floatResult + delta.
						higher := floatResult rounded.
						(higher raisedToInteger: aPositiveInteger) < self ] whileTrue: [
							delta := delta * 2.
							lower := higher ]].
			[ higher - lower > 1 ] whileTrue: [
				guess := lower + higher // 2.
				raised := guess raisedToInteger: aPositiveInteger.
				raised = self
					ifTrue: [
						^ guess ].
				raised > self
					ifTrue: [ higher := guess ]
					ifFalse: [ lower := guess ]]].

	"We need an approximate result"
	^floatResult! !

!Integer methodsFor: 'mathematical functions' stamp: 'nice 10/19/2011 20:21'!
nthRootTruncated: aPositiveInteger
	"Answer the integer part of the nth root of the receiver."
	| guess guessToTheNthMinusOne delta |
	self = 0 ifTrue: [^0].
	self negative
		ifTrue:
			[aPositiveInteger even ifTrue: [ ArithmeticError signal: 'Negative numbers don''t have even roots.' ].
			^(self negated nthRootTruncated: aPositiveInteger) negated].
	guess := 1 bitShift: self highBitOfMagnitude + aPositiveInteger - 1 // aPositiveInteger.
	[
		guessToTheNthMinusOne := guess raisedTo: aPositiveInteger - 1.
		delta := (guess * guessToTheNthMinusOne - self) // (guessToTheNthMinusOne * aPositiveInteger).
		delta = 0 ] whileFalse:
			[ guess := guess - delta ].
	( (guess := guess - 1) raisedTo: aPositiveInteger) > self  ifTrue:
			[ guess := guess - 1 ].
	^guess! !

!Integer methodsFor: 'printing' stamp: 'nice 6/17/2011 04:10'!
numberOfDigitsInBase: b 
	"Return how many digits are necessary to print this number in base b.
	This does not count any place for minus sign, radix prefix or whatever.
	Note that this algorithm may cost a few operations on LargeInteger."

	| nDigits q total |
	self negative ifTrue: [^self negated numberOfDigitsInBase: b].
	self < b ifTrue: [^1].
	b isPowerOfTwo ifTrue: [^self highBit + b highBit - 2 quo: b highBit - 1].
	
	"A conversion from base 2 to base b has to be performed.
	This algorithm avoids Float computations like (self log: b) floor + 1,
	1) because they are inexact
	2) because LargeInteger might overflow
	3) because this algorithm might be cheaper than conversion"

	q := self.
	total := 0.
	["Make an initial nDigits guess that is lower than or equal to required number of digits"
	nDigits := b = 10
		ifTrue: [((q highBit - 1) * 1233 >> 12) + 1. "This is because (2 log)/(10 log)*4096 is slightly greater than 1233"]
		ifFalse: [q highBit quo: b highBit].
	total := total + nDigits.
	
	"See how many digits remains above these first nDigits guess"
	(q := q quo: (b raisedToInteger: nDigits)) < b] whileFalse.
	^q = 0
		ifTrue: [total]
		ifFalse: [total + 1]! !

!Integer methodsFor: 'accessing' stamp: 'nice 9/7/2011 21:47'!
numerator
	"Let an Integer be polymorphic to a Fraction. See #isFraction."
	^self! !

!Integer methodsFor: 'private' stamp: ''!
print: t1 on: t2 prefix: t3 length: t4 padded: t5 
	| t6 |
	t6 := t4 - t1 size - t3 size.
	t6 > 0
		ifTrue: [t5
				ifTrue: [t2 nextPutAll: t3;
						
						nextPutAll: (String new: t6 withAll: $0)]
				ifFalse: [t2
						nextPutAll: (String new: t6 withAll: Character space);
						 nextPutAll: t3]]
		ifFalse: [t2 nextPutAll: t3].
	t2 nextPutAll: t1! !

!Integer methodsFor: 'printing' stamp: ''!
printOn: t1 
	^ self printOn: t1 base: 10! !

!Integer methodsFor: 'printing' stamp: 'bf 8/31/2012 20:26'!
printOn: aStream asFixedPoint: base
	"assume I am a fixedpoint decimal scaled by base"
	"String streamContents: [:s | 1234 printOn: s asFixedPoint: 1000]"

	| b n |
	self < 0 ifTrue: [aStream nextPut: $-. 
		^self negated printOn: aStream asFixedPoint: base].
	b := base.
	n := self.
	[aStream print: n // b.
	(n := n \\ b) = 0] whileFalse: [
		b = base ifTrue: [aStream nextPut: $.].
		b := b // 10].
! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printOn: t1 base: t2 
	^ self subclassResponsibility! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printOn: t1 base: t2 length: t3 padded: t4 
	| t5 |
	t5 := self negative
				ifTrue: ['-']
				ifFalse: [String new].
	self
		print: (self abs printStringBase: t2)
		on: t1
		prefix: t5
		length: t3
		padded: t4! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printOn: t1 base: t2 nDigits: t3 
	self subclassResponsibility! !

!Integer methodsFor: 'printing' stamp: ''!
printOn: t1 base: t2 showRadix: t3 
	| t4 t5 |
	t4 := self printStringRadix: t2.
	t3
		ifTrue: [^ t1 nextPutAll: t4].
	t5 := (t4
				indexOf: $r
				ifAbsent: [self error: 'radix indicator not found.'])
				+ 1.
	self negative
		ifTrue: [t1 nextPut: $-].
	t1
		nextPutAll: (t4 copyFrom: t5 to: t4 size)! !

!Integer methodsFor: 'printing' stamp: 'nice 5/15/2012 22:56'!
printOn: aStream maxDecimalPlaces: placesDesired
	^self printOn: aStream! !

!Integer methodsFor: 'printing' stamp: 'nice 3/29/2011 21:58'!
printOn: aStream showingDecimalPlaces: placesDesired
	"Same as super, but provides a faster implementation because fraction part and rounding are trivial."
	
	self printOn: aStream base: 10.
	placesDesired <= 0
		ifFalse:
			[aStream nextPut: $..
			0 printOn: aStream base: 10 length: placesDesired padded: true].! !

!Integer methodsFor: 'printing' stamp: ''!
printPaddedWith: t1 to: t2 
	^ self
		printPaddedWith: t1
		to: t2
		base: 10! !

!Integer methodsFor: 'printing' stamp: ''!
printPaddedWith: t1 to: t2 base: t3 
	| t4 t5 t6 |
	t4 := WriteStream
				on: (String new: 10).
	self
		printOn: t4
		base: t3
		showRadix: false.
	t6 := t4 contents.
	t5 := t2 - t6 size.
	t5 > 0
		ifFalse: [^ t6].
	^ ((String new: t5) atAllPut: t1;
		 yourself) , t6! !

!Integer methodsFor: 'printing' stamp: ''!
printString
	^ String
		streamContents: [:t1 | self printOn: t1 base: 10]! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printStringBase: t1 length: t2 padded: t3 
	^ String
		streamContents: [:t4 | self
				printOn: t4
				base: t1
				length: t2
				padded: t3]! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printStringHex
	^ self printStringBase: 16! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printStringLength: t1 
	^ self printStringLength: t1 padded: false! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printStringLength: t1 padded: t2 
	^ self
		printStringBase: 10
		length: t1
		padded: t2! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printStringPadded: t1 
	^ self printStringLength: t1 padded: true! !

!Integer methodsFor: 'printing' stamp: ''!
printStringRadix: t1 
	| t2 |
	t1 = 10
		ifTrue: [t2 := self storeStringBase: t1.
			self negative
				ifTrue: [^ '-10r'
						, (t2 copyFrom: 2 to: t2 size)].
			^ '10r' , t2].
	^ self storeStringBase: t1! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
printStringRoman
	^ String
		streamContents: [:t1 | 
			| t2 |
			t2 := self negative
						ifTrue: [t1 nextPut: $-.
							self negated]
						ifFalse: [self].
			t2 // 1000
				timesRepeat: [t1 nextPut: $M].
			t2
				romanDigits: 'MDC'
				for: 100
				on: t1;
				
				romanDigits: 'CLX'
				for: 10
				on: t1;
				
				romanDigits: 'XVI'
				for: 1
				on: t1]! !

!Integer methodsFor: 'printing' stamp: 'nice 9/8/2011 22:07'!
printTruncatedOn: aStream showingDecimalPlaces: placesDesired
	"Print a representation of the receiver on aStream in decimal notation with prescribed number of places after decimal separator.
	Print as if the receiver was truncated to requested precision."

	self printOn: aStream.
	placesDesired > 0
		ifTrue:
			[aStream nextPut: $..
			aStream next: placesDesired put: $0]! !

!Integer methodsFor: 'arithmetic' stamp: ''!
quo: t1 
	| t2 t3 |
	t1 isInteger
		ifTrue: [t2 := self negative == t1 negative == false.
			t3 := (self
						digitDiv: (t1 class == SmallInteger
								ifTrue: [t1 abs]
								ifFalse: [t1])
						neg: t2)
						at: 1.
			^ t3 normalize].
	^ t1 adaptToInteger: self andSend: #quo:! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
radix: t1 
	^ self printStringBase: t1! !

!Integer methodsFor: 'mathematical functions' stamp: 'nice 5/19/2011 02:08'!
raisedTo: n modulo: m
	"Answer the modular exponential.
	Note: this implementation is optimized for case of large integers raised to large powers."
	| a s mInv |
	n = 0 ifTrue: [^1].
	(self >= m or: [self < 0]) ifTrue: [^self \\ m raisedTo: n modulo: m].
	n < 0 ifTrue: [^(self reciprocalModulo: m) raisedTo: n negated modulo: m].
	(n < 4096 or: [m even])
		ifTrue:
			["Overhead of Montgomery method might cost more than naive divisions, use naive"
			^self slidingLeftRightRaisedTo: n modulo: m].
	
	mInv := 256 - ((m bitAnd: 255) reciprocalModulo: 256).
 
	"Initialize the result to R=256 raisedTo: m digitLength"
	a := (1 bitShift: m digitLength*8) \\ m.
	
	"Montgomerize self (multiply by R)"
	(s := self montgomeryTimes: (a*a \\ m) modulo: m mInvModB: mInv)
		ifNil:
			["No Montgomery primitive available ? fallback to naive divisions"
			^self slidingLeftRightRaisedTo: n modulo: m].

	"Exponentiate self*R"
	a := s montgomeryRaisedTo: n times: a modulo: m mInvModB: mInv.

	"Demontgomerize the result (divide by R)"
	^a montgomeryTimes: 1 modulo: m mInvModB: mInv! !

!Integer methodsFor: 'mathematical functions' stamp: 'nice 5/19/2011 02:10'!
raisedToInteger: exp modulo: m
	self deprecated: 'rather use #raisedTo:modulo: for efficiency'.
	(exp = 0) ifTrue: [^ 1].
	exp even
		ifTrue: [^ (self raisedToInteger: (exp // 2) modulo: m) squared \\ m]
		ifFalse: [^ (self * (self raisedToInteger: (exp - 1) modulo: m)) \\ m].! !

!Integer methodsFor: 'arithmetic' stamp: 'nice 9/2/2010 21:29'!
reciprocalModulo: n
	"Answer an integer x such that (self * x) \\ n = 1, x > 0, x < n.
	Raise an error if there is no such integer.
	The algorithm is a non extended euclidean modular inversion called NINV.
	It is described in this article:
		'Using an RSA Accelerator for Modular Inversion'
	by Martin Seysen. See http://www.iacr.org/archive/ches2005/017.pdf"

	| u v f fPlusN b result result2 |
	((self <= 0) or: [n <= 0]) ifTrue: [self error: 'self and n must be greater than zero'].
	self >= n ifTrue: [self error: 'self must be < n'].

	b := n highBit + 1.
	f := 1 bitShift: b.
	v := (self bitShift: b) + 1.
	u := n bitShift: b.
	fPlusN := f + n.
	[v >= fPlusN] whileTrue:
		[v := u \\\ (u := v)].
	result := v - f.
	(result2 := result + n) > 0
		ifFalse: [self error: 'no inverse'].
	^result positive
		ifTrue: [result]
		ifFalse: [result2]! !

!Integer methodsFor: 'system primitives' stamp: ''!
replaceFrom: t1 to: t2 with: t3 startingAt: t4 
	| t5 |
	t5 := t4.
	t1
		to: t2
		do: [:t6 | 
			self
				digitAt: t6
				put: (t3 digitAt: t5).
			t5 := t5 + 1]! !

!Integer methodsFor: 'private' stamp: ''!
romanDigits: t1 for: t2 on: t3 
	| t4 |
	t4 := self \\ (t2 * 10) // t2.
	t4 = 9
		ifTrue: [^ t3 nextPut: t1 last;
				 nextPut: t1 first].
	t4 = 4
		ifTrue: [^ t3 nextPut: t1 last;
				 nextPut: t1 second].
	t4 > 4
		ifTrue: [t3 nextPut: t1 second].
	t4 \\ 5
		timesRepeat: [t3 nextPut: t1 last]! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
rounded
	^ self! !

!Integer methodsFor: 'private' stamp: 'nice 5/19/2011 02:00'!
slidingLeftRightRaisedTo: n modulo: m
	"Private - compute (self raisedTo: n) \\ m,
	Note: this method has to be fast because it is generally used with large integers in cryptography.
	It thus operate on exponent bits from left to right by packets with a sliding window rather than bit by bit (see below)."
	
	| pow j k w index oddPowersOfSelf square |
	
	"Precompute powers of self for odd bit patterns xxxx1 up to length w + 1.
	The width w is chosen with respect to the total bit length of n,
	such that each bit pattern will on average be encoutered P times in the whole bit sequence of n.
	This costs (2 raisedTo: w) multiplications, but more will be saved later (see below)."
	k := n highBit.
	w := (k highBit - 1 >> 1 min: 16) max: 1.
	oddPowersOfSelf := Array new: 1 << w.
	oddPowersOfSelf at: 1 put: (pow := self).
	square := self * self \\\ m.
	2 to: oddPowersOfSelf size do: [:i | pow := oddPowersOfSelf at: i put: pow * square \\\ m].
	
	"Now exponentiate by searching precomputed bit patterns with a sliding window"
	pow := 1.
	[k > 0]
		whileTrue:
			[pow := pow * pow \\\ m.
			"Skip bits set to zero (the sliding window)"
			(n bitAt: k) = 0
				ifFalse:
					["Find longest odd bit pattern up to window length (w + 1)"
					j := k - w max: 1.
					[j < k and: [(n bitAt: j) = 0]] whileTrue: [j := j + 1].
					"We found an odd bit pattern of length k-j+1;
					perform the square powers for each bit
					(same cost as bitwise algorithm);
					compute the index of this bit pattern in the precomputed powers."
					index := 0.
					[k > j] whileTrue:
						[pow := pow * pow \\\ m.
						index := index << 1 + (n bitAt: k).
						k := k - 1].
					"Perform a single multiplication for the whole bit pattern.
					This saves up to (k-j) multiplications versus a naive algorithm operating bit by bit"
					pow := pow * (oddPowersOfSelf at: index + 1) \\\ m].
			k := k - 1].
	^pow normalize! !

!Integer methodsFor: 'mathematical functions' stamp: 'nice 10/29/2011 15:00'!
sqrt
	"Answer the square root of the receiver."

	| selfAsFloat floatResult guess |
	selfAsFloat := self asFloat.
	floatResult := selfAsFloat sqrt.

	floatResult isInfinite ifFalse: [
		guess := floatResult truncated.

		"If got an exact answer, answer it. Otherwise answer float approximate answer."
		guess squared = self
			ifTrue: [ ^ guess ]].

	"In this case, maybe it failed because we are such a big integer that the Float method becomes
	inexact, even if we are a whole square number. So, try the slower but more general method"
	selfAsFloat >= Float maxExactInteger asFloat squared
		ifTrue: [
			guess := self sqrtFloor.
			guess squared = self ifTrue: [
				^guess ].
			
			"Nothing else can be done. No exact answer means answer must be a Float.
			Answer the best we have which is the rounded sqrt."
			guess := (self * 4) sqrtFloor.
			^(guess // 2 + (guess \\ 2)) asFloat].

	"We need an approximate result"
	^floatResult! !

!Integer methodsFor: 'mathematical functions' stamp: 'nice 10/17/2011 22:53'!
sqrtFloor
	"Return the integer part of the square root of self"

	| guess delta |
	guess := 1 bitShift: self highBit + 1 // 2.
	[
		delta := guess squared - self // (guess bitShift: 1).
		delta = 0 ] whileFalse: [
			guess := guess - delta ].
	^guess - 1! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
storeOn: t1 base: t2 
	| t3 |
	t3 := self negative
				ifTrue: [t1 nextPut: $-.
					self negated]
				ifFalse: [self].
	t2 = 10
		ifFalse: [t1 nextPutAll: t2 printString;
				 nextPut: $r].
	t1
		nextPutAll: (t3 printStringBase: t2)! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
storeOn: t1 base: t2 length: t3 padded: t4 
	| t5 |
	t5 := self negative
				ifTrue: ['-']
				ifFalse: [String new].
	t2 = 10
		ifFalse: [t5 := t5 , t2 printString , 'r'].
	self
		print: (self abs printStringBase: t2)
		on: t1
		prefix: t5
		length: t3
		padded: t4! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
storeStringBase: t1 length: t2 padded: t3 
	^ String
		streamContents: [:t4 | self
				storeOn: t4
				base: t1
				length: t2
				padded: t3]! !

!Integer methodsFor: 'printing-numerative' stamp: ''!
storeStringHex
	^ self storeStringBase: 16! !

!Integer methodsFor: 'mathematical functions' stamp: ''!
take: t1 
	| t2 t3 |
	t1 < 0
		ifTrue: [^ 0].
	t1 > self
		ifTrue: [^ 0].
	t2 := 1.
	self
		to: (t1 max: self - t1)
				+ 1
		by: -1
		do: [:t4 | t2 := t2 * t4].
	t3 := 1.
	1
		to: (t1 min: self - t1)
		do: [:t6 | t3 := t3 * t6].
	^ t2 // t3! !

!Integer methodsFor: 'enumerating' stamp: ''!
timesRepeat: t1 
	1
		to: self
		do: [:t2 | t1 value]! !

!Integer methodsFor: 'benchmarks' stamp: ''!
tinyBenchmarks
	| t1 t2 t3 t5 t6 |
	t3 := 1.
	[t1 := Time
				millisecondsToRun: [t3 benchmark].
	t1 < 1000]
		whileTrue: [t3 := t3 * 2].
	t6 := 28.
	[t2 := Time
				millisecondsToRun: [t5 := t6 benchFib].
	t2 < 1000]
		whileTrue: [t6 := t6 + 1].
	^ (t3 * 500000 * 1000 // t1) printString , ' bytecodes/sec; ' , (t5 * 1000 // t2) printString , ' sends/sec'! !

!Integer methodsFor: 'truncation and round off' stamp: ''!
truncated
	^ self! !

Integer variableByteSubclass: #LargePositiveInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

LargePositiveInteger variableByteSubclass: #LargeNegativeInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!LargeNegativeInteger class methodsFor: 'as yet unclassified' stamp: ''!
initializedInstance
	^ -9876543210987654321 copy! !

!LargeNegativeInteger methodsFor: 'arithmetic' stamp: ''!
abs
	^ self negated! !

!LargeNegativeInteger methodsFor: 'converting' stamp: 'nice 9/22/2011 01:36'!
asFloat
	^self negated asFloat negated! !

!LargeNegativeInteger methodsFor: 'bit manipulation' stamp: 'nice 5/20/2011 23:01'!
bitAt: anInteger
	"super would not work because we have to pretend we are in two-complement.
	this has to be tricky..."
	
	| digitIndex bitIndex i |
	digitIndex := anInteger - 1 // 8 + 1.
	digitIndex > self digitLength ifTrue: [^1].
	bitIndex := (anInteger - 1 bitAnd: 2r111) + 1.

	i := 1.
	[i = digitIndex
		ifTrue:
			["evaluate two complement (bitInvert + 1) on the digit :
			(if digitIndex > 1, we must still add 1 due to the carry).
			but x bitInvert is -1-x, bitInvert+1 is just x negated..."
			^(self digitAt: digitIndex) negated bitAt: bitIndex].
	(self digitAt: i) = 0]
		whileTrue: [
			"two complement (bitInvert + 1) raises a carry:
			0 bitInvert -> 2r11111111.  2r11111111 + 1 -> 0 with carry...
			Thus we must inquire one digit forward"
			i := i + 1].
	
	"We escaped the while loop, because there is no more carry.
	Do a simple bitInvert without a carry"
	^1 - ((self digitAt: digitIndex) bitAt: bitIndex)! !

!LargeNegativeInteger methodsFor: 'bit manipulation' stamp: ''!
highBit
	^ self shouldNotImplement! !

!LargeNegativeInteger methodsFor: 'testing' stamp: 'ul 1/22/2012 23:57'!
isPowerOfTwo
	"Return true if the receiver is an integral power of two. Optimized version."
	
	^false! !

!LargeNegativeInteger methodsFor: 'mathematical functions' stamp: 'nice 7/15/2011 14:06'!
ln
	^DomainError signal: 'ln is only defined for x > 0' from: 0! !

!LargeNegativeInteger methodsFor: 'mathematical functions' stamp: 'nice 7/15/2011 14:06'!
log
	^DomainError signal: 'log is only defined for x > 0' from: 0! !

!LargeNegativeInteger methodsFor: 'arithmetic' stamp: ''!
negated
	^ self
		copyto: (LargePositiveInteger new: self digitLength)! !

!LargeNegativeInteger methodsFor: 'testing' stamp: ''!
negative
	^ true! !

!LargeNegativeInteger methodsFor: 'converting' stamp: ''!
normalize
	| t1 t2 t3 t4 t5 |
	<primitive: 'primNormalizeNegative' module: 'LargeIntegers'>
	t3 := t4 := self digitLength.
	[t3 = 0
		ifTrue: [^ 0].
	(self digitAt: t3)
		= 0]
		whileTrue: [t3 := t3 - 1].
	t1 := 4.
	t3 <= t1
		ifTrue: [t5 := SmallInteger minVal.
			(t3 < t1
					or: [(self digitAt: t1)
							< t5 lastDigit])
				ifTrue: [t2 := 0.
					t3
						to: 1
						by: -1
						do: [:t6 | t2 := t2 * 256
										- (self digitAt: t6)].
					^ t2].
			1
				to: t1
				do: [:t7 | (self digitAt: t7)
							= (t5 digitAt: t7)
						ifFalse: [t3 < t4
								ifTrue: [^ self growto: t3].
							^ self]].
			^ t5].
	t3 < t4
		ifTrue: [^ self growto: t3]! !

!LargeNegativeInteger methodsFor: 'testing' stamp: ''!
positive
	^ false! !

!LargeNegativeInteger methodsFor: 'printing' stamp: ''!
printOn: t1 base: t2 
	t1 nextPut: $-.
	self abs printOn: t1 base: t2! !

!LargeNegativeInteger methodsFor: 'testing' stamp: ''!
sign
	^ -1! !

!LargeNegativeInteger methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 21:40'!
sqrt
	"Answer the square root of the receiver."
	^ DomainError signal: 'sqrt undefined for number less than zero.'! !

!LargeNegativeInteger methodsFor: 'testing' stamp: ''!
strictlyPositive
	^ false! !

!LargePositiveInteger class methodsFor: 'testing' stamp: ''!
initializedInstance
	^ 12345678901234567 copy! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
* t1 
	<primitive: 29>
	^ super * t1! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
+ t1 
	<primitive: 21>
	^ super + t1! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
- t1 
	<primitive: 22>
	^ super - t1! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
/ t1 
	<primitive: 30>
	^ super / t1! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
// t1 
	<primitive: 32>
	^ super // t1! !

!LargePositiveInteger methodsFor: 'comparing' stamp: ''!
< t1 
	<primitive: 23>
	^ super < t1! !

!LargePositiveInteger methodsFor: 'comparing' stamp: ''!
<= t1 
	<primitive: 25>
	^ super <= t1! !

!LargePositiveInteger methodsFor: 'comparing' stamp: ''!
> t1 
	<primitive: 24>
	^ super > t1! !

!LargePositiveInteger methodsFor: 'comparing' stamp: ''!
>= t1 
	<primitive: 26>
	^ super >= t1! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
\\ t1 
	<primitive: 31>
	^ super \\ t1! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
\\\ t1 
	^ (self digitDiv: t1 neg: false) second! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
abs
	^ self! !

!LargePositiveInteger methodsFor: 'converting' stamp: ''!
as31BitSmallInt
	self highBit = 31
		ifFalse: [self error: 'more than 31 bits can not fit in a SmallInteger'].
	^ self - 2147483648! !

!LargePositiveInteger methodsFor: 'converting' stamp: 'nice 9/22/2011 01:53'!
asFloat
	"Answer a Float that best approximates the value of the receiver.
	This algorithm is optimized to process only the significant digits of a LargeInteger.
	And it does honour IEEE 754 round to nearest even mode in case of excess precision (see details below)."
	
	"How numbers are rounded in IEEE 754 default rounding mode:
	A shift is applied so that the highest 53 bits are placed before the floating point to form a mantissa.
	The trailing bits form the fraction part placed after the floating point.
	This fractional number must be rounded to the nearest integer.
	If fraction part is 2r0.1, exactly between two consecutive integers, there is a tie.
	The nearest even integer is chosen in this case.
	Examples (First 52bits of mantissa are omitted for brevity):
	2r0.00001 is rounded downward to 2r0
	2r1.00001 is rounded downward to 2r1
	2r0.1 is a tie and rounded to 2r0 (nearest even)
	2r1.1 is a tie and rounded to 2r10 (nearest even)
	2r0.10001 is rounded upward to 2r1
	2r1.10001 is rounded upward to 2r10
	Thus, if the next bit after floating point is 0, the mantissa is left unchanged.
	If next bit after floating point is 1, an odd mantissa is always rounded upper.
	An even mantissa is rounded upper only if the fraction part is not a tie."
	
	"Algorihm details:
	Floating point hardware will correctly handle the rounding by itself with a single inexact operation if mantissa has one excess bit of precision.
	Except in the last case when extra bits are present after an even mantissa, we must round upper by ourselves.
	Note 1: the inexact flag in floating point hardware must not be trusted because it won't take into account the bits we truncated by ourselves.
	Note 2: the floating point hardware is presumed configured in default rounding mode."
	
	| mantissa shift sum excess |

	"Check how many bits excess the maximum precision of a Float mantissa."
	excess := self highBitOfMagnitude - Float precision.
	excess > 1
		ifTrue:
			["Remove the excess bits but one."
			mantissa := self bitShift: 1 - excess.
			shift := excess - 1.
			"Handle the case of extra bits truncated after an even mantissa."
			((mantissa bitAnd: 2r11) = 2r01 and: [self anyBitOfMagnitudeFrom: 1 to: shift])
				ifTrue: [mantissa := mantissa + 1]]
		ifFalse:
			[mantissa := self.
			shift := 0].

	"Now that mantissa has at most 1 excess bit of precision, let floating point operations perform the final rounding."
	sum := 0.0.
	1 to: mantissa digitLength do:
		[:byteIndex | 
		sum := sum + ((mantissa digitAt: byteIndex) asFloat timesTwoPower: shift).
		shift := shift + 8].
	^sum! !

!LargePositiveInteger methodsFor: 'bit manipulation' stamp: 'nice 5/20/2011 23:00'!
bitAt: anInteger
	"Optimize super algorithm to avoid long bit operations.
	Instead work on digits which are known to be SmallInteger and fast.
	Note that this algorithm does not work for negative integers."
	
	| digitIndex bitIndex |
	digitIndex := anInteger - 1 // 8 + 1.
	digitIndex > self digitLength ifTrue: [^0].
	bitIndex := (anInteger - 1 bitAnd: 2r111) + 1.
	^(self digitAt: digitIndex) bitAt: bitIndex! !

!LargePositiveInteger methodsFor: 'bit manipulation' stamp: 'nice 4/12/2011 08:59'!
bitReverse: highBit 
	"This implementation is faster than super"
	
	| digitSize reversed |
	highBit < self highBit ifTrue: [ self error: 'Not enough bits.' ].
	digitSize := highBit + 7 // 8.
	reversed := self class new: digitSize.
	1 to: self digitLength do: [:i |
		reversed digitAt: digitSize + 1 - i put: (self digitAt: i) byteReversed].
	^reversed bitShift: highBit - (digitSize * 8)! !

!LargePositiveInteger methodsFor: 'system primitives' stamp: ''!
digitAt: t1 
	<primitive: 60>
	self digitLength < t1
		ifTrue: [^ 0].
	^ super at: t1! !

!LargePositiveInteger methodsFor: 'system primitives' stamp: ''!
digitAt: t1 put: t2 
	<primitive: 61>
	^ super at: t1 put: t2! !

!LargePositiveInteger methodsFor: 'system primitives' stamp: ''!
digitLength
	<primitive: 62>
	self primitiveFailed! !

!LargePositiveInteger methodsFor: 'comparing' stamp: ''!
hash
	^ ByteArray hashBytes: self startingWith: self species hash! !

!LargePositiveInteger methodsFor: 'bit manipulation' stamp: ''!
hashMultiply
	^ (self bitAnd: 268435455) hashMultiply! !

!LargePositiveInteger methodsFor: 'bit manipulation' stamp: ''!
highBit
	^ self highBitOfMagnitude! !

!LargePositiveInteger methodsFor: 'bit manipulation' stamp: 'nice 9/22/2011 01:59'!
highBitOfMagnitude
	"Answer the index of the high order bit of the magnitude of the  
	receiver, or zero if the receiver is zero.  
	This method is used for LargeNegativeIntegers as well,  
	since Squeak's LargeIntegers are sign/magnitude."
	| realLength lastDigit |
	realLength := self digitLength.
	[(lastDigit := self digitAt: realLength) = 0]
		whileTrue: [(realLength := realLength - 1) = 0 ifTrue: [^ 0]].
	^ lastDigit highBitOfByte + (8 * (realLength - 1))! !

!LargePositiveInteger methodsFor: 'testing' stamp: ''!
isLarge
	^ true! !

!LargePositiveInteger methodsFor: 'testing' stamp: 'ul 1/22/2012 23:56'!
isPowerOfTwo
	"Return true if the receiver is an integral power of two. Optimized version."
	
	| size |
	1 to: (size := self digitLength) do: [ :index |
		| digit |
		(digit := self digitAt: index) = 0 ifFalse: [ 
			^size = index and: [ digit isPowerOfTwo ] ] ].
	^false! !

!LargePositiveInteger methodsFor: 'testing' stamp: ''!
isPrime
	^ self isProbablyPrime! !

!LargePositiveInteger methodsFor: 'mathematical functions' stamp: 'nice 7/15/2011 14:06'!
ln
	"This function is defined because super ln might overflow."
	| res h |
	res := super ln.
	res isFinite ifTrue: [^res].
	h := self highBit.
	^2 ln * h + (self / (1 << h)) asFloat ln! !

!LargePositiveInteger methodsFor: 'mathematical functions' stamp: 'nice 7/15/2011 14:05'!
log
	"This function is defined because super log might overflow."
	| res h |
	res := super log.
	res isFinite ifTrue: [^res].
	h := self highBit.
	^2 log * h + (self / (1 << h)) asFloat log! !

!LargePositiveInteger methodsFor: 'mathematical functions' stamp: 'nice 10/14/2011 23:38'!
mightBeASquare
	"In base 16, a square number can end only with 0,1,4 or 9 and
	- in case 0, only 0,1,4,9 can precede it,
	- in case 4, only even numbers can precede it.
	See http://en.wikipedia.org/wiki/Square_number
	So, in hex, the last byte must be one of:
		00
		10
		40
		90
		x1
		e4
		x9
	where x is any hex digit and e is any even digit
	Also, the receiver must be an aven power of two."
	| lsb |
	lsb := self digitAt: 1.
	^(lsb = 0 and: [ self lowBit odd ])	"00 (and even power of 2)"
		or: [ lsb = 16r40				"40"
		or: [ (lsb bitAnd: 16r7) = 1		"any|1 or any|9"
		or: [ (lsb bitAnd: 16r1F) = 4		"even|4"
		or: [ (lsb bitAnd: 16r7F) = 16 ]]]]	"10 or 90"! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
negated
	^ (self
		copyto: (LargeNegativeInteger new: self digitLength)) normalize! !

!LargePositiveInteger methodsFor: 'testing' stamp: ''!
negative
	^ false! !

!LargePositiveInteger methodsFor: 'converting' stamp: ''!
normalize
	| t1 t2 t3 t4 |
	<primitive: 'primNormalizePositive' module: 'LargeIntegers'>
	t3 := t4 := self digitLength.
	[t3 = 0
		ifTrue: [^ 0].
	(self digitAt: t3)
		= 0]
		whileTrue: [t3 := t3 - 1].
	t1 := SmallInteger maxVal digitLength.
	(t3 <= t1
			and: [(self digitAt: t1)
					<= (SmallInteger maxVal digitAt: t1)])
		ifTrue: [t2 := 0.
			t3
				to: 1
				by: -1
				do: [:t5 | t2 := t2 * 256
								+ (self digitAt: t5)].
			^ t2].
	t3 < t4
		ifTrue: [^ self growto: t3]! !

!LargePositiveInteger methodsFor: 'testing' stamp: ''!
positive
	^ true! !

!LargePositiveInteger methodsFor: 'printing' stamp: 'nice 6/17/2011 04:12'!
printOn: aStream base: b
	"Append a representation of this number in base b on aStream.
	In order to reduce cost of LargePositiveInteger ops, split the number in approximately two equal parts in number of digits."
	
	| halfDigits halfPower head tail nDigitsUnderestimate |
	"Don't engage any arithmetic if not normalized"
	(self digitLength = 0 or: [(self digitAt: self digitLength) = 0]) ifTrue: [^self normalize printOn: aStream base: b].
	
	nDigitsUnderestimate := b = 10
		ifTrue: [((self highBit - 1) * 1233 >> 12) + 1. "This is because (2 log)/(10 log)*4096 is slightly greater than 1233"]
		ifFalse: [self highBit quo: b highBit].
		
	"splitting digits with a whole power of two is more efficient"
	halfDigits := 1 bitShift: nDigitsUnderestimate highBit - 2.
	
	halfDigits <= 1
		ifTrue: ["Hmmm, this could happen only in case of a huge base b... Let lower level fail"
			^self printOn: aStream base: b nDigits: (self numberOfDigitsInBase: b)].
	
	"Separate in two halves, head and tail"
	halfPower := b raisedToInteger: halfDigits.
	head := self quo: halfPower.
	tail := self - (head * halfPower).
	
	"print head"
	head printOn: aStream base: b.
	
	"print tail without the overhead to count the digits"
	tail printOn: aStream base: b nDigits: halfDigits! !

!LargePositiveInteger methodsFor: 'printing' stamp: 'ul 8/23/2010 13:56'!
printOn: aStream base: b nDigits: n
	"Append a representation of this number in base b on aStream using n digits.
	In order to reduce cost of LargePositiveInteger ops, split the number of digts approximatily in two
	Should be invoked with: 0 <= self < (b raisedToInteger: n)"
	
	| halfPower half head tail |
	n <= 1 ifTrue: [
		n <= 0 ifTrue: [self error: 'Number of digits n should be > 0'].
		
		"Note: this is to stop an infinite loop if one ever attempts to print with a huge base
		This can happen because choice was to not hardcode any limit for base b
		We let Character>>#digitValue: fail"
		^aStream nextPut: (Character digitValue: self) ].
	halfPower := n bitShift: -1.
	half := b raisedToInteger: halfPower.
	head := self quo: half.
	tail := self - (head * half).
	head printOn: aStream base: b nDigits: n - halfPower.
	tail printOn: aStream base: b nDigits: halfPower! !

!LargePositiveInteger methodsFor: 'printing' stamp: ''!
printStringBase: t1 
	^ String
		streamContents: [:t2 | self printOn: t2 base: t1]! !

!LargePositiveInteger methodsFor: 'arithmetic' stamp: ''!
quo: t1 
	<primitive: 33>
	^ super quo: t1! !

!LargePositiveInteger methodsFor: 'system primitives' stamp: ''!
replaceFrom: t1 to: t2 with: t3 startingAt: t4 
	<primitive: 105>
	^ super
		replaceFrom: t1
		to: t2
		with: t3
		startingAt: t4! !

!LargePositiveInteger methodsFor: 'testing' stamp: ''!
sign
	^ 1! !

!LargePositiveInteger methodsFor: 'mathematical functions' stamp: 'nice 10/29/2011 15:07'!
sqrt
	"If we know for sure no exact solution exists, then just answer the cheap float approximation without wasting time."
	| selfAsFloat |
	self mightBeASquare
		ifFalse:
			[selfAsFloat := self asFloat.
			selfAsFloat isFinite ifTrue: [^self asFloat sqrt ]].

	"If some exact solution might exist, or self asFloat isInfinite, call potentially expensive super"
	^super sqrt! !

!LargePositiveInteger methodsFor: 'mathematical functions' stamp: 'nice 10/14/2011 23:50'!
sqrtFloor
	"Return the integer part of the square root of self"

	| powerOfTwo |
	(powerOfTwo := self lowBit - 1 // 2) > 1
		ifFalse: [^super sqrtFloor].
	^(self bitShift: -2 * powerOfTwo) sqrtFloor bitShift: powerOfTwo! !

!LargePositiveInteger methodsFor: 'testing' stamp: ''!
strictlyPositive
	^ true! !

!LargePositiveInteger methodsFor: 'converting' stamp: ''!
withAtLeastNDigits: t1 
	| t2 |
	self size >= t1
		ifTrue: [^ self].
	t2 := self class new: t1.
	t2
		replaceFrom: 1
		to: self size
		with: self
		startingAt: 1.
	^ t2! !

!Number class methodsFor: 'constants' stamp: ''!
one
	^ 1! !

!Number class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 
	^ (ExtendedNumberParser on: t1) nextNumber! !

!Number class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 base: t2 
	^ (SqNumberParser on: t1)
		nextNumberBase: t2! !

!Number class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 ifFail: t2 
	^ (ExtendedNumberParser on: t1) failBlock: t2;
		 nextNumber! !

!Number class methodsFor: 'instance creation' stamp: 'nice 2/22/2010 21:41'!
readSmalltalkSyntaxFrom: stringOrStream 
	"Answer a number as described on aStream.  The number may
	be any accepted Smalltalk literal Number format.
	It can include a leading radix specification, as in 16rFADE.
	It can as well be NaN, Infinity or -Infinity for conveniency.
	If stringOrStream does not start with a valid number description, fail."
	
	^(SqNumberParser on: stringOrStream) nextNumber! !

!Number methodsFor: 'arithmetic' stamp: ''!
* t1 
	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
+ t1 
	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
- t1 
	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
/ t1 
	self subclassResponsibility! !

!Number methodsFor: 'arithmetic' stamp: ''!
// t1 
	^ (self / t1) floor! !

!Number methodsFor: 'converting' stamp: ''!
@ t1 
	<primitive: 18>
	^ Point x: self y: t1! !

!Number methodsFor: 'arithmetic' stamp: ''!
\\ t1 
	^ self - (self // t1 * t1)! !

!Number methodsFor: 'arithmetic' stamp: ''!
abs
	self < 0
		ifTrue: [^ self negated]! !

!Number methodsFor: 'converting' stamp: ''!
adaptToCollection: t1 andSend: t2 
	^ t1
		collect: [:t3 | t3 perform: t2 with: self]! !

!Number methodsFor: 'converting' stamp: 'nice 10/13/2011 23:55'!
adaptToComplex: rcvr andSend: selector
	"If I am involved in arithmetic with a Complex number, convert me to a Complex number."
	^ rcvr perform: selector with: self asComplex! !

!Number methodsFor: 'converting' stamp: ''!
adaptToFloat: t1 andCompare: t2 
	t1 isFinite
		ifFalse: [t2 == #=
				ifTrue: [^ false].
			t2 == #~=
				ifTrue: [^ true].
			t1 isNaN
				ifTrue: [^ false].
			(t2 = #<
					or: [t2 = #<=])
				ifTrue: [^ t1 positive not].
			(t2 = #>
					or: [t2 = #>=])
				ifTrue: [^ t1 positive].
			^ self error: 'unknow comparison selector'].
	^ t1 asTrueFraction perform: t2 with: self! !

!Number methodsFor: 'converting' stamp: ''!
adaptToFloat: t1 andSend: t2 
	^ t1 perform: t2 with: self asFloat! !

!Number methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andSend: t2 
	^ self subclassResponsibility! !

!Number methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andSend: t2 
	^ self subclassResponsibility! !

!Number methodsFor: 'converting' stamp: ''!
adaptToPoint: t1 andSend: t2 
	^ t1 perform: t2 with: self @ self! !

!Number methodsFor: 'converting' stamp: ''!
adaptToScaledDecimal: t1 andSend: t2 
	^ self subclassResponsibility! !

!Number methodsFor: 'converting' stamp: ''!
adaptToString: t1 andSend: t2 
	^ t1 asNumber perform: t2 with: self! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:10'!
arCosh
	"Answer receiver's area hyperbolic cosine.
	That is the inverse function of cosh."

	^self asFloat arCosh! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:10'!
arSinh
	"Answer receiver's area hyperbolic sine.
	That is the inverse function of sinh."

	^self asFloat arSinh! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:09'!
arTanh
	"Answer receiver's area hyperbolic tangent.
	That is the inverse function of tanh."

	^self asFloat arTanh! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcCos
	^ self asFloat arcCos! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcSin
	^ self asFloat arcSin! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcTan
	^ self asFloat arcTan! !

!Number methodsFor: 'mathematical functions' stamp: ''!
arcTan: t1 
	^ self asFloat arcTan: t1! !

!Number methodsFor: 'arithmetic' stamp: ''!
arg
	self isZero
		ifTrue: [self error: 'Zero (0 + 0 i) does not have an argument.'].
	0 < self
		ifTrue: [^ 0].
	^ Float pi! !

!Number methodsFor: 'converting' stamp: ''!
asB3DVector3
	^ self @ self @ self! !

!Number methodsFor: 'converting' stamp: 'nice 10/13/2011 23:53'!
asComplex
	"Answer a Complex number that represents value of the the receiver."

	^ Complex real: self imaginary: 0! !

!Number methodsFor: 'converting' stamp: 'brp 5/13/2003 10:13'!
asDuration

	^ Duration nanoSeconds: self asInteger
! !

!Number methodsFor: 'converting' stamp: ''!
asFloatD
	^ self asFloat! !

!Number methodsFor: 'converting' stamp: ''!
asFloatE
	^ self asFloat! !

!Number methodsFor: 'converting' stamp: ''!
asFloatQ
	^ self asFloat! !

!Number methodsFor: 'converting' stamp: ''!
asInteger
	^ self truncated! !

!Number methodsFor: 'converting' stamp: 'wiz 5/29/2011 18:34'!
asNonFraction	
	"Answer a number equivalent to the receiver that is not a fraction. See Fraction for active method."

	^self ! !

!Number methodsFor: 'converting' stamp: ''!
asNumber
	^ self! !

!Number methodsFor: 'converting' stamp: ''!
asPoint
	^ self @ self! !

!Number methodsFor: 'converting' stamp: ''!
asScaledDecimal
	^ self asScaledDecimal: 8! !

!Number methodsFor: 'converting' stamp: ''!
asScaledDecimal: t1 
	^ ScaledDecimal newFromNumber: self scale: t1! !

!Number methodsFor: 'converting' stamp: ''!
asSmallAngleDegrees
	| t1 |
	t1 := self \\ 360.
	t1 > 180
		ifTrue: [t1 := t1 - 360].
	^ t1! !

!Number methodsFor: 'converting' stamp: ''!
asSmallPositiveDegrees
	^ self \\ 360! !

!Number methodsFor: 'filter streaming' stamp: ''!
byteEncode: t1 
	^ t1 writeNumber: self! !

!Number methodsFor: 'truncation and round off' stamp: 'wiz 5/29/2011 17:54'!
ceiling
	"Answer the integer nearest the receiver toward  infinity."

	| truncation |
	truncation := self truncated.
	self <= 0 ifTrue: [^truncation].
	self = truncation
		ifTrue: [^truncation]
		ifFalse: [^truncation + 1]! !

!Number methodsFor: 'comparing' stamp: ''!
closeTo: t1 
	t1 isFloat
		ifTrue: [^ t1 closeTo: self asFloat].
	^ [self = t1]
		ifError: [false]! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 02:26'!
copySignTo: aNumber
	"Return a number with same magnitude as aNumber and same sign as self."

	^ self positive
		ifTrue: [aNumber abs]
		ifFalse: [aNumber withNegativeSign].! !

!Number methodsFor: 'mathematical functions' stamp: ''!
cos
	^ self asFloat cos! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 00:54'!
cosh
	"Answer receivers hyperbolic cosine."
	
	^self asFloat cosh! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:12'!
day

	^ self sign days! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:56'!
days

	^ Duration days: self! !

!Number methodsFor: 'printing' stamp: ''!
defaultLabelForInspector
	^ super defaultLabelForInspector , ': ' , self printString! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 10/31/2010 22:03'!
degreeCos
	"Answer the cosine of the receiver taken as an angle in degrees."
	
	^ (90 - (180 + self \\ 360 - 180) abs) degreesToRadians sin! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 10/31/2010 22:01'!
degreeSin
	"Answer the sine of the receiver taken as an angle in degrees."
	
	^(90 - self) degreeCos! !

!Number methodsFor: 'converting' stamp: ''!
degreesToRadians
	^ self asFloat degreesToRadians! !

!Number methodsFor: 'truncation and round off' stamp: ''!
detentBy: t1 atMultiplesOf: t2 snap: t3 
	| t4 t5 |
	t4 := self roundTo: t2.
	(self roundTo: t1)
			= t4
		ifTrue: [^ t4].
	t3
		ifTrue: [^ self].
	t5 := self < t4
				ifTrue: [t4 - (t1 asFloat / 2)]
				ifFalse: [t4 + (t1 asFloat / 2)].
	^ t4 + (self - t5 * t2 asFloat / (t2 - t1))! !

!Number methodsFor: 'testing' stamp: ''!
even
	^ self \\ 2 = 0! !

!Number methodsFor: 'mathematical functions' stamp: ''!
exp
	^ self asFloat exp! !

!Number methodsFor: 'truncation and round off' stamp: ''!
floor
	| t1 |
	t1 := self truncated.
	self >= 0
		ifTrue: [^ t1].
	self = t1
		ifTrue: [^ t1].
	^ t1 - 1! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 12/11/2012 19:18'!
floorLog: radix
	"Answer the floor of the log base radix of the receiver."

	^(self log: radix) floor! !

!Number methodsFor: 'truncation and round off' stamp: ''!
fractionPart
	^ self - self integerPart! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:28'!
hour

	^ self sign hours
! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:56'!
hours

	^ Duration hours: self! !

!Number methodsFor: 'converting' stamp: ''!
i
	^ Complex real: 0 imaginary: self! !

!Number methodsFor: 'truncation and round off' stamp: ''!
integerPart
	^ self truncated! !

!Number methodsFor: 'mathematical functions' stamp: ''!
interpolateTo: t1 at: t2 
	^ self + (t1 - self * t2)! !

!Number methodsFor: 'testing' stamp: ''!
isDivisibleBy: t1 
	t1 = 0
		ifTrue: [^ false].
	t1 isInteger
		ifFalse: [^ false].
	^ self \\ t1 = 0! !

!Number methodsFor: 'testing' stamp: ''!
isInf
	self deprecated: 'Use #isInfinite instead'.
	^ self isInfinite! !

!Number methodsFor: 'testing' stamp: ''!
isInfinite
	^ false! !

!Number methodsFor: 'testing' stamp: ''!
isNaN
	^ false! !

!Number methodsFor: 'testing' stamp: ''!
isNumber
	^ true! !

!Number methodsFor: 'printing' stamp: ''!
isOrAreStringWith: t1 
	| t2 |
	t2 := self = 1
				ifTrue: [' is one ']
				ifFalse: [self = 0
						ifTrue: [' are no ']
						ifFalse: [' are ' , self printString , ' ']].
	t2 := t2 , t1.
	self = 1
		ifFalse: [t2 := t2 , 's'].
	^ t2! !

!Number methodsFor: 'testing' stamp: ''!
isZero
	^ self = 0! !

!Number methodsFor: 'mathematical functions' stamp: ''!
ln
	^ self asFloat ln! !

!Number methodsFor: 'mathematical functions' stamp: ''!
log
	^ self asFloat log! !

!Number methodsFor: 'mathematical functions' stamp: ''!
log: t1 
	^ self ln / t1 ln! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:26'!
milliSecond

	^ self sign milliSeconds
! !

!Number methodsFor: 'converting' stamp: 'brp 9/25/2003 13:16'!
milliSeconds

	^ Duration milliSeconds: self
! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:16'!
minute

	^ self sign minutes
! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:56'!
minutes

	^ Duration minutes: self! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:27'!
nanoSecond

	^ self sign nanoSeconds
! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 08:52'!
nanoSeconds

	^ Duration nanoSeconds: self.! !

!Number methodsFor: 'arithmetic' stamp: ''!
negated
	^ 0 - self! !

!Number methodsFor: 'testing' stamp: ''!
negative
	^ self < 0! !

!Number methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 08:36'!
nthRoot: aPositiveInteger
	"Answer the nth root of the receiver."

	self subclassResponsibility! !

!Number methodsFor: 'testing' stamp: ''!
odd
	^ self even == false! !

!Number methodsFor: 'testing' stamp: ''!
positive
	^ self >= 0! !

!Number methodsFor: 'printing' stamp: ''!
printOn: t1 
	self printOn: t1 base: 10! !

!Number methodsFor: 'printing' stamp: ''!
printOn: t1 base: t2 
	^ self subclassResponsibility! !

!Number methodsFor: 'printing' stamp: 'nice 5/15/2012 23:08'!
printOn: aStream maxDecimalPlaces: placesDesired
	"Print a representation of the receiver on aStream in decimal notation with at most prescribed number of places after decimal separator."

	| rounder rounded roundedFractionPart placesRequired shorten |
	placesDesired <= 0 ifTrue: [^ self rounded printOn: aStream].
	rounder := 10 raisedToInteger: placesDesired.
	rounded := self roundTo: rounder reciprocal.
	rounded negative ifTrue: [aStream nextPut: $-].
	rounded := rounded abs.
	rounded integerPart truncated printOn: aStream.
	roundedFractionPart := (rounded fractionPart * rounder) truncated.
	placesRequired := placesDesired.
	[roundedFractionPart = 0 ifTrue: [^self].
	(shorten := roundedFractionPart // 10) * 10 = roundedFractionPart]
		whileTrue:
			[placesRequired := placesRequired - 1.
			roundedFractionPart := shorten].
	placesRequired > 0
		ifTrue:
			[aStream nextPut: $..
			roundedFractionPart printOn: aStream base: 10 length: placesRequired padded: true]! !

!Number methodsFor: 'printing' stamp: 'nice 3/29/2011 21:48'!
printOn: aStream showingDecimalPlaces: placesDesired
	"Print a representation of the receiver on aStream in decimal notation with prescribed number of places after decimal separator."

	| rounder rounded roundedFractionPart |
	placesDesired <= 0 ifTrue: [^ self rounded printOn: aStream].
	rounder := 10 raisedToInteger: placesDesired.
	rounded := self roundTo: rounder reciprocal.
	rounded negative ifTrue: [aStream nextPut: $-].
	rounded := rounded abs.
	rounded integerPart truncated printOn: aStream.
	aStream nextPut: $..
	roundedFractionPart := (rounded fractionPart * rounder) truncated.
	roundedFractionPart printOn: aStream base: 10 length: placesDesired padded: true! !

!Number methodsFor: 'printing' stamp: 'nice 3/29/2011 21:39'!
printShowingDecimalPlaces: placesDesired
	"Print the receiver showing precisely the given number of places desired.  If placesDesired is positive, a decimal point and that many digits after the decimal point will always be shown.  If placesDesired is zero, a whole number will be shown, without a decimal point."

	^String new: placesDesired + 10 streamContents: [:aStream |
		self printOn: aStream showingDecimalPlaces: placesDesired]
"
23 printShowingDecimalPlaces: 2
23.5698 printShowingDecimalPlaces: 2
-234.567 printShowingDecimalPlaces: 5
23.4567 printShowingDecimalPlaces: 0
23.5567 printShowingDecimalPlaces: 0
-23.4567 printShowingDecimalPlaces: 0
-23.5567 printShowingDecimalPlaces: 0
100000000 printShowingDecimalPlaces: 1
0.98 printShowingDecimalPlaces: 5
-0.98 printShowingDecimalPlaces: 2
2.567 printShowingDecimalPlaces: 2
-2.567 printShowingDecimalPlaces: 2
0 printShowingDecimalPlaces: 2
"! !

!Number methodsFor: 'printing' stamp: 'nice 5/15/2012 23:14'!
printShowingMaxDecimalPlaces: placesDesired
	"Print the receiver showing at most the given number of places desired after the decimal point.
	Trailing zeros of decimal part are discarded, so the number of digits after the decimal point may vary.
	When placesDesired is zero or negative, or when fraction part vanish, no decimal point is shown."

	^String new: placesDesired + 10 streamContents: [:aStream |
		self printOn: aStream maxDecimalPlaces: placesDesired]! !

!Number methodsFor: 'printing' stamp: ''!
printString
	^ self printStringBase: 10! !

!Number methodsFor: 'printing' stamp: ''!
printStringBase: t1 
	^ String
		streamContents: [:t2 | self printOn: t2 base: t1]! !

!Number methodsFor: 'arithmetic' stamp: ''!
quo: t1 
	^ (self / t1) truncated! !

!Number methodsFor: 'converting' stamp: ''!
radiansToDegrees
	^ self asFloat radiansToDegrees! !

!Number methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 08:50'!
raisedTo: aNumber 
	"Answer the receiver raised to aNumber."

	aNumber isInteger ifTrue: [
		"Do the special case of integer power"
		^ self raisedToInteger: aNumber].
	aNumber isFraction ifTrue: [
		"Special case for fraction power"
		^ (self nthRoot: aNumber denominator) raisedToInteger: aNumber numerator ].
	self < 0 ifTrue: [
		^ ArithmeticError signal: 'Negative numbers can''t be raised to float powers.' ].
	0 = aNumber ifTrue: [^ self class one].	"Special case of exponent=0"
	1 = aNumber ifTrue: [^ self].	"Special case of exponent=1"
	0 = self ifTrue: [				"Special case of self = 0"
		aNumber < 0
			ifTrue: [^ (ZeroDivide dividend: self) signal]
			ifFalse: [^ self]].
	^ (aNumber * self ln) exp		"Otherwise use logarithms"! !

!Number methodsFor: 'mathematical functions' stamp: ''!
raisedToInteger: t1 
	| t2 t3 |
	t1 negative
		ifTrue: [^ (self raisedToInteger: t1 negated) reciprocal].
	t2 := 1 bitShift: t1 highBit - 1.
	t3 := self class one.
	[(t1 bitAnd: t2)
			= 0
		ifFalse: [t3 := t3 * self].
	t2 := t2 bitShift: -1.
	t2 > 0]
		whileTrue: [t3 := t3 * t3].
	^ t3! !

!Number methodsFor: 'arithmetic' stamp: ''!
reciprocal
	^ 1 / self! !

!Number methodsFor: 'truncation and round off' stamp: ''!
reduce
	^ self! !

!Number methodsFor: 'arithmetic' stamp: ''!
rem: t1 
	^ self - ((self quo: t1)
			* t1)! !

!Number methodsFor: 'truncation and round off' stamp: 'cbc 6/7/2011 22:20'!
roundDownTo: aNumber 
	"Answer the next multiple of aNumber toward negative infinity that is nearest the 
	receiver."
 	"Examples:
		3.1479 roundDownTo: 0.01 -> 3.14
		3.1479 roundDownTo: 0.1 -> 3.1
		1923 roundDownTo: 10 -> 1920
		3.1479 roundDownTo: 0.005 -> 3.145
		-3.1479 roundDownTo: 0.01 -> -3.15"
		
	^(self/aNumber) floor * aNumber! !

!Number methodsFor: 'truncation and round off' stamp: ''!
roundTo: t1 
	^ (self / t1) rounded * t1! !

!Number methodsFor: 'truncation and round off' stamp: 'cbc 6/7/2011 22:21'!
roundUpTo: aNumber 
	"Answer the next multiple of aNumber toward infinity that is nearest the 
	receiver."
 	"Examples:
		3.1479 roundUpTo: 0.01 -> 3.15
		3.1479 roundUpTo: 0.1 -> 3.2
		1923 roundUpTo: 10 -> 1930
		3.1479 roundUpTo: 0.005 -> 3.15
		-3.1479 roundUpTo: 0.01 -> -3.14"

	^(self/aNumber) ceiling * aNumber! !

!Number methodsFor: 'truncation and round off' stamp: ''!
rounded
	^ (self + (self sign / 2)) truncated! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:17'!
second

	^ self sign seconds
! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:57'!
seconds

	^ Duration seconds: self! !

!Number methodsFor: 'mathematical functions' stamp: ''!
sign
	"Answer 1 if the receiver is greater than 0, -1 if less than 0, else 0."

	self > 0 ifTrue: [^1].
	self < 0 ifTrue: [^-1].
	^0! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 9/21/2010 23:24'!
sign: aNumber
	"Return a Number with the same sign as aNumber and same magnitude as self."

	^ aNumber copySignTo: self! !

!Number methodsFor: 'mathematical functions' stamp: ''!
sin
	^ self asFloat sin! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 00:54'!
sinh
	"Answer receivers hyperbolic sine"
	
	^self asFloat sinh! !

!Number methodsFor: 'mathematical functions' stamp: 'jmv 10/11/2011 08:34'!
sqrt
	"Answer the square root of the receiver."

	self subclassResponsibility! !

!Number methodsFor: 'mathematical functions' stamp: ''!
squared
	^ self * self! !

!Number methodsFor: 'printing' stamp: ''!
storeOn: t1 
	self printOn: t1! !

!Number methodsFor: 'printing' stamp: ''!
storeOn: t1 base: t2 
	^ self subclassResponsibility! !

!Number methodsFor: 'printing' stamp: ''!
storeStringBase: t1 
	^ String
		streamContents: [:t2 | self storeOn: t2 base: t1]! !

!Number methodsFor: 'testing' stamp: ''!
strictlyPositive
	^ self > 0! !

!Number methodsFor: 'printing' stamp: ''!
stringForReadout
	^ self rounded printString! !

!Number methodsFor: 'mathematical functions' stamp: ''!
tan
	^ self asFloat tan! !

!Number methodsFor: 'mathematical functions' stamp: 'nice 4/23/2011 00:55'!
tanh
	"Answer receivers hyperbolic tangent"
	
	^self asFloat tanh! !

!Number methodsFor: 'intervals' stamp: ''!
to: t1 
	^ Interval
		from: self
		to: t1
		by: 1! !

!Number methodsFor: 'intervals' stamp: ''!
to: t1 by: t2 
	^ Interval
		from: self
		to: t1
		by: t2! !

!Number methodsFor: 'intervals' stamp: ''!
to: t1 by: t2 do: t3 
	| t4 |
	t4 := self.
	t2 = 0
		ifTrue: [self error: 'step must be non-zero'].
	t2 < 0
		ifTrue: [[t1 <= t4]
				whileTrue: [t3 value: t4.
					t4 := t4 + t2].
			nil]
		ifFalse: [[t1 >= t4]
				whileTrue: [t3 value: t4.
					t4 := t4 + t2].
			nil]! !

!Number methodsFor: 'intervals' stamp: ''!
to: t1 do: t2 
	self
		to: t1
		do: [:t3 | t2 value: t3]! !

!Number methodsFor: 'truncation and round off' stamp: 'cbc 6/7/2011 22:18'!
truncateTo: aNumber 
	"Answer the next multiple of aNumber toward zero that is nearest the 
	receiver."
	"Examples:
		3.1479 truncateTo: 0.01 -> 3.14
		3.1479 truncateTo: 0.1 -> 3.1
		1923 truncateTo: 10 -> 1920
		3.1479 truncateTo: 0.005 -> 3.145
		-3.1479 truncateTo: 0.01 -> -3.14"

	^(self quo: aNumber)
		* aNumber! !

!Number methodsFor: 'truncation and round off' stamp: ''!
truncated
	^ self quo: 1! !

!Number methodsFor: 'converting' stamp: 'brp 1/9/2004 06:19'!
week

	^ self sign weeks
! !

!Number methodsFor: 'converting' stamp: 'brp 5/16/2003 07:57'!
weeks

	^ Duration weeks: self! !

!Number methodsFor: 'converting' stamp: 'nice 4/23/2011 02:25'!
withNegativeSign
	"Answer a number with same magnitude than receiver and negative sign."
	^self abs negated! !

Object subclass: #Message
	instanceVariableNames: 'selector args lookupClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!Message class methodsFor: 'instance creation' stamp: ''!
selector: t1 
	^ self new
		setSelector: t1
		arguments: (Array new: 0)! !

!Message class methodsFor: 'instance creation' stamp: ''!
selector: t1 argument: t2 
	^ self new
		setSelector: t1
		arguments: (Array with: t2)! !

!Message class methodsFor: 'instance creation' stamp: ''!
selector: t1 arguments: t2 
	^ self new setSelector: t1 arguments: t2! !

!Message methodsFor: 'comparing' stamp: ''!
analogousCodeTo: t1 
	^ self class == t1 class
		and: [selector == t1 selector
				and: [args = t1 arguments
						and: [lookupClass == t1 lookupClass]]]! !

!Message methodsFor: 'accessing' stamp: ''!
argument
	^ args at: 1! !

!Message methodsFor: 'accessing' stamp: ''!
argument: t1 
	args at: 1 put: t1! !

!Message methodsFor: 'accessing' stamp: ''!
arguments
	^ args! !

!Message methodsFor: 'stub creation' stamp: ''!
createStubMethod
	| t1 |
	t1 := Set new.
	^ String
		streamContents: [:t2 | 
			self selector keywords
				doWithIndex: [:t3 :t4 | 
					| t5 t6 t7 t8 |
					t2 nextPutAll: t3.
					(t3 last = $:
							or: [self selector isInfix])
						ifTrue: [t7 := self arguments at: t4.
							t8 := (t7 isKindOf: Class)
										ifTrue: ['Class']
										ifFalse: [t7 class name].
							t5 := t8 first isVowel
										ifTrue: ['an']
										ifFalse: ['a'].
							t6 := t5 , t8.
							[t1 includes: t6]
								whileTrue: [t6 := t6 , t4 asString].
							t1 add: t6.
							t2 nextPutAll: ' ';
								 nextPutAll: t6;
								 space]].
			t2 cr; tab.
			t2 nextPutAll: 'self shouldBeImplemented']! !

!Message methodsFor: 'accessing' stamp: ''!
lookupClass
	^ lookupClass! !

!Message methodsFor: 'private' stamp: ''!
lookupClass: t1 
	lookupClass := t1! !

!Message methodsFor: 'accessing' stamp: ''!
numArgs
	^ args size! !

!Message methodsFor: 'printing' stamp: ''!
printOn: t1 
	args isEmpty
		ifTrue: [^ t1 nextPutAll: selector].
	args
		with: selector keywords
		do: [:t2 :t3 | 
			t1 nextPutAll: t3.
			t1 space.
			t2 printOn: t1.
			t1 space].
	t1 skip: -1! !

!Message methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!Message methodsFor: 'sending' stamp: ''!
sendTo: t1 
	^ t1 perform: selector withArguments: args! !

!Message methodsFor: 'accessing' stamp: ''!
sends: t1 
	^ selector == t1! !

!Message methodsFor: 'sending' stamp: ''!
sentTo: t1 
	lookupClass
		ifNil: [^ t1 perform: selector withArguments: args].
	^ t1
		perform: selector
		withArguments: args
		inSuperclass: lookupClass! !

!Message methodsFor: 'private' stamp: ''!
setSelector: t1 
	selector := t1! !

!Message methodsFor: 'private' stamp: ''!
setSelector: t1 arguments: t2 
	selector := t1.
	args := t2! !

!Message methodsFor: 'printing' stamp: ''!
storeOn: t1 
	t1 nextPut: $(;
		 nextPutAll: self class name;
		 nextPutAll: ' selector: ';
		 store: selector;
		 nextPutAll: ' arguments: ';
		 store: args;
		 nextPut: $)! !

Object subclass: #MessageSend
	instanceVariableNames: 'receiver selector arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!MessageSend class methodsFor: 'instance creation' stamp: ''!
receiver: t1 selector: t2 
	^ self
		receiver: t1
		selector: t2
		arguments: #()! !

!MessageSend class methodsFor: 'instance creation' stamp: ''!
receiver: t1 selector: t2 argument: t3 
	^ self
		receiver: t1
		selector: t2
		arguments: (Array with: t3)! !

!MessageSend class methodsFor: 'instance creation' stamp: ''!
receiver: t1 selector: t2 arguments: t3 
	^ self new receiver: t1;
		 selector: t2;
		 arguments: t3! !

!MessageSend methodsFor: 'comparing' stamp: ''!
= t1 
	^ t1 species == self species
		and: [receiver == t1 receiver
				and: [selector == t1 selector
						and: [arguments = t1 arguments]]]! !

!MessageSend methodsFor: 'accessing' stamp: ''!
arguments
	^ arguments! !

!MessageSend methodsFor: 'accessing' stamp: ''!
arguments: t1 
	arguments := t1! !

!MessageSend methodsFor: 'converting' stamp: ''!
asMinimalRepresentation
	^ self! !

!MessageSend methodsFor: 'private' stamp: ''!
collectArguments: t1 
	| t2 |
	t2 := self arguments.
	^ t1 size = t2 size
		ifTrue: [t1]
		ifFalse: [(t2 isEmpty
				ifTrue: [t2 := Array new: selector numArgs]
				ifFalse: [t2 copy])
				replaceFrom: 1
				to: (t1 size min: t2 size)
				with: t1
				startingAt: 1]! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 01:01'!
cull: firstArg
	"Send the message with these optional arguments and answer the return value"

	selector numArgs >= 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 01:01'!
cull: firstArg cull: secondArg
	"Send the message with these optional arguments and answer the return value"

	| numArgs |
	(numArgs := selector numArgs) >= 2 ifTrue: [ ^self value: firstArg value: secondArg ].	
	numArgs = 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 01:03'!
cull: firstArg cull: secondArg cull: thirdArg
	"Send the message with these optional arguments and answer the return value"

	| numArgs |
	(numArgs := selector numArgs) >= 2 ifTrue: [ 
		numArgs >= 3 ifTrue: [ ^self value: firstArg value: secondArg value: thirdArg ].
		^self value: firstArg value: secondArg ].
	numArgs = 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 01:04'!
cull: firstArg cull: secondArg cull: thirdArg cull: fourthArg
	"Send the message with these optional arguments and answer the return value"

	| numArgs |
	(numArgs := selector numArgs) >= 3 ifTrue: [
		numArgs >= 4 ifTrue: [
			^self value: firstArg value: secondArg value: thirdArg value: fourthArg ].
		^self value: firstArg value: secondArg value: thirdArg ].
	numArgs = 2 ifTrue: [ ^self value: firstArg value: secondArg ].	
	numArgs = 1 ifTrue: [ ^self value: firstArg ].
	^self value! !

!MessageSend methodsFor: 'comparing' stamp: ''!
hash
	^ receiver hash bitXor: selector hash! !

!MessageSend methodsFor: 'testing' stamp: ''!
isMessageSend
	^ true! !

!MessageSend methodsFor: 'private' stamp: 'jmv 5/14/2009 09:54'!
isReceiverOrAnyArgumentGarbage
	^false! !

!MessageSend methodsFor: 'accessing' stamp: ''!
numArgs
	^ arguments size! !

!MessageSend methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: self class name;
		 nextPut: $(.
	selector printOn: t1.
	t1 nextPutAll: ' -> '.
	receiver printOn: t1.
	t1 nextPut: $)! !

!MessageSend methodsFor: 'accessing' stamp: ''!
receiver
	^ receiver! !

!MessageSend methodsFor: 'accessing' stamp: ''!
receiver: t1 
	receiver := t1! !

!MessageSend methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!MessageSend methodsFor: 'accessing' stamp: ''!
selector: t1 
	selector := t1! !

!MessageSend methodsFor: 'tiles' stamp: ''!
stringFor: t1 
	| t2 t3 |
	t1 isLiteral
		ifTrue: [^ t1 printString].
	t1 class == Color
		ifTrue: [^ t1 printString].
	t1 class superclass == Boolean
		ifTrue: [^ t1 printString].
	t1 isBlock
		ifTrue: [^ '[''do nothing'']'].
	t1 class isMeta
		ifTrue: [^ t1 name].
	t2 := t1 knownName.
	t3 := t1 uniqueNameForReference.
	t2
		ifNil: [(t1 respondsTo: #renameTo:)
				ifTrue: [t1 renameTo: t3]
				ifFalse: [t3 := t1 storeString]].
	^ t3! !

!MessageSend methodsFor: 'evaluating' stamp: ''!
value
	arguments
		ifNil: [^ receiver perform: selector].
	^ receiver
		perform: selector
		withArguments: (self collectArguments: arguments)! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 00:53'!
value: firstArg
	"Send the message with these arguments and answer the return value"

	^receiver perform: selector with: firstArg! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 00:52'!
value: firstArg value: secondArg
	"Send the message with these arguments and answer the return value"

	^receiver perform: selector with: firstArg with: secondArg! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 00:52'!
value: firstArg value: secondArg value: thirdArg
	"Send the message with these arguments and answer the return value"

	^receiver perform: selector with: firstArg with: secondArg with: thirdArg! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 00:54'!
value: firstArg value: secondArg value: thirdArg value: fourthArg
	"Send the message with these arguments and answer the return value"

	^receiver perform: selector withArguments: { firstArg. secondArg. thirdArg. fourthArg }! !

!MessageSend methodsFor: 'evaluating' stamp: 'jmv 5/14/2009 10:11'!
valueOtherwise: aBlock
	"Send the message and answer the return value"

	^self value! !

!MessageSend methodsFor: 'evaluating' stamp: ''!
valueWithArguments: t1 
	^ receiver
		perform: selector
		withArguments: (self collectArguments: t1)! !

!MessageSend methodsFor: 'evaluating' stamp: 'jmv 5/14/2009 10:22'!
valueWithArguments: anArray otherwise: aBlock

	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: 'evaluating' stamp: ''!
valueWithEnoughArguments: t1 
	| t2 |
	t2 := Array new: selector numArgs.
	t2
		replaceFrom: 1
		to: (arguments size min: t2 size)
		with: arguments
		startingAt: 1.
	t2 size > arguments size
		ifTrue: [t2
				replaceFrom: arguments size + 1
				to: (arguments size + t1 size min: t2 size)
				with: t1
				startingAt: 1].
	^ receiver perform: selector withArguments: t2! !

!MessageSend methodsFor: 'evaluating' stamp: 'ul 3/15/2011 01:54'!
valueWithPossibleArgs: anArray
	"Send selector to the receiver with arguments in anArray. Only use enough arguments for the arity of the selector; supply nils for missing ones."
	
	^receiver perform: selector withEnoughArguments: anArray! !

Object subclass: #MethodFinder
	instanceVariableNames: 'data answers selector argMap thisData mapStage mapList expressions cachedClass cachedArgNum cachedSelectorLists'
	classVariableNames: 'AddAndRemove Approved Blocks Dangerous'
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!MethodFinder class methodsFor: 'as yet unclassified' stamp: ''!
methodFor: t1 
	| t2 t3 |
	t2 := self new load: t1;
				 findMessage.
	t3 := String
				streamContents: [:t4 | t2
						do: [:t5 | t4 nextPut: $(;
								 nextPutAll: t5;
								 nextPut: $);
								 space]].
	^ t3! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
allNumbers
	answers
		do: [:t1 | t1 isNumber
				ifFalse: [^ false]].
	thisData
		do: [:t1 | t1
				do: [:t2 | t2 isNumber
						ifFalse: [^ false]]].
	^ true! !

!MethodFinder methodsFor: 'access' stamp: ''!
answers
	^ answers! !

!MethodFinder methodsFor: 'arg maps' stamp: ''!
argMap
	^ argMap! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
cleanInputs: t1 
	| t2 t3 t4 t6 |
	t6 := t1.
	t4 := false.
	t2 := ReadStream on: t6 , ' '.
	t3 := OrderedCollection new.
	[t2 upToAll: '#true'.
	t2 atEnd]
		whileFalse: [t3 addFirst: t2 position - 4].
	t3
		do: [:t7 | 
			t6 := t6
						copyReplaceFrom: t7
						to: t7
						with: ''.
			t4 := true].
	t2 := ReadStream on: t6.
	t3 := OrderedCollection new.
	[t2 upToAll: '#false'.
	t2 atEnd]
		whileFalse: [t3 addFirst: t2 position - 5].
	t3
		do: [:t7 | 
			t6 := t6
						copyReplaceFrom: t7
						to: t7
						with: ''.
			t4 := true].
	t4
		ifTrue: [self inform: '#(true false) are Symbols, not Booleans.  
Next time use { true. false }.'].
	t4 := false.
	t2 := ReadStream on: t6.
	t3 := OrderedCollection new.
	[t2 upToAll: '#nil'.
	t2 atEnd]
		whileFalse: [t3 addFirst: t2 position - 3].
	t3
		do: [:t7 | 
			t6 := t6
						copyReplaceFrom: t7
						to: t7
						with: ''.
			t4 := true].
	t4
		ifTrue: [self inform: '#nil is a Symbol, not the authentic UndefinedObject.  
Next time use nil instead of #nil'].
	^ t6! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
const
	| t1 |
	((t1 := answers at: 1)
			closeTo: (answers at: 2))
		ifFalse: [^ false].
	3
		to: answers size
		do: [:t2 | (t1
					closeTo: (answers at: t2))
				ifFalse: [^ false]].
	expressions add: '^ ' , t1 printString.
	selector add: #yourself.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constDiv
	| t1 t2 t3 |
	t1 := ((thisData at: 1)
				at: 1)
				// (answers at: 1).
	t3 := (t2 := MethodFinder new copy: self addArg: t1) searchForOne isEmpty not.
	t3
		ifFalse: [^ false].
	t2 expressions
		do: [:t4 | expressions
				add: (t4 copyReplaceAll: 'data2' with: t1 printString)].
	selector addAll: t2 selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constEquiv
	| t1 t2 t3 t4 |
	(answers at: 1) class superclass == Boolean
		ifFalse: [^ false].
	2
		to: answers size
		do: [:t5 | (answers at: t5) class superclass == Boolean
				ifFalse: [^ false]].
	t1 := (thisData at: 1)
				at: 1.
	t3 := (t2 := MethodFinder new copy: self addArg: t1) searchForOne isEmpty not.
	t3
		ifFalse: [(t4 := answers indexOf: (answers at: 1) not) > 0
				ifTrue: [t1 := (thisData at: t4)
								at: 1.
					t3 := (t2 := MethodFinder new copy: self addArg: t1) searchForOne isEmpty not]].
	t3
		ifFalse: [^ false].
	t2 expressions
		do: [:t7 | expressions
				add: (t7 copyReplaceAll: 'data2' with: t1 printString)].
	selector addAll: t2 selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constLinear
	| t1 t2 t3 t4 t5 t6 t7 |
	t4 := ((thisData at: 2)
				at: 1)
				- ((thisData at: 1)
						at: 1).
	t4 = 0
		ifTrue: [^ false].
	t5 := (answers at: 2)
				- (answers at: 1).
	t6 := (t5 asFloat / t4) reduce.
	t7 := ((answers at: 2)
				- (((thisData at: 2)
						at: 1)
						* t6)) reduce.
	t1 := Array with: t7 with: t6.
	t3 := (t2 := MethodFinder new copy: self addArg: t1) searchForOne isEmpty not.
	t3
		ifFalse: [^ false].
	t2 expressions
		do: [:t8 | expressions
				add: (t8 copyReplaceAll: 'data2' with: t1 printString)].
	selector addAll: t2 selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constMod
	| t1 t2 |
	t2 := answers max.
	t2 + 1
		to: t2 + 20
		do: [:t3 | 
			t1 := MethodFinder new copy: self addArg: t3.
			(t1 testPerfect: #\\)
				ifTrue: [expressions add: 'data1 \\ ' , t3 printString.
					selector add: #\\.
					^ true]].
	^ false! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constMult
	| t1 t2 t3 |
	((thisData at: 1)
			at: 1)
			= 0
		ifTrue: [^ false].
	t1 := ((answers at: 1) asFloat
				/ ((thisData at: 1)
						at: 1)) reduce.
	t3 := (t2 := MethodFinder new copy: self addArg: t1) searchForOne isEmpty not.
	t3
		ifFalse: [^ false].
	t2 expressions
		do: [:t4 | expressions
				add: (t4 copyReplaceAll: 'data2' with: t1 printString)].
	selector addAll: t2 selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constPlus
	| t1 t2 t3 |
	t1 := (answers at: 1)
				- ((thisData at: 1)
						at: 1).
	t3 := (t2 := MethodFinder new copy: self addArg: t1) searchForOne isEmpty not.
	t3
		ifFalse: [^ false].
	t2 expressions
		do: [:t4 | expressions
				add: (t4 copyReplaceAll: 'data2' with: t1 printString)].
	selector addAll: t2 selectors.
	^ true! !

!MethodFinder methodsFor: 'find a constant' stamp: ''!
constUsingData1Value
	| t3 |
	(answers at: 1) class superclass == Boolean
		ifFalse: [^ false].
	2
		to: answers size
		do: [:t1 | (answers at: t1) class superclass == Boolean
				ifFalse: [^ false]].
	thisData
		do: [:t5 | 
			| t6 t7 |
			t7 := t5 first.
			t6 := (t3 := MethodFinder new copy: self addArg: t7) searchForOne isEmpty not.
			t6
				ifTrue: [t3 expressions
						do: [:t8 | expressions
								add: (t8 copyReplaceAll: 'data2' with: t7 printString)].
					selector addAll: t3 selectors.
					^ true].
			nil].
	^ false! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
copy: t1 addArg: t2 
	| t3 |
	t3 := Array with: t2.
	data := t1 data
				collect: [:t4 | t4 , t3].
	answers := t1 answers.
	self load: nil! !

!MethodFinder methodsFor: 'access' stamp: ''!
data
	^ data! !

!MethodFinder methodsFor: 'search' stamp: ''!
exceptions
	| t1 |
	answers first isSymbol
		ifFalse: [^ self].
	thisData first first isString
		ifFalse: [^ self].
	t1 := #asSymbol.
	(self testPerfect: t1)
		ifTrue: [selector add: t1.
			expressions
				add: (String
						streamContents: [:t2 | 
							t2 nextPutAll: 'data' , argMap first printString.
							t1 keywords
								doWithIndex: [:t3 :t4 | 
									t2 nextPutAll: ' ' , t3.
									t3 last == $: | t3 first isLetter not
										ifTrue: [t2 nextPutAll: ' data' , (argMap at: t4 + 1) printString]]])]! !

!MethodFinder methodsFor: 'access' stamp: ''!
expressions
	^ expressions! !

!MethodFinder methodsFor: 'search' stamp: ''!
findMessage
	data
		do: [:t1 | (t1 isKindOf: SequenceableCollection)
				ifFalse: [^ OrderedCollection with: 'first and third items are not Arrays']].
	Approved
		ifNil: [self initialize].
	expressions := OrderedCollection new.
	self search: true.
	expressions isEmpty
		ifTrue: [^ OrderedCollection with: 'no single method does that function'].
	expressions isString
		ifTrue: [^ OrderedCollection with: expressions].
	^ expressions! !

!MethodFinder methodsFor: 'initialize' stamp: 'cmm 5/2/2011 19:51'!
initialize
	"The methods we are allowed to use.  (MethodFinder new initialize) "

	Approved := Set new.
	AddAndRemove := Set new.
	Blocks := Set new.
	"These modify an argument and are not used by the MethodFinder: longPrintOn: printOn: storeOn: sentTo: storeOn:base: printOn:base: absPrintExactlyOn:base: absPrintOn:base: absPrintOn:base:digitCount: writeOn: writeScanOn: possibleVariablesFor:continuedFrom: printOn:format:"

"Object"  
	#("in class, instance creation" categoryForUniclasses chooseUniqueClassName initialInstance isSystemDefined newFrom: officialClass readCarefullyFrom:
"accessing" at: basicAt: basicSize bindWithTemp: in: size yourself 
"testing" basicType ifNil: ifNil:ifNotNil: ifNotNil: ifNotNil:ifNil: isColor isFloat isFraction isInMemory isInteger isMorph isNil isNumber isPoint isPseudoContext isText isTransparent isWebBrowser knownName notNil pointsTo: wantsSteps 
"comparing" = == closeTo: hash identityHash identityHashPrintString ~= ~~ 
"copying" clone copy shallowCopy 
"dependents access" canDiscardEdits dependents hasUnacceptedEdits 
"updating" changed changed: okToChange update: windowIsClosing 
"printing" fullPrintString isLiteral longPrintString printString storeString stringForReadout stringRepresentation 
"class membership" class isKindOf: isKindOf:orOf: isMemberOf: respondsTo: xxxClass 
"error handling" 
"user interface" addModelMenuItemsTo:forMorph:hand: defaultBackgroundColor defaultLabelForInspector fullScreenSize initialExtent modelWakeUp mouseUpBalk: newTileMorphRepresentative windowActiveOnFirstClick windowReqNewLabel: 
"system primitives" asOop instVarAt: instVarNamed: 
"private" 
"associating" -> 
"converting" as: asOrderedCollection asString 
"casing" caseOf: caseOf:otherwise: 
"binding" bindingOf: 
"macpal" contentsChanged currentEvent currentHand currentWorld flash instanceVariableValues scriptPerformer 
"flagging" flag: 
"translation support" "objects from disk" "finalization" ) do: [:sel | Approved add: sel].
	#(at:add: at:modify: at:put: basicAt:put: "NOT instVar:at:"
"message handling" perform: perform:orSendTo: perform:with: perform:with:with: perform:with:with:with: perform:withArguments: perform:withArguments:inSuperclass: 
) do: [:sel | AddAndRemove add: sel].

"Boolean, True, False, UndefinedObject"  
	#("logical operations" & eqv: not xor: |
"controlling" and: ifFalse: ifFalse:ifTrue: ifTrue: ifTrue:ifFalse: or:
"copying" 
"testing" isEmptyOrNil) do: [:sel | Approved add: sel].

"Behavior" 
	#("initialize-release"
"accessing" compilerClass decompilerClass evaluatorClass format methodDict parserClass sourceCodeTemplate subclassDefinerClass
"testing" instSize instSpec isBits isBytes isFixed isPointers isVariable isWeak isWords
"copying"
"printing" defaultNameStemForInstances printHierarchy
"creating class hierarchy"
"creating method dictionary"
"instance creation" basicNew basicNew: new new:
"accessing class hierarchy" allSubclasses allSubclassesWithLevelDo:startingLevel: allSuperclasses subclasses superclass withAllSubclasses withAllSuperclasses
"accessing method dictionary" allSelectors changeRecordsAt: compiledMethodAt: compiledMethodAt:ifAbsent: firstCommentAt: lookupSelector: selectors selectorsDo: selectorsWithArgs: "slow but useful ->" sourceCodeAt: sourceCodeAt:ifAbsent: sourceMethodAt: sourceMethodAt:ifAbsent:
"accessing instances and variables" allClassVarNames allInstVarNames allSharedPools classVarNames instVarNames instanceCount sharedPools someInstance subclassInstVarNames
"testing class hierarchy" inheritsFrom: kindOfSubclass
"testing method dictionary" canUnderstand: classThatUnderstands: hasMethods includesSelector: whichClassIncludesSelector: whichSelectorsAccess: whichSelectorsReferTo: whichSelectorsReferTo:special:byte: whichMethodsStoreInto:
"enumerating"
"user interface"
"private" indexIfCompact) do: [:sel | Approved add: sel].

"ClassDescription"
	#("initialize-release" 
"accessing" classVersion isMeta name theNonMetaClass
"copying" 
"printing" classVariablesString instanceVariablesString sharedPoolsString
"instance variables" checkForInstVarsOK: 
"method dictionary" 
"organization" category organization whichCategoryIncludesSelector:
"compiling" acceptsLoggingOfCompilation wantsChangeSetLogging
"fileIn/Out" definition
"private" ) do: [:sel | Approved add: sel].

"Class"
	#("initialize-release" 
"accessing" classPool
"testing"
"copying" 
"class name" 
"instance variables" 
"class variables" classVarAt: classVariableAssociationAt:
"pool variables" 
"compiling" 
"subclass creation" 
"fileIn/Out" ) do: [:sel | Approved add: sel]. 

"Metaclass"
	#("initialize-release" 
"accessing" isSystemDefined soleInstance
"copying" "instance creation" "instance variables"  "pool variables" "class hierarchy"  "compiling"
"fileIn/Out"  nonTrivial ) do: [:sel | Approved add: sel].

"Context, BlockContext"
	#(receiver client method receiver tempAt: 
"debugger access" pc selector sender shortStack sourceCode tempNames tempsAndValues
"controlling"  "printing" "system simulation" 
"initialize-release" 
"accessing" hasMethodReturn home numArgs
"evaluating" value value:ifError: value:value: value:value:value: value:value:value:value: valueWithArguments:
"controlling"  "scheduling"  "instruction decoding"  "printing" "private"  "system simulation" ) do: [:sel | Approved add: sel].
	#(value: "<- Association has it as a store" ) do: [:sel | AddAndRemove add: sel].

"Message"
	#("inclass, instance creation" selector: selector:argument: selector:arguments:
"accessing" argument argument: arguments sends:
"printing" "sending" ) do: [:sel | Approved add: sel].
	#("private" setSelector:arguments:) do: [:sel | AddAndRemove add: sel].

"Magnitude"
	#("comparing" < <= > >= between:and:
"testing" max: min: min:max: ) do: [:sel | Approved add: sel].

"Date, Time"
	#("in class, instance creation" fromDays: fromSeconds: fromString: newDay:month:year: newDay:year: today
	"in class, general inquiries" dateAndTimeNow dayOfWeek: daysInMonth:forYear: daysInYear: firstWeekdayOfMonth:year: indexOfMonth: leapYear: nameOfDay: nameOfMonth:
"accessing" day leap monthIndex monthName weekday year
"arithmetic" addDays: subtractDate: subtractDays:
"comparing"
"inquiries" dayOfMonth daysInMonth daysInYear daysLeftInYear firstDayOfMonth previous:
"converting" asSeconds
"printing"  mmddyyyy printFormat: 
"private" weekdayIndex 
	"in class, instance creation" fromSeconds: now 
	"in class, general inquiries" dateAndTimeFromSeconds: dateAndTimeNow millisecondClockValue millisecondsToRun: totalSeconds
"accessing" hours minutes seconds
"arithmetic" addTime: subtractTime:
"comparing"
"printing" intervalString print24 
"converting") do: [:sel | Approved add: sel].
	#("private" 
		 ) do: [:sel | AddAndRemove add: sel].

"Number"
	#("in class" readFrom:base: 
"arithmetic" * + - / // \\ abs negated quo: reciprocal rem:
"mathematical functions" arcCos arcSin arcTan arcTan: cos exp floorLog: ln log log: raisedTo: raisedToInteger: sin sqrt squared tan
"truncation and round off" ceiling detentBy:atMultiplesOf:snap: floor roundTo: roundUpTo: rounded truncateTo: truncated
"comparing"
"testing" even isDivisibleBy: isInfinite isNaN isZero negative odd positive sign strictlyPositive
"converting" @ asInteger asNumber asPoint asSmallAngleDegrees degreesToRadians radiansToDegrees
"intervals" to: to:by: 
"printing" printStringBase: storeStringBase: ) do: [:sel | Approved add: sel].

"Integer"
	#("in class" primesUpTo:
"testing" isPowerOfTwo
"arithmetic" alignedTo:
"comparing"
"truncation and round off" atRandom normalize
"enumerating" timesRepeat:
"mathematical functions" degreeCos degreeSin factorial gcd: lcm: take:
"bit manipulation" << >> allMask: anyMask: bitAnd: bitClear: bitInvert bitInvert32 bitOr: bitShift: bitXor: lowBit noMask:
"converting" asCharacter asColorOfDepth: asFloat asFraction asHexDigit
"printing" asStringWithCommas hex hex8 radix:
"system primitives" lastDigit replaceFrom:to:with:startingAt:
"private" "benchmarks" ) do: [:sel | Approved add: sel].

"SmallInteger, LargeNegativeInteger, LargePositiveInteger"
	#("arithmetic" "bit manipulation" highBit "testing" "comparing" "copying" "converting" "printing" 
"system primitives" digitAt: digitLength 
"private" fromString:radix: ) do: [:sel | Approved add: sel].
	#(digitAt:put: ) do: [:sel | AddAndRemove add: sel].

"Float"
	#("arithmetic"
"mathematical functions" reciprocalFloorLog: reciprocalLogBase2 timesTwoPower:
"comparing" "testing"
"truncation and round off" exponent fractionPart integerPart significand significandAsInteger
"converting" asApproximateFraction asIEEE32BitWord asTrueFraction
"copying") do: [:sel | Approved add: sel].

"Fraction, Random"
	#(denominator numerator reduced next nextValue) do: [:sel | Approved add: sel].
	#(setNumerator:denominator:) do: [:sel | AddAndRemove add: sel].

"Collection"
	#("accessing" anyOne
"testing" includes: includesAllOf: includesAnyOf: includesSubstringAnywhere: isEmpty isSequenceable occurrencesOf:
"enumerating" collect: collect:thenSelect: count: detect: detect:ifNone: detectMax: detectMin: detectSum: inject:into: reject: select: select:thenCollect: intersection:
"converting" asBag asCharacterSet asSet asSortedArray asSortedCollection asSortedCollection:
"printing"
"private" maxSize
"arithmetic"
"math functions" average max median min range sum) do: [:sel | Approved add: sel].
	#("adding" add: addAll: addIfNotPresent:
"removing" remove: remove:ifAbsent: removeAll: removeAllFoundIn: removeAllSuchThat: remove:ifAbsent:) do: [:sel | AddAndRemove add: sel].

"SequenceableCollection"
	#("comparing" hasEqualElements:
"accessing" allButFirst allButLast at:ifAbsent: atAll: atPin: atRandom: atWrap: fifth first fourth identityIndexOf: identityIndexOf:ifAbsent: indexOf: indexOf:ifAbsent: indexOf:startingAt:ifAbsent: indexOfSubCollection:startingAt: indexOfSubCollection:startingAt:ifAbsent: last second sixth third
"removing"
"copying" , copyAfterLast: copyAt:put: copyFrom:to: copyReplaceAll:with: copyReplaceFrom:to:with: copyUpTo: copyUpToLast: copyWith: copyWithout: copyWithoutAll: forceTo:paddingWith: shuffled sortBy:
"enumerating" collectWithIndex: findFirst: findLast: pairsCollect: with:collect: withIndexCollect: polynomialEval:
"converting" asArray asDictionary asFloatArray asIntegerArray asStringWithCr asWordArray reversed
"private" copyReplaceAll:with:asTokens: ) do: [:sel | Approved add: sel].
	#( swap:with:) do: [:sel | AddAndRemove add: sel].

"ArrayedCollection, Bag"
	#("private" defaultElement 
"sorting" isSorted
"accessing" cumulativeCounts sortedCounts sortedElements "testing" "adding" add:withOccurrences: "removing" "enumerating" 
	) do: [:sel | Approved add: sel].
	#( mergeSortFrom:to:by: sort sort: add: add:withOccurrences:
"private" setDictionary ) do: [:sel | AddAndRemove add: sel].

"Other messages that modify the receiver"
	#(atAll:put: atAll:putAll: atAllPut: atWrap:put: replaceAll:with: replaceFrom:to:with:  removeFirst removeLast) do: [:sel | AddAndRemove add: sel].

	self initialize2.

"
MethodFinder new initialize.
MethodFinder new organizationFiltered: Set
"

! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
initialize2
	#(#sizeFor: #array #scanFor: #someElement )
		do: [:t1 | Approved add: t1].
	#(#associationAt: #associationAt:ifAbsent: #at:ifPresent: #keyAtIdentityValue: #keyAtIdentityValue:ifAbsent: #keyAtValue: #keyAtValue:ifAbsent: #keys #includesKey: )
		do: [:t1 | Approved add: t1].
	#(#removeKey: #removeKey:ifAbsent: )
		do: [:t1 | AddAndRemove add: t1].
	#(#from:to: #from:to:by: #contents )
		do: [:t1 | Approved add: t1].
	#(#addFirst: #addLast: )
		do: [:t1 | AddAndRemove add: t1].
	#(#after: #before: #copyEmpty #growSize #sortBlock )
		do: [:t1 | Approved add: t1].
	#(#add:after: #add:afterIndex: #add:before: #addAllFirst: #addAllLast: #addFirst: #addLast: #removeAt: #removeFirst #removeLast #sortBlock: )
		do: [:t1 | AddAndRemove add: t1].
	#(#allCharacters #digitValue: #new #separators #backspace #cr #enter #lf #linefeed #nbsp #newPage #space #tab #alphabet #characterTable #asciiValue #digitValue #isAlphaNumeric #isDigit #isLetter #isLowercase #isSafeForHTTP #isSeparator #isSpecial #isUppercase #isVowel #tokenish #asIRCLowercase #asLowercase #asUppercase )
		do: [:t1 | Approved add: t1].
	#(#crlf #fromPacked: #findFirstInString:inSet:startingAt: #indexOfAscii:inString:startingAt: #valueOfHtmlEntity: #byteAt: #endsWithDigit #findAnySubStr:startingAt: #findBetweenSubStrs: #findDelimiters:startingAt: #findString:startingAt: #findString:startingAt:caseSensitive: #findTokens: #findTokens:includes: #findTokens:keep: #includesSubString: #includesSubstring:caseSensitive: #indexOf:startingAt: #indexOfAnyOf: #indexOfAnyOf:ifAbsent: #indexOfAnyOf:startingAt: #indexOfAnyOf:startingAt:ifAbsent: #lineCorrespondingToIndex: #lineCount #lineNumber: #skipAnySubStr:startingAt: #skipDelimiters:startingAt: #startsWithDigit #alike: #beginsWith: #caseSensitiveLessOrEqual: #charactersExactlyMatching: #compare: #crc16 #endsWith: #endsWithAnyOf: #sameAs: #startingAt:match:startingAt: #copyReplaceTokens:with: #padded:to:with: #asByteArray #asDate #asDisplayText #asFileName #asHtml #asLegalSelector #asPacked #asParagraph #asText #asTime #asUnHtml #asUrl #asUrlRelativeTo: #capitalized #compressWithTable: #contractTo: #correctAgainst: #encodeForHTTP #initialIntegerOrNil #keywords #quoted #sansPeriodSuffix #splitInteger #stemAndNumericSuffix #substrings #surroundedBySingleQuotes #truncateWithElipsisTo: #withBlanksTrimmed #withFirstCharacterDownshifted #withNoLineLongerThan: #withSeparatorsCompacted #withoutLeadingDigits #withoutTrailingBlanks #compare:with:collated: #withCRs #decodeMimeHeader #decodeQuotedPrintable #unescapePercents #withInternetLineEndings #withSqueakLineEndings #withoutQuoting #isAllSeparators #lastSpacePosition #indentationIfBlank: )
		do: [:t1 | Approved add: t1].
	#(#byteAt:put: #translateToLowercase #match: )
		do: [:t1 | AddAndRemove add: t1].
	#(#hasInterned:ifTrue: #morePossibleSelectorsFor: #possibleSelectorsFor: #selectorsContaining: #thatStarts:skipping: #isInfix #isKeyword #isPvtSelector #isUnary )
		do: [:t1 | Approved add: t1].
	#(#evalStrings #hasLiteralSuchThat: )
		do: [:t1 | Approved add: t1].
	#(#at:at: #atCol: #atCol:put: #atRow: #extent #extent:fromArray: #height #width #width:height:type: )
		do: [:t1 | Approved add: t1].
	#(#at:at:add: #at:at:put: #atRow:put: )
		do: [:t1 | AddAndRemove add: t1].
	#(#doubleWordAt: #wordAt: #longAt:bigEndian: #shortAt:bigEndian: #unsignedLongAt:bigEndian: #unsignedShortAt:bigEndian: )
		do: [:t1 | Approved add: t1].
	#(#doubleWordAt:put: #wordAt:put: #longAt:put:bigEndian: #shortAt:put:bigEndian: #unsignedLongAt:put:bigEndian: #unsignedShortAt:put:bigEndian: )
		do: [:t1 | AddAndRemove add: t1].
	false
		ifTrue: [#(#*= #+= #-= #/= #primAddArray: #primAddScalar: #primDivArray: #primDivScalar: #primMulArray: #primMulScalar: #primSubArray: #primSubScalar: #primAddArray:withArray:from:to: #primMulArray:withArray:from:to: #primSubArray:withArray:from:to: )
				do: [:t1 | Approved add: t1]].
	#(#runs:values: #scanFrom: #runLengthAt: #runs #values )
		do: [:t1 | Approved add: t1].
	#(#coalesce #addLast:times: #repeatLast:ifEmpty: #repeatLastIfEmpty: )
		do: [:t1 | AddAndRemove add: t1].
	#(#atEnd )
		do: [:t1 | Approved add: t1].
	#(#next: #nextMatchAll: #nextMatchFor: #upToEnd #next:put: #nextPut: #nextPutAll: #print: #printHtml: )
		do: [:t1 | AddAndRemove add: t1].
	#(#contentsOfEntireFile #originalContents #peek #peekFor: #position )
		do: [:t1 | Approved add: t1].
	#(#nextDelimited: #nextLine #upTo: #position: #reset #resetContents #setToEnd #skip: #skipTo: #upToAll: )
		do: [:t1 | AddAndRemove add: t1].
	#(#closed )
		do: [:t1 | Approved add: t1].
	#(#next: #on: )
		do: [:t1 | AddAndRemove add: t1].
	#(#on:from:to: #with: #with:from:to: )
		do: [:t1 | Approved add: t1].
	#(#resetToStart #crtab #crtab: )
		do: [:t1 | AddAndRemove add: t1].
	#(#key #nextLink )
		do: [:t1 | Approved add: t1].
	#(#key: #key:value: #nextLink: )
		do: [:t1 | AddAndRemove add: t1].
	#(#r:degrees: #x:y: #x #y #degrees #r #theta #bearingToPoint: #crossProduct: #dist: #dotProduct: #eightNeighbors #flipBy:centerAt: #fourNeighbors #grid: #nearestPointAlongLineFrom:to: #nearestPointOnLineFrom:to: #normal #normalized #octantOf: #onLineFrom:to: #onLineFrom:to:within: #quadrantOf: #rotateBy:centerAt: #transposed #unitVector #asFloatPoint #asIntegerPoint #corner: #extent: #rect: #adhereTo: #rotateBy:about: #scaleBy: #scaleFrom:to: #translateBy: #interpolateTo:at: )
		do: [:t1 | Approved add: t1].
	#(#center:extent: #encompassing: #left:right:top:bottom: #merging: #origin:corner: #origin:extent: #area #bottom #bottomCenter #bottomLeft #bottomRight #boundingBox #center #corner #corners #innerCorners #left #leftCenter #origin #right #rightCenter #top #topCenter #topLeft #topRight #adjustTo:along: #amountToTranslateWithin: #areasOutside: #bordersOn:along: #encompass: #expandBy: #extendBy: #forPoint:closestSideDistLen: #insetBy: #insetOriginBy:cornerBy: #intersect: #merge: #pointNearestTo: #quickMerge: #rectanglesAt:height: #sideNearestTo: #translatedToBeWithin: #withBottom: #withHeight: #withLeft: #withRight: #withSide:setTo: #withTop: #withWidth: #containsPoint: #containsRect: #hasPositiveExtent #intersects: #isTall #isWide #align:with: #centeredBeneath: #newRectFrom: #squishedWithin: )
		do: [:t1 | Approved add: t1].
	#(#colorFrom: #colorFromPixelValue:depth: #fromRgbTriplet: #gray: #h:s:v: #r:g:b: #r:g:b:alpha: #r:g:b:range: #black #blue #brown #cyan #darkGray #gray #green #lightBlue #lightBrown #lightCyan #lightGray #lightGreen #lightMagenta #lightOrange #lightRed #lightYellow #magenta #orange #red #transparent #veryDarkGray #veryLightGray #veryVeryDarkGray #veryVeryLightGray #white #yellow #colorNames #indexedColors #pixelScreenForDepth: #quickHighLight: #alpha #blue #brightness #green #hue #luminance #red #saturation #isBitmapFill #isBlack #isGray #isSolidFill #isTranslucent #isTranslucentColor #alpha: #dansDarker #darker #lighter #mixed:with: #muchLighter #slightlyDarker #slightlyLighter #veryMuchLighter #alphaMixed:with: #darkShades: #lightShades: #mix:shades: #wheel: #shortPrintString #colorForInsets #rgbTriplet #asB3DColor #asColor #balancedPatternForDepth: #bitPatternForDepth: #closestPixelValue1 #closestPixelValue2 #closestPixelValue4 #closestPixelValue8 #dominantColor #halfTonePattern1 #halfTonePattern2 #indexInMap: #pixelValueForDepth: #pixelWordFor:filledWith: #pixelWordForDepth: #scaledPixelValue32 #privateAlpha #privateBlue #privateGreen #privateRGB #privateRed )
		do: [:t1 | Approved add: t1].
	#(#(#timesRepeat: 1 ) #(#indexOf:ifAbsent: 2 ) #(#pairsCollect: 1 ) #(#mergeSortFrom:to:by: 3 ) #(#ifNotNil:ifNil: 1 ) #(#ifNotNil:ifNil: 2 ) #(#ifNil: 1 ) #(#at:ifAbsent: 2 ) #(#ifNil:ifNotNil: 1 ) #(#ifNil:ifNotNil: 2 ) #(#ifNotNil: 1 ) #(#at:modify: 2 ) #(#identityIndexOf:ifAbsent: 2 ) #(#sort: 1 ) #(#sortBlock: 1 ) #(#detectMax: 1 ) #(#repeatLastIfEmpty: 1 ) #(#allSubclassesWithLevelDo:startingLevel: 1 ) #(#keyAtValue:ifAbsent: 2 ) #(#in: 1 ) #(#ifTrue: 1 ) #(#or: 1 ) #(#select: 1 ) #(#inject:into: 2 ) #(#forPoint:closestSideDistLen: 2 ) #(#value:ifError: 2 ) #(#selectorsDo: 1 ) #(#removeAllSuchThat: 1 ) #(#keyAtIdentityValue:ifAbsent: 2 ) #(#detectMin: 1 ) #(#detect:ifNone: 1 ) #(#ifTrue:ifFalse: 1 ) #(#ifTrue:ifFalse: 2 ) #(#detect:ifNone: 2 ) #(#hasLiteralSuchThat: 1 ) #(#indexOfAnyOf:ifAbsent: 2 ) #(#reject: 1 ) #(#newRectFrom: 1 ) #(#removeKey:ifAbsent: 2 ) #(#at:ifPresent: 2 ) #(#associationAt:ifAbsent: 2 ) #(#withIndexCollect: 1 ) #(#repeatLast:ifEmpty: 2 ) #(#findLast: 1 ) #(#indexOf:startingAt:ifAbsent: 3 ) #(#remove:ifAbsent: 2 ) #(#ifFalse:ifTrue: 1 ) #(#ifFalse:ifTrue: 2 ) #(#caseOf:otherwise: 2 ) #(#count: 1 ) #(#collect: 1 ) #(#sortBy: 1 ) #(#and: 1 ) #(#asSortedCollection: 1 ) #(#with:collect: 2 ) #(#sourceCodeAt:ifAbsent: 2 ) #(#detect: 1 ) #(#collectWithIndex: 1 ) #(#compiledMethodAt:ifAbsent: 2 ) #(#bindWithTemp: 1 ) #(#detectSum: 1 ) #(#indexOfSubCollection:startingAt:ifAbsent: 3 ) #(#findFirst: 1 ) #(#sourceMethodAt:ifAbsent: 2 ) #(#collect:thenSelect: 1 ) #(#collect:thenSelect: 2 ) #(#select:thenCollect: 1 ) #(#select:thenCollect: 2 ) #(#ifFalse: 1 ) #(#indexOfAnyOf:startingAt:ifAbsent: 3 ) #(#indentationIfBlank: 1 ) )
		do: [:t1 | Blocks add: t1].
	self initialize3! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
initialize3
	#(#asWords #threeDigitName )
		do: [:t1 | Approved add: t1]! !

!MethodFinder methodsFor: 'search' stamp: ''!
insertConstants
	thisData size >= 2
		ifFalse: [^ false].
	(thisData at: 1) size = 1
		ifFalse: [^ false].
	self const
		ifTrue: [^ true].
	self constUsingData1Value
		ifTrue: [^ true].
	self allNumbers
		ifFalse: [^ false].
	self constMod
		ifTrue: [^ true].
	self constPlus
		ifTrue: [^ true].
	self constMult
		ifTrue: [^ true].
	self constDiv
		ifTrue: [^ true].
	self constLinear
		ifTrue: [^ true].
	^ false! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
load: t1 
	t1
		ifNotNil: [data := Array new: t1 size // 2.
			1
				to: data size
				do: [:t2 | data
						at: t2
						put: (t1 at: t2 * 2 - 1)].
			answers := Array new: data size.
			1
				to: answers size
				do: [:t4 | answers
						at: t4
						put: (t1 at: t4 * 2)]].
	data
		do: [:t6 | (t6 isKindOf: SequenceableCollection)
				ifFalse: [^ self inform: 'first and third items are not Arrays']].
	argMap := (1 to: data first size) asArray.
	data
		do: [:t6 | t6 size = argMap size
				ifFalse: [self inform: 'data arrays must all be the same size']].
	argMap size > 4
		ifTrue: [self inform: 'No more than a receiver and 
three arguments allowed'].
	thisData := data copy.
	mapStage := mapList := nil! !

!MethodFinder methodsFor: 'arg maps' stamp: ''!
makeAllMaps
	| t1 |
	mapList := Array new: argMap size factorial.
	t1 := 1.
	argMap
		permutationsDo: [:t3 | 
			mapList at: t1 put: t3 copy.
			t1 := t1 + 1].
	mapStage := 1! !

!MethodFinder methodsFor: 'arg maps' stamp: ''!
mapData
	thisData := data
				collect: [:t1 | argMap
						collect: [:t2 | t1 at: t2]]! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
noteDangerous
	Dangerous := Set new.
	#(#addInstanceVarNamed:withValue: #haltIfNil #copyAddedStateFrom: #veryDeepCopy #veryDeepCopyWith: #veryDeepFixupWith: #veryDeepInner: #addDependent: #evaluate:wheneverChangeIn: #codeStrippedOut: #playSoundNamed: #isThisEverCalled #isThisEverCalled: #logEntry #logExecution #logExit )
		do: [:t1 | Dangerous add: t1].
	#(#cannotInterpret: #caseError #confirm: #confirm:orCancel: #doesNotUnderstand: #error: #halt #halt: #notify: #notify:at: #primitiveFailed #shouldNotImplement #subclassResponsibility )
		do: [:t1 | Dangerous add: t1].
	#(#basicInspect #beep #inform: #inspect #inspectWithLabel: #notYetImplemented #inspectElement )
		do: [:t1 | Dangerous add: t1].
	#(#become: #becomeForward: #instVarAt:put: #instVarNamed:put: #nextInstance #nextObject #rootStubInImageSegment: #someObject #tryPrimitive:withArgs: )
		do: [:t1 | Dangerous add: t1].
	#(#errorImproperStore #errorNonIntegerIndex #errorNotIndexable #errorSubscriptBounds: #mustBeBoolean #primitiveError: #species #storeAt:inTempFrame: )
		do: [:t1 | Dangerous add: t1].
	#(#cCode: #cCode:inSmalltalk: #cCoerce:to: #export: #inline: #returnTypeC: #sharedCodeNamed:inCase: #var:declareC: )
		do: [:t1 | Dangerous add: t1].
	#(#comeFullyUpOnReload: #objectForDataStream: #readDataFrom:size: #rehash #saveOnFile #storeDataOn: #actAsExecutor #executor #finalize #retryWithGC:until: #suspend )
		do: [:t1 | Dangerous add: t1].
	#()
		do: [:t1 | Dangerous add: t1].
	#(#obsolete #confirmRemovalOf: #copyOfMethodDictionary #literalScannedAs:notifying: #storeLiteral:on: #addSubclass: #removeSubclass: #superclass: #addSelector:withMethod: #compile: #compile:notifying: #compileAll #compileAllFrom: #compress #decompile: #defaultSelectorForMethod: #methodDictionary: #recompile:from: #recompileChanges #removeSelector: #compressedSourceCodeAt: #selectorAtMethod:setClass: #allInstances #allSubInstances #inspectAllInstances #inspectSubInstances #thoroughWhichSelectorsReferTo:special:byte: #allInstancesDo: #allSubInstancesDo: #allSubclassesDo: #allSuperclassesDo: #selectSubclasses: #selectSuperclasses: #subclassesDo: #withAllSubclassesDo: #crossReference #removeUninstantiatedSubclassesSilently #unreferencedInstanceVariables #becomeCompact #becomeUncompact #flushCache #format:variable:words:pointers: #format:variable:words:pointers:weak: #printSubclassesOn:level: #basicRemoveSelector: #addSelector:withMethod:notifying: #addSelectorSilently:withMethod: )
		do: [:t1 | Dangerous add: t1].
	#(#defaultSelector )
		do: [:t1 | Dangerous add: t1].
	#(#do: #associationsDo: #adaptToCollection:andSend: #adaptToNumber:andSend: #adaptToPoint:andSend: #adaptToString:andSend: #instVarAt:put: #asDigitsToPower:do: #combinations:atATimeDo: #doWithIndex: #pairsDo: #permutationsDo: #reverseDo: #reverseWith:do: #with:do: #withIndexDo: #asDigitsAt:in:do: #combinationsAt:in:after:do: #errorOutOfBounds #permutationsStartingAt:do: #fromUser )
		do: [:t1 | Dangerous add: t1].
	#(#fileOutPrototype #addSpareFields #makeFileOutFile )
		do: [:t1 | Dangerous add: t1].
	#(#recompile:from: #recompileAllFrom: #recompileChanges #asPrototypeWithFields: #asPrototype #addInstanceVarNamed:withValue: #addInstanceVariable #addClassVarName: #removeClassVarName: #findOrAddClassVarName: #instanceVariableNames: )
		do: [:t1 | Dangerous add: t1]! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
organizationFiltered: t1 
	| t2 t3 |
	t2 := t1 organization deepCopy.
	Dangerous
		do: [:t4 | t2 removeElement: t4].
	Approved
		do: [:t4 | t2 removeElement: t4].
	AddAndRemove
		do: [:t4 | t2 removeElement: t4].
	t3 := t2 printString copyWithout: $(.
	t3 := '('
				, (t3 copyWithout: $)).
	t3 := t3 replaceAll: $' with: $".
	^ t3! !

!MethodFinder methodsFor: 'arg maps' stamp: ''!
permuteArgs
	data first size <= 1
		ifTrue: [^ false].
	mapList
		ifNil: [self makeAllMaps].
	mapStage := mapStage + 1.
	mapStage > mapList size
		ifTrue: [^ false].
	argMap := mapList at: mapStage.
	self mapData.
	^ true! !

!MethodFinder methodsFor: 'search' stamp: ''!
search: t1 
	selector := OrderedCollection new.
	self simpleSearch.
	t1 not & selector isEmpty not
		ifTrue: [^ selector].
	[self permuteArgs]
		whileTrue: [self simpleSearch.
			t1 not & selector isEmpty not
				ifTrue: [^ selector]].
	self insertConstants.
	^ #()! !

!MethodFinder methodsFor: 'search' stamp: ''!
searchForOne
	expressions := OrderedCollection new.
	self search: false.
	^ expressions! !

!MethodFinder methodsFor: 'access' stamp: ''!
selectors
	^ selector! !

!MethodFinder methodsFor: 'search' stamp: ''!
simpleSearch
	| t1 t2 t3 |
	self exceptions.
	t1 := thisData first first class.
	(t1 == cachedClass
			and: [cachedArgNum = (argMap size - 1)])
		ifTrue: [t3 := cachedSelectorLists]
		ifFalse: [t2 := t1 withAllSuperclasses.
			t3 := OrderedCollection new.
			t2
				do: [:t4 | t3
						add: (t4 selectorsWithArgs: argMap size - 1)].
			cachedClass := t1.
			cachedArgNum := argMap size - 1.
			cachedSelectorLists := t3].
	t3
		do: [:t4 | t4
				do: [:t5 | (selector includes: t5)
						ifFalse: [((Approved includes: t5)
									or: [AddAndRemove includes: t5])
								ifTrue: [(self testPerfect: t5)
										ifTrue: [selector add: t5.
											expressions
												add: (String
														streamContents: [:t6 | 
															t6 nextPutAll: 'data' , argMap first printString.
															t5 keywords
																doWithIndex: [:t7 :t8 | 
																	t6 nextPutAll: ' ' , t7.
																	t7 last == $: | t7 first isLetter not
																		ifTrue: [t6 nextPutAll: ' data' , (argMap at: t8 + 1) printString]]])]]]]]! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
test2: t1 
	t1
		do: [:t2 | 
			t2 class == Association
				ifTrue: [(#('true' '$a' '2' 'false' ) includes: t2 value printString)
						ifFalse: [self error: 'bad assn'].
					(#('3' '5.6' 'x' '''abcd''' ) includes: t2 key printString)
						ifFalse: [self error: 'bad assn']].
			t2 class == Array
				ifTrue: [t2
						do: [:t3 | 
							t3 isString
								ifTrue: [t3 first asciiValue < 32
										ifTrue: [self error: 'store into string in data']].
							t3 class == Association
								ifTrue: [t3 value class == Association
										ifTrue: [self error: 'bad assn']]]].
			t2 class == Date
				ifTrue: [t2 year isInteger
						ifFalse: [self error: 'stored into input date!!!!']].
			t2 class == Dictionary
				ifTrue: [t2 size > 0
						ifTrue: [self error: 'store into dictionary']].
			t2 class == OrderedCollection
				ifTrue: [t2 size > 4
						ifTrue: [self error: 'store into OC']]]! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
test3
	(#x at: 1) asciiValue = 120
		ifFalse: [self error: 'Character table mod']! !

!MethodFinder methodsFor: 'initialize' stamp: 'nice 12/29/2010 14:49'!
testFromTuple: nth
	"verify that the methods allowed don't crash the system.  Try N of each of the fundamental types.  up to 4 of each kind." 

| objects nonRepeating even other aa cnt |
objects := #((1 4 17 42) ($a $b $c $d) ('one' 'two' 'three' 'four')
	(x + rect: new) ((a b 1 4) (c 1 5) ($a 3 d) ()) (4.5 0.0 3.2 100.3)
	).

objects := objects, {{true. false. true. false}. {Point. SmallInteger. Association. Array}.
	{Point class. SmallInteger class. Association class. Array class}.
	"{ 4 blocks }."
	{Date today. '1 Jan 1950' asDate. '25 Aug 1987' asDate. '1 Jan 2000' asDate}.
	{'15:16' asTime. '1:56' asTime. '4:01' asTime. '6:23' asTime}.
	{Dictionary new. Dictionary new. Dictionary new. Dictionary new}.
	{#(a b 1 4) asOrderedCollection. #(c 1 5) asOrderedCollection. 
		#($a 3 d) asOrderedCollection. #() asOrderedCollection}.
	{3 -> true. 5.6 -> $a. #x -> 2. 'abcd' -> false}.
	{9 @ 3 extent: 5 @ 4. 0 @ 0 extent: 45 @ 9. -3 @ -7 extent: 2 @ 2. 4 @ 4 extent: 16 @ 16}.
	{Color red.  Color blue. Color black. Color gray}}.

self test2: objects.
"rec+0, rec+1, rec+2, rec+3 need to be tested.  " 
cnt := 0.
nth to: 4 do: [:take |
	nonRepeating := OrderedCollection new.
	objects do: [:each |
		nonRepeating addAll: (each copyFrom: 1 to: take)].
	"all combinations of take, from nonRepeating"
	even := true.
	nonRepeating combinations: take atATimeDo: [:tuple |
		even ifTrue: [other := tuple clone]
			ifFalse: [self load: (aa := Array with: tuple with: 1 with: other with: 7).
				(cnt := cnt + 1) \\ 50 = 0 ifTrue: [
					Transcript cr; show: aa first printString].
				self search: true.
				self test2: aa.
				self test2: nonRepeating.
				"self test2: objects"].
		even := even not].
	].! !

!MethodFinder methodsFor: 'search' stamp: ''!
testPerfect: t1 
	| t2 t3 t4 t5 t9 t11 |
	t5 := t1 beginsWith: 'perform:'.
	t2 := argMap size.
	1
		to: thisData size
		do: [:t7 | 
			t9 := (thisData at: t7)
						copyFrom: 2
						to: t2.
			t5
				ifTrue: [t4 := t9 first.
					((Approved includes: t4)
							or: [AddAndRemove includes: t4])
						ifFalse: [^ false].
					t1 == #perform:withArguments:
						ifTrue: [t4 numArgs = (t9 at: 2) basicSize
								ifFalse: [^ false]]
						ifFalse: [t4 numArgs = (t1 numArgs - 1)
								ifFalse: [^ false]]]
				ifFalse: [t4 := t1].
			1
				to: t2
				do: [:t6 | (Blocks
							includes: (Array with: t4 with: t6))
						ifTrue: [(t9 at: t6) isBlock
								ifFalse: [^ false]]].
			t11 := (AddAndRemove includes: t4)
						ifTrue: [(thisData at: t7) first isSymbol
								ifTrue: [^ false].
							(thisData at: t7) first copyTwoLevel]
						ifFalse: [(thisData at: t7) first].
			t3 := [t11 perform: t1 withArguments: t9]
						ifError: [:t12 :t13 | ^ false].
			((answers at: t7)
					closeTo: t3)
				ifFalse: [^ false]].
	^ true! !

!MethodFinder methodsFor: 'initialize' stamp: 'nice 3/31/2011 01:15'!
testRandom
	"verify that the methods allowed don't crash the system.  Pick 3 or 4 from a mixed list of the fundamental types." 

	| objects other aa cnt take tuple fName sss |
	objects := #(
		(1 4 17 42) ($a $b $c $d) ('one' 'two' 'three' 'four')
		(x + rect: new) ((a b 1 4) (c 1 5) ($a 3 d) ()) (4.5 0.0 3.2 100.3)
	).

	objects := objects, {{true. false. true. false}. {Point. SmallInteger. Association. Array}.
		{Point class. SmallInteger class. Association class. Array class}.
		"{ 4 blocks }."
		{Date today. '1 Jan 1950' asDate. '25 Aug 1987' asDate. '1 Jan 2000' asDate}.
		{'15:16' asTime. '1:56' asTime. '4:01' asTime. '6:23' asTime}.
		{Dictionary new. Dictionary new. Dictionary new. Dictionary new}.
		{#(a b 1 4) asOrderedCollection. #(c 1 5) asOrderedCollection. 
			#($a 3 d) asOrderedCollection. #() asOrderedCollection}.
		{3 -> true. 5.6 -> $a. #x -> 2. 'abcd' -> false}.
		{9 @ 3 extent: 5 @ 4. 0 @ 0 extent: 45 @ 9. -3 @ -7 extent: 2 @ 2. 4 @ 4 extent: 16 @ 16}.
		{Color red.  Color blue. Color black. Color gray}}.

	self test2: objects.
	"rec+0, rec+1, rec+2, rec+3 need to be tested.  " 
	fName := (FileDirectory default fileNamesMatching: '*.ran') first.
	sss := fName splitInteger first.
	(Collection classPool at: #RandomForPicking) seed: sss.
	cnt := 0.
	
	[take := #(3 4) atRandom.
	tuple := (1 to: take) collect: [:ind | (objects atRandom) atRandom].
	other := (1 to: take) collect: [:ind | (objects atRandom) atRandom].
	self load: (aa := Array with: tuple with: 1 with: other with: 7).
	((cnt := cnt + 1) \\ 10 = 0) " | (cnt > Skip)" ifTrue:
		[Transcript cr; show: cnt printString; tab; tab; show: aa first printString].
	cnt > (Smalltalk at: #StopHere) ifTrue: [self halt].		"stop just before crash"
	cnt > (Smalltalk at: #Skip)
		ifTrue:
			["skip this many at start"
			self search: true.
			self test2: aa first.  self test2: (aa at: 3).
			"self test2: objects"]] repeat.
	! !

!MethodFinder methodsFor: 'arg maps' stamp: ''!
thisData
	^ thisData! !

!MethodFinder methodsFor: 'initialize' stamp: ''!
verify
	Approved
		ifNil: [self initialize].
	(MethodFinder new load: #(#(0 ) 0 #(30 ) 0.5 #(45 ) 0.707106 #(90 ) 1 )) searchForOne asArray = #('data1 degreeSin' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: {{true. [3]. [4]}. 3. {false. [0]. [6]}. 6}) searchForOne asArray = #('data1 ifTrue: data2 ifFalse: data3' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: {#(1 ). true. #(2 ). false. #(5 ). true. #(10 ). false}) searchForOne asArray = #('data1 odd' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(4 2 ) '2r100' #(255 16 ) '16rFF' #(14 8 ) '8r16' )) searchForOne asArray = #('data1 radix: data2' 'data1 printStringBase: data2' 'data1 storeStringBase: data2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: {{Point x: 3 y: 4}. 4. {Point x: 1 y: 5}. 5}) searchForOne asArray = #('data1 y' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#('abcd' ) $a #('TedK' ) $T )) searchForOne asArray = #('data1 asCharacter' 'data1 first' 'data1 anyOne' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#('abcd' 1 ) $a #('Ted ' 3 ) $d )) searchForOne asArray = #('data1 at: data2' 'data1 atPin: data2' 'data1 atWrap: data2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(#(12 4 8 ) ) 24 #(#(1 3 6 ) ) 10 )) searchForOne asArray = #('data1 sum' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(14 3 ) 11 #(-10 5 ) -15 #(4 -3 ) 7 )) searchForOne asArray = #('data1 - data2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(4 ) 4 #(-10 ) 10 #(-3 ) 3 #(2 ) 2 #(-6 ) 6 #(612 ) 612 )) searchForOne asArray = #('data1 abs' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: {#(4 3 ). true. #(-7 3 ). false. #(5 1 ). true. #(5 5 ). false}) searchForOne asArray = #('data1 > data2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(5 ) 0.2 #(2 ) 0.5 )) searchForOne asArray = #('data1 reciprocal' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(12 4 8 ) 2 #(1 3 6 ) 2 #(5 2 16 ) 8 )) searchForOne asArray = #()
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(0.0 ) 0.0 #(1.5 ) 0.997495 #(0.75 ) 0.681639 )) searchForOne asArray = #('data1 sin' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(7 5 ) 2 #(4 5 ) 4 #(-9 4 ) 3 )) searchForOne asArray = #('data1 \\ data2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(7 ) 2 #(4 ) 2 )) searchForOne asArray = #('^ 2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: {#(7 ). true. #(4.1 ). true. #(1.5 ). false}) searchForOne asArray = #('data1 >= 4.1' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(35 ) 3 #(17 ) 1 #(5 ) 5 )) searchForOne asArray = #('data1 \\ 8' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(36 ) 7 #(50 ) 10 )) searchForOne asArray = #('data1 quo: 5' 'data1 // 5' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(#(2 3 ) 2 ) 8 #(#(2 3 ) 5 ) 17 )) searchForOne asArray = #('data1 polynomialEval: data2' )
		ifFalse: [self error: 'should have found it'].
	(MethodFinder new load: #(#(2 ) 8 #(5 ) 17 )) searchForOne asArray = #('#(2 3) polynomialEval: data1' )
		ifFalse: [self error: 'should have found it']! !

Object subclass: #Model
	instanceVariableNames: 'dependents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Models'!

!Model class methodsFor: 'toolbuilder' stamp: ''!
buildWith: t1 
	^ self new buildWith: t1! !

!Model methodsFor: 'keyboard' stamp: ''!
arrowKey: t1 from: t2 
	^ false! !

!Model methodsFor: 'dependents' stamp: ''!
canDiscardEdits
	dependents
		ifNil: [^ true].
	^ super canDiscardEdits! !

!Model methodsFor: 'dependents' stamp: ''!
containingWindow
	^ self dependents
		detect: [:t1 | t1 isWindowForModel: self]
		ifNone: []! !

!Model methodsFor: 'dependents' stamp: ''!
hasUnacceptedEdits
	dependents
		ifNil: [^ false].
	^ super hasUnacceptedEdits! !

!Model methodsFor: 'dependents' stamp: ''!
myDependents
	^ dependents! !

!Model methodsFor: 'dependents' stamp: ''!
myDependents: t1 
	dependents := t1! !

!Model methodsFor: 'menus' stamp: ''!
perform: t1 orSendTo: t2 
	^ t2 perform: t1! !

!Model methodsFor: 'menus' stamp: ''!
selectedClass
	^ nil! !

!Model methodsFor: 'menus' stamp: ''!
step
	^ self! !

!Model methodsFor: 'dependents' stamp: ''!
topView
	dependents
		ifNil: [^ nil].
	dependents
		do: [:t1 | 
			(t1 isWindowForModel: self)
				ifTrue: [^ t1].
			nil].
	^ nil! !

!Model methodsFor: 'menus' stamp: ''!
trash
	^ ''! !

!Model methodsFor: 'menus' stamp: ''!
trash: t1 
	^ true! !

!Model methodsFor: 'copying' stamp: ''!
veryDeepFixupWith: t1 
	| t2 t3 |
	super veryDeepFixupWith: t1.
	t2 := dependents.
	t2
		ifNil: [^ self].
	dependents := nil.
	t3 := t1 references.
	t2
		do: [:t4 | 
			| t5 |
			t5 := t3
						at: t4
						ifAbsent: [].
			t5
				ifNotNil: [self addDependent: t5]]! !

!Model methodsFor: 'copying' stamp: ''!
veryDeepInner: t1 
	^ self! !

Object subclass: #Monitor
	instanceVariableNames: 'mutex ownerProcess nestingLevel defaultQueue queueDict queuesMutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Monitor methodsFor: 'private' stamp: ''!
checkOwnerProcess
	self isOwnerProcess
		ifFalse: [self error: 'Monitor access violation']! !

!Monitor methodsFor: 'accessing' stamp: ''!
cleanup
	self checkOwnerProcess.
	self
		critical: [self privateCleanup]! !

!Monitor methodsFor: 'synchronization' stamp: ''!
critical: t1 
	^ [self enter.
	t1 value]
		ensure: [self exit]! !

!Monitor methodsFor: 'private' stamp: ''!
defaultQueue
	defaultQueue
		ifNil: [defaultQueue := OrderedCollection new].
	^ defaultQueue! !

!Monitor methodsFor: 'private' stamp: ''!
enter
	self isOwnerProcess
		ifTrue: [nestingLevel := nestingLevel + 1]
		ifFalse: [mutex wait.
			ownerProcess := Processor activeProcess.
			nestingLevel := 1]! !

!Monitor methodsFor: 'private' stamp: ''!
exit
	nestingLevel := nestingLevel - 1.
	nestingLevel < 1
		ifTrue: [ownerProcess := nil.
			mutex signal]! !

!Monitor methodsFor: 'private' stamp: 'ul 9/10/2011 19:23'!
exitAndWaitInQueue: anOrderedCollection maxMilliseconds: anIntegerOrNil

	[ 
		| lock |
		lock := queuesMutex critical: [ anOrderedCollection addLast: Semaphore new ].
		self exit.
		anIntegerOrNil 
			ifNil: [ lock wait 	]
			ifNotNil: [
				| delay |
				delay := MonitorDelay 
					signalLock: lock
					afterMSecs: anIntegerOrNil
					inMonitor: self
					queue: anOrderedCollection.
				[ lock wait ] ensure: [ delay unschedule ] ] ]
		ensure: [ self enter ]! !

!Monitor methodsFor: 'initialize-release' stamp: ''!
initialize
	mutex := Semaphore forMutualExclusion.
	queuesMutex := Semaphore forMutualExclusion.
	nestingLevel := 0! !

!Monitor methodsFor: 'private' stamp: ''!
isOwnerProcess
	^ Processor activeProcess == ownerProcess! !

!Monitor methodsFor: 'private' stamp: ''!
privateCleanup
	queuesMutex
		critical: [defaultQueue isEmpty
				ifTrue: [defaultQueue := nil].
			queueDict
				ifNotNil: [queueDict copy
						keysAndValuesDo: [:t1 :t2 | t2 isEmpty
								ifTrue: [queueDict removeKey: t1]].
					queueDict isEmpty
						ifTrue: [queueDict := nil]]]! !

!Monitor methodsFor: 'private' stamp: 'ul 10/17/2010 02:13'!
queueDict
	
	^queueDict ifNil: [ queueDict := IdentityDictionary new ]! !

!Monitor methodsFor: 'private' stamp: ''!
queueFor: t1 
	t1
		ifNil: [^ self defaultQueue].
	^ self queueDict
		at: t1
		ifAbsent: [self queueDict at: t1 put: OrderedCollection new]! !

!Monitor methodsFor: 'signaling-default' stamp: ''!
signal
	^ self signal: nil! !

!Monitor methodsFor: 'signaling-specific' stamp: ''!
signal: t1 
	| t2 |
	self checkOwnerProcess.
	t2 := self queueFor: t1.
	t2 isEmpty
		ifTrue: [t2 := self defaultQueue].
	self signalQueue: t2! !

!Monitor methodsFor: 'signaling-default' stamp: ''!
signalAll
	^ self signalAll: nil! !

!Monitor methodsFor: 'signaling-specific' stamp: ''!
signalAll: t1 
	| t2 |
	self checkOwnerProcess.
	t2 := self queueFor: t1.
	self signalAllInQueue: self defaultQueue.
	t2 ~~ self defaultQueue
		ifTrue: [self signalAllInQueue: t2]! !

!Monitor methodsFor: 'private' stamp: 'ul 10/17/2010 03:40'!
signalAllInQueue: anOrderedCollection

	queuesMutex critical: [
		anOrderedCollection removeAllSuchThat: [ :each |
			each signal.
			true ] ]! !

!Monitor methodsFor: 'private' stamp: ''!
signalLock: t1 inQueue: t2 
	queuesMutex
		critical: [t1 signal.
			t2
				remove: t1
				ifAbsent: []]! !

!Monitor methodsFor: 'private' stamp: 'ul 10/17/2010 03:41'!
signalQueue: anOrderedCollection

	queuesMutex critical: [
		anOrderedCollection isEmpty ifFalse: [
			anOrderedCollection removeFirst signal ] ]! !

!Monitor methodsFor: 'signaling-specific' stamp: ''!
signalReallyAll
	self checkOwnerProcess.
	self signalAll.
	self queueDict
		valuesDo: [:t1 | self signalAllInQueue: t1]! !

!Monitor methodsFor: 'waiting-basic' stamp: ''!
wait
	^ self waitMaxMilliseconds: nil! !

!Monitor methodsFor: 'waiting-specific' stamp: ''!
waitFor: t1 
	^ self waitFor: t1 maxMilliseconds: nil! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitFor: t1 maxMilliseconds: t2 
	self checkOwnerProcess.
	self
		waitInQueue: (self queueFor: t1)
		maxMilliseconds: t2! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitFor: t1 maxSeconds: t2 
	^ self waitFor: t1 maxMilliseconds: (t2 * 1000) asInteger! !

!Monitor methodsFor: 'private' stamp: ''!
waitInQueue: t1 maxMilliseconds: t2 
	self exitAndWaitInQueue: t1 maxMilliseconds: t2! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitMaxMilliseconds: t1 
	^ self waitFor: nil maxMilliseconds: t1! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitMaxSeconds: t1 
	^ self waitMaxMilliseconds: (t1 * 1000) asInteger! !

!Monitor methodsFor: 'waiting-basic' stamp: ''!
waitUntil: t1 
	^ self waitUntil: t1 for: nil! !

!Monitor methodsFor: 'waiting-specific' stamp: ''!
waitUntil: t1 for: t2 
	^ self
		waitUntil: t1
		for: t2
		maxMilliseconds: nil! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitUntil: t1 for: t2 maxMilliseconds: t3 
	^ self
		waitWhile: [t1 value not]
		for: t2
		maxMilliseconds: t3! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitUntil: t1 for: t2 maxSeconds: t3 
	^ self
		waitUntil: t1
		for: t2
		maxMilliseconds: (t3 * 1000) asInteger! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitUntil: t1 maxMilliseconds: t2 
	^ self
		waitUntil: t1
		for: nil
		maxMilliseconds: t2! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitUntil: t1 maxSeconds: t2 
	^ self waitUntil: t1 maxMilliseconds: (t2 * 1000) asInteger! !

!Monitor methodsFor: 'waiting-basic' stamp: ''!
waitWhile: t1 
	^ self waitWhile: t1 for: nil! !

!Monitor methodsFor: 'waiting-specific' stamp: ''!
waitWhile: t1 for: t2 
	^ self
		waitWhile: t1
		for: t2
		maxMilliseconds: nil! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitWhile: t1 for: t2 maxMilliseconds: t3 
	self checkOwnerProcess.
	self
		waitWhile: t1
		inQueue: (self queueFor: t2)
		maxMilliseconds: t3! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitWhile: t1 for: t2 maxSeconds: t3 
	^ self
		waitWhile: t1
		for: t2
		maxMilliseconds: (t3 * 1000) asInteger! !

!Monitor methodsFor: 'private' stamp: ''!
waitWhile: t1 inQueue: t2 maxMilliseconds: t3 
	[t1 value]
		whileTrue: [self exitAndWaitInQueue: t2 maxMilliseconds: t3]! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitWhile: t1 maxMilliseconds: t2 
	^ self
		waitWhile: t1
		for: nil
		maxMilliseconds: t2! !

!Monitor methodsFor: 'waiting-timeout' stamp: ''!
waitWhile: t1 maxSeconds: t2 
	^ self waitWhile: t1 maxMilliseconds: (t2 * 1000) asInteger! !

Object subclass: #Mutex
	instanceVariableNames: 'semaphore owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Mutex methodsFor: 'mutual exclusion' stamp: ''!
critical: t1 
	| t2 |
	t2 := Processor activeProcess.
	t2 == owner
		ifTrue: [^ t1 value].
	^ semaphore
		critical: [owner := t2.
			t1
				ensure: [owner := nil]]! !

!Mutex methodsFor: 'initialize' stamp: ''!
initialize
	semaphore := Semaphore forMutualExclusion! !

Object subclass: #MutexSet
	instanceVariableNames: 'array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!MutexSet class methodsFor: 'instance creation' stamp: ''!
withAll: t1 
	^ self new withAll: t1! !

!MutexSet methodsFor: 'mutual exclusion' stamp: ''!
critical: t1 
	^ self pvtCritical: t1 startingAt: 1! !

!MutexSet methodsFor: 'private' stamp: ''!
pvtCritical: t1 startingAt: t2 
	| t3 |
	t2 > array size
		ifTrue: [^ t1 value].
	t3 := array at: t2.
	^ t3
		critical: [self pvtCritical: t1 startingAt: t2 + 1]! !

!MutexSet methodsFor: 'initialize' stamp: ''!
withAll: t1 
	array := t1! !

Object subclass: #NumberParser
	instanceVariableNames: 'sourceStream base neg integerPart fractionPart exponent scale nDigits lastNonZero requestor failBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

NumberParser subclass: #FORTRANNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!FORTRANNumberParser methodsFor: 'accessing' stamp: ''!
allowPlusSign
	^ true! !

!FORTRANNumberParser methodsFor: 'accessing' stamp: ''!
exponentLetters
	^ 'ED'! !

!FORTRANNumberParser methodsFor: 'parsing-public' stamp: ''!
nextFloat
	^ self nextNumber asFloat! !

!FORTRANNumberParser methodsFor: 'parsing-public' stamp: ''!
nextNumber
	| t1 t2 t3 t4 t5 t6 |
	base := 10.
	(self nextMatchAll: 'NaN')
		ifTrue: [^ Float nan].
	neg := self peekSignIsMinus.
	(self nextMatchAll: 'Infinity')
		ifTrue: [^ neg
				ifTrue: [Float infinity negated]
				ifFalse: [Float infinity]].
	(t6 := sourceStream peekFor: $.)
		ifTrue: [integerPart := 0.
			t1 := 0]
		ifFalse: [integerPart := self nextUnsignedIntegerBase: base.
			t1 := nDigits - lastNonZero].
	(t6
			or: [sourceStream peekFor: $.])
		ifTrue: [fractionPart := self
						nextUnsignedIntegerBase: base
						ifFail: [].
			fractionPart isNil
				ifTrue: [t6
						ifTrue: [self expected: 'a digit 0 to 9'.
							^ nil].
					fractionPart := 0]
				ifFalse: [t2 := lastNonZero.
					t5 := nDigits - lastNonZero].
			self readExponent]
		ifFalse: [self readExponent
				ifFalse: [^ neg
						ifTrue: [integerPart negated]
						ifFalse: [integerPart]].
			fractionPart := 0].
	fractionPart isZero
		ifTrue: [t3 := integerPart
						// (base raisedTo: t1).
			exponent := exponent + t1]
		ifFalse: [t3 := integerPart
						* (base raisedTo: t2) + (fractionPart
							// (base raisedTo: t5)).
			exponent := exponent - t2].
	t4 := self
				makeFloatFromMantissa: t3
				exponent: exponent
				base: base.
	^ neg
		ifTrue: [t4 isZero
				ifTrue: [Float negativeZero]
				ifFalse: [t4 negated]]
		ifFalse: [t4]! !

!NumberParser class methodsFor: 'instance creation' stamp: ''!
on: t1 
	^ self new on: t1! !

!NumberParser class methodsFor: 'instance creation' stamp: ''!
parse: t1 
	^ self new on: t1;
		 nextNumber! !

!NumberParser class methodsFor: 'instance creation' stamp: ''!
parse: t1 onError: t2 
	^ self new on: t1;
		 failBlock: t2;
		 nextNumber! !

!NumberParser methodsFor: 'accessing' stamp: ''!
allowPlusSign
	^ self subclassResponsibility! !

!NumberParser methodsFor: 'accessing' stamp: ''!
allowPlusSignInExponent
	^ self allowPlusSign! !

!NumberParser methodsFor: 'error' stamp: 'cmm 10/11/2012 22:30'!
error: aString
	NumberParserError signal: aString! !

!NumberParser methodsFor: 'error' stamp: ''!
expected: t1 
	| t2 |
	t2 := t1 , ' expected'.
	requestor isNil
		ifFalse: [requestor
				notify: t2
				at: sourceStream position + 1
				in: sourceStream].
	failBlock
		ifNotNil: [^ failBlock cull: t2 cull: sourceStream position + 1].
	self error: 'Reading a number failed: ' , t2! !

!NumberParser methodsFor: 'accessing' stamp: ''!
exponentLetters
	^ self subclassResponsibility! !

!NumberParser methodsFor: 'accessing' stamp: ''!
failBlock: t1 
	failBlock := t1! !

!NumberParser methodsFor: 'parsing-private' stamp: ''!
makeFloatFromMantissa: t1 exponent: t2 base: t3 
	^ (t2 positive
		ifTrue: [t1
				* (t3 raisedToInteger: t2)]
		ifFalse: [Fraction
				numerator: t1
				denominator: (t3 raisedToInteger: t2 negated)]) asFloat! !

!NumberParser methodsFor: 'parsing-private' stamp: ''!
makeScaledDecimalWithNumberOfNonZeroFractionDigits: t1 andNumberOfTrailingZeroInFractionPart: t2 
	| t3 t4 |
	t3 := base raisedToInteger: t1.
	t4 := integerPart * t3 + (fractionPart
					// (base raisedTo: t2)) / t3.
	^ ScaledDecimal
		newFromNumber: (neg
				ifTrue: [t4 negated]
				ifFalse: [t4])
		scale: scale! !

!NumberParser methodsFor: 'parsing-large int' stamp: ''!
nextElementaryLargeIntegerBase: t1 
	| t2 t3 |
	t2 := 0.
	nDigits := 0.
	lastNonZero := 0.
	[t2 isLarge
		or: [sourceStream next
				ifNil: [true]
				ifNotNil: [:t4 | 
					t3 := t4 digitValue.
					(0 > t3
							or: [t3 >= t1])
						and: [sourceStream skip: -1.
							true]]]]
		whileFalse: [nDigits := nDigits + 1.
			0 = t3
				ifFalse: [lastNonZero := nDigits].
			t2 := t2 * t1 + t3].
	^ t2! !

!NumberParser methodsFor: 'parsing-public' stamp: 'nice 5/20/2012 15:00'!
nextInteger
	"Read an Integer from sourceStream, asnwser that Integer.
	This is a generic version dealing with an optional sign and a simple sequence of decimal digits.
	Subclass might define extended syntax."
	
	base := 10.
	^self nextIntegerBase: base ifFail: [^self expected: ('a digit between 0 and ' copyWith: (Character digitValue: base - 1))]! !

!NumberParser methodsFor: 'parsing-public' stamp: 'nice 4/2/2010 20:25'!
nextIntegerBase: aRadix
	"Form an integer with following digits.
	Fail if no digit found"
	
	| isNeg value |
	isNeg := self peekSignIsMinus.
	value := self nextUnsignedIntegerBase: aRadix.
	^isNeg
		ifTrue: [value negated]
		ifFalse: [value]! !

!NumberParser methodsFor: 'parsing-public' stamp: 'nice 8/27/2010 20:51'!
nextIntegerBase: aRadix ifFail: aBlock
	"Form an integer with optional sign and following digits from sourceStream."
	
	| isNeg value |
	isNeg := self peekSignIsMinus.
	value := self nextUnsignedIntegerOrNilBase: aRadix.
	value ifNil: [^aBlock value].
	^isNeg
		ifTrue: [value negated]
		ifFalse: [value]! !

!NumberParser methodsFor: 'parsing-large int' stamp: ''!
nextLargeIntegerBase: t1 nPackets: t2 
	| t3 t4 t5 t6 t7 |
	t7 := t2 bitShift: -1.
	t7 = 0
		ifTrue: [^ self nextElementaryLargeIntegerBase: t1].
	t3 := self nextLargeIntegerBase: t1 nPackets: t7.
	t3 isLarge
		ifFalse: [^ t3].
	t4 := nDigits.
	t5 := self nextLargeIntegerBase: t1 nPackets: t7.
	t6 := nDigits.
	nDigits := t4 + t6.
	lastNonZero = 0
		ifFalse: [lastNonZero := lastNonZero + t4].
	^ t3
		* (t1 raisedToInteger: t6) + t5! !

!NumberParser methodsFor: 'parsing-public' stamp: ''!
nextNumber
	^ self subclassResponsibility! !

!NumberParser methodsFor: 'parsing-public' stamp: 'nice 5/20/2012 15:00'!
nextUnsignedInteger
	"Read an Integer from sourceStream, asnwser that Integer.
	This is a generic version dealing with a simple sequence of decimal digits.
	Subclass might define extended syntax."
	
	base := 10.
	^self nextUnsignedIntegerBase: base ifFail: [^self expected: ('a digit between 0 and ' copyWith: (Character digitValue: base - 1))]! !

!NumberParser methodsFor: 'parsing-public' stamp: ''!
nextUnsignedIntegerBase: t1 
	| t2 |
	t2 := self nextUnsignedIntegerOrNilBase: t1.
	t2
		ifNil: [^ self
				expected: ('a digit between 0 and '
						copyWith: (Character digitValue: t1 - 1))].
	^ t2! !

!NumberParser methodsFor: 'parsing-public' stamp: ''!
nextUnsignedIntegerBase: t1 ifFail: t2 
	| t3 |
	t3 := self nextUnsignedIntegerOrNilBase: t1.
	t3
		ifNil: [^ t2 value].
	^ t3! !

!NumberParser methodsFor: 'parsing-public' stamp: ''!
nextUnsignedIntegerOrNilBase: t1 
	| t2 t3 t4 t5 t6 |
	t3 := self nextElementaryLargeIntegerBase: t1.
	nDigits = 0
		ifTrue: [^ nil].
	t3 isLarge
		ifFalse: [^ t3].
	t2 := 1.
	t4 := nDigits.
	t5 := lastNonZero.
	[t6 := self nextLargeIntegerBase: t1 nPackets: t2.
	t3 := t3
				* (t1 raisedToInteger: nDigits) + t6.
	lastNonZero = 0
		ifFalse: [t5 := lastNonZero + t4].
	t4 := t4 + nDigits.
	t6 isLarge]
		whileTrue: [t2 := t2 * 2].
	nDigits := t4.
	lastNonZero := t5.
	^ t3! !

!NumberParser methodsFor: 'initialize-release' stamp: ''!
on: t1 
	sourceStream := t1 isString
				ifTrue: [t1 readStream]
				ifFalse: [t1].
	base := 10.
	neg := false.
	integerPart := fractionPart := exponent := scale := 0.
	requestor := failBlock := nil! !

!NumberParser methodsFor: 'parsing-private' stamp: ''!
peekSignIsMinus
	| t1 |
	t1 := sourceStream peekFor: $-.
	t1
		ifFalse: [self allowPlusSign
				ifTrue: [sourceStream peekFor: $+]].
	^ t1! !

!NumberParser methodsFor: 'parsing-private' stamp: ''!
readExponent
	| t1 t2 |
	exponent := 0.
	sourceStream atEnd
		ifTrue: [^ false].
	(self exponentLetters includes: sourceStream peek)
		ifFalse: [^ false].
	sourceStream next.
	t1 := sourceStream peekFor: $-.
	t2 := t1 not
				and: [self allowPlusSignInExponent
						and: [sourceStream peekFor: $+]].
	exponent := self nextUnsignedIntegerOrNilBase: 10.
	exponent
		ifNil: [exponent := 0.
			sourceStream
				skip: ((t1
							or: [t2])
						ifTrue: [-2]
						ifFalse: [-1]).
			^ false].
	t1
		ifTrue: [exponent := exponent negated].
	^ true! !

!NumberParser methodsFor: 'accessing' stamp: ''!
requestor: t1 
	requestor := t1! !

!Object class methodsFor: 'instance creation' stamp: 'sw 1/23/2003 09:45'!
categoryForUniclasses
	"Answer the default system category into which to place unique-class instances"

	^ 'UserObjects'! !

!Object class methodsFor: 'instance creation' stamp: ''!
chooseUniqueClassName
	| t1 t2 |
	t1 := 1.
	[t2 := (self name , t1 printString) asSymbol.
	Smalltalk includesKey: t2]
		whileTrue: [t1 := t1 + 1].
	^ t2! !

!Object class methodsFor: 'objects from disk' stamp: ''!
createFrom: t1 size: t2 version: t3 
	^ self isVariable
		ifTrue: [self basicNew: t2 - (t3 size - 1)]
		ifFalse: [self basicNew]! !

!Object class methodsFor: 'file list services' stamp: ''!
fileReaderServicesForDirectory: t1 
	^ #()! !

!Object class methodsFor: 'file list services' stamp: ''!
fileReaderServicesForFile: t1 suffix: t2 
	^ #()! !

!Object class methodsFor: 'class initialization' stamp: ''!
flushDependents
	DependentsFields
		keysAndValuesDo: [:t1 :t2 | t1
				ifNotNil: [t1 removeDependent: nil]].
	DependentsFields finalizeValues! !

!Object class methodsFor: 'class initialization' stamp: ''!
flushEvents
	EventManager flushEvents! !

!Object class methodsFor: 'documentation' stamp: ''!
howToModifyPrimitives
	self error: 'comment only'! !

!Object class methodsFor: 'instance creation' stamp: ''!
initialInstance
	^ self new! !

!Object class methodsFor: 'class initialization' stamp: ''!
initialize
	DependentsFields
		ifNil: [self initializeDependentsFields]! !

!Object class methodsFor: 'class initialization' stamp: ''!
initializeDependentsFields
	DependentsFields := WeakIdentityKeyDictionary new! !

!Object class methodsFor: 'instance creation' stamp: ''!
initializedInstance
	^ self new! !

!Object class methodsFor: 'instance creation' stamp: ''!
instanceOfUniqueClass
	^ self instanceOfUniqueClassWithInstVarString: '' andClassInstVarString: ''! !

!Object class methodsFor: 'instance creation' stamp: ''!
instanceOfUniqueClassWithInstVarString: t1 andClassInstVarString: t2 
	^ (self newUniqueClassInstVars: t1 classInstVars: t2) initialInstance! !

!Object class methodsFor: 'instance creation' stamp: ''!
isUniClass
	^ false! !

!Object class methodsFor: 'instance creation' stamp: ''!
newFrom: t1 
	^ (self isVariable
		ifTrue: [self basicNew: t1 basicSize]
		ifFalse: [self basicNew])
		copySameFrom: t1! !

!Object class methodsFor: 'instance creation' stamp: ''!
newUniqueClassInstVars: t1 classInstVars: t2 
	| t3 t4 |
	self isSystemDefined
		ifFalse: [^ superclass newUniqueClassInstVars: t1 classInstVars: t2].
	t3 := self chooseUniqueClassName.
	t4 := self
				subclass: t3
				instanceVariableNames: t1
				classVariableNames: ''
				poolDictionaries: ''
				category: self categoryForUniclasses.
	t2 size > 0
		ifTrue: [t4 class instanceVariableNames: t2].
	^ t4! !

!Object class methodsFor: 'instance creation' stamp: ''!
newUserInstance
	^ self instanceOfUniqueClass! !

!Object class methodsFor: 'class initialization' stamp: ''!
reInitializeDependentsFields
	| t1 |
	t1 := DependentsFields.
	DependentsFields := WeakIdentityKeyDictionary new.
	t1
		keysAndValuesDo: [:t2 :t3 | t3
				do: [:t4 | t2 addDependent: t4]]! !

!Object class methodsFor: 'instance creation' stamp: ''!
readCarefullyFrom: t1 
	| t2 |
	(Compiler couldEvaluate: t1)
		ifFalse: [^ self error: 'expected String, Stream, or Text'].
	t2 := Compiler
				evaluate: t1
				for: nil
				notifying: #error:
				logged: false.
	(t2 isKindOf: self)
		ifFalse: [self error: self name , ' expected'].
	^ t2! !

!Object class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 
	| t2 |
	(Compiler couldEvaluate: t1)
		ifFalse: [^ self error: 'expected String, Stream, or Text'].
	t2 := Compiler evaluate: t1.
	(t2 isKindOf: self)
		ifFalse: [self error: self name , ' expected'].
	^ t2! !

!Object class methodsFor: 'private' stamp: ''!
releaseExternalSettings
	^ self! !

!Object class methodsFor: 'file list services' stamp: ''!
services
	^ #()! !

!Object class methodsFor: 'documentation' stamp: ''!
whatIsAPrimitive
	self error: 'comment only'! !

!Object class methodsFor: 'window color' stamp: ''!
windowColorSpecification
	^ WindowColorSpec
		classSymbol: self name
		wording: 'Default'
		brightColor: #white
		pastelColor: #white
		helpMessage: 'Other windows without color preferences.'! !

!Object methodsFor: 'associating' stamp: ''!
-> t1 
	^ Association basicNew key: self value: t1! !

!Object methodsFor: 'comparing' stamp: ''!
= t1 
	^ self == t1! !

!Object methodsFor: 'drag and drop' stamp: ''!
acceptDroppingMorph: t1 event: t2 inMorph: t3 
	^ false! !

!Object methodsFor: 'finalization' stamp: ''!
actAsExecutor
	self breakDependents! !

!Object methodsFor: 'events-accessing' stamp: 'jmv 5/13/2009 10:14'!
actionForEvent: anEventSelector
    "Answer the action to be evaluated when <anEventSelector> has been triggered."

	^self actionMap
		at: anEventSelector asSymbol
		ifAbsent: [nil]! !

!Object methodsFor: 'events-accessing' stamp: 'nice 8/22/2010 20:57'!
actionForEvent: anEventSelector
ifAbsent: anExceptionBlock
    "Answer the action to be evaluated when <anEventSelector> has been triggered."

	| actions |
	actions := self actionMap
		at: anEventSelector asSymbol
		ifAbsent: [nil].
	^actions ifNil: [anExceptionBlock value]! !

!Object methodsFor: 'events-accessing' stamp: ''!
actionMap
	^ EventManager actionMapFor: self! !

!Object methodsFor: 'events-accessing' stamp: ''!
actionSequenceForEvent: t1 
	^ (self actionMap
		at: t1 asSymbol
		ifAbsent: [^ WeakActionSequence new]) asActionSequence! !

!Object methodsFor: 'events-accessing' stamp: ''!
actionsDo: t1 
	self actionMap do: t1! !

!Object methodsFor: 'events' stamp: ''!
actionsWithReceiver: t1 forEvent: t2 
	^ (self actionSequenceForEvent: t2)
		select: [:t3 | t3 receiver == t1]! !

!Object methodsFor: 'converting' stamp: ''!
adaptToFloat: t1 andCompare: t2 
	^ self adaptToFloat: t1 andSend: t2! !

!Object methodsFor: 'converting' stamp: ''!
adaptToFloat: t1 andSend: t2 
	^ self adaptToNumber: t1 andSend: t2! !

!Object methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andCompare: t2 
	^ self adaptToFraction: t1 andSend: t2! !

!Object methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andSend: t2 
	^ self adaptToNumber: t1 andSend: t2! !

!Object methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andCompare: t2 
	^ self adaptToInteger: t1 andSend: t2! !

!Object methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andSend: t2 
	^ self adaptToNumber: t1 andSend: t2! !

!Object methodsFor: 'converting' stamp: ''!
adaptToScaledDecimal: t1 andCompare: t2 
	^ self adaptToScaledDecimal: t1 andSend: t2! !

!Object methodsFor: 'scripting' stamp: ''!
adaptedToWorld: t1 
	^ self! !

!Object methodsFor: 'dependents access' stamp: ''!
addDependent: t1 
	| t2 |
	t2 := self dependents.
	(t2 includes: t1)
		ifFalse: [self
				myDependents: (t2 copyWithDependent: t1)].
	^ t1! !

!Object methodsFor: 'accessing' stamp: ''!
addInstanceVarNamed: t1 withValue: t2 
	self class addInstVarName: t1 asString.
	self instVarAt: self class instSize put: t2! !

!Object methodsFor: 'user interface' stamp: ''!
addModelItemsToWindowMenu: t1 
	^ self! !

!Object methodsFor: 'user interface' stamp: ''!
addModelMenuItemsTo: t1 forMorph: t2 hand: t3 
	^ self! !

!Object methodsFor: 'graph model' stamp: ''!
addModelYellowButtonMenuItemsTo: t1 forMorph: t2 hand: t3 
	Preferences cmdGesturesEnabled
		ifTrue: [t1
				add: 'inspect model' translated
				target: self
				action: #inspect].
	^ t1! !

!Object methodsFor: 'converting' stamp: ''!
as: t1 
	^ t1 newFrom: self! !

!Object methodsFor: 'converting' stamp: ''!
asActionSequence
	^ WeakActionSequence with: self! !

!Object methodsFor: 'converting' stamp: ''!
asActionSequenceTrappingErrors
	^ WeakActionSequenceTrappingErrors with: self! !

!Object methodsFor: 'user interface' stamp: ''!
asExplorerString
	^ self printString! !

!Object methodsFor: 'system primitives' stamp: ''!
asOop
	^ self identityHash! !

!Object methodsFor: 'converting' stamp: ''!
asOrderedCollection
	^ OrderedCollection with: self! !

!Object methodsFor: 'converting' stamp: ''!
asSetElement
	^ self! !

!Object methodsFor: 'converting' stamp: ''!
asString
	^ self printString! !

!Object methodsFor: 'converting' stamp: 'cmm 1/24/2011 17:10'!
asStringOrText
	"Answer a string that represents the receiver."
	^ self asString! !

!Object methodsFor: 'error handling' stamp: ''!
assert: t1 
	t1 value
		ifFalse: [AssertionFailure signal: 'Assertion failed']! !

!Object methodsFor: 'error handling' stamp: 'ul 9/21/2012 03:22'!
assert: aBlock description: aStringOrBlock
	"Throw an assertion error if aBlock does not evaluates to true."

	aBlock value ifFalse: [ AssertionFailure signal: aStringOrBlock value ]! !

!Object methodsFor: 'error handling' stamp: ''!
assert: t1 descriptionBlock: t2 
	t1 value
		ifFalse: [AssertionFailure signal: t2 value asString]! !

!Object methodsFor: 'accessing' stamp: ''!
at: t1 
	<primitive: 60>
	t1 isInteger
		ifTrue: [self class isVariable
				ifTrue: [self errorSubscriptBounds: t1]
				ifFalse: [self errorNotIndexable]].
	t1 isNumber
		ifTrue: [^ self at: t1 asInteger].
	self errorNonIntegerIndex! !

!Object methodsFor: 'accessing' stamp: ''!
at: t1 modify: t2 
	^ self
		at: t1
		put: (t2
				value: (self at: t1))! !

!Object methodsFor: 'accessing' stamp: ''!
at: t1 put: t2 
	<primitive: 61>
	t1 isInteger
		ifTrue: [self class isVariable
				ifTrue: [(t1 >= 1
							and: [t1 <= self size])
						ifTrue: [self errorImproperStore]
						ifFalse: [self errorSubscriptBounds: t1]]
				ifFalse: [self errorNotIndexable]].
	t1 isNumber
		ifTrue: [^ self at: t1 asInteger put: t2].
	self errorNonIntegerIndex! !

!Object methodsFor: 'error handling' stamp: ''!
backwardCompatibilityOnly: t1 
	Preferences showDeprecationWarnings
		ifTrue: [Deprecation signal: thisContext sender printString , ' has been deprecated (but will be kept for compatibility). ' , t1]! !

!Object methodsFor: 'accessing' stamp: ''!
basicAddInstanceVarNamed: t1 withValue: t2 
	self class addInstVarName: t1 asString.
	self instVarAt: self class instSize put: t2! !

!Object methodsFor: 'accessing' stamp: ''!
basicAt: t1 
	<primitive: 60>
	t1 isInteger
		ifTrue: [self errorSubscriptBounds: t1].
	t1 isNumber
		ifTrue: [^ self basicAt: t1 asInteger].
	self errorNonIntegerIndex! !

!Object methodsFor: 'accessing' stamp: ''!
basicAt: t1 put: t2 
	<primitive: 61>
	t1 isInteger
		ifTrue: [(t1 >= 1
					and: [t1 <= self size])
				ifTrue: [self errorImproperStore]
				ifFalse: [self errorSubscriptBounds: t1]].
	t1 isNumber
		ifTrue: [^ self basicAt: t1 asInteger put: t2].
	self errorNonIntegerIndex! !

!Object methodsFor: 'inspecting' stamp: ''!
basicInspect
	^ ToolSet basicInspect: self! !

!Object methodsFor: 'accessing' stamp: ''!
basicSize
	<primitive: 62>
	^ 0! !

!Object methodsFor: 'testing' stamp: ''!
beViewed
	self uniqueNameForReference.
	self presenter viewObject: self! !

!Object methodsFor: 'system primitives' stamp: ''!
becomeForward: t1 
	(Array with: self)
		elementsForwardIdentityTo: (Array with: t1)! !

!Object methodsFor: 'system primitives' stamp: ''!
becomeForward: t1 copyHash: t2 
	(Array with: self)
		elementsForwardIdentityTo: (Array with: t1)
		copyHash: t2! !

!Object methodsFor: 'testing' stamp: ''!
belongsToUniClass
	^ self class isUniClass! !

!Object methodsFor: 'accessing' stamp: ''!
bindWithTemp: t1 
	^ t1 value: self value: nil! !

!Object methodsFor: 'binding' stamp: ''!
bindingOf: t1 
	^ nil! !

!Object methodsFor: 'breakpoint' stamp: ''!
break
	BreakPoint signal! !

!Object methodsFor: 'dependents access' stamp: ''!
breakDependents
	self myDependents: nil! !

!Object methodsFor: 'filter streaming' stamp: ''!
byteEncode: t1 
	self flattenOnStream: t1! !

!Object methodsFor: 'dependents access' stamp: ''!
canDiscardEdits
	self dependents
		do: [:t1 | t1 canDiscardEdits
				ifFalse: [^ false]]
		without: self.
	^ true! !

!Object methodsFor: 'error handling' stamp: ''!
caseError
	self error: 'Case not found (' , self printString , '), and no otherwise clause'! !

!Object methodsFor: 'casing' stamp: ''!
caseOf: t1 
	^ self
		caseOf: t1
		otherwise: [self caseError]! !

!Object methodsFor: 'casing' stamp: ''!
caseOf: t1 otherwise: t2 
	t1
		associationsDo: [:t3 | 
			t3 key value = self
				ifTrue: [^ t3 value value].
			nil].
	^ t2 value! !

!Object methodsFor: 'updating' stamp: ''!
changed
	self changed: self! !

!Object methodsFor: 'updating' stamp: ''!
changed: t1 
	self dependents
		do: [:t2 | t2 update: t1]! !

!Object methodsFor: 'updating' stamp: ''!
changed: t1 with: t2 
	self dependents
		do: [:t3 | t3 update: t1 with: t2]! !

!Object methodsFor: 'tracing' stamp: 'mtf 8/19/2008 22:38'!
chasePointers
	PointerFinder on: self! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
checkHaltCountExpired
	| t1 |
	t1 := Smalltalk
				at: #HaltCount
				ifAbsent: [0].
	^ t1 = 0! !

!Object methodsFor: 'class membership' stamp: ''!
class
	<primitive: 111>
	self primitiveFailed! !

!Object methodsFor: 'system primitives' stamp: ''!
className
	^ self class name asString! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
clearHaltOnce
	Smalltalk at: #HaltOnce put: false! !

!Object methodsFor: 'copying' stamp: ''!
clone
	<primitive: 148>
	self primitiveFailed! !

!Object methodsFor: 'comparing' stamp: ''!
closeTo: t1 
	^ [self = t1]
		ifError: [false]! !

!Object methodsFor: 'macpal' stamp: ''!
codeStrippedOut: t1 
	self halt: 'Code stripped out -- ' , t1 , '-- do not proceed.'! !

!Object methodsFor: 'objects from disk' stamp: ''!
comeFullyUpOnReload: t1 
	^ self! !

!Object methodsFor: 'converting' stamp: ''!
complexContents
	^ self! !

!Object methodsFor: 'error handling' stamp: ''!
confirm: t1 
	^ UIManager default confirm: t1! !

!Object methodsFor: 'error handling' stamp: ''!
confirm: t1 orCancel: t2 
	^ UIManager default confirm: t1 orCancel: t2! !

!Object methodsFor: 'macpal' stamp: ''!
contentsChanged
	self changed: #contents! !

!Object methodsFor: 'objects from disk' stamp: ''!
convertToCurrentVersion: t1 refStream: t2 
	^ self! !

!Object methodsFor: 'copying' stamp: ''!
copy
	^ self shallowCopy postCopy! !

!Object methodsFor: 'copying' stamp: ''!
copyAddedStateFrom: t1 
	self class superclass instSize + 1
		to: self class instSize
		do: [:t2 | self
				instVarAt: t2
				put: (t1 instVarAt: t2)]! !

!Object methodsFor: 'copying' stamp: ''!
copyFrom: t1 
	| t2 t3 |
	<primitive: 168>
	t2 := self class allInstVarNames.
	t3 := t1 class allInstVarNames.
	1
		to: (t2 size min: t3 size)
		do: [:t4 | (t2 at: t4)
					= (t3 at: t4)
				ifTrue: [self
						instVarAt: t4
						put: (t1 instVarAt: t4)]].
	self class isVariable & t1 class isVariable
		ifTrue: [1
				to: (self basicSize min: t1 basicSize)
				do: [:t6 | self
						basicAt: t6
						put: (t1 basicAt: t6)]]! !

!Object methodsFor: 'copying' stamp: ''!
copySameFrom: t1 
	| t2 t3 |
	t2 := self class allInstVarNames.
	t3 := t1 class allInstVarNames.
	t2
		doWithIndex: [:t6 :t7 | | t8 | (t8 := t3 indexOf: t6) > 0
				ifTrue: [self
						instVarAt: t7
						put: (t1 instVarAt: t8)]].
	1
		to: (self basicSize min: t1 basicSize)
		do: [:t4 | self
				basicAt: t4
				put: (t1 basicAt: t4)]! !

!Object methodsFor: 'copying' stamp: ''!
copyTwoLevel
	| t1 t2 t3 |
	t2 := self class.
	t1 := self clone.
	t1 == self
		ifTrue: [^ self].
	t2 isVariable
		ifTrue: [t3 := self basicSize.
			[t3 > 0]
				whileTrue: [t1 basicAt: t3 put: (self basicAt: t3) shallowCopy.
					t3 := t3 - 1]].
	t3 := t2 instSize.
	[t3 > 0]
		whileTrue: [t1 instVarAt: t3 put: (self instVarAt: t3) shallowCopy.
			t3 := t3 - 1].
	^ t1! !

!Object methodsFor: 'testing' stamp: ''!
costumes
	^ nil! !

!Object methodsFor: 'events-accessing' stamp: ''!
createActionMap
	^ IdentityDictionary new! !

!Object methodsFor: 'system primitives' stamp: ''!
creationStamp
	^ '<no creation stamp>'! !

!Object methodsFor: 'macpal' stamp: ''!
currentEvent
	^ ActiveEvent
		ifNil: [self currentHand lastEvent]! !

!Object methodsFor: 'macpal' stamp: ''!
currentHand
	^ ActiveHand
		ifNil: [self currentWorld primaryHand]! !

!Object methodsFor: 'macpal' stamp: ''!
currentWorld
	^ ActiveWorld
		ifNil: [World]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
decrementAndCheckHaltCount
	self decrementHaltCount.
	^ self checkHaltCountExpired! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
decrementHaltCount
	| t1 |
	t1 := Smalltalk
				at: #HaltCount
				ifAbsent: [0].
	t1 > 0
		ifTrue: [t1 := t1 - 1.
			self setHaltCountTo: t1]! !

!Object methodsFor: 'copying' stamp: ''!
deepCopy
	| t1 t2 t3 |
	t2 := self class.
	t2 == Object
		ifTrue: [^ self].
	t2 isVariable
		ifTrue: [t3 := self basicSize.
			t1 := t2 basicNew: t3.
			[t3 > 0]
				whileTrue: [t1 basicAt: t3 put: (self basicAt: t3) deepCopy.
					t3 := t3 - 1].
			nil]
		ifFalse: [t1 := t2 basicNew].
	t3 := t2 instSize.
	[t3 > 0]
		whileTrue: [t1 instVarAt: t3 put: (self instVarAt: t3) deepCopy.
			t3 := t3 - 1].
	^ t1! !

!Object methodsFor: 'user interface' stamp: ''!
defaultBackgroundColor
	^ Preferences windowColorFor: self class name! !

!Object methodsFor: 'scripting' stamp: ''!
defaultFloatPrecisionFor: t1 
	^ 1! !

!Object methodsFor: 'user interface' stamp: ''!
defaultLabelForInspector
	^ self class name! !

!Object methodsFor: 'dependents access' stamp: ''!
dependents
	^ self myDependents
		ifNil: [#()]! !

!Object methodsFor: 'error handling' stamp: ''!
deprecated: t1 
	Preferences showDeprecationWarnings
		ifTrue: [Deprecation signal: thisContext sender printString , ' has been deprecated. ' , t1]! !

!Object methodsFor: 'error handling' stamp: ''!
deprecated: t1 block: t2 
	Preferences showDeprecationWarnings
		ifTrue: [Deprecation signal: thisContext sender printString , ' has been deprecated. ' , t1].
	^ t2 value! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
doExpiredHaltCount
	self clearHaltOnce.
	self removeHaltCount.
	self halt! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
doExpiredHaltCount: t1 
	self clearHaltOnce.
	self removeHaltCount.
	self halt: t1! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
doExpiredInspectCount
	self clearHaltOnce.
	self removeHaltCount.
	self inspect! !

!Object methodsFor: 'error handling' stamp: 'dtl 5/15/2011 11:19'!
doesNotUnderstand: aMessage 
	 "Handle the fact that there was an attempt to send the given
	  message to the receiver but the receiver does not understand
	  this message (typically sent from the machine when a message
	 is sent to the receiver and no method is defined for that selector)."

	"Testing: (3 activeProcess)"

	| exception resumeValue |
	(exception := MessageNotUnderstood new)
		message: aMessage;
		receiver: self.
	resumeValue := exception signal.
	^exception reachedDefaultHandler
		ifTrue: [aMessage sentTo: self]
		ifFalse: [resumeValue]! !

!Object methodsFor: 'error handling' stamp: ''!
dpsTrace: t1 
	Transcript myDependents isNil
		ifTrue: [^ self].
	self
		dpsTrace: t1
		levels: 1
		withContext: thisContext! !

!Object methodsFor: 'error handling' stamp: ''!
dpsTrace: t1 levels: t2 
	self
		dpsTrace: t1
		levels: t2
		withContext: thisContext! !

!Object methodsFor: 'error handling' stamp: ''!
dpsTrace: t1 levels: t2 withContext: t3 
	| t4 t5 t6 |
	t4 := (t1 respondsTo: #asString)
				ifTrue: [t1 asString]
				ifFalse: [t1 printString].
	(Smalltalk
		at: #Decompiler
		ifAbsent: [])
		ifNil: [Transcript cr; show: t4]
		ifNotNil: [t5 := t3.
			t6 := t2 > 1.
			1
				to: t2
				do: [:t7 | 
					Transcript cr.
					t6
						ifTrue: [Transcript show: t7 printString , ': '].
					t4 notNil
						ifTrue: [Transcript show: t5 home class name , '/' , t5 sender selector , ' (' , t4 , ')'.
							t5 := t5 sender.
							t4 := nil]
						ifFalse: [(t5 notNil
									and: [(t5 := t5 sender) notNil])
								ifTrue: [Transcript show: t5 receiver class name , '/' , t5 selector]]].
			nil]! !

!Object methodsFor: 'drag and drop' stamp: ''!
dragAnimationFor: t1 transferMorph: t2 
	^ self! !

!Object methodsFor: 'drag and drop' stamp: ''!
dragPassengerFor: t1 inMorph: t2 
	^ t1! !

!Object methodsFor: 'drag and drop' stamp: ''!
dragTransferType
	^ nil! !

!Object methodsFor: 'drag and drop' stamp: ''!
dragTransferTypeForMorph: t1 
	^ nil! !

!Object methodsFor: 'filter streaming' stamp: ''!
drawOnCanvas: t1 
	self flattenOnStream: t1! !

!Object methodsFor: 'user interface' stamp: ''!
eToyStreamedRepresentationNotifying: t1 
	| t2 |
	[t2 := SmartRefStream streamedRepresentationOf: self]
		on: ProgressInitiationException
		do: [:t4 | t4
				sendNotificationsTo: [:t5 :t6 :t7 | t1
						ifNotNil: [t1 flashIndicator: #working]]].
	^ t2! !

!Object methodsFor: 'filter streaming' stamp: ''!
elementSeparator
	^ nil! !

!Object methodsFor: 'accessing' stamp: ''!
enclosedSetElement
	^ self! !

!Object methodsFor: 'filter streaming' stamp: ''!
encodePostscriptOn: t1 
	self byteEncode: t1! !

!Object methodsFor: 'error handling' stamp: ''!
error
	^ self error: 'Error!!'! !

!Object methodsFor: 'error handling' stamp: ''!
error: t1 
	^ Error new signal: t1! !

!Object methodsFor: 'private' stamp: ''!
errorImproperStore
	self error: 'Improper store into indexable object'! !

!Object methodsFor: 'private' stamp: ''!
errorNonIntegerIndex
	self error: 'only integers should be used as indices'! !

!Object methodsFor: 'private' stamp: ''!
errorNotIndexable
	<textDomain: 'Kernel'>
	self
		error: ('Instances of {1} are not indexable' translated format: {self class name})! !

!Object methodsFor: 'private' stamp: ''!
errorSubscriptBounds: t1 
	self error: 'subscript is out of bounds: ' , t1 printString! !

!Object methodsFor: 'dependents access' stamp: ''!
evaluate: t1 wheneverChangeIn: t2 
	| t3 t4 |
	t4 := self.
	t3 := ObjectViewer on: t4.
	t4 become: t3.
	t4
		xxxViewedObject: t3
		evaluate: t1
		wheneverChangeIn: t2! !

!Object methodsFor: 'scripting' stamp: ''!
evaluateUnloggedForSelf: t1 
	^ Compiler
		evaluate: t1
		for: self
		logged: false! !

!Object methodsFor: 'message handling' stamp: 'ul 3/5/2011 10:56'!
executeMethod: compiledMethod
	"Execute compiledMethod against the receiver with no args"

	<primitive: 189>
	^ self withArgs: #() executeMethod: compiledMethod! !

!Object methodsFor: 'finalization' stamp: ''!
executor
	^ self shallowCopy actAsExecutor! !

!Object methodsFor: 'error handling' stamp: ''!
explicitRequirement
	self error: 'Explicitly required method'! !

!Object methodsFor: 'user interface' stamp: ''!
explore
	^ ToolSet explore: self! !

!Object methodsFor: 'tracing' stamp: 'mtf 8/15/2008 17:43'!
explorePointers
	PointerExplorer new openExplorerFor: self! !

!Object methodsFor: 'finalization' stamp: ''!
finalizationRegistry
	^ WeakRegistry default! !

!Object methodsFor: 'finalization' stamp: ''!
finalize
	^ self! !

!Object methodsFor: 'objects from disk' stamp: 'tk 11/29/2004 15:04'!
fixUponLoad: aProject seg: anImageSegment
	"change the object due to conventions that have changed on
the project level.  (sent to all objects in the incoming project).
Specific classes should reimplement this."! !

!Object methodsFor: 'macpal' stamp: ''!
flash
	^ self! !

!Object methodsFor: 'filter streaming' stamp: ''!
flattenOnStream: t1 
	self writeOnFilterStream: t1! !

!Object methodsFor: 'filter streaming' stamp: ''!
fullDrawPostscriptOn: t1 
	^ t1 fullDraw: self! !

!Object methodsFor: 'printing' stamp: ''!
fullPrintString
	^ String
		streamContents: [:t1 | self printOn: t1]! !

!Object methodsFor: 'user interface' stamp: ''!
fullScreenSize
	| t1 |
	t1 := 3 * Preferences scrollBarWidth @ 0.
	^ Rectangle origin: t1 extent: DisplayScreen actualScreenSize - t1! !

!Object methodsFor: 'futures' stamp: ''!
future
	^ FutureMaker new setDeltaMSecs: 0.0 target: self! !

!Object methodsFor: 'futures' stamp: ''!
future: t1 
	^ FutureMaker new setDeltaMSecs: t1 target: self! !

!Object methodsFor: 'futures' stamp: ''!
futureDo: t1 at: t2 args: t3 
	Project current
		future: self
		do: t1
		at: t2
		args: t3.
	^ nil! !

!Object methodsFor: 'futures' stamp: ''!
futureSend: t1 at: t2 args: t3 
	^ Project current
		future: self
		send: t1
		at: t2
		args: t3! !

!Object methodsFor: 'error handling' stamp: ''!
halt
	Halt signal! !

!Object methodsFor: 'error handling' stamp: ''!
halt: t1 
	Halt new signal: t1! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
halt: t1 onCount: t2 
	self haltOnceEnabled
		ifTrue: [self hasHaltCount
				ifTrue: [self decrementAndCheckHaltCount
						ifTrue: [self doExpiredHaltCount: t1]]
				ifFalse: [t2 = 1
						ifTrue: [self doExpiredHaltCount: t1]
						ifFalse: [self setHaltCountTo: t2 - 1]]]! !

!Object methodsFor: 'debugging' stamp: ''!
haltIf: t1 
	| t2 |
	t1 isSymbol
		ifTrue: [t2 := thisContext.
			[t2 sender isNil]
				whileFalse: [t2 := t2 sender.
					t2 selector = t1
						ifTrue: [Halt signal]].
			^ self].
	(t1 isBlock
			ifTrue: [t1 valueWithPossibleArgument: self]
			ifFalse: [t1])
		ifTrue: [Halt signal]! !

!Object methodsFor: 'testing' stamp: ''!
haltIfNil
	^ self! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
haltOnCount: t1 
	self haltOnceEnabled
		ifTrue: [self hasHaltCount
				ifTrue: [self decrementAndCheckHaltCount
						ifTrue: [self doExpiredHaltCount]]
				ifFalse: [t1 = 1
						ifTrue: [self doExpiredHaltCount]
						ifFalse: [self setHaltCountTo: t1 - 1]]]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
haltOnce
	self haltOnceEnabled
		ifTrue: [self clearHaltOnce.
			^ self halt]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
haltOnce: t1 
	self haltOnceEnabled
		ifTrue: [self clearHaltOnce.
			^ self halt: t1]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
haltOnceEnabled
	^ Smalltalk
		at: #HaltOnce
		ifAbsent: [false]! !

!Object methodsFor: 'updating' stamp: ''!
handledListVerification
	^ false! !

!Object methodsFor: 'error handling' stamp: ''!
handles: t1 
	^ false! !

!Object methodsFor: 'events-accessing' stamp: ''!
hasActionForEvent: t1 
	^ (self actionForEvent: t1) notNil! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
hasHaltCount
	^ self class environment includesKey: #HaltCount! !

!Object methodsFor: 'testing' stamp: ''!
hasLiteralSuchThat: t1 
	^ false! !

!Object methodsFor: 'graph model' stamp: ''!
hasModelYellowButtonMenuItems
	^ Preferences cmdGesturesEnabled! !

!Object methodsFor: 'finalization' stamp: 'Igor.Stasenko 5/25/2010 04:59'!
hasMultipleExecutors
	"All objects, except ObjectFinalizerCollection instances should answer false to this message"
	^ false! !

!Object methodsFor: 'dependents access' stamp: ''!
hasUnacceptedEdits
	self dependents
		do: [:t1 | 
			t1 hasUnacceptedEdits
				ifTrue: [^ true].
			nil]
		without: self.
	^ false! !

!Object methodsFor: 'comparing' stamp: ''!
hash
	^ self scaledIdentityHash! !

!Object methodsFor: 'thumbnail' stamp: ''!
iconOrThumbnailOfSize: t1 
	^ nil! !

!Object methodsFor: 'comparing' stamp: ''!
identityHashPrintString
	^ '(' , self identityHash printString , ')'! !

!Object methodsFor: 'accessing' stamp: ''!
ifNil: t1 ifNotNilDo: t2 
	^ t2 value: self! !

!Object methodsFor: 'accessing' stamp: ''!
ifNotNilDo: t1 
	^ t1 value: self! !

!Object methodsFor: 'accessing' stamp: ''!
ifNotNilDo: t1 ifNil: t2 
	^ t1 value: self! !

!Object methodsFor: 'accessing' stamp: ''!
in: t1 
	^ t1 value: self! !

!Object methodsFor: 'tracing' stamp: 'mtf 8/15/2008 16:28'!
inboundPointers
"Answers a collection of all objects in the system that point to myself"

	^ self inboundPointersExcluding: #()! !

!Object methodsFor: 'tracing' stamp: 'ul 9/2/2012 19:46'!
inboundPointersExcluding: objectsToExclude
	"Answer a list of all objects in the system that hold a reference to me, excluding those in the collection of objectsToExclude."

	| pointers object objectsToAlwaysExclude |
	Smalltalk garbageCollect.
	pointers := OrderedCollection new.
	"SystemNavigation >> #allObjectsDo: is inlined here with a slight modification: the marker object is pointers. This gives better results, because the value of pointers, it's inner objects and transient method contexts will not be iterated over."
	object := self someObject.
	[ object == pointers ] whileFalse: [
		(object isInMemory and: [ object pointsTo: self ]) ifTrue: [
			pointers add: object ].
		object := object nextObject ].
	objectsToAlwaysExclude := {
		thisContext.
		thisContext sender.
		thisContext sender sender.
		objectsToExclude.
	}.
	^pointers removeAllSuchThat: [ :ea |
		(objectsToAlwaysExclude identityIncludes: ea)
			or: [ objectsToExclude identityIncludes: ea ] ]! !

!Object methodsFor: 'objects from disk' stamp: ''!
indexIfCompact
	^ 0! !

!Object methodsFor: 'user interface' stamp: ''!
inform: t1 
	t1 isEmptyOrNil
		ifFalse: [UIManager default inform: t1]! !

!Object methodsFor: 'class membership' stamp: ''!
inheritsFromAnyIn: t1 
	t1
		do: [:t2 | Symbol
				hasInterned: t2 asString
				ifTrue: [:t3 | 
					| t4 |
					(((t4 := Smalltalk
										at: t3
										ifAbsent: []) isKindOf: Class)
							and: [self isKindOf: t4])
						ifTrue: [^ true].
					nil]].
	^ false! !

!Object methodsFor: 'copying' stamp: ''!
initialDeepCopierSize
	^ 4096! !

!Object methodsFor: 'user interface' stamp: ''!
initialExtent
	^ RealEstateAgent standardWindowExtent! !

!Object methodsFor: 'inspecting' stamp: ''!
inspect
	ToolSet inspect: self! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
inspectOnCount: t1 
	self haltOnceEnabled
		ifTrue: [self hasHaltCount
				ifTrue: [self decrementAndCheckHaltCount
						ifTrue: [self doExpiredInspectCount]]
				ifFalse: [t1 = 1
						ifTrue: [self doExpiredInspectCount]
						ifFalse: [self setHaltCountTo: t1 - 1]]]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
inspectOnce
	self haltOnceEnabled
		ifTrue: [self clearHaltOnce.
			^ self inspect]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
inspectUntilCount: t1 
	self haltOnceEnabled
		ifTrue: [self hasHaltCount
				ifTrue: [self decrementAndCheckHaltCount
						ifTrue: [self doExpiredInspectCount]
						ifFalse: [self inspect]]
				ifFalse: [t1 = 1
						ifTrue: [self doExpiredInspectCount]
						ifFalse: [self setHaltCountTo: t1 - 1]]]! !

!Object methodsFor: 'user interface' stamp: ''!
inspectWithLabel: t1 
	^ ToolSet inspect: self label: t1! !

!Object methodsFor: 'inspecting' stamp: ''!
inspectorClass
	^ Inspector! !

!Object methodsFor: 'system primitives' stamp: ''!
instVarAt: t1 
	<primitive: 73>
	^ self basicAt: t1 - self class instSize! !

!Object methodsFor: 'system primitives' stamp: ''!
instVarAt: t1 put: t2 
	<primitive: 74>
	^ self basicAt: t1 - self class instSize put: t2! !

!Object methodsFor: 'system primitives' stamp: ''!
instVarNamed: t1 
	^ self
		instVarAt: (self class
				instVarIndexFor: t1 asString
				ifAbsent: [self error: 'no such inst var'])! !

!Object methodsFor: 'system primitives' stamp: ''!
instVarNamed: t1 put: t2 
	^ self
		instVarAt: (self class
				instVarIndexFor: t1 asString
				ifAbsent: [self error: 'no such inst var'])
		put: t2! !

!Object methodsFor: 'macpal' stamp: ''!
instanceVariableValues
	| t1 |
	t1 := OrderedCollection new.
	self class superclass instSize + 1
		to: self class instSize
		do: [:t2 | t1
				add: (self instVarAt: t2)].
	^ t1! !

!Object methodsFor: 'testing' stamp: ''!
isArray
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isBehavior
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isBlock
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isCharacter
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isClosure
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isCollection
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isColor
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isColorForm
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isCompiledMethod
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isComplex
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isContext
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isDictionary
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isFloat
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isForm
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isFraction
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isHeap
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isInteger
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isInterval
	^ false! !

!Object methodsFor: 'class membership' stamp: ''!
isKindOf: t1 
	self class == t1
		ifTrue: [^ true].
	^ self class inheritsFrom: t1! !

!Object methodsFor: 'class membership' stamp: ''!
isKindOf: t1 orOf: t2 
	^ (self isKindOf: t1)
		or: [self isKindOf: t2]! !

!Object methodsFor: 'printing' stamp: ''!
isLiteral
	^ false! !

!Object methodsFor: 'class membership' stamp: ''!
isMemberOf: t1 
	^ self class == t1! !

!Object methodsFor: 'testing' stamp: ''!
isMessageSend
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isMethodContext
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isMethodProperties
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isMorph
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isMorphicEvent
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isMorphicModel
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isNumber
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isPlayer
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isPoint
	^ false! !

!Object methodsFor: 'testing' stamp: 'mtf 12/30/2010 23:41'!
isPrimitiveCostume
"True for primitive costumes in Tweak. Added here because a Tweak override in DisplayScanner was merged into trunk for maintainability"
	^false! !

!Object methodsFor: 'testing' stamp: ''!
isPseudoContext
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isRectangle
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isScriptEditorMorph
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isSketchMorph
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isStream
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isString
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isSymbol
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isSystemWindow
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isText
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isTextView
	^ false! !

!Object methodsFor: 'flagging' stamp: ''!
isThisEverCalled
	^ self isThisEverCalled: thisContext sender printString! !

!Object methodsFor: 'flagging' stamp: ''!
isThisEverCalled: t1 
	self halt: 'This is indeed called: ' , t1 printString! !

!Object methodsFor: 'testing' stamp: ''!
isTrait
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isTransparent
	^ false! !

!Object methodsFor: 'macpal' stamp: ''!
isUniversalTiles
	^ Preferences universalTiles! !

!Object methodsFor: 'testing' stamp: ''!
isVariableBinding
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isWebBrowser
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
isWindowForModel: t1 
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
knownName
	^ Preferences capitalizedReferences
		ifTrue: [References
				keyAtValue: self
				ifAbsent: []]! !

!Object methodsFor: 'user interface' stamp: ''!
launchPartVia: t1 
	| t2 |
	t2 := self perform: t1.
	t2 setProperty: #beFullyVisibleAfterDrop toValue: true.
	t2 openInHand! !

!Object methodsFor: 'user interface' stamp: ''!
launchPartVia: t1 label: t2 
	| t3 |
	t3 := self perform: t1.
	t3
		setNameTo: (ActiveWorld unusedMorphNameLike: t2).
	t3 setProperty: #beFullyVisibleAfterDrop toValue: true.
	t3 openInHand! !

!Object methodsFor: 'user interface' stamp: ''!
launchTileToRefer
	self currentHand attachMorph: self tileToRefer! !

!Object methodsFor: 'comparing' stamp: ''!
literalEqual: t1 
	^ self class == t1 class
		and: [self = t1]! !

!Object methodsFor: 'locales' stamp: ''!
localeChanged
	self shouldBeImplemented! !

!Object methodsFor: 'flagging' stamp: ''!
logEntry
	Transcript show: 'Entered ' , thisContext sender printString;
		 cr! !

!Object methodsFor: 'flagging' stamp: ''!
logExecution
	Transcript show: 'Executing ' , thisContext sender printString;
		 cr! !

!Object methodsFor: 'flagging' stamp: ''!
logExit
	Transcript show: 'Exited ' , thisContext sender printString;
		 cr! !

!Object methodsFor: 'printing' stamp: ''!
longPrintOn: t1 
	self class allInstVarNames
		doWithIndex: [:t2 :t3 | t1 nextPutAll: t2;
				 nextPut: $:;
				 space;
				 tab;
				
				print: (self instVarAt: t3);
				 cr]! !

!Object methodsFor: 'printing' stamp: ''!
longPrintOn: t1 limitedTo: t2 indent: t3 
	self class allInstVarNames
		doWithIndex: [:t4 :t5 | 
			t3
				timesRepeat: [t1 tab].
			t1 nextPutAll: t4;
				 nextPut: $:;
				 space;
				 tab;
				
				nextPutAll: ((self instVarAt: t5)
						printStringLimitedTo: (t2 - 3 - t4 size max: 1));
				 cr]! !

!Object methodsFor: 'printing' stamp: ''!
longPrintString
	| t1 |
	t1 := String
				streamContents: [:t2 | self longPrintOn: t2].
	^ t1 isEmpty
		ifTrue: [self printString , String cr]
		ifFalse: [t1]! !

!Object methodsFor: 'printing' stamp: ''!
longPrintStringLimitedTo: t1 
	| t2 |
	t2 := String
				streamContents: [:t3 | self
						longPrintOn: t3
						limitedTo: t1
						indent: 0].
	^ t2 isEmpty
		ifTrue: [self printString , String cr]
		ifFalse: [t2]! !

!Object methodsFor: 'scripting' stamp: ''!
methodInterfacesForCategory: t1 inVocabulary: t2 limitClass: t3 
	| t4 |
	t4 := t1 asSymbol.
	t4 == ScriptingSystem nameForInstanceVariablesCategory
		ifTrue: [^ self methodInterfacesForInstanceVariablesCategoryIn: t2].
	t4 == ScriptingSystem nameForScriptsCategory
		ifTrue: [^ self methodInterfacesForScriptsCategoryIn: t2].
	^ self
		usableMethodInterfacesIn: (t2
				methodInterfacesInCategory: t4
				forInstance: self
				ofClass: self class
				limitClass: t3)! !

!Object methodsFor: 'scripting' stamp: ''!
methodInterfacesForInstanceVariablesCategoryIn: t1 
	^ OrderedCollection new! !

!Object methodsFor: 'scripting' stamp: ''!
methodInterfacesForScriptsCategoryIn: t1 
	^ OrderedCollection new! !

!Object methodsFor: 'user interface' stamp: ''!
modelSleep
	^ self! !

!Object methodsFor: 'user interface' stamp: ''!
modelWakeUp
	^ self! !

!Object methodsFor: 'user interface' stamp: ''!
modelWakeUpIn: t1 
	self modelWakeUp! !

!Object methodsFor: 'user interface' stamp: ''!
mouseUpBalk: t1 
	^ self! !

!Object methodsFor: 'converting' stamp: ''!
mustBeBoolean
	^ self mustBeBooleanIn: thisContext sender! !

!Object methodsFor: 'converting' stamp: ''!
mustBeBooleanIn: t1 
	| t2 |
	t1 skipBackBeforeJump.
	t2 := NonBooleanReceiver new object: self;
				 signal: 'proceed for truth.'.
	^ t2 ~~ false! !

!Object methodsFor: 'dependents access' stamp: ''!
myDependents
	^ DependentsFields
		at: self
		ifAbsent: []! !

!Object methodsFor: 'dependents access' stamp: ''!
myDependents: t1 
	t1
		ifNil: [DependentsFields
				removeKey: self
				ifAbsent: []]
		ifNotNil: [DependentsFields at: self put: t1]! !

!Object methodsFor: 'testing' stamp: ''!
name
	^ self printString! !

!Object methodsFor: 'testing' stamp: ''!
nameForViewer
	| t1 |
	(t1 := self uniqueNameForReferenceOrNil)
		ifNotNil: [^ t1].
	(t1 := self knownName)
		ifNotNil: [^ t1].
	^ [(self asString copyWithout: Character cr)
		truncateTo: 27]
		ifError: [:t2 :t3 | self class name printString]! !

!Object methodsFor: 'debugging' stamp: ''!
needsWork
	^ self! !

!Object methodsFor: 'printing' stamp: ''!
nominallyUnsent: t1 
	false
		ifTrue: [self flag: #nominallyUnsent:]! !

!Object methodsFor: 'testing' stamp: ''!
notNil
	^ true! !

!Object methodsFor: 'user interface' stamp: ''!
notYetImplemented
	NotYetImplemented signal! !

!Object methodsFor: 'updating' stamp: ''!
noteSelectionIndex: t1 for: t2 
	^ self! !

!Object methodsFor: 'error handling' stamp: ''!
notify: t1 
	Warning signal: t1! !

!Object methodsFor: 'error handling' stamp: ''!
notify: t1 at: t2 
	self notify: t1! !

!Object methodsFor: 'error handling' stamp: ''!
notifyWithLabel: t1 
	ToolSet
		debugContext: thisContext
		label: t1
		contents: t1! !

!Object methodsFor: 'objects from disk' stamp: ''!
objectForDataStream: t1 
	^ self! !

!Object methodsFor: 'macpal' stamp: ''!
objectRepresented
	^ self! !

!Object methodsFor: 'updating' stamp: ''!
okToChange
	^ true! !

!Object methodsFor: 'updating' stamp: 'eem 6/15/2008 16:02'!
okToClose
	"Allows a controller to ask this of any model"
	^self okToChange! !

!Object methodsFor: 'system primitives' stamp: ''!
oopString
	^ self asOop printString! !

!Object methodsFor: 'tracing' stamp: 'mtf 8/19/2008 22:33'!
outboundPointers
"Answers a list of all objects I am causing not to be garbage-collected"

	| collection |
	collection := OrderedCollection new.
	self outboundPointersDo: [:ea | collection add: ea].
	^ collection! !

!Object methodsFor: 'tracing' stamp: 'mtf 8/15/2008 15:34'!
outboundPointersDo: aBlock
"do aBlock for every object I point to, exactly how the garbage collector would. Adapted from PointerFinder >> #followObject:"

	aBlock value: self class.
	1 to: self class instSize do: [:i | aBlock value: (self instVarAt: i)].
	1 to: self basicSize do: [:i | aBlock value: (self basicAt: i)].! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 
	<primitive: 83>
	^ self
		perform: t1
		withArguments: (Array new: 0)! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 orSendTo: t2 
	^ (self respondsTo: t1)
		ifTrue: [self perform: t1]
		ifFalse: [t2 perform: t1]! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 with: t2 
	<primitive: 83>
	^ self
		perform: t1
		withArguments: (Array with: t2)! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 with: t2 with: t3 
	<primitive: 83>
	^ self
		perform: t1
		withArguments: (Array with: t2 with: t3)! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 with: t2 with: t3 with: t4 
	<primitive: 83>
	^ self
		perform: t1
		withArguments: (Array
				with: t2
				with: t3
				with: t4)! !

!Object methodsFor: 'message handling' stamp: 'eem 1/16/2009 17:11'!
perform: aSymbol with: firstObject with: secondObject with: thirdObject with: fourthObject
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not four.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 83>
	^ self perform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: fourthObject)! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 withArguments: t2 
	<primitive: 84>
	^ self
		perform: t1
		withArguments: t2
		inSuperclass: self class! !

!Object methodsFor: 'message handling' stamp: ''!
perform: t1 withArguments: t2 inSuperclass: t3 
	<primitive: 100>
	t1 isSymbol
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	t1 numArgs = t2 size
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == t3
			or: [self class inheritsFrom: t3])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: 'message handling' stamp: 'ul 3/15/2011 01:39'!
perform: selector withEnoughArguments: anArray
	"Send selector to the receiver with arguments in anArray. Only use enough arguments for the arity of the selector; supply nils for missing ones."
	
	| numArgs args |
	(numArgs := selector numArgs) = anArray size 
		ifTrue: [ args := anArray asArray ]
		ifFalse: [
			args := Array new: numArgs.
			args 
				replaceFrom: 1
				to: (anArray size min: args size)
				with: anArray
				startingAt: 1 ].
	^self perform: selector withArguments: args! !

!Object methodsFor: 'copying' stamp: ''!
postCopy
	^ self! !

!Object methodsFor: 'accessing' stamp: ''!
presenter
	^ self currentWorld presenter! !

!Object methodsFor: 'system primitives' stamp: ''!
primitiveChangeClassTo: t1 
	<primitive: 115>
	self primitiveFailed! !

!Object methodsFor: 'private' stamp: ''!
primitiveError: t1 
	(String
		streamContents: [:t2 | 
			| t3 |
			t2 nextPutAll: '***System error handling failed***'.
			t2 cr; nextPutAll: t1.
			t3 := thisContext sender sender.
			20
				timesRepeat: [t3
						ifNotNil: [t2 cr; print: (t3 := t3 sender)]].
			t2 cr; nextPutAll: '-------------------------------'.
			t2 cr; nextPutAll: 'Type CR to enter an emergency evaluator.'.
			t2 cr; nextPutAll: 'Type any other character to restart.'])
		displayAt: 0 @ 0.
	[Sensor keyboardPressed] whileFalse.
	Sensor keyboard = Character cr
		ifTrue: [Transcripter emergencyEvaluator].
	Project current resetDisplay! !

!Object methodsFor: 'error handling' stamp: ''!
primitiveFailed
	self primitiveFailed: thisContext sender selector! !

!Object methodsFor: 'error handling' stamp: ''!
primitiveFailed: t1 
	self error: t1 asString , ' failed'! !

!Object methodsFor: 'converting' stamp: ''!
printDirectlyToDisplay
	self asString displayAt: 0 @ 100! !

!Object methodsFor: 'printing' stamp: ''!
printOn: t1 
	| t2 |
	t2 := self class name.
	t1
		nextPutAll: (t2 first isVowel
				ifTrue: ['an ']
				ifFalse: ['a ']);
		 nextPutAll: t2! !

!Object methodsFor: 'filter streaming' stamp: ''!
printOnStream: t1 
	self byteEncode: t1! !

!Object methodsFor: 'printing' stamp: ''!
printString
	^ self printStringLimitedTo: 50000! !

!Object methodsFor: 'printing' stamp: ''!
printStringLimitedTo: t1 
	| t2 |
	t2 := String
				streamContents: [:t3 | self printOn: t3]
				limitedTo: t1.
	t2 size < t1
		ifTrue: [^ t2].
	^ t2 , '...etc...'! !

!Object methodsFor: 'printing' stamp: ''!
printWithClosureAnalysisOn: t1 
	| t2 |
	t2 := self class name.
	t1
		nextPutAll: (t2 first isVowel
				ifTrue: ['an ']
				ifFalse: ['a ']);
		 nextPutAll: t2! !

!Object methodsFor: 'filter streaming' stamp: ''!
putOn: t1 
	^ t1 nextPut: self! !

!Object methodsFor: 'objects from disk' stamp: ''!
readDataFrom: t1 size: t2 
	| t3 t4 |
	t3 := self class instSize.
	self class isVariable
		ifTrue: [t4 := t2 - t3.
			t4 < 0
				ifTrue: [self error: 'Class has changed too much.  Define a convertxxx method']]
		ifFalse: [t4 := 0.
			t3 := t2].
	t1 beginReference: self.
	1
		to: t3
		do: [:t5 | self instVarAt: t5 put: t1 next].
	1
		to: t4
		do: [:t6 | self basicAt: t6 put: t1 next]! !

!Object methodsFor: 'accessing' stamp: ''!
readFromString: t1 
	^ self
		readFrom: (ReadStream on: t1)! !

!Object methodsFor: 'macpal' stamp: ''!
refusesToAcceptCode
	^ false! !

!Object methodsFor: 'dependents access' stamp: ''!
release
	self releaseActionMap! !

!Object methodsFor: 'events-removing' stamp: ''!
releaseActionMap
	EventManager releaseActionMapFor: self! !

!Object methodsFor: 'events-removing' stamp: ''!
removeAction: t1 forEvent: t2 
	self
		removeActionsSatisfying: [:t3 | t3 = t1]
		forEvent: t2! !

!Object methodsFor: 'events-removing' stamp: ''!
removeActionsForEvent: t1 
	| t2 |
	t2 := self actionMap.
	t2
		removeKey: t1 asSymbol
		ifAbsent: [].
	t2 isEmpty
		ifTrue: [self releaseActionMap]! !

!Object methodsFor: 'events-removing' stamp: ''!
removeActionsSatisfying: t1 
	self actionMap keys
		do: [:t2 | self removeActionsSatisfying: t1 forEvent: t2]! !

!Object methodsFor: 'events-removing' stamp: 'ul 8/2/2011 20:06'!
removeActionsSatisfying: aOneArgBlock 
forEvent: anEventSelector

    self
        setActionSequence:
            ((self actionSequenceForEvent: anEventSelector)
                reject: aOneArgBlock)
        forEvent: anEventSelector! !

!Object methodsFor: 'events-removing' stamp: ''!
removeActionsWithReceiver: t1 
	self actionMap copy
		keysDo: [:t2 | self
				removeActionsSatisfying: [:t3 | t3 receiver == t1]
				forEvent: t2]! !

!Object methodsFor: 'events-removing' stamp: ''!
removeActionsWithReceiver: t1 forEvent: t2 
	self
		removeActionsSatisfying: [:t3 | t3 receiver == t1]
		forEvent: t2! !

!Object methodsFor: 'dependents access' stamp: ''!
removeDependent: t1 
	| t2 |
	t2 := self dependents
				reject: [:t3 | t3 == t1].
	self
		myDependents: (t2 isEmpty
				ifFalse: [t2]).
	^ t1! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
removeHaltCount
	(self class environment includesKey: #HaltCount)
		ifTrue: [self class environment removeKey: #HaltCount]! !

!Object methodsFor: 'events' stamp: ''!
renameActionsWithReceiver: t1 forEvent: t2 toEvent: t3 
	| t4 t5 |
	t4 := Set new.
	t5 := Set new.
	(self actionSequenceForEvent: t2)
		do: [:t6 | t6 receiver == t1
				ifTrue: [t4 add: t1]
				ifFalse: [t5 add: t1]].
	self
		setActionSequence: (ActionSequence withAll: t5)
		forEvent: t2.
	t4
		do: [:t6 | self when: t3 evaluate: t6]! !

!Object methodsFor: 'testing' stamp: ''!
renameInternal: t1 
	^ nil! !

!Object methodsFor: 'testing' stamp: ''!
renameTo: t1 
	^ self! !

!Object methodsFor: 'printing' stamp: ''!
reportableSize
	^ (self basicSize + self class instSize) printString! !

!Object methodsFor: 'error handling' stamp: ''!
requirement
	self error: 'Implicitly required method'! !

!Object methodsFor: 'class membership' stamp: ''!
respondsTo: t1 
	^ self class canUnderstand: t1! !

!Object methodsFor: 'finalization' stamp: ''!
retryWithGC: t1 until: t2 
	| t3 |
	t3 := t1 value.
	(t2 value: t3)
		ifTrue: [^ t3].
	Smalltalk garbageCollectMost.
	t3 := t1 value.
	(t2 value: t3)
		ifTrue: [^ t3].
	Smalltalk garbageCollect.
	^ t1 value! !

!Object methodsFor: 'system primitives' stamp: ''!
rootStubInImageSegment: t1 
	^ ImageSegmentRootStub new
		xxSuperclass: nil
		format: nil
		segment: t1! !

!Object methodsFor: 'objects from disk' stamp: 'cmm 5/4/2011 13:54'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  Does not file out the class of the object.  tk 6/26/97 13:48"

	| aFileName |
	aFileName := self class name asFileName.	"do better?"
	aFileName := UIManager default 
				request: 'File name?' translated initialAnswer: aFileName.
	aFileName size = 0 ifTrue: [^ Beeper beep].

	self saveOnFileNamed: aFileName! !

!Object methodsFor: 'objects from disk' stamp: 'cmm 2/24/2011 20:45'!
saveOnFileNamed: filenameString
	"Save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."
	| fileStream |
	fileStream := FileStream newFileNamed: filenameString asFileName.
	fileStream fileOutClass: nil andObject: self.	"Puts UniClass definitions out anyway, and closes the stream."! !

!Object methodsFor: 'macpal' stamp: ''!
scriptPerformer
	^ self! !

!Object methodsFor: 'scripting' stamp: ''!
selfWrittenAsIll
	^ self! !

!Object methodsFor: 'scripting' stamp: ''!
selfWrittenAsIm
	^ self! !

!Object methodsFor: 'scripting' stamp: ''!
selfWrittenAsMe
	^ self! !

!Object methodsFor: 'scripting' stamp: ''!
selfWrittenAsMy
	^ self! !

!Object methodsFor: 'scripting' stamp: ''!
selfWrittenAsThis
	^ self! !

!Object methodsFor: 'events-accessing' stamp: 'jmv 5/13/2009 10:16'!
setActionSequence: actionSequence
forEvent: anEventSelector

	| action |
	"This is a good time to compact the action sequence of old, garbage collected stuff."
	action := actionSequence asMinimalRepresentation.
	action
		ifNil: [ self removeActionsForEvent: anEventSelector]
		ifNotNil: [
			self updateableActionMap
				at: anEventSelector asSymbol
				put: action]! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
setHaltCountTo: t1 
	Smalltalk at: #HaltCount put: t1! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
setHaltOnce
	Smalltalk at: #HaltOnce put: true! !

!Object methodsFor: 'copying' stamp: ''!
shallowCopy
	| t1 t2 t3 |
	<primitive: 148>
	t1 := self class.
	t1 isVariable
		ifTrue: [t3 := self basicSize.
			t2 := t1 basicNew: t3.
			[t3 > 0]
				whileTrue: [t2
						basicAt: t3
						put: (self basicAt: t3).
					t3 := t3 - 1].
			nil]
		ifFalse: [t2 := t1 basicNew].
	t3 := t1 instSize.
	[t3 > 0]
		whileTrue: [t2
				instVarAt: t3
				put: (self instVarAt: t3).
			t3 := t3 - 1].
	^ t2! !

!Object methodsFor: 'error handling' stamp: ''!
shouldBeImplemented
	self error: 'This message should be implemented'! !

!Object methodsFor: 'testing' stamp: 'ul 11/23/2010 13:28'!
shouldBePrintedAsLiteral

	^self isLiteral! !

!Object methodsFor: 'testing' stamp: 'eem 11/2/2011 10:59'!
shouldBePrintedAsLiteralVisiting: aSet

	^self isLiteral! !

!Object methodsFor: 'error handling' stamp: ''!
shouldNotImplement
	self error: 'This message is not appropriate for this object'! !

!Object methodsFor: 'testing' stamp: ''!
showDiffs
	^ false! !

!Object methodsFor: 'accessing' stamp: ''!
size
	<primitive: 62>
	self class isVariable
		ifFalse: [self errorNotIndexable].
	^ 0! !

!Object methodsFor: 'macpal' stamp: ''!
slotInfo
	^ Dictionary new! !

!Object methodsFor: 'system primitives' stamp: ''!
someObject
	<primitive: 138>
	self primitiveFailed! !

!Object methodsFor: 'private' stamp: ''!
species
	<primitive: 111>
	^ self class! !

!Object methodsFor: 'testing' stamp: ''!
stepAt: t1 in: t2 
	^ self stepIn: t2! !

!Object methodsFor: 'testing' stamp: ''!
stepIn: t1 
	^ self step! !

!Object methodsFor: 'testing' stamp: ''!
stepTime
	^ 1000! !

!Object methodsFor: 'testing' stamp: ''!
stepTimeIn: t1 
	^ 1000! !

!Object methodsFor: 'private' stamp: ''!
storeAt: t1 inTempFrame: t2 
	^ t2 tempAt: t1 put: self! !

!Object methodsFor: 'objects from disk' stamp: ''!
storeDataOn: t1 
	| t2 t3 |
	t2 := self class instSize.
	t3 := self basicSize.
	t1 beginInstance: self class size: t2 + t3.
	1
		to: t2
		do: [:t4 | t1
				nextPut: (self instVarAt: t4)].
	(t1 byteStream class == DummyStream
			and: [self class isBits])
		ifFalse: [1
				to: t3
				do: [:t5 | t1
						nextPut: (self basicAt: t5)]]! !

!Object methodsFor: 'printing' stamp: ''!
storeOn: t1 
	t1 nextPut: $(.
	self class isVariable
		ifTrue: [t1 nextPutAll: '(' , self class name , ' basicNew: ';
				 store: self basicSize;
				 nextPutAll: ') ']
		ifFalse: [t1 nextPutAll: self class name , ' basicNew'].
	1
		to: self class instSize
		do: [:t2 | t1 nextPutAll: ' instVarAt: ';
				 store: t2;
				 nextPutAll: ' put: ';
				
				store: (self instVarAt: t2);
				 nextPut: $;].
	1
		to: self basicSize
		do: [:t4 | t1 nextPutAll: ' basicAt: ';
				 store: t4;
				 nextPutAll: ' put: ';
				
				store: (self basicAt: t4);
				 nextPut: $;].
	t1 nextPutAll: ' yourself)'! !

!Object methodsFor: 'filter streaming' stamp: ''!
storeOnStream: t1 
	self printOnStream: t1! !

!Object methodsFor: 'printing' stamp: ''!
storeString
	^ String
		streamContents: [:t1 | self storeOn: t1]! !

!Object methodsFor: 'printing' stamp: ''!
stringForReadout
	^ self stringRepresentation! !

!Object methodsFor: 'printing' stamp: ''!
stringRepresentation
	^ self printString! !

!Object methodsFor: 'error handling' stamp: ''!
subclassResponsibility
	self error: 'My subclass should have overridden ' , thisContext sender selector printString! !

!Object methodsFor: 'finalization' stamp: ''!
toFinalizeSend: t1 to: t2 with: t3 
	self == t2
		ifTrue: [self error: 'I cannot finalize myself'].
	self == t3
		ifTrue: [self error: 'I cannot finalize myself'].
	^ self finalizationRegistry
		add: self
		executor: (ObjectFinalizer
				receiver: t2
				selector: t1
				argument: t3)! !

!Object methodsFor: 'debugging-haltOnce' stamp: ''!
toggleHaltOnce
	self haltOnceEnabled
		ifTrue: [self clearHaltOnce]
		ifFalse: [self setHaltOnce]! !

!Object methodsFor: 'error handling' stamp: ''!
traitConflict
	self error: 'A class or trait does not properly resolve a conflict between multiple traits it uses.'! !

!Object methodsFor: 'events-triggering' stamp: ''!
triggerEvent: t1 
	^ (self actionForEvent: t1) value! !

!Object methodsFor: 'events-triggering' stamp: ''!
triggerEvent: t1 ifNotHandled: t2 
	^ (self
		actionForEvent: t1
		ifAbsent: [^ t2 value]) value! !

!Object methodsFor: 'events-triggering' stamp: ''!
triggerEvent: t1 with: t2 
	^ self
		triggerEvent: t1
		withArguments: (Array with: t2)! !

!Object methodsFor: 'events-triggering' stamp: ''!
triggerEvent: t1 with: t2 ifNotHandled: t3 
	^ self
		triggerEvent: t1
		withArguments: (Array with: t2)
		ifNotHandled: t3! !

!Object methodsFor: 'events-triggering' stamp: ''!
triggerEvent: t1 withArguments: t2 
	^ (self actionForEvent: t1)
		valueWithArguments: t2! !

!Object methodsFor: 'events-triggering' stamp: ''!
triggerEvent: t1 withArguments: t2 ifNotHandled: t3 
	^ (self
		actionForEvent: t1
		ifAbsent: [^ t3 value])
		valueWithArguments: t2! !

!Object methodsFor: 'updating' stamp: ''!
update: t1 
	^ self! !

!Object methodsFor: 'updating' stamp: ''!
update: t1 with: t2 
	^ self update: t1! !

!Object methodsFor: 'updating' stamp: ''!
updateListsAndCodeIn: t1 
	self canDiscardEdits
		ifFalse: [^ self].
	t1 updatablePanes
		do: [:t2 | t2 verifyContents]! !

!Object methodsFor: 'events-accessing' stamp: ''!
updateableActionMap
	^ EventManager updateableActionMapFor: self! !

!Object methodsFor: 'evaluating' stamp: ''!
value
	^ self! !

!Object methodsFor: 'evaluating' stamp: ''!
valueWithArguments: t1 
	^ self! !

!Object methodsFor: 'copying' stamp: ''!
veryDeepCopy
	| t1 t2 |
	t1 := DeepCopier new initialize: self initialDeepCopierSize.
	t2 := self veryDeepCopyWith: t1.
	t1 mapUniClasses.
	t1 references
		associationsDo: [:t3 | t3 value veryDeepFixupWith: t1].
	t1 fixDependents.
	^ t2! !

!Object methodsFor: 'copying' stamp: ''!
veryDeepCopySibling
	| t1 t2 |
	t1 := DeepCopier new initialize: self initialDeepCopierSize.
	t1 newUniClasses: false.
	t2 := self veryDeepCopyWith: t1.
	t1 mapUniClasses.
	t1 references
		associationsDo: [:t3 | t3 value veryDeepFixupWith: t1].
	t1 fixDependents.
	^ t2! !

!Object methodsFor: 'copying' stamp: ''!
veryDeepCopyUsing: t1 
	| t2 t3 |
	t2 := self veryDeepCopyWith: t1.
	t1 mapUniClasses.
	t1 references
		associationsDo: [:t4 | t4 value veryDeepFixupWith: t1].
	t3 := t1 references.
	DependentsFields
		associationsDo: [:t4 | t4 value
				do: [:t5 | | t7 | (t3
						at: t5
						ifAbsent: [])
						ifNotNil: [:t6 | 
							t7 := t3
										at: t4 key
										ifAbsent: [t4 key].
							t7 addDependent: t6]]].
	^ t2! !

!Object methodsFor: 'copying' stamp: ''!
veryDeepCopyWith: t1 
	| t2 t3 t4 t5 t6 t7 t8 t9 t10 |
	t1 references
		at: self
		ifPresent: [:t13 | ^ t13].
	t2 := self class.
	t2 isMeta
		ifTrue: [^ self].
	t6 := self clone.
	(t2 isSystemDefined not
			and: [t1 newUniClasses])
		ifTrue: [t7 := t1 uniClasses
						at: t2
						ifAbsent: [].
			t7
				ifNil: [t1 uniClasses at: t2 put: (t7 := self copyUniClassWith: t1).
					t1 references at: t2 put: t7].
			t6 := t7 new.
			t6 copyFrom: self].
	t1 references at: self put: t6.
	(t2 isVariable
			and: [t2 isPointers])
		ifTrue: [t3 := self basicSize.
			[t3 > 0]
				whileTrue: [t4 := self basicAt: t3.
					(t5 := t1 references
								associationAt: t4
								ifAbsent: [])
						ifNil: [t6
								basicAt: t3
								put: (t4 veryDeepCopyWith: t1)]
						ifNotNil: [t6 basicAt: t3 put: t5 value].
					t3 := t3 - 1]].
	t6 veryDeepInner: t1.
	t8 := t2.
	t3 := t2 instSize.
	[t9 := t8
				compiledMethodAt: #veryDeepInner:
				ifAbsent: [].
	t9 := t9
				ifNil: [t2 isSystemDefined not]
				ifNotNil: [true].
	t10 := t8 instVarNames.
	t9
		ifTrue: [t3 := t3 - t10 size]
		ifFalse: [1
				to: t10 size
				do: [:t11 | 
					t4 := self instVarAt: t3.
					(t5 := t1 references
								associationAt: t4
								ifAbsent: [])
						ifNil: [t6
								instVarAt: t3
								put: (t4 veryDeepCopyWith: t1)]
						ifNotNil: [t6 instVarAt: t3 put: t5 value].
					t3 := t3 - 1].
			nil].
	(t8 := t8 superclass) == nil] whileFalse.
	t6 rehash.
	^ t6! !

!Object methodsFor: 'copying' stamp: ''!
veryDeepFixupWith: t1 
	^ self! !

!Object methodsFor: 'copying' stamp: ''!
veryDeepInner: t1 
	^ self! !

!Object methodsFor: 'testing' stamp: ''!
vocabularyDemanded
	^ nil! !

!Object methodsFor: 'testing' stamp: ''!
wantsDiffFeedback
	^ false! !

!Object methodsFor: 'drag and drop' stamp: ''!
wantsDroppedMorph: t1 event: t2 inMorph: t3 
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
wantsSteps
	^ false! !

!Object methodsFor: 'testing' stamp: ''!
wantsStepsIn: t1 
	^ self wantsSteps! !

!Object methodsFor: 'events-registering' stamp: ''!
when: t1 evaluate: t2 
	| t3 |
	t3 := self actionSequenceForEvent: t1.
	(t3 includes: t2)
		ifTrue: [^ self].
	self
		setActionSequence: (t3 copyWith: t2)
		forEvent: t1! !

!Object methodsFor: 'events-registering' stamp: ''!
when: t1 send: t2 to: t3 
	self
		when: t1
		evaluate: (WeakMessageSend receiver: t3 selector: t2)! !

!Object methodsFor: 'events-registering' stamp: ''!
when: t1 send: t2 to: t3 with: t4 
	self
		when: t1
		evaluate: (WeakMessageSend
				receiver: t3
				selector: t2
				arguments: (Array with: t4))! !

!Object methodsFor: 'events-registering' stamp: ''!
when: t1 send: t2 to: t3 withArguments: t4 
	self
		when: t1
		evaluate: (WeakMessageSend
				receiver: t3
				selector: t2
				arguments: t4)! !

!Object methodsFor: 'user interface' stamp: ''!
windowActiveOnFirstClick
	^ false! !

!Object methodsFor: 'updating' stamp: ''!
windowIsClosing
	^ self! !

!Object methodsFor: 'user interface' stamp: ''!
windowReqNewLabel: t1 
	^ true! !

!Object methodsFor: 'message handling' stamp: 'ul 3/5/2011 10:55'!
with: arg1 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1"

	<primitive: 189>
	^ self withArgs: {arg1} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ul 3/5/2011 10:55'!
with: arg1 with: arg2 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1 & arg2"

	<primitive: 189>
	^ self withArgs: {arg1. arg2} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ul 3/5/2011 10:55'!
with: arg1 with: arg2 with: arg3 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1, arg2, & arg3"

	<primitive: 189>
	^ self withArgs: {arg1. arg2. arg3} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: 'ul 3/5/2011 10:55'!
with: arg1 with: arg2 with: arg3 with: arg4 executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and arg1, arg2, arg3, & arg4"

	<primitive: 189>
	^ self withArgs: {arg1. arg2. arg3. arg4} executeMethod: compiledMethod! !

!Object methodsFor: 'message handling' stamp: ''!
withArgs: t1 executeMethod: t2 
	| t3 |
	<primitive: 188>
	t3 := Symbol new.
	self class addSelectorSilently: t3 withMethod: t2.
	^ [self perform: t3 withArguments: t1]
		ensure: [self class basicRemoveSelector: t3]! !

!Object methodsFor: 'converting' stamp: ''!
withoutListWrapper
	^ self! !

!Object methodsFor: 'filter streaming' stamp: ''!
writeOnFilterStream: t1 
	t1 writeObject: self! !

!Object methodsFor: 'class membership' stamp: ''!
xxxClass
	^ self class! !

!Object methodsFor: 'accessing' stamp: ''!
yourself
	^ self! !

!Object methodsFor: 'comparing' stamp: ''!
~= t1 
	^ self = t1 == false! !

Object subclass: #Pragma
	instanceVariableNames: 'method keyword arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!Pragma commentStamp: 'fbs 5/8/2011 18:21' prior: 0!
I represent an occurrence of a pragma in a compiled method.  A pragma is a literal message pattern that occurs between angle brackets at the start of a method after any temporaries.  A common example is the primitive pragma:
	<primitive: 123 errorCode: 'errorCode'>
but one can add one's own and use them as metadata attached to a method.  Because pragmas are messages one can browse senders and implementors and perform them.  One can query a method for its pragmas by sending it the pragmas message, which answers an Array of instances of me, one for each pragma in the method.

I can provide information about the defining class, method, its selector, as well as the information about the pragma keyword and its arguments. See the two 'accessing' protocols for details. 'accessing-method' provides information about the method the pragma is found in, while 'accessing-pragma' is about the pragma itself.

Instances are retrieved using one of the pragma search methods of the 'finding' protocol on the class side.

To browse all methods with pragmas in the system evaluate
	SystemNavigation default browseAllSelect: [:m| m pragmas notEmpty]
and to browse all nonprimitive methods with pragmas evaluate
	SystemNavigation default browseAllSelect: [:m| m primitive isZero and: [m pragmas notEmpty]]!

!Pragma class methodsFor: 'finding' stamp: ''!
allNamed: t1 from: t2 to: t3 
	^ Array
		streamContents: [:t4 | t2
				withAllSuperclassesDo: [:t5 | 
					self
						withPragmasIn: t5
						do: [:t6 | t6 keyword = t1
								ifTrue: [t4 nextPut: t6]].
					t3 = t5
						ifTrue: [^ t4 contents].
					nil]]! !

!Pragma class methodsFor: 'finding' stamp: ''!
allNamed: t1 from: t2 to: t3 sortedByArgument: t4 
	^ self
		allNamed: t1
		from: t2
		to: t3
		sortedUsing: [:t5 :t6 | (t5 argumentAt: t4)
				< (t6 argumentAt: t4)]! !

!Pragma class methodsFor: 'finding' stamp: ''!
allNamed: t1 from: t2 to: t3 sortedUsing: t4 
	^ (self
		allNamed: t1
		from: t2
		to: t3)
		sort: t4! !

!Pragma class methodsFor: 'finding' stamp: ''!
allNamed: t1 in: t2 
	^ Array
		streamContents: [:t3 | self
				withPragmasIn: t2
				do: [:t4 | t4 keyword = t1
						ifTrue: [t3 nextPut: t4]]]! !

!Pragma class methodsFor: 'finding' stamp: ''!
allNamed: t1 in: t2 sortedByArgument: t3 
	^ self
		allNamed: t1
		in: t2
		sortedUsing: [:t4 :t5 | (t4 argumentAt: t3)
				< (t5 argumentAt: t3)]! !

!Pragma class methodsFor: 'finding' stamp: ''!
allNamed: t1 in: t2 sortedUsing: t3 
	^ (self allNamed: t1 in: t2)
		sort: t3! !

!Pragma class methodsFor: 'instance creation' stamp: ''!
for: t1 selector: t2 arguments: t3 
	^ self new setMethod: t1;
		 setKeyword: t2;
		 setArguments: t3;
		 yourself! !

!Pragma class methodsFor: 'private' stamp: ''!
keyword: t1 arguments: t2 
	^ self new setKeyword: t1;
		 setArguments: t2;
		 yourself! !

!Pragma class methodsFor: 'private' stamp: ''!
withPragmasIn: t1 do: t2 
	t1
		selectorsAndMethodsDo: [:t3 :t4 | t4 pragmas do: t2]! !

!Pragma methodsFor: 'comparing' stamp: 'eem 10/4/2011 10:41'!
= anObject 
	^self class == anObject class
	  and: [keyword == anObject keyword
	  and: [arguments = anObject arguments]]! !

!Pragma methodsFor: 'comparing' stamp: ''!
analogousCodeTo: t1 
	^ self class == t1 class
		and: [keyword == t1 keyword
				and: [arguments = t1 arguments]]! !

!Pragma methodsFor: 'accessing-pragma' stamp: ''!
argumentAt: t1 
	^ self arguments at: t1! !

!Pragma methodsFor: 'accessing-pragma' stamp: ''!
arguments
	^ arguments! !

!Pragma methodsFor: 'testing' stamp: ''!
hasLiteral: t1 
	^ keyword == t1
		or: [arguments hasLiteral: t1]! !

!Pragma methodsFor: 'testing' stamp: ''!
hasLiteralSuchThat: t1 
	^ (t1 value: keyword)
		or: [arguments hasLiteralSuchThat: t1]! !

!Pragma methodsFor: 'comparing' stamp: 'eem 10/4/2011 10:41'!
hash
	^keyword hash + arguments hash! !

!Pragma methodsFor: 'accessing-pragma' stamp: ''!
key
	^ keyword! !

!Pragma methodsFor: 'accessing-pragma' stamp: ''!
keyword
	^ keyword! !

!Pragma methodsFor: 'accessing-pragma' stamp: ''!
message
	^ Message selector: self keyword arguments: self arguments! !

!Pragma methodsFor: 'accessing-method' stamp: ''!
method
	^ method! !

!Pragma methodsFor: 'accessing-method' stamp: ''!
methodClass
	^ method methodClass! !

!Pragma methodsFor: 'accessing-pragma' stamp: ''!
numArgs
	^ self arguments size! !

!Pragma methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPut: $<.
	self keyword precedence = 1
		ifTrue: [t1 nextPutAll: self keyword]
		ifFalse: [self keyword keywords
				with: self arguments
				do: [:t2 :t3 | t1 nextPutAll: t2;
						 space;
						 print: t3;
						 space].
			t1 skip: -1].
	t1 nextPut: $>! !

!Pragma methodsFor: 'accessing-method' stamp: ''!
selector
	^ method selector! !

!Pragma methodsFor: 'initialization' stamp: ''!
setArguments: t1 
	arguments := t1! !

!Pragma methodsFor: 'initialization' stamp: ''!
setKeyword: t1 
	keyword := t1! !

!Pragma methodsFor: 'initialization' stamp: ''!
setMethod: t1 
	method := t1! !

Object subclass: #ProcessSpecificVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes-Variables'!

ProcessSpecificVariable class
	instanceVariableNames: 'hash'!

!ProcessSpecificVariable commentStamp: 'mvl 3/13/2007 13:53' prior: 0!
My subclasses (not instances of them) keep state specific to the current process.

There are two kinds of process-specific variables: process-local (state available
for read and write in all methods inside the process), and dynamic variables
(implementing dynamic scope).!

ProcessSpecificVariable class
	instanceVariableNames: 'hash'!

ProcessSpecificVariable subclass: #DynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes-Variables'!

!DynamicVariable commentStamp: 'mvl 3/13/2007 13:55' prior: 0!
My subclasses are dynamic variables: each subclass represents a variable
whose value persists inside the block passed to #value:during:. There is
no way to change the value inside such a block, but it is possible to
temporarirly rebind it in a nested manner.!

!DynamicVariable class methodsFor: 'accessing' stamp: 'ul 8/16/2011 11:23'!
value: anObject during: aBlock

	| p oldValue |
	p := Processor activeProcess.
	oldValue := p environmentAt: self ifAbsent: [self default].
	^[
		p environmentAt: self put: anObject.
		aBlock value ] 
			ensure: [ p environmentAt: self put: oldValue ].! !

ProcessSpecificVariable subclass: #ProcessLocalVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes-Variables'!

!ProcessLocalVariable commentStamp: 'mvl 3/13/2007 12:28' prior: 0!
My subclasses have values specific to the active process. They can be read with #value and set with #value:!

!ProcessLocalVariable class methodsFor: 'accessing' stamp: 'ul 9/17/2011 17:41'!
value: anObject
	
	^Processor activeProcess environmentAt: self put: anObject! !

!ProcessSpecificVariable class methodsFor: 'accessing' stamp: 'mvl 3/13/2007 14:32'!
default
	"Answer the default value for the variable. The default for the default value is nil."
	^nil! !

!ProcessSpecificVariable class methodsFor: 'accessing' stamp: 'ul 8/16/2011 11:22'!
hash
	
	^hash ifNil: [ hash := super hash ]! !

!ProcessSpecificVariable class methodsFor: 'accessing' stamp: 'mvl 3/13/2007 14:33'!
value
	"Answer the current value for this variable in the current context."
	^Processor activeProcess environmentAt: self ifAbsent: [self default].! !

Object subclass: #ProcessorScheduler
	instanceVariableNames: 'quiescentProcessLists activeProcess'
	classVariableNames: 'BackgroundProcess HighIOPriority LowIOPriority SystemBackgroundPriority SystemRockBottomPriority TimingPriority UserBackgroundPriority UserInterruptPriority UserSchedulingPriority'
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!ProcessorScheduler class methodsFor: 'background process' stamp: 'ul 6/17/2011 12:41'!
idleProcess
	"A default background process which is invisible."

	[self relinquishProcessorForMicroseconds: 1000] repeat! !

!ProcessorScheduler class methodsFor: 'class initialization' stamp: ''!
initialize
	SystemRockBottomPriority := 10.
	SystemBackgroundPriority := 20.
	UserBackgroundPriority := 30.
	UserSchedulingPriority := 40.
	UserInterruptPriority := 50.
	LowIOPriority := 60.
	HighIOPriority := 70.
	TimingPriority := 80! !

!ProcessorScheduler class methodsFor: 'instance creation' stamp: ''!
new
	self error: 'New ProcessSchedulers should not be created since
the integrity of the system depends on a unique scheduler'! !

!ProcessorScheduler class methodsFor: 'background process' stamp: ''!
relinquishProcessorForMicroseconds: t1 
	<primitive: 230>
	^ self! !

!ProcessorScheduler class methodsFor: 'background process' stamp: ''!
startUp
	Smalltalk installLowSpaceWatcher.
	BackgroundProcess
		ifNotNil: [BackgroundProcess terminate].
	BackgroundProcess := [self idleProcess] newProcess.
	BackgroundProcess priority: SystemRockBottomPriority.
	BackgroundProcess resume! !

!ProcessorScheduler class methodsFor: 'background process' stamp: 'ul 6/17/2011 12:41'!
sweepHandIdleProcess
	"A default background process which shows a sweeping circle of XOR-ed bits on the screen."

	| sweepHand |
	sweepHand := Pen new.
	sweepHand defaultNib: 2.
	sweepHand combinationRule: 6.
	[
		2 timesRepeat: [
			sweepHand north.
			36 timesRepeat: [
				sweepHand place: Display boundingBox topRight + (-25@25).
				sweepHand go: 20.
				sweepHand turn: 10]].
		self relinquishProcessorForMicroseconds: 10000] repeat
! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
activePriority
	^ activeProcess priority! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
activeProcess
	^ activeProcess! !

!ProcessorScheduler methodsFor: 'private' stamp: ''!
anyProcessesAbove: t1 
	^ (Process allSubInstances
		select: [:t2 | t2 priority > t1]) isEmpty! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
backgroundProcess
	^ BackgroundProcess! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
highIOPriority
	^ HighIOPriority! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
highestPriority
	^ quiescentProcessLists size! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
highestPriority: t1 
	| t2 t3 |
	(quiescentProcessLists size > t1
			and: [self anyProcessesAbove: t1])
		ifTrue: [self error: 'There are processes with priority higher than ' , t1 printString].
	t3 := Array new: t1.
	1
		to: (quiescentProcessLists size min: t3 size)
		do: [:t4 | t3
				at: t4
				put: (quiescentProcessLists at: t4)].
	quiescentProcessLists size
		to: t3 size
		do: [:t6 | t3 at: t6 put: LinkedList new].
	quiescentProcessLists := t3! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
lowIOPriority
	^ LowIOPriority! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
lowestPriority
	^ SystemRockBottomPriority! !

!ProcessorScheduler methodsFor: 'CPU usage tally' stamp: ''!
nextReadyProcess
	quiescentProcessLists
		reverseDo: [:t1 | | t2 | t1 isEmpty
				ifFalse: [t2 := t1 first.
					t2 suspendedContext
						ifNotNil: [^ t2]]].
	^ nil! !

!ProcessorScheduler methodsFor: 'objects from disk' stamp: ''!
objectForDataStream: t1 
	| t2 |
	t2 := DiskProxy
				global: #Processor
				selector: #yourself
				args: #().
	t1 replace: self with: t2.
	^ t2! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
preemptedProcess
	| t1 |
	activeProcess priority
		to: 1
		by: -1
		do: [:t2 | 
			t1 := quiescentProcessLists at: t2.
			t1 isEmpty
				ifFalse: [^ t1 last]].
	^ nil! !

!ProcessorScheduler methodsFor: 'removing' stamp: ''!
remove: t1 ifAbsent: t2 
	(quiescentProcessLists at: t1 priority)
		remove: t1
		ifAbsent: t2.
	^ t1! !

!ProcessorScheduler methodsFor: 'process state change' stamp: ''!
suspendFirstAt: t1 
	^ self
		suspendFirstAt: t1
		ifNone: [self error: 'No Process to suspend']! !

!ProcessorScheduler methodsFor: 'process state change' stamp: ''!
suspendFirstAt: t1 ifNone: t2 
	| t3 |
	t3 := quiescentProcessLists at: t1.
	t3 isEmpty
		ifTrue: [^ t2 value].
	^ t3 first suspend! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
systemBackgroundPriority
	^ SystemBackgroundPriority! !

!ProcessorScheduler methodsFor: 'CPU usage tally' stamp: ''!
tallyCPUUsageFor: t1 
	^ self tallyCPUUsageFor: t1 every: 10! !

!ProcessorScheduler methodsFor: 'CPU usage tally' stamp: ''!
tallyCPUUsageFor: t1 every: t2 
	| t3 t4 t5 t6 |
	t3 := IdentityBag new: 200.
	t5 := Delay forMilliseconds: t2 truncated.
	t6 := Delay forSeconds: t1.
	t6 schedule.
	t4 := Semaphore new.
	[[t6 isExpired]
		whileFalse: [t5 wait.
			t3 add: Processor nextReadyProcess].
	t4 signal]
		forkAt: self highestPriority.
	^ [t4 wait.
	t3]! !

!ProcessorScheduler methodsFor: 'process state change' stamp: ''!
terminateActive
	activeProcess terminate! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
timingPriority
	^ TimingPriority! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
userBackgroundPriority
	^ UserBackgroundPriority! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
userInterruptPriority
	^ UserInterruptPriority! !

!ProcessorScheduler methodsFor: 'priority names' stamp: ''!
userSchedulingPriority
	^ UserSchedulingPriority! !

!ProcessorScheduler methodsFor: 'accessing' stamp: ''!
waitingProcessesAt: t1 
	^ quiescentProcessLists at: t1! !

!ProcessorScheduler methodsFor: 'process state change' stamp: ''!
yield
	| t1 |
	<primitive: 167>
	t1 := Semaphore new.
	[t1 signal] fork.
	t1 wait! !

Object subclass: #Promise
	instanceVariableNames: 'isResolved value resolvers mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Promise methodsFor: 'private' stamp: 'fbs 6/7/2012 21:45'!
evaluateResolver: resolverBlock
	resolverBlock cull: value.! !

!Promise methodsFor: 'initialize' stamp: ''!
initialize
	isResolved := false.
	resolvers := #().
	mutex := Mutex new! !

!Promise methodsFor: 'testing' stamp: ''!
isResolved
	^ isResolved! !

!Promise methodsFor: 'resolving' stamp: 'fbs 6/7/2012 21:46'!
resolveWith: arg
	"Resolve this promise"
	mutex critical: [
		isResolved ifTrue: [self error: 'Promise was already resolved'].
		value := arg.
		isResolved := true.
		resolvers do: [:r | self evaluateResolver: r].
	].! !

!Promise methodsFor: 'accessing' stamp: ''!
value
	^ value! !

!Promise methodsFor: 'waiting' stamp: ''!
wait
	| t1 |
	t1 := Semaphore new.
	self
		whenResolved: [t1 signal].
	t1 wait.
	^ value! !

!Promise methodsFor: 'waiting' stamp: ''!
waitTimeoutMSecs: t1 
	| t2 t3 |
	t2 := Semaphore new.
	self
		whenResolved: [t2 signal].
	t3 := Delay timeoutSemaphore: t2 afterMSecs: t1.
	[t2 wait]
		ensure: [t3 unschedule].
	^ isResolved! !

!Promise methodsFor: 'waiting' stamp: ''!
waitTimeoutSeconds: t1 
	^ self waitTimeoutMSecs: t1 * 1000! !

!Promise methodsFor: 'resolving' stamp: ''!
whenResolved: t1 
	t1 numArgs <= 1
		ifFalse: [self error: 'Must be 0- or 1-argument block'].
	mutex
		critical: [resolvers := resolvers copyWith: t1.
			self isResolved
				ifTrue: [self evaluateResolver: t1]]! !

ProtoObject subclass: #ObjectOut
	instanceVariableNames: 'url page recursionFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!ObjectOut methodsFor: 'object storage' stamp: ''!
comeFullyUpOnReload: t1 
	(SqueakPageCache pageCache
		at: page
		ifAbsent: [])
		ifNotNil: [:t2 | t2 isContentsInMemory
				ifTrue: [^ t2 contentsMorph]]! !

!ObjectOut methodsFor: 'fetch from disk' stamp: ''!
doesNotUnderstand: t1 
	| t2 t3 t4 |
	t3 := recursionFlag.
	recursionFlag := true.
	t2 := self xxxFetch.
	t3 == true
		ifTrue: [t4 := UIManager default chooseFrom: #('proceed normally' 'debug' ) title: 'Object being fetched for a second time.
Should not happen, and needs to be fixed later.'.
			t4 = 2
				ifTrue: [self halt]].
	^ t2 perform: t1 selector withArguments: t1 arguments! !

!ObjectOut methodsFor: 'basics' stamp: ''!
isInMemory
	^ false! !

!ObjectOut methodsFor: 'object storage' stamp: ''!
objectForDataStream: t1 
	^ self! !

!ObjectOut methodsFor: 'object storage' stamp: ''!
readDataFrom: t1 size: t2 
	| t3 |
	t3 := self xxxClass instSize.
	self xxxClass isVariable
		ifTrue: [self xxxClass error: 'needs updating']
		ifFalse: [t3 := t2].
	t1 beginReference: self.
	1
		to: t3
		do: [:t4 | self xxxInstVarAt: t4 put: t1 next]! !

!ObjectOut methodsFor: 'object storage' stamp: ''!
storeDataOn: t1 
	| t2 |
	t2 := self class instSize.
	t1 beginInstance: self xxxClass size: t2.
	1
		to: t2
		do: [:t3 | t1
				nextPut: (self xxxInstVarAt: t3)]! !

!ObjectOut methodsFor: 'access' stamp: ''!
url: t1 
	url := t1! !

!ObjectOut methodsFor: 'object storage' stamp: ''!
veryDeepCopyWith: t1 
	| t2 t3 t4 t6 t7 |
	t6 := t1 references
				at: self
				ifAbsent: [t7 := true].
	t7
		ifNil: [^ t6].
	t2 := self xxxClass.
	t2 isMeta
		ifTrue: [^ self].
	t6 := self xxxClone.
	t1 references at: self put: t6.
	t3 := t2 instSize.
	[t3 > 0]
		whileTrue: [t4 := self xxxInstVarAt: t3.
			(t1 references
				associationAt: t4
				ifAbsent: [])
				ifNil: [t6
						xxxInstVarAt: t3
						put: (t4 veryDeepCopyWith: t1)]
				ifNotNil: [:t5 | t6 xxxInstVarAt: t3 put: t5 value].
			t3 := t3 - 1].
	t6 rehash.
	^ t6! !

!ObjectOut methodsFor: 'basics' stamp: ''!
xxxClass
	<primitive: 111>
	self primitiveFailed! !

!ObjectOut methodsFor: 'basics' stamp: ''!
xxxClone
	<primitive: 148>
	self primitiveFailed! !

!ObjectOut methodsFor: 'fetch from disk' stamp: ''!
xxxFetch
	| t1 t2 t3 |
	t3 := SqueakPageCache pageCache
				at: url
				ifAbsent: [].
	t3
		ifNotNil: [t3 isContentsInMemory
				ifTrue: [page := t1 := t3]].
	t1
		ifNil: [t1 := SqueakPageCache atURL: url oldPage: page].
	t2 := t1 isContentsInMemory
				ifTrue: [t1 contentsMorph]
				ifFalse: [t1 fetchInformIfError].
	t2
		ifNil: [^ 'Object could not be fetched.'].
	t1 contentsMorph: t2.
	page := t1.
	self xxxFixup.
	^ t2! !

!ObjectOut methodsFor: 'fetch from disk' stamp: ''!
xxxFixup
	| t1 t2 t3 |
	t1 := page contentsMorph.
	t1 == self
		ifTrue: [page error: 'should be converted by now'].
	t2 := self.
	t3 := (Utilities pointersTo: t2) asOrderedCollection.
	t3 add: thisContext.
	t3 add: thisContext sender.
	t3
		do: [:t4 | 
			1
				to: t4 class instSize
				do: [:t5 | (t4 instVarAt: t5)
							== t2
						ifTrue: [t4 instVarAt: t5 put: t1]].
			1
				to: t4 basicSize
				do: [:t7 | (t4 basicAt: t7)
							== t2
						ifTrue: [t4 basicAt: t7 put: t1]].
			nil].
	^ t1! !

!ObjectOut methodsFor: 'basics' stamp: ''!
xxxInstVarAt: t1 
	<primitive: 73>
	self primitiveFailed! !

!ObjectOut methodsFor: 'basics' stamp: ''!
xxxInstVarAt: t1 put: t2 
	<primitive: 74>
	self primitiveFailed! !

!ObjectOut methodsFor: 'access' stamp: ''!
xxxReset
	recursionFlag := nil! !

!ObjectOut methodsFor: 'fetch from disk' stamp: ''!
xxxSetUrl: t1 page: t2 
	url := t1.
	page := t2! !

ProtoObject subclass: #ObjectTracer
	instanceVariableNames: 'tracedObject recursionFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!ObjectTracer commentStamp: '<historical>' prior: 0!
An ObjectTracer can be wrapped around another object, and then give you a chance to inspect it whenever it receives messages from the outside.  For instance...
	(ObjectTracer on: Display) flash: (50@50 extent: 50@50)
will give control to a debugger just before the message flash is sent.
Obviously this facility can be embellished in many useful ways.
See also the even more perverse subclass, ObjectViewer, and its example.
!

!ObjectTracer class methodsFor: 'instance creation' stamp: ''!
on: t1 
	^ self new xxxViewedObject: t1! !

!ObjectTracer methodsFor: 'very few messages' stamp: ''!
doesNotUnderstand: t1 
	ToolSet
		debugContext: thisContext
		label: 'About to perform: ' , t1 selector
		contents: nil.
	^ t1 sentTo: tracedObject! !

!ObjectTracer methodsFor: 'very few messages' stamp: ''!
xxxUnTrace
	tracedObject become: self! !

!ObjectTracer methodsFor: 'very few messages' stamp: ''!
xxxViewedObject
	^ tracedObject! !

!ObjectTracer methodsFor: 'very few messages' stamp: ''!
xxxViewedObject: t1 
	tracedObject := t1! !

ObjectTracer subclass: #ObjectViewer
	instanceVariableNames: 'valueBlock lastValue changeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!ObjectViewer methodsFor: 'very few messages' stamp: 'bf 4/5/2011 15:36'!
doesNotUnderstand: aMessage 
	"Check for change after sending aMessage"
	| returnValue newValue |
	recursionFlag ifTrue: [^ aMessage sendTo: tracedObject].
	recursionFlag := true.
	returnValue := aMessage sendTo: tracedObject.
	newValue := valueBlock valueWithPossibleArgument: aMessage.
	newValue = lastValue ifFalse:
		[changeBlock valueWithPossibleArgument: aMessage..
		lastValue := newValue].
	recursionFlag := false.
	^ returnValue! !

!ObjectViewer methodsFor: 'very few messages' stamp: ''!
xxxViewedObject: t1 evaluate: t2 wheneverChangeIn: t3 
	tracedObject := t1.
	valueBlock := t3.
	changeBlock := t2.
	recursionFlag := false! !

!ProtoObject class methodsFor: 'as yet unclassified' stamp: ''!
initializedInstance
	^ nil! !

!ProtoObject methodsFor: 'comparing' stamp: ''!
== t1 
	<primitive: 110>
	self primitiveFailed! !

!ProtoObject methodsFor: 'system primitives' stamp: ''!
become: t1 
	(Array with: self)
		elementsExchangeIdentityWith: (Array with: t1)! !

!ProtoObject methodsFor: 'system primitives' stamp: ''!
cannotInterpret: t1 
	(self class lookupSelector: t1 selector)
		ifNotNil: [^ t1 sentTo: self].
	Error signal: 'MethodDictionary fault'.
	^ t1 sentTo: self! !

!ProtoObject methodsFor: 'debugging' stamp: ''!
doOnlyOnce: t1 
	(Smalltalk
			at: #OneShotArmed
			ifAbsent: [true])
		ifTrue: [Smalltalk at: #OneShotArmed put: false.
			t1 value]! !

!ProtoObject methodsFor: 'system primitives' stamp: ''!
doesNotUnderstand: t1 
	^ MessageNotUnderstood new message: t1;
		 receiver: self;
		 signal! !

!ProtoObject methodsFor: 'debugging' stamp: ''!
flag: t1 
	^ self! !

!ProtoObject methodsFor: 'comparing' stamp: ''!
identityHash
	<primitive: 75>
	self primitiveFailed! !

!ProtoObject methodsFor: 'testing' stamp: ''!
ifNil: t1 
	^ self! !

!ProtoObject methodsFor: 'testing' stamp: 'ul 8/12/2010 00:04'!
ifNil: nilBlock ifNotNil: ifNotNilBlock
	"Evaluate the block, unless I'm == nil (q.v.)"

	^ ifNotNilBlock cull: self! !

!ProtoObject methodsFor: 'testing' stamp: 'ul 8/12/2010 00:04'!
ifNotNil: ifNotNilBlock
	"Evaluate the block, unless I'm == nil (q.v.)"

	^ ifNotNilBlock cull: self! !

!ProtoObject methodsFor: 'testing' stamp: 'ul 8/12/2010 00:04'!
ifNotNil: ifNotNilBlock ifNil: nilBlock 
	"If I got here, I am not nil, so evaluate the block ifNotNilBlock"

	^ ifNotNilBlock cull: self! !

!ProtoObject methodsFor: 'initialize-release' stamp: ''!
initialize
	^ self! !

!ProtoObject methodsFor: 'system primitives' stamp: 'mtf 8/15/2008 17:19'!
instVarsInclude: anObject
"Answers true if anObject is among my named or indexed instance variables, and false otherwise"

	<primitive: 132>
	1 to: self class instSize do:
		[:i | (self instVarAt: i) == anObject ifTrue: [^ true]].
	1 to: self basicSize do:
		[:i | (self basicAt: i) == anObject ifTrue: [^ true]].
	^ false! !

!ProtoObject methodsFor: 'testing' stamp: ''!
isInMemory
	^ true! !

!ProtoObject methodsFor: 'testing' stamp: ''!
isNil
	^ false! !

!ProtoObject methodsFor: 'system primitives' stamp: ''!
nextInstance
	<primitive: 78>
	^ nil! !

!ProtoObject methodsFor: 'system primitives' stamp: ''!
nextObject
	<primitive: 139>
	self primitiveFailed! !

!ProtoObject methodsFor: 'tracing' stamp: 'ul 9/2/2012 19:00'!
pointsOnlyWeaklyTo: anObject
	"Assume, we already know that receiver points to an object, answer true if receiver points only weakly to it."
	
	self class isWeak ifFalse: [ ^false ].
	1 to: self class instSize do: [ :i |
		(self instVarAt: i) == anObject ifTrue: [ ^false ] ].
	^true! !

!ProtoObject methodsFor: 'tracing' stamp: 'mtf 8/15/2008 18:40'!
pointsTo: anObject
"Answers true if I hold a reference to anObject, or false otherwise. Or stated another way:

Answers true if the garbage collector would fail to collect anObject because I hold a reference to it, or false otherwise"

	^ (self instVarsInclude: anObject)
		or: [self class == anObject]! !

!ProtoObject methodsFor: 'debugging' stamp: ''!
rearmOneShot
	Smalltalk at: #OneShotArmed put: true! !

!ProtoObject methodsFor: 'objects from disk' stamp: ''!
rehash
	^ self! !

!ProtoObject methodsFor: 'comparing' stamp: ''!
scaledIdentityHash
	^ self identityHash * 262144! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 with: t3 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 with: t3 with: t4 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 with: t3 with: t4 with: t5 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 with: t3 with: t4 with: t5 with: t6 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 with: t3 with: t4 with: t5 with: t6 with: t7 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryNamedPrimitive: t1 with: t2 with: t3 with: t4 with: t5 with: t6 with: t7 with: t8 
	<primitive: '' module: ''>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'apply primitives' stamp: ''!
tryPrimitive: t1 withArgs: t2 
	<primitive: 118>
	^ ContextPart primitiveFailToken! !

!ProtoObject methodsFor: 'debugging' stamp: ''!
withArgs: t1 executeMethod: t2 
	<primitive: 188>
	self primitiveFailed! !

!ProtoObject methodsFor: 'comparing' stamp: ''!
~~ t1 
	self == t1
		ifTrue: [^ false].
	^ true! !

Object subclass: #Random
	instanceVariableNames: 'seed a m q r'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!Random class methodsFor: 'testing' stamp: ''!
bucketTest: t1 
	| t2 t3 t4 |
	t2 := 20.
	t3 := Array new: t2.
	t3 atAllPut: 0.
	t4 := 100.
	t4 * t2
		timesRepeat: [| t6 |
			t6 := (t1 next * t2) floor + 1.
			t3 at: t6 put: (t3 at: t6)
					+ 1].
	Transcript cr.
	1
		to: t2
		do: [:t5 | Transcript show: (t3 at: t5) printString , ' ']! !

!Random class methodsFor: 'instance creation' stamp: ''!
seed: t1 
	^ self new seed: t1! !

!Random methodsFor: 'die rolling' stamp: ''!
check: t1 
	^ self check: t1 difficulty: 6! !

!Random methodsFor: 'die rolling' stamp: ''!
check: t1 against: t2 
	^ self
		check: t1
		against: t2
		difficulty: 6! !

!Random methodsFor: 'die rolling' stamp: ''!
check: t1 against: t2 difficulty: t3 
	| t4 t5 |
	t4 := self check: t1 difficulty: t3.
	t4 < 0
		ifTrue: [^ t4].
	t5 := self check: t2 difficulty: t3.
	^ t4 - t5 min: 0! !

!Random methodsFor: 'die rolling' stamp: ''!
check: t1 difficulty: t2 
	| t3 |
	t3 := 0.
	t1
		timesRepeat: [| t5 | (t5 := self nextInt: 10) = 1
				ifTrue: [t3 := t3 - 1]
				ifFalse: [t5 >= t2
						ifTrue: [t3 := t3 + 1]]].
	^ t3! !

!Random methodsFor: 'die rolling' stamp: ''!
diceToken: t1 
	t1 atEnd
		ifTrue: [^ nil].
	t1 peek isDigit
		ifTrue: [^ Number readFrom: t1].
	^ t1 next asLowercase! !

!Random methodsFor: 'initialization' stamp: ''!
initialize
	[seed := (Time millisecondClockValue bitAnd: 1073741823)
				bitXor: self hash.
	seed = 0] whileTrue.
	a := 16807 asFloat.
	m := 2147483647 asFloat.
	q := (m quo: a) asFloat.
	r := (m \\ a) asFloat! !

!Random methodsFor: 'accessing' stamp: ''!
next
	^ (seed := self nextValue) / m! !

!Random methodsFor: 'accessing' stamp: ''!
next: t1 
	^ self
		next: t1
		into: (Array new: t1)! !

!Random methodsFor: 'accessing' stamp: ''!
next: t1 into: t2 
	1
		to: t1
		do: [:t3 | t2 at: t3 put: self next].
	^ t2! !

!Random methodsFor: 'accessing' stamp: ''!
nextInt: t1 
	t1 strictlyPositive
		ifFalse: [self error: 'Range must be positive'].
	^ (self next * t1) truncated + 1! !

!Random methodsFor: 'private' stamp: ''!
nextValue
	| t1 t2 t3 t4 |
	t2 := (seed quo: q) asFloat.
	t1 := seed - (t2 * q).
	t3 := a * t1 - (r * t2).
	t4 := t3 > 0.0
				ifTrue: [t3]
				ifFalse: [t3 + m].
	^ t4! !

!Random methodsFor: 'die rolling' stamp: ''!
roll: t1 
	| t2 t3 t4 t5 t6 t7 |
	t2 := t1 readStream.
	t4 := 0.
	t3 := #+.
	[t7 := self diceToken: t2.
	t7 isNumber
		ifTrue: [t6 := t7.
			t7 := self diceToken: t2]
		ifFalse: [t7 == $d
				ifTrue: [t6 := 1]
				ifFalse: [_r8 := 0]].
	t7 == $d
		ifTrue: [t7 := self diceToken: t2.
			t7 isNumber
				ifTrue: [t5 := t7.
					t7 := self diceToken: t2]
				ifFalse: [t7 == $%
						ifTrue: [t5 := 100.
							t7 := self diceToken: t2]
						ifFalse: [t5 := 6]].
			_r8 := 0.
			t6
				timesRepeat: [_r8 := _r8
								+ (self nextInt: t5)]].
	t4 := t4 perform: t3 with: _r8.
	t7
		ifNil: [^ t4].
	(t7 == $+
			or: [t7 == $-])
		ifFalse: [self error: 'unknown token ' , t7].
	t3 := t7 asSymbol] repeat! !

!Random methodsFor: 'private' stamp: ''!
seed
	^ seed! !

!Random methodsFor: 'initialization' stamp: ''!
seed: t1 
	seed := t1! !

InstructionPrinter subclass: #RelativeInstructionPrinter
	instanceVariableNames: 'printCode labels labelling'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!RelativeInstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
jump: t1 
	labelling
		ifTrue: [labels at: scanner pc + t1 + 1 put: true.
			self print: 'jumpBy: ' , t1 printString , ' to: ' , (scanner pc + t1 - method initialPC) printString]
		ifFalse: [self print: 'jumpTo: '
					, (labels at: scanner pc + t1 + 1)]! !

!RelativeInstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
jump: t1 if: t2 
	labelling
		ifTrue: [labels at: scanner pc + t1 + 1 put: true.
			self print: (t2
					ifTrue: ['jumpTrueBy: ']
					ifFalse: ['jumpFalseBy: '])
					, t1 printString , ' to: '
					, (labelling
							ifTrue: [(scanner pc + t1 - method initialPC) printString]
							ifFalse: [labels at: scanner pc + t1])]
		ifFalse: [self print: (t2
					ifTrue: ['jumpTrueTo: ']
					ifFalse: ['jumpFalseTo: '])
					, (labels at: scanner pc + t1 + 1)]! !

!RelativeInstructionPrinter methodsFor: 'printing' stamp: ''!
print: t1 
	| t3 |
	stream tab: self indent.
	labelling
		ifTrue: [stream print: oldPC - method initialPC;
				 space]
		ifFalse: [stream tab].
	stream
		tab: (innerIndents at: oldPC).
	self printCode
		ifTrue: [stream nextPut: $<.
			oldPC
				to: scanner pc - 1
				do: [:t2 | 
					t3 := (method at: t2)
								radix: 16.
					stream
						nextPut: (t3 size < 2
								ifTrue: [$0]
								ifFalse: [t3 at: 1]);
						 nextPut: t3 last;
						 space].
			stream skip: -1;
				 nextPut: $>;
				 space].
	stream nextPutAll: t1.
	stream cr.
	labelling
		ifFalse: [(labels at: scanner pc + 1)
					~~ false
				ifTrue: [stream
						nextPutAll: (labels at: scanner pc + 1);
						 nextPut: $:;
						 cr]].
	oldPC := scanner pc! !

!RelativeInstructionPrinter methodsFor: 'printing' stamp: ''!
printCode
	^ printCode ~~ false! !

!RelativeInstructionPrinter methodsFor: 'initialize-release' stamp: ''!
printCode: t1 
	printCode := t1! !

!RelativeInstructionPrinter methodsFor: 'printing' stamp: ''!
printInstructionsOn: t1 
	| t2 |
	labelling := true.
	labels := Array new: method size + 1 withAll: false.
	super printInstructionsOn: (String new: 1024) writeStream.
	t2 := 0.
	labels
		withIndexDo: [:t4 :t5 | t4
				ifTrue: [labels at: t5 put: 'L' , (t2 := t2 + 1) printString]].
	labelling := false.
	super printInstructionsOn: t1! !

!RelativeInstructionPrinter methodsFor: 'printing' stamp: ''!
printInstructionsOn: t1 do: t2 
	| t3 |
	labelling := true.
	labels := Array new: method size withAll: false.
	super
		printInstructionsOn: (String new: 1024) writeStream
		do: [:t5 :t6 :t7 | t7].
	t3 := 0.
	labels
		withIndexDo: [:t5 :t6 | t5
				ifTrue: [labels at: t6 put: 'L' , (t3 := t3 + 1) printString]].
	labelling := false.
	super printInstructionsOn: t1 do: t2! !

!RelativeInstructionPrinter methodsFor: 'instruction decoding' stamp: ''!
send: t1 super: t2 numArgs: t3 
	self print: (t2
			ifTrue: ['superSend: ']
			ifFalse: ['send: '])
			, t1 storeString
			, (t3 = 1
					ifTrue: [' (1 arg)']
					ifFalse: [' (' , t3 printString , ' args)'])! !

Number subclass: #ScaledDecimal
	instanceVariableNames: 'fraction scale'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!ScaledDecimal commentStamp: 'nice 9/7/2011 19:09' prior: 0!
ScaledDecimal provides a numeric representation of fixed point decimal numbers able to accurately represent decimal fractions.  It supports unbounded precision, with no limit to the number of digits before and after the decimal point.
	ScaledDecimal complies with the ANSI protocols:

	Object
	number
	ScaledDecimal
	????
#todo. "finish protocol list."

Implementation Notes:

In order to fullfil exact arithmetic requirements, ScaledDecimal is implemented using a Fraction (or an Integer if fraction part is zero) in the fraction instance variable, and a positive Integer number of digits after the decimal point in the scale instance variable. 

A scaled decimal will perform arithmetic by coercing the arguments to fractions, and perform the operations with exact arithmetic.

Note that the denominator needs not being a power of two. If denominator has other prime factors than 2 and 5, then it cannot be printed in decimal form with a finite number of digits. Instead, the printed representation will be truncated to the number of digits prescribed in scale. But beware, the number still has hidden precision.

Example: 
| x |
x := 1 / 3.0s2.
^{ x printString -> 'truncated print'.
  3 * x -> 'but full precision'}
!

!ScaledDecimal class methodsFor: 'instance creation' stamp: ''!
newFromNumber: t1 scale: t2 
	| t3 |
	t3 := self basicNew.
	t3 setFraction: t1 asFraction scale: t2.
	^ t3! !

!ScaledDecimal class methodsFor: 'instance creation' stamp: ''!
readFrom: t1 
	^ (SqNumberParser on: t1) nextScaledDecimal! !

!ScaledDecimal class methodsFor: 'constants' stamp: ''!
zero
	^ self newFromNumber: 0 scale: 0! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
* t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ ScaledDecimal
				newFromNumber: fraction * t1 asFraction
				scale: (scale max: t1 scale)].
	^ t1 adaptToScaledDecimal: self andSend: #*! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
+ t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ ScaledDecimal
				newFromNumber: fraction + t1 asFraction
				scale: (scale max: t1 scale)].
	^ t1 adaptToScaledDecimal: self andSend: #+! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
- t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ ScaledDecimal
				newFromNumber: fraction - t1 asFraction
				scale: (scale max: t1 scale)].
	^ t1 adaptToScaledDecimal: self andSend: #-! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
/ t1 
	t1 = 0
		ifTrue: [^ (ZeroDivide dividend: self) signal].
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ ScaledDecimal
				newFromNumber: fraction / t1 asFraction
				scale: (scale max: t1 scale)].
	^ t1 adaptToScaledDecimal: self andSend: #/! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
// t1 
	^ fraction // t1! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
< t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ fraction < t1 asFraction].
	^ t1 adaptToScaledDecimal: self andCompare: #<! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
<= t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ fraction <= t1 asFraction].
	^ t1 adaptToScaledDecimal: self andCompare: #<=! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
= t1 
	t1 isNumber
		ifFalse: [^ false].
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ fraction = t1 asFraction].
	^ t1 adaptToScaledDecimal: self andCompare: #=! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
> t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ fraction > t1 asFraction].
	^ t1 adaptToScaledDecimal: self andCompare: #>! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
>= t1 
	(t1 isKindOf: ScaledDecimal)
		ifTrue: [^ fraction >= t1 asFraction].
	^ t1 adaptToScaledDecimal: self andCompare: #>=! !

!ScaledDecimal methodsFor: 'converting' stamp: ''!
adaptToFraction: t1 andSend: t2 
	^ (t1 asScaledDecimal: scale)
		perform: t2
		with: self! !

!ScaledDecimal methodsFor: 'converting' stamp: ''!
adaptToInteger: t1 andSend: t2 
	^ (t1 asScaledDecimal: 0)
		perform: t2
		with: self! !

!ScaledDecimal methodsFor: 'converting' stamp: ''!
asFloat
	^ fraction asFloat! !

!ScaledDecimal methodsFor: 'converting' stamp: ''!
asFraction
	^ fraction! !

!ScaledDecimal methodsFor: 'converting' stamp: ''!
asScaledDecimal: t1 
	^ ScaledDecimal newFromNumber: fraction scale: t1! !

!ScaledDecimal methodsFor: 'converting' stamp: ''!
asSpecies: t1 
	^ ScaledDecimal newFromNumber: t1 scale: scale! !

!ScaledDecimal methodsFor: 'private' stamp: ''!
denominator
	^ fraction denominator! !

!ScaledDecimal methodsFor: 'truncation and round off' stamp: ''!
fractionPart
	^ ScaledDecimal newFromNumber: fraction fractionPart scale: scale! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
hash
	^ fraction hash! !

!ScaledDecimal methodsFor: 'truncation and round off' stamp: ''!
integerPart
	^ ScaledDecimal newFromNumber: fraction integerPart scale: scale! !

!ScaledDecimal methodsFor: 'testing' stamp: ''!
isLiteral
	^ fraction denominator = 1
		or: [(10 raisedTo: scale)
				\\ fraction denominator = 0]! !

!ScaledDecimal methodsFor: 'testing' stamp: ''!
isScaledDecimal
	^ true! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
isZero
	^ fraction numerator = 0! !

!ScaledDecimal methodsFor: 'comparing' stamp: ''!
literalEqual: t1 
	^ (super literalEqual: t1)
		and: [self scale = t1 scale]! !

!ScaledDecimal methodsFor: 'mathematical functions' stamp: 'nice 12/11/2012 22:34'!
ln
	"Unlike super, avoid FLoat overflow/underflow"
	
	^self asFraction ln! !

!ScaledDecimal methodsFor: 'mathematical functions' stamp: 'nice 12/11/2012 22:34'!
log
	"Unlike super, avoid FLoat overflow/underflow"
	
	^self asFraction log! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
negated
	^ ScaledDecimal newFromNumber: fraction negated scale: scale! !

!ScaledDecimal methodsFor: 'testing' stamp: 'ul 11/29/2010 20:06'!
negative

	^fraction negative! !

!ScaledDecimal methodsFor: 'mathematical functions' stamp: 'nice 10/14/2011 22:21'!
nthRoot: anInteger
	"Answer the nth root of the receiver.
	Preserve receiver class and scale if answer is exact.
	Otherwise, answer a Float to denote inexactness."
	| nthRoot |
	nthRoot := self asFraction nthRoot: anInteger.
	^nthRoot isFloat
		ifTrue: [nthRoot]
		ifFalse: [nthRoot asScaledDecimal: scale]! !

!ScaledDecimal methodsFor: 'private' stamp: ''!
numerator
	^ fraction numerator! !

!ScaledDecimal methodsFor: 'printing' stamp: 'nice 3/29/2011 21:52'!
printFractionAsDecimalOn: stream 
	"Please note: this is different from printOn:showingDecimalPlaces: because it prints truncated."

	fraction printTruncatedOn: stream showingDecimalPlaces: scale! !

!ScaledDecimal methodsFor: 'printing' stamp: 'ul 11/29/2010 00:19'!
printOn: stream

	self
		printFractionAsDecimalOn: stream;
		printScaleOn: stream! !

!ScaledDecimal methodsFor: 'printing' stamp: 'nice 3/29/2011 21:59'!
printOn: aStream showingDecimalPlaces: placesDesired
	"Same as super, except the fraction knows better how to do it."

	fraction printOn: aStream showingDecimalPlaces: placesDesired! !

!ScaledDecimal methodsFor: 'printing' stamp: 'ul 11/29/2010 00:14'!
printScaleOn: stream

	stream nextPut: $s.
	scale printOn: stream! !

!ScaledDecimal methodsFor: 'printing' stamp: ''!
printString
	| t1 |
	t1 := WriteStream
				on: (String new: 10).
	self printOn: t1.
	^ t1 contents! !

!ScaledDecimal methodsFor: 'mathematical functions' stamp: ''!
raisedToInteger: t1 
	^ self class
		newFromNumber: (fraction raisedToInteger: t1)
		scale: scale! !

!ScaledDecimal methodsFor: 'arithmetic' stamp: ''!
reciprocal
	self = 0
		ifTrue: [^ (ZeroDivide dividend: 1) signal].
	^ ScaledDecimal newFromNumber: fraction reciprocal scale: scale! !

!ScaledDecimal methodsFor: 'private' stamp: ''!
scale
	^ scale! !

!ScaledDecimal methodsFor: 'private' stamp: ''!
setFraction: t1 scale: t2 
	fraction := t1.
	scale := t2! !

!ScaledDecimal methodsFor: 'mathematical functions' stamp: 'nice 10/14/2011 22:02'!
sqrt
	"Answer the square root of the receiver.
	Preserve receiver class and scale if answer is exact.
	Otherwise, answer a Float to denote inexactness."
	| squareRoot |
	squareRoot := self asFraction sqrt.
	^squareRoot isFloat
		ifTrue: [squareRoot]
		ifFalse: [squareRoot asScaledDecimal: scale]! !

!ScaledDecimal methodsFor: 'mathematical functions' stamp: ''!
squared
	^ ScaledDecimal newFromNumber: fraction squared scale: scale! !

!ScaledDecimal methodsFor: 'printing' stamp: 'ul 11/23/2010 13:28'!
storeOn: aStream 
	"SxaledDecimal sometimes have more digits than they print (potentially an infinity).
	In this case, do not use printOn: because it would loose some extra digits"
	
	self shouldBePrintedAsLiteral
		ifTrue: [self printOn: aStream]
		ifFalse: [aStream
			nextPut: $(;
		 	store: fraction numerator;
			nextPut: $/;
			store: fraction denominator;
			nextPut: $s;
			store: scale;
			nextPut: $)]! !

!ScaledDecimal methodsFor: 'truncation and round off' stamp: ''!
truncated
	^ fraction truncated! !

Integer subclass: #SmallInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!SmallInteger class methodsFor: 'instance creation' stamp: ''!
basicNew
	self error: 'SmallIntegers can only be created by performing arithmetic'! !

!SmallInteger class methodsFor: 'documentation' stamp: ''!
guideToDivision
	^ self! !

!SmallInteger class methodsFor: 'constants' stamp: ''!
maxVal
	^ 1073741823! !

!SmallInteger class methodsFor: 'constants' stamp: ''!
minVal
	^ -1073741824! !

!SmallInteger class methodsFor: 'instance creation' stamp: ''!
new
	self basicNew! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
* t1 
	<primitive: 9>
	^ super * t1! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
+ t1 
	<primitive: 1>
	^ super + t1! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
- t1 
	<primitive: 2>
	^ super - t1! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
/ t1 
	<primitive: 10>
	t1 isZero
		ifTrue: [^ (ZeroDivide dividend: self) signal].
	^ (t1 isMemberOf: SmallInteger)
		ifTrue: [(Fraction numerator: self denominator: t1) reduced]
		ifFalse: [super / t1]! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
// t1 
	<primitive: 12>
	^ super // t1! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
< t1 
	<primitive: 3>
	^ super < t1! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
<= t1 
	<primitive: 5>
	^ super <= t1! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
= t1 
	<primitive: 7>
	^ super = t1! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
> t1 
	<primitive: 4>
	^ super > t1! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
>= t1 
	<primitive: 6>
	^ super >= t1! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
\\ t1 
	<primitive: 11>
	^ super \\ t1! !

!SmallInteger methodsFor: 'converting' stamp: ''!
as31BitSmallInt
	^ self! !

!SmallInteger methodsFor: 'converting' stamp: ''!
asFloat
	<primitive: 40>
	self primitiveFailed! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
bitAnd: t1 
	<primitive: 14>
	self >= 0
		ifTrue: [^ t1 bitAnd: self].
	^ (self bitInvert bitOr: t1 bitInvert) bitInvert! !

!SmallInteger methodsFor: 'bit manipulation' stamp: 'nice 6/14/2011 21:48'!
bitCountOfByte
	"Count the number of bits set to 1 in a byte."

	^#[0 1 1 2 1 2 2 3 1 2 2 3 2 3 3 4 1 2 2 3 2 3 3 4 2 3 3 4 3 4 4 5 1 2 2 3 2 3 3 4 2 3 3 4 3 4 4 5 2 3 3 4 3 4 4 5 3 4 4 5 4 5 5 6 1 2 2 3 2 3 3 4 2 3 3 4 3 4 4 5 2 3 3 4 3 4 4 5 3 4 4 5 4 5 5 6 2 3 3 4 3 4 4 5 3 4 4 5 4 5 5 6 3 4 4 5 4 5 5 6 4 5 5 6 5 6 6 7 1 2 2 3 2 3 3 4 2 3 3 4 3 4 4 5 2 3 3 4 3 4 4 5 3 4 4 5 4 5 5 6 2 3 3 4 3 4 4 5 3 4 4 5 4 5 5 6 3 4 4 5 4 5 5 6 4 5 5 6 5 6 6 7 2 3 3 4 3 4 4 5 3 4 4 5 4 5 5 6 3 4 4 5 4 5 5 6 4 5 5 6 5 6 6 7 3 4 4 5 4 5 5 6 4 5 5 6 5 6 6 7 4 5 5 6 5 6 6 7 5 6 6 7 6 7 7 8] at: self + 1

	"Evaluate this expression to form above byte array:
	((0 to: 255)
		collect: [:i | 
			| bitCount n |
			n := i.
			bitCount := 0.
			[n = 0]
				whileFalse:
					[bitCount := bitCount + 1.
					n := n bitAnd: n - 1].
			bitCount]
		as: ByteArray)"! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
bitOr: t1 
	<primitive: 15>
	self >= 0
		ifTrue: [^ t1 bitOr: self].
	^ t1 < 0
		ifTrue: [(self bitInvert bitAnd: t1 bitInvert) bitInvert]
		ifFalse: [(self bitInvert bitClear: t1) bitInvert]! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
bitShift: t1 
	<primitive: 17>
	self >= 0
		ifTrue: [^ super bitShift: t1].
	^ t1 >= 0
		ifTrue: [(self negated bitShift: t1) negated]
		ifFalse: [(self bitInvert bitShift: t1) bitInvert]! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
bitXor: t1 
	<primitive: 16>
	self >= 0
		ifTrue: [^ t1 bitXor: self].
	^ t1 < 0
		ifTrue: [self bitInvert bitXor: t1 bitInvert]
		ifFalse: [(self bitInvert bitXor: t1) bitInvert]! !

!SmallInteger methodsFor: 'bit manipulation' stamp: 'nice 4/12/2011 08:58'!
byteReversed
	"Answer the receiver with bits reversed in a byte.
	The receiver must be between 0 and 255.
	The constant has been obtained by this snippet:
	(0 to: 255) collect: [:e |
		| r |
		r := ((e bitAnd: 2r11110000) bitShift: -4) + ((e bitAnd: 2r00001111) bitShift: 4).
		r := ((r bitAnd: 2r11001100) bitShift: -2) + ((r bitAnd: 2r00110011) bitShift: 2).
		((r bitAnd: 2r10101010) bitShift: -1) + ((r bitAnd: 2r01010101) bitShift: 1).] as: ByteArray"
	
	^#[0 128 64 192 32 160 96 224 16 144 80 208 48 176 112 240 8 136 72 200 40 168 104 232 24 152 88 216 56 184 120 248 4 132 68 196 36 164 100 228 20 148 84 212 52 180 116 244 12 140 76 204 44 172 108 236 28 156 92 220 60 188 124 252 2 130 66 194 34 162 98 226 18 146 82 210 50 178 114 242 10 138 74 202 42 170 106 234 26 154 90 218 58 186 122 250 6 134 70 198 38 166 102 230 22 150 86 214 54 182 118 246 14 142 78 206 46 174 110 238 30 158 94 222 62 190 126 254 1 129 65 193 33 161 97 225 17 145 81 209 49 177 113 241 9 137 73 201 41 169 105 233 25 153 89 217 57 185 121 249 5 133 69 197 37 165 101 229 21 149 85 213 53 181 117 245 13 141 77 205 45 173 109 237 29 157 93 221 61 189 125 253 3 131 67 195 35 163 99 227 19 147 83 211 51 179 115 243 11 139 75 203 43 171 107 235 27 155 91 219 59 187 123 251 7 135 71 199 39 167 103 231 23 151 87 215 55 183 119 247 15 143 79 207 47 175 111 239 31 159 95 223 63 191 127 255] at: 1 + self! !

!SmallInteger methodsFor: 'copying' stamp: ''!
clone
	^ self! !

!SmallInteger methodsFor: 'printing' stamp: ''!
decimalDigitLength
	^ self < 10000
		ifTrue: [self < 100
				ifTrue: [self < 10
						ifTrue: [1]
						ifFalse: [2]]
				ifFalse: [self < 1000
						ifTrue: [3]
						ifFalse: [4]]]
		ifFalse: [self < 1000000
				ifTrue: [self < 100000
						ifTrue: [5]
						ifFalse: [6]]
				ifFalse: [self < 100000000
						ifTrue: [self < 10000000
								ifTrue: [7]
								ifFalse: [8]]
						ifFalse: [self < 1000000000
								ifTrue: [9]
								ifFalse: [10]]]]! !

!SmallInteger methodsFor: 'copying' stamp: ''!
deepCopy
	^ self! !

!SmallInteger methodsFor: 'printing' stamp: ''!
destinationBuffer: t1 
	^ LargePositiveInteger new: t1! !

!SmallInteger methodsFor: 'system primitives' stamp: ''!
digitAt: t1 
	t1 > 4
		ifTrue: [^ 0].
	self < 0
		ifTrue: [self = SmallInteger minVal
				ifTrue: [^ #(0 0 0 64 ) at: t1].
			^ (0 - self bitShift: 1 - t1 * 8)
				bitAnd: 255].
	^ (self bitShift: 1 - t1 * 8)
		bitAnd: 255! !

!SmallInteger methodsFor: 'system primitives' stamp: ''!
digitAt: t1 put: t2 
	self error: 'You can''t store in a SmallInteger'! !

!SmallInteger methodsFor: 'system primitives' stamp: ''!
digitLength
	(self < 256
			and: [self > -256])
		ifTrue: [^ 1].
	(self < 65536
			and: [self > -65536])
		ifTrue: [^ 2].
	(self < 16777216
			and: [self > -16777216])
		ifTrue: [^ 3].
	^ 4! !

!SmallInteger methodsFor: 'testing' stamp: ''!
even
	^ (self bitAnd: 1)
		= 0! !

!SmallInteger methodsFor: 'private' stamp: ''!
fromString: t1 radix: t2 
	| t3 t4 t5 |
	t3 := t2
				+ (t2 > 10
						ifTrue: [55 - 1]
						ifFalse: [48 - 1]).
	t5 := 0.
	1
		to: t1 size
		do: [:t6 | 
			t4 := t1 at: t6.
			(t4 < 48
					ifFalse: [t4 > t3])
				ifTrue: [^ false].
			t5 := t5 * t2
						+ (t4 <= 57
								ifTrue: [t4 - 48]
								ifFalse: [t4 < 65
										ifTrue: [^ false].
									t4 - 55])].
	^ t5! !

!SmallInteger methodsFor: 'arithmetic' stamp: ''!
gcd: t1 
	| t2 t3 |
	t2 := self.
	t3 := t1.
	[t2 = 0]
		whileFalse: [t2 := t3 \\ (t3 := t2)].
	^ t3 abs! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
hash
	^ self! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
hashMultiply
	| t1 |
	t1 := self bitAnd: 16383.
	^ 9741 * t1 + ((9741
			* (self bitShift: -14) + (101 * t1) bitAnd: 16383)
			* 16384) bitAnd: 268435455! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
highBit
	self < 0
		ifTrue: [^ self error: 'highBit is not defined for negative integers'].
	^ self highBitOfPositiveReceiver! !

!SmallInteger methodsFor: 'private' stamp: 'nice 9/24/2011 22:52'!
highBitOfByte
	"The high bits table can be obtained with:
	(1 to: 8) inject: #[0] into: [:highBits :rank | highBits , (highBits collect: [:e | rank])]."
	^ #[0 1 2 2 3 3 3 3 4 4 4 4 4 4 4 4 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 5 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 6 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 7 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8] at: self + 1! !

!SmallInteger methodsFor: 'bit manipulation' stamp: ''!
highBitOfMagnitude
	self < 0
		ifTrue: [^ self negated highBitOfMagnitude].
	^ self highBitOfPositiveReceiver! !

!SmallInteger methodsFor: 'private' stamp: 'nice 9/24/2011 22:52'!
highBitOfPositiveReceiver
	| shifted bitNo |
	"Answer the index of the high order bit of the receiver, or zero if the 
	receiver is zero. Receiver has to be positive!!"
	shifted := self.
	bitNo := 0.
	[shifted < 65536]
		whileFalse: 
			[shifted := shifted bitShift: -16.
			bitNo := bitNo + 16].
	shifted < 256
		ifFalse: 
			[shifted := shifted bitShift: -8.
			bitNo := bitNo + 8].
	^bitNo + shifted highBitOfByte! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
identityHash
	^ self! !

!SmallInteger methodsFor: 'system primitives' stamp: ''!
instVarAt: t1 
	t1 = 1
		ifTrue: [^ self].
	self error: 'argument too big for small integer instVarAt:'! !

!SmallInteger methodsFor: 'testing' stamp: ''!
isLarge
	^ false! !

!SmallInteger methodsFor: 'testing' stamp: 'ul 1/22/2012 23:56'!
isPowerOfTwo
	"Return true if the receiver is an integral power of two. Optimized version."
	
	^self > 0 and: [ (self bitAnd: self - 1) = 0 ]! !

!SmallInteger methodsFor: 'bit manipulation' stamp: 'ul 7/18/2011 17:27'!
lowBit
	" Answer the index of the low order one bit.
		2r00101000 lowBit       (Answers: 4)
		2r-00101000 lowBit      (Answers: 4)
	  First we skip bits in groups of 8, then do a lookup in a table.
	  While not optimal, this is a good tradeoff; long
	  integer #lowBit always invokes us with bytes."

	| n result lastByte |
	n := self.
	n = 0 ifTrue: [ ^ 0 ].
	result := 0.
	[(lastByte := n bitAnd: 16rFF) = 0]
		whileTrue: [
			result := result + 8.
			n := n bitShift: -8 ].
	^result + (LowBitPerByteTable at: lastByte)! !

!SmallInteger methodsFor: 'system primitives' stamp: ''!
nextInstance
	self shouldNotImplement! !

!SmallInteger methodsFor: 'system primitives' stamp: ''!
nextObject
	self shouldNotImplement! !

!SmallInteger methodsFor: 'printing' stamp: ''!
numberOfDigitsInBase: t1 
	t1 = 10
		ifFalse: [^ super numberOfDigitsInBase: t1].
	self < 0
		ifTrue: [^ self negated numberOfDigitsInBase: t1].
	^ self decimalDigitLength! !

!SmallInteger methodsFor: 'testing' stamp: ''!
odd
	^ (self bitAnd: 1)
		= 1! !

!SmallInteger methodsFor: 'printing' stamp: 'ul 12/8/2010 03:59'!
printOn: stream base: base 
	"Append a representation of this number in base b on aStream."

	self printOn: stream base: base length: 0 padded: false! !

!SmallInteger methodsFor: 'printing' stamp: 'ul 11/30/2010 01:38'!
printOn: stream base: base length: minimumLength padded: padWithZeroes

	| n numberOfDigits totalLength divisor |
	self < 0
		ifTrue: [
			n := self negated.
			totalLength := 1 ]
		ifFalse: [
			n := self.
			totalLength := 0 ].
	numberOfDigits := n numberOfDigitsInBase: base.
	totalLength := totalLength + numberOfDigits.
	padWithZeroes ifFalse: [
		[ totalLength < minimumLength ] whileTrue: [
			stream space.
			totalLength := totalLength + 1 ] ].
	n = self ifFalse: [ stream nextPut: $- ].
	padWithZeroes ifTrue: [
		[ totalLength < minimumLength ] whileTrue: [
			stream nextPut: $0.
			totalLength := totalLength + 1 ] ].
	divisor := (base raisedToInteger: numberOfDigits - 1).
	[ divisor > 0 ] whileTrue: [
		| digit |
		digit := n // divisor.
		stream nextPut: ('0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ' at: digit + 1).
		n := n - (digit * divisor).
		divisor := divisor // base ]! !

!SmallInteger methodsFor: 'printing' stamp: 'ul 12/8/2010 04:00'!
printOn: aStream base: b nDigits: n 
	"Append a representation of this number in base b on aStream using nDigits.
	self must be positive."

	self printOn: aStream base: b length: n padded: true! !

!SmallInteger methodsFor: 'printing' stamp: ''!
printString
	| t1 t2 t3 t4 |
	self = 0
		ifTrue: [^ '0'].
	self < 0
		ifTrue: [^ '-' , self negated printString].
	t4 := self decimalDigitLength.
	t3 := String new: t4.
	t1 := self.
	t4
		to: 1
		by: -1
		do: [:t5 | 
			t2 := t1 // 10.
			t3 byteAt: t5 put: 48 + (t1 - (t2 * 10)).
			t1 := t2].
	^ t3! !

!SmallInteger methodsFor: 'printing' stamp: ''!
printStringBase: t1 
	self < 0
		ifTrue: [^ '-'
				, (self negated printStringBase: t1)].
	self < t1
		ifTrue: [^ String
				with: (Character digitValue: self)].
	^ self
		printStringBase: t1
		nDigits: (self numberOfDigitsInBase: t1)! !

!SmallInteger methodsFor: 'printing' stamp: ''!
printStringBase: t1 nDigits: t2 
	| t3 t4 t5 |
	t5 := String new: t2.
	t3 := self.
	t2
		to: 1
		by: -1
		do: [:t6 | 
			t4 := t3 // t1.
			t5
				byteAt: t6
				put: (Character digitValue: t3 - (t4 * t1)).
			t3 := t4].
	^ t5! !

!SmallInteger methodsFor: 'arithmetic' stamp: 'ul 11/15/2010 10:12'!
quo: aNumber 
	"Primitive. Divide the receiver by the argument and answer with the 
	result. Round the result down towards zero to make it a whole integer. 
	Fail if the argument is 0 or is not a SmallInteger. Optional. See Object 
	documentation whatIsAPrimitive."
	<primitive: 13>
	aNumber = 0 ifTrue: [^ (ZeroDivide dividend: self) signal].
	(aNumber isMemberOf: SmallInteger)
		ifFalse: [^ super quo: aNumber].
	(aNumber = -1 and: [self = self class minVal])
		ifTrue: ["result is aLargeInteger" ^ self negated].
	self primitiveFailed! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
scaledIdentityHash
	^ self! !

!SmallInteger methodsFor: 'copying' stamp: ''!
shallowCopy
	^ self! !

!SmallInteger methodsFor: 'mathematical functions' stamp: 'jmv 10/13/2011 21:41'!
sqrt
	self negative ifTrue: [
		^ DomainError signal: 'sqrt undefined for number less than zero.' ].
	^super sqrt! !

!SmallInteger methodsFor: 'printing' stamp: ''!
threeDigitName
	| t1 t2 |
	self = 0
		ifTrue: [^ ''].
	t1 := #('one' 'two' 'three' 'four' 'five' 'six' 'seven' 'eight' 'nine' 'ten' 'eleven' 'twelve' 'thirteen' 'fourteen' 'fifteen' 'sixteen' 'seventeen' 'eighteen' 'nineteen' ).
	self > 99
		ifTrue: [t2 := (t1 at: self // 100)
						, ' hundred'.
			self \\ 100 = 0
				ifFalse: [t2 := t2 , ' ' , (self \\ 100) threeDigitName].
			^ t2].
	self < 20
		ifTrue: [^ t1 at: self].
	t2 := #('twenty' 'thirty' 'forty' 'fifty' 'sixty' 'seventy' 'eighty' 'ninety' ) at: self // 10 - 1.
	self \\ 10 = 0
		ifFalse: [t2 := t2 , '-'
						, (t1 at: self \\ 10)].
	^ t2! !

!SmallInteger methodsFor: 'copying' stamp: ''!
veryDeepCopyWith: t1 
	^ self! !

!SmallInteger methodsFor: 'comparing' stamp: ''!
~= t1 
	<primitive: 8>
	^ super ~= t1! !

NumberParser subclass: #SqNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

SqNumberParser subclass: #ExtendedNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!

!ExtendedNumberParser methodsFor: 'accessing' stamp: ''!
allowPlusSign
	^ true! !

!ExtendedNumberParser methodsFor: 'parsing-public' stamp: 'nice 5/22/2012 22:49'!
nextFraction
	| numerator denominator numberOfTrailingZeroInIntegerPart |
	base := 10.
	neg := self peekSignIsMinus.
	(integerPart := self nextUnsignedIntegerOrNilBase: base)
		ifNil: [numberOfTrailingZeroInIntegerPart := 0]
		ifNotNil: [
			numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero.
			(sourceStream peekFor: $r)
				ifTrue: ["<base>r<integer>"
					(base := integerPart) < 2
						ifTrue: [
							sourceStream skip: -1.
							^ self expected: 'an integer greater than 1 as valid radix'].
					self peekSignIsMinus
						ifTrue: [neg := neg not].
					integerPart := self nextUnsignedIntegerBase: base.
					numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero]].
	(sourceStream peekFor: $.)
		ifTrue:
			[^self readFractionPartNumberOfTrailingZeroInIntegerPart: numberOfTrailingZeroInIntegerPart].
	integerPart
		ifNil:
			["No integerPart, raise an error"
			^ self expected: 'a digit'].
	numerator := neg
		ifTrue: [integerPart negated]
		ifFalse: [integerPart].
	self readExponent ifTrue: [numerator := numerator * (base raisedToInteger: exponent)].
	(sourceStream peekFor: $/) ifFalse: [^numerator].
	base := 10.
	(denominator := self nextUnsignedIntegerOrNilBase: base)
		ifNil:
			[sourceStream skip: -1. "Not a valid denominator, ungobble / and return numerator"
			^numerator].
	(sourceStream peekFor: $r)
		ifTrue: ["<base>r<integer>"
			(base := denominator) < 2
				ifTrue: [
					sourceStream skip: -1.
					^ self expected: 'an integer greater than 1 as valid radix'].
			denominator := self nextUnsignedIntegerBase: base].
	self readExponent ifTrue: [denominator := denominator * (base raisedToInteger: exponent)].
	^numerator / denominator! !

!ExtendedNumberParser methodsFor: 'parsing-public' stamp: ''!
nextNumber
	| t1 t3 t4 |
	base := 10.
	neg := self peekSignIsMinus.
	integerPart := self nextUnsignedIntegerOrNilBase: base.
	integerPart
		ifNil: [(sourceStream peekFor: $.)
				ifTrue: [^ self readNumberWithoutIntegerPart].
			^ self readNamedFloatOrFail].
	t1 := nDigits - lastNonZero.
	(sourceStream peekFor: $r)
		ifTrue: [t4 := sourceStream position.
			(base := integerPart) < 2
				ifTrue: [sourceStream skip: -1.
					^ neg
						ifTrue: [base negated]
						ifFalse: [base]].
			t3 := neg.
			self peekSignIsMinus
				ifTrue: [neg := neg not].
			integerPart := self nextUnsignedIntegerOrNilBase: base.
			integerPart
				ifNil: [(sourceStream peekFor: $.)
						ifTrue: [self readNumberWithoutIntegerPartOrNil
								ifNotNil: [:t2 | ^ t2]].
					sourceStream position: t4.
					^ t3
						ifTrue: [base negated]
						ifFalse: [base]].
			t1 := nDigits - lastNonZero].
	^ (sourceStream peekFor: $.)
		ifTrue: [self readNumberWithFractionPartNumberOfTrailingZeroInIntegerPart: t1]
		ifFalse: [self makeIntegerOrScaledInteger]! !

!ExtendedNumberParser methodsFor: 'parsing-private' stamp: 'nice 5/22/2012 22:51'!
readFractionPartNumberOfTrailingZeroInIntegerPart: numberOfTrailingZeroInIntegerPart
	"at this stage, sign integerPart and a fraction point have been read.
	try and form a number with a fractionPart"
	
	| numberOfNonZeroFractionDigits numberOfTrailingZeroInFractionPart mantissa value |
	fractionPart := self nextUnsignedIntegerOrNilBase: base.
	fractionPart
		ifNil: [
			"No fractionPart found, but can be an extended 1.e2 syntax"
			integerPart ifNil: ["No integerPart, nor fractionPart found, ungobble the fraction point and raise an error"
					sourceStream skip: -1.
					^self expected: 'a digit'].
			fractionPart := 0.
			numberOfNonZeroFractionDigits := 0.
			numberOfTrailingZeroInFractionPart := 0]
		ifNotNil: [.
			numberOfNonZeroFractionDigits := lastNonZero.
			numberOfTrailingZeroInFractionPart := nDigits - lastNonZero].
	self readExponent.
	integerPart ifNil: [integerPart := 0].
	
	fractionPart isZero
		ifTrue: [mantissa := integerPart
						// (base raisedToInteger: numberOfTrailingZeroInIntegerPart).
			exponent := exponent + numberOfTrailingZeroInIntegerPart]
		ifFalse: [mantissa := integerPart
						* (base raisedToInteger: numberOfNonZeroFractionDigits) + (fractionPart // (base raisedToInteger: numberOfTrailingZeroInFractionPart)).
			exponent := exponent - numberOfNonZeroFractionDigits].

	value := exponent positive
		ifTrue: [mantissa * (base raisedToInteger: exponent)]
		ifFalse: [mantissa / (base raisedToInteger: exponent negated)].
	^ neg
		ifTrue: [value negated]
		ifFalse: [value]! !

!ExtendedNumberParser methodsFor: 'parsing-private' stamp: ''!
readNumberWithFractionPartNumberOfTrailingZeroInIntegerPart: t1 
	| t2 t3 t4 t5 |
	fractionPart := self nextUnsignedIntegerOrNilBase: base.
	fractionPart
		ifNil: [fractionPart := 0.
			t2 := 0.
			t3 := 0]
		ifNotNil: [t2 := lastNonZero.
			t3 := nDigits - lastNonZero].
	self readExponent
		ifFalse: [self readScale
				ifTrue: [^ self makeScaledDecimalWithNumberOfNonZeroFractionDigits: t2 andNumberOfTrailingZeroInFractionPart: t3]].
	fractionPart isZero
		ifTrue: [t4 := integerPart
						// (base raisedToInteger: t1).
			exponent := exponent + t1]
		ifFalse: [t4 := integerPart
						* (base raisedToInteger: t2) + (fractionPart
							// (base raisedToInteger: t3)).
			exponent := exponent - t2].
	t5 := self
				makeFloatFromMantissa: t4
				exponent: exponent
				base: base.
	^ neg
		ifTrue: [t5 isZero
				ifTrue: [Float negativeZero]
				ifFalse: [t5 negated]]
		ifFalse: [t5]! !

!ExtendedNumberParser methodsFor: 'parsing-private' stamp: ''!
readNumberWithoutIntegerPart
	^ self readNumberWithoutIntegerPartOrNil
		ifNil: [^ self expected: 'a digit between 0 and 9']! !

!ExtendedNumberParser methodsFor: 'parsing-private' stamp: ''!
readNumberWithoutIntegerPartOrNil
	| t1 t2 t3 t4 |
	integerPart := 0.
	fractionPart := self nextUnsignedIntegerOrNilBase: base.
	fractionPart
		ifNil: [^ nil].
	t1 := lastNonZero.
	t2 := nDigits - lastNonZero.
	self readExponent
		ifFalse: [self readScale
				ifTrue: [^ self makeScaledDecimalWithNumberOfNonZeroFractionDigits: t1 andNumberOfTrailingZeroInFractionPart: t2]].
	fractionPart isZero
		ifTrue: [t3 := 0]
		ifFalse: [t3 := fractionPart
						// (base raisedToInteger: t2).
			exponent := exponent - t1].
	t4 := self
				makeFloatFromMantissa: t3
				exponent: exponent
				base: base.
	^ neg
		ifTrue: [t4 isZero
				ifTrue: [Float negativeZero]
				ifFalse: [t4 negated]]
		ifFalse: [t4]! !

!SqNumberParser class methodsFor: 'instance creation' stamp: ''!
on: t1 
	^ self new on: t1! !

!SqNumberParser class methodsFor: 'instance creation' stamp: ''!
parse: t1 
	^ self new on: t1;
		 nextNumber! !

!SqNumberParser class methodsFor: 'instance creation' stamp: ''!
parse: t1 onError: t2 
	^ self new on: t1;
		 failBlock: t2;
		 nextNumber! !

!SqNumberParser methodsFor: 'accessing' stamp: ''!
allowPlusSign
	^ false! !

!SqNumberParser methodsFor: 'accessing' stamp: ''!
exponentLetters
	^ 'edq'! !

!SqNumberParser methodsFor: 'parsing-private' stamp: ''!
makeIntegerOrScaledInteger
	neg
		ifTrue: [integerPart := integerPart negated].
	self readExponent
		ifTrue: [^ integerPart
				* (base raisedToInteger: exponent)].
	self readScale
		ifTrue: [^ ScaledDecimal newFromNumber: integerPart scale: scale].
	^ integerPart! !

!SqNumberParser methodsFor: 'parsing-private' stamp: ''!
makeScaledDecimalWithNumberOfNonZeroFractionDigits: t1 andNumberOfTrailingZeroInFractionPart: t2 
	| t3 t4 |
	t3 := base raisedToInteger: t1.
	t4 := integerPart * t3 + (fractionPart
					// (base raisedTo: t2)) / t3.
	^ ScaledDecimal
		newFromNumber: (neg
				ifTrue: [t4 negated]
				ifFalse: [t4])
		scale: scale! !

!SqNumberParser methodsFor: 'parsing-public' stamp: 'nice 5/22/2012 22:48'!
nextFraction
	| numerator denominator numberOfTrailingZeroInIntegerPart |
	base := 10.
	neg := self peekSignIsMinus.
	(integerPart := self nextUnsignedIntegerOrNilBase: base)
		ifNil: ["No integerPart, raise an error"
			^ self expected: 'a digit'].
	numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero.
	(sourceStream peekFor: $r)
		ifTrue: ["<base>r<integer>"
			(base := integerPart) < 2
				ifTrue: [
					sourceStream skip: -1.
					^ self expected: 'an integer greater than 1 as valid radix'].
			self peekSignIsMinus
				ifTrue: [neg := neg not].
			integerPart := self nextUnsignedIntegerBase: base.
			numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero].
	(sourceStream peekFor: $.)
		ifTrue:
			[^self readFractionPartNumberOfTrailingZeroInIntegerPart: numberOfTrailingZeroInIntegerPart].
	numerator := neg
		ifTrue: [integerPart negated]
		ifFalse: [integerPart].
	self readExponent ifTrue: [numerator := numerator * (base raisedToInteger: exponent)].
	(sourceStream peekFor: $/) ifFalse: [^numerator].
	base := 10.
	(denominator := self nextUnsignedIntegerOrNilBase: base)
		ifNil:
			[sourceStream skip: -1. "Not a valid denominator, ungobble / and return numerator"
			^numerator].
	(sourceStream peekFor: $r)
		ifTrue: ["<base>r<integer>"
			(base := denominator) < 2
				ifTrue: [
					sourceStream skip: -1.
					^ self expected: 'an integer greater than 1 as valid radix'].
			denominator := self nextUnsignedIntegerBase: base].
	self readExponent ifTrue: [denominator := denominator * (base raisedToInteger: exponent)].
	^numerator / denominator! !

!SqNumberParser methodsFor: 'parsing-public' stamp: 'nice 5/20/2012 16:09'!
nextFractionBase: aRadix
	| numerator denominator |
	base := aRadix.
	neg := self peekSignIsMinus.
	(integerPart := self nextUnsignedIntegerOrNilBase: base)
		ifNil: [^self expected: 'a digit between 0 and ' , (Character digitValue: aRadix)].
	numerator := neg
		ifTrue: [integerPart negated]
		ifFalse: [integerPart].
	self readExponent ifTrue: [numerator := numerator * (base raisedToInteger: exponent)].
	(sourceStream peekFor: $/) ifFalse: [^numerator].
	(denominator := self nextUnsignedIntegerOrNilBase: base)
		ifNil:
			[sourceStream skip: -1. "Not a valid denominator, ungobble / and return numerator"
			^numerator].
	self readExponent ifTrue: [denominator := denominator * (base raisedToInteger: exponent)].
	^numerator / denominator! !

!SqNumberParser methodsFor: 'parsing-public' stamp: 'nice 5/20/2012 14:55'!
nextInteger
	"Read an Integer from sourceStream, asnwser that Integer.
	In Smalltalk syntax, a radix can be specified, and an exponent too."
	
	| numberOfTrailingZeroInIntegerPart |
	base := 10.
	neg := self peekSignIsMinus.
	integerPart := self nextUnsignedIntegerOrNilBase: base.
	numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero.
	(sourceStream peekFor: $r)
		ifTrue: ["<base>r<integer>"
			(base := integerPart) < 2
				ifTrue: [
					sourceStream skip: -1.
					^ self expected: 'an integer greater than 1 as valid radix'].
			self peekSignIsMinus
				ifTrue: [neg := neg not].
			integerPart := self nextUnsignedIntegerBase: base.
			numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero].
	^ self makeIntegerOrScaledInteger! !

!SqNumberParser methodsFor: 'parsing-public' stamp: 'nice 2/24/2010 02:51'!
nextNumber
	"main method for reading a number.
	This one can read Float Integer and ScaledDecimal"
	
	| numberOfTrailingZeroInIntegerPart |
	base := 10.
	neg := self peekSignIsMinus.
	integerPart := self nextUnsignedIntegerOrNilBase: base.
	integerPart ifNil: [
		"This is not a regular number beginning with a digit
		It is time to check for exceptional condition NaN and Infinity"
		^self readNamedFloatOrFail].
	numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero.
	(sourceStream peekFor: $r)
		ifTrue: ["<base>r<integer>"
			(base := integerPart) < 2
				ifTrue: [
					sourceStream skip: -1.
					^ self expected: 'an integer greater than 1 as valid radix'].
			self peekSignIsMinus
				ifTrue: [neg := neg not].
			integerPart := self nextUnsignedIntegerBase: base.
			numberOfTrailingZeroInIntegerPart := nDigits - lastNonZero].
	^ (sourceStream peekFor: $.)
		ifTrue: [self readNumberWithFractionPartNumberOfTrailingZeroInIntegerPart: numberOfTrailingZeroInIntegerPart]
		ifFalse: [self makeIntegerOrScaledInteger]! !

!SqNumberParser methodsFor: 'parsing-public' stamp: ''!
nextNumberBase: t1 
	| t2 |
	base := t1.
	neg := sourceStream peekFor: $-.
	integerPart := self nextUnsignedIntegerOrNilBase: base.
	integerPart
		ifNil: [^ self readNamedFloatOrFail].
	t2 := nDigits - lastNonZero.
	^ (sourceStream peekFor: $.)
		ifTrue: [self readNumberWithFractionPartNumberOfTrailingZeroInIntegerPart: t2]
		ifFalse: [self makeIntegerOrScaledInteger]! !

!SqNumberParser methodsFor: 'parsing-public' stamp: ''!
nextScaledDecimal
	| t1 t2 |
	base := 10.
	neg := sourceStream peekFor: $-.
	integerPart := self nextUnsignedIntegerBase: base.
	(sourceStream peekFor: $.)
		ifTrue: [fractionPart := self nextUnsignedIntegerOrNilBase: base.
			fractionPart
				ifNil: [sourceStream skip: -1.
					^ neg
						ifTrue: [integerPart negated asScaledDecimal: 0]
						ifFalse: [integerPart asScaledDecimal: 0]].
			t1 := lastNonZero.
			t2 := nDigits - lastNonZero.
			self readScale
				ifFalse: [scale := nDigits].
			^ self makeScaledDecimalWithNumberOfNonZeroFractionDigits: t1 andNumberOfTrailingZeroInFractionPart: t2].
	self readScale.
	neg
		ifTrue: [integerPart := integerPart negated].
	^ integerPart asScaledDecimal: scale! !

!SqNumberParser methodsFor: 'parsing-public' stamp: 'nice 5/20/2012 15:01'!
nextUnsignedInteger
	"Read an unsigned Integer from sourceStream, asnwser that Integer.
	In Smalltalk syntax, a radix can be specified, and an exponent too."
	
	base := 10.
	neg := false.
	integerPart := self nextUnsignedIntegerOrNilBase: base.
	(sourceStream peekFor: $r)
		ifTrue: ["<base>r<integer>"
			(base := integerPart) < 2
				ifTrue: [
					sourceStream skip: -1.
					^ self expected: 'an integer greater than 1 as valid radix'].
			integerPart := self nextUnsignedIntegerBase: base].
	^ self makeIntegerOrScaledInteger! !

!SqNumberParser methodsFor: 'parsing-private' stamp: 'nice 5/22/2012 22:32'!
readFractionPartNumberOfTrailingZeroInIntegerPart: numberOfTrailingZeroInIntegerPart
	"at this stage, sign integerPart and a decimal point have been read.
	try and form a number with a fractionPart"
	
	| numberOfNonZeroFractionDigits numberOfTrailingZeroInFractionPart mantissa value |
	fractionPart := self nextUnsignedIntegerOrNilBase: base.
	fractionPart ifNil: ["No fractionPart found, ungobble the decimal point and return the integerPart"
					sourceStream skip: -1.
					^ neg
						ifTrue: [integerPart negated]
						ifFalse: [integerPart]].
	numberOfNonZeroFractionDigits := lastNonZero.
	numberOfTrailingZeroInFractionPart := nDigits - lastNonZero.
	self readExponent.
	fractionPart isZero
		ifTrue: [mantissa := integerPart
						// (base raisedToInteger: numberOfTrailingZeroInIntegerPart).
			exponent := exponent + numberOfTrailingZeroInIntegerPart]
		ifFalse: [mantissa := integerPart
						* (base raisedToInteger: numberOfNonZeroFractionDigits) + (fractionPart // (base raisedToInteger: numberOfTrailingZeroInFractionPart)).
			exponent := exponent - numberOfNonZeroFractionDigits].

	value := exponent positive
		ifTrue: [mantissa * (base raisedToInteger: exponent)]
		ifFalse: [mantissa / (base raisedToInteger: exponent negated)].
	^ neg
		ifTrue: [value negated]
		ifFalse: [value]! !

!SqNumberParser methodsFor: 'parsing-private' stamp: ''!
readNamedFloatOrFail
	neg
		ifFalse: [(sourceStream nextMatchAll: 'NaN')
				ifTrue: [^ Float nan]].
	(sourceStream nextMatchAll: 'Infinity')
		ifTrue: [^ neg
				ifTrue: [Float infinity negated]
				ifFalse: [Float infinity]].
	^ self expected: 'a digit between 0 and '
			, (String
					with: (Character digitValue: base - 1))! !

!SqNumberParser methodsFor: 'parsing-private' stamp: ''!
readNumberWithFractionPartNumberOfTrailingZeroInIntegerPart: t1 
	| t2 t3 t4 t5 |
	fractionPart := self nextUnsignedIntegerOrNilBase: base.
	fractionPart
		ifNil: [sourceStream skip: -1.
			^ neg
				ifTrue: [integerPart negated]
				ifFalse: [integerPart]].
	t2 := lastNonZero.
	t3 := nDigits - lastNonZero.
	self readExponent
		ifFalse: [self readScale
				ifTrue: [^ self makeScaledDecimalWithNumberOfNonZeroFractionDigits: t2 andNumberOfTrailingZeroInFractionPart: t3]].
	fractionPart isZero
		ifTrue: [t4 := integerPart
						// (base raisedToInteger: t1).
			exponent := exponent + t1]
		ifFalse: [t4 := integerPart
						* (base raisedToInteger: t2) + (fractionPart
							// (base raisedToInteger: t3)).
			exponent := exponent - t2].
	t5 := self
				makeFloatFromMantissa: t4
				exponent: exponent
				base: base.
	^ neg
		ifTrue: [t5 isZero
				ifTrue: [Float negativeZero]
				ifFalse: [t5 negated]]
		ifFalse: [t5]! !

!SqNumberParser methodsFor: 'parsing-private' stamp: ''!
readScale
	scale := 0.
	sourceStream atEnd
		ifTrue: [^ false].
	(sourceStream peekFor: $s)
		ifFalse: [^ false].
	scale := self nextUnsignedIntegerOrNilBase: 10.
	scale
		ifNil: [scale := 0.
			sourceStream skip: -1.
			^ false].
	^ true! !

Object subclass: #Stopwatch
	instanceVariableNames: 'timespans state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology'!

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
activate
	self isSuspended
		ifTrue: [self timespans
				add: (Timespan starting: DateAndTime now duration: Duration zero).
			self state: #active]! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
duration
	| t1 t2 |
	self isSuspended
		ifTrue: [(t1 := self timespans) isEmpty
				ifTrue: [t1 := {Timespan starting: DateAndTime now duration: Duration zero}]]
		ifFalse: [t2 := self timespans last.
			t1 := self timespans allButLast add: (t2 duration: DateAndTime now - t2 start;
							 yourself);
						 yourself].
	^ (t1
		collect: [:t3 | t3 duration]) sum! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
end
	^ self timespans last next! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
isActive
	^ self state = #active! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
isSuspended
	^ self state = #suspended! !

!Stopwatch methodsFor: 'copying' stamp: 'cmm 1/28/2012 16:31'!
postCopy
	super postCopy.
	timespans := timespans copy! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(;
		 nextPutAll: self state;
		 nextPut: $:;
		 print: self duration;
		 nextPut: $)! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
reActivate
	self suspend; activate! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
reset
	self suspend.
	timespans := nil! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
start
	^ self timespans first start! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
state
	^ state
		ifNil: [state := #suspended]! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
state: t1 
	state := t1! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
suspend
	| t1 |
	self isActive
		ifTrue: [t1 := self timespans last.
			t1 duration: DateAndTime now - t1 start.
			self state: #suspended]! !

!Stopwatch methodsFor: 'squeak protocol' stamp: ''!
timespans
	^ timespans
		ifNil: [timespans := OrderedCollection new]! !

Model subclass: #StringHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Models'!

!StringHolder class methodsFor: 'yellow button menu' stamp: ''!
codePaneMenu: t1 shifted: t2 
	t1
		addList: (t2
				ifTrue: [self shiftedYellowButtonMenuItems]
				ifFalse: [self yellowButtonMenuItems]).
	^ t1! !

!StringHolder class methodsFor: 'class initialization' stamp: ''!
initialize
	^ self! !

!StringHolder class methodsFor: 'instance creation' stamp: 'fbs 4/28/2010 18:53'!
open
	^ (Smalltalk at: #Workspace ifAbsent:[self]) new openLabel: 'Workspace'
		"Not to be confused with our own class var 'Workspace'"! !

!StringHolder class methodsFor: 'instance creation' stamp: 'dtl 5/15/2011 20:46'!
openLabel: aString

	^self new openLabel: aString! !

!StringHolder class methodsFor: 'yellow button menu' stamp: ''!
shiftedYellowButtonMenuItems
	| t1 |
	t1 := OrderedCollection withAll: {{'explain' translated. #explain}. {'pretty print' translated. #prettyPrint}. {'pretty print with color' translated. #prettyPrintWithColor}. {'file it in (G)' translated. #fileItIn}. {'spawn (o)' translated. #spawn}. #-. {'browse it (b)' translated. #browseIt}. {'senders of it (n)' translated. #sendersOfIt}. {'implementors of it (m)' translated. #implementorsOfIt}. {'references to it (N)' translated. #referencesToIt}. #-. {'selectors containing it (W)' translated. #methodNamesContainingIt}. {'method strings with it (E)' translated. #methodStringsContainingit}. {'method source with it' translated. #methodSourceContainingIt}. {'class names containing it' translated. #classNamesContainingIt}. {'class comments with it' translated. #classCommentsContainingIt}. {'change sets with it' translated. #browseChangeSetsWithSelector}. #-. {'save contents to file...' translated. #saveContentsInFile}. {'send contents to printer' translated. #sendContentsToPrinter}. {'printer setup' translated. #printerSetup}. #-}.
	Smalltalk isMorphic
		ifFalse: [t1 add: {'special menu...' translated. #presentSpecialMenu}].
	t1 add: {'more...' translated. #yellowButtonActivity}.
	^ t1! !

!StringHolder class methodsFor: 'window color' stamp: ''!
windowColorSpecification
	^ WindowColorSpec
		classSymbol: self name
		wording: 'Workspace'
		brightColor: #lightYellow
		pastelColor: #paleYellow
		helpMessage: 'A place for text in a window.'! !

!StringHolder class methodsFor: 'yellow button menu' stamp: 'yo 6/23/2011 00:16'!
yellowButtonMenuItems
	"Returns the standard yellow button menu items"
	^{
			{'set font... (k)' translated.				#offerFontMenu}.
			{'set style... (K)' translated.				#changeStyle}.
			{'set alignment... (u)' translated.		#chooseAlignment}.
			#-.
			{'make project link (P)' translated.	#makeProjectLink}.
			#-.
			{'find...(f)' translated.					#find}.
			{'find again (g)' translated.				#findAgain}.
			{'set search string (h)' translated.		#setSearchString}.
			#-.
			{'do again (j)' translated.				#again}.
			{'undo (z)' translated.					#undo}.
			#-.
			{'copy (c)' translated.					#copySelection}.
			{'cut (x)' translated.						#cut}.
			{'paste (v)' translated.					#paste}.
			{'paste...' translated.					#pasteRecent}.
			#-.
			{'do it (d)' translated.		#doIt}.			     
		{'print it (p)' translated.		#printIt}.		     
		{'inspect it (i)' translated.		#inspectIt}.		     
		{'explore it (I)' translated.		#exploreIt}.		     
		{'debug it' translated.			#debugIt}.		     
		{'button for it' translated.			#buttonForIt}.		     
		{'tally it' translated.			#tallyIt}.
			#-.
			{'accept (s)' translated.					#accept}.
			{'cancel (l)' translated.					#cancel}.
			#-.
			{'show bytecodes' translated.			#showBytecodes}.
			#-.
			{'copy html' translated.					#copyHtml}.
			#-.
			{'more...' translated.					#shiftedTextPaneMenuRequest}.
		}! !

!StringHolder methodsFor: 'accessing' stamp: ''!
acceptContents: t1 
	self contents: t1.
	^ true! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
annotation
	^ ''! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
buildCodePaneWith: t1 
	| t2 |
	t2 := t1 pluggableTextSpec new.
	t2 model: self;
		 getText: #contents;
		 setText: #contents:notifying:;
		 selection: #contentsSelection;
		 menu: #codePaneMenu:shifted:.
	^ t2! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
buildOptionalButtonsWith: t1 
	| t2 |
	t2 := t1 pluggablePanelSpec new.
	t2 children: OrderedCollection new.
	self optionalButtonPairs
		do: [:t3 | 
			| t4 |
			t4 := t1 pluggableActionButtonSpec new.
			t4 model: self.
			t4 label: t3 first.
			t4 action: t3 second.
			t3 size > 2
				ifTrue: [t4 help: t3 third].
			t2 children add: t4].
	t2 layout: #horizontal.
	^ t2! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
buildWindowWith: t1 
	| t2 |
	t2 := t1 pluggableWindowSpec new.
	t2 model: self.
	t2 label: #labelString.
	t2 children: OrderedCollection new.
	^ t2! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
buildWindowWith: t1 specs: t2 
	| t3 |
	t3 := self buildWindowWith: t1.
	t2
		do: [:t4 | 
			| t5 t6 t7 |
			t5 := t4 key.
			t6 := t4 value.
			t7 := t6 value.
			t7
				ifNotNil: [t7 frame: t5.
					t3 children add: t7]].
	^ t3! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
buildWith: t1 
	| t2 |
	t2 := self buildWindowWith: t1 specs: {(0 @ 0 corner: 1 @ 1)
					-> [self buildCodePaneWith: t1]}.
	^ t1 build: t2! !

!StringHolder methodsFor: 'accessing' stamp: ''!
classCommentIndicated
	^ false! !

!StringHolder methodsFor: 'user edits' stamp: ''!
clearUserEditFlag
	self changed: #clearUserEdits! !

!StringHolder methodsFor: 'code pane menu' stamp: ''!
codePaneMenu: t1 shifted: t2 
	^ self class codePaneMenu: t1 shifted: t2! !

!StringHolder methodsFor: 'accessing' stamp: ''!
contents
	^ contents! !

!StringHolder methodsFor: 'accessing' stamp: ''!
contents: t1 
	contents := t1! !

!StringHolder methodsFor: 'code pane menu' stamp: ''!
contents: t1 notifying: t2 
	^ self acceptContents: t1! !

!StringHolder methodsFor: 'accessing' stamp: ''!
contentsSelection
	^ 1 to: 0! !

!StringHolder methodsFor: 'initialize-release' stamp: ''!
defaultContents
	^ ''! !

!StringHolder methodsFor: 'evaluation' stamp: ''!
doItContext
	^ nil! !

!StringHolder methodsFor: 'evaluation' stamp: ''!
doItReceiver
	^ nil! !

!StringHolder methodsFor: 'initialize-release' stamp: ''!
initialize
	contents := self defaultContents! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
labelString
	^ self class name! !

!StringHolder methodsFor: 'accessing' stamp: ''!
noteAcceptanceOfCodeFor: t1 
	^ self! !

!StringHolder methodsFor: 'user edits' stamp: ''!
okToChange
	self canDiscardEdits
		ifTrue: [^ true].
	self changed: #wantToChange.
	^ self canDiscardEdits! !

!StringHolder methodsFor: 'initialize-release' stamp: ''!
openLabel: t1 
	^ ToolBuilder open: self label: t1! !

!StringHolder methodsFor: 'toolbuilder' stamp: ''!
optionalButtonPairs
	^ #()! !

!StringHolder methodsFor: 'code pane menu' stamp: ''!
perform: t1 orSendTo: t2 
	(self respondsTo: t1)
		ifTrue: [^ self perform: t1].
	^ t2 perform: t1! !

!StringHolder methodsFor: 'accessing' stamp: ''!
reformulateList
	^ self! !

!StringHolder methodsFor: 'accessing' stamp: ''!
reformulateListNoting: t1 
	^ self reformulateList! !

!StringHolder methodsFor: 'accessing' stamp: ''!
selectedClassName
	self selectedClass
		ifNotNil: [^ self selectedClass name].
	^ nil! !

!StringHolder methodsFor: 'accessing' stamp: ''!
selectedClassOrMetaClass
	^ self selectedClass! !

!StringHolder methodsFor: 'accessing' stamp: ''!
selectedMessageName
	^ nil! !

!StringHolder methodsFor: 'code pane menu' stamp: ''!
showBytecodes
	^ self changed: #flash! !

!StringHolder methodsFor: 'code pane menu' stamp: ''!
spawn: t1 
	UIManager default edit: t1 label: 'Workspace'! !

!StringHolder methodsFor: 'accessing' stamp: ''!
textContents: t1 
	contents := t1! !

!StringHolder methodsFor: 'optional panes' stamp: ''!
wantsAnnotationPane
	^ Preferences annotationPanes! !

!StringHolder methodsFor: 'optional panes' stamp: ''!
wantsOptionalButtons
	^ Preferences optionalButtons! !

Magnitude subclass: #Timespan
	instanceVariableNames: 'start duration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology'!

Timespan subclass: #Schedule
	instanceVariableNames: 'schedule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology'!

!Schedule methodsFor: 'enumerating' stamp: ''!
between: t1 and: t2 do: t3 
	| t4 t5 t6 |
	t5 := self end min: t2.
	t4 := self start.
	t6 := 1.
	[t4 < t1]
		whileTrue: [t4 := t4
						+ (schedule at: t6).
			t6 := t6 + 1.
			t6 > schedule size
				ifTrue: [t6 := 1]].
	t6 := 1.
	[t4 <= t5]
		whileTrue: [t3 value: t4.
			t4 := t4
						+ (schedule at: t6).
			t6 := t6 + 1.
			t6 > schedule size
				ifTrue: [t6 := 1]]! !

!Schedule methodsFor: 'enumerating' stamp: ''!
dateAndTimes
	| t1 |
	t1 := OrderedCollection new.
	self
		scheduleDo: [:t2 | t1 add: t2].
	^ t1 asArray! !

!Schedule methodsFor: 'squeak protocol' stamp: ''!
includes: t1 
	| t2 |
	t2 := t1 asDateAndTime.
	self
		scheduleDo: [:t3 | 
			t3 = t2
				ifTrue: [^ true].
			nil].
	^ false! !

!Schedule methodsFor: 'enumerating' stamp: ''!
schedule
	^ schedule! !

!Schedule methodsFor: 'enumerating' stamp: ''!
schedule: t1 
	schedule := t1! !

!Schedule methodsFor: 'enumerating' stamp: ''!
scheduleDo: t1 
	self
		between: self start
		and: self end
		do: t1! !

!Timespan class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 20:19'!
current
	^ self starting: (DateAndTime nowWithOffset: self defaultOffset)! !

!Timespan class methodsFor: 'configuring' stamp: 'cmm 2/10/2012 16:51'!
defaultOffset
	"Timespans created in the context of an offset will start in that offset.  When no context is available, the defaultOffset for Timespans must be zero.  For example, two ways to make a Date for today:
	Date today.  'start is midnight at offset zero.  Will compare successfully to other Date today results.'
	DateAndTime now asDate.  'In this case, the start is midnight of the local time-zone.  It can only compare equally to Dates of its time-zone.'"
	^ Duration zero! !

!Timespan class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 22:08'!
new
	"Answer a Timespan starting on the Squeak epoch: 1 January 1901"
	^ self starting: (DateAndTime new offset: self defaultOffset)! !

!Timespan class methodsFor: 'squeak protocol' stamp: ''!
starting: t1 
	^ self starting: t1 duration: Duration zero! !

!Timespan class methodsFor: 'squeak protocol' stamp: ''!
starting: t1 duration: t2 
	^ self basicNew start: t1 asDateAndTime;
		 duration: t2;
		 yourself! !

!Timespan class methodsFor: 'squeak protocol' stamp: ''!
starting: t1 ending: t2 
	^ self starting: t1 duration: t2 asDateAndTime - t1! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
+ t1 
	^ self class starting: self start + t1 duration: self duration! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
- t1 
	^ (t1 respondsTo: #asDateAndTime)
		ifTrue: [self start - t1]
		ifFalse: [self + t1 negated]! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
< t1 
	^ self start < t1! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
= t1 
	^ self class = t1 class
		and: [self start = t1 start
				and: [self duration = t1 duration]]! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asDate
	^ start asDate! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asDateAndTime
	^ start! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asDuration
	^ self duration! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asMonth
	^ start asMonth! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asTime
	^ start asTime! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asTimeStamp
	^ start asTimeStamp! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asWeek
	^ start asWeek! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
asYear
	^ start asYear! !

!Timespan methodsFor: 'enumerating' stamp: ''!
dates
	| t1 |
	t1 := OrderedCollection new.
	self
		datesDo: [:t2 | t1 add: t2].
	^ t1 asArray! !

!Timespan methodsFor: 'enumerating' stamp: ''!
datesDo: t1 
	self do: t1 with: start asDate! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
day
	^ self dayOfYear! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
dayOfMonth
	^ start dayOfMonth! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
dayOfWeek
	^ start dayOfWeek! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
dayOfWeekName
	^ start dayOfWeekName! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
dayOfYear
	^ start dayOfYear! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
daysInMonth
	^ start daysInMonth! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
daysInYear
	^ start daysInYear! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
daysLeftInYear
	^ start daysLeftInYear! !

!Timespan methodsFor: 'private' stamp: ''!
do: t1 with: t2 
	self
		do: t1
		with: t2
		when: [:t3 | true]! !

!Timespan methodsFor: 'private' stamp: ''!
do: t1 with: t2 when: t3 
	| t4 t5 |
	t4 := t2.
	t5 := self end.
	[t4 start <= t5]
		whileTrue: [(t3 value: t4)
				ifTrue: [t1 value: t4].
			t4 := t4 next]! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
duration
	^ duration! !

!Timespan methodsFor: 'private' stamp: ''!
duration: t1 
	duration := t1! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
end
	^ self duration asNanoSeconds = 0
		ifTrue: [self start]
		ifFalse: [self next start - DateAndTime clockPrecision]! !

!Timespan methodsFor: 'enumerating' stamp: ''!
every: t1 do: t2 
	| t3 t4 |
	t3 := self start.
	t4 := self end.
	[t3 <= t4]
		whileTrue: [t2 value: t3.
			t3 := t3 + t1]! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
firstDayOfMonth
	^ start firstDayOfMonth! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
hash
	^ start hash + duration hash! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
includes: t1 
	^ (t1 isKindOf: Timespan)
		ifTrue: [(self includes: t1 start)
				and: [self includes: t1 end]]
		ifFalse: [t1 asDateAndTime between: start and: self end]! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
includesAllOf: t1 
	t1
		do: [:t2 | (self includes: t2)
				ifFalse: [^ false]].
	^ true! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
includesAnyOf: t1 
	t1
		do: [:t2 | 
			(self includes: t2)
				ifTrue: [^ true].
			nil].
	^ false! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
intersection: t1 
	| t2 t3 |
	t2 := self start max: t1 start.
	t3 := self end min: t1 end.
	t3 < t2
		ifTrue: [^ nil].
	^ self class starting: t2 ending: t3! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
isLeapYear
	^ start isLeapYear! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
julianDayNumber
	^ start julianDayNumber! !

!Timespan methodsFor: 'squeak protocol' stamp: 'cmm 7/10/2011 21:31'!
makeUTC
	"Change the receiver's timezone to UTC, which affords substantially better hashing performance."
	start makeUTC! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
month
	^ start month! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
monthAbbreviation
	^ start monthAbbreviation! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
monthIndex
	^ self month! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
monthName
	^ start monthName! !

!Timespan methodsFor: 'enumerating' stamp: ''!
months
	| t1 |
	t1 := OrderedCollection new: 12.
	self
		monthsDo: [:t2 | t1 add: t2].
	^ t1 asArray! !

!Timespan methodsFor: 'enumerating' stamp: ''!
monthsDo: t1 
	self do: t1 with: start asMonth! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
next
	^ self class starting: start + duration duration: duration! !

!Timespan methodsFor: 'smalltalk-80' stamp: ''!
previous
	^ self class starting: start - duration duration: duration! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(;
		 print: start;
		 nextPut: $D;
		 print: duration;
		 nextPut: $)! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
start
	^ start! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
start: t1 
	start := t1 asDateAndTime! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
to: t1 
	^ Timespan starting: self start ending: t1 asDateAndTime! !

!Timespan methodsFor: 'squeak protocol' stamp: ''!
union: t1 
	| t2 t3 |
	t2 := self start min: t1 start.
	t3 := self end max: t1 end.
	^ Timespan starting: t2 ending: t3 + DateAndTime clockPrecision! !

!Timespan methodsFor: 'enumerating' stamp: ''!
weeks
	| t1 |
	t1 := OrderedCollection new.
	self
		weeksDo: [:t2 | t1 add: t2].
	^ t1 asArray! !

!Timespan methodsFor: 'enumerating' stamp: ''!
weeksDo: t1 
	self do: t1 with: self asWeek! !

!Timespan methodsFor: 'enumerating' stamp: ''!
workDatesDo: t1 
	self
		do: t1
		with: start asDate
		when: [:t2 | t2 dayOfWeek < 6]! !

!Timespan methodsFor: 'ansi protocol' stamp: ''!
year
	^ start year! !

!Timespan methodsFor: 'enumerating' stamp: ''!
years
	| t1 |
	t1 := OrderedCollection new.
	self
		yearsDo: [:t2 | t1 add: t2].
	^ t1 asArray! !

!Timespan methodsFor: 'enumerating' stamp: ''!
yearsDo: t1 
	self do: t1 with: start asYear! !

Boolean subclass: #True
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!True class methodsFor: 'as yet unclassified' stamp: ''!
initializedInstance
	^ true! !

!True methodsFor: 'logical operations' stamp: ''!
& t1 
	^ t1! !

!True methodsFor: 'logical operations' stamp: 'nice 2/1/2011 21:50'!
==> aBlock
	^aBlock value! !

!True methodsFor: 'controlling' stamp: ''!
and: t1 
	^ t1 value! !

!True methodsFor: 'printing' stamp: ''!
asBit
	^ 1! !

!True methodsFor: 'controlling' stamp: ''!
ifFalse: t1 
	^ nil! !

!True methodsFor: 'controlling' stamp: ''!
ifFalse: t1 ifTrue: t2 
	^ t2 value! !

!True methodsFor: 'controlling' stamp: ''!
ifTrue: t1 
	^ t1 value! !

!True methodsFor: 'controlling' stamp: ''!
ifTrue: t1 ifFalse: t2 
	^ t1 value! !

!True methodsFor: 'logical operations' stamp: ''!
not
	^ false! !

!True methodsFor: 'controlling' stamp: ''!
or: t1 
	^ self! !

!True methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: 'true'! !

!True methodsFor: 'logical operations' stamp: ''!
xor: t1 
	^ t1 not! !

!True methodsFor: 'logical operations' stamp: ''!
| t1 
	^ self! !

Object subclass: #UndefinedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!UndefinedObject class methodsFor: 'accessing' stamp: ''!
allInstancesDo: t1 
	t1 value: nil! !

!UndefinedObject class methodsFor: 'instance creation' stamp: ''!
initializedInstance
	^ nil! !

!UndefinedObject class methodsFor: 'instance creation' stamp: ''!
new
	self error: 'You may not create any more undefined objects--use nil'! !

!UndefinedObject methodsFor: 'dependents access' stamp: ''!
addDependent: t1 
	self error: 'Nil should not have dependents'! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
addSubclass: t1 
	^ self! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
allSuperclassesDo: t1 
	self shouldBeImplemented! !

!UndefinedObject methodsFor: 'sets support' stamp: ''!
asSetElement
	^ SetElement withNil! !

!UndefinedObject methodsFor: 'bottom context' stamp: ''!
canHandleSignal: t1 
	^ false! !

!UndefinedObject methodsFor: 'copying' stamp: ''!
clone
	^ self! !

!UndefinedObject methodsFor: 'copying' stamp: ''!
deepCopy
	^ self! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
environment
	^ self class environment! !

!UndefinedObject methodsFor: '3ds parser support' stamp: ''!
from3DS: t1 
	^ t1! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
haltIfNil
	self halt! !

!UndefinedObject methodsFor: 'bottom context' stamp: ''!
handleSignal: t1 
	^ t1 resumeUnchecked: t1 defaultAction! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNil: t1 
	^ t1 value! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNil: t1 ifNotNil: t2 
	^ t1 value! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNil: t1 ifNotNilDo: t2 
	^ t1 value! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNotNil: t1 
	^ self! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNotNil: t1 ifNil: t2 
	^ t2 value! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNotNilDo: t1 
	^ self! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
ifNotNilDo: t1 ifNil: t2 
	^ t2 value! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
isEmptyOrNil
	^ true! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
isLiteral
	^ true! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
isNil
	^ true! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
literalScannedAs: t1 notifying: t2 
	^ t1! !

!UndefinedObject methodsFor: 'testing' stamp: ''!
notNil
	^ false! !

!UndefinedObject methodsFor: 'compiling' stamp: ''!
parserClass
	^ Compiler parserClass! !

!UndefinedObject methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: 'nil'! !

!UndefinedObject methodsFor: 'dependents access' stamp: ''!
release
	^ self! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
removeObsoleteSubclass: t1 
	^ self! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
removeSubclass: t1 
	^ self! !

!UndefinedObject methodsFor: 'copying' stamp: ''!
shallowCopy
	^ self! !

!UndefinedObject methodsFor: 'printing' stamp: ''!
storeOn: t1 
	t1 nextPutAll: 'nil'! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
subclass: t1 instanceVariableNames: t2 classVariableNames: t3 poolDictionaries: t4 category: t5 
	Transcript show: 'Attempt to create ' , t1 , ' as a subclass of nil.  Possibly a class is being loaded before its superclass.';
		 cr.
	^ ProtoObject
		subclass: t1
		instanceVariableNames: t2
		classVariableNames: t3
		poolDictionaries: t4
		category: t5! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
subclassDefinerClass
	^ Compiler! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
subclasses
	| t1 |
	t1 := WriteStream on: Array new.
	self
		subclassesDo: [:t2 | t1 nextPut: t2].
	^ t1 contents! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
subclassesDo: t1 
	^ Class
		subclassesDo: [:t2 | t2 isMeta
				ifTrue: [t1 value: t2 soleInstance]]! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
subclassesDoGently: t1 
	^ Class
		subclassesDoGently: [:t2 | t2 isMeta
				ifTrue: [t1 value: t2 soleInstance]]! !

!UndefinedObject methodsFor: 'dependents access' stamp: ''!
suspend
	Processor terminateActive! !

!UndefinedObject methodsFor: 'class hierarchy' stamp: ''!
typeOfClass
	^ #normal! !

!UndefinedObject methodsFor: 'copying' stamp: ''!
veryDeepCopyWith: t1 
	^ self! !

Model subclass: #ValueHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Models'!

!ValueHolder methodsFor: 'accessing' stamp: ''!
contents
	^ contents! !

!ValueHolder methodsFor: 'accessing' stamp: ''!
contents: t1 
	contents := t1.
	self contentsChanged! !

Object weakSubclass: #WeakMessageSend
	instanceVariableNames: 'selector shouldBeNil arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!WeakMessageSend class methodsFor: 'instance creation' stamp: ''!
new
	^ self new: 1! !

!WeakMessageSend class methodsFor: 'instance creation' stamp: ''!
receiver: t1 selector: t2 
	^ self
		receiver: t1
		selector: t2
		arguments: #()! !

!WeakMessageSend class methodsFor: 'instance creation' stamp: ''!
receiver: t1 selector: t2 argument: t3 
	^ self
		receiver: t1
		selector: t2
		arguments: (Array with: t3)! !

!WeakMessageSend class methodsFor: 'instance creation' stamp: ''!
receiver: t1 selector: t2 arguments: t3 
	^ self new receiver: t1;
		 selector: t2;
		 arguments: t3! !

!WeakMessageSend methodsFor: 'comparing' stamp: ''!
= t1 
	^ t1 isMessageSend
		and: [self receiver == t1 receiver
				and: [selector == t1 selector
						and: [(Array withAll: arguments)
								= (Array withAll: t1 arguments)]]]! !

!WeakMessageSend methodsFor: 'accessing' stamp: ''!
arguments
	^ arguments
		ifNil: [Array new]! !

!WeakMessageSend methodsFor: 'accessing' stamp: ''!
arguments: t1 
	arguments := WeakArray withAll: t1.
	shouldBeNil := Array
				withAll: (t1
						collect: [:t2 | t2 isNil])! !

!WeakMessageSend methodsFor: 'converting' stamp: ''!
asMessageSend
	^ MessageSend
		receiver: self receiver
		selector: selector
		arguments: (Array withAll: self arguments)! !

!WeakMessageSend methodsFor: 'converting' stamp: 'jmv 5/13/2009 10:19'!
asMinimalRepresentation

	^self isReceiverOrAnyArgumentGarbage
		ifTrue: [ nil ]
		ifFalse: [ self ]! !

!WeakMessageSend methodsFor: 'private' stamp: ''!
collectArguments: t1 
	| t2 |
	t2 := self arguments.
	^ t1 size = t2 size
		ifTrue: [t1]
		ifFalse: [(t2 isEmpty
				ifTrue: [t2 := Array new: selector numArgs]
				ifFalse: [t2 copy])
				replaceFrom: 1
				to: (t1 size min: t2 size)
				with: t1
				startingAt: 1]! !

!WeakMessageSend methodsFor: 'comparing' stamp: ''!
hash
	^ self receiver hash bitXor: selector hash! !

!WeakMessageSend methodsFor: 'private' stamp: ''!
isAnyArgumentGarbage
	arguments
		ifNotNil: [arguments
				with: shouldBeNil
				do: [:t1 :t2 | 
					(t2 not
							and: [t1 isNil])
						ifTrue: [^ true].
					nil]].
	^ false! !

!WeakMessageSend methodsFor: 'testing' stamp: ''!
isMessageSend
	^ true! !

!WeakMessageSend methodsFor: 'private' stamp: ''!
isReceiverGarbage
	^ self receiver isNil! !

!WeakMessageSend methodsFor: 'private' stamp: ''!
isReceiverOrAnyArgumentGarbage
	^ self isReceiverGarbage
		or: [self isAnyArgumentGarbage]! !

!WeakMessageSend methodsFor: 'printing' stamp: ''!
printOn: t1 
	t1 nextPutAll: self class name;
		 nextPut: $(.
	selector printOn: t1.
	t1 nextPutAll: ' -> '.
	self receiver printOn: t1.
	t1 nextPut: $)! !

!WeakMessageSend methodsFor: 'accessing' stamp: ''!
receiver
	^ self at: 1! !

!WeakMessageSend methodsFor: 'accessing' stamp: ''!
receiver: t1 
	self at: 1 put: t1! !

!WeakMessageSend methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!WeakMessageSend methodsFor: 'accessing' stamp: ''!
selector: t1 
	selector := t1! !

!WeakMessageSend methodsFor: 'evaluating' stamp: 'jmv 5/14/2009 10:21'!
value
	^self valueOtherwise: []! !

!WeakMessageSend methodsFor: 'evaluating' stamp: 'ul 8/2/2011 20:14'!
valueOtherwise: aBlock

	^ arguments
		ifNil: [
			self withEnsuredReceiverDo: [ :r | r perform: selector ] otherwise: aBlock ]
		ifNotNil: [
			self
				withEnsuredReceiverAndArgumentsDo: [ :r :a |
					r
						perform: selector
						withArguments: a ]
				otherwise: aBlock ]! !

!WeakMessageSend methodsFor: 'evaluating' stamp: 'jmv 5/14/2009 10:21'!
valueWithArguments: anArray
	^ self valueWithArguments: anArray otherwise: []! !

!WeakMessageSend methodsFor: 'evaluating' stamp: 'ul 8/2/2011 20:14'!
valueWithArguments: anArray otherwise: aBlock
	| argsToUse |
	
	"Safe to use, because they are built before ensureing receiver and args..."
	argsToUse := self collectArguments: anArray.
	^ self
		withEnsuredReceiverAndArgumentsDo: [ :r :a |
			r
				perform: selector
				withArguments: argsToUse ]
		otherwise: aBlock! !

!WeakMessageSend methodsFor: 'evaluating' stamp: 'nice 8/22/2010 21:36'!
valueWithEnoughArguments: anArray
	"call the selector with enough arguments from arguments and anArray"
	^self
		withEnsuredReceiverAndArgumentsDo: [ :r :a |
			r
				perform: selector
				withArguments: a ]
		withEnoughArguments: anArray
		otherwise: [ ]! !

!WeakMessageSend methodsFor: 'private' stamp: 'jmv 5/14/2009 10:03'!
withEnsuredReceiverAndArgumentsDo: aBlock otherwise: altBlock
	"Grab real references to receiver and arguments. If they still exist, evaluate aBlock."

	"Return if my receiver has gone away"
	| r a |
	r := self receiver.
	r ifNil: [ ^altBlock value ].

	
	"Make sure that my arguments haven't gone away"
	a := Array withAll: arguments.
	a with: shouldBeNil do: [ :arg :flag |
		arg ifNil: [ flag ifFalse: [ ^altBlock value ]]
	].

	^aBlock value: r value: a! !

!WeakMessageSend methodsFor: 'private' stamp: 'nice 8/22/2010 21:37'!
withEnsuredReceiverAndArgumentsDo: aBlock withEnoughArguments: anArray otherwise: altBlock
	"call the selector with enough arguments from arguments and anArray"
	| r selfArgs enoughArgs |
	r := self receiver.
	r ifNil: [ ^altBlock value ].
	
	selfArgs := self arguments.
	selfArgs with: shouldBeNil do: [ :arg :flag |
		arg ifNil: [ flag ifFalse: [ ^altBlock value ]]
	].

	enoughArgs := Array new: selector numArgs.
	enoughArgs replaceFrom: 1
		to: ( selfArgs size min: enoughArgs size)
		with: selfArgs
		startingAt: 1.
	enoughArgs size > selfArgs size ifTrue: [
		enoughArgs replaceFrom: selfArgs size + 1
			to: (selfArgs size + anArray size min: enoughArgs size)
			with: anArray
			startingAt: 1.
	].
	^aBlock value: r value: enoughArgs! !

!WeakMessageSend methodsFor: 'private' stamp: 'nice 8/22/2010 17:27'!
withEnsuredReceiverDo: aBlock otherwise: altBlock
	"Grab a real reference to receive. If still there, evaluate aBlock.
	Use altBlock if my receiver has gone away."
	^self receiver
		ifNil: [ altBlock value ]
		ifNotNil: [:r | aBlock value: r ]! !

Timespan subclass: #Year
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology'!

!Year commentStamp: 'cbr 7/28/2010 18:10' prior: 0!
I represent a year.

Try me!! Select the following expression and print it:

Year current daysInYear "Try me again next leap year!!"!

!Year class methodsFor: 'squeak protocol' stamp: ''!
current
	^ self year: DateAndTime now year! !

!Year class methodsFor: 'smalltalk-80' stamp: ''!
daysInYear: t1 
	^ 365
		+ ((self isLeapYear: t1)
				ifTrue: [1]
				ifFalse: [0])! !

!Year class methodsFor: 'squeak protocol' stamp: ''!
isLeapYear: t1 
	| t2 |
	t2 := t1 > 0
				ifTrue: [t1]
				ifFalse: [(t1 + 1) negated].
	^ (t2 \\ 4 ~= 0
		or: [t2 \\ 100 = 0
				and: [t2 \\ 400 ~= 0]]) not! !

!Year class methodsFor: 'smalltalk-80' stamp: ''!
leapYear: t1 
	^ (self isLeapYear: t1)
		ifTrue: [1]
		ifFalse: [0]! !

!Year class methodsFor: 'squeak protocol' stamp: ''!
starting: t1 duration: t2 
	| t3 |
	t3 := t1 asDateAndTime midnight.
	^ super
		starting: t3
		duration: (Duration
				days: (self daysInYear: t3 year))! !

!Year class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 20:21'!
year: aYear 
	^ self starting:
		(DateAndTime
			year: aYear
			month: 1
			day: 1
			hour: 0
			minute: 0
			second: 0
			offset: self defaultOffset)! !

!Year methodsFor: 'squeak protocol' stamp: ''!
asYear
	^ self! !

!Year methodsFor: 'squeak protocol' stamp: ''!
daysInMonth
	self shouldNotImplement! !

!Year methodsFor: 'squeak protocol' stamp: ''!
daysInYear
	^ self duration days! !

!Year methodsFor: 'smalltalk-80' stamp: ''!
previous
	^ self class year: self year - 1! !

!Year methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	t1 nextPutAll: 'a Year ('.
	self start year printOn: t1.
	t1 nextPutAll: ')'! !
(PackageInfo named: 'Kernel') postscript: 'DateAndTime classPool at: #OffsetsAreValid put: true.
Timespan withAllSubclassesDo: [ : each | each initialize ].
HashedCollection rehashAll.
"add this comment for forcing a change detection and a rehashAll..."'!

!ModifiedClassDefinitionEvent methodsFor: '*Kernel-Classes' stamp: ''!
anyChanges
	^ self isSuperclassModified
		or: [self areInstVarsModified
				or: [self areClassVarsModified
						or: [self areSharedPoolsModified
								or: [self isTraitCompositionModified]]]]! !

!ModifiedClassDefinitionEvent methodsFor: '*Kernel-Classes' stamp: ''!
isTraitCompositionModified
	^ self traitComposition printString ~= self oldTraitComposition printString! !

!ModifiedClassDefinitionEvent methodsFor: '*Kernel-Classes' stamp: ''!
oldTraitComposition
	^ oldItem traitComposition! !

!ModifiedClassDefinitionEvent methodsFor: '*Kernel-Classes' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPutAll: ' Super: ';
		 print: self isSuperclassModified;
		 nextPutAll: ' TraitComposition: ';
		 print: self isTraitCompositionModified;
		 nextPutAll: ' InstVars: ';
		 print: self areInstVarsModified;
		 nextPutAll: ' ClassVars: ';
		 print: self areClassVarsModified;
		 nextPutAll: ' SharedPools: ';
		 print: self areSharedPoolsModified! !

!ModifiedClassDefinitionEvent methodsFor: '*Kernel-Classes' stamp: ''!
traitComposition
	^ item traitComposition! !

Dictionary variableSubclass: #MethodDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!MethodDictionary commentStamp: 'nice 2/1/2011 02:47' prior: 0!
I am a special dictionary holding methods. I am just like a normal Dictionary, except that I am implemented differently.  Each Class has an instance of MethodDictionary to hold the correspondence between selectors (names of methods) and methods themselves.

In a normal Dictionary, the instance variable 'array' holds an array of Associations.  Since there are thousands of methods in the system, these Associations waste space.  

Each MethodDictionary is a variable object, with the list of keys (selector Symbols) in the variable part of the instance.  The variable 'array' holds the values, which are CompiledMethods.

I also maintain the following invariant: (self basicAt: index) isNil = (array at: index) isNil.!

!MethodDictionary class methodsFor: 'initialize-release' stamp: 'ul 9/18/2011 15:08'!
compactAllInstances

	| instancesToExchange newInstances |
	instancesToExchange := Array streamContents: [ :oldStream |
		newInstances := Array streamContents: [ :newStream |
			self allInstances do: [ :each |
				| newInstance |
				newInstance := each compactWithoutBecome.
				newInstance capacity = each capacity 
					ifTrue: [ each copyFrom: newInstance ]
					ifFalse: [
						oldStream nextPut: each.
						newStream nextPut: newInstance ] ] ] ].
	instancesToExchange elementsForwardIdentityTo: newInstances! !

!MethodDictionary class methodsFor: 'instance creation' stamp: 'ul 9/27/2011 18:02'!
new
	"Create a new instance with 32 slots, which can hold at most 24 methods before growing is necessary."
	
	^self newForCapacity: 32! !

!MethodDictionary class methodsFor: 'instance creation' stamp: 'ul 9/27/2011 17:51'!
new: numberOfElements
	"Create an instance large enough to hold numberOfElements methods without growing."
	
	^self newForCapacity: (self sizeFor: numberOfElements)! !

!MethodDictionary class methodsFor: 'private' stamp: 'ul 9/27/2011 17:34'!
newForCapacity: capacity
	"Create an instance with the given capacity which must be a power of two."
	
	^(self basicNew: capacity) initialize: capacity! !

!MethodDictionary class methodsFor: 'sizing' stamp: 'ul 1/23/2012 03:16'!
sizeFor: numberOfElements
	"Return the minimum capacity of a dictionary that can hold numberOfElements elements. At least 25% of the array must be empty and the return value must be a power of 2."

	^(numberOfElements * 4 // 3 max: 1) asLargerPowerOfTwo! !

!MethodDictionary methodsFor: 'accessing' stamp: 'ul 6/18/2010 21:38'!
associationAt: key ifAbsent: aBlock 
	"Answer the association with the given key.
	If key is not found, return the result of evaluating aBlock."

	^(array at: (self scanFor: key)) 
		ifNil: [ aBlock value ]
		ifNotNil: [ :value | key -> value ]! !

!MethodDictionary methodsFor: 'enumeration' stamp: ''!
associationsDo: t1 
	tally = 0
		ifTrue: [^ self].
	1
		to: self basicSize
		do: [:t3 | (self basicAt: t3)
				ifNotNil: [:t2 | t1
						value: (Association
								key: t2
								value: (array at: t3))]]! !

!MethodDictionary methodsFor: 'accessing' stamp: ''!
at: t1 ifAbsent: t2 
	^ (array
		at: (self scanFor: t1))
		ifNil: [t2 value]! !

!MethodDictionary methodsFor: 'accessing' stamp: 'ul 9/18/2011 15:13'!
at: key put: value
	"Set the value at key to be value."
	
	| index |
	index := self scanFor: key.
	(self basicAt: index)
		ifNil: [
			self
				basicAt: index put: key;
				atNewIndex: index put: value ]
		ifNotNil: [ 
			(array at: index) flushCache.
			array at: index put: value ].
	^value! !

!MethodDictionary methodsFor: 'private' stamp: 'ul 9/18/2011 15:11'!
compact
	"Make sure that I have the highest possible load factor (between 37.5% and 75%)."
	
	| newInstance |
	newInstance := self compactWithoutBecome.
	newInstance capacity = self capacity
		ifTrue: [ self copyFrom: newInstance ]
		ifFalse: [ self becomeForward: newInstance ]! !

!MethodDictionary methodsFor: 'private' stamp: 'ul 9/18/2011 13:41'!
compactWithoutBecome
	"Return a copy of self which has the highest possible load factor (between 37.5% and 75%)."
	
	| newInstance |
	newInstance := self species new: self size.
	1 to: self basicSize do: [ :index | 
		(self basicAt: index) ifNotNil: [ :key |
			newInstance at: key put: (array at: index) ] ].
	^newInstance! !

!MethodDictionary methodsFor: 'private' stamp: ''!
fixCollisionsFrom: t1 
	| t2 t3 t4 |
	t3 := t1.
	[(t2 := self basicAt: (t3 := t3 \\ array size + 1)) == nil]
		whileFalse: [(t4 := self scanFor: t2) = t3
				ifFalse: [self swap: t3 with: t4]]! !

!MethodDictionary methodsFor: 'private' stamp: 'ul 9/27/2011 17:37'!
grow

	| newSelf |
	newSelf := self species newForCapacity: self basicSize * 2.
	1 to: self basicSize do: [ :i | 
		(self basicAt: i) ifNotNil: [ :key |
			newSelf at: key put: (array at: i) ] ].
	self become: newSelf! !

!MethodDictionary methodsFor: 'accessing' stamp: 'nice 2/1/2011 02:23'!
includesKey: aSymbol
	"This override assumes that instVarsInclude: uses a fast primitive"

	aSymbol ifNil: [^ false].
	^ self instVarsInclude: aSymbol! !

!MethodDictionary methodsFor: 'accessing' stamp: ''!
keyAtIdentityValue: t1 ifAbsent: t2 
	t1
		ifNotNil: [1
				to: self basicSize
				do: [:t3 | (array at: t3)
							== t1
						ifTrue: [^ self basicAt: t3]]].
	^ t2 value! !

!MethodDictionary methodsFor: 'accessing' stamp: ''!
keyAtValue: t1 ifAbsent: t2 
	t1
		ifNotNil: [1
				to: self basicSize
				do: [:t3 | (array at: t3)
							= t1
						ifTrue: [^ self basicAt: t3]]].
	^ t2 value! !

!MethodDictionary methodsFor: 'enumeration' stamp: ''!
keysAndValuesDo: t1 
	tally = 0
		ifTrue: [^ self].
	1
		to: self basicSize
		do: [:t3 | (self basicAt: t3)
				ifNotNil: [:t2 | t1
						value: t2
						value: (array at: t3)]]! !

!MethodDictionary methodsFor: 'enumeration' stamp: ''!
keysDo: t1 
	tally = 0
		ifTrue: [^ self].
	1
		to: self basicSize
		do: [:t3 | (self basicAt: t3)
				ifNotNil: [:t2 | t1 value: t2]]! !

!MethodDictionary methodsFor: 'private' stamp: ''!
methodArray
	self deprecated: 'Use #array'.
	^ array! !

!MethodDictionary methodsFor: 'copying' stamp: ''!
postCopy
	array := array copy! !

!MethodDictionary methodsFor: 'private' stamp: 'ul 9/27/2011 17:40'!
rehash 
	
	| newInstance |
	newInstance := self species newForCapacity: self basicSize.
	1 to: self basicSize do: [ :index | 
		(self basicAt: index) ifNotNil: [ :key |
			newInstance at: key put: (array at: index) ] ].
	self copyFrom: newInstance! !

!MethodDictionary methodsFor: 'removing' stamp: 'ul 9/27/2011 17:41'!
removeAll
	"Remove all elements from this collection. Preserve the capacity"
	
	| newSelf |
	tally = 0 ifTrue: [^self].
	newSelf := self species newForCapacity: self basicSize.
	self copyFrom: newSelf! !

!MethodDictionary methodsFor: 'private' stamp: ''!
removeDangerouslyKey: t1 ifAbsent: t2 
	| t3 t4 |
	t3 := self scanFor: t1.
	(t4 := array at: t3)
		ifNil: [^ t2 value].
	array at: t3 put: nil.
	self basicAt: t3 put: nil.
	tally := tally - 1.
	self fixCollisionsFrom: t3.
	^ t4! !

!MethodDictionary methodsFor: 'removing' stamp: 'ul 9/18/2011 11:39'!
removeKey: key ifAbsent: errorBlock 
	"The interpreter might be using this MethodDict while
	this method is running!!  Therefore we perform the removal
	in a copy, and then atomically copy that copy"

	| copy |
	copy := self copy.
	copy removeDangerouslyKey: key ifAbsent: [^ errorBlock value].
	self copyFrom: copy! !

!MethodDictionary methodsFor: 'private' stamp: ''!
scanFor: t1 
	| t2 t3 |
	t2 := t3 := t1 identityHash \\ array size + 1.
	[((self basicAt: t2)
			ifNil: [true]
			ifNotNil: [:t4 | t4 == t1])
		ifTrue: [^ t2].
	(t2 := t2 \\ array size + 1) = t3] whileFalse.
	self errorNoFreeSpace! !

!MethodDictionary methodsFor: 'private' stamp: ''!
swap: t1 with: t2 
	| t3 |
	t3 := self basicAt: t1.
	self
		basicAt: t1
		put: (self basicAt: t2).
	self basicAt: t2 put: t3.
	array swap: t1 with: t2! !

!MethodDictionary methodsFor: 'enumeration' stamp: ''!
valuesDo: t1 
	tally = 0
		ifTrue: [^ self].
	1
		to: self basicSize
		do: [:t3 | (array at: t3)
				ifNotNil: [:t2 | t1 value: t2]]! !

Link subclass: #Process
	instanceVariableNames: 'suspendedContext priority myList threadId name island env'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Process commentStamp: 'ul 3/22/2011 05:18' prior: 0!
I represent an independent path of control in the system. This path of control may be stopped (by sending the message suspend) in such a way that it can later be restarted (by sending the message resume). When any one of several paths of control can be advanced, the single instance of ProcessorScheduler named Processor determines which one will actually be advanced partly using the value of priority.

(If anyone ever makes a subclass of Process, be sure to use allSubInstances in anyProcessesAbove:.)

The threadId variable is used by multi-threaded CogVMs to control process-to-thread binding. It's required to be the fourth instance variable. See SmalltalkImage >> #processHasThreadIdInstVar: for further information.

The island and env instance variables are not used by core squeak, but are used by external packages and included here because Monticello cannot handle external instance variables:
island: used by Tweak and Croquet to partition the image into multiple address spaces
env: used by ProcessSpecific to implement per-process variables!

!Process class methodsFor: 'instance creation' stamp: ''!
forContext: t1 priority: t2 
	| t3 |
	t3 := self new.
	t3 suspendedContext: t1.
	t3 priority: t2.
	^ t3! !

!Process methodsFor: 'changing suspended state' stamp: ''!
activateReturn: t1 value: t2 
	^ suspendedContext := suspendedContext activateReturn: t1 value: t2! !

!Process methodsFor: 'printing' stamp: ''!
browserPrintString
	^ self browserPrintStringWith: suspendedContext! !

!Process methodsFor: 'printing' stamp: ''!
browserPrintStringWith: t1 
	| t2 |
	t2 := WriteStream
				on: (String new: 100).
	t2 nextPut: $(.
	priority printOn: t2.
	self isSuspended
		ifTrue: [t2 nextPut: $s].
	t2 nextPutAll: ') '.
	t2 nextPutAll: self name.
	t2 nextPut: $:.
	t2 space.
	t2 nextPutAll: t1 asString.
	^ t2 contents! !

!Process methodsFor: 'accessing' stamp: ''!
calleeOf: t1 
	suspendedContext == t1
		ifTrue: [^ nil].
	^ (suspendedContext
		findContextSuchThat: [:t2 | t2 sender == t1])
		ifNil: [self error: 'aContext not in process chain']! !

!Process methodsFor: 'changing suspended state' stamp: ''!
complete: t1 
	| t2 t3 t4 |
	t2 := suspendedContext.
	suspendedContext := nil.
	t3 := t2 runUntilErrorOrReturnFrom: t1.
	suspendedContext := t3 first.
	t4 := t3 second.
	t4
		ifNotNil: [^ t4 signalerContext].
	^ suspendedContext! !

!Process methodsFor: 'changing suspended state' stamp: ''!
completeStep: t1 
	| t2 |
	self suspendedContext == t1
		ifFalse: [^ self
				complete: (self calleeOf: t1)].
	t2 := self step.
	t2 == t1
		ifTrue: [^ t2].
	t1 isDead
		ifTrue: [^ self suspendedContext].
	^ self complete: t2! !

!Process methodsFor: 'changing suspended state' stamp: ''!
completeTo: t1 
	self suspendedContext == t1
		ifTrue: [^ t1].
	^ self
		complete: (self calleeOf: t1)! !

!Process methodsFor: 'accessing' stamp: ''!
copyStack
	^ self copy install: suspendedContext copyStack! !

!Process methodsFor: 'debugging' stamp: ''!
debug
	self debugWithTitle: 'Debug'! !

!Process methodsFor: 'debugging' stamp: ''!
debug: t1 title: t2 
	self
		debug: t1
		title: t2
		full: false! !

!Process methodsFor: 'debugging' stamp: ''!
debug: t1 title: t2 full: t3 
	| t4 |
	t4 := self isActiveProcess
				ifTrue: [thisContext]
				ifFalse: [self suspendedContext].
	(t4 hasContext: t1)
		ifFalse: [^ self error: 'context not in process'].
	ToolSet
		debug: self
		context: t1
		label: t2
		contents: nil
		fullView: t3! !

!Process methodsFor: 'debugging' stamp: ''!
debugWithTitle: t1 
	| t2 |
	t2 := self isActiveProcess
				ifTrue: [thisContext]
				ifFalse: [self suspendedContext].
	self
		debug: t2
		title: t1
		full: true! !

!Process methodsFor: 'process specific' stamp: 'GiovanniCorriga 8/30/2009 15:42'!
environmentAt: key 
	^ self environmentAt: key ifAbsent: [self environmentKeyNotFound]! !

!Process methodsFor: 'process specific' stamp: 'ul 8/16/2011 11:24'!
environmentAt: key  ifAbsent: aBlock
	
	^(env ifNil: [ ^aBlock value ]) at: key ifAbsent: aBlock.! !

!Process methodsFor: 'process specific' stamp: 'ul 9/2/2012 20:03'!
environmentAt: key ifAbsentPut: aBlock
	
	^(env ifNil: [ env := Dictionary new ]) at: key ifAbsentPut: aBlock.! !

!Process methodsFor: 'process specific' stamp: 'ul 8/16/2011 11:24'!
environmentAt: key put: value
	
	^(env ifNil: [ env := Dictionary new ]) at: key put: value.! !

!Process methodsFor: 'process specific' stamp: 'GiovanniCorriga 8/30/2009 15:40'!
environmentKeyNotFound 
	self error: 'Environment key not found'! !

!Process methodsFor: 'process specific' stamp: 'GiovanniCorriga 8/30/2009 15:43'!
environmentRemoveKey: key
	^ self environmentRemoveKey: key ifAbsent: [self environmentKeyNotFound]! !

!Process methodsFor: 'process specific' stamp: 'ul 8/16/2011 11:25'!
environmentRemoveKey: key ifAbsent: errorBlock
	
	^(env ifNil: [ ^errorBlock value ]) removeKey: key ifAbsent: errorBlock! !

!Process methodsFor: 'changing suspended state' stamp: ''!
install: t1 
	self == Processor activeProcess
		ifTrue: [^ self error: 'The active process cannot install contexts'].
	suspendedContext := t1! !

!Process methodsFor: 'accessing' stamp: ''!
isActiveProcess
	^ self == Processor activeProcess! !

!Process methodsFor: 'accessing' stamp: ''!
isSuspended
	^ myList isNil! !

!Process methodsFor: 'accessing' stamp: ''!
isTerminated
	self isActiveProcess
		ifTrue: [^ false].
	^ suspendedContext isNil
		or: [suspendedContext isBottomContext
				and: [suspendedContext pc > suspendedContext startpc]]! !

!Process methodsFor: 'printing' stamp: ''!
longPrintOn: t1 
	| t2 |
	super printOn: t1.
	t1 cr.
	t2 := self suspendedContext.
	[t2 == nil]
		whileFalse: [t1 space.
			t2 printOn: t1.
			t1 cr.
			t2 := t2 sender]! !

!Process methodsFor: 'accessing' stamp: 'svp 12/5/2002 14:42'!
name

	^name ifNil: [ self hash asString forceTo: 5 paddingStartWith: $ ]! !

!Process methodsFor: 'accessing' stamp: ''!
name: t1 
	name := t1! !

!Process methodsFor: 'objects from disk' stamp: ''!
objectForDataStream: t1 
	t1 replace: self with: nil.
	^ nil! !

!Process methodsFor: 'accessing' stamp: ''!
offList
	myList := nil! !

!Process methodsFor: 'changing suspended state' stamp: ''!
popTo: t1 
	| t2 |
	self == Processor activeProcess
		ifTrue: [^ self error: 'The active process cannot pop contexts'].
	t2 := (self calleeOf: t1)
				ifNil: [^ t1].
	^ self return: t2 value: t2 receiver! !

!Process methodsFor: 'changing suspended state' stamp: ''!
popTo: t1 value: t2 
	| t3 |
	self == Processor activeProcess
		ifTrue: [^ self error: 'The active process cannot pop contexts'].
	t3 := (self calleeOf: t1)
				ifNil: [^ self].
	self return: t3 value: t2! !

!Process methodsFor: 'changing process state' stamp: ''!
primitiveResume
	<primitive: 87>
	self primitiveFailed! !

!Process methodsFor: 'printing' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPutAll: ' in '.
	suspendedContext printOn: t1! !

!Process methodsFor: 'accessing' stamp: ''!
priority
	^ priority! !

!Process methodsFor: 'accessing' stamp: ''!
priority: t1 
	(t1 >= Processor lowestPriority
			and: [t1 <= Processor highestPriority])
		ifTrue: [priority := t1]
		ifFalse: [self error: 'Invalid priority: ' , t1 printString]! !

!Process methodsFor: 'signaling' stamp: ''!
pvtSignal: t1 list: t2 
	| t3 |
	self isActiveProcess
		ifFalse: [^ self].
	t1 signal.
	t3 := Semaphore new.
	[self suspend.
	suspendedContext := suspendedContext swapSender: nil.
	t2 class == Semaphore
		ifTrue: [t2 isSignaled
				ifTrue: [t2 wait.
					self resume]
				ifFalse: [myList := t2.
					t2 add: self]]
		ifFalse: [self resume]] fork.
	t3 wait! !

!Process methodsFor: 'changing suspended state' stamp: ''!
restartTop
	suspendedContext privRefresh! !

!Process methodsFor: 'changing suspended state' stamp: ''!
restartTopWith: t1 
	t1 isQuick
		ifTrue: [self popTo: suspendedContext sender]
		ifFalse: [suspendedContext privRefreshWith: t1]! !

!Process methodsFor: 'changing process state' stamp: ''!
resume
	suspendedContext
		ifNil: [^ self primitiveFailed].
	^ self primitiveResume! !

!Process methodsFor: 'changing suspended state' stamp: ''!
return: t1 value: t2 
	suspendedContext == t1
		ifTrue: [^ suspendedContext := t1 return: t2 from: t1].
	self activateReturn: t1 value: t2.
	^ self complete: t1! !

!Process methodsFor: 'changing process state' stamp: ''!
run
	| t1 |
	t1 := Processor activeProcess.
	[t1 suspend.
	self resume]
		forkAt: Processor highestPriority! !

!Process methodsFor: 'signaling' stamp: ''!
signalException: t1 
	| t2 |
	self isActiveProcess
		ifTrue: [^ t1 signal].
	myList
		ifNotNil: [t2 := self suspend].
	suspendedContext := MethodContext
				sender: suspendedContext
				receiver: self
				method: (self class lookupSelector: #pvtSignal:list:)
				arguments: (Array with: t1 with: t2).
	t2
		ifNotNil: [self resume]! !

!Process methodsFor: 'changing suspended state' stamp: ''!
step
	^ suspendedContext := suspendedContext step! !

!Process methodsFor: 'changing suspended state' stamp: ''!
step: t1 
	^ self suspendedContext == t1
		ifTrue: [self step]
		ifFalse: [self
				complete: (self calleeOf: t1)]! !

!Process methodsFor: 'changing suspended state' stamp: ''!
stepToCallee
	| t1 |
	t1 := suspendedContext.
	[t1 == suspendedContext]
		whileTrue: [suspendedContext := suspendedContext step].
	^ suspendedContext! !

!Process methodsFor: 'changing suspended state' stamp: ''!
stepToHome: t1 
	| t2 t3 |
	t2 := t1 home.
	[t3 := self step.
	t2 == t3 home]
		whileFalse: [t2 isDead
				ifTrue: [^ self suspendedContext]].
	^ self suspendedContext! !

!Process methodsFor: 'changing suspended state' stamp: ''!
stepToSendOrReturn
	^ suspendedContext := suspendedContext stepToSendOrReturn! !

!Process methodsFor: 'changing process state' stamp: ''!
suspend
	| t1 |
	<primitive: 88>
	myList
		ifNil: [^ nil].
	t1 := myList.
	myList := nil.
	t1
		remove: self
		ifAbsent: [].
	^ t1! !

!Process methodsFor: 'accessing' stamp: ''!
suspendedContext
	^ suspendedContext! !

!Process methodsFor: 'private' stamp: ''!
suspendedContext: t1 
	suspendedContext := t1! !

!Process methodsFor: 'accessing' stamp: ''!
suspendingList
	^ myList! !

!Process methodsFor: 'changing process state' stamp: ''!
terminate
	| t1 t2 t3 |
	self isActiveProcess
		ifTrue: [t1 := thisContext.
			[t1 := t1 findNextUnwindContextUpTo: nil.
			t1 isNil]
				whileFalse: [(t1 tempAt: 2)
						ifNil: [t1 tempAt: 2 put: nil.
							t2 := t1 tempAt: 1.
							thisContext terminateTo: t1.
							t2 value]].
			thisContext terminateTo: nil.
			self suspend]
		ifFalse: [t3 := self suspend.
			suspendedContext
				ifNotNil: [(t3 class == Semaphore
							and: [suspendedContext method
									== (Semaphore compiledMethodAt: #critical:)])
						ifTrue: [suspendedContext := suspendedContext home].
					(suspendedContext findNextUnwindContextUpTo: nil)
						ifNotNil: [:t5 | (suspendedContext
								findContextSuchThat: [:t6 | t6 closure
										== (t5 tempAt: 1)])
								ifNotNil: [:t4 | suspendedContext runUntilErrorOrReturnFrom: t4]].
					t1 := self popTo: suspendedContext bottomContext.
					t1 == suspendedContext bottomContext
						ifFalse: [self debug: t1 title: 'Unwind error during termination']]]! !

Array variableSubclass: #WeakActionSequence
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Objects'!

!WeakActionSequence methodsFor: 'converting' stamp: ''!
asActionSequence
	^ self! !

!WeakActionSequence methodsFor: 'converting' stamp: ''!
asActionSequenceTrappingErrors
	^ WeakActionSequenceTrappingErrors withAll: self! !

!WeakActionSequence methodsFor: 'converting' stamp: 'jmv 5/13/2009 10:20'!
asMinimalRepresentation

	| valid |
	valid := self reject: [:e | e isReceiverOrAnyArgumentGarbage ].
	valid size = 0
		ifTrue: [ ^nil ].
	valid size = 1
		ifTrue: [ ^valid first ].
	^valid! !

!WeakActionSequence methodsFor: 'printing' stamp: ''!
printOn: t1 
	self size < 2
		ifTrue: [^ super printOn: t1].
	t1 nextPutAll: '#('.
	self
		do: [:t2 | t2 printOn: t1]
		separatedBy: [t1 cr].
	t1 nextPut: $)! !

!WeakActionSequence methodsFor: 'evaluating' stamp: 'nice 8/22/2010 21:05'!
value
	"Answer the result of evaluating the elements of the receiver.
	Actually, return just the last result."

	^self inject: nil into: [ :previousAnswer :each | 
		each valueOtherwise: [ previousAnswer ]].! !

!WeakActionSequence methodsFor: 'evaluating' stamp: 'nice 8/22/2010 21:02'!
valueWithArguments: anArray
	"Return the last result"

	^self inject: nil into: [ :previousAnswer :each |
		each valueWithArguments: anArray otherwise: [ previousAnswer ]]! !

ByteArray variableByteSubclass: #CompiledMethod
	instanceVariableNames: ''
	classVariableNames: 'LargeFrame SmallFrame'
	poolDictionaries: ''
	category: 'Kernel-Methods'!

!CompiledMethod commentStamp: 'ul 1/29/2011 13:18' prior: 0!
My instances are methods suitable for interpretation by the virtual machine.  This is the only class in the system whose instances intermix both indexable pointer fields and indexable integer fields.
I'm a subclass of ByteArray to avoid duplicating some of ByteArray's methods, not because a CompiledMethod is-a ByteArray.

	
The current format of a CompiledMethod is as follows:

	header (4 bytes)
	literals (4 bytes each)
	bytecodes  (variable)
	trailer (variable)

The header is a 30-bit integer with the following format:

(index 0)	9 bits:	main part of primitive number   (#primitive)
(index 9)	8 bits:	number of literals (#numLiterals)
(index 17)	1 bit:	whether a large frame size is needed (#frameSize)
(index 18)	6 bits:	number of temporary variables (#numTemps)
(index 24)	4 bits:	number of arguments to the method (#numArgs)
(index 28)	1 bit:	high-bit of primitive number (#primitive)
(index 29)	1 bit:	flag bit, ignored by the VM  (#flag)


The trailer has two variant formats.  In the first variant, the last byte is at least 252 and the last four bytes represent a source pointer into one of the sources files (see #sourcePointer).  In the second variant, the last byte is less than 252, and the last several bytes are a compressed version of the names of the method's temporary variables.  The number of bytes used for this purpose is the value of the last byte in the method.
!

!CompiledMethod class methodsFor: 'constants' stamp: ''!
abstractMarkers
	^ #(#subclassResponsibility #shouldNotImplement )! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
basicNew: t1 
	self error: 'CompiledMethods may only be created with newMethod:header:'! !

!CompiledMethod class methodsFor: 'constants' stamp: ''!
conflictMarker
	^ #traitConflict! !

!CompiledMethod class methodsFor: 'constants' stamp: ''!
disabledMarker
	^ #shouldNotImplement! !

!CompiledMethod class methodsFor: 'constants' stamp: ''!
explicitRequirementMarker
	^ #explicitRequirement! !

!CompiledMethod class methodsFor: 'class initialization' stamp: ''!
fullFrameSize
	^ LargeFrame! !

!CompiledMethod class methodsFor: 'constants' stamp: ''!
implicitRequirementMarker
	^ #requirement! !

!CompiledMethod class methodsFor: 'class initialization' stamp: ''!
initialize
	SmallFrame := 16.
	LargeFrame := 56! !

!CompiledMethod class methodsFor: 'accessing class hierarchy' stamp: 'eem 9/16/2011 11:12'!
methodPropertiesClass
	"Answer the class to use to create a method's properties, which can be a poor man's way
	 to add instance variables to subclassses of CompiledMethod.  Subclasses of CompiledMethod
	 should define a corresponding subclass of AdditionalMethodState that adds any instance variables
	 required, and override this method to answer that class."
	^AdditionalMethodState! !

!CompiledMethod class methodsFor: 'instance creation' stamp: 'eem 9/14/2011 10:53'!
new
	"This will not make a meaningful method, but it could be used
	to invoke some otherwise useful method in this class."
	^self newMethod: 2 header: 1024! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
new: t1 
	self error: 'CompiledMethods may only be created with newMethod:header:'! !

!CompiledMethod class methodsFor: 'instance creation' stamp: 'eem 9/13/2011 15:16'!
newBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex
	"Answer an instance of me. The header is specified by the message 
	arguments. The remaining parts are not as yet determined."
	| largeBit primBits |
	nTemps > 63 ifTrue:
		[^ self error: 'Cannot compile -- too many temporary variables'].	
	nLits > 255 ifTrue:
		[^ self error: 'Cannot compile -- too many literals variables'].	
	largeBit := (nTemps + stackSize) > SmallFrame ifTrue: [1] ifFalse: [0].
	primBits := primitiveIndex <= 16r1FF
		ifTrue: [primitiveIndex]
		ifFalse: ["For now the high bit of primitive no. is in the 29th bit of header"
				primitiveIndex > 16r3FF ifTrue: [self error: 'prim num too large'].
				(primitiveIndex bitAnd: 16r1FF) + ((primitiveIndex bitAnd: 16r200) bitShift: 19)].

	^trailer
		createMethod: numberOfBytes
		class: self
		header: (nArgs bitShift: 24) +
				(nTemps bitShift: 18) +
				(largeBit bitShift: 17) +
				(nLits bitShift: 9) +
				primBits! !

!CompiledMethod class methodsFor: 'instance creation' stamp: 'eem 9/13/2011 15:18'!
newBytes: numberOfBytes trailerBytes: trailer nArgs: nArgs nTemps: nTemps nStack: stackSize nLits: nLits primitive: primitiveIndex flag: flag
	"Answer an instance of me. The header is specified by the message 
	arguments. The remaining parts are not as yet determined."
	| largeBit primBits flagBit |
	nTemps > 63 ifTrue:
		[^ self error: 'Cannot compile -- too many temporary variables'].	
	nLits > 255 ifTrue:
		[^ self error: 'Cannot compile -- too many literals variables'].	
	largeBit := (nTemps + stackSize) > SmallFrame ifTrue: [1] ifFalse: [0].

	"For now the high bit of the primitive no. is in a high bit of the header"
	primBits := (primitiveIndex bitAnd: 16r1FF) + ((primitiveIndex bitAnd: 16r200) bitShift: 19).

	flagBit := flag ifTrue: [ 1 ] ifFalse: [ 0 ].

	"Copy the source code trailer to the end"
	^trailer
		createMethod: numberOfBytes
		class: self
		header: (nArgs bitShift: 24) +
				(nTemps bitShift: 18) +
				(largeBit bitShift: 17) +
				(nLits bitShift: 9) +
				primBits +
				(flagBit bitShift: 29)! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
newFrom: t1 
	| t2 |
	t2 := super basicNew: t1 size.
	1
		to: t1 size
		do: [:t3 | t2
				at: t3
				put: (t1 at: t3)].
	^ t2! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
newInstanceFrom: t1 variable: t2 size: t3 map: t4 
	| t5 |
	t5 := self newFrom: t1.
	1
		to: t3
		do: [:t6 | (t4 at: t6)
					> 0
				ifTrue: [t5
						instVarAt: t6
						put: (t1
								instVarAt: (t4 at: t6))]].
	^ t5! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
newMethod: t1 header: t2 
	<primitive: 79>
	(t1 isInteger
			and: [t2 isInteger
					and: [t1 >= 0]])
		ifTrue: [OutOfMemory signal.
			^ self newMethod: t1 header: t2].
	^ self primitiveFailed! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
primitive: t1 numArgs: t2 numTemps: t3 stackSize: t4 literals: t5 bytecodes: t6 trailer: t7 
	| t8 |
	t8 := self
				newBytes: t6 size
				trailerBytes: t7
				nArgs: t2
				nTemps: t3
				nStack: t4
				nLits: t5 size
				primitive: t1.
	(WriteStream with: t8) position: t8 initialPC - 1;
		 nextPutAll: t6.
	t5
		withIndexDo: [:t9 :t10 | t8 literalAt: t10 put: t9].
	^ t8! !

!CompiledMethod class methodsFor: 'evaluating' stamp: 'ul 6/7/2011 21:58'!
receiver: receiver withArguments: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and the arguments in argArray"

	<primitive: 188>
	^receiver withArgs: argArray executeMethod: compiledMethod! !

!CompiledMethod class methodsFor: 'class initialization' stamp: ''!
smallFrameSize
	^ SmallFrame! !

!CompiledMethod class methodsFor: 'constants' stamp: ''!
subclassResponsibilityMarker
	^ #subclassResponsibility! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
toReturnConstant: t1 trailerBytes: t2 
	^ self
		newBytes: 0
		trailerBytes: t2
		nArgs: 0
		nTemps: 0
		nStack: 0
		nLits: 2
		primitive: 256 + t1! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
toReturnField: t1 trailerBytes: t2 
	^ self
		newBytes: 0
		trailerBytes: t2
		nArgs: 0
		nTemps: 0
		nStack: 0
		nLits: 2
		primitive: 264 + t1! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
toReturnSelf
	^ self toReturnSelfTrailerBytes: CompiledMethodTrailer empty! !

!CompiledMethod class methodsFor: 'instance creation' stamp: ''!
toReturnSelfTrailerBytes: t1 
	^ self
		newBytes: 0
		trailerBytes: t1
		nArgs: 0
		nTemps: 0
		nStack: 0
		nLits: 2
		primitive: 256! !

!CompiledMethod methodsFor: 'comparing' stamp: 'eem 2/13/2012 16:15'!
= method
	"Answer whether the receiver implements the same code as the argument, method.
	 Here ``same code'' means that if the receiver's source is compiled with the same
	 compiler it should produce the same sequence of bytecodes and literals, same
	 trailer and same properties.  Hence this definition of #= (only one of many plausible
	 definitions) can be used to quickly identify changes in the compiler's output."
	| numLits |
	method isCompiledMethod ifFalse: [^false].
	self size = method size ifFalse: [^false].
	self header = method header ifFalse: [^false]. "N.B. includes numLiterals comparison."
	self initialPC to: self endPC do:
		[:i | (self at: i) = (method at: i) ifFalse: [^false]].
	numLits := self numLiterals.
	1 to: numLits do:
		[:i| | lit1 lit2 |
		lit1 := self literalAt: i.
		lit2 := method literalAt: i.
		(lit1 == lit2 or: [lit1 literalEqual: lit2]) ifFalse:
			[(i = 1 and: [#(117 120) includes: self primitive])
				ifTrue:
					[lit1 isArray
						ifTrue:
							[(lit2 isArray and: [lit1 allButLast = lit2 allButLast]) ifFalse:
								[^false]]
						ifFalse: "ExternalLibraryFunction"
							[(lit1 analogousCodeTo: lit2) ifFalse:
								[^false]]]
				ifFalse:
					[i = (numLits - 1)
						ifTrue: "properties"
							[(self properties analogousCodeTo: method properties)
								ifFalse: [^false]]
						ifFalse: "last literal (methodClassAssociation) of class-side methods is not unique"
							[(i = numLits
							 and: [lit1 isVariableBinding
							 and: [lit2 isVariableBinding
							 and: [lit1 key == lit2 key
							 and: [lit1 value == lit2 value]]]]) ifFalse:
								[^false]]]]].
	^true! !

!CompiledMethod methodsFor: 'scanning' stamp: 'eem 12/6/2011 13:35'!
abstractBytecodeMessagesDo: aBlock
	"Evaluate aBlock with the sequence of abstract bytecodes in the receiver"
	self abstractBytecodeMessagesFrom: self initialPC
		to: self endPC
		do: aBlock

	"| msgs |
	 msgs := OrderedCollection new.
	 CompiledMethod >> #abstractBytecodeMessagesFrom:to: abstractBytecodeMessagesDo:
		[:msg| msgs add: msg selector].
	 msgs"! !

!CompiledMethod methodsFor: 'debugger support' stamp: 'nice 3/31/2011 01:08'!
abstractPCForConcretePC: concretePC
	"Answer the abstractPC matching concretePC."

	| abstractPC scanner client |
	self flag: 'belongs in DebuggerMethodMap?'.
	abstractPC := 1.
	scanner := InstructionStream on: self.
	client := InstructionClient new.
	[(scanner atEnd
	  or: [scanner pc >= concretePC]) ifTrue:
		[^abstractPC].
	 abstractPC := abstractPC + 1.
	 scanner interpretNextInstructionFor: client] repeat! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
abstractSymbolic
	| t1 |
	t1 := WriteStream
				on: (String new: 1000).
	self longPrintRelativeOn: t1 indent: 0.
	^ t1 contents! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
allLiterals
	^ self literals! !

!CompiledMethod methodsFor: 'converting' stamp: 'ul 12/8/2010 03:24'!
asString

	^self printString! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
blockExtentsInto: t1 from: t2 to: t3 scanner: t4 numberer: t5 
	| t6 t7 |
	self flag: 'belongs in DebuggerMethodMap'.
	t6 := t5 value.
	[t4 pc <= t3]
		whileTrue: [t7 := t4 interpretNextInstructionFor: BlockStartLocator new.
			t7 isInteger
				ifTrue: [self
						blockExtentsInto: t1
						from: t4 pc
						to: t4 pc + t7 - 1
						scanner: t4
						numberer: t5]].
	t1
		at: t2
		put: (t6 to: t5 value).
	^ t1! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
blockExtentsToTempsMap
	^ self holdsTempNames
		ifTrue: [self
				mapFromBlockKeys: ((self startpcsToBlockExtents associations
						asSortedCollection: [:t1 :t2 | t1 key < t2 key])
						collect: [:t1 | t1 value])
				toSchematicTemps: self tempNamesString]! !

!CompiledMethod methodsFor: 'accessing' stamp: 'rms 1/11/2013 22:27'!
category

	^self methodClass organization categoryOfElement: self selector! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
checkOKToAdd: t1 at: t2 
	^ SourceFiles checkOKToAdd: t1 at: t2! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
clearFlag
	self
		objectAt: 1
		put: (self header bitAnd: (1 << 29) bitInvert)! !

!CompiledMethod methodsFor: 'accessing' stamp: 'eem 2/19/2012 10:59'!
clearSignFlag
	"Clear the sign flag bit.  The sign flag bit may be
	 used by the VM to select an alternate bytecode set."

	self signFlag ifTrue:
		[self objectAt: 1 put: self header - SmallInteger minVal]! !

!CompiledMethod methodsFor: 'decompiling' stamp: ''!
compilerClass
	^ self methodClass
		ifNil: [Compiler]
		ifNotNil: [:t1 | t1 compilerClass]! !

!CompiledMethod methodsFor: 'closures' stamp: 'mha 9/23/2010 10:21'!
containsBlockClosures
	^ self scanner scanFor: [ :bc | bc = 143 "push closure bytecode" ]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
copyWithTempNames: t1 
	| t2 |
	t2 := String
				streamContents: [:t3 | 
					t1
						do: [:t4 | t3 nextPutAll: t4]
						separatedBy: [t3 space].
					t3 space].
	^ self
		copyWithTrailerBytes: (CompiledMethodTrailer new tempNames: t2)! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
copyWithTempsFromMethodNode: t1 
	^ self
		copyWithTrailerBytes: (CompiledMethodTrailer new tempNames: t1 schematicTempNamesString)! !

!CompiledMethod methodsFor: 'copying' stamp: 'eem 7/23/2012 13:44'!
copyWithTrailerBytes: trailer
"Testing:
	(CompiledMethod compiledMethodAt: #copyWithTrailerBytes:)
		tempNamesPut: 'copy end '
"
	| copy end start penultimateLiteral |
	start := self initialPC.
	end := self endPC.
	copy := trailer createMethod: end - start + 1 class: self class header: self header.
	1 to: self numLiterals do: [:i | copy literalAt: i put: (self literalAt: i)].
	(penultimateLiteral := self penultimateLiteral) isMethodProperties ifTrue:
		[copy penultimateLiteral: (penultimateLiteral copy
									setMethod: copy;
									yourself)].
	start to: end do: [:i | copy at: i put: (self at: i)].
	^copy! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
dateMethodLastSubmitted
	| t1 t2 |
	t1 := self timeStamp.
	t2 := t1 findBetweenSubStrs: ' 
'.
	^ t2 size > 1
		ifTrue: [[t2 second asDate]
				ifError: []]! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
debuggerMap
	^ DebuggerMethodMap forMethod: self! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'eem 9/26/2011 17:25'!
decompile
	"Return the decompiled parse tree that represents self"

	|  class selector |
	class := self methodClass ifNil: [Object].
	selector := self selector ifNil: [self defaultSelector].
	^class decompilerClass new decompile: selector in: class method: self methodForDecompile! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
decompileString
	^ self decompile decompileString! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'eem 3/19/2012 14:49'!
decompileWithTemps
	"Return the decompiled parse tree that represents self, but with the temp names obtained
	 either by compiling the sourcecode, or directly if the method has temps in its trailer."

	| class selector tempNames source |
	class := self methodClass ifNil: [Object].
	selector := self selector ifNil: [self defaultSelector].

	self holdsTempNames
		ifTrue: [tempNames := self tempNamesString]
		ifFalse:
			["No source file or no source (e.g. doits) and no temp names
			 -- decompile without temp names "
			((self fileIndex > 0 and: [(SourceFiles at: self fileIndex) isNil])
			or: [(source := self getSourceFromFile) isNil]) ifTrue:
				[^self decompile].
			tempNames := (class newCompiler
									parse: source asString
									in: class
									notifying: nil)
										generate: CompiledMethodTrailer defaultMethodTrailer;
										schematicTempNamesString].

	^(self decompilerClass new withTempNames: tempNames)
		decompile: selector
		in: class
		method: self methodForDecompile! !

!CompiledMethod methodsFor: 'decompiling' stamp: ''!
decompilerClass
	^ self compilerClass decompilerClass! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
defaultSelector
	^ #DoIt numArgs: self numArgs! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
dragLabel
	^ self methodClass name , '>>' , self selector! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
dropSourcePointer
	self trailer hasSourcePointer
		ifTrue: [self
				becomeForward: (self
						copyWithTrailerBytes: (CompiledMethodTrailer new sourceCode: self getSource))]! !

!CompiledMethod methodsFor: 'closures' stamp: 'ul 3/28/2011 03:55'!
embeddedBlockClosures

	| bms extractor scanner |
	bms := OrderedCollection new.
	scanner := self scanner.
	extractor := ClosureExtractor withAction: [ :c | bms add: c ] andScanner: scanner.
	[ scanner pc <= self endPC ] whileTrue: [ scanner interpretNextInstructionFor: extractor ].
	^ bms! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
endPC
	^ self trailer endPC! !

!CompiledMethod methodsFor: 'comparing' stamp: 'eem 7/24/2012 15:27'!
equivalentTo: aCompiledMethod
	| parseTree |
	^self = aCompiledMethod
	or: [self class == aCompiledMethod class
		and: [self numArgs = aCompiledMethod numArgs
		and: [self numLiterals = aCompiledMethod numLiterals
		and: [parseTree := self decompile.
			(parseTree isKindOf: MethodNode)
				ifTrue: [parseTree asString = aCompiledMethod decompile asString "Standard compiler"]
				ifFalse: [parseTree = aCompiledMethod decompile "RB parse trees, we hope"]]]]]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
fileIndex
	^ SourceFiles fileIndexFromSourcePointer: self sourcePointer! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
filePosition
	^ SourceFiles filePositionFromSourcePointer: self sourcePointer! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
flag
	^ ((self header bitShift: -29)
		bitAnd: 1)
		= 1! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
flushCache
	<primitive: 116>
	^ self! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
frameSize
	(self header noMask: 131072)
		ifTrue: [^ SmallFrame].
	^ LargeFrame! !

!CompiledMethod methodsFor: 'source code management' stamp: 'ul 3/16/2011 23:38'!
getPreambleFrom: aFileStream at: endPosition
	"This method is an ugly hack. This method assumes that source files have ASCII-compatible encoding and that preambles contain no non-ASCII characters."

	| chunkSize chunk |
	chunkSize := 160 min: endPosition.
	[
		| index |
		chunk := aFileStream
			position: (endPosition - chunkSize + 1 max: 0);
			basicNext: chunkSize.
		(index := chunk lastIndexOf: $!! startingAt: chunk size ifAbsent: 0) ~= 0 ifTrue: [
			^chunk copyFrom: index + 1 to: chunk size ].
		chunkSize := chunkSize * 2.
		chunkSize <= endPosition ] whileTrue.
	^chunk! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
getSource
	^ self getSourceFor: self selector in: self methodClass! !

!CompiledMethod methodsFor: 'source code management' stamp: 'eem 9/26/2011 17:25'!
getSourceFor: selector in: class
	"Retrieve or reconstruct the source code for this method."
	| trailer source |
	(self properties includesKey: #source) ifTrue:
		[^self properties at: #source].
	trailer := self trailer.

	trailer tempNames ifNotNil: [:namesString | 
		"Magic sources -- decompile with temp names"
		^ ((class decompilerClass new withTempNames: namesString)
				decompile: selector in: class method: self methodForDecompile)
			decompileString].
	
	trailer sourceCode ifNotNil: [:code | ^ code ].
	
	trailer hasSourcePointer ifFalse: [
		"No source pointer -- decompile without temp names"
		^ (class decompilerClass new decompile: selector in: class method: self methodForDecompile)
			decompileString].

	"Situation normal;  read the sourceCode from the file"
	source := [self getSourceFromFileAt: trailer sourcePointer]
				on: Error
		"An error can happen here if, for example, the changes file has been truncated by an aborted download.  The present solution is to ignore the error and fall back on the decompiler.  A more thorough solution should probably trigger a systematic invalidation of all source pointers past the end of the changes file.  Consider that, as time goes on, the changes file will eventually grow large enough to cover the lost code, and then instead of falling into this error case, random source code will get returned."
				do: [ :ex | ex return: nil].
		
	^source ifNil: [
			"Something really wrong -- decompile blind (no temps)"
			 (class decompilerClass new decompile: selector in: class method: self methodForDecompile)
				decompileString]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
getSourceFromFile
	^ self getSourceFromFileAt: self sourcePointer! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
getSourceFromFileAt: t1 
	| t2 t3 |
	t2 := SourceFiles filePositionFromSourcePointer: t1.
	t2 = 0
		ifTrue: [^ nil].
	t3 := SourceFiles fileIndexFromSourcePointer: t1.
	^ (RemoteString newFileNumber: t3 position: t2) text! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
hasBreakpoint
	^ BreakpointManager methodHasBreakpoint: self! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
hasInstVarRef
	| t1 t2 t3 |
	t1 := InstructionStream on: self.
	t3 := InstVarRefLocator new.
	t2 := self endPC.
	[t1 pc <= t2]
		whileTrue: [(t3 interpretNextInstructionUsing: t1)
				ifTrue: [^ true]].
	^ false! !

!CompiledMethod methodsFor: 'literals' stamp: 'nice 7/20/2011 09:05'!
hasLiteral: literal
	"Answer whether the receiver references the argument, literal."
	2 to: self numLiterals - 1 do: "exclude superclass + selector/properties"
		[:index |
		((self objectAt: index) literalEqual: literal) ifTrue: [^true]].
	^false! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
hasLiteralSuchThat: t1 
	| t3 |
	(self penultimateLiteral isMethodProperties
			and: [self penultimateLiteral hasLiteralSuchThat: t1])
		ifTrue: [^ true].
	2
		to: self numLiterals + 1
		do: [:t2 | 
			t3 := self objectAt: t2.
			((t1 value: t3)
					or: [t3 isArray
							and: [t3 hasLiteralSuchThat: t1]])
				ifTrue: [^ true]].
	^ false! !

!CompiledMethod methodsFor: 'literals' stamp: 'nice 7/20/2011 09:10'!
hasLiteralThorough: literal
	"Answer true if any literal in this method is literal,
	even if embedded in array structure."

	(self penultimateLiteral isMethodProperties
	 and: [self penultimateLiteral hasLiteralThorough: literal]) ifTrue:[^true].
	2 to: self numLiterals - 1 "exclude superclass + selector/properties"
	   do:[:index | | lit |
		(((lit := self objectAt: index) literalEqual: literal)
		 or: [(lit isVariableBinding and: [lit key == literal])
		 or: [lit isArray and: [lit hasLiteral: literal]]]) ifTrue:
			[^ true]].
	^ false ! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
hasNewPropertyFormat
	^ true! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
hasReportableSlip
	#(#doOnlyOnce: #halt #halt: #hottest #printDirectlyToDisplay #toRemove #personal #urgent #haltOnce #haltOnce: #haltIf: )
		do: [:t1 | 
			(self hasLiteral: t1)
				ifTrue: [^ true].
			nil].
	#(#Transcript #AA #BB #CC #DD #EE )
		do: [:t1 | (Smalltalk globals
				associationAt: t1
				ifAbsent: [])
				ifNotNil: [:t2 | 
					(self hasLiteral: t2)
						ifTrue: [^ true].
					nil]].
	^ false! !

!CompiledMethod methodsFor: 'comparing' stamp: 'eem 5/27/2012 15:05'!
hash
	"CompiledMethod>>#= compares code, i.e. same literals and same bytecode.
	 So we look at the header, methodClass and some bytes between initialPC and endPC,
	 but /not/ the selector because the equal method does not compare selectors.
	 Note that we must override ByteArray>hash which looks at all bytes of the receiver.
	 Using bytes from the pointer part of a COmpiledmethod can lead to a variable hash
	 if and when when the GC moves literals in the receiver."
	| initialPC endPC hash |
	initialPC := self initialPC.
	endPC := self endPC.
	hash := self species hash + self header + initialPC + endPC + self methodClass hash bitAnd: 16rFFFFFFF.
	"sample approximately 20 bytes"
	initialPC to: endPC by: (endPC - initialPC // 20 max: 1) do:
		[:i| hash := hash + (self at: i)].
	^hash

	"(CompiledMethod>>#hash) hash"! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
header
	^ self objectAt: 1! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
headerDescription
	| t1 |
	t1 := '' writeStream.
	self header printOn: t1.
	t1 cr; nextPutAll: '"primitive: '.
	self primitive printOn: t1.
	t1 cr; nextPutAll: ' numArgs: '.
	self numArgs printOn: t1.
	t1 cr; nextPutAll: ' numTemps: '.
	self numTemps printOn: t1.
	t1 cr; nextPutAll: ' numLiterals: '.
	self numLiterals printOn: t1.
	t1 cr; nextPutAll: ' frameSize: '.
	self frameSize printOn: t1.
	t1 cr; nextPutAll: ' isClosureCompiled: '.
	self isBlueBookCompiled not printOn: t1.
	t1 nextPut: $";
		 cr.
	^ t1 contents! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
holdsTempNames
	^ self trailer hasTempNames! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
indexOfLiteral: t1 
	2
		to: self numLiterals - 1
		do: [:t2 | t1
					== (self objectAt: t2)
				ifTrue: [^ t2 - 1]].
	^ 0! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
initialPC
	^ self numLiterals + 1 * Smalltalk wordSize + 1! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isAbstract
	| t1 |
	t1 := self markerOrNil.
	^ t1 notNil
		and: [self class abstractMarkers includes: t1]! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isBlueBookCompiled
	^ ((InstructionStream on: self)
			scanFor: [:t1 | 
				(t1 >= 138
						and: [t1 <= 143])
					ifTrue: [^ false].
				t1 = 200])
		or: [(self hasLiteral: #blockCopy:)
				and: [self messages includes: #blockCopy:]]! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isClosureCompiled
	^ ((InstructionStream on: self)
			scanFor: [:t1 | t1 >= 138
					and: [t1 <= 143]])
		or: [(self hasLiteral: #closureCopy:copiedValues:)
				and: [self messages includes: #closureCopy:copiedValues:]]! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isCompiledMethod
	^ true! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isConflict
	^ self markerOrNil == self class conflictMarker! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isDisabled
	^ self isDisabled: self markerOrNil! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isDisabled: t1 
	^ t1 == self class disabledMarker! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isExplicitlyRequired
	^ self isExplicitlyRequired: self markerOrNil! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isExplicitlyRequired: t1 
	^ t1 == self class explicitRequirementMarker! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isImplicitlyRequired
	^ self isImplicitlyRequired: self markerOrNil! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isImplicitlyRequired: t1 
	^ t1 == self class implicitRequirementMarker! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isInstalled
	self methodClass
		ifNotNil: [:t2 | self selector
				ifNotNil: [:t1 | ^ self
						== (t2 methodDict
								at: t1
								ifAbsent: [])]].
	^ false! !

!CompiledMethod methodsFor: 'as yet unclassified' stamp: 'rms 1/11/2013 22:55'!
isNamedPrimitive 

	^ self primitive = 117! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isProvided
	^ self isProvided: self markerOrNil! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isProvided: t1 
	t1
		ifNil: [^ true].
	^ (self isRequired: t1) not
		and: [(self isDisabled: t1) not]! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isQuick
	^ self primitive between: 256 and: 519! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isRequired
	^ self isRequired: self markerOrNil! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isRequired: t1 
	t1
		ifNil: [^ false].
	(self isImplicitlyRequired: t1)
		ifTrue: [^ true].
	(self isExplicitlyRequired: t1)
		ifTrue: [^ true].
	(self isSubclassResponsibility: t1)
		ifTrue: [^ true].
	^ false! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isReturnField
	^ self primitive between: 264 and: 519! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isReturnSelf
	^ self primitive = 256! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isReturnSpecial
	^ self primitive between: 256 and: 263! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isSubclassResponsibility
	^ self isSubclassResponsibility: self markerOrNil! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
isSubclassResponsibility: t1 
	^ t1 == self class subclassResponsibilityMarker! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
linesOfCode
	| t1 |
	t1 := 0.
	self getSource asString
		lineIndicesDo: [:t3 :t4 :t5 | t4 > t3
				ifTrue: [t1 := t1 + 1]].
	^ t1! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
literalAt: t1 
	^ self objectAt: t1 + 1! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
literalAt: t1 put: t2 
	^ self objectAt: t1 + 1 put: t2! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
literalStrings
	| t1 |
	t1 := OrderedCollection new: self numLiterals.
	self
		literalsDo: [:t2 | t2 isVariableBinding
				ifTrue: [t1 addLast: t2 key]
				ifFalse: [t2 isSymbol
						ifTrue: [t1 addAll: t2 keywords]
						ifFalse: [t1 addLast: t2 printString]]].
	^ t1! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
literals
	| t1 t2 |
	t1 := Array new: (t2 := self numLiterals).
	1
		to: t2
		do: [:t3 | t1
				at: t3
				put: (self objectAt: t3 + 1)].
	^ t1! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
literalsDo: t1 
	1
		to: self numLiterals
		do: [:t2 | t1
				value: (self objectAt: t2 + 1)]! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
longPrintOn: t1 
	self longPrintOn: t1 indent: 0! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
longPrintOn: t1 indent: t2 
	self isQuick
		ifTrue: [self isReturnSpecial
				ifTrue: [^ t1 tab: t2;
						 nextPutAll: 'Quick return '
							, (#('self' 'true' 'false' 'nil' '-1' '0' '1' '2' ) at: self primitive - 255)].
			^ t1 nextPutAll: 'Quick return field ' , self returnField printString , ' (0-based)'].
	self primitive = 0
		ifFalse: [t1 tab: t2.
			self printPrimitiveOn: t1].
	(InstructionPrinter on: self) indent: t2;
		 printInstructionsOn: t1! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
longPrintRelativeOn: t1 indent: t2 
	self isQuick
		ifTrue: [^ self longPrintOn: t1 indent: t2].
	self primitive = 0
		ifFalse: [t1 tab: t2.
			self printPrimitiveOn: t1].
	(RelativeInstructionPrinter on: self) indent: t2;
		 printCode: false;
		 printInstructionsOn: t1! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
mapFromBlockKeys: t1 toSchematicTemps: t2 
	| t3 t4 |
	t3 := Dictionary new.
	t4 := t2 readStream.
	t1
		do: [:t5 | 
			| t6 t8 |
			t6 := OrderedCollection new.
			t8 := 0.
			[(t4 skipSeparators; peek)
				ifNil: [true]
				ifNotNil: [:t7 | '[]' includes: t7]]
				whileFalse: [t4 peek = $(
						ifTrue: [t6
								addAllLast: ((self tempsSubSequenceFrom: (t4 next; yourself))
										withIndexCollect: [:t10 :t11 | {t10. {t8 + 1. t11}}]).
							t4 peek ~= $)
								ifTrue: [self error: 'parse error'].
							t8 := t8 + 1.
							t4 next]
						ifFalse: [t6
								addAllLast: ((self tempsSubSequenceFrom: t4)
										withIndexCollect: [:t10 :t11 | {t10. t8 := t8 + 1}])]].
			t3 at: t5 put: t6 asArray.
			[t4 peek = $]]
				whileTrue: [t4 next].
			t4 peek = $[
				ifTrue: [t4 next]].
	^ t3! !

!CompiledMethod methodsFor: 'private' stamp: ''!
markerOrNil
	| t1 |
	((t1 := self endPC) = 19
			or: [t1 = 20])
		ifFalse: [^ nil].
	self numLiterals = 3
		ifFalse: [^ nil].
	(self at: 17)
			= 112
		ifFalse: [^ nil].
	(self at: 18)
			= 208
		ifFalse: [^ nil].
	^ self literalAt: 1! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
messages
	| t1 t2 |
	t2 := Set new.
	t1 := InstructionStream on: self.
	t1
		scanFor: [:t3 | 
			t1 addSelectorTo: t2.
			false].
	^ t2! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
messagesDo: t1 
	^ self messages do: t1! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
messagesSequence
	^ Array
		streamContents: [:t1 | 
			| t2 |
			t2 := InstructionStream on: self.
			t2
				scanFor: [:t3 | 
					| t4 |
					(t4 := t2 selectorToSendOrSelf) == t2
						ifFalse: [t1 nextPut: t4].
					false]]! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
methodClass
	^ (self literalAt: self numLiterals) value! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
methodClass: t1 
	self literalAt: self numLiterals put: t1 binding! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
methodClassAssociation
	^ self literalAt: self numLiterals! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
methodClassAssociation: t1 
	^ self literalAt: self numLiterals put: t1! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'eem 9/26/2011 17:24'!
methodForDecompile
	"This is a hook to allow recursive methods like MwMethodWrapper to avoid infinite recursion."
	^self! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
methodHome
	^ self properties methodHome! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'bf 3/19/2012 18:56'!
methodNode
	"Return the parse tree that represents self. If parsing fails, decompile the method."
	| aClass source |
	aClass := self methodClass.
	source := self
				getSourceFor: (self selector ifNil: [self defaultSelector])
				in: aClass.
	^[(aClass newParser
		encoderClass: (self isBlueBookCompiled
						ifTrue: [EncoderForV3]
						ifFalse: [EncoderForV3PlusClosures]);
		parse: source class: aClass)
			sourceText: source;
			yourself]
		on: SyntaxErrorNotification
		do: [:ex | ex return: self decompileWithTemps].! !

!CompiledMethod methodsFor: 'decompiling' stamp: 'nice 2/23/2011 21:47'!
methodNodeFormattedAndDecorated: decorate
	"Answer a method node made from pretty-printed (and colorized, if decorate is true) 
	 source text."

	| class source node  |
	
	source := self getSourceFromFile.
	class := self methodClass ifNil: [self sourceClass].
	source ifNil: [^self decompile].
	source := class prettyPrinterClass 
				format: source
				in: class
				notifying: nil
				decorated: decorate.
	node := class newParser parse: source class: class.
	node sourceText: source.
	^node! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
methodReference
	| t1 t2 |
	t1 := self methodClass
				ifNil: [^ nil].
	t2 := self selector
				ifNil: [^ nil].
	^ MethodReference class: t1 selector: t2! !

!CompiledMethod methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/19/2010 00:46'!
needsFrameSize: newFrameSize
	"Set the largeFrameBit to accomodate the newFrameSize"
	| largeFrameBit header |
	largeFrameBit := 16r20000.
	(self numTemps + newFrameSize) > LargeFrame ifTrue:
		[^ self error: 'Cannot compile -- stack including temps is too deep'].
	header := self objectAt: 1.
	(header bitAnd: largeFrameBit) ~= 0
		ifTrue: [header := header - largeFrameBit].
	self objectAt: 1 put: header
			+ ( ((self numTemps + newFrameSize) > SmallFrame or: [ self primitive = 84 "perform:withArguments:"])
					ifTrue: [largeFrameBit]
					ifFalse: [0])! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
numArgs
	^ (self header bitShift: -24)
		bitAnd: 15! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
numLiterals
	^ (self header bitShift: -9)
		bitAnd: 255! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
numTemps
	^ (self header bitShift: -18)
		bitAnd: 63! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
objectAt: t1 
	<primitive: 68>
	self primitiveFailed! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
objectAt: t1 put: t2 
	<primitive: 69>
	self primitiveFailed! !

!CompiledMethod methodsFor: 'file in/out' stamp: ''!
objectForDataStream: t1 
	self primitive = 117
		ifTrue: [self literals first at: 4 put: 0]! !

!CompiledMethod methodsFor: 'tracing' stamp: 'mtf 8/19/2008 22:36'!
outboundPointersDo: aBlock

	| numLiterals |
	aBlock value: self class.
	numLiterals := self numLiterals.
	1 to: numLiterals do: [:i | aBlock value: (self literalAt: i)]! !

!CompiledMethod methodsFor: 'decompiling' stamp: ''!
parserClass
	^ self methodClass
		ifNil: [Compiler parserClass]
		ifNotNil: [:t1 | t1 parserClass]! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
pcPreviousTo: t1 
	| t2 t3 t4 |
	self flag: 'belongs in DebuggerMethodMap?'.
	t1 > self endPC
		ifTrue: [^ self endPC].
	t2 := InstructionStream on: self.
	t3 := InstructionClient new.
	[t2 pc < t1]
		whileTrue: [t4 := t2 pc.
			t2 interpretNextInstructionFor: t3].
	^ t4! !

!CompiledMethod methodsFor: 'private' stamp: ''!
penultimateLiteral
	| t1 |
	^ (t1 := self numLiterals - 1) > 0
		ifTrue: [self literalAt: t1]! !

!CompiledMethod methodsFor: 'private' stamp: ''!
penultimateLiteral: t1 
	| t2 |
	(t2 := self numLiterals - 1) > 0
		ifTrue: [self literalAt: t2 put: t1]
		ifFalse: [self error: 'insufficient literals']! !

!CompiledMethod methodsFor: 'copying' stamp: 'eem 7/4/2012 13:41'!
postCopy
	| penultimateLiteral |
	(penultimateLiteral := self penultimateLiteral) isMethodProperties ifTrue:
		[self penultimateLiteral: (penultimateLiteral copy
									setMethod: self;
									yourself).
		 self pragmas do:
			[:p| p setMethod: self]]! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
pragmaAt: t1 
	| t2 |
	^ (t2 := self penultimateLiteral) isMethodProperties
		ifTrue: [t2
				at: t1
				ifAbsent: []]! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
pragmas
	| t1 |
	^ (t1 := self penultimateLiteral) isMethodProperties
		ifTrue: [t1 pragmas]
		ifFalse: [#()]! !

!CompiledMethod methodsFor: 'printing' stamp: 'ul 3/16/2011 23:45'!
preamble
	"Return the preamble of this method stored in the source files."

	^SourceFiles
		fileIndexAndPositionFromSourcePointer: self sourcePointer
		do: [ :fileIndex :filePosition |
			fileIndex = 0
				ifTrue: [ String new "no source pointer for this method" ]
				ifFalse: [
					(CurrentReadOnlySourceFiles at: fileIndex)
						ifNil: [ String new "sources file not available" ]
						ifNotNil: [ :file |
							self
								getPreambleFrom: file
								at: (0 max: filePosition - 3) ] ] ]! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
primitive
	| t1 |
	t1 := self header bitAnd: 268435967.
	^ (t1 bitAnd: 511)
		+ (t1 bitShift: -19)! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
primitiveErrorVariableName
	self primitive > 0
		ifTrue: [self pragmas
				do: [:t1 | 
					| t2 t3 |
					((t2 := t1 keyword keywords) first = 'primitive:'
							and: [(t3 := t2 indexOf: 'error:') > 0])
						ifTrue: [^ t1 argumentAt: t3].
					nil]].
	^ nil! !

!CompiledMethod methodsFor: 'printing' stamp: 'cmm 9/20/2010 13:58'!
printOn: aStream 
	"Overrides method inherited from the byte arrayed collection."
	aStream nextPut: $(.
	self printReferenceOn: aStream.
	aStream space; nextPut: $".
	self printNameOn: aStream.
	aStream nextPut: $(;
		 print: self identityHash;
		 nextPut: $);
		 nextPut: $";
		 nextPut: $)! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
printOnStream: t1 
	t1 print: 'a CompiledMethod'! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
printPrimitiveOn: t1 
	| t2 t3 |
	(t2 := self primitive) = 0
		ifTrue: [^ self].
	t2 = 120
		ifTrue: [^ t1
				print: (self literalAt: 1);
				 cr].
	t1 nextPutAll: '<primitive: '.
	t2 = 117
		ifTrue: [t3 := self literalAt: 1.
			(t3 at: 2) asString printOn: t1.
			(t3 at: 1)
				ifNotNil: [:t4 | 
					t1 nextPutAll: ' module: '.
					t4 asString printOn: t1]]
		ifFalse: [t1 print: t2].
	self primitiveErrorVariableName
		ifNotNil: [:t5 | t1 nextPutAll: ' error: ';
				 nextPutAll: t5].
	t1 nextPut: $>;
		 cr! !

!CompiledMethod methodsFor: 'printing' stamp: 'cmm 9/20/2010 13:58'!
printReferenceOn: aStream 
	"Print a string that can be used to access the currently installed method."
	aStream print: self methodClass;
		 nextPutAll: '>>';
		 nextPutAll: self selector storeString! !

!CompiledMethod methodsFor: 'printing' stamp: 'cmm 9/19/2010 16:32'!
printSignatureOn: aStream 
	"Print a string that can be used to access the currently installed method."
	aStream print: self methodClass;
		 nextPutAll: '>>';
		 nextPutAll: self selector storeString! !

!CompiledMethod methodsFor: 'accessing' stamp: 'eem 9/15/2011 17:04'!
properties
	"Answer the method properties of the receiver."
	| propertiesOrSelector |
	^(propertiesOrSelector := self penultimateLiteral) isMethodProperties
		ifTrue: [propertiesOrSelector]
		ifFalse: [self class methodPropertiesClass forMethod: self selector: propertiesOrSelector]! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
properties: t1 
	self
		literalAt: self numLiterals - 1
		put: (t1 isEmpty
				ifTrue: [t1 selector]
				ifFalse: [t1 setMethod: self;
						 yourself])! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
propertyKeysAndValuesDo: t1 
	| t2 |
	(t2 := self penultimateLiteral) isMethodProperties
		ifTrue: [t2 propertyKeysAndValuesDo: t1]! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
propertyValueAt: t1 
	| t2 |
	^ (t2 := self penultimateLiteral) isMethodProperties
		ifTrue: [t2
				propertyValueAt: t1
				ifAbsent: []]! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
propertyValueAt: t1 ifAbsent: t2 
	| t3 |
	^ (t3 := self penultimateLiteral) isMethodProperties
		ifTrue: [t3 propertyValueAt: t1 ifAbsent: t2]
		ifFalse: [t2 value]! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: 'eem 9/15/2011 17:04'!
propertyValueAt: propName put: propValue
	"Set or add the property with key propName and value propValue.
	 If the receiver does not yet have a method properties create one and replace
	 the selector with it.  Otherwise, either relace propValue in the method properties
	 or replace method properties with one containing the new property."
	| propertiesOrSelector |
	(propertiesOrSelector := self penultimateLiteral) isMethodProperties ifFalse:
		[self penultimateLiteral: ((self class methodPropertiesClass
									selector: propertiesOrSelector
									with: (Association
											key: propName asSymbol
											value: propValue))
									setMethod: self;
									yourself).
		^propValue].
	(propertiesOrSelector includesProperty: propName) ifTrue:
		[^propertiesOrSelector at: propName put: propValue].
	self penultimateLiteral: (propertiesOrSelector
								copyWith: (Association
												key: propName asSymbol
												value: propValue)).
	^propValue! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
putSource: t1 fromParseNode: t2 class: t3 category: t4 inFile: t5 priorMethod: t6 
	^ self
		putSource: t1
		fromParseNode: t2
		inFile: t5
		withPreamble: [:t7 | 
			t3
				printCategoryChunk: t4
				on: t7
				priorMethod: t6.
			t7 cr]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
putSource: t1 fromParseNode: t2 class: t3 category: t4 withStamp: t5 inFile: t6 priorMethod: t7 
	^ self
		putSource: t1
		fromParseNode: t2
		inFile: t6
		withPreamble: [:t8 | 
			t3
				printCategoryChunk: t4
				on: t8
				withStamp: t5
				priorMethod: t7.
			t8 cr]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
putSource: t1 fromParseNode: t2 inFile: t3 withPreamble: t4 
	| t5 t6 |
	(SourceFiles
			ifNil: [true]
			ifNotNil: [(t5 := SourceFiles at: t3) == nil])
		ifTrue: [^ self
				become: (self copyWithTempsFromMethodNode: t2)].
	SmalltalkImage current assureStartupStampLogged.
	t5 setToEnd.
	t4 value: t5.
	t6 := RemoteString
				newString: t1
				onFileNumber: t3
				toFile: t5.
	t5 nextChunkPut: ' '.
	InMidstOfFileinNotification signal
		ifFalse: [t5 flush].
	self checkOKToAdd: t1 size at: t6 position.
	self setSourcePosition: t6 position inFile: t3! !

!CompiledMethod methodsFor: 'file in/out' stamp: ''!
readDataFrom: t1 size: t2 
	self error: 'Must use readMethod'! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
readsField: t1 
	| t2 t3 |
	t2 := t1 - 1.
	self isReturnField
		ifTrue: [^ self returnField = t2].
	^ (t3 := InstructionStream on: self)
		scanFor: [:t4 | t4 < 16
				ifTrue: [t4 = t2]
				ifFalse: [t4 = 128
						ifTrue: [t3 followingByte = t2
								and: [t2 <= 63]]
						ifFalse: [t4 = 132
								and: [(t3 followingByte between: 64 and: 95)
										and: [t3 thirdByte = t2]]]]]! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
readsRef: t1 
	| t2 t3 |
	(t2 := self indexOfLiteral: t1) = 0
		ifTrue: [^ false].
	t2 := t2 - 1.
	^ (t3 := InstructionStream on: self)
		scanFor: [:t4 | t4 >= 64
				and: [t4 <= 95
						ifTrue: [t4 - 64 = t2]
						ifFalse: [t4 = 128
								ifTrue: [t3 followingByte - 192 = t2]
								ifFalse: [t4 = 132
										and: [(t3 followingByte between: 128 and: 159)
												and: [t3 thirdByte = t2]]]]]]! !

!CompiledMethod methodsFor: 'printing' stamp: 'cmm 9/20/2010 13:59'!
reference
	^ String streamContents: [ : stream | self printReferenceOn: stream ]! !

!CompiledMethod methodsFor: 'accessing' stamp: 'eem 5/20/2012 11:45'!
referredInstVars
	"Answer a Set of the inst var names the receiver accesses."
	| allInstVarNames instVarNames |
	allInstVarNames := self methodClass allInstVarNames.
	self isReturnField ifTrue:
		[^Set with: (allInstVarNames at: self returnField + 1)].
	instVarNames := Set new.
	self abstractBytecodeMessagesDo:
		[:msg|
		(#(#popIntoReceiverVariable:
		    #pushReceiverVariable:
		    #storeIntoReceiverVariable:) includes: msg selector) ifTrue:
			[instVarNames add: (allInstVarNames at: msg argument + 1)]].
	^instVarNames

	"Dictionary newFromPairs: (Point selectors collect: [:s| { s. (Point >> s) referredInstVars}])"! !

!CompiledMethod methodsFor: 'literals' stamp: ''!
refersToLiteral: t1 
	^ self hasLiteral: t1! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
removeProperty: t1 
	| t2 |
	t2 := self
				propertyValueAt: t1
				ifAbsent: [^ nil].
	self
		penultimateLiteral: (self penultimateLiteral
				copyWithout: (Association key: t1 value: t2)).
	^ t2! !

!CompiledMethod methodsFor: 'accessing-pragmas & properties' stamp: ''!
removeProperty: t1 ifAbsent: t2 
	| t3 |
	t3 := self
				propertyValueAt: t1
				ifAbsent: [^ t2 value].
	self
		penultimateLiteral: (self penultimateLiteral
				copyWithout: (Association key: t1 value: t3)).
	^ t3! !

!CompiledMethod methodsFor: 'private' stamp: 'nice 2/23/2011 21:47'!
replace: oldSelector with: newSelector in: aText
	| oldKeywords newKeywords args newSelectorWithArgs startOfSource lastSelectorToken |
	oldKeywords := oldSelector keywords.
	newKeywords := (newSelector ifNil: [self defaultSelector]) keywords.
	self assert: oldKeywords size = newKeywords size.
	args := (self methodClass newParser
		parseArgsAndTemps: aText string notifying: nil) copyFrom: 1 to: self numArgs.
	newSelectorWithArgs := String streamContents: [:stream |
		newKeywords withIndexDo: [:keyword :index |
			stream nextPutAll: keyword.
			stream space.
			args size >= index ifTrue: [
				stream nextPutAll: (args at: index); space]]].
	lastSelectorToken := args isEmpty
		ifFalse: [args last]
		ifTrue: [oldKeywords last].
	startOfSource := (aText string
		indexOfSubCollection: lastSelectorToken startingAt: 1) + lastSelectorToken size.
	^newSelectorWithArgs withBlanksTrimmed asText , (aText copyFrom: startOfSource to: aText size)! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
returnField
	| t1 |
	t1 := self primitive.
	t1 < 264
		ifTrue: [self error: 'only meaningful for quick-return']
		ifFalse: [^ t1 - 264]! !

!CompiledMethod methodsFor: 'scanning' stamp: 'eliot 10/8/2012 11:24'!
scanFor: byteOrClosure
	"Answer whether the receiver contains the argument as a bytecode,
	 if it is a number, or evaluates to true if a block."
	^ (InstructionStream on: self) scanFor: (byteOrClosure isBlock
													ifTrue: [byteOrClosure]
													ifFalse: [[:instr | instr = byteOrClosure]])
"
Smalltalk browseAllSelect: [:m | m scanFor: 134]
"! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
scanLongLoad: t1 
	| t2 |
	t2 := InstructionStream on: self.
	^ t2
		scanFor: [:t3 | t3 = 128
				and: [t2 followingByte = t1]]! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
scanLongStore: t1 
	| t2 |
	t2 := InstructionStream on: self.
	^ t2
		scanFor: [:t3 | (t3 = 129
					or: [t3 = 130])
				and: [t2 followingByte = t1]]! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
scanVeryLongLoad: t1 offset: t2 
	| t3 |
	t3 := InstructionStream on: self.
	^ t3
		scanFor: [:t4 | (t4 = 132
					and: [t3 followingByte = t1])
				and: [t3 thirdByte = t2]]! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
scanVeryLongStore: t1 offset: t2 
	| t3 |
	t3 := InstructionStream on: self.
	^ t3
		scanFor: [:t4 | | t5 | (t4 = 132
					and: [(t5 := t3 followingByte) = t1
							or: [t5 = (t1 + 32)]])
				and: [t3 thirdByte = t2]]! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
scanner
	^ InstructionStream on: self! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
searchForClass
	self systemNavigation
		allBehaviorsDo: [:t1 | (t1 methodDict
				keyAtIdentityValue: self
				ifAbsent: [])
				ifNotNil: [^ t1]].
	^ nil! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
searchForSelector
	self systemNavigation
		allBehaviorsDo: [:t1 | (t1 methodDict
				keyAtIdentityValue: self
				ifAbsent: [])
				ifNotNil: [:t2 | ^ t2]].
	^ nil! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
selector
	| t1 |
	^ (t1 := self penultimateLiteral) isMethodProperties
		ifTrue: [t1 selector]
		ifFalse: [t1]! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
selector: t1 
	| t2 t3 |
	(t2 := self penultimateLiteral) isMethodProperties
		ifTrue: [t2 selector: t1]
		ifFalse: [(t3 := self numLiterals) < 2
				ifTrue: [self error: 'insufficient literals to hold selector'].
			self literalAt: t3 - 1 put: t1]! !

!CompiledMethod methodsFor: 'literals' stamp: 'eem 11/5/2012 09:42'!
sendsSelector: aSelector 
	| scanner |
	scanner := InstructionStream on: self.
	scanner scanFor: 
		[:x | 
		 scanner selectorToSendOrSelf == aSelector ifTrue:
			[^true].
		 false	"keep scanning"].
	^false! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
sendsToSuper
	| t1 |
	t1 := InstructionStream on: self.
	^ t1
		scanFor: [:t2 | t2 = 133
				or: [t2 = 132
						and: [t1 followingByte between: 32 and: 63]]]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
setMySourcePointer: t1 
	self deprecated: 'Use #setSourcePointer: '.
	^ self setSourcePointer: t1! !

!CompiledMethod methodsFor: 'accessing' stamp: 'eem 2/19/2012 10:59'!
setSignFlag
	"Set the sign flag bit.  The sign flag bit may be
	 used by the VM to select an alternate bytecode set."

	self signFlag ifFalse:
		[self objectAt: 1 put: self header + SmallInteger minVal]! !

!CompiledMethod methodsFor: 'source code management' stamp: 'eem 9/29/2011 14:06'!
setSourcePointer: srcPointer
	"We can't change the trailer of existing method, since it could have a
	 completely different format. Therefore we need to generate a copy
	 with new trailer, containing a srcPointer, and then #become it."
	| trailer copy start |
	trailer := srcPointer = 0
				ifTrue: "catch the common case of setting the source pointer to 0 when already 0"
					[self sourcePointer = 0 ifTrue:
						[^self].
					 CompiledMethodTrailer empty]
				ifFalse:
					[CompiledMethodTrailer new sourcePointer: srcPointer].
	copy := self copyWithTrailerBytes: trailer.

	"ar 3/31/2010: Be a bit more clever since #become: is slow.
	If the old and the new trailer have the same size, just replace it."
	(self trailer class == trailer class and:[self size = copy size])
		ifTrue:
			[start := self endPC + 1.
			self replaceFrom: start to: self size with: copy startingAt: start]
		ifFalse:
			[self becomeForward: copy].

	^self "will be copy if #become was needed"
! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
setSourcePosition: t1 inFile: t2 
	self
		setSourcePointer: (SourceFiles sourcePointerFromFileIndex: t2 andPosition: t1)! !

!CompiledMethod methodsFor: 'accessing' stamp: 'eem 2/19/2012 10:59'!
signFlag
	"Answer the sign flag bit.  The sign flag bit may be
	 used by the VM to select an alternate bytecode set."

	^self header < 0! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
sourceClass
	^ [(Compiler evaluate: (self sourceFileStream backChunk; backChunk)) theClass]
		on: Error
		do: []! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
sourceFileStream
	| t1 |
	(t1 := self filePosition) = 0
		ifTrue: [^ nil].
	^ (RemoteString newFileNumber: self fileIndex position: t1) fileStream! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
sourcePointer
	^ self trailer sourcePointer! !

!CompiledMethod methodsFor: 'source code management' stamp: 'nice 2/23/2011 21:47'!
sourceSelector
	"Answer my selector extracted from my source.  If no source answer nil"

	| sourceString |
	sourceString := self getSourceFromFile ifNil: [^ nil].
	^self methodClass newParser parseSelector: sourceString! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
startpcsToBlockExtents
	| t1 |
	self flag: 'belongs in DebuggerMethodMap'.
	t1 := 0.
	^ self
		blockExtentsInto: Dictionary new
		from: self initialPC
		to: self endPC
		scanner: (InstructionStream on: self)
		numberer: [| t3 |
			t3 := t1.
			t1 := t1 + 2.
			t3]! !

!CompiledMethod methodsFor: 'file in/out' stamp: ''!
storeDataOn: t1 
	| t2 t3 |
	t2 := self basicSize.
	t1 beginInstance: self class size: t2.
	t3 := self numLiterals + 1.
	1
		to: t3
		do: [:t4 | t1
				nextPut: (self objectAt: t4)].
	t3 * 4 + 1
		to: t2
		do: [:t5 | t1 byteStream
				nextPut: (self basicAt: t5)]! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
storeLiteralsOn: t1 forClass: t2 
	| t3 |
	2
		to: self numLiterals + 1
		do: [:t4 | 
			t2
				storeLiteral: (self objectAt: t4)
				on: t1.
			t1 space]! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
storeOn: t1 
	| t2 |
	t1 nextPutAll: '(('.
	t1 nextPutAll: self class name.
	t1 nextPutAll: ' newMethod: '.
	t1 store: self size - self initialPC + 1.
	t1 nextPutAll: ' header: '.
	t1 store: self header.
	t1 nextPut: $).
	t2 := self
				storeElementsFrom: self initialPC
				to: self endPC
				on: t1.
	1
		to: self numLiterals
		do: [:t3 | 
			t2
				ifTrue: [t2 := false]
				ifFalse: [t1 nextPut: $;].
			t1 nextPutAll: ' literalAt: '.
			t1 store: t3.
			t1 nextPutAll: ' put: '.
			t1
				store: (self literalAt: t3)].
	t2
		ifFalse: [t1 nextPutAll: '; yourself'].
	t1 nextPut: $)! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
symbolic
	| t1 |
	t1 := WriteStream
				on: (String new: 1000).
	self longPrintOn: t1.
	^ t1 contents! !

!CompiledMethod methodsFor: 'printing' stamp: ''!
symbolicLinesDo: t1 
	| t2 t3 |
	t2 := ReadWriteStream
				on: (String new: 64).
	self isQuick
		ifTrue: [self longPrintOn: t2.
			t1 value: 0 value: t2 contents.
			^ self].
	self primitive ~= 0
		ifTrue: [self printPrimitiveOn: t2.
			t1 value: 1 value: t2 contents.
			t2 resetContents].
	t3 := self initialPC.
	(InstructionPrinter on: self) indent: 0;
		 printPC: false;
		
		printInstructionsOn: t2
		do: [:t5 :t6 :t7 | 
			| t8 t9 |
			t8 := t7 contents allButLast.
			(t8 includes: Character cr)
				ifTrue: [t8 := (t8 copyUpTo: Character cr)
								, '...'' (continues)'].
			(t9 := t8 indexOf: $>) > 0
				ifTrue: [[(t8 at: t9 + 1) isSeparator]
						whileTrue: [t9 := t9 + 1].
					t8 := ((t8 copyFrom: 1 to: t9)
								copyReplaceAll: (String with: Character tab)
								with: (String new: 8 withAll: Character space))
								, (t8 copyFrom: t9 + 1 to: t8 size)].
			t1 value: t3 value: t8.
			t3 := t6 pc.
			t7 resetContents]! !

!CompiledMethod methodsFor: 'source code management' stamp: ''!
tempNamesString
	^ self trailer tempNames! !

!CompiledMethod methodsFor: 'debugger support' stamp: ''!
tempsSubSequenceFrom: t1 
	^ Array
		streamContents: [:t2 | 
			[t1 skipSeparators.
			t1 atEnd
				or: ['[]()' includes: t1 peek]]
				whileFalse: [t2
						nextPut: (String
								streamContents: [:t3 | 
									[t3 nextPut: t1 next.
									t1 peek
										ifNil: [true]
										ifNotNil: [:t4 | ' []()' includes: t4]] whileFalse.
									nil])].
			nil]! !

!CompiledMethod methodsFor: 'printing' stamp: 'ul 3/15/2011 04:57'!
timeStamp
	"Answer the authoring time-stamp for the given method, retrieved from the sources or changes file. Answer the empty string if no time stamp is available."
	"(CompiledMethod compiledMethodAt: #timeStamp) timeStamp"

	| preamble stamp tokens tokenCount |
	stamp := nil.
	preamble := self preamble.
	tokens := (preamble findString: 'methodsFor:' startingAt: 1) > 0
		ifTrue: [Scanner new scanTokens: preamble]
		ifFalse: [#()  "ie cant be back ref"].
	(((tokenCount := tokens size) between: 7 and: 8) and: [(tokens at: tokenCount - 5) == #methodsFor:])
		ifTrue:
			[(tokens at: tokenCount - 3) == #stamp:
				ifTrue: ["New format gives change stamp and unified prior pointer"
						stamp := tokens at: tokenCount - 2]].
	((tokenCount between: 5 and: 6) and: [(tokens at: tokenCount - 3) == #methodsFor:])
		ifTrue:
			[(tokens at: tokenCount  - 1) == #stamp:
				ifTrue: ["New format gives change stamp and unified prior pointer"
					stamp := tokens at: tokenCount]].
	^stamp ifNil: [ String new ]
! !

!CompiledMethod methodsFor: 'accessing' stamp: ''!
trailer
	^ CompiledMethodTrailer new method: self! !

!CompiledMethod methodsFor: 'testing' stamp: ''!
usesClosureBytecodes
	^ (InstructionStream on: self)
		scanFor: [:t1 | t1 >= 138
				and: [t1 <= 143]]! !

!CompiledMethod methodsFor: 'evaluating' stamp: 'ul 6/13/2011 11:41'!
valueWithReceiver: aReceiver arguments: anArray 

	"This should be changed after the release of Squeak 4.3 to
		^self class receiver: aReceiver withArguments: anArray executeMethod: self"
	^ aReceiver withArgs: anArray executeMethod: self! !

!CompiledMethod methodsFor: 'file in/out' stamp: ''!
veryDeepCopyWith: t1 
	^ self! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
writesField: t1 
	| t2 t3 |
	self isQuick
		ifTrue: [^ false].
	t2 := t1 - 1.
	^ (t3 := InstructionStream on: self)
		scanFor: [:t4 | t4 >= 96
				and: [t4 <= 103
						ifTrue: [t4 - 96 = t2]
						ifFalse: [(t4 = 129
									or: [t4 = 130])
								ifTrue: [t3 followingByte = t2
										and: [t2 <= 63]]
								ifFalse: [t4 = 132
										and: [(t3 followingByte between: 160 and: 223)
												and: [t3 thirdByte = t2]]]]]]! !

!CompiledMethod methodsFor: 'scanning' stamp: ''!
writesRef: t1 
	| t2 t3 |
	(t2 := self indexOfLiteral: t1) = 0
		ifTrue: [^ false].
	t2 := t2 - 1.
	^ (t3 := InstructionStream on: self)
		scanFor: [:t4 | (t4 = 129
					or: [t4 = 130])
				ifTrue: [t3 followingByte - 192 = t2]
				ifFalse: [t4 = 132
						and: [t3 followingByte >= 224
								and: [t3 thirdByte = t2]]]]! !

!CompiledMethod methodsFor: 'file in/out' stamp: ''!
zapSourcePointer
	| t1 |
	t1 := self copyWithTrailerBytes: CompiledMethodTrailer empty.
	self becomeForward: t1.
	^ t1! !

Collection weakSubclass: #DependentsArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Models'!

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
with: t1 
	^ (self basicNew: 1) basicAt: 1 put: t1;
		 yourself! !

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
with: t1 with: t2 
	^ (self basicNew: 2) basicAt: 1 put: t1;
		 basicAt: 2 put: t2;
		 yourself! !

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
with: t1 with: t2 with: t3 
	^ (self basicNew: 3) basicAt: 1 put: t1;
		 basicAt: 2 put: t2;
		 basicAt: 3 put: t3;
		 yourself! !

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
with: t1 with: t2 with: t3 with: t4 
	^ (self basicNew: 4) basicAt: 1 put: t1;
		 basicAt: 2 put: t2;
		 basicAt: 3 put: t3;
		 basicAt: 4 put: t4;
		 yourself! !

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
with: t1 with: t2 with: t3 with: t4 with: t5 
	^ (self basicNew: 5) basicAt: 1 put: t1;
		 basicAt: 2 put: t2;
		 basicAt: 3 put: t3;
		 basicAt: 4 put: t4;
		 basicAt: 5 put: t5;
		 yourself! !

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
with: t1 with: t2 with: t3 with: t4 with: t5 with: t6 
	^ (self basicNew: 6) basicAt: 1 put: t1;
		 basicAt: 2 put: t2;
		 basicAt: 3 put: t3;
		 basicAt: 4 put: t4;
		 basicAt: 5 put: t5;
		 basicAt: 6 put: t6;
		 yourself! !

!DependentsArray class methodsFor: 'instance creation' stamp: ''!
withAll: t1 
	| t2 |
	t2 := self basicNew: t1 size.
	1
		to: t1 size
		do: [:t3 | t2
				basicAt: t3
				put: (t1 at: t3)].
	^ t2! !

!DependentsArray methodsFor: 'accessing' stamp: ''!
at: t1 
	| t2 t3 |
	t1 > 0
		ifTrue: [t2 := self basicSize.
			t1 <= t2
				ifTrue: [t3 := 0.
					1
						to: t2
						do: [:t5 | (self basicAt: t5)
								ifNotNil: [:t4 | (t3 := t3 + 1) = t1
										ifTrue: [^ t4]]]]].
	self error: 'access with an index out of bounds'! !

!DependentsArray methodsFor: 'accessing' stamp: ''!
at: t1 put: t2 
	| t3 t4 |
	t1 > 0
		ifTrue: [t3 := self basicSize.
			t1 <= t3
				ifTrue: [t4 := 0.
					1
						to: t3
						do: [:t5 | (self basicAt: t5)
								ifNotNil: [(t4 := t4 + 1) = t1
										ifTrue: [^ self basicAt: t5 put: t2]]]]].
	self error: 'access with an index out of bounds'! !

!DependentsArray methodsFor: 'private' stamp: ''!
basicReplaceFrom: t1 to: t2 with: t3 startingAt: t4 
	<primitive: 105>
	t1
		to: t2
		do: [:t5 | self
				basicAt: t5
				put: (t3 basicAt: t4 - t1 + t5)]! !

!DependentsArray methodsFor: 'enumerating' stamp: ''!
collect: t1 
	| t2 t3 t4 t5 t6 |
	t2 := self basicSize.
	t3 := self species new: t2.
	t4 := 0.
	1
		to: t2
		do: [:t7 | (t5 := self basicAt: t7) notNil
				ifTrue: [t3
						basicAt: (t4 := t4 + 1)
						put: (t1 value: t5)]].
	t6 := self species new: t4.
	t6
		basicReplaceFrom: 1
		to: t4
		with: t3
		startingAt: 1.
	^ t6! !

!DependentsArray methodsFor: 'copying' stamp: ''!
copyWith: t1 
	| t2 t3 |
	t2 := self class new: self size + 1.
	t3 := 0.
	self
		do: [:t5 | t2 basicAt: (t3 := t3 + 1) put: t5].
	t2 basicAt: (t3 := t3 + 1) put: t1.
	^ t2! !

!DependentsArray methodsFor: 'enumerating' stamp: ''!
do: t1 
	1
		to: self basicSize
		do: [:t3 | (self basicAt: t3)
				ifNotNil: [:t2 | t1 value: t2]]! !

!DependentsArray methodsFor: 'accessing' stamp: ''!
first
	self
		do: [:t1 | ^ t1].
	self error: 'this collection is empty'! !

!DependentsArray methodsFor: 'accessing' stamp: ''!
last
	self
		reverseDo: [:t1 | ^ t1].
	self error: 'this collection is empty'! !

!DependentsArray methodsFor: 'enumerating' stamp: ''!
reverseDo: t1 
	self basicSize
		to: 1
		by: -1
		do: [:t3 | (self basicAt: t3)
				ifNotNil: [:t2 | t1 value: t2]]! !

!DependentsArray methodsFor: 'enumerating' stamp: 'ul 6/18/2010 23:31'!
select: aBlock 
	"Refer to the comment in Collection|select:."
	| basicSize newSelf size selection |
	basicSize := self basicSize.
	newSelf := self species new: basicSize.
	size := 0.
	1 to: basicSize do: [ :i |
		(self basicAt: i) ifNotNil: [ :dep |
			(aBlock value: dep) ifTrue: [
				newSelf basicAt: (size := size+1) put: dep ] ] ].
	selection := self species new: size.
	selection basicReplaceFrom: 1 to: size with: newSelf startingAt: 1.
	^selection! !

!DependentsArray methodsFor: 'accessing' stamp: ''!
size
	^ self
		count: [:t1 | true]! !

SharedPool subclass: #ChronologyConstants
	instanceVariableNames: 'seconds offset jdn nanos'
	classVariableNames: 'DayNames DaysInMonth MonthNames NanosInMillisecond NanosInSecond OneDay SecondsInDay SecondsInHour SecondsInMinute SqueakEpoch Zero'
	poolDictionaries: ''
	category: 'Kernel-Chronology'!

!ChronologyConstants commentStamp: 'brp 3/12/2004 14:34' prior: 0!
ChronologyConstants is a SharedPool for the constants used by the Kernel-Chronology classes.!

!ChronologyConstants class methodsFor: 'class initialization' stamp: ''!
initialize
	SqueakEpoch := 2415386.
	SecondsInDay := 86400.
	SecondsInHour := 3600.
	SecondsInMinute := 60.
	NanosInSecond := 10 raisedTo: 9.
	NanosInMillisecond := 10 raisedTo: 6.
	DayNames := #(#Sunday #Monday #Tuesday #Wednesday #Thursday #Friday #Saturday ).
	MonthNames := #(#January #February #March #April #May #June #July #August #September #October #November #December ).
	DaysInMonth := #(31 28 31 30 31 30 31 31 30 31 30 31 )! !

Timespan subclass: #Date
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!Date commentStamp: 'cmm 2/3/2012 17:30' prior: 0!
Instances of Date are Timespans with duration of 1 day.

Their default creation assumes a start of midnight of UTC to provide the fast, globalized Dates out of the box.  The legacy behavior that creates Timezone-sensitive Dates can be used by sending #localizedDates.
!

!Date class methodsFor: 'smalltalk-80' stamp: ''!
dateAndTimeNow
	^ Time dateAndTimeNow! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
dayOfWeek: t1 
	^ Week indexOfDay: t1! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
daysInMonth: t1 forYear: t2 
	^ Month daysInMonth: t1 forYear: t2! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
daysInYear: t1 
	^ Year daysInYear: t1! !

!Date class methodsFor: 'general inquiries' stamp: ''!
easterDateFor: t1 
	| t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 |
	t2 := t1 // 100.
	t3 := 15 + (3 * t2 + 3 // 4) - (8 * t2 + 13 // 25).
	t4 := 2 - (3 * t2 + 3 // 4).
	t5 := t1 \\ 19.
	t6 := 19 * t5 + t3 \\ 30.
	t7 := t6 // 29 + (t6 // 28 - (t6 // 29) * (t5 // 11)).
	t8 := 21 + t6 - t7.
	t9 := 7 - (t1 // 4 + t1 + t4 \\ 7).
	t10 := 7 - (t8 - t9 \\ 7).
	t11 := t8 + t10.
	^ t11 <= 31
		ifTrue: [Date
				newDay: t11
				month: 3
				year: t1]
		ifFalse: [Date
				newDay: t11 - 31
				month: 4
				year: t1]! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
firstWeekdayOfMonth: t1 year: t2 
	^ (self
		newDay: 1
		month: t1
		year: t2) weekdayIndex! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
fromDays: t1 
	^ self julianDayNumber: t1 + SqueakEpoch! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
fromSeconds: t1 
	^ self fromDays: (Duration seconds: t1) days! !

!Date class methodsFor: 'squeak protocol' stamp: ''!
fromString: t1 
	^ self readFrom: t1 readStream! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
indexOfMonth: t1 
	^ Month indexOfMonth: t1! !

!Date class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:49'!
julianDayNumber: aJulianDayNumber 
	^ self starting:
		(DateAndTime
			julianDayNumber: aJulianDayNumber
			offset: self defaultOffset)! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
leapYear: t1 
	^ Year leapYear: t1! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
nameOfDay: t1 
	^ Week nameOfDay: t1! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
nameOfMonth: t1 
	^ Month nameOfMonth: t1! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
newDay: t1 month: t2 year: t3 
	^ self
		year: t3
		month: t2
		day: t1! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
newDay: t1 year: t2 
	^ self year: t2 day: t1! !

!Date class methodsFor: 'general inquiries' stamp: ''!
orthodoxEasterDateFor: t1 
	| t2 t3 t4 t5 t6 t7 t8 t9 t10 |
	t2 := t1 \\ 19.
	t3 := t1 \\ 4.
	t4 := t1 \\ 7.
	t6 := 19 * t2 + 16.
	t5 := t6 \\ 30.
	t7 := t3 + t3 + (4 * t4) + (6 * t5).
	t8 := t7 \\ 7.
	t9 := t5 + t8.
	t10 := Date
				newDay: 3
				month: 4
				year: t1.
	^ t10 addDays: t9! !

!Date class methodsFor: 'squeak protocol' stamp: ''!
readFrom: t1 
	| t2 t3 t4 t5 t6 |
	t1 peek = $-
		ifTrue: [t6 := -1]
		ifFalse: [t6 := 1].
	[t1 peek isAlphaNumeric]
		whileFalse: [t1 skip: 1].
	t1 peek isDigit
		ifTrue: [t5 := (Integer readFrom: t1)
						* t6.
			(t5 < 0
					or: [t5 > 31])
				ifTrue: [t4 := t5]].
	[t1 peek isAlphaNumeric]
		whileFalse: [t1 skip: 1].
	t1 peek isLetter
		ifTrue: [t3 := WriteStream
						on: (String new: 10).
			[t1 peek isLetter]
				whileTrue: [t3 nextPut: t1 next].
			t3 := t3 contents.
			[t1 peek isAlphaNumeric]
				whileFalse: [t1 skip: 1].
			t5 isNil
				ifTrue: [t2 := Integer readFrom: t1]
				ifFalse: [t4 isNil
						ifTrue: [t2 := t5]]]
		ifFalse: [t4 isNil
				ifTrue: [t5 > 12
						ifTrue: [t2 := t5.
							t3 := Month
										nameOfMonth: (Integer readFrom: t1)]
						ifFalse: [t3 := Month nameOfMonth: t5.
							t2 := Integer readFrom: t1]]
				ifFalse: [t3 := Month
								nameOfMonth: (Integer readFrom: t1)]].
	[t1 peek isAlphaNumeric]
		whileFalse: [t1 skip: 1].
	t4 isNil
		ifTrue: [t4 := Integer readFrom: t1]
		ifFalse: [t2 := Integer readFrom: t1].
	(t4 < 100
			and: [t4 >= 0])
		ifTrue: [t4 < 69
				ifTrue: [t4 := 2000 + t4]
				ifFalse: [t4 := 1900 + t4]].
	^ self
		year: t4
		month: t3
		day: t2! !

!Date class methodsFor: 'squeak protocol' stamp: ''!
readFrom: t1 pattern: t2 
	| t3 t4 t5 t6 t7 |
	t6 := t2 readStream.
	[t6 atEnd]
		whileFalse: [t1 atEnd
				ifTrue: [^ nil].
			t7 := t6 next.
			t7 = $\
				ifTrue: [t1 next = t6 next
						ifFalse: [^ nil]]
				ifFalse: [t7 = $y
						ifTrue: [(t6 nextMatchAll: 'yyy')
								ifTrue: [t5 := (t1 next: 4) asInteger]
								ifFalse: [(t6 peekFor: $y)
										ifTrue: [t5 := (t1 next: 2) asInteger]
										ifFalse: [t5 := Integer readFrom: t1]]]
						ifFalse: [t7 = $m
								ifTrue: [(t6 peekFor: $m)
										ifTrue: [t4 := (t1 next: 2) asInteger]
										ifFalse: [t4 := Integer readFrom: t1]]
								ifFalse: [t7 = $d
										ifTrue: [(t6 peekFor: $d)
												ifTrue: [t3 := (t1 next: 2) asInteger]
												ifFalse: [t3 := Integer readFrom: t1]]
										ifFalse: [t1 next = t7
												ifFalse: [^ nil]]]]]].
	t5 isNil | t4 isNil | t3 isNil
		ifTrue: [^ nil].
	^ self
		year: t5
		month: t4
		day: t3! !

!Date class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:18'!
starting: aDateAndTime 
	^ self
		starting: aDateAndTime midnight
		duration: Duration oneDay! !

!Date class methodsFor: 'smalltalk-80' stamp: ''!
today
	^ self current! !

!Date class methodsFor: 'squeak protocol' stamp: ''!
tomorrow
	^ self today next! !

!Date class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:50'!
year: year day: dayOfYear 
	^ self starting:
		(DateAndTime
			year: year
			day: dayOfYear
			hour: 0
			minute: 0
			second: 0
			offset: self defaultOffset)! !

!Date class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:50'!
year: year month: month day: day 
	^ self starting:
		(DateAndTime
			year: year
			month: month
			day: day
			hour: 0
			minute: 0
			second: 0
			offset: self defaultOffset)! !

!Date class methodsFor: 'squeak protocol' stamp: ''!
yesterday
	^ self today previous! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
addDays: t1 
	^ (self asDateAndTime + t1 days) asDate! !

!Date methodsFor: 'utils' stamp: ''!
addMonths: t1 
	| t2 t3 t4 t5 |
	t2 := self year + (t1 + self monthIndex - 1 // 12).
	t3 := self monthIndex + t1 - 1 \\ 12 + 1.
	t4 := Month daysInMonth: t3 forYear: t2.
	t5 := self dayOfMonth > t4
				ifTrue: [t4]
				ifFalse: [self dayOfMonth].
	^ Date
		newDay: t5
		month: t3
		year: t2! !

!Date methodsFor: 'squeak protocol' stamp: ''!
asDate
	^ self! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
asSeconds
	^ start asSeconds! !

!Date methodsFor: 'squeak protocol' stamp: ''!
dayMonthYearDo: t1 
	^ start dayMonthYearDo: t1! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
leap
	^ start isLeapYear
		ifTrue: [1]
		ifFalse: [0]! !

!Date methodsFor: 'printing' stamp: ''!
mmddyyyy
	^ self printFormat: #(2 1 3 $/ 1 1 )! !

!Date methodsFor: 'squeak protocol' stamp: ''!
month
	^ self asMonth! !

!Date methodsFor: 'squeak protocol' stamp: ''!
monthIndex
	^ super month! !

!Date methodsFor: 'utils' stamp: ''!
onNextMonth
	^ self addMonths: 1! !

!Date methodsFor: 'utils' stamp: ''!
onPreviousMonth
	^ self addMonths: -1! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
previous: t1 
	| t2 |
	t2 := 7 + self weekdayIndex
				- (self class dayOfWeek: t1) \\ 7.
	t2 = 0
		ifTrue: [t2 := 7].
	^ self subtractDays: t2! !

!Date methodsFor: 'printing' stamp: ''!
printFormat: t1 
	| t2 |
	t2 := WriteStream
				on: (String new: 16).
	self printOn: t2 format: t1.
	^ t2 contents! !

!Date methodsFor: 'printing' stamp: ''!
printOn: t1 
	self printOn: t1 format: ((Array new: 6) at: 1 put: 1; at: 2 put: 2; at: 3 put: 3; at: 4 put: Character space; at: 5 put: 3; at: 6 put: 1; yourself)! !

!Date methodsFor: 'printing' stamp: ''!
printOn: t1 format: t2 
	| t3 t4 t5 t6 |
	t3 := self
				dayMonthYearDo: [:t8 :t9 :t10 | {t8. t9. t10}].
	t4 := t2 size > 6
				and: [(t2 at: 7)
						> 1].
	1
		to: 3
		do: [:t7 | 
			t5 := t2 at: t7.
			t5 = 1
				ifTrue: [t4
						ifTrue: [t1
								nextPutAll: (t3 first asString
										padded: #left
										to: 2
										with: $0)]
						ifFalse: [t3 first printOn: t1]].
			t5 = 2
				ifTrue: [t6 := t2 at: 5.
					t6 = 1
						ifTrue: [t4
								ifTrue: [t1
										nextPutAll: (t3 middle asString
												padded: #left
												to: 2
												with: $0)]
								ifFalse: [t3 middle printOn: t1]].
					t6 = 2
						ifTrue: [t1
								nextPutAll: ((Month nameOfMonth: t3 middle)
										copyFrom: 1
										to: 3)].
					t6 = 3
						ifTrue: [t1
								nextPutAll: (Month nameOfMonth: t3 middle)]].
			t5 = 3
				ifTrue: [(t2 at: 6)
							= 1
						ifTrue: [t3 last printOn: t1]
						ifFalse: [t1
								nextPutAll: ((t3 last \\ 100) asString
										padded: #left
										to: 2
										with: $0)]].
			t7 < 3
				ifTrue: [(t2 at: 4)
							~= 0
						ifTrue: [t1 nextPut: (t2 at: 4) asCharacter]]]! !

!Date methodsFor: 'printing' stamp: ''!
storeOn: t1 
	t1 print: self printString;
		 nextPutAll: ' asDate'! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
subtractDate: t1 
	^ (self start - t1 asDateAndTime) days! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
subtractDays: t1 
	^ (self asDateAndTime - t1 days) asDate! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
weekday
	^ self dayOfWeekName! !

!Date methodsFor: 'smalltalk-80' stamp: ''!
weekdayIndex
	^ self dayOfWeek! !

!Date methodsFor: 'printing' stamp: ''!
yyyymmdd
	^ self printFormat: #(3 2 1 $- 1 1 2 )! !

Magnitude subclass: #DateAndTime
	instanceVariableNames: 'seconds offset jdn nanos'
	classVariableNames: 'ClockProvider DaysSinceEpoch LastMilliSeconds LastTick LastTickSemaphore LocalTimeZone MilliSecondOffset OffsetsAreValid'
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!DateAndTime commentStamp: 'brp 5/13/2003 08:07' prior: 0!
I represent a point in UTC time as defined by ISO 8601. I have zero duration.


My implementation uses three SmallIntegers
 and a Duration:
jdn		- julian day number.
seconds	- number of seconds since midnight.
nanos	- the number of nanoseconds since the second.

offset	- duration from UTC.

The nanosecond attribute is almost always zero but it defined for full ISO compliance and is suitable for timestamping.
!

!DateAndTime class methodsFor: 'clock provider' stamp: ''!
clock
	^ ClockProvider! !

!DateAndTime class methodsFor: 'ansi protocol' stamp: ''!
clockPrecision
	^ Duration seconds: 0 nanoSeconds: 1! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
current
	^ self now! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'bf 7/3/2012 23:35'!
date: aDate time: aTime

	^ self 
		year: aDate year 
		day: aDate dayOfYear 
		hour: aTime hour 
		minute: aTime minute 
		second: aTime second
		offset: aDate start offset! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
epoch
	^ self julianDayNumber: SqueakEpoch! !

!DateAndTime class methodsFor: 'smalltalk-80' stamp: ''!
fromSeconds: t1 
	| t2 t3 |
	t2 := t1 truncated.
	t2 = t1
		ifTrue: [t3 := 0]
		ifFalse: [t3 := (t1 - t2 * NanosInSecond) asInteger].
	^ self basicNew
		ticks: (Array
				with: SqueakEpoch
				with: t2
				with: t3)
		offset: self localOffset! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
fromString: t1 
	^ self
		readFrom: (ReadStream on: t1)! !

!DateAndTime class methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	ClockProvider := Time.
	LastTickSemaphore := Semaphore forMutualExclusion.
	LastMilliSeconds := 0.
	LastTick := 0.
	Smalltalk addToStartUpList: self.
	self startUp: true! !

!DateAndTime class methodsFor: 'initialize-release' stamp: 'ul 11/6/2010 23:37'!
initializeOffsets
	| durationSinceEpoch secondsSinceMidnight nowSecs |
	LastTick := 0.
	nowSecs := self clock secondsWhenClockTicks.
	LastMilliSeconds := self millisecondClockValue.
	durationSinceEpoch := Duration
		days: SqueakEpoch
		hours: 0
		minutes: 0
		seconds: nowSecs.
	DaysSinceEpoch := durationSinceEpoch days.
	secondsSinceMidnight := (durationSinceEpoch -
		(Duration
			days: DaysSinceEpoch
			hours: 0
			minutes: 0
			seconds: 0)) asSeconds.
	MilliSecondOffset := secondsSinceMidnight * 1000 - LastMilliSeconds! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:14'!
julianDayNumber: anInteger 
	^ self
		julianDayNumber: anInteger
		offset: self localOffset! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:13'!
julianDayNumber: anInteger offset: aDuration 
	^ self basicNew
		ticks: anInteger days ticks
		offset: aDuration ;
		 yourself! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
localOffset
	^ self localTimeZone offset! !

!DateAndTime class methodsFor: 'accessing' stamp: ''!
localTimeZone
	^ LocalTimeZone
		ifNil: [LocalTimeZone := TimeZone default]! !

!DateAndTime class methodsFor: 'accessing' stamp: ''!
localTimeZone: t1 
	LocalTimeZone := t1! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
midnight
	^ self now midnight! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'ul 11/6/2010 23:38'!
milliSecondsSinceMidnight
	| msm msClock |

	"This is usually only during system startup..."
	self waitForOffsets.

	msClock := self millisecondClockValue.
	msClock < LastMilliSeconds ifTrue: [ "rolled over"
		MilliSecondOffset := MilliSecondOffset + (SmallInteger maxVal // 2) + 1 ].
	LastMilliSeconds := msClock.
	[
	msm := msClock + MilliSecondOffset.
	msm >= 86400000 ] whileTrue: [
		"next day"
		LastTick := -1.
		DaysSinceEpoch := DaysSinceEpoch + 1.
		MilliSecondOffset := MilliSecondOffset - 86400000 ].
	"day rolled over sanity check"
	(LastTick = -1 and: [
		(Duration
			days: SqueakEpoch
			hours: 0
			minutes: 0
			seconds: self clock totalSeconds) days ~= DaysSinceEpoch ]) ifTrue: [
		self initializeOffsets.
		^ self milliSecondsSinceMidnight ].
	^ msm.! !

!DateAndTime class methodsFor: 'smalltalk-80' stamp: ''!
millisecondClockValue
	^ self clock millisecondClockValue! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
new
	^ self epoch! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
noon
	^ self now noon! !

!DateAndTime class methodsFor: 'ansi protocol' stamp: 'cmm 2/2/2012 19:46'!
now 
	^ self nowWithOffset: self localOffset! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'cmm 7/4/2012 13:42'!
nowWithOffset: aDuration 
	| nanoTicks msm |
	nanoTicks := (msm := self milliSecondsSinceMidnight) * 1000000.
	"The following usually only executes at system startup."
	^ LastTick < nanoTicks
		ifTrue:
			[ LastTick := nanoTicks.
			self waitForOffsets.
			self basicNew
				setJdn: DaysSinceEpoch
				seconds: msm // 1000
				nano: msm \\ 1000 * 1000000
				offset: aDuration ]
		ifFalse:
			[ LastTickSemaphore critical:
				[ LastTick := LastTick + 1.
				self waitForOffsets.
				self basicNew
					setJdn: DaysSinceEpoch
					seconds: LastTick // 1000000000
					nano: LastTick \\ 1000000000
					offset: aDuration ] ]
" 
[ 10000 timesRepeat: [ self now. ] ] timeToRun / 10000.0 . 

If calls to DateAndTime-c-#now are within a single millisecond the semaphore code 
to ensure that (self now <= self now) slows things down considerably by a factor of about 20.

The actual speed of a single call to DateAndTime-now in milliseconds is 
demonstrated by the unguarded method below.

[ 100000 timesRepeat: [ self todayAtMilliSeconds: (self milliSecondsSinceMidnight) ] ] timeToRun / 100000.0 .  0.00494 0.00481 0.00492 0.00495
  
"! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: 'jrm 7/5/2012 18:31'!
readFrom: aStream

	| offset date time ch |

	date := Date readFrom: aStream.
	[aStream peek isDigit]
		whileFalse: [aStream next].
	time := Time readFrom: aStream.
	aStream atEnd
		ifTrue: [ (aStream last = $Z) ifTrue: [offset := Duration zero] ifFalse: [ offset := self localOffset ]]
		ifFalse: [
			ch := aStream next.
			ch = $+ ifTrue: [ch := Character space].
			offset := Duration fromString: ch asString, '0:', aStream upToEnd, ':0'].
		
	^ self
		year: date year
		month: date monthIndex
		day: date dayOfMonth
		hour: time hour
		minute: time minute
		second: time second
		nanoSecond: time nanoSecond
		offset: offset


	"	'-1199-01-05T20:33:14.321-05:00' asDateAndTime
		' 2002-05-16T17:20:45.1+01:01' asDateAndTime

		' 2002-05-16T17:20:45.02+01:01' asDateAndTime

		' 2002-05-16T17:20:45.003+01:01' asDateAndTime

		' 2002-05-16T17:20:45.0004+01:01' asDateAndTime
  		' 2002-05-16T17:20:45.00005' asDateAndTime
		' 2002-05-16T17:20:45.000006+01:01' asDateAndTime

		' 2002-05-16T17:20:45.0000007+01:01' asDateAndTime
		' 2002-05-16T17:20:45.00000008-01:01' asDateAndTime   
		' 2002-05-16T17:20:45.000000009+01:01' asDateAndTime  
		' 2002-05-16T17:20:45.0000000001+01:01' asDateAndTime  

 		' 2002-05-16T17:20' asDateAndTime
		' 2002-05-16T17:20:45' asDateAndTime
		' 2002-05-16T17:20:45+01:57' asDateAndTime
 		' 2002-05-16T17:20:45-02:34' asDateAndTime
 		' 2002-05-16T17:20:45+00:00' asDateAndTime
		' 1997-04-26T01:02:03+01:02:3' asDateAndTime 
 	"! !

!DateAndTime class methodsFor: 'initialize-release' stamp: 'dtl 4/13/2011 08:10'!
startUp: resuming
	resuming ifFalse: [ ^ self ].
	Time initializeMillisecondClockMask.
	OffsetsAreValid := false.
	[
		self initializeOffsets.
		OffsetsAreValid := true
	] forkAt: Processor userInterruptPriority.! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
today
	^ self midnight! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
tomorrow
	^ self today asDate next asDateAndTime! !

!DateAndTime class methodsFor: 'smalltalk-80' stamp: ''!
totalSeconds
	^ self clock totalSeconds! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
unixEpoch
	^ self basicNew ticks: #(2440588 0 0 ) offset: Duration zero;
		 yourself! !

!DateAndTime class methodsFor: 'initialize-release' stamp: 'jmv 10/19/2010 14:10'!
waitForOffsets
	OffsetsAreValid ifFalse: [
		[
			(Delay forSeconds: 1) wait.
			OffsetsAreValid
		] whileFalse
	]! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
year: t1 day: t2 
	^ self
		year: t1
		day: t2
		hour: 0
		minute: 0
		second: 0! !

!DateAndTime class methodsFor: 'ansi protocol' stamp: ''!
year: t1 day: t2 hour: t3 minute: t4 second: t5 
	^ self
		year: t1
		day: t2
		hour: t3
		minute: t4
		second: t5
		offset: self localOffset! !

!DateAndTime class methodsFor: 'ansi protocol' stamp: ''!
year: t1 day: t2 hour: t3 minute: t4 second: t5 offset: t6 
	| t7 t8 |
	t7 := self
				year: t1
				month: 1
				day: 1
				hour: t3
				minute: t4
				second: t5
				nanoSecond: 0
				offset: t6.
	t8 := Duration days: t2 - 1.
	^ t7 + t8! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
year: t1 month: t2 day: t3 
	^ self
		year: t1
		month: t2
		day: t3
		hour: 0
		minute: 0! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
year: t1 month: t2 day: t3 hour: t4 minute: t5 
	^ self
		year: t1
		month: t2
		day: t3
		hour: t4
		minute: t5
		second: 0! !

!DateAndTime class methodsFor: 'ansi protocol' stamp: ''!
year: t1 month: t2 day: t3 hour: t4 minute: t5 second: t6 
	^ self
		year: t1
		month: t2
		day: t3
		hour: t4
		minute: t5
		second: t6
		offset: self localOffset! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
year: t1 month: t2 day: t3 hour: t4 minute: t5 second: t6 nanoSecond: t7 offset: t8 
	| t9 t10 t11 t12 t13 t14 t15 |
	t9 := t2 isInteger
				ifTrue: [t2]
				ifFalse: [Month indexOfMonth: t2].
	t10 := Month daysInMonth: t9 forYear: t1.
	t3 < 1
		ifTrue: [self error: 'day may not be zero or negative'].
	t3 > t10
		ifTrue: [self error: 'day is after month ends'].
	t11 := t9 - 14 quo: 12.
	t12 := t1 + 4800 + t11.
	t13 := t9 - 2 - (12 * t11).
	t14 := t1 + 4900 + t11 quo: 100.
	t15 := (1461 * t12 quo: 4)
				+ (367 * t13 quo: 12)
				- (3 * t14 quo: 4) + (t3 - 32075).
	^ self basicNew
		setJdn: t15
		seconds: t4 * 60 + t5 * 60 + t6
		nano: t7
		offset: t8;
		 yourself! !

!DateAndTime class methodsFor: 'ansi protocol' stamp: ''!
year: t1 month: t2 day: t3 hour: t4 minute: t5 second: t6 offset: t7 
	^ self
		year: t1
		month: t2
		day: t3
		hour: t4
		minute: t5
		second: t6
		nanoSecond: 0
		offset: t7! !

!DateAndTime class methodsFor: 'squeak protocol' stamp: ''!
yesterday
	^ self today asDate previous asDateAndTime! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
+ t1 
	| t2 |
	t2 := self ticks + t1 asDuration ticks.
	^ self class basicNew ticks: t2 offset: self offset;
		 yourself! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
- t1 
	| t2 t3 |
	^ (t1 respondsTo: #asDateAndTime)
		ifTrue: [t2 := self asLocal ticks.
			t3 := t1 asDateAndTime asLocal ticks.
			Duration seconds: SecondsInDay * (t2 first - t3 first) + (t2 second - t3 second) nanoSeconds: t2 third - t3 third]
		ifFalse: [self + t1 negated]! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
< t1 
	| t2 t3 t4 |
	t4 := t1 asDateAndTime.
	offset = t4 offset
		ifTrue: [t2 := self ticks.
			t3 := t4 ticks]
		ifFalse: [t2 := self asUTC ticks.
			t3 := t4 asUTC ticks].
	^ t2 first < t3 first
		or: [t2 first > t3 first
				ifTrue: [false]
				ifFalse: [t2 second < t3 second
						or: [t2 second > t3 second
								ifTrue: [false]
								ifFalse: [t2 third < t3 third]]]]! !

!DateAndTime methodsFor: 'ansi protocol' stamp: 'klc 9/12/2010 15:29'!
= aDateAndTimeOrTimeStamp 
	self == aDateAndTimeOrTimeStamp ifTrue: [ ^ true ].
	((aDateAndTimeOrTimeStamp isKindOf: self class)
		or: [aDateAndTimeOrTimeStamp isKindOf: DateAndTime orOf: TimeStamp])
			ifFalse: [ ^ false ].
	^ self offset = aDateAndTimeOrTimeStamp offset
		ifTrue: [ self hasEqualTicks: aDateAndTimeOrTimeStamp ]
		ifFalse: [ self asUTC ticks = aDateAndTimeOrTimeStamp asUTC ticks ]! !

!DateAndTime methodsFor: 'squeak protocol' stamp: 'klc 9/12/2010 15:56'!
asDate


	^ Date starting: self asDateAndTime! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asDateAndTime
	^ self! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asDuration
	^ Duration seconds: seconds nanoSeconds: nanos! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
asLocal
	^ self offset = self class localOffset
		ifTrue: [self]
		ifFalse: [self utcOffset: self class localOffset]! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asMonth
	^ Month starting: self! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asNanoSeconds
	^ self asDuration asNanoSeconds! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: 'cmm 2/2/2012 22:05'!
asSeconds
	"Return the number of seconds since the Squeak epoch"
	^ (self - (self class epoch offset: offset)) asSeconds! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asTime
	^ Time seconds: seconds nanoSeconds: nanos! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asTimeStamp
	^ self as: TimeStamp! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
asUTC
	^ offset isZero
		ifTrue: [self]
		ifFalse: [self utcOffset: 0]! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asUnixTime
	^ (self - self class unixEpoch) asSeconds! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asWeek
	^ Week starting: self! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
asYear
	^ Year starting: self! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
day
	^ self dayOfYear! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
dayMonthYearDo: t1 
	| t2 t3 t4 t5 t6 t7 t8 |
	t2 := jdn + 68569.
	t3 := 4 * t2 // 146097.
	t2 := t2 - (146097 * t3 + 3 // 4).
	t4 := 4000 * (t2 + 1) // 1461001.
	t2 := t2 - (1461 * t4 // 4) + 31.
	t5 := 80 * t2 // 2447.
	t6 := t2 - (2447 * t5 // 80).
	t2 := t5 // 11.
	t7 := t5 + 2 - (12 * t2).
	t8 := 100 * (t3 - 49) + t4 + t2.
	^ t1
		value: t6
		value: t7
		value: t8! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
dayOfMonth
	^ self
		dayMonthYearDo: [:t1 :t2 :t3 | t1]! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
dayOfWeek
	^ (jdn + 1 rem: 7)
		+ 1! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
dayOfWeekAbbreviation
	^ self dayOfWeekName copyFrom: 1 to: 3! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
dayOfWeekName
	^ Week nameOfDay: self dayOfWeek! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
dayOfYear
	^ self
		dayMonthYearDo: [:t1 :t2 :t3 | 
			| t4 |
			t4 := #(1 32 60 91 121 152 182 213 244 274 305 335 ) at: t2.
			(t2 > 2
					and: [Year isLeapYear: t3])
				ifTrue: [t4 + t1]
				ifFalse: [t4 + t1 - 1]]! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
daysInMonth
	^ self asMonth daysInMonth! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
daysInYear
	^ self asYear daysInYear! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
daysLeftInYear
	^ self daysInYear - self dayOfYear! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
duration
	^ Duration zero! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
firstDayOfMonth
	^ self asMonth start day! !

!DateAndTime methodsFor: 'private' stamp: ''!
hasEqualTicks: t1 
	^ jdn = t1 julianDayNumber
		and: [seconds = t1 secondsSinceMidnight
				and: [nanos = t1 nanoSecond]]! !

!DateAndTime methodsFor: 'ansi protocol' stamp: 'pad 5/10/2012 17:00'!
hash
	| totalSeconds |
	totalSeconds := seconds - offset asSeconds.
	^ ((totalSeconds // 86400 + jdn) hashMultiply bitXor: totalSeconds \\
86400) bitXor: nanos! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
hour
	^ self hour24! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
hour12
	^ self hour24 - 1 \\ 12 + 1! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
hour24
	^ (Duration seconds: seconds) hours! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
hours
	^ self hour! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
isLeapYear
	^ Year isLeapYear: self year! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
julianDayNumber
	^ jdn! !

!DateAndTime methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 19:02'!
makeUTC
	"Make the receiver's timezone UTC."
	self primOffset: Duration zero! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
meridianAbbreviation
	^ self asTime meridianAbbreviation! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
middleOf: t1 
	| t2 |
	t2 := t1 asDuration.
	^ Timespan starting: self - (t2 / 2) duration: t2! !

!DateAndTime methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 20:06'!
midnight
	"Answer a DateAndTime starting at midnight of the same timezone offset as the receiver."
	^ self class basicNew
		setJdn: jdn
		seconds: 0
		nano: 0
		offset: offset! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
minute
	^ (Duration seconds: seconds) minutes! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
minutes
	^ self minute! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
month
	^ self
		dayMonthYearDo: [:t1 :t2 :t3 | t2]! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
monthAbbreviation
	^ self monthName copyFrom: 1 to: 3! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
monthIndex
	^ self month! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
monthName
	^ Month nameOfMonth: self month! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
nanoSecond
	^ nanos! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
noon
	^ self
		dayMonthYearDo: [:t1 :t2 :t3 | self class
				year: t3
				month: t2
				day: t1
				hour: 12
				minute: 0
				second: 0]! !

!DateAndTime methodsFor: 'private' stamp: ''!
normalize: t1 ticks: t2 base: t3 
	| t4 t5 t6 t7 |
	t4 := t2 at: t1.
	t5 := t4 digitDiv: t3 neg: t4 negative.
	t6 := (t5 at: 1) normalize.
	t7 := (t5 at: 2) normalize.
	t7 < 0
		ifTrue: [t6 := t6 - 1.
			t7 := t3 + t7].
	t2 at: t1 - 1 put: (t2 at: t1 - 1)
			+ t6.
	t2 at: t1 put: t7! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
offset
	^ offset! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
offset: t1 
	^ self class basicNew ticks: self ticks offset: t1 asDuration;
		 yourself! !

!DateAndTime methodsFor: 'private' stamp: 'cmm 7/16/2011 15:32'!
primOffset: aDuration
	offset := aDuration! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
printHMSOn: t1 
	t1
		nextPutAll: (self hour asString
				padded: #left
				to: 2
				with: $0);
		 nextPut: $:;
		
		nextPutAll: (self minute asString
				padded: #left
				to: 2
				with: $0);
		 nextPut: $:;
		
		nextPutAll: (self second asString
				padded: #left
				to: 2
				with: $0)! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	^ self printOn: t1 withLeadingSpace: false! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 withLeadingSpace: t2 
	| t3 t4 |
	self printYMDOn: t1 withLeadingSpace: t2.
	t1 nextPut: $T.
	self printHMSOn: t1.
	self nanoSecond ~= 0
		ifTrue: [t4 := self nanoSecond printString
						padded: #left
						to: 9
						with: $0.
			t3 := t4
						findLast: [:t5 | t5 asciiValue > $0 asciiValue].
			t3 > 0
				ifTrue: [t1 nextPut: $.].
			t4
				from: 1
				to: t3
				do: [:t5 | t1 nextPut: t5]].
	t1
		nextPut: (offset positive
				ifTrue: [$+]
				ifFalse: [$-]);
		
		nextPutAll: (offset hours abs asString
				padded: #left
				to: 2
				with: $0);
		 nextPut: $:;
		
		nextPutAll: (offset minutes abs asString
				padded: #left
				to: 2
				with: $0).
	offset seconds = 0
		ifFalse: [t1 nextPut: $:;
				 nextPutAll: offset seconds abs truncated asString]! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
printYMDOn: t1 
	^ self printYMDOn: t1 withLeadingSpace: false! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
printYMDOn: t1 withLeadingSpace: t2 
	| t3 t5 t6 |
	self
		dayMonthYearDo: [:t7 :t8 :t9 | 
			t3 := t9.
			t5 := t8.
			t6 := t7].
	t3 negative
		ifTrue: [t1 nextPut: $-]
		ifFalse: [t2
				ifTrue: [t1 space]].
	t1
		nextPutAll: (t3 abs asString
				padded: #left
				to: 4
				with: $0);
		 nextPut: $-;
		
		nextPutAll: (t5 asString
				padded: #left
				to: 2
				with: $0);
		 nextPut: $-;
		
		nextPutAll: (t6 asString
				padded: #left
				to: 2
				with: $0)! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
second
	^ (Duration seconds: seconds) seconds! !

!DateAndTime methodsFor: 'smalltalk-80' stamp: ''!
seconds
	^ self second! !

!DateAndTime methodsFor: 'private' stamp: ''!
secondsSinceMidnight
	^ seconds! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
setJdn: t1 seconds: t2 nano: t3 offset: t4 
	jdn := t1.
	seconds := t2.
	nanos := t3.
	offset := t4! !

!DateAndTime methodsFor: 'private' stamp: ''!
ticks
	^ Array
		with: jdn
		with: seconds
		with: nanos! !

!DateAndTime methodsFor: 'private' stamp: ''!
ticks: t1 offset: t2 
	self
		normalize: 3
		ticks: t1
		base: NanosInSecond.
	self
		normalize: 2
		ticks: t1
		base: SecondsInDay.
	jdn := t1 at: 1.
	seconds := t1 at: 2.
	nanos := t1 at: 3.
	offset := t2! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
timeZoneAbbreviation
	^ self class localTimeZone abbreviation! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
timeZoneName
	^ self class localTimeZone name! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
to: t1 
	^ Timespan starting: self ending: t1 asDateAndTime! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
to: t1 by: t2 
	^ (Schedule starting: self ending: t1 asDateAndTime)
		schedule: (Array with: t2 asDuration);
		 yourself! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
to: t1 by: t2 do: t3 
	^ (self to: t1 by: t2)
		scheduleDo: t3! !

!DateAndTime methodsFor: 'squeak protocol' stamp: ''!
utcOffset: t1 
	| t2 |
	t2 := self + (t1 asDuration - self offset).
	^ t2 ticks: t2 ticks offset: t1 asDuration;
		 yourself! !

!DateAndTime methodsFor: 'ansi protocol' stamp: ''!
year
	^ self
		dayMonthYearDo: [:t1 :t2 :t3 | t3]! !

DateAndTime subclass: #TimeStamp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Chronology'!

!TimeStamp class methodsFor: 'squeak protocol' stamp: ''!
current
	| t1 t2 |
	t1 := super now asTimeStamp.
	t2 := t1 ticks.
	t2 at: 3 put: 0.
	t1 ticks: t2 offset: t1 offset.
	^ t1! !

!TimeStamp class methodsFor: 'ansi protocol' stamp: ''!
now
	^ self current! !

!TimeStamp methodsFor: 'squeak protocol' stamp: 'klc 9/12/2010 16:10'!
asDateAndTime
	"Answer the receiver as an instance of DateAndTime."

	^ DateAndTime new setJdn: jdn seconds: seconds nano: nanos offset: offset! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
asTimeStamp
	^ self! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
date
	^ self asDate! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
dateAndTime
	^ Array with: self date with: self time! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
minusDays: t1 
	^ self - t1 days! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
minusSeconds: t1 
	^ self - t1 seconds! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
plusDays: t1 
	^ self + t1 days! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
plusSeconds: t1 
	^ self + t1 seconds! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	t1 nextPutAll: self date printString;
		 space;
		 nextPutAll: self time printString! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
storeOn: t1 
	t1 print: self printString;
		 nextPutAll: ' asTimeStamp'! !

!TimeStamp methodsFor: 'squeak protocol' stamp: ''!
time
	^ self asTime! !

Magnitude subclass: #Duration
	instanceVariableNames: 'nanos seconds'
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!Duration class methodsFor: 'squeak protocol' stamp: ''!
days: t1 
	^ self seconds: t1 * SecondsInDay nanoSeconds: 0! !

!Duration class methodsFor: 'ansi protocol' stamp: ''!
days: t1 hours: t2 minutes: t3 seconds: t4 
	^ self
		days: t1
		hours: t2
		minutes: t3
		seconds: t4
		nanoSeconds: 0! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
days: t1 hours: t2 minutes: t3 seconds: t4 nanoSeconds: t5 
	^ self seconds: t1 * SecondsInDay + (t2 * SecondsInHour) + (t3 * SecondsInMinute) + t4 nanoSeconds: t5! !

!Duration class methodsFor: 'ansi protocol' stamp: ''!
days: t1 seconds: t2 
	^ self basicNew seconds: t1 * SecondsInDay + t2 nanoSeconds: 0! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
fromString: t1 
	^ self
		readFrom: (ReadStream on: t1)! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
hours: t1 
	^ self seconds: t1 * SecondsInHour nanoSeconds: 0! !

!Duration class methodsFor: 'initialize-release' stamp: 'cmm 7/17/2011 14:58'!
initialize
	ChronologyConstants classPool
		at: #Zero
		put:
			(self basicNew
				seconds: 0
				nanoSeconds: 0) ;
		at: #OneDay
		put: 1 day! !

!Duration class methodsFor: 'squeak protocol' stamp: 'ul 4/28/2010 09:44'!
milliSeconds: milliCount 
	
	^self
		seconds: (milliCount quo: 1000)
		nanoSeconds: (milliCount rem: 1000) * NanosInMillisecond! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
minutes: t1 
	^ self seconds: t1 * SecondsInMinute nanoSeconds: 0! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
month: t1 
	^ (Month month: t1 year: Year current year) duration! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
nanoSeconds: t1 
	| t2 |
	t2 := t1 quo: NanosInSecond.
	^ self basicNew seconds: t2 nanoSeconds: t1 - (t2 * NanosInSecond)! !

!Duration class methodsFor: 'squeak protocol' stamp: 'cmm 7/17/2011 14:59'!
oneDay
	"Answer the canonicalized Duration representing length of 1 day.  Used by Dates."
	^ OneDay! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
readFrom: t1 
	| t2 t3 t4 t5 t6 t7 t8 |
	t2 := (t1 peekFor: $-)
				ifTrue: [-1]
				ifFalse: [1].
	t3 := (t1 upTo: $:) asInteger sign: t2.
	t4 := (t1 upTo: $:) asInteger sign: t2.
	t5 := (t1 upTo: $:) asInteger sign: t2.
	t6 := (t1 upTo: $.) asInteger sign: t2.
	t8 := '000000000' copy.
	t7 := WriteStream on: t8.
	[t1 atEnd not
		and: [t1 peek isDigit]]
		whileTrue: [t7 nextPut: t1 next].
	^ self
		days: t3
		hours: t4
		minutes: t5
		seconds: t6
		nanoSeconds: (t8 asInteger sign: t2)! !

!Duration class methodsFor: 'ansi protocol' stamp: ''!
seconds: t1 
	^ self seconds: t1 nanoSeconds: 0! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
seconds: t1 nanoSeconds: t2 
	^ self basicNew seconds: t1 truncated nanoSeconds: t1 fractionPart * NanosInSecond + t2! !

!Duration class methodsFor: 'squeak protocol' stamp: ''!
weeks: t1 
	^ self days: t1 * 7 seconds: 0! !

!Duration class methodsFor: 'ansi protocol' stamp: 'cmm 7/16/2011 15:13'!
zero
	"Answer the canonicalized instance of Duration zero."
	^ Zero! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
* t1 
	^ self class nanoSeconds: (self asNanoSeconds * t1) asInteger! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
+ t1 
	^ self class nanoSeconds: self asNanoSeconds + t1 asNanoSeconds! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
- t1 
	^ self + t1 negated! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
/ t1 
	^ t1 isNumber
		ifTrue: [self class nanoSeconds: (self asNanoSeconds / t1) asInteger]
		ifFalse: [self asNanoSeconds / t1 asDuration asNanoSeconds]! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
// t1 
	^ t1 isNumber
		ifTrue: [self class nanoSeconds: (self asNanoSeconds // t1) asInteger]
		ifFalse: [self asNanoSeconds // t1 asDuration asNanoSeconds]! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
< t1 
	^ self asNanoSeconds < t1 asNanoSeconds! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
= t1 
	^ self == t1
		or: [self species = t1 species
				and: [self asNanoSeconds = t1 asNanoSeconds]]! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
\\ t1 
	^ t1 isNumber
		ifTrue: [self class nanoSeconds: self asNanoSeconds \\ t1]
		ifFalse: [self - (t1 * (self // t1))]! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
abs
	^ self class seconds: seconds abs nanoSeconds: nanos abs! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
asDelay
	^ Delay forDuration: self! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
asDuration
	^ self! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
asMilliSeconds
	^ seconds * NanosInSecond + nanos
		// (10 raisedToInteger: 6)! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
asNanoSeconds
	^ seconds * NanosInSecond + nanos! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
asSeconds
	^ seconds! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
days
	^ seconds quo: SecondsInDay! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
hash
	^ seconds bitXor: nanos! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
hours
	^ (seconds rem: SecondsInDay)
		quo: SecondsInHour! !

!Duration methodsFor: 'initialize-release' stamp: ''!
initialize
	self seconds: 0 nanoSeconds: 0! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
isZero
	^ seconds = 0
		and: [nanos = 0]! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
minutes
	^ (seconds rem: SecondsInHour)
		quo: SecondsInMinute! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
nanoSeconds
	^ nanos! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
negated
	^ self class seconds: seconds negated nanoSeconds: nanos negated! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
negative
	^ self positive not! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
positive
	^ seconds = 0
		ifTrue: [nanos positive]
		ifFalse: [seconds positive]! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	| t2 t3 t4 t5 t6 t7 t8 |
	t2 := self days abs.
	t3 := self hours abs.
	t4 := self minutes abs.
	t5 := self seconds abs truncated.
	t6 := self nanoSeconds abs.
	self negative
		ifTrue: [t1 nextPut: $-].
	t2 printOn: t1.
	t1 nextPut: $:.
	t3 < 10
		ifTrue: [t1 nextPut: $0].
	t3 printOn: t1.
	t1 nextPut: $:.
	t4 < 10
		ifTrue: [t1 nextPut: $0].
	t4 printOn: t1.
	t1 nextPut: $:.
	t5 < 10
		ifTrue: [t1 nextPut: $0].
	t5 printOn: t1.
	t6 = 0
		ifFalse: [t1 nextPut: $..
			t8 := t6 printString
						padded: #left
						to: 9
						with: $0.
			t7 := t8
						findLast: [:t9 | t9 asciiValue > $0 asciiValue].
			t8
				from: 1
				to: t7
				do: [:t9 | t1 nextPut: t9]]! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
roundTo: t1 
	^ self class
		nanoSeconds: (self asNanoSeconds roundTo: t1 asNanoSeconds)! !

!Duration methodsFor: 'ansi protocol' stamp: ''!
seconds
	^ seconds rem: SecondsInMinute! !

!Duration methodsFor: 'private' stamp: 'dtl 8/29/2010 11:31'!
seconds: secondCount nanoSeconds: nanoCount 
	"Private - only used by Duration class"

	seconds := secondCount.
	nanos := nanoCount rounded.
	"normalize if signs do not match"
	[ nanos < 0 and: [ seconds > 0 ] ]
		whileTrue: [ seconds := seconds - 1.
			nanos := nanos + NanosInSecond ].
	[ seconds < 0 and: [ nanos > 0 ] ]
		whileTrue: [ seconds := seconds + 1.
			nanos := nanos - NanosInSecond ]

! !

!Duration methodsFor: 'private' stamp: ''!
storeOn: t1 
	t1 nextPut: $(;
		 nextPutAll: self className;
		 nextPutAll: ' seconds: ';
		 print: seconds;
		 nextPutAll: ' nanoSeconds: ';
		 print: nanos;
		 nextPut: $)! !

!Duration methodsFor: 'private' stamp: ''!
ticks
	| t1 |
	t1 := self days.
	^ Array
		with: t1
		with: seconds - (t1 * SecondsInDay)
		with: nanos! !

!Duration methodsFor: 'squeak protocol' stamp: ''!
truncateTo: t1 
	^ self class
		nanoSeconds: (self asNanoSeconds truncateTo: t1 asNanoSeconds)! !

Timespan subclass: #Month
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!Month commentStamp: 'cbr 7/28/2010 18:11' prior: 0!
I represent a month.

For example, to get the number of days this month, you can evaluate the following expression:

Month current daysInMonth!

!Month class methodsFor: 'smalltalk-80' stamp: ''!
daysInMonth: t1 forYear: t2 
	| t3 |
	t3 := t1 isInteger
				ifTrue: [t1]
				ifFalse: [self indexOfMonth: t1].
	^ (DaysInMonth at: t3)
		+ ((t3 = 2
					and: [Year isLeapYear: t2])
				ifTrue: [1]
				ifFalse: [0])! !

!Month class methodsFor: 'smalltalk-80' stamp: 'brp 8/23/2003 09:29'!
indexOfMonth: aMonthName


	1 to: 12 do: [ :i |  (aMonthName, '*' match: (MonthNames at: i)) ifTrue: [^i] ].
	self error: aMonthName , ' is not a recognized month name'.! !

!Month class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 20:16'!
month: month year: year 
	"Create a Month for the given <year> and <month>.
	<month> may be a number or a String with the
	name of the month. <year> should be with 4 digits."
	^ self starting:
		(DateAndTime
			year: year
			month: month
			day: 1
			hour: 0
			minute: 0
			second: 0
			offset: self defaultOffset)! !

!Month class methodsFor: 'smalltalk-80' stamp: ''!
nameOfMonth: t1 
	^ MonthNames at: t1! !

!Month class methodsFor: 'squeak protocol' stamp: 'cmm 4/28/2011 22:09'!
readFrom: aStream

	| m y c |
	m := (ReadWriteStream with: '') reset.
	[(c := aStream next) isSeparator] whileFalse: [m nextPut: c].
	[(c := aStream next) isSeparator] whileTrue.
	y := (ReadWriteStream with: '') reset.
	y nextPut: c.
	[aStream atEnd] whileFalse: [y nextPut: aStream next].

	^ self 
		month: m contents
		year: y contents asInteger

"Month readFrom: 'July 1998' readStream"! !

!Month class methodsFor: 'squeak protocol' stamp: 'cmm 2/2/2012 23:15'!
starting: aDateAndTime duration: aDuration 
	"Override - a each month has a defined duration"
	| start adjusted days |
	start := aDateAndTime asDateAndTime.
	adjusted := DateAndTime
		year: start year
		month: start month
		day: 1
		hour: 0
		minute: 0
		second: 0
		offset: start offset.
	days := self
		daysInMonth: adjusted month
		forYear: adjusted year.
	^ super
		starting: adjusted
		duration: (Duration days: days)! !

!Month methodsFor: 'squeak protocol' stamp: ''!
asMonth
	^ self! !

!Month methodsFor: 'squeak protocol' stamp: ''!
daysInMonth
	^ self duration days! !

!Month methodsFor: 'squeak protocol' stamp: ''!
index
	^ self monthIndex! !

!Month methodsFor: 'squeak protocol' stamp: ''!
name
	^ self monthName! !

!Month methodsFor: 'squeak protocol' stamp: ''!
previous
	^ self class starting: self start - 1! !

!Month methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	t1 nextPutAll: self monthName , ' ' , self year printString! !

Magnitude subclass: #Time
	instanceVariableNames: 'seconds nanos'
	classVariableNames: 'MillisecondClockMask'
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!Time commentStamp: 'dew 10/23/2004 17:58' prior: 0!
This represents a particular point in time during any given day.  For example, '5:19:45 pm'.

If you need a point in time on a particular day, use DateAndTime.  If you need a duration of time, use Duration.
!

!Time class methodsFor: 'benchmarks' stamp: ''!
benchmarkMillisecondClock
	| t1 t2 t3 t4 t5 t6 |
	t4 := 5000.
	Delay anyActive
		ifTrue: [^ self notify: 'Some delay is currently active.

Running this benchmark will not give any useful result.'].
	Object flushCache.
	t1 := 0.
	t2 := self.
	t3 := self millisecondClockValue + t4.
	[t2 millisecondClockValue < t3]
		whileTrue: [t1 := t1 + 1].
	t5 := t1.
	t1 := 0.
	t3 := t5.
	t6 := Time millisecondClockValue.
	[t1 < t3]
		whileTrue: [t1 := t1 + 1].
	t6 := Time millisecondClockValue - t6.
	^ (t4 - t6 * 1000.0 / t5 truncateTo: 0.001) printString , ' microseconds per call to Time>>millisecondClockValue'! !

!Time class methodsFor: 'benchmarks' stamp: ''!
benchmarkPrimitiveResponseDelay
	| t1 t2 t3 t4 t5 t6 |
	t6 := 5000.
	Delay anyActive
		ifTrue: [^ self notify: 'Some delay is currently active.

Running this benchmark will not give any useful result.'].
	t2 := Array new: 1.
	[(Delay forMilliseconds: t6) wait]
		forkAt: Processor userInterruptPriority.
	t1 := 0.
	[Delay anyActive]
		whileTrue: [t2 basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize.
			t1 := t1 + 1].
	Object flushCache.
	t2 basicSize.
	t4 := self millisecondClockValue.
	t3 := t1.
	[t3 > 0]
		whileTrue: [t2 basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize.
			t3 := t3 - 1].
	t4 := self millisecondClockValue - t4.
	[(Delay forMilliseconds: t6 + t6) wait]
		forkAt: Processor userInterruptPriority.
	t5 := self millisecondClockValue.
	t3 := t1.
	[t3 > 0]
		whileTrue: [t2 basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize; basicSize.
			t3 := t3 - 1].
	t5 := self millisecondClockValue - t5.
	^ (t5 - t4 * 1000 asFloat / (t1 * 10) truncateTo: 0.001) printString , ' microseconds overhead per primitive call'! !

!Time class methodsFor: 'general inquiries' stamp: ''!
condenseBunches: t1 
	| t2 t3 t4 t5 t7 t8 |
	t2 := t1 asSortedCollection.
	t5 := 1.
	t3 := self totalSeconds.
	t4 := OrderedCollection new.
	t7 := 0.
	t8 := nil.
	t2
		reverseDo: [:t9 | 
			| t10 |
			t10 := t3 - t9.
			t10 > (60 * 30)
				ifTrue: [t5 := 1800].
			t10 > (60 * 60 * 24)
				ifTrue: [t5 := 7200].
			t10 - t7 >= t5
				ifTrue: [t4 add: t8.
					t8 := t9].
			t7 := t10].
	t4 add: t8.
	t4 removeFirst.
	^ t4! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
current
	^ self now! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
dateAndTimeFromSeconds: t1 
	^ Array
		with: (Date fromSeconds: t1)
		with: (Time fromSeconds: t1 \\ 86400)! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
dateAndTimeNow
	^ self dateAndTimeFromSeconds: self totalSeconds! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
fromSeconds: t1 
	| t2 t3 |
	t2 := t1 truncated.
	t2 = t1
		ifTrue: [t3 := 0]
		ifFalse: [t3 := (t1 - t2 * NanosInSecond) asInteger].
	^ self seconds: t2 nanoSeconds: t3! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
hour: t1 minute: t2 second: t3 
	^ self
		hour: t1
		minute: t2
		second: t3
		nanoSecond: 0! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
hour: t1 minute: t2 second: t3 nanoSecond: t4 
	^ self seconds: t1 * SecondsInHour + (t2 * SecondsInMinute) + t3 nanoSeconds: t4! !

!Time class methodsFor: 'general inquiries' stamp: ''!
humanWordsForSecondsAgo: t1 
	| t2 t3 |
	t1 <= 1
		ifTrue: [^ 'a second ago'].
	t1 < 45
		ifTrue: [^ t1 printString , ' seconds ago'].
	t1 < 90
		ifTrue: [^ 'a minute ago'].
	t1 < 2700
		ifTrue: [^ (t1 // 60) printString , ' minutes ago'].
	t1 < 5400
		ifTrue: [^ 'an hour ago'].
	t1 < 64800
		ifTrue: [^ (t1 // 3600) printString , ' hours ago'].
	t2 := Date fromSeconds: self totalSeconds - t1.
	t3 := Date today.
	t2
			> (t3 subtractDays: 2)
		ifTrue: [^ 'yesterday'].
	t2
			> (t3 subtractDays: 8)
		ifTrue: [^ 'last ' , t2 dayOfWeekName].
	t2
			> (t3 subtractDays: 13)
		ifTrue: [^ 'a week ago'].
	t2
			> (t3 subtractDays: 28)
		ifTrue: [^ ((t3 subtractDate: t2)
				// 7) printString , ' weeks ago'].
	t2
			> (t3 subtractDays: 45)
		ifTrue: [^ 'a month ago'].
	t2
			> (t3 subtractDays: 300)
		ifTrue: [^ 'last ' , t2 monthName].
	^ t2 monthName , ', ' , t2 year printString! !

!Time class methodsFor: 'clock' stamp: 'dtl 4/13/2011 08:09'!
initializeMillisecondClockMask
	"Initialize cached value from the VM, or set to nil if VM cannot support the request"

	MillisecondClockMask := self primMillisecondClockMask
! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
midnight
	^ self seconds: 0! !

!Time class methodsFor: 'ansi protocol' stamp: ''!
milliSecondsSinceMidnight
	^ DateAndTime milliSecondsSinceMidnight! !

!Time class methodsFor: 'general inquiries' stamp: 'dtl 4/13/2011 08:06'!
millisecondClockMask
	"Answer the mask used for millisecond clock rollover in the virtual machine.
	Answer a default if the VM cannot supply the value."

	^MillisecondClockMask ifNil: [16r1FFFFFFF]
! !

!Time class methodsFor: 'general inquiries' stamp: ''!
millisecondClockValue
	<primitive: 135>
	^ 0! !

!Time class methodsFor: 'squeak protocol' stamp: 'dtl 4/13/2011 08:05'!
milliseconds: currentTime since: lastTime
	"Answer the elapsed time since last recorded in milliseconds.
	Compensate for rollover."

	| delta |
	delta := currentTime - lastTime.
	^ delta < 0
		ifTrue: [self millisecondClockMask + delta]
		ifFalse: [delta]! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
millisecondsSince: t1 
	^ self milliseconds: self millisecondClockValue since: t1! !

!Time class methodsFor: 'general inquiries' stamp: ''!
millisecondsToRun: t1 
	| t2 |
	t2 := self millisecondClockValue.
	t1 value.
	^ self millisecondsSince: t2! !

!Time class methodsFor: 'general inquiries' stamp: ''!
namesForTimes: t1 
	| t2 t3 t4 |
	t2 := t1
				collect: [:t6 | self humanWordsForSecondsAgo: self totalSeconds - t6].
	t4 := ''.
	t3 := t2 copy.
	t2
		withIndexDo: [:t6 :t7 | 
			| t8 t9 |
			t6 = t4
				ifTrue: [t8 := self
								dateAndTimeFromSeconds: (t1 at: t7 - 1).
					t9 := self
								dateAndTimeFromSeconds: (t1 at: t7).
					(t3 at: t7 - 1)
							= t4
						ifTrue: [t3 at: t7 - 1 put: (t3 at: t7 - 1)
									, ', ' , t8 first mmddyyyy].
					t3 at: t7 put: (t3 at: t7)
							, ', ' , t9 first mmddyyyy.
					t8 first = t9 first
						ifTrue: [(t3 at: t7 - 1) last == $m
								ifFalse: [t3 at: t7 - 1 put: (t3 at: t7 - 1)
											, ', ' , t8 second printMinutes].
							t3 at: t7 put: (t3 at: t7)
									, ', ' , t9 second printMinutes]]
				ifFalse: [t6].
			t4 := t6].
	^ t3! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
new
	^ self midnight! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
noon
	^ self seconds: SecondsInDay / 2! !

!Time class methodsFor: 'ansi protocol' stamp: ''!
now
	| t1 |
	t1 := self milliSecondsSinceMidnight.
	^ self seconds: t1 // 1000 nanoSeconds: t1 \\ 1000 * 1000000! !

!Time class methodsFor: 'clock' stamp: 'dtl 8/14/2010 15:25'!
primMicrosecondClock
	"Answer the number of microseconds since the microsecond clock
	was last reset or rolled over. Answer zero if the primitive fails."

	<primitive: 'primitiveMicrosecondClock'>
	^ 0! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
primMillisecondClock
	<primitive: 135>
	^ 0! !

!Time class methodsFor: 'clock' stamp: 'dtl 4/13/2011 08:02'!
primMillisecondClockMask
	"Answer the mask value used for millisecond clock rollover in the
	virtual machine, or nil if the VM cannot support the request."

	<primitive: 'primitiveMillisecondClockMask'>
	^nil! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
primSecondsClock
	<primitive: 137>
	self primitiveFailed! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
readFrom: t1 
	| t2 t3 t4 t5 t6 t7 |
	t2 := Integer readFrom: t1.
	t3 := 0.
	t4 := 0.
	t7 := '000000000' copy.
	t6 := WriteStream on: t7.
	(t1 peekFor: $:)
		ifTrue: [t3 := Integer readFrom: t1.
			(t1 peekFor: $:)
				ifTrue: [t4 := Integer readFrom: t1].
			(t1 peekFor: $.)
				ifTrue: [[t1 atEnd not
						and: [t1 peek isDigit]]
						whileTrue: [t6 nextPut: t1 next]]].
	t1 skipSeparators.
	(t1 atEnd not
			and: [t1 peek isLetter])
		ifTrue: [t5 := t1 next asLowercase.
			(t5 = $p
					and: [t2 < 12])
				ifTrue: [t2 := t2 + 12].
			(t5 = $a
					and: [t2 = 12])
				ifTrue: [t2 := 0].
			(t1 peekFor: $m)
				ifFalse: [t1 peekFor: $M]].
	^ self
		hour: t2
		minute: t3
		second: t4
		nanoSecond: t7 asInteger! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
seconds: t1 
	^ self basicNew ticks: (Duration seconds: t1) ticks! !

!Time class methodsFor: 'squeak protocol' stamp: ''!
seconds: t1 nanoSeconds: t2 
	^ self basicNew ticks: (Duration seconds: t1 nanoSeconds: t2) ticks! !

!Time class methodsFor: 'clock' stamp: ''!
secondsWhenClockTicks
	| t1 t2 |
	t2 := Delay forMilliseconds: 1.
	t1 := self primSecondsClock.
	[t1 = self primSecondsClock]
		whileTrue: [t2 wait].
	^ t1 + 1! !

!Time class methodsFor: 'smalltalk-80' stamp: ''!
totalSeconds
	^ self primSecondsClock! !

!Time methodsFor: 'ansi protocol' stamp: ''!
< t1 
	^ self asDuration < t1 asDuration! !

!Time methodsFor: 'ansi protocol' stamp: ''!
= t1 
	^ [self ticks = t1 ticks]
		on: MessageNotUnderstood
		do: [false]! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
addSeconds: t1 
	^ self class seconds: self asSeconds + t1! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
addTime: t1 
	^ self class seconds: self asSeconds + t1 asSeconds! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asDate
	^ Date today! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asDateAndTime
	^ DateAndTime today + self! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asDuration
	^ Duration seconds: seconds nanoSeconds: nanos! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asMonth
	^ self asDateAndTime asMonth! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asNanoSeconds
	^ self asDuration asNanoSeconds! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
asSeconds
	^ seconds! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asTime
	^ self! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asTimeStamp
	^ self asDateAndTime asTimeStamp! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asWeek
	^ self asDateAndTime asWeek! !

!Time methodsFor: 'squeak protocol' stamp: ''!
asYear
	^ self asDateAndTime asYear! !

!Time methodsFor: 'ansi protocol' stamp: ''!
duration
	^ Duration zero! !

!Time methodsFor: 'ansi protocol' stamp: ''!
hash
	^ self ticks hash! !

!Time methodsFor: 'printing' stamp: ''!
hhmm24
	^ (String
		streamContents: [:t1 | self
				print24: true
				showSeconds: false
				on: t1])
		copyWithout: $:! !

!Time methodsFor: 'ansi protocol' stamp: ''!
hour
	^ self hour24! !

!Time methodsFor: 'ansi protocol' stamp: ''!
hour12
	^ self hour24 - 1 \\ 12 + 1! !

!Time methodsFor: 'ansi protocol' stamp: ''!
hour24
	^ self asDuration hours! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
hours
	^ self hour! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
intervalString
	| t1 |
	t1 := self asDuration.
	^ String
		streamContents: [:t2 | 
			t1 hours > 0
				ifTrue: [t2 print: t1 hours;
						 nextPutAll: ' hours'].
			t1 minutes > 0
				ifTrue: [t2 space; print: t1 minutes; nextPutAll: ' minutes'].
			t1 seconds > 0
				ifTrue: [t2 space; print: t1 seconds; nextPutAll: ' seconds']]! !

!Time methodsFor: 'ansi protocol' stamp: ''!
meridianAbbreviation
	^ self hour < 12
		ifTrue: ['AM']
		ifFalse: ['PM']! !

!Time methodsFor: 'ansi protocol' stamp: ''!
minute
	^ self asDuration minutes! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
minutes
	^ self asDuration minutes! !

!Time methodsFor: 'squeak protocol' stamp: ''!
nanoSecond
	^ nanos! !

!Time methodsFor: 'printing' stamp: ''!
print24
	^ String
		streamContents: [:t1 | self print24: true on: t1]! !

!Time methodsFor: 'printing' stamp: ''!
print24: t1 on: t2 
	self
		print24: t1
		showSeconds: true
		on: t2! !

!Time methodsFor: 'printing' stamp: 'bf 8/31/2012 20:23'!
print24: hr24 showSeconds: showSeconds on: aStream 
	"Format is 'hh:mm:ss' or 'h:mm:ss am'  or, if showSeconds is false, 'hh:mm' or 'h:mm am'"

	| h m s |
	h := self hour. m := self minute. s := self second.
	hr24
		ifTrue: 
			[ h < 10 ifTrue: [ aStream nextPutAll: '0' ].
			h printOn: aStream ]
		ifFalse:
			[ h > 12
				ifTrue: [h - 12 printOn: aStream]
				ifFalse: 
					[h < 1
						ifTrue: [ 12 printOn: aStream ]
						ifFalse: [ h printOn: aStream ]]].

	aStream nextPutAll: (m < 10 ifTrue: [':0'] ifFalse: [':']).
	m printOn: aStream.

	showSeconds ifTrue:
		[ aStream nextPutAll: (s < 10 ifTrue: [':0'] ifFalse: [':']).
		self nanoSecond = 0
			ifTrue: [s asInteger printOn: aStream]
			ifFalse: [s asInteger * NanosInSecond + self nanoSecond asInteger 
				printOn: aStream asFixedPoint: NanosInSecond]].

	hr24 ifFalse:
		[ aStream nextPutAll: (h < 12 ifTrue: [' am'] ifFalse: [' pm']) ].
! !

!Time methodsFor: 'printing' stamp: ''!
printMinutes
	^ String
		streamContents: [:t1 | self
				print24: false
				showSeconds: false
				on: t1]! !

!Time methodsFor: 'printing' stamp: ''!
printOn: t1 
	self
		print24: false
		showSeconds: (self seconds ~= 0
				or: [self nanoSecond ~= 0])
		on: t1! !

!Time methodsFor: 'ansi protocol' stamp: ''!
second
	^ self asDuration seconds! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
seconds
	^ self second! !

!Time methodsFor: 'private' stamp: ''!
seconds: t1 
	seconds := t1.
	nanos := 0! !

!Time methodsFor: 'private' stamp: ''!
seconds: t1 nanoSeconds: t2 
	seconds := t1.
	nanos := t2! !

!Time methodsFor: 'printing' stamp: ''!
storeOn: t1 
	t1 print: self printString;
		 nextPutAll: ' asTime'! !

!Time methodsFor: 'smalltalk-80' stamp: ''!
subtractTime: t1 
	^ self class seconds: self asSeconds - t1 asSeconds! !

!Time methodsFor: 'private' stamp: ''!
ticks
	^ Array
		with: 0
		with: seconds
		with: nanos! !

!Time methodsFor: 'private' stamp: ''!
ticks: t1 
	seconds := t1 at: 2.
	nanos := t1 at: 3! !

!Time methodsFor: 'squeak protocol' stamp: ''!
to: t1 
	^ self asDateAndTime to: t1! !

Object subclass: #TimeZone
	instanceVariableNames: 'offset abbreviation name'
	classVariableNames: ''
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!TimeZone class methodsFor: 'accessing' stamp: ''!
default
	^ self timeZones
		detect: [:t1 | t1 offset = Duration zero]! !

!TimeZone class methodsFor: 'instance creation' stamp: ''!
offset: t1 name: t2 abbreviation: t3 
	^ self new offset: t1;
		 name: t2;
		 abbreviation: t3;
		 yourself! !

!TimeZone class methodsFor: 'accessing' stamp: ''!
timeZones
	^ {self
		offset: 0 hours
		name: 'Universal Time'
		abbreviation: 'UTC'. self
		offset: 0 hours
		name: 'Greenwich Mean Time'
		abbreviation: 'GMT'. self
		offset: 1 hours
		name: 'British Summer Time'
		abbreviation: 'BST'. self
		offset: 2 hours
		name: 'South African Standard Time'
		abbreviation: 'SAST'. self
		offset: -8 hours
		name: 'Pacific Standard Time'
		abbreviation: 'PST'. self
		offset: -7 hours
		name: 'Pacific Daylight Time'
		abbreviation: 'PDT'. self
		offset: -7 hours
		name: 'Mountain Standard Time'
		abbreviation: 'MST'. self
		offset: -6 hours
		name: 'Mountain Daylight Time'
		abbreviation: 'MDT'. self
		offset: -6 hours
		name: 'Central Standard Time'
		abbreviation: 'CST'. self
		offset: -5 hours
		name: 'Central Daylight Time'
		abbreviation: 'CDT'. self
		offset: -5 hours
		name: 'Eastern Standard Time'
		abbreviation: 'EST'. self
		offset: -4 hours
		name: 'Eastern Daylight Time'
		abbreviation: 'EDT'}! !

!TimeZone methodsFor: 'accessing' stamp: ''!
abbreviation
	^ abbreviation! !

!TimeZone methodsFor: 'accessing' stamp: ''!
abbreviation: t1 
	abbreviation := t1! !

!TimeZone methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!TimeZone methodsFor: 'accessing' stamp: ''!
name: t1 
	name := t1! !

!TimeZone methodsFor: 'accessing' stamp: ''!
offset
	^ offset! !

!TimeZone methodsFor: 'accessing' stamp: ''!
offset: t1 
	offset := t1! !

!TimeZone methodsFor: 'private' stamp: ''!
printOn: t1 
	super printOn: t1.
	t1 nextPut: $(;
		 nextPutAll: self abbreviation;
		 nextPut: $)! !

Timespan subclass: #Week
	instanceVariableNames: ''
	classVariableNames: 'StartDay'
	poolDictionaries: 'ChronologyConstants'
	category: 'Kernel-Chronology'!

!Week commentStamp: 'cbr 7/28/2010 18:11' prior: 0!
I represent a week.

To find out what days of the week on which Squeak is fun, select the following expression, and print it:

Week dayNames!

!Week class methodsFor: 'squeak protocol' stamp: ''!
dayNames
	^ DayNames! !

!Week class methodsFor: 'squeak protocol' stamp: ''!
indexOfDay: t1 
	^ DayNames indexOf: t1! !

!Week class methodsFor: 'smalltalk-80' stamp: ''!
nameOfDay: t1 
	^ DayNames at: t1! !

!Week class methodsFor: 'squeak protocol' stamp: ''!
startDay
	^ StartDay
		ifNil: [StartDay := DayNames first]! !

!Week class methodsFor: 'squeak protocol' stamp: ''!
startDay: t1 
	(DayNames includes: t1)
		ifTrue: [StartDay := t1]
		ifFalse: [self error: t1 , ' is not a recognised day name']! !

!Week class methodsFor: 'squeak protocol' stamp: ''!
starting: t1 duration: t2 
	| t3 t4 t5 |
	t3 := t1 asDateAndTime midnight.
	t4 := (t3 dayOfWeek + 7
				- (DayNames indexOf: self startDay) rem: 7) abs.
	t5 := t3
				- (Duration days: t4 seconds: 0).
	^ super
		starting: t5
		duration: (Duration weeks: 1)! !

!Week methodsFor: 'squeak protocol' stamp: ''!
asWeek
	^ self! !

!Week methodsFor: 'squeak protocol' stamp: ''!
index
	^ self asMonth dayOfWeek + self dayOfMonth - 2 // 7 + 1! !

!Week methodsFor: 'squeak protocol' stamp: ''!
printOn: t1 
	t1 nextPutAll: 'a Week starting: '.
	self start printOn: t1! !

SharedPool subclass: #EventSensorConstants
	instanceVariableNames: ''
	classVariableNames: 'BlueButtonBit CommandKeyBit CtrlKeyBit EventKeyChar EventKeyDown EventKeyUp EventTouchCancelled EventTouchDown EventTouchMoved EventTouchStationary EventTouchUp EventTypeComplex EventTypeDragDropFiles EventTypeKeyboard EventTypeMenu EventTypeMouse EventTypeNone EventTypeWindow OptionKeyBit RedButtonBit ShiftKeyBit TouchPhaseBegan TouchPhaseCancelled TouchPhaseEnded TouchPhaseMoved TouchPhaseStationary WindowEventActivated WindowEventClose WindowEventIconise WindowEventMetricChange WindowEventPaint WindowEventStinks YellowButtonBit'
	poolDictionaries: ''
	category: 'Kernel-Processes'!

InputSensor subclass: #EventSensor
	instanceVariableNames: 'mouseButtons mousePosition keyboardBuffer interruptKey interruptSemaphore eventQueue inputSemaphore lastEventPoll hasInputSemaphore'
	classVariableNames: 'EventPollPeriod EventTicklerProcess'
	poolDictionaries: 'EventSensorConstants'
	category: 'Kernel-Processes'!

!EventSensor class methodsFor: 'class initialization' stamp: ''!
eventPollPeriod
	^ EventPollPeriod
		ifNil: [EventPollPeriod := 500]! !

!EventSensor class methodsFor: 'class initialization' stamp: ''!
eventPollPeriod: t1 
	EventPollPeriod := t1 max: 10! !

!EventSensor class methodsFor: 'class initialization' stamp: ''!
install
	| t1 |
	Sensor shutDown.
	t1 := self new.
	t1 startUp.
	Sensor becomeForward: t1! !

!EventSensor methodsFor: 'mouse' stamp: ''!
createMouseEvent
	| t1 t2 t3 t4 t5 |
	t5 := Array new: 8.
	t1 := self primMouseButtons.
	t3 := self primMousePt.
	t2 := t1 bitShift: -3.
	t1 := t1 bitAnd: 7.
	t4 := self mapButtons: t1 modifiers: t2.
	t5 at: 1 put: EventTypeMouse;
		 at: 2 put: Time millisecondClockValue;
		 at: 3 put: t3 x;
		 at: 4 put: t3 y;
		 at: 5 put: t4;
		 at: 6 put: t2.
	^ t5! !

!EventSensor methodsFor: 'accessing' stamp: ''!
eventQueue
	^ eventQueue! !

!EventSensor methodsFor: 'private' stamp: 'nice 3/31/2011 01:12'!
eventTickler
	"Poll infrequently to make sure that the UI process is not been stuck. 
	If it has been stuck, then spin the event loop so that I can detect the 
	interrupt key."
	| delay |
	delay := Delay forMilliseconds: self class eventPollPeriod.
	self lastEventPoll.	"ensure not nil."
	[| delta | 
	[ delay wait.
	delta := Time millisecondClockValue - lastEventPoll.
	(delta < 0
			or: [delta > self class eventPollPeriod])
		ifTrue:
			["force check on rollover"
			self fetchMoreEvents]]
		on: Error do: [:ex | ]] repeat.! !

!EventSensor methodsFor: 'accessing' stamp: ''!
eventTicklerProcess
	^ EventTicklerProcess! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
fetchMoreEvents
	| t1 t2 |
	inputSemaphore isSignaled
		ifTrue: [hasInputSemaphore := true.
			inputSemaphore initSignals].
	lastEventPoll := Time millisecondClockValue.
	t1 := Array new: 8.
	[self primGetNextEvent: t1.
	t2 := t1 at: 1.
	t2 = EventTypeNone]
		whileFalse: [self processEvent: t1]! !

!EventSensor methodsFor: 'accessing' stamp: ''!
flushAllButDandDEvents
	| t1 t2 t3 t4 |
	t1 := SharedQueue new.
	self eventQueue
		ifNil: [eventQueue := t1.
			^ self].
	t2 := self eventQueue.
	[t2 size > 0]
		whileTrue: [t3 := t2 next.
			t4 := t3 at: 1.
			t4 = EventTypeDragDropFiles
				ifTrue: [t1 nextPut: t3]].
	eventQueue := t1! !

!EventSensor methodsFor: 'accessing' stamp: ''!
flushEvents
	eventQueue
		ifNotNil: [eventQueue flush]! !

!EventSensor methodsFor: 'private' stamp: ''!
flushNonKbdEvents
	eventQueue
		ifNil: [^ self].
	eventQueue
		flushAllSuchThat: [:t1 | (self isKbdEvent: t1) not]! !

!EventSensor methodsFor: 'initialize' stamp: ''!
initialize
	mouseButtons := 0.
	mousePosition := 0 @ 0.
	keyboardBuffer := SharedQueue new.
	self
		setInterruptKey: (interruptKey
				ifNil: [$. asciiValue bitOr: 2048]).
	interruptSemaphore := (Smalltalk specialObjectsArray at: 31)
				ifNil: [Semaphore new].
	self flushAllButDandDEvents.
	inputSemaphore := Semaphore new.
	hasInputSemaphore := false! !

!EventSensor methodsFor: 'private' stamp: ''!
installEventTickler
	EventTicklerProcess
		ifNotNil: [EventTicklerProcess terminate].
	EventTicklerProcess := [self eventTickler]
				forkAt: Processor lowIOPriority! !

!EventSensor methodsFor: 'private' stamp: ''!
isKbdEvent: t1 
	^ (t1 at: 1)
			= EventTypeKeyboard
		and: [(t1 at: 4)
				= EventKeyChar]! !

!EventSensor methodsFor: 'keyboard' stamp: 'eem 4/9/2012 10:14'!
kbdTest    "Sensor kbdTest"
	"This test routine will print the unmodified character, its keycode,
	and the OR of all its modifier bits, until the character x is typed"
	| char evt |
	char := nil.
	[char = $x] whileFalse: 
		[[(evt := self peekKeyboardEvent) isNil] whileTrue.
		char := self characterForKeycode: evt third.
		(String streamContents: 
			[:s |
			s nextPut: char.
			(3 to: 8) with: 'cpmurw' do:
				[:i :c|
				s space; nextPut: c; nextPut: $:; print: (evt at: i); nextPutAll: '     ']])
			displayAt: 10@10]! !

!EventSensor methodsFor: 'private' stamp: ''!
lastEventPoll
	^ lastEventPoll
		ifNil: [lastEventPoll := Time millisecondClockValue]! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
mapButtons: t1 modifiers: t2 
	t1 = RedButtonBit
		ifFalse: [^ t1].
	(t2 allMask: CtrlKeyBit)
		ifTrue: [^ BlueButtonBit].
	(t2 allMask: CommandKeyBit)
		ifTrue: [^ YellowButtonBit].
	^ t1! !

!EventSensor methodsFor: 'accessing' stamp: ''!
nextEvent
	eventQueue
		ifNil: [^ self nextEventSynthesized].
	^ self nextEventFromQueue! !

!EventSensor methodsFor: 'private' stamp: ''!
nextEventFromQueue
	eventQueue isEmpty
		ifTrue: [self fetchMoreEvents].
	eventQueue isEmpty
		ifTrue: [^ nil].
	^ eventQueue next! !

!EventSensor methodsFor: 'private' stamp: ''!
nextEventSynthesized
	| t1 t2 t3 t4 t5 t6 |
	t2 := Array new: 8.
	t1 := self primKbdNext.
	t1
		ifNotNil: [t2 at: 1 put: EventTypeKeyboard.
			t2 at: 2 put: Time millisecondClockValue.
			t2
				at: 3
				put: (t1 bitAnd: 255).
			t2 at: 4 put: EventKeyChar.
			t2
				at: 5
				put: (t1 bitShift: -8).
			^ t2].
	t4 := self primMousePt.
	t3 := mouseButtons.
	t5 := t3 bitShift: -3.
	t3 := t3 bitAnd: 7.
	t6 := self mapButtons: t3 modifiers: t5.
	t2 at: 1 put: EventTypeMouse;
		 at: 2 put: Time millisecondClockValue;
		 at: 3 put: t4 x;
		 at: 4 put: t4 y;
		 at: 5 put: t6;
		 at: 6 put: t5.
	^ t2! !

!EventSensor methodsFor: 'accessing' stamp: ''!
peekButtons
	self wait2ms.
	self fetchMoreEvents.
	^ mouseButtons! !

!EventSensor methodsFor: 'accessing' stamp: ''!
peekEvent
	eventQueue
		ifNil: [^ nil].
	self fetchMoreEvents.
	^ eventQueue peek! !

!EventSensor methodsFor: 'accessing' stamp: ''!
peekKeyboardEvent
	^ eventQueue
		nextOrNilSuchThat: [:t1 | t1 first = EventTypeKeyboard
				and: [t1 fourth = EventKeyChar]]! !

!EventSensor methodsFor: 'accessing' stamp: ''!
peekMousePt
	^ mousePosition! !

!EventSensor methodsFor: 'accessing' stamp: ''!
peekPosition
	self wait2ms.
	self fetchMoreEvents.
	^ mousePosition! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
primGetNextEvent: t1 
	| t2 t3 t4 t5 t6 |
	<primitive: 94>
	t1 at: 1 put: EventTypeNone.
	t2 := super primKbdNext.
	t2 = nil
		ifFalse: [t1 at: 1 put: EventTypeKeyboard.
			t1 at: 2 put: Time millisecondClockValue.
			t1
				at: 3
				put: (t2 bitAnd: 255).
			t1 at: 4 put: EventKeyChar.
			t1
				at: 5
				put: (t2 bitShift: -8).
			^ self].
	t3 := super primMouseButtons.
	t5 := super primMousePt.
	t4 := t3 bitShift: -3.
	t3 := t3 bitAnd: 7.
	t6 := self mapButtons: t3 modifiers: t4.
	(t5 = mousePosition
			and: [(t6
					bitOr: (t4 bitShift: 3))
					= mouseButtons])
		ifTrue: [^ self].
	t1 at: 1 put: EventTypeMouse;
		 at: 2 put: Time millisecondClockValue;
		 at: 3 put: t5 x;
		 at: 4 put: t5 y;
		 at: 5 put: t6;
		 at: 6 put: t4! !

!EventSensor methodsFor: 'private' stamp: ''!
primInterruptSemaphore: t1 
	interruptSemaphore := t1.
	super primInterruptSemaphore: t1! !

!EventSensor methodsFor: 'private' stamp: ''!
primKbdNext
	| t1 |
	self wait2ms.
	self fetchMoreEvents.
	keyboardBuffer isEmpty
		ifFalse: [^ keyboardBuffer next].
	eventQueue
		ifNotNil: [t1 := eventQueue
						nextOrNilSuchThat: [:t2 | self isKbdEvent: t2].
			self flushNonKbdEvents].
	^ t1
		ifNotNil: [t1 at: 3]! !

!EventSensor methodsFor: 'private' stamp: ''!
primKbdPeek
	| t1 |
	self wait2ms.
	self fetchMoreEvents.
	keyboardBuffer isEmpty
		ifFalse: [^ keyboardBuffer peek].
	t1 := nil.
	eventQueue
		ifNotNil: [eventQueue
				nextOrNilSuchThat: [:t3 | 
					(self isKbdEvent: t3)
						ifTrue: [t1
								ifNil: [t1 := t3 at: 3]].
					false]].
	^ t1! !

!EventSensor methodsFor: 'private' stamp: ''!
primMouseButtons
	self wait2ms.
	self fetchMoreEvents.
	self flushNonKbdEvents.
	^ mouseButtons! !

!EventSensor methodsFor: 'private' stamp: ''!
primMousePt
	self wait2ms.
	self fetchMoreEvents.
	self flushNonKbdEvents.
	^ mousePosition! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
primSetInputSemaphore: t1 
	<primitive: 93>
	^ nil! !

!EventSensor methodsFor: 'private' stamp: ''!
primSetInterruptKey: t1 
	interruptKey := t1.
	super primSetInterruptKey: t1! !

!EventSensor methodsFor: 'private-I/O' stamp: 'bf 1/3/2012 15:28'!
processEvent: evt 
	"Process a single event. This method is run at high priority."
	| type buttons window |
	type := evt at: 1.

	"Only process main window events, forward others to host window proxies"
	window := evt at: 8.
	(window isNil or: [window isZero]) ifTrue: 
		[window := 1. 
		evt at: 8 put: window].
	window = 1 ifFalse: [
		^Smalltalk at: #HostWindowProxy ifPresent: [:w | w processEvent: evt]].

	"Tackle mouse events first"
	type = EventTypeMouse
		ifTrue: [buttons := (ButtonDecodeTable at: (evt at: 5) + 1). 
				evt at: 5 put: (Smalltalk platformName = 'Mac OS'
							ifTrue: [ buttons ]
							ifFalse: [ self mapButtons: buttons modifiers: (evt at: 6) ]).
				self queueEvent: evt.
				self processMouseEvent: evt . 
				^self].
	
	
	"Store the event in the queue if there's any"
	type = EventTypeKeyboard
		ifTrue: [ "Check if the event is a user interrupt"
			((evt at: 4) = 0
				and: [((evt at: 3)
						bitOr: (((evt at: 5)
							bitAnd: 8)
							bitShift: 8))
							= interruptKey])
					ifTrue: ["interrupt key is meta - not reported as event"
							^ interruptSemaphore signal].
			"Else swap ctrl/alt keys if neeeded.
			Look at the Unicode char first, then ascii."
			KeyDecodeTable
				at: {evt at: 6. evt at: 5}
				ifPresent: [:a | evt at: 6 put: a first;
						 at: 5 put: a second]. 
			KeyDecodeTable
				at: {evt at: 3. evt at: 5}
				ifPresent: [:a | evt at: 3 put: a first;
						 at: 5 put: a second]. 
			self queueEvent: evt. 
			self processKeyboardEvent: evt . 
			^self ].
				
	"Handle all events other than Keyborad or Mouse."
	self queueEvent: evt.
	! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
processKeyboardEvent: t1 
	| t2 t3 |
	mouseButtons := (mouseButtons bitAnd: 7)
				bitOr: ((t1 at: 5)
						bitShift: 3).
	eventQueue
		ifNotNil: [^ self].
	t2 := t1 at: 3.
	t2 = nil
		ifTrue: [^ self].
	t3 := t1 at: 4.
	t3 = EventKeyChar
		ifFalse: [^ self].
	t2 := t2
				bitOr: ((t1 at: 5)
						bitShift: 8).
	keyboardBuffer nextPut: t2! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
processMouseEvent: t1 
	| t2 t3 t4 |
	mousePosition := (t1 at: 3)
				@ (t1 at: 4).
	t3 := t1 at: 5.
	t2 := t1 at: 6.
	t4 := self mapButtons: t3 modifiers: t2.
	mouseButtons := t4
				bitOr: (t2 bitShift: 3)! !

!EventSensor methodsFor: 'private-I/O' stamp: ''!
queueEvent: t1 
	eventQueue
		ifNil: [^ self].
	eventQueue nextPut: t1 clone! !

!EventSensor methodsFor: 'initialize' stamp: ''!
shutDown
	super shutDown.
	EventTicklerProcess
		ifNotNil: [EventTicklerProcess terminate.
			EventTicklerProcess := nil].
	inputSemaphore
		ifNotNil: [Smalltalk unregisterExternalObject: inputSemaphore]! !

!EventSensor methodsFor: 'initialize' stamp: ''!
startUp
	self initialize.
	self
		primSetInputSemaphore: (Smalltalk registerExternalObject: inputSemaphore).
	super startUp.
	self installEventTickler.
	Smalltalk isMorphic
		ifTrue: [self flushAllButDandDEvents].
	hasInputSemaphore := false.
	inputSemaphore initSignals! !

!EventSensor methodsFor: 'private' stamp: ''!
wait2ms
	(Delay forMilliseconds: 2) wait! !

!EventSensorConstants class methodsFor: 'pool initialization' stamp: 'bf 1/3/2012 16:42'!
initialize
	"EventSensorConstants initialize"
	RedButtonBit := 4.
	BlueButtonBit := 2.
	YellowButtonBit := 1.

	ShiftKeyBit := 1.
	CtrlKeyBit := 2.
	OptionKeyBit := 4.
	CommandKeyBit := 8.

	"Types of events"
	EventTypeNone := 0.
	EventTypeMouse := 1.
	EventTypeKeyboard := 2.
	EventTypeDragDropFiles := 3.
	EventTypeMenu := 4.
	EventTypeWindow := 5.
	EventTypeComplex := 6.

	"Press codes for keyboard events"
	EventKeyChar := 0.
	EventKeyDown := 1.
	EventKeyUp := 2.

	"Host window events"
	WindowEventMetricChange := 1.
	WindowEventClose := 2.
	WindowEventIconise := 3. 
	WindowEventActivated	:= 4. 
	WindowEventPaint := 5.
	WindowEventStinks := 6.

	"types for touch events"
	EventTouchDown := 1.
	EventTouchUp := 2.
	EventTouchMoved := 3.
	EventTouchStationary := 4.
	EventTouchCancelled := 5.

	"iOS touch phase constants"
	TouchPhaseBegan := 0.
	TouchPhaseMoved := 1.
	TouchPhaseStationary := 2.
	TouchPhaseEnded := 3.
	TouchPhaseCancelled := 4.
! !

LinkedList subclass: #Semaphore
	instanceVariableNames: 'excessSignals'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!Semaphore class methodsFor: 'instance creation' stamp: ''!
forMutualExclusion
	^ self new signal! !

!Semaphore class methodsFor: 'instance creation' stamp: ''!
new
	^ self basicNew initSignals! !

!Semaphore methodsFor: 'comparing' stamp: ''!
= t1 
	^ self == t1! !

!Semaphore methodsFor: 'mutual exclusion' stamp: ''!
critical: t1 
	| t2 |
	t2 := false.
	^ [t2 := true.
	self wait.
	t1 value]
		ensure: [t2
				ifTrue: [self signal]]! !

!Semaphore methodsFor: 'mutual exclusion' stamp: 'ul 11/7/2010 05:29'!
critical: mutuallyExcludedBlock ifCurtailed: terminationBlock
	"Evaluate mutuallyExcludedBlock only if the receiver is not currently in 
	the process of running the critical: message. If the receiver is, evaluate 
	mutuallyExcludedBlock after the other critical: message is finished."
	^self critical: [ mutuallyExcludedBlock ifCurtailed: terminationBlock ]
! !

!Semaphore methodsFor: 'mutual exclusion' stamp: 'ul 11/7/2010 15:00'!
critical: mutuallyExcludedBlock ifError: errorBlock
	"Evaluate mutuallyExcludedBlock only if the receiver is not currently in 
	the process of running the critical: message. If the receiver is, evaluate 
	mutuallyExcludedBlock after the other critical: message is finished."
	| blockValue hasError errMsg errRcvr |
	hasError := false.
	blockValue := self critical:[
		mutuallyExcludedBlock ifError: [ :msg :rcvr |
			hasError := true.
			errMsg := msg.
			errRcvr := rcvr
		].
	].
	hasError ifTrue:[ ^errorBlock value: errMsg value: errRcvr].
	^blockValue! !

!Semaphore methodsFor: 'mutual exclusion' stamp: 'ul 12/8/2010 03:16'!
critical: mutuallyExcludedBlock ifLocked: alternativeBlock
	"Evaluate mutuallyExcludedBlock only if the receiver is not currently in 
	the process of running the critical: message. If the receiver is, then evaluate 
	alternativeBlock and return."
	"See the comment of #critical: for the explanation how this pattern works
	before changing the code."

	| caught |
	caught := false.
	^[
		"We're using #== here instead of #=, because it won't introduce a
		suspension point, while #= may do that."
		excessSignals == 0
			ifTrue: [ alternativeBlock value ]
			ifFalse: [
				excessSignals := excessSignals - 1.
				caught := true.
				mutuallyExcludedBlock value ] ]
		ensure: [ caught ifTrue: [ self signal ] ]! !

!Semaphore methodsFor: 'comparing' stamp: ''!
hash
	^ self identityHash! !

!Semaphore methodsFor: 'initialize-release' stamp: ''!
initSignals
	excessSignals := 0! !

!Semaphore methodsFor: 'testing' stamp: ''!
isSignaled
	^ excessSignals > 0! !

!Semaphore methodsFor: 'initialize-release' stamp: ''!
resumeProcess: t1 
	| t2 |
	t2 := self
				remove: t1
				ifAbsent: [].
	t2
		ifNotNil: [t2 resume]! !

!Semaphore methodsFor: 'communication' stamp: ''!
signal
	<primitive: 85>
	self primitiveFailed! !

!Semaphore methodsFor: 'initialize-release' stamp: ''!
terminateProcess
	self isEmpty
		ifFalse: [self removeFirst terminate]! !

!Semaphore methodsFor: 'communication' stamp: ''!
wait
	<primitive: 86>
	self primitiveFailed! !

!Semaphore methodsFor: 'communication' stamp: 'ul 12/8/2010 04:30'!
waitIfLocked: aBlock
	"Use a signal if available, otherwise evaluate aBlock"

	excessSignals == 0 ifTrue: [ ^aBlock value ].
	excessSignals := excessSignals - 1! !

!Semaphore methodsFor: 'communication' stamp: ''!
waitTimeoutMSecs: t1 
	| t2 |
	t2 := DelayWaitTimeout new
				setDelay: (t1 max: 0)
				forSemaphore: self.
	^ t2 wait! !

!Semaphore methodsFor: 'communication' stamp: ''!
waitTimeoutSeconds: t1 
	^ self waitTimeoutMSecs: t1 * 1000! !
Behavior initialize!
Categorizer initialize!
Delay initialize!
ContextPart initialize!
InstructionStream initialize!
Float initialize!
Integer initialize!
Object initialize!
ProcessorScheduler initialize!
StringHolder initialize!
CompiledMethod initialize!
ChronologyConstants initialize!
DateAndTime initialize!
Duration initialize!
EventSensorConstants initialize!
